package kal.base.com.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;

 /**
   * CREW SELF BRIEFING SQL 
   * @author Copyright (c) 2009/05/12 
   */     
public class ComQ02Query {
	private static ComQ02Query instance = new ComQ02Query();
	
	public static ComQ02Query getInstance() {
		return instance;
	}
	
	/** 
	  * Flight Plan ȸ SQLԼ.
	  * @param String flt_num
	  * @return String Query 
	  * @author Copyright (c) 2009/05/12 
	  */
	public String selFltPlan(String flt_num) {

		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT * FROM ( ");
		sql.append(" 		SELECT A.FIRST_LEG_FLT_DT, A.FLT_NUM, A.STNFR, A.STNTO, A.ROUTE, A.PLAN_MSG, A.SYSKEY ");
		sql.append(" 		FROM FLIGHT_PLAN_T A, DAILY_SCH_T B ");
		sql.append(" 		WHERE A.FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE,'YYMMDD')||'0000','YYMMDDHH24MI')-1 ");
		sql.append(" 		AND A.FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE,'YYMMDD')||'2359','YYMMDDHH24MI') ");
		sql.append(" 		AND A.FLT_NUM = '"+flt_num+"' ");
		sql.append(" 		AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" 		AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" 		AND B.SCH_DEP_DT_LOC BETWEEN TO_DATE(TO_CHAR(SYSDATE,'YYMMDD')||'0000','YYMMDDHH24MI') ");
		sql.append(" 		AND TO_DATE(TO_CHAR(SYSDATE,'YYMMDD')||'2359','YYMMDDHH24MI') ");
		sql.append(" 		AND A.ACTIVE = 'Y' ");
		sql.append(" 		ORDER BY A.MSG_TMPST DESC ");
		sql.append(" ) WHERE ROWNUM = 1 ");
		
		//System.out.println("[CREW SELF BRIEFING SQL : selFltPlan] "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Flight Plan Confirm SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/05/13 
	  */
	public String confirmFltPlan() {

		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE FLIGHT_PLAN_T ");
		sql.append(" SET CREW_NAME = ?, ");
		sql.append("        CREW_TMPST = TO_DATE(?, 'YYMMDDHH24MISS'), ");
		sql.append("        PLAN_MSG = ? "); //2009.07.08 ߰
		sql.append(" WHERE SYSKEY = ? ");
		
		System.out.println("[CREW SELF BRIEFING SQL : confirmFltPlan] "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  *  ð  SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/07/09 
	  */
	public String selNowTime() {

		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SYSDATE, 'DDMONYY HH24MI') NOW_TIME1, TO_CHAR(SYSDATE, 'YYMMDDHH24MISS') NOW_TIME2 FROM DUAL ");
		
		//System.out.println("[CREW SELF BRIEFING SQL : selNowTime] "+sql.toString());
		return sql.toString();
	}
}
