package kal.base.com.util;

import java.io.*;
import java.text.*;
import java.util.*;
import java.sql.*;

import kal.base.jdf.db.ConnectionResource;
import kal.base.pbf.db.ToolConnectionResource;

/**
 * EMS(Email Marketing Server) ̿Ͽ Email/Fax Service ߼Ѵ. 
 * ۼ ¥ : 2005-10-27
 *  ¥ : 2006-02-28 : System.exit() 
 *  ¥ : 2007-04-11 :  EMS ҽ ü .
 */
public class EMS {
	/** DB Driver */
	private static final String dbDriver = "oracle.jdbc.driver.OracleDriver";
	/** DB URL */
	private static final String dbURL = "jdbc:oracle:thin:@10.20.13.5:2003:emsdb"; //2007.04.11 
	/** User ID */ 
	private static final String dbUserID = "ems_kfos";   					//Your dedicated DBMS Account  
	/** User Password */
	private static final String dbUserPass = "kfospw";					//Your dedicated DBMS Account 
	
	/** Application Specific Area **/							
	private static final String appSvcID = "31"; //2007.04.11 	//Your dedicated Service ID      						
	
	//private static final String sName = "KALNOTAM"; 						//Your Sender Name 
	//private static final String sEmail ="KALNOTAM@koreanair.com"; //Your Sender EMail
	private static final String fmsUserID = "selocgrp";  					//Your fms UserID
	
	/* System gloval Value */
	private static Connection con = null;
	private static int msgSeqValue = 0 ;
	private static final String faxSMTP = "fmsadmin@fms.koreanair.co.kr";
	
	/**
	 * Email ߼Ѵ.
	 * @param : String sName -   ̸
	 * @param : String sEmail -    ̸ ּ
	 * @param : String rName - ޴  ̸
	 * @param : String rEmail - ޴  ̸ ּ
	 * @param : String subject -  
	 * @param : String content -  ->URL(EMS ȭ鿡 Contents Type  : 1) URLȣ, 2) Contents Mapping) 
	 * @return : 
	 */
	public static boolean sendEmail(String sName, String sEmail, String rName, String rEmail, String subject, String content) {	
		EMS ems = new EMS();
		boolean sendFlg = ems.sendEmailMsg(sName, sEmail, rName, rEmail, subject, content);	
			
		if (con != null) {
			try {	 con.close();	} catch (Exception e) {	}
		}
		
		if (sendFlg) {
			System.out.println("[EMS] ===== Sending Email Completed !! =====");
		} else {
			System.out.println("[EMS] ===== Sending Email Failed !! =====");
		}
		return sendFlg;
	}
	
	/**
	 * Fax ߼Ѵ.
	 * @param : String sName -   ̸
	 * @param : String sEmail -   ȣ(?)
	 * @param : String faxNo - ޴  ѽ ȣ
	 * @param : String faxTitle - ѽ 
	 * @param : String faxContent - ѽ ->URL(EMS ȭ鿡 Contents Type  : 1) URLȣ, 2) Contents Mapping)
	 * @return : 
	 */
	public static boolean sendFax(String sName, String sEmail, String faxNo, String faxTitle, String faxContent) {
		EMS ems = new EMS();	
		boolean sendFlg = ems.sendFaxMsg(sName, sEmail, faxNo, faxTitle, faxContent);
		
		if (con != null) {
			try {	con.close();	} catch (Exception e) {	}
		}
		
		if (sendFlg) {
			System.out.println("[EMS] ===== Sending Fax Completed !! =====");
		} else {
			System.out.println("[EMS] ===== Sending Fax Failed !! =====");
		}
		return sendFlg;
	}
	
	
	private boolean sendEmailMsg(String sName, String sEmail, String rName, String rEmail, String subject, String content) {	
		boolean sFlg = false;
		
		try {
			//Set establish DBMS Session 
			if (setConnection()) {
				
				//set Message sequence Value 
				setMsgSeqValue();
				if (msgSeqValue != -1) {
					
					if (InsertSimpleTextMsg(sName, sEmail, rName, rEmail, subject, content)) {
						sFlg = true;
					}
				}
			}
			con.commit();
			
		} catch (Exception e) {
			System.out.println("[EMS] sendEmailMsg Fail - " + e.toString());
		}	
		
		return sFlg;
	}
	
	
	private boolean sendFaxMsg(String sName, String sEmail, String faxNo, String faxTitle, String faxContent) {
		boolean sFlg = false;
		
		try {
			//Set establish DBMS Session 
			if (setConnection()) {
				
				//set Message sequence Value 
				setMsgSeqValue();
				if (msgSeqValue != -1) {
						
					String subject = "";
					//fax subject Format [fmsuserid<faxno>] faxTitle||||||||| 
					subject = "[" + fmsUserID + "<" + faxNo+ ">]" + faxTitle + "|||||||||"; 
					
					if (InsertSimpleTextMsg(sName, sEmail, "FAXSvr", faxSMTP, subject, faxContent)) {
						sFlg = true;
					}
				}
			}
			con.commit();
			
		} catch (Exception e) {
			System.out.println("[EMS] sendFaxMsg Fail - " + e.toString());
		}
		
		return sFlg;
	}
	
	
	private boolean setConnection() {
		con = null;
		try {
			/*Class.forName(dbDriver);
			con = DriverManager.getConnection(dbURL, dbUserID, dbUserPass);
			con.setAutoCommit(false);
			*/
			//@2014-03-03
			ConnectionResource cr = new ToolConnectionResource();
			con = cr.getConnection();
			con.setAutoCommit(false);
			
		} catch (Exception e) {
			System.out.println("[EMS] Fail to get connection from DBMS - " + e.toString());
			return false;
		}
		return true;
	}
	
	
	private void setMsgSeqValue() {
		msgSeqValue = 0;//@2014-03-03 msgSeqValue = -1;
		/*@2014-03-03
		 * String sql = "SELECT SYNMAILSEQ.NEXTVAL FROM DUAL";
		
		try {
			Statement stmt = con.createStatement();
		 	ResultSet rs = stmt.executeQuery(sql);	
		 	
		 	if (rs != null && rs.next()){
				msgSeqValue = rs.getInt(1);
				rs.close();
		 	} else {
		 		System.out.println("[EMS] SetMsgSeqValue Fail : due to non-SQL Excetption");
		 	}	
		 		
		} catch (Exception e) {
			System.out.println("[EMS] SetMsgSeqValue Fail - " + e.toString());
		}*/
	}
	
	
	/*private boolean InsertSimpleTextMsg(String sName, String sEmail, String rName, String rEmail, String subject, String content) {		
		try {
			String sqlMail = "INSERT INTO SYNQUEUESEC (MID, TID, EMAIL, NAME, TITLE, CONTENTS, SEMAIL, SNAME) VALUES(?,?,?,?,?,?,?,?)"; //2007.04.11 
			
			PreparedStatement ps = con.prepareStatement(sqlMail);
			
			//MID, TID, EMAIL, NAME, TITLE, CONTENTS
			ps.setInt(1, msgSeqValue);
			ps.setString(2, appSvcID);
			ps.setString(3, rEmail);
			ps.setString(4, rName);
			ps.setString(5, subject);
			ps.setString(6, content);
			ps.setString(7, sEmail);
			ps.setString(8, sName);
			
			System.out.println(msgSeqValue);
			System.out.println(appSvcID);
			System.out.println(rEmail);
			System.out.println(rName);
			System.out.println(subject);
			System.out.println(content);
			System.out.println(sEmail);
			System.out.println(sName);
			
			ps.executeUpdate();
			ps.close();
			
		} catch (Exception e) {
			System.out.println("[EMS] InsertSimpleTextMsg Fail - " + e.toString());
			try {   con.rollback();	 } catch (Exception ex) {	}
			return false;
		}
		return true;
	}
	@2014-03-03
	*/
	private boolean InsertSimpleTextMsg(String sName, String sEmail, String rName, String rEmail, String subject, String content) {	//@2014-03-03	
		String	sqlMail	=	"";			
		try {			
			sqlMail	+=	"INSERT INTO KFOS.UMS_SND_T (	";
			sqlMail	+=	"	MSG_CAT	,	MSG_TMPST	,	TID	,	PNR	,	EID	";
			sqlMail	+=	",	EMAIL	";
			sqlMail	+=	",	NAME	";
			sqlMail	+=	",	TITLE	";
			sqlMail	+=	",	CONTENTS	";
			sqlMail	+=	",	SEMAIL	";
			sqlMail	+=	",	SNAME	";
			sqlMail	+=	",	MSG_TYPE	";
			sqlMail	+=	",	ENC_EMAIL	";
			sqlMail	+=	",	ENC_SEMAIL	";
			sqlMail	+=	")	";
			sqlMail	+=	" VALUES(	";
			sqlMail	+=	"	'SKYWEB'	,	SYSDATE	,	'E038'	,	TO_CHAR(SYSTIMESTAMP,	'YYMMDDHH24MIFF2')	,	TO_CHAR(SYSTIMESTAMP,	'YYMMDDHH24MIFF6')	";
			sqlMail	+=	",	?	";//rEmail
			sqlMail	+=	",	?	";//rName
			sqlMail	+=	",	?	";//subject
			sqlMail	+=	",	?	";//content
			sqlMail	+=	",	?	";//sEmail
			sqlMail	+=	",	?	";//sName
			sqlMail	+=	",	'M'	";
			sqlMail	+=	",	?	";//Enc rEmail
			sqlMail	+=	",	?	";//Enc sEmail
			sqlMail	+=	")	";

			PreparedStatement ps = con.prepareStatement(sqlMail);
			
			//2016.09.07 ȣȭ 
			String dec_rEmail = "";
			String dec_sEmail = "";

			System.out.println("InsertSimpleTextMsg 1 Start");
			System.out.println("InsertSimpleTextMsg     rEmail:"+rEmail);
			
			if(!"".equals(rEmail)){ 
				dec_rEmail = SecurityUtil.self.encrypt(rEmail, "INT_EML");
				System.out.println("InsertSimpleTextMsg dec_rEmail:"+dec_rEmail);
				rEmail = "";
			}
			
			System.out.println("InsertSimpleTextMsg     sEmail:"+sEmail);
			
			if(!"".equals(sEmail)){
				dec_sEmail = SecurityUtil.self.encrypt(sEmail, "INT_EML");
				System.out.println("InsertSimpleTextMsg dec_sEmail:"+dec_sEmail);
				sEmail = "";
			}
			
			ps.setString(1, rEmail);
			ps.setString(2, rName);
			ps.setString(3, subject);
			ps.setString(4, content);
			ps.setString(5, sEmail);
			ps.setString(6, sName);
			//2016.09.07 ȣȭ 
			ps.setString(7, dec_rEmail);
			ps.setString(8, dec_sEmail);
			

			//System.out.println(subject);
			//System.out.println(content);
			//System.out.println(sEmail);
			//System.out.println(sName);
			
			ps.executeUpdate();
			ps.close();
			
		} catch (Exception e) {
			System.out.println("[EMS] InsertSimpleTextMsg Fail - " + e.toString()+sqlMail+"/"+rEmail+"/"+rName+"/"+subject+"/"+content+"/"+sEmail+"/"+sName);
			try {   con.rollback();	 } catch (Exception ex) {	}
			return false;
		}
		return true;
	}
	
	/**
	 * Email ߼Ѵ.
	 * ATTACH01
	 * ATTACH01_NAME
	 * PROCESSED_Y
	 * 20140903
	 * sunpark 
	 */
	public static boolean sendEmail(String sName, String sEmail, String rName, String rEmail, String subject, String content, String attachFilePath, String attachFileName, String processed) {	
		EMS ems = new EMS();
		boolean sendFlg = ems.sendEmailMsg(sName, sEmail, rName, rEmail, subject, content, attachFilePath, attachFileName, processed);	
			
		if (con != null) {
			try {	 con.close();	} catch (Exception e) {	}
		}
		
		if (sendFlg) {
			System.out.println("[EMS] ===== Sending Email Completed !! =====");
		} else {
			System.out.println("[EMS] ===== Sending Email Failed !! =====");
		}
		return sendFlg;
	}
	/**
	 * ATTACH01
	 * ATTACH01_NAME
	 * PROCESSED_Y
	 * 20140903
	 * sunpark 
	 */
	private boolean sendEmailMsg(String sName, String sEmail, String rName, String rEmail, String subject, String content, String attachFilePath, String attachFileName, String processed) {	
		boolean sFlg = false;
		
		try {
			//Set establish DBMS Session 
			if (setConnection()) {
				
				//set Message sequence Value 
				setMsgSeqValue();
				if (msgSeqValue != -1) {
					
					if (InsertSimpleTextMsg(sName, sEmail, rName, rEmail, subject, content, attachFilePath, attachFileName, processed)) {
						sFlg = true;
					}
				}
			}
			con.commit();
			
		} catch (Exception e) {
			System.out.println("[EMS] sendEmailMsg Fail - " + e.toString());
		}	
		
		return sFlg;
	}
	/**
	 * ATTACH01
	 * ATTACH01_NAME
	 * PROCESSED_Y
	 * 20140903
	 * sunpark 
	 */	
	private boolean InsertSimpleTextMsg(String sName, String sEmail, String rName, String rEmail, String subject, String content, String attachFilePath, String attachFileName, String processed) {	
		String	sqlMail	=	"";			
		try {			
			sqlMail	+=	"INSERT INTO KFOS.UMS_SND_T (	";
			sqlMail	+=	"	MSG_CAT	,	MSG_TMPST	,	TID	,	PNR	,	EID	";
			sqlMail	+=	",	EMAIL	";
			sqlMail	+=	",	NAME	";
			sqlMail	+=	",	TITLE	";
			sqlMail	+=	",	CONTENTS	";
			sqlMail	+=	",	SEMAIL	";
			sqlMail	+=	",	SNAME	";
			sqlMail	+=	",	MSG_TYPE	";
			sqlMail	+=	",	ATTACH01	";
			sqlMail	+=	",	ATTACH01_NAME	";
			sqlMail	+=	",	PROCESSED_Y	";
			sqlMail	+=	",	ENC_EMAIL	";
			sqlMail	+=	",	ENC_SEMAIL	";
			sqlMail	+=	")	";
			sqlMail	+=	" VALUES(	";
			sqlMail	+=	"	'SKYWEB'	,	SYSDATE	,	'E038'	,	TO_CHAR(SYSTIMESTAMP,	'YYMMDDHH24MIFF2')	,	TO_CHAR(SYSTIMESTAMP,	'YYMMDDHH24MIFF6')	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	'M'	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	")	";

			PreparedStatement ps = con.prepareStatement(sqlMail);

			//2016.09.07 ȣȭ 
			String dec_rEmail = "";
			String dec_sEmail = "";
			
			System.out.println("InsertSimpleTextMsg 2 Start");
			System.out.println("InsertSimpleTextMsg     rEmail:"+rEmail);
			
			if(!"".equals(rEmail)){ 
				dec_rEmail = SecurityUtil.self.encrypt(rEmail, "INT_EML");
				System.out.println("InsertSimpleTextMsg dec_rEmail:"+dec_rEmail);
				rEmail = "";
			}
			
			System.out.println("InsertSimpleTextMsg     sEmail:"+sEmail);
			
			if(!"".equals(sEmail)){
				dec_sEmail = SecurityUtil.self.encrypt(sEmail, "INT_EML");
				System.out.println("InsertSimpleTextMsg dec_sEmail:"+dec_sEmail);
				sEmail = "";
			}
			
			ps.setString(1, rEmail);
			ps.setString(2, rName);
			ps.setString(3, subject);
			ps.setString(4, content);
			ps.setString(5, sEmail);
			ps.setString(6, sName);
			ps.setString(7, attachFilePath);
			ps.setString(8, attachFileName);
			ps.setString(9, processed);
			//2016.09.07 ȣȭ 
			ps.setString(10, dec_rEmail);
			ps.setString(11, dec_sEmail);
			
			ps.executeUpdate();
			ps.close();
			
		} catch (Exception e) {
			System.out.println("[EMS] InsertSimpleTextMsg Fail - " + e.toString()+sqlMail+"/"+rEmail+"/"+rName+"/"+subject+"/"+content+"/"+sEmail+"/"+sName);
			try {   con.rollback();	 } catch (Exception ex) {	}
			return false;
		}
		return true;
	}
	/**
	 * PROCESSED_Y
	 * 20140903
	 * sunpark 
	 */	
	public static boolean sendFax(String sName, String sEmail, String faxNo, String faxTitle, String faxContent, String processed) {
		EMS ems = new EMS();	
		boolean sendFlg = ems.sendFaxMsg(sName, sEmail, faxNo, faxTitle, faxContent, processed);
		
		if (con != null) {
			try {	con.close();	} catch (Exception e) {	}
		}
		
		if (sendFlg) {
			System.out.println("[EMS] ===== Sending Fax Completed !! =====");
		} else {
			System.out.println("[EMS] ===== Sending Fax Failed !! =====");
		}
		return sendFlg;
	}
	private boolean sendFaxMsg(String sName, String sEmail, String faxNo, String faxTitle, String faxContent, String processed) {
		boolean sFlg = false;
		
		try {
			if (setConnection()) {
				
				setMsgSeqValue();
				if (msgSeqValue != -1) {
						
					String subject = "";
					subject = "[" + fmsUserID + "<" + faxNo+ ">]" + faxTitle + "|||||||||"; 
					
					if (InsertSimpleTextMsg(sName, sEmail, "FAXSvr", faxSMTP, subject, faxContent, processed)) {
						sFlg = true;
					}
				}
			}
			con.commit();
			
		} catch (Exception e) {
			System.out.println("[EMS] sendFaxMsg Fail - " + e.toString());
		}
		
		return sFlg;
	}
	private boolean InsertSimpleTextMsg(String sName, String sEmail, String rName, String rEmail, String subject, String content, String processed) {	
		String	sqlMail	=	"";			
		try {			
			sqlMail	+=	"INSERT INTO KFOS.UMS_SND_T (	";
			sqlMail	+=	"	MSG_CAT	,	MSG_TMPST	,	TID	,	PNR	,	EID	";
			sqlMail	+=	",	EMAIL	";
			sqlMail	+=	",	NAME	";
			sqlMail	+=	",	TITLE	";
			sqlMail	+=	",	CONTENTS	";
			sqlMail	+=	",	SEMAIL	";
			sqlMail	+=	",	SNAME	";
			sqlMail	+=	",	MSG_TYPE	";
			sqlMail	+=	",	PROCESSED_Y	";
			sqlMail	+=	",	ENC_EMAIL	";
			sqlMail	+=	",	ENC_SEMAIL	";
			sqlMail	+=	")	";
			sqlMail	+=	" VALUES(	";
			sqlMail	+=	"	'SKYWEB'	,	SYSDATE	,	'F019'	,	TO_CHAR(SYSTIMESTAMP,	'YYMMDDHH24MIFF2')	,	TO_CHAR(SYSTIMESTAMP,	'YYMMDDHH24MIFF6')	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	'F'	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			sqlMail	+=	",	?	";
			
			sqlMail	+=	")	";

			PreparedStatement ps = con.prepareStatement(sqlMail);

			ps.setString(1, rEmail);
			ps.setString(2, rName);
			ps.setString(3, subject);
			ps.setString(4, content);
			ps.setString(5, sEmail);
			ps.setString(6, sName);
			ps.setString(7, processed);
			
			//2016.09.07 ȣȭ 
			String dec_rEmail = "";
			String dec_sEmail = "";
			
			if(!"".equals(dec_rEmail)) dec_rEmail = SecurityUtil.self.encrypt(rEmail, "INT_EML");
			if(!"".equals(dec_sEmail)) dec_sEmail = SecurityUtil.self.encrypt(sEmail, "INT_EML");
			
			ps.setString(8, dec_rEmail);
			ps.setString(9, dec_sEmail);
			
			ps.executeUpdate();
			ps.close();
			
		} catch (Exception e) {
			System.out.println("[EMS] InsertSimpleTextMsg Fail - " + e.toString()+sqlMail+"/"+rEmail+"/"+rName+"/"+subject+"/"+content+"/"+sEmail+"/"+sName);
			try {   con.rollback();	 } catch (Exception ex) {	}
			return false;
		}
		return true;
	}
	
	
	/**
	 * 20151021 UMS  ߰
	 * 
	 */
	public static boolean setTempMailContent(String typ, String keyStr, String content) {	
		EMS ems = new EMS();
		boolean sendFlg = ems.insertTempMailContent(typ, keyStr, content);	
			
		if(con != null) {
			try {
				con.close();
			} catch (Exception e) {	}
		}
		
		if (sendFlg) {
			System.out.println("[EMS] ===== setTempMailContent Completed !! =====");
		} else {
			System.out.println("[EMS] ===== setTempMailContent Failed !! =====");
		}
		
		return sendFlg;
	}
	private boolean insertTempMailContent(String typ, String keyStr, String content) {	
		boolean sFlg = false;
		
		try {
			if(setConnection()) {

				setMsgSeqValue();
				if (msgSeqValue != -1) {
					if (InsertTempMailContentQuery(typ, keyStr, content)) {
						sFlg = true;
					}
				}
			}
			con.commit();
			
		} catch (Exception e) {
			System.out.println("[EMS] insertTempMailContent Fail - " + e.toString());
		}	
		
		return sFlg;
	}
	private boolean InsertTempMailContentQuery(String typ, String keyStr, String content) {	
		String	sqlMail	=	"";			
		try {			
			sqlMail	+=	"INSERT INTO KFOS.BS_TEMP_MAIL_CONTENT_T ( ";
			sqlMail	+=	"	TYP ";
			sqlMail	+=	"	, KEYSTR ";
			sqlMail	+=	"	, CONTENT ";
			sqlMail	+=	"	, TIMESTMP ";
			sqlMail	+=	") VALUES( ";
			sqlMail	+=	"	?	";
			sqlMail	+=	"	, ?	";
			sqlMail	+=	"	, ? ";
			sqlMail	+=	"	, SYSDATE ";
			sqlMail	+=	") ";

			PreparedStatement ps = con.prepareStatement(sqlMail);
			

			ps.setString(1, typ);
			ps.setString(2, keyStr);
			ps.setString(3, content);
			
			ps.executeUpdate();
			ps.close();
			
		} catch (Exception e) {
			System.out.println("[EMS] InsertTempMailContent Fail - " + e.toString()+sqlMail+"/"+typ+"/"+keyStr+"/"+content);
			try {
				con.rollback();
			} catch(Exception ex) { }
			
			return false;
		}
		
		return true;
	}
}
