package kal.base.com.util;

import java.io.*;
import java.text.*;
import java.util.*;
import java.sql.Clob;
import java.net.*;

import javax.servlet.http.HttpServletRequest;
import kal.base.jdf.db.*;
import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.*;
import kal.base.com.util.MessageCode;

/**
 * Ŭ ۼ  ֱ  String ó ƿ Ŭ
 * @author Copyright (c) 2002 HIST 
 */
public final class StringUtil {
	public StringUtil() {
		super();
	}
	
	/**
	 * IP Address ´.
	 * @return String IP Address
	 * @exception Exception
	 * @author Copyright (c) 2009/12/18 
	 */
	public static String getIpAddress() throws Exception {
		String IPaddr = "";
		
		InetAddress ia = InetAddress.getLocalHost();
		IPaddr = ia.getHostAddress();
		
		//System.out.println("##### IP Address ##### : "+IPaddr);
		
		try {
			
		} catch (Exception e) {
			throw new Exception(e.getMessage());
		}
		
		return IPaddr;
	}
	
	/**
	 * HttpServletRequet ûURL мϿ ų URL ǺѴ.
	 * @param req HttpServletRequest Request
	 * @param mode String login: α׾ƿ ,  portal : Ż
	 * @return String ų URL
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static String ConvertURL(HttpServletRequest req,String mode) throws Exception {
		String URL = "";
		
		if (req == null) throw new Exception("[System Exception] USER Request Is Null");
		
		try {
			/*
			local ⺻  (IP, Name, Port)
			Local IP : request.getLocalAddr()
			Local Name : request.getLocalName()
			Local Port : request.getLocalPort()

			Ŭ̾Ʈ  (IP, Host, Port)
			Remote IP : request.getRemoteAddr()
			Remote Host : request.getRemoteHost()
			Remote Port : request.getRemotePort()

			 ̸ Ʈ
			Server Name : request.getServerName()
			Server Port : request.getServerPort()
			*/
			
			//reqURL = 210.105.1.15/SIGNRoot/jsp/com/login.jsp   
			String reqURL = checkString((req.getRequestURL()).toString()).substring(7);
			Logger.debug.println("[BASE:ConvertURL] reqURL : "+reqURL);
			StringTokenizer st = new StringTokenizer(reqURL,"/");
			//reqIP = 210.105.1.15   
			String reqIP = checkString(st.nextToken());
			
			reqIP = "http://" + reqIP;
			
			if (mode.equals("login")) URL = reqIP + MessageCode.getInstance().SIGN_URL;
			else if (mode.equals("portal")) URL = reqIP + MessageCode.getInstance().SIGN_INTER_URL;
			
			/*
			if (reqIP.equals(MessageCode.getInstance().ICN_IP)) {
				if (mode.equals("login")) URL = MessageCode.getInstance().SIGN_URL_ICN;
				else URL = MessageCode.getInstance().SIGN_INTER_URL_ICN;
			} else if (reqIP.equals(MessageCode.getInstance().LOCAL_IP)) {
				if (mode.equals("login")) URL = MessageCode.getInstance().SIGN_URL_LOCAL;
				else URL = MessageCode.getInstance().SIGN_INTER_URL_LOCAL;
			} else if (reqIP.equals(MessageCode.getInstance().BASET_IP)) {
				if (mode.equals("login")) URL = MessageCode.getInstance().SIGN_URL_BASET;
				else URL = MessageCode.getInstance().SIGN_INTER_URL_BASET;
			} else {
				if (mode.equals("login")) URL = MessageCode.getInstance().SIGN_URL;
				else URL = MessageCode.getInstance().SIGN_INTER_URL;
			}
			*/
			
			//System.out.println("[BASE:ConvertURL] URL : "+URL);
			
		} catch (Exception e) {
			throw new Exception(e.getMessage());
		}

		return URL;
	}
	
	/**
	 * Ķ ڿ int ȭϿ ȯѴ.
	 * @param str String int ȯ ڿ
	 * @return int	ڿ ȯ int
	 * @exception java.text.ParseException
	 * @author Copyright (c) 2002 HIST 
	 */
    public static int convertInt(String str)
    		throws ParseException {
    	try {
    		return NumberFormat.getInstance().parse(str).intValue();
    	} catch(ParseException e) {
    		throw new ParseException(e.getMessage(), e.getErrorOffset());
    	}
    }
	
	/**
	 * Ķ ڿ double ȭϿ ȯѴ.
	 * @param str String double ȯ ڿ
	 * @return double	ڿ ȯ double
	 * @exception java.text.ParseException
	 * @author Copyright (c) 2002 HIST 
	 */
	public static double convertDouble(String str)
			throws ParseException {
		try {
			return NumberFormat.getInstance().parse(str).doubleValue();
		} catch(ParseException e) {
			throw new ParseException(e.getMessage(), e.getErrorOffset());
		}
	}
	
	/**
	 * Ķ ڿ long ȭϿ ȯѴ.
	 * @param str String long ȯ ڿ
	 * @return long	ڿ ȯ long
	 * @exception java.text.ParseException
	 * @author Copyright (c) 2002 HIST 
	 */
	public static long convertLong(String str)
			throws ParseException {
		try {
			return NumberFormat.getInstance().parse(str).longValue();
		} catch(ParseException e) {
			throw new ParseException(e.getMessage(), e.getErrorOffset());
		}
	}
	
	/**
     * Ķ double  '0,###,###"  , õ  comma
	 * ߰Ͽ ѱ ǥ ˿ .
	 * @param no int	 int value
	 * @return String	˵Ǿ String value.
	 *					ܹ߻ 鹮ڸ ȯ
     * @author Copyright (c) 2002 HIST 
     */
    public static String formatNumber(int no) {
		try	{
			return NumberFormat.getInstance().format(no);
		} catch(Exception e) {
			return "";
		}
	}
	
	/**
	 * Ķ double  '0,###,###.00"  , õ  comma
	 * ߰ϰ, Ҽ  ڸ  Ų.
	 * @param flag String flag="USD" ޷, ׿ 
	 *					flag="USD" Ҽ   
	 *					flag!="USD" Ҽ ̻ 
	 * @param no double  double value.
	 * @return String	˵Ǿ double
	 *					ܹ߻ 鹮ڸ ȯ
	 * @author Copyright (c) 2002 HIST 
	 */
	public static String formatNumber(String flag, double no) {
		try {
			if(flag.equals("USD")) {
				DecimalFormat df = new DecimalFormat(",##0.00");
				return df.format(no);
			} else {
				return formatNumber(no);
			}
		} catch(Exception e) {
			return "";
		}
	}
	
	/**
	 * Ķ ڿ  '0,###,###.00"  , õ  comma
	 * ߰ϰ, Ҽ  ڸ  Ų.
	 * @param flag String flag="USD" ޷, ׿ 
	 *					flag="USD" Ҽ   
	 *					flag!="USD" Ҽ ̻ 
	 * @param str String  ڿ
	 * @return String	˵Ǿ double
	 *					ܹ߻ 鹮ڸ ȯ
	 * @author Copyright (c) 2002 HIST 
	 */
	public static String formatNumber(String flag, String str) {
		try {
			if(flag.equals("USD")) {
				DecimalFormat df = new DecimalFormat(",##0.00");
				return df.format(convertDouble(str));
			} else {
				return formatNumber(convertDouble(str));
			}
		} catch(Exception e) {
			return "";
		}
	}
	
	/**
	 * Ķ double  '0,###,###"  , õ  comma
	 * ߰Ͽ ѱ ǥ ˿ .
	 * @param no double  double value
	 * @return String	˵Ǿ double
	 *					ܹ߻ 鹮ڸ ȯ
	 * @author Copyright (c) 2002 HIST 
	 */
	public static String formatNumber(double no) {
		try {
			DecimalFormat df = new DecimalFormat(",##0");
			return df.format(no);
		} catch(Exception e) {
			return "";
		}
	}
	
	/**
	 * Ķ long  '0,###,###.00"  , õ  comma
	 * ߰ϰ, Ҽ  ڸ  Ų.
	 * @param flag String flag="USD" ޷, ׿ 
	 *					flag="USD" Ҽ   
	 *					flag!="USD" Ҽ ̻ 
	 * @param no long 	 long value.
	 * @return String	˵Ǿ long
	 *					ܹ߻ 鹮ڸ ȯ
	 * @author Copyright (c) 2002 HIST 
	 */
	public static String formatNumber(String flag, long no) {
		try {
			if(flag.equals("USD")) {
				DecimalFormat df = new DecimalFormat(",##0.00");
				return df.format(no);
			} else {
				return formatNumber(no);
			}
		} catch(Exception e) {
			return "";
		}
	}
	
	/**
	 * Ķ long  '0,###,###"  , õ  comma
	 * ߰Ͽ ѱ ǥ ˿ .
	 * @param no long 	 long value
	 * @return String	˵Ǿ long.
	 *					ܹ߻ 鹮ڸ ȯ
	 * @author Copyright (c) 2002 HIST 
	 */
	public static String formatNumber(long no) {
		try {
			DecimalFormat df = new DecimalFormat(",##0");
			return df.format(no);
		} catch(Exception e) {
			return "";
		}
	}
	
	/**
     * ý ¥ "YYYY-MM-DD" ˿ 缭 ȯѴ.
     * @return String ˵ ý ¥
     * @author Copyright (c) 2002 HIST 
     */
    public static String systemDate() {
		SimpleDateFormat formatter
			= new SimpleDateFormat("yyyy-MM-dd");
		return formatter.format( new Date() );
    }
    
    /**
     * Ķͷ Ѿ ¥ "YYYY-MM-DD" ˿ 缭 ȯѴ.
     * @param str String Ϸϴ ¥
     * @return String 	˵ ¥
     * @author Copyright (c) 2002 HIST 
     */
    public static String formatDate(String str) {
        return format(str, "####-##-##");
    }
    
    /**
	 * Ű ޵ ڿ ȭ ڿ ߾ ȯѴ.
	 * -------------------------------------------------------
	 * * ڿ ȭ Ģ
	 * 
	 * 1. ں ȯ Ǹ,  ڿ õȴ.
	 * 2. ڰ ƴ ڿ Ű ޵Ǹ
	 * 	  FormatTypeDismatchException ߻Ѵ.
	 * 3. Ĺڿ  ڿ ڿ Ѵ.
	 * 	  (ڿ -   ڿ)
	 * 4. Ĺڿ
	 * 	  '#'  - Digit
	 * 	  etc. - String
	 * 5. 
	 * 	  - Ű ڿ Ĺڿ  ġ Ǻ
	 * 6. ߰Ǿ 
	 * 	  - Ĺڿ Ȯ
	 * 
	 * ) String return_value = format("20010101", "####-##-##");
	 * -------------------------------------------------------
	 * @param str String ˴ ڿ
	 * @param format_str String 
	 * @return String ˵ ڿ
	 * @author Copyright (c) 2002 HIST 
     */
    public static String format(String str, String format_str) {
        int i;
        int ptr = 0;
        StringBuffer strbuf = new StringBuffer();

        try {
            if((str == null) || (str.length() == 0)) return "";
            if(str.length() != countChar(format_str)) throw new Exception();

            for(i = 0; i < format_str.length(); i++) {
				if(format_str.charAt(i) == '#')
                    strbuf.append(str.charAt(ptr++));
                else
                    strbuf.append(format_str.charAt(i));
            }
            
            return strbuf.toString();
        } catch(Exception e) {
            return "";
        }
    }
    
    /**
     * ڿӿ Ե Ư[default : '#']  ȯѴ.
     * @param str String м  ڿ
     * @return int ڿӿ Ե Ư 
     * @author Copyright (c) 2002 HIST 
     */
    public static int countChar(String str) {
        int i;
        int count = 0;

        for(i = 0; i < str.length(); i++)
            if(str.charAt(i) == '#') count++;

        return count;
    }
    
    /**
     * ˵ ¥ ڿ  
     * 2001-01-0122:00 --> 200101012200
     * @param str String ˵ ¥ڿ
     * @return String  ڿ
     * @author Copyright (c) 2002 HIST 
     */
    public static String unFormatDate(String str) {
    	StringBuffer strDate = new StringBuffer();

		if (str == null || str.length() == 0) return "";

    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == '-' || str.charAt(i) == ':') continue;
    		strDate.append(str.charAt(i));
    	}

    	return strDate.toString();
    }
    
    /**
	 *  ¥  Ⱓ 
	 * @param from String	  ¥(YYYYMMDD )
	 * @param to String		񱳴 ¥(YYYYMMDD )
	 * @return int  ¥  Ⱓ ڴ ȯ
	 * @exception java.text.ParseException
	 * @author Copyright (c) 2002 HIST 
	 */
    public static int daysBetween(String from, String to)
    		throws java.text.ParseException {
        java.text.SimpleDateFormat format =
        	new java.text.SimpleDateFormat ("yyyyMMdd", java.util.Locale.KOREA);
		    
        java.util.Date d1 = null;
        java.util.Date d2 = null;

        try {		    
		    d1 = format.parse(from);
		    d2 = format.parse(to);
		} catch (java.text.ParseException e) {
			throw new java.text.ParseException(e.getMessage(), e.getErrorOffset());
		}
		
        long duration = d2.getTime() - d1.getTime();

        return (int)( duration/(1000 * 60 * 60 * 24) );
    }
    
    /**
	* Ķͷ Ѿ ,  شϴ  ¥ ȯѴ.
	* ) 2 - 28, 3 - 31, ........ , 12 - 31
	* @param y int 
	* @param m int 
	* @return int   شϴ  ¥
	* @author Copyright (c) 2002 HIST 
	*/
	public static int daysPerMonth(int y, int m) {
		Calendar cal = Calendar.getInstance();
	    cal.set(y, m-1, 1);
	    return cal.getActualMaximum(Calendar.DAY_OF_MONTH);
	}
	
	/**
	* ־  شϴ  س.
	* ) 1-,2-,3-ȭ,4-,5-,6-,7-
	* @param y int 
	* @param m int 
	* @param d int 
	* @return int   شϴ  ¥
	* @author Copyright (c) 2002 HIST 
	*/
	public static int aDayOfTheWeek(int y,int m,int d) {
		Calendar cal = Calendar.getInstance();
	    cal.set(y, m-1, d);
	    return cal.get(Calendar.DAY_OF_WEEK);
	}
	
	/**
	 *  ¥   
	 * @param from String	  ¥(YYYYMMDDHH24MI )
	 * @param to String		񱳴 ¥(YYYYMMDDHH24MI )
	 * @return int  ¥  Ⱓ   ȯ
	 * @exception java.text.ParseException
	 * @author Copyright (c) 2004 HIST 
	 */
    public static int minsBetween(String from, String to)
    		throws java.text.ParseException {
    			
    	java.text.SimpleDateFormat sdf = new  java.text.SimpleDateFormat ("yyyyMMddHHmm"); 
    	/*
		java.util.Date d1 = sdf.parse("200410151030");
	    java.util.Date d2 = sdf.parse("200410151245");
	    int duration = (int)((d2.getTime() - d1.getTime())/(1000 * 60));
	    */
		    
        java.util.Date d1 = null;
        java.util.Date d2 = null;

        try {		    
		    d1 = sdf.parse(from);
		    d2 = sdf.parse(to);
		} catch (java.text.ParseException e) {
			throw new java.text.ParseException(e.getMessage(), e.getErrorOffset());
		}
		
        long duration = d2.getTime() - d1.getTime();

        return (int)( duration/(1000 * 60) );
    }
	
   /**
    * ڿ ASCII ڿ ȯѴ.  ѱĶͰ ļյǾ
    * ޵Ǿ   ޼ҵ ȭϿ Ѵ.
    * @param str String ڿ
    * @return String ASCII ڿ
    * @author Copyright (c) 2002 HIST 
	*/
    public static String escape(String str) {
		String sTmp = "";
		char[] textArray = str.toCharArray();
        int iCnt = java.lang.reflect.Array.getLength(textArray);
		for(int i=0; i<iCnt; i++) {
			sTmp = sTmp + "/u" + (Integer.toHexString((int)textArray[i])).toUpperCase();
		}
		return sTmp;
	}

   /**
	* ASCIIڿ ڿ ȯѴ.
	* @param str String ASCIIڿ
	* @return String ڿ
	* @author Copyright (c) 2002 HIST 
	*/
	public static String unescape(String str) {
		String sTmp = "";

		StringTokenizer st = new StringTokenizer(str,"/u");

		while (st.hasMoreTokens()) {
			sTmp = sTmp + (char)Integer.parseInt(st.nextToken(), 16);
		}
		return sTmp;
	}
	
	/**
     * (ѱ) ð ´.
     * () Էĸ format string "yyyyMMddhh" ϸ 1998121011  Return.
     * () format string "yyyyMMddHHmmss" ϸ 19990114232121 
     *      0~23ð Ÿ Return.
     *      String CurrentDate = StringUtil.getKST("yyyyMMddHH");
     * @param format String ϴ ð Type
     * @return String  ѱ ð.
     */
	public static String getKST(String format) {
		//1hour(ms) = 60s * 60m * 1000ms
		int 	millisPerHour 	= 60 * 60 * 1000;
		SimpleDateFormat 	fmt	= new SimpleDateFormat(format);
		
		SimpleTimeZone timeZone = new SimpleTimeZone(9*millisPerHour,"KST");
		fmt.setTimeZone(timeZone);
		
		long time=System.currentTimeMillis();
		String str=fmt.format(new java.util.Date(time));
		return str;
	}
	
	public static String getGMTheader(String format) {
		//1hour(ms) = 60s * 60m * 1000ms
		int 	millisPerHour 	= 60 * 60 * 1000;
		SimpleDateFormat 	fmt	= new SimpleDateFormat(format);
		
		SimpleTimeZone timeZone = new SimpleTimeZone(9*millisPerHour,"KST");
		fmt.setTimeZone(timeZone);
		
		Calendar cal = fmt.getCalendar();
		cal.add(Calendar.HOUR_OF_DAY,-9);
		String str = fmt.format(cal.getTime());
		return str;
	}
	
	/**
     * (ѱ) ð(HHmm) ϴ ð ŭ Ѵ.
     * @param val int  ϴ ð.
     * @return String  ð.
     */
	public static String getGMT(int val) {
		//SimpleDateFormat sdf = new SimpleDateFormat ("yyyy/MM/dd HH:mm:ss"); 
		SimpleDateFormat sdf = new SimpleDateFormat ("yyMMddHHmm"); 
		long currentTime = System.currentTimeMillis (); 
		String nowTime = sdf.format (new Date (currentTime)); 
		
		Calendar cal = sdf.getCalendar (); 
		long instanceTime = cal.getTime ().getTime (); 
		
		//1 2 14ð ߰ 
		//cal.add (Calendar.YEAR, 1); 
		//cal.add (Calendar.MONTH, 2); 
		//cal.add (Calendar.DAY_OF_MONTH, 0); 
		cal.add (Calendar.HOUR_OF_DAY, val); 
		String calTime = sdf.format (cal.getTime ()); 

		return calTime;
	}
	
	/**
     * (ѱ) ð(HHmm) ϴ ð ŭ Ѵ.
     * @param val int  ϴ ð.
     * @return String  ð.
     */
	public static String getGMTHeader(String format) {
		SimpleDateFormat sdf = new SimpleDateFormat ("format"); 
		long currentTime = System.currentTimeMillis (); 
		String nowTime = sdf.format (new Date (currentTime)); 
		
		Calendar cal = sdf.getCalendar (); 
		long instanceTime = cal.getTime ().getTime (); 
		
		//1 2 14ð ߰ 
		//cal.add (Calendar.YEAR, 1); 
		//cal.add (Calendar.MONTH, 2); 
		//cal.add (Calendar.DAY_OF_MONTH, 0); 
		cal.add (Calendar.HOUR_OF_DAY, -9); 
		String calTime = sdf.format (cal.getTime ()); 

		return calTime;
	}	
	
	/**
     * GMT  ڸ ´
     * @param formatDate String Display ϴ Format
     * @return String  ð.
     */
	public static String getGMTYM(String formatDate) {
		SimpleDateFormat sdf = new SimpleDateFormat (formatDate); 
		long currentTime = System.currentTimeMillis (); 
		String nowTime = sdf.format (new Date (currentTime)); 
		
		Calendar cal = sdf.getCalendar (); 
		//long instanceTime = cal.getTime ().getTime (); 
		
		cal.add (Calendar.HOUR_OF_DAY, -9); 
		String calTime = sdf.format (cal.getTime ()); 

		return calTime;
	}
	
	/**
     * GMT  ڸ ´
     * @param formatDate String Display ϴ Format
     * @return Date
     */
	public static Date getGMTDate() {
		SimpleDateFormat sdf = new SimpleDateFormat (); 
		long currentTime = System.currentTimeMillis (); 
		String nowTime = sdf.format (new Date (currentTime)); 
		
		Calendar cal = sdf.getCalendar (); 
		cal.add (Calendar.HOUR_OF_DAY, -9); 
		//String calTime = sdf.format (cal.getTime ()); 

		return cal.getTime ();
	}
	
	/**
     * GMT ð ´
     * @param dateForm String ==> yyMMddHHmmss, MMddHHss, ddHHss
     * @return String  ð.
     */
	public static String getGMTSecond(String dateForm) {
		if (StringUtil.checkString(dateForm).equals("")) dateForm = "yyMMddHHmmss";
		
		//SimpleDateFormat sdf = new SimpleDateFormat ("yyyy/MM/dd HH:mm:ss"); 
		SimpleDateFormat sdf = new SimpleDateFormat (dateForm); 
		long currentTime = System.currentTimeMillis (); 
		String nowTime = sdf.format (new Date (currentTime)); 
		
		Calendar cal = sdf.getCalendar (); 
		long instanceTime = cal.getTime ().getTime (); 
		
		//1 2 14ð ߰ 
		//cal.add (Calendar.YEAR, 1); 
		//cal.add (Calendar.MONTH, 2); 
		//cal.add (Calendar.DAY_OF_MONTH, 0); 
		cal.add (Calendar.HOUR_OF_DAY, -9); 
		String calTime = sdf.format (cal.getTime ()); 

		return calTime;
	}

	/**
	 * ־ ¥   Ķͷ ϸ  ջ ¥ ȯѴ.
	 * @param baseDay String س¥
	 * @param min int س¥  
	 * @param formatType String ȯ ¥ 
	 * @return String  ջ ¥
	 * @exception java.text.ParseException
	 */
	public static String addMins(String baseDay, int min, String formatType) throws ParseException {
		String format = formatType;
		
        SimpleDateFormat formatter = new SimpleDateFormat(format, java.util.Locale.KOREA);
        
        Date date = null;
        try {		    
		    date = formatter.parse(baseDay);
		} catch (ParseException e) {
			throw new ParseException(e.getMessage(), e.getErrorOffset());
		}
        date.setTime(date.getTime() + ((long)min * 1000 * 60));
        
        return formatter.format(date);
    }
	
	/**
	 * ־ ¥  ¥ Ķͷ ϸ  ջ ¥ ȯѴ.
	 * @param baseDay String س¥
	 * @param day int س¥  ¥
	 * @param format int ȯ ¥ 
	 *		1 : 'yyyyMMdd' 2 : 'yyyyMMddhh' 3 : 'yyyy-MM-dd' 4 : 'yyyy-MM-dd-hh' 5 : 'yyyy:MM:dd'
	 * @return String  ջ ¥
	 * @exception java.text.ParseException
	 */
	public static String addDays(String baseDay, int day, int formatType)
			throws java.text.ParseException {
		String format = getDateFormatType(formatType);
		
        java.text.SimpleDateFormat formatter =
		    new java.text.SimpleDateFormat (format, java.util.Locale.KOREA);
        
        java.util.Date date = null;
        try {		    
		    date = formatter.parse(baseDay);
		} catch (java.text.ParseException e) {
			throw new java.text.ParseException(e.getMessage(), e.getErrorOffset());
		}
        date.setTime(date.getTime() + ((long)day * 1000 * 60 * 60 * 24));
        return formatter.format(date);
    }
    
    public static String addMons(String baseMon, int mon) {
    	if (baseMon == null || baseMon.length() != 6) return "000000";
    	String addMon = null;
    	
    	int term = 0;
    	int yyyy = Integer.valueOf(baseMon.substring(0,4)).intValue();
    	int mm = Integer.valueOf(baseMon.substring(4)).intValue();
    	
    	term = mm - mon;
    	
    	//Logger.debug.println("===== mm : "+mm+", mon : "+mon+", term : "+term);
    	
    	if (term == 0) {
    		addMon = String.valueOf(yyyy-1).toString() + "12";
    	} else if (term < 0) {
    		int term2 = 12 + term;
    		if (term2 < 10)  addMon = String.valueOf(yyyy-1).toString()  + "0" + term2;
    		else addMon = String.valueOf(yyyy-1).toString()  + term2;
    	} else {
    		if (term  < 10) addMon = String.valueOf(yyyy).toString() + "0" + String.valueOf(term).toString();
			else addMon = String.valueOf(yyyy).toString() + String.valueOf(term).toString();
    	}
    	
    	/*
    	if (mm < 1) {
    			addMon = String.valueOf(yyyy-1).toString() + "12";
    	} else {
				if (mm  < 10) addMon = String.valueOf(yyyy).toString() + "0" + String.valueOf(mm).toString();
				else addMon = String.valueOf(yyyy).toString() + String.valueOf(mm).toString();
    	}
    	*/
    	
    	return addMon;
    }
    
    /**
     * ־  ´ ¥¸ ȯ
     * @param type int ¥ 
     * @return String ¥  
     */
    public static String getDateFormatType(int type) {
    	String format = "yyyy-MM-dd";
		
		switch(type) {
			case 1:
				format = "yyyyMMdd";
				break;
			case 2:
				format = "yyyyMMddhh";
				break;
			case 3:
				format = "yyyy-MM-dd";
				break;
			case 4:
				format = "yyyy-MM-dd-hh";
				break;
			case 5:
				format = "yyyy:MM:dd";
				break;
			case 6:
				format = "MMMDD HH:MM";
			default:
				break;
		}
		
		return format;
    }
    
    /**
     * Null ڿ 鹮ڿ ٲٰų  Ե ڿ  Ѵ.
     */
	public static String checkString(String str) {
		if(str != null)
			return str.trim();
		else
			return "";
	}    

    /**
     * '-' Ե ȭȣ 3 ߶ 
     * @param type String '-' Ե ȭȣ
     * @return String[] ȣ,,ȣ 
     */	
	public static String[] unFormatTel(String str) {
		int i = 0;
		String noTel[] = new String[3];
		StringTokenizer st = new StringTokenizer(str,"-");
		 while (st.hasMoreTokens()) {
		 	noTel[i] = st.nextToken();
		 	i++;
		 }
		 return noTel;
	}
	
	public static ArrayList unFormatTel2(String str) {
		int i = 0;
		//String noTel[] = new String[3];
		ArrayList noTel = new ArrayList();
		
		StringTokenizer st = new StringTokenizer(str,"-");
		 while (st.hasMoreTokens()) {
		 	noTel.add(i,st.nextToken());
		 	i++;
		 }
		 return noTel;
	}

    /**
     * ǰȣ Ư Լ
     * ǰȣ Ưڸ  ex) 123 45.67/8-9 -> 123456789
     * @param str String ˵ ǰȣ ڿ
     * @return String  ڿ
     * @author Copyright (c) 2002 HIST 
     */
    public static String unFormatPart(String str) {
    	StringBuffer strPart = new StringBuffer();

		if (str == null || str.length() == 0) return "";

    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == '-' || str.charAt(i) == '.' || str.charAt(i) == '/' || str.charAt(i) == ' ' || str.charAt(i) == '+') continue;
    		strPart.append(str.charAt(i));
    	}

    	return strPart.toString();
    }	
    
    /**
     * ǰȣ Ư Կ ˻ Լ
     * ǰȣ Ư Կθ ˻
     * @param str String ˻ ǰȣ ڿ
     * @return String Ư Կ ڿ ex) : Y,  : N
     * @author Copyright (c) 2002 HIST 
     */
    public static String checkChar(String str) {
    	String strCheck = "N";

	if (str == null || str.length() == 0) return "";

    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == '-' || str.charAt(i) == '.' || str.charAt(i) == '/' || str.charAt(i) == ' ' || str.charAt(i) == '+') strCheck="Y";
    	}

    	return strCheck;
    }	   
    
  /**
     * ڵϹȣ Formatting Լ.
     * ڵϹȣ 3ڸ-2ڸ-5ڸ Format
     * @param str String ڵϹȣ
     * @return String - Ե ڵϹȣ
     * @author Copyright (c) 2002 HIST 
     */
    public static String FormatBiz(String str)
    {
    	try {
	            int iLen = str.length();
	            if(iLen == 10) {
	                return str.substring(0, 3) + "-" + str.substring(3, 5) + "-" + str.substring(5);
	            } else {
	    		    return str;
	            }
    	}
    	catch(Exception e) {
    		return str;
    	}
    }       
    
  /**
     * ݾ׹׼ Formatting Լ.
     * ݾ׹׼ õ ',' 
     * @param str String ݾ׹׼
     * @return String , Ե ݾ׹׼
     * @author Copyright (c) 2002 HIST 
     */
    public static String FormatComma(String str)
    {
	try {
		long iVal = StringUtil.convertLong(str);
	 	double dVal = StringUtil.convertDouble(str);
	 	
	 	if(iVal==dVal) {
	 		DecimalFormat df = new DecimalFormat(",##0");
	 		return df.format(dVal);
	 	} else {
	 		StringTokenizer st = new StringTokenizer(str,".");
			String[] arr = new String[st.countTokens()];
		
			int iCnt = 0;
			while(st.hasMoreTokens())
			{
			        arr[iCnt] = st.nextToken();
			        iCnt = iCnt + 1;
			}
			
			//if((arr[1].substring(1)).equals("0")) {
			if(((arr[1].substring(1)).equals("0"))||((arr[1].substring(1)).equals(""))) {
		 		DecimalFormat df = new DecimalFormat(",##0.0");
				return df.format(dVal);
		 	} else {
		 		DecimalFormat df = new DecimalFormat(",##0.00");
				return df.format(dVal);
		 	}
	 	}    		
    	}
    	catch(Exception e) {
    		return "";
    	}
    }        
    
  /**
     * ݾ׹׼ Formatting Լ.
     * ݾ׹׼ õ ',' 
     * @param no double ݾ׹׼
     * @return String , Ե ݾ׹׼
     * @author Copyright (c) 2002 HIST 
     */
    public static String FormatComma(double no)
    {
	try {
		String str = no+"";
		long iVal = StringUtil.convertLong(str);
	 	double dVal = StringUtil.convertDouble(str);
	 	if(iVal==dVal) {
	 		DecimalFormat df = new DecimalFormat(",##0");
	 		return df.format(dVal);
	 	} else {
	 		StringTokenizer st = new StringTokenizer(str,".");
			String[] arr = new String[st.countTokens()];
		
			int iCnt = 0;
			while(st.hasMoreTokens())
			{
			        arr[iCnt] = st.nextToken();
			        iCnt = iCnt + 1;
			}
			
			//if((arr[1].substring(1)).equals("0")) {
			if(((arr[1].substring(1)).equals("0"))||((arr[1].substring(1)).equals(""))) {
		 		DecimalFormat df = new DecimalFormat(",##0.0");
				return df.format(dVal);
		 	} else {
		 		DecimalFormat df = new DecimalFormat(",##0.00");
				return df.format(dVal);
		 	}
	 	}    		
    	}
    	catch(Exception e) {
    		return "";
    	}
    }         
    
    /**
     * ݾ׹׼ UnFormatting Լ.
     * ݾ׹׼ ',' 
     * @param str String ݾ׹׼
     * @return String , ŵ ݾ׹׼
     * @author Copyright (c) 2002 HIST 
     */
    public static String unFormatComma(String str) {
    	StringBuffer strPart = new StringBuffer();

	if (str == null || str.length() == 0) return "";

    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == ',') continue;
    		strPart.append(str.charAt(i));
    	}

    	return strPart.toString();
    }	 
    
    /**
     * ¥ ú 
     * 200101012200 --> 2001-01-01 22:00
     * @param str String ˵ ¥ڿ
     * @return String ˵ ڿ
     * @author Copyright (c) 2002 HIST 
     */
    public static String FormatDHM(String str) {
    	StringBuffer strDate = new StringBuffer();

	if (str == null || str.length() == 0) return "";
	
	String sYear = str.substring(0,4);
	String sMon = str.substring(4,6);
	String sDay = str.substring(6,8);
	String sHour = str.substring(8,10);
	String sMin = str.substring(10);
	strDate.append(sYear);
	strDate.append("-");
	strDate.append(sMon);
	strDate.append("-");
	strDate.append(sDay);
	strDate.append(" ");
	strDate.append(sHour);
	strDate.append(":");
	strDate.append(sMin);

    	return strDate.toString();
    }             
    
    /**
     * Hashtable   Ѵ.
     * @param hashData Hashtable Input Data
     * @param key String Hashtable key
     * @return long  
     * @author Copyright (c) 2004 HIST 
     */
    public static long hashCount(Hashtable hashData, String key) {
    	long hashCnt = 0;
    	
    	if (hashData != null) {
			List listData = (List)hashData.get(key);
			if (listData != null) {
				hashCnt = listData.size();
			} else hashCnt = 0;
    	} else hashCnt = 0;
    	
    	return hashCnt;
    }	 
    
     /**
     * String[] ͸ SortѴ
     * @param args String[] Sortų Array
     * @return  String[] Sort Array
     * @author Copyright (c) 2004 HIST 
     */
    public static String[] sortArr(String[] args) {
    	if (args != null) Arrays.sort(args);
    	return args;
    }	 
    
     /**
     * String[] ͸ String ȯѴ
     * @param args String[] ȯų Array
     * @param fName String ʵ
     * @return  String ȯ String
     * @author Copyright (c) 2004 HIST 
     */
    public static String convertArr(String[] args, String fName) {
    	StringBuffer strbuf = new StringBuffer();
    	
    	if (args != null) {
    		args = sortArr(args);
    		for(int i=0; i<args.length; i++) {
    			//Aircraft Reg  Flight ID  ڸ ڸ --> Flight Number  
    			//if (fName.equals("reg") || fName.equals("fid")) strbuf.append(args[i].substring(2));
    			if (fName.equals("fid")) strbuf.append(args[i].substring(2));
    			else  strbuf.append(args[i]);
    			if (i != args.length-1) strbuf.append(",");
    		}
    	} else return "";
    	
    	return strbuf.toString();
    }	 
    
    /** 
     * String Array ȯѴ
     * @param str String , е String
     * @return String[] ȯ Array
     * @author Copyright (c) 2004 HIST 
     */
    public static String[] convertString(String str) {
    	String[] arrString = null;
    	
    	if (!str.equals("")) {
	    	StringTokenizer st = new StringTokenizer(str, ",");
			arrString = new String[st.countTokens()];
	
			int iCnt = 0;
			while(st.hasMoreTokens())
			{
			        arrString[iCnt] = st.nextToken();
			        iCnt = iCnt + 1;
			}
    	}
		
		return arrString;
    }
    
      /**
     * MM  MMM ȯѴ
     * @param MM 
     * @return  MMM
     * @author Copyright (c) 2004 HIST 
     */
    public static String fmtDate(String str) {
    	String strDate = "";
    	if (!str.equals("")) {
    		strDate = formatMMM(str.substring(2,4))+" "+str.substring(4,6)+" "+str.substring(6,8)+":"+str.substring(8);
    	}
    	return strDate;
    }	 
    
     /**
     * MM  MMM ȯѴ
     * @param MM String 
     * @return  MMM
     * @author Copyright (c) 2004 HIST 
     */
    public static String formatMMM(String MM) {
    	String MMM = null;
    	
    	if (MM != null) {
    		if (MM.equals("01")) MMM = "JAN";
    		else if(MM.equals("02")) MMM = "FEB";
    		else if(MM.equals("03")) MMM = "MAR";
    		else if(MM.equals("04")) MMM = "APR";
    		else if(MM.equals("05")) MMM = "MAY";
    		else if(MM.equals("06")) MMM = "JUN";
    		else if(MM.equals("07")) MMM = "JUL";
    		else if(MM.equals("08")) MMM = "AUG";
    		else if(MM.equals("09")) MMM = "SEP";
    		else if(MM.equals("10")) MMM = "OCT";
    		else if(MM.equals("11")) MMM = "NOV";
    		else MMM = "DEC";
    	}else MMM = "";
    	
    	return MMM;
    }	 
    
    public static String monCheck(String val,String header) {
    	//
    	String flag = "";
    	String yymmmdd = "";
    	String yyyy = "20";
    	String mmm = "";
    	String dd = "";
    	
    	//Value null̰ų  鸮    	
    	if (val == null || val.length() == 0) return "";
    	
		yymmmdd = val.trim();
		if (yymmmdd.length() != 7) return "Invalid"+header+"Date Format<BR>Ex) 04FEB12";
		yyyy = yymmmdd.substring(0,2);
		mmm = yymmmdd.substring(2,5);
		dd = yymmmdd.substring(5);
		
		if (!numberCheck(yyyy)) return header+"Year is Only Numeric";
		else if (Integer.valueOf(yyyy).intValue() < 1) return header+"Year is Over 1 Year";
		if (!numberCheck(dd)) return header+"Day is Only Numeric";
		else if (Integer.valueOf(dd).intValue() < 1 || Integer.valueOf(dd).intValue() > 31) return "Invalid"+header+"Date<BR>Insert From 01 To 31";
		
		int chkMon = mmm.indexOf("JAN,FEB,MAR,APR,MAY,JUN,JUL,AUG,SEP,OCT,NOV,DEC");
		if (chkMon == -1) return "Invalid"+header+"Month<BR>>Ex) FEB";
    	
    	return flag;
    }
    
    /**
     * ڿ Ե ĳ    ã´
     * @param str String ڿ
     * @return  cnt ĳ  
     * @author Copyright (c) 2004 HIST 
     */
    public static int countCRLF(String str) {
    	int cnt = 0;

		if (str == null || str.length() == 0) return 0;
			
    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == '\n') cnt++;
    	}

    	return cnt;
    }	
    
    /**
     * ڿ Ե '$'   ã´
     * @param str String ڿ
     * @return  cnt ĳ  
     * @author Copyright (c) 2004 HIST 
     */
    public static int countDollar(String str) {
    	int cnt = 0;

		if (str == null || str.length() == 0) return 0;
	
    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == '$') cnt++;
    	}

    	return cnt;
    }	
    
    /**
     * ڿ Ե ĳ  ſ <BR> Ѵ
     * @param str String ڿ
     * @return  strTemp  ڿ
     * @author Copyright (c) 2004 HIST 
     */
    public static String replaceCRLF(String str) {
    	StringBuffer strTemp = new StringBuffer();

		if (str == null || str.length() == 0) return "";
		
		//Logger.debug.println("[StringUtil:countCRLF] str : "+str);
	
    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == '\n') {
    		  //Logger.debug.println("[StringUtil:countCRLF] str.charAt(i) : "+str.charAt(i));
    		  //strTemp.append("<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    		  strTemp.append("<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
    		} else if (str.charAt(i) == ' ') {
    		  strTemp.append("&nbsp;");	
    		} else strTemp.append(str.charAt(i));
    	}
	
	    return strTemp.toString();
    }
    
    /**
     * ڿ CR ſ '$' ϰ LF,SOH,STX,ETX Ѵ
     * @param str String ڿ
     * @return  strTemp  ڿ
     * @author Copyright (c) 2004 HIST 
     */
    public static String convertCRLF(String str) {
    	String strTemp = "";

		if (str == null || str.length() == 0) return "";
		
		//<etx>ġ ķ  
		/*
		int posETX = (escape(str)).lastIndexOf("/u3");
		if (posETX != -1) str = unescape((escape(str)).substring(0,posETX+1));
		*/
		
    	for(int i=0; i < str.length(); i++) {
    		String tmp = escape(str.substring(i,i+1));
    		
    		if (tmp.equals("/uA")) strTemp += "$";
    		else if (tmp.equals("/uD")|| tmp.equals("/u1")|| tmp.equals("/u2")|| tmp.equals("/u3")) strTemp += "";
    		else strTemp += unescape(tmp);
    	}
	
	    return strTemp.toString();
    }
    
    /**
     * ڿ Ե '$ ſ 'ĳ  Ѵ
     * @param str String ڿ
     * @return  strTemp  ڿ
     * @author Copyright (c) 2004 HIST 
     */
    public static String replaceDollar(String str) {
    	StringBuffer strTemp = new StringBuffer();

		if (str == null || str.length() == 0) return "";
	
    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == '$') {
    		  strTemp.append("\n");
    		} else strTemp.append(str.charAt(i));
    	}
	
	    return strTemp.toString();
    }
    
       /**
     * ڿ Ե '$ ſ '#' Ѵ
     * @param str String ڿ
     * @return  strTemp  ڿ
     * @author Copyright (c) 2004 HIST 
     */
    public static String replaceSharp(String str) {
    	StringBuffer strTemp = new StringBuffer();

		if (str == null || str.length() == 0) return "";
	
    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == '$') {
    		  strTemp.append("#");
    		} else strTemp.append(str.charAt(i));
    	}
	
	    return strTemp.toString();
    }
    
    /**
     * ڿ Ե ĳ  ſ '<BR>' Ѵ
     * @param str String ڿ
     * @return  strTemp  ڿ
     * @author Copyright (c) 2004 HIST 
     */
    public static String replaceBR(String str) {
    	StringBuffer strTemp = new StringBuffer();
		if (str == null || str.length() == 0) return "";
	
    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == '\n') {
    		   strTemp.append("<BR>");
   		    } else if (str.charAt(i) == '\r') {
    			continue;
    		} else if (str.charAt(i) == ' ') {
    			strTemp.append("&nbsp;");
    		} else strTemp.append(str.charAt(i));
    	}
    
	   return strTemp.toString();
    }    
    
    /**
     * ڿ Ե '##' ſ ĳ  Ѵ
     * @param str String ڿ
     * @return  strTemp  ڿ
     * @author Copyright (c) 2004 HIST 
     */
    public static String repCRLF(String str) {
		if (str == null || str.length() == 0) return "";
	
    	StringBuffer strTemp = new StringBuffer();
		for (int i=0; i<str.length(); i++) {
				if (i == str.length()-1) {
					strTemp.append(str.charAt(i));
				} else {
					if (str.charAt(i) == '#' && str.charAt(i+1) == '#') {
						strTemp.append("\n");
						i += 1;
					} else {
						strTemp.append(str.charAt(i));
					}
				}
		}
	
	    return strTemp.toString();
    }    
    
     /**
     * ޼  Ѵ
     * @param pgmID String α׷ ID
     * @return  strHeader  Headerڿ
     * @author Copyright (c) 2004 HIST 
     */
    public static String msgHeader(String pgmID) {
    	String strHeader = null;
    	
    	if (pgmID == null || pgmID.length() == 0) return "";
    	
    	strHeader = "["+pgmID+" | "+getGMTheader("MM/dd HH:mm")+"]"+"  ";
    	return strHeader;
    }
    
     /**
     * String[]  "" ƴ  ã ȯѴ.
     * @param arrStr String[]
     * @return  cntY Array ǵ 
     * @author Copyright (c) 2004 HIST 
     */
    public static int countY(String[] arrStr) {
    	int cntY = 0;
    	
    	if (arrStr == null ) return 0;
    	
    	//arrStr[0] ü Ѱ̶ Ѵ
    	for (int i = 1; i<arrStr.length; i++) {
    		//Logger.debug.println("[StringUtil:countY] arrStr["+i+"] : "+ arrStr[i]);
   			if (!arrStr[i].equals("")) cntY = cntY +1;
    	}
    	
    	return cntY;
    }
    
    /**
     * arrStr  arrData شϴ ʵ带 ؼ
     * arrFilter  Y arrData  "" false Ѵ
     * @param arrStr String[] Config ϵ  
     * @param arrData String[]  Message 
     * @return  chkFlag 
     * @author Copyright (c) 2004 HIST 
     */
    public static boolean compareArray(String[] arrStr, String[] arrData) {
    	boolean chkFlag = true;
    	
    	if (arrStr == null || arrData == null) return false;
    	
    	//Array [1] ϴ ʵ
    	for (int i=1; i<arrStr.length; i++) {
    		//Logger.debug.println("[StringUtil:countY] arrStr["+i+"] : "+ arrStr[i]+", arrData["+i+"] : "+arrData[i]);
    		if (!arrStr[i].equals("") && arrData[i].equals("")) {
    			chkFlag = false;
    			break;
    		}
    	}
    	
    	return chkFlag;
    }
    
    /**
     * Remote Exception Error Message мؼ   ߻
     * ޼ Ѵ
     * @param strMsg String Remote Exception Message
     * @return  str   ޼
     * @author Copyright (c) 2004 HIST 
     */
    public static String tokenMessage(String strMsg) {
    	if (strMsg == null || strMsg.length() == 0) return "";
    	
    	String str = null;
    	
    	//lastIndex  -1 Ѵ
    	int startIndex = strMsg.lastIndexOf("##");
    	int endIndex = strMsg.lastIndexOf("::");
    	
    	if (startIndex == -1 || endIndex == -1) str = strMsg;
    	else str = strMsg.substring(startIndex+2, endIndex);
    	return str;
    }
    
     /**
     * YY-MM-DD ͸ YYYYMMDD ٲ۴
     * @param strDate String ٲ Date String
     * @return  String  Date
     * @author Copyright (c) 2004 HIST 
     */
    public static String chgDate(String strDate) {
		if (strDate == null || strDate.length() != 8) return "";
    	
    	String str = "20"+strDate.substring(0,2)+strDate.substring(3,5)+strDate.substring(6,8);
    	
    	return str;
    }	 
    
    //ѱ  ڵ
	public static String to8859_1(String ko){ 
		if(ko==null){ 
		    return null; 
		} 
		try{ 
		    return new String(checkString(ko).getBytes("KSC5601"),"8859_1"); 
		}catch(Exception e){return ko;} 
	} 
	
    //ѱ۷ ڵ
	public static String toKSC5601(String en){ 
		if(en==null){ 
		    return null; 
		} 
		try{ 
		    return new String(checkString(en).getBytes("8859_1"),"KSC5601"); 
		}catch(Exception e){return en;} 
	} 
	
    /**
     * ڿ Ե '/'   ã´
     * @param str String ڿ
     * @return  cnt ĳ  
     * @author Copyright (c) 2004 HIST 
     */
    public static int countSlash(String str) {
    	int cnt = 0;

		if (str == null || str.length() == 0) return 0;
	
    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == '/') cnt++;
    	}

    	return cnt;
    }	    
    
    /**
     * Messenger Raw Message ==> Short Message
     * @param str String ڿ
     * @return  cnt ĳ  
     * @author Copyright (c) 2004 HIST 
     */
    public static String shtMessage(String str) {
    	String strTemp = "";

		if (str == null || str.length() == 0) return "";
		
		//ڿ DT ġ
		int dtPos = str.indexOf("DT");
		
		//DT  ϸ
		if (dtPos != -1) {
			//'-' ġ
			int indexDash = str.indexOf("-");
			//'-' ϸ -  ڿ ´
			if (indexDash != -1) {
				//Logger.debug.println("[StringUtil:shtMessage] 1 :"+str);
				strTemp = checkString(str.substring(indexDash+1));
			//'-'  SMI  ڿ ´
			} else {
				//Logger.debug.println("[StringUtil:shtMessage] 2 :"+str);
				if (str.length() > 30) strTemp = checkString(str.substring(30));
				else strTemp = str;
			}
		} 
		//Dt 
		else {
			//SMI  ڿ ´
			if (str.length() > 30) strTemp = checkString(str.substring(30));
			else strTemp = str;
		}
	
    	return strTemp;
    }    
    
    //A,B,C ڿ 'A','B','C' ȯѴ
    public static String addSingle(String str) {
    	if (str == null || str.length() == 0) return "";
    	
    	String strTemp = "";
    	int i = 0;
		StringTokenizer st = new StringTokenizer(str, ",");
		while(st.hasMoreTokens()) {
				strTemp += ",'"+st.nextToken()+"'";
		        i = i + 1;
		}
		if (strTemp.length() > 1) strTemp = strTemp.substring(1);
		
		return strTemp;
    }
    
    public static boolean numberCheck(String str) {
    	if (str == null || str.length() == 0) return false;
    	
    	boolean nFlag = true;
    	for (int i=0; i<str.length(); i++) {
    		if (str.charAt(i) != '0' && str.charAt(i) != '1' && str.charAt(i) != '2' && str.charAt(i) != '3' && 
    		str.charAt(i) != '4' && str.charAt(i) != '5' && str.charAt(i) != '6' && str.charAt(i) != '7' && 
    		str.charAt(i) != '8' && str.charAt(i) != '9') {
    		    	nFlag = false;
    		    	break;
    		}
    	}
    	
    	return nFlag;
    }
    
    //string byte Ѵ
    public static int stringByte(String str) {
    	if (str == null || str.length() == 0) return 0;
    	
    	byte[] bt = str.getBytes();
		int stringSize = bt.length;
    	
    	return stringSize;
    }
    
   /**
     * Daily_Sch_T Status ڵ庰 ð  Լ.
     * Dep_sts/Arv_sts  ETD,ATD,TOFF/ETA,ATA,TDWN 
     * @param flag String DEP/ARV ڵ ex) D/A
     * @param depSts String Dep Status Code
     * @param arvSts String Dep Status Code
     * @param time1 String ETD/ETA
     * @param time2 String ATD/ATA
     * @param time3 String TOFF/TDWN
     * @return String - Ե ڵϹȣ
     * @author Copyright (c) 2002 HIST 
     */
    public static String[] StatusTime(String flag,String depSts,String arvSts,String time1,String time2,String time3) {
    	
    	if (flag == null || flag.length() == 0) return null;
    	String[] arrTime = null;
    	
    	if (flag.equals("D")) {
			arrTime = new String[3];    		
			if (depSts.equals("SCH")) {
				arrTime[0] = "";
				arrTime[1] = "";
				arrTime[2] = "";
			} else if (depSts.equals("EST")) {
				arrTime[0] = time1;
				arrTime[1] = "";
				arrTime[2] = "";
			} else if (depSts.equals("ACT")) {
				arrTime[0] = "";
				arrTime[1] = time2;
				arrTime[2] = time3;
			} else {
				arrTime[0] = "";
				arrTime[1] = "";
				arrTime[2] = "";
			}
    	} else {
    		arrTime = new String[3];
    		if (arvSts.equals("SCH")) {
    			if (depSts.equals("ACT"))	{
    				arrTime[0] = time1;
					arrTime[1] = "";
					arrTime[2] = time3; //Land_t 2017.01.11 "" time3 
    			} else {
    				arrTime[0] = "";
					arrTime[1] = "";
					arrTime[2] = time3; //Land_t 2017.01.11 "" time3 
    			}
			} else if (arvSts.equals("EST")) {
				arrTime[0] = time1; //Est_arv_tm
				arrTime[1] = "";	//Act_arv_tm
				arrTime[2] = time3; //Land_t 2017.01.11 "" time3 
			} else if (arvSts.equals("ACT")) {
				arrTime[0] = "";
				arrTime[1] = time2;
				arrTime[2] = time3;
			} else {
				arrTime[0] = "";
				arrTime[1] = "";
				arrTime[2] = "";
			}
    	}
    	
    	return arrTime;
    }     
    
    /**
     * Number Format Լ.
     *  Flag Number Format
     * @param flag int 1 :   2 : Ҽ1ڸ  3 : Ҽ2ڸ
     * @param val double ڰ
     * @return String Formatting Number
     * @author Copyright (c) 2002 HIST 
     */
	public static String NumberFormatD(int flag,double val) {    
		if (val == 0) return "0";
		DecimalFormat df = null;
		
		switch(flag) {
			case 1:
				df = new DecimalFormat("#,##0");
				break;
			case 2:
				df = new DecimalFormat("##0.0");
				break;
			case 3:
				df = new DecimalFormat("##0.00");
				break;
			default:
				break;
		}
		
		//
		
		return df.format(val);
	}
	
    /**
     * Number Format Լ.
     *  Flag Number Format
     * @param flag int 1 :   2 : Ҽ1ڸ  3 : Ҽ2ڸ
     * @param val String ڰ
     * @return String Formatting Number
     * @author Copyright (c) 2002 HIST 
     */
	public static String NumberFormatS(int flag,String val) {    
		if (val.equals("0")) return "0";
		DecimalFormat df = null;
		
		switch(flag) {
			case 1:
				df = new DecimalFormat("#,##0");
				break;
			case 2:
				df = new DecimalFormat("##0.0");
				break;
			case 3:
				df = new DecimalFormat("##0.00");
				break;
			default:
				break;
		}
		
		return df.format(Double.valueOf(val).doubleValue());
	}	
	
	public static String replace(String strTarget, String strSearch, String strReplace) {
		
		String strCheck = new String(strTarget);
		StringBuffer strBuf = new StringBuffer();
		
		while(strCheck.length() != 0) {
			int begin = strCheck.indexOf(strSearch);
			
			if(begin == -1) {
				strBuf.append(strCheck);
				break;
			}
			 else{
				int end = begin + strSearch.length();
				strBuf.append(strCheck.substring(0, begin));
				strBuf.append(strReplace);
				strCheck = strCheck.substring(end);
			}
		}
		
		return new String(strBuf);
	}
	
	public static String DBInsStr(String orStr){
		String dbStr = new String();
		
		if(orStr != null && !orStr.equals("")){
			dbStr = replace(orStr, "'", "''");
		}
		else{
			dbStr = orStr;
		}
		
		return dbStr;
	}
	
	public static String TBselStr(String orStr){
			String dbStr = new String();
		
			if(orStr != null && !orStr.equals("")){				
				dbStr = replace(orStr, "\"", "&quot;");
			}
			else{
				dbStr = orStr;
			}
		
			return dbStr;
	}
	
	public static String CRLFselStr(String orStr){
			String dbStr = new String();
		
			if(orStr != null && !orStr.equals("")){				
				dbStr = replace(orStr, "\n", "$");
			}
			else{
				dbStr = orStr;
			}
		
			return dbStr;
	}	
	
	public static String HTMLselStr(String orStr){
			String dbStr = new String();
			String temp = new String();
		
			if(orStr != null && !orStr.equals("")){				
				temp = replace(orStr, "\"", "&quot;");
				temp = replace(temp, "<", "&lt;");
				temp = replace(temp, ">", "&gt;");
				temp = replace(temp, "&", "&amp;");
				temp = replace(temp, " ", "&nbsp;");
				
				dbStr = temp;
			}
			else{
				dbStr = orStr;
			}
		
			return dbStr;
	}
	
	public static String JSRselStr(String orStr){
			String dbStr = new String();
			String temp = new String();
		
			if(orStr != null && !orStr.equals("")){				
				temp = replace(orStr, "\"", "&quot;");				
				dbStr = temp;
			}
			else{
				dbStr = orStr;
			}
		
			return dbStr;
	}	
	
	public static String insString(String str) {
		if (str.equals("100")) return str;
		
		String tmp = "";
		if (str.length() == 1) tmp = "00"+str;
		else if (str.length() == 2) tmp = "0"+str;
		else if (str.length() == 3) tmp = "00"+str;
		else if (str.length() == 4) tmp = "0"+str;
		
		return tmp;
	}
	
   /**
     * Operations Control Board Gauge ġ 5 ȯѴ (0%~100% )
     * @param str String  %
     * @return  String ȯ ġ (5)
     * @author Copyright (c) 2004 HIST 
     */
    public static String OCBConvGag(String str) {
    	
    	if (str == null || str.length() == 0) return "0";
    	
    	//Logger.debug.println("[StringUtil] str : "+str);
    	
    	String conv = null;
    	if (str.equals("0")) {
    		conv = str;
    	} else if (str.length() == 3 || str.equals("100.0")) {
    		conv = "100";
    	} else if (str.length() == 1) {
    		int tmp2 =  Integer.valueOf(str).intValue();						//ڸ
    		
    		//1~2 => 0
    		//3~7 => 5
    		//8~9 => 0 +1
    		if (tmp2 >= 0 && tmp2 <= 2) {
    			tmp2 = 0;
    		} else if (tmp2 >= 3 && tmp2 <= 7) {
    			tmp2 = 5;
    		} else {
    			tmp2 = 10;
    		}
			
			//int => String ȯ
			conv = String.valueOf(tmp2).toString();
    	} else {
    		int tmp1 = Integer.valueOf(str.substring(0,1)).intValue();	//ڸ
    		int tmp2 = Integer.valueOf(str.substring(1,2)).intValue();	//ڸ
    		
    		//0~2 => 0
    		//3~7 => 5
    		//8~9 => 0 +1
    		if (tmp2 >= 0 && tmp2 <= 2) {
    			//tmp1 = tmp1;
    			tmp2 = 0;
    		} else if (tmp2 >= 3 && tmp2 <= 7) {
    			//tmp1 = tmp1;
    			tmp2 = 5;
    		} else {
    			tmp1 = tmp1 +1;
    			tmp2 = 0;
    		}
			
			//int => String ȯ
			conv = String.valueOf(tmp1).toString() + String.valueOf(tmp2).toString();
    	}
    	
    	return conv;
    }//end of function
    
     /**
     * Operations Control Board Gauge ġ 5 ȯѴ (50%~150% )
     * @param str String  %
     * @return  String ȯ ġ (5)
     * @author Copyright (c) 2005 
     */
    public static String OCBConvGag2(double dou) {
    	
    	if (dou == 0) return "50";
    	
    	String conv = "";
    	int tmp1 = 0;
    	int tmp2 = 0;
    	
    	if (dou >= 50 && dou < 100) {
			// 2ڸ
			tmp1 = Integer.valueOf((String.valueOf(dou).toString()).substring(0,1)).intValue();
			tmp2 = Integer.valueOf((String.valueOf(dou).toString()).substring(1,2)).intValue();
			
			if (tmp2 >= 0 && tmp2 <= 2) {
				conv = String.valueOf(tmp1).toString() + "0";
			} else if (tmp2 >= 8 && tmp2 <= 9) {
				conv = String.valueOf(tmp1 + 1).toString() + "0";
			} else {
				conv = String.valueOf(tmp1).toString() + "5";
			}
    	} else {
			// 3ڸ
			tmp1 = Integer.valueOf((String.valueOf(dou).toString()).substring(0,2)).intValue();
			tmp2 = Integer.valueOf((String.valueOf(dou).toString()).substring(2,3)).intValue();
			
			if (tmp2 >= 0 && tmp2 <= 2) {
				conv = String.valueOf(tmp1).toString() + "0";
			} else if (tmp2 >= 8 && tmp2 <= 9) {
				conv = String.valueOf(tmp1 + 1).toString() + "0";
			} else {
				conv = String.valueOf(tmp1).toString() + "5";
			}
    	}
    	
    	return conv;
    }//end of function
    
   /**
     * Domestic, International, Cargo θ Ѵ.
     * @param fltNum String Flight Number
     * @param kacTyp String Korea Actyp
     * @return  String ȯ ġ (5)
     * @author Copyright (c) 2004 HIST 
     */
    public static String GetDomIntX(String fltNum, String kacTyp) {    
    	
    	String domIntX = null;
    	if (fltNum == null || fltNum.length() < 4) return domIntX = "";
    	if (kacTyp == null || kacTyp.length() != 3) return domIntX = "";
    	
    	try {
			//2008.02.22 
			/*
    		//Actyp Ǻ
    		int flag_actyp = kacTyp.indexOf("M1F,7FQ,7FR,74Y,7FG,79S");
    		
    		//CGO Ǻ
    		if (!fltNum.substring(0,1).equals("1") && flag_actyp != -1) {
    			domIntX = "CGO";
    		} else {
    			//DOM - INT Ǻ
    			if (fltNum.substring(0,1).equals("1")) domIntX = "DOM";
    			else if (fltNum.length() >= 5) {
    				char chr = fltNum.charAt(4);
    				if (fltNum.substring(0,2).equals("01") && ( chr >= 'A' && chr <= 'Z') && flag_actyp == -1)
    					domIntX = "DOM";
    				else 
    					domIntX = "INT";
    			} else domIntX = "INT";
    		}
    		*/
    		
			//Actyp Ǻ
			//int flag_actyp = kacTyp.indexOf("ABF,M1F,7FQ,7FR,74Y,7FG,79S,7GG,ABH"); //2009.05.21 ߰ : ABH
			
			//int flag_actyp = "ABF,M1F,7FQ,7FR,74Y,7FG,79S,7GG,ABH,74F".indexOf(kacTyp); //2009.09.14  :   ȳ´ -_-, 2010.03.26 ߰ : 74F
    		int flag_actyp = "ABF,M1F,7FQ,7FR,74Y,7FG,79S,7GG,ABH,74F,74N,77X".indexOf(kacTyp); //2012.02.03 ߰ : 74N,77X
    		
			//CGO Ǻ
			if (!fltNum.substring(0,1).equals("1") && flag_actyp != -1) {
				domIntX = "CGO";
			} else {
				//DOM - INT Ǻ
				if (fltNum.substring(0,1).equals("1")) domIntX = "DOM";
				else domIntX = "INT";
			}
    		
    	} catch(Exception e) {
			return domIntX = "";
		}
   		return domIntX;
    }
    
   /**
     * IP Code 4 Array 
     * @param str String ڿ
     * @return  arrIP String[] IP Code
     * @author Copyright (c) 2004 HIST 
     */
    public static String[] convertIP(String str) {
    	
    	if (str == null || str.length() == 0) return null;
    	String[] arrIP = new String[4];
    	
    	//IP Code 1    	
    	int pos = str.indexOf(".");
    	arrIP[0] = str.substring(0,pos);
    	String temp = str.substring(pos+1);
    	pos = 0;
    	//IP Code 2    	
    	pos = temp.indexOf(".");
    	arrIP[1] = temp.substring(0,pos);
    	temp = temp.substring(pos+1);
    	pos = 0;
    	//IP Code 3,4    	
    	pos = temp.indexOf(".");
    	arrIP[2] = temp.substring(0,pos);
    	arrIP[3] = temp.substring(pos+1);

    	return arrIP;
    }	    
    
    public static String CRLFcvtET(String str) {
    	String strTemp = "";

		if (str == null || str.length() == 0) return "";
		
    	for(int i=0; i < str.length(); i++) {
    		String tmp = escape(str.substring(i,i+1));
    		
    		if (tmp.equals("/uA")) strTemp += "\n";
    		else if (tmp.equals("/uD")|| tmp.equals("/u1")|| tmp.equals("/u2")|| tmp.equals("/u3")) strTemp += "";
    		else strTemp += unescape(tmp);
    	}
	
	    return strTemp.toString();
    }    
    
    public static String CRLFcvtBR(String str) {
    	String strTemp = "";

		if (str == null || str.length() == 0) return "";
		
    	for(int i=0; i < str.length(); i++) {
    		String tmp = escape(str.substring(i,i+1));
    		
    		if (tmp.equals("/uA")) strTemp += "<BR>";
    		else if (tmp.equals("/uD")|| tmp.equals("/u1")|| tmp.equals("/u2")|| tmp.equals("/u3")) strTemp += "";
    		else if (tmp.equals("/20")) strTemp += "&nbsp;";
    		else strTemp += unescape(tmp);
    	}
	
	    return strTemp.toString();
    }

   /**
     * Էµ ڿ ĸ ̽  ĸ ٿ .
     * ,,̽ ĸ  ڰ Է½ 
     * Ex) RKNN,SKTT OASS = RKNN,SKTT,OASS
     * @param stnInp String Է¹ڿ
     * @return  String ռڿ
     * @author Copyright (c) 2005 HIST 
     */      
    public static String icaoChk(String stnInp) throws BusinessException {
    	StringBuffer strbuf = new StringBuffer();
    	if (stnInp == null || stnInp.length() == 0) return "";
    	
    	try {
	    	for (int i=0; i<stnInp.length(); i++) {
	    		char tmp = stnInp.charAt(i);
	    		//tmp //̽/ĸ ƴϸ 
	    		if (tmp < 'A' || tmp > 'Z') {
	    			if (tmp < 'a' || tmp > 'z') {
	    				if (tmp < '0' || tmp > '9') {
	    					if (tmp != ' ' && tmp != ',' && tmp != '/') {
	    						strbuf = new StringBuffer();
	    						//return strbuf.append(tmp).toString();
	    						//throw new BusinessException(strbuf.append(tmp).toString()+" is Invalid Character!! \n Only used Number,Alphabet ,Space,Comma");
	    						throw new BusinessException("Invalid Character!! Only use \n Number,Alphabet ,Space,Comma");
	    					}
	    				}
	    			}
	    		}
	    		
	    		if (stnInp.charAt(i) == ' ' || stnInp.charAt(i) == '/') {
	    			strbuf.append(',');
	    		} else {
	    			strbuf.append(stnInp.charAt(i));
	    		}
	    	}
	    	
	    	//ICAO Station 4ڸ Check
	    	/*
	    	StringTokenizer st = new StringTokenizer(strbuf.toString(),",");
	    	while (st.hasMoreTokens()) {
	    		Logger.debug.println("[icaoChk] st.nextToken() : "+st.nextToken());
	    		//if (st.nextToken().length() > 4 && st.nextToken().length() < 3) {
	    		if (st.nextToken().length() != 4) {
    				Logger.debug.println("[icaoChk] ERROR");
	    			throw new BusinessException (st.nextToken()+" is Invalid ICAO Station or FIR Code");
	    		} else Logger.debug.println("[icaoChk] NOT ERROR");
	    	}
	    	*/
	    	
	    	//Logger.debug.println("[StringUtil:icaoChk] strbuf : "+strbuf.toString());
    	
    		return strbuf.toString();
    	} catch (BusinessException be) {
    		throw new BusinessException(((BusinessException)be).getMessage());
    	}
    }
    
   /**
     *  String ߺ ڿ ϰ  String ߰Ͽ 
     * Ex) RKNN,SKTT,OASS  +   RTFF,OASS  = RKNN,SKTT,OASS,RTFF
     * @param strExt String ڿ
     * @param stnAdd String ߰ڿ
     * @return  String ռڿ
     * @author Copyright (c) 2005 HIST 
     */    
    public static String icaoAdd(String stnExt,String stnAdd) {
    	String stnList = null;
    	if (stnAdd == null || stnAdd.length() == 0) return stnList = stnExt;
    	
    	StringTokenizer st = new StringTokenizer(stnAdd,",");
		while (st.hasMoreTokens()) {
			String temp = checkString(st.nextToken());
			int iFlag = stnExt.indexOf(temp);
			if (iFlag == -1) {
				if (stnExt.equals("")) stnExt += temp;
				else stnExt += ","+temp;
			}
		}
		
		//Logger.debug.println("[StringUtil:icaoAdd] stnExt : "+stnExt);
    	return stnList = stnExt;
    }
    
	/**
	  *  String 1, 2  ߺ ڿ ϰ  String 2  ߰Ͽ 
	  * @author Copyright (c) 2007/09/13  Package 2  ߰!!
	  */    
	 public static String icaoAdd2(String stnExt1,String stnExt2, String stnAdd) {
		 String stnList = null;
		 if (stnAdd == null || stnAdd.length() == 0) return stnList = stnExt2;
    	
		 StringTokenizer st = new StringTokenizer(stnAdd,",");
		 while (st.hasMoreTokens()) {
			 String temp = checkString(st.nextToken());
				 
			 int iFlag = (stnExt1+","+stnExt2).indexOf(temp); //ã 1,2 ʿ ã
			 
			 if (iFlag == -1) {
			 	if (stnExt2.equals("")) stnExt2 += temp;			//߰ 2ٰ ش.
				else stnExt2 += ","+temp;
			 }
		 }
		 
		 return stnList = stnExt2;
	 }
    
   /**
     * Է String DB Decode Format ٲپ 
     * Ex) RKNN',1,'NZAA',2,'WSSS',3,4
     * @param stnList String ڿ
     * @return  String ռڿ
     * @author Copyright (c) 2005 HIST 
     */      
    public static String icaoDecode(String stnList) {
    	StringBuffer strbuf = new StringBuffer();
    	if (stnList == null || stnList.length() == 0) return "";
    	
    	int i = 1;
    	StringTokenizer st = new StringTokenizer(stnList,",");
    	while (st.hasMoreTokens()) {
    		strbuf.append("'");
    		strbuf.append(st.nextToken());
    		strbuf.append("',");
    		strbuf.append(String.valueOf(i).toString());
    		strbuf.append(",");
    		i++;
    	}
    	strbuf.append(String.valueOf(i).toString());
    	//Logger.debug.println("[StringUtil:icaoDecode] strbuf : "+strbuf.toString());
    	
    	return strbuf.toString();
    }

   /**
     * Է String DB Format ٲپ 
     * Ex) RKNN,NZAA WSSS -> 'RKNN','NZAA','WSSS'
     * @param str String ڿ
     * @author Copyright (c) 2005 HIST 
     */      
	public static String strDBformat(String str){
		StringBuffer strbuf = new StringBuffer();
    	if (str == null || str.length() == 0) return "";
    	
    	strbuf.append("'");
    	for (int i=0; i<str.length(); i++) {
    		if (str.charAt(i) == ',') {
				strbuf.append("','");
    		} else if (str.charAt(i) == ' ') {
				strbuf.append("','");
			} else {
				strbuf.append(str.charAt(i));
			}
    	}
    	strbuf.append("'");
    	//Logger.debug.println("[StringUtil:strDBformat] strbuf : "+strbuf.toString());

		return strbuf.toString();
	}    
	
   /**
     * Է String HTML Format ٲپ 
     * Ex) RKNN,NZAA,WSSS -> RKNN&nbsp;&nbsp;&nbsp;NZAA&nbsp;&nbsp;&nbsp;WSSS
     * @param str String ڿ
     * @author Copyright (c) 2005 HIST 
     */      
	public static String strHTMLformat(String str){
		StringBuffer strbuf = new StringBuffer();
    	if (str == null || str.length() == 0) return "";
    	
    	for (int i=0; i<str.length(); i++) {
    		String tmp = str.substring(i,i+1);
    		if (tmp.equals(","))
    			strbuf.append("&nbsp;&nbsp;&nbsp;");
    		else if (tmp.equals("'")) 
    			strbuf.append("");
    		else 
    			strbuf.append(str.charAt(i));
    	}
    	//Logger.debug.println("[StringUtil:strHTMLformat] strbuf : "+strbuf.toString());

		return strbuf.toString();
	}	
	
	/**
	  * Է String , &nbsp;&nbsp;+ĭ  .
	  * Ex) RKNN,NZAA,WSSS -> RKNN&nbsp; NZAA&nbsp; WSSS
	  * @param str String ڿ
	  * @author Copyright (c) 2007 
	  */      
	 public static String strHTMLformat2(String str){
		 StringBuffer strbuf = new StringBuffer();
		 if (str == null || str.length() == 0) return "";
    	
		 for (int i=0; i<str.length(); i++) {
			 String tmp = str.substring(i,i+1);
			 if (tmp.equals(","))
				 strbuf.append("&nbsp;&nbsp; ");
			 else if (tmp.equals("'")) 
				 strbuf.append("");
			 else 
				 strbuf.append(str.charAt(i));
		 }
		 //Logger.debug.println("[StringUtil:strHTMLformat2] strbuf : "+strbuf.toString());

		 return strbuf.toString();
	 }	
	
   /**
     * Էµ ڿ[ICAO or IATA] ĸ ̽  ĸ ٿ .
     * ,,̽ ĸ  ڰ Է½ 
     * Ex) RKNN,SKTT ICN = RKNN,SKTT,ICN
     * @param stnInp String Է¹ڿ
     * @return  String ռڿ
     * @author Copyright (c) 2005 HIST 
     */      
    public static String allStationChk(String stnInp) throws BusinessException {
    	StringBuffer strbuf = new StringBuffer();
    	if (stnInp == null || stnInp.length() == 0) return "";
    	
    	try {
	    	for (int i=0; i<stnInp.length(); i++) {
	    		char tmp = stnInp.charAt(i);
	    		//tmp //̽/ĸ ƴϸ 
	    		if (tmp < 'A' || tmp > 'Z') {
	    			if (tmp < 'a' || tmp > 'z') {
	    				if (tmp < '0' || tmp > '9') {
	    					if (tmp != ' ' && tmp != ',' && tmp != '/') {
	    						strbuf = new StringBuffer();
	    						//return strbuf.append(tmp).toString();
	    						//throw new BusinessException(strbuf.append(tmp).toString()+" is Invalid Character!! \n Only used Number,Alphabet ,Space,Comma");
	    						throw new BusinessException("Invalid Character!! Only use \n Number,Alphabet ,Space,Comma");
	    					}
	    				}
	    			}
	    		}
	    		
	    		if (stnInp.charAt(i) == ' ') {
	    			strbuf.append(',');
	    		} else {
	    			strbuf.append(stnInp.charAt(i));
	    		}
	    	}

    		return strbuf.toString();
    	} catch (BusinessException be) {
    		throw new BusinessException(((BusinessException)be).getMessage());
    	}
    }	
	
    /**
     * ڿ Ե Character   ã´
     * @param chr char ã ĳ
     * @param str String ڿ
     * @return  cnt ĳ  
     * @author Copyright (c) 2005 HIST 
     */
    public static int cntChar(String str,char chr) {
    	int cnt = 0;

		if (str == null || str.length() == 0) return 0;
			
    	for(int i=0; i < str.length(); i++) {
    		if(str.charAt(i) == chr) cnt++;
    	}

    	return cnt;
    }	
    
    
    /**
     *  ڵ幮ڿ Editing TRAF,PURP,SCOP
     * @param mode String 'T' : TRAF , 'P' : PURP , 'S' : SCOP
     * @param str String ڿ
     * @return  boolean 
     * @author Copyright (c) 2005 HIST 
     */    
    public static boolean notamCdChk(String mode, String str) {
    	
    	boolean flag = true;
    	
    	if (str == null || str.length() == 0) return false;
    	
    	//ڿ ߶ Vector ִ´
    	Vector vtCode = new Vector();
    	for (int i=0; i<str.length(); i++) {
    		vtCode.add(str.substring(i,i+1));
    	}
    	
    	//Vector    ߺ üũ
    	int pos = 0;
    	String strTraf = "I,V";
    	String strPurp = "N,B,O,M";
    	String strScop = "A,E,W";
    	for (int j=0; j<vtCode.size(); j++) {
    		String tmp = (String)vtCode.get(j);
    		int cnt = 0;
    		for (int k=0; k<vtCode.size(); k++) {
    			//Logger.debug.println("[StringUtil:notamCdChk] tmp : "+tmp+", (String)vtCode.get("+k+")) : "+(String)vtCode.get(k));
    			if (tmp.equals((String)vtCode.get(k))) cnt++;
    		}
    		if (cnt > 1) return false;
    		
    		if (mode.equals("T")) {
    			int iTraf =strTraf.indexOf(tmp);
    			if (iTraf == -1) pos++;
    		} else if (mode.equals("P")) {
    			int iPurp =strPurp.indexOf(tmp);
    			if (iPurp == -1) pos++;
    		} else if (mode.equals("S")) {
    			int iScop =strScop.indexOf(tmp);
    			if (iScop == -1) pos++;
    		}
    		
    		//Logger.debug.println("[StringUtil:notamCdChk] mode : "+mode+", pos : "+pos);
    	}
    	
    	if (pos != 0) flag = false;
    	return flag;
    }
    
   /**
     * Էµ Weather ڵ忡  ش Weather ̹  ̸ 
     * Ex) ICON1 & X1 => w_icon_X1.gif
     * @param iconCode String ICON ڵ  : ICON1, ICON2......
     * @param wxCode String Weather ڵ  : X1, X2...
     * @author Copyright (c) 2005 HIST 
     */      
    public static String wxImageConv(String iconCode,String wxCode) throws BusinessException {
    	String wxImage = "";
    	if (wxCode == null || wxCode.length() == 0) return "";

		if (iconCode.equals("ICON1")) {
			wxImage = "w_icon_X1.gif";
		} else if (iconCode.equals("ICON2")) {
			if (wxCode.equals("X2")) wxImage = "w_icon_X2.gif";
			else wxImage = "w_icon_X5.gif";
		} else if (iconCode.equals("ICON3")) {
			wxImage = "w_icon_X3.gif";
		} else if (iconCode.equals("ICON4")) {
			wxImage = "w_icon_X4.gif";
		} else if (iconCode.equals("ICON5")) {
			wxImage = "w_icon_FC_PO_SS_DS.gif";
		} else if (iconCode.equals("ICON6")) {
			wxImage = "w_icon_TT_SQ.gif";
		} else if (iconCode.equals("ICON7")) {
			wxImage = "w_icon_FG.gif";
		} else if (iconCode.equals("ICON8")) {
			wxImage = "w_icon_BR_FU.gif";
		} else if (iconCode.equals("ICON9")) {
			wxImage = "w_icon_HZ.gif";
		} else if (iconCode.equals("ICON10")) {
			wxImage = "w_icon_SN_SG.gif";
		} else if (iconCode.equals("ICON11")) {
			wxImage = "w_icon_RA_DZ.gif";
		} else if (iconCode.equals("ICON12")) {
			wxImage = "w_icon_IC_FZ.gif";
		} else if (iconCode.equals("ICON13")) {
			wxImage = "w_icon_SA_DU.gif";
		} else if (iconCode.equals("ICON14")) {
			wxImage = "w_icon_VA.gif";
		} else wxImage = "";

		return wxImage;
    }    
    
    public static String fileDispatcher(String fileName) {
    	String fileTyp = "";
    	if (fileName == null || fileName.length() == 0) return "";
    	
    	int iTyp = fileName.indexOf(".");
    	String sTyp = (fileName.substring(iTyp+1)).toUpperCase();
    	
    	if (sTyp.equals("DOC")) fileTyp = "docu";
    	else if (sTyp.equals("PPT")) fileTyp = "ppt";
   		else if (sTyp.equals("HWP")) fileTyp = "hwp";
   		else if (sTyp.equals("XLS")) fileTyp = "excel";
   		else if (sTyp.equals("TXT")) fileTyp = "text";
    	else fileTyp = "img";
    	
    	return fileTyp;
    }
    
    public static Vector stringCutter(String str,int cnt) {
    	Vector vtStr = new Vector();
    	if (str == null || str.length() == 0) {
    		vtStr.add("");
    		return vtStr;
    	} else if (str.length() < cnt) {
    		vtStr.add(str);
    		return vtStr;
    	}
    	
    	String tmp = "";
    	for (int i=0; i<str.length(); i++) {
    		if (tmp.length() == cnt) {
    			vtStr.add(tmp);
    			tmp = str.substring(i,i+1);
    		} else {
    			tmp += str.substring(i,i+1);
    		}
    	}
    	
    	if (!tmp.equals("")) vtStr.add(tmp);
    	
    	return vtStr;
    }    
    
    /**
     * ʸ ::ʷ ٲ۴.
     * @param int i 
     * @author Copyright (c) 2006.01.12 HIST 
     */
    public static String secTohms(int i) {
    	if (i == 0) return "00:00:00";
    	
    	String str = null;
		int j = 0;
		int k = 0;
		int m = 0;
		int n = 0;						
		String jj = null;
		String mm = null;
		String nn = null;
		
		j = i / 3600;
		
		if (j < 10) {
		 	jj = "0" + j;
		}
		else {
			jj = "" + j;		
		}
		
		k = i % 3600;
		if (k >= 60) {
			m = k / 60;
			n = k % 60;
		}
		else {
			m = 0;
			n = k;
		}		
		
		if (m < 10) {
		 	mm = "0" + m;
		}
		else {
			mm = "" + m;
		}
		
		if (n < 10) {
			nn = "0" + n;
		}
		else {
			nn = "" + n;
		}						
		
		str = jj + ":" + mm + ":" + nn;
		return str;
   }
   
   /**
     *  :(00:00) ٲ۴.
     * @param int i 
     * @author Copyright (c) 2007.02.13 
     */
    public static String minTohm(int min) {
    	String str = "";
    	if (min < 10) {
    		str = "00:0" + min;
    	} else if (min >= 10 && min < 60) {
    		str = "00:" + min;
    	} else {
    		if ((min/60) < 10) {
    			if ((min%60) < 10) {
    				str = "0" + (min/60) + ":0" + (min%60);
    			} else { 
    				str = "0" + (min/60) + ":" + (min%60);
    			}
    		} else {
    			if ((min%60) < 10) {
    				str = (min/60) + ":0" + (min%60);
    			} else {
    				str = (min/60) + ":" + (min%60);
    			}
    		}
   		}
    	return str;
   }
   
	/**
	 * Oracle Clob String ȯѴ.
	 * @param Clob sClob
	 * @return String
	 * @exception Exception
	 * @author Copyright (c) 2007/07/03 
	 */
	public static String convertClobToString(Clob sClob) {
		String cStr = "";
		
		if (sClob != null) {
			try {
				Reader reader = sClob.getCharacterStream();
				StringBuffer clobData = new StringBuffer();
				char[] buffer = new char[1024];
                int byteRead = 0;
                
                while ((byteRead = reader.read(buffer, 0, 1024)) != -1) {
                	clobData.append(buffer, 0, byteRead);
                }
                
                cStr = clobData.toString();
                
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return cStr;
	}
	
	/*
	Database Clob data update  , 
	String tempNote = exnewsvo.getNote();
	Reader sqlcontent = new StringReader(tempNote);
	pstmt.setCharacterStream(7, sqlcontent, tempNote.length());
	PreparedStatement setCharacterStream() Method ̿Ͽ, 
	String Stream ٲ Reader ̿Ͽ UpdateѴ.????
	*/
   
	/**
	 * " " &nbsp; ȯѴ.
	 * @param String str
	 * @return String strTemp
	 * @author Copyright (c) 2007/11/23 
	 */
	public static String blankToNbsp(String str){
		
		if (str == null || str.length() == 0) return "";
		
		StringBuffer strTemp = new StringBuffer();
		
		for (int i=0; i<str.length(); i++) {
			if (str.charAt(i) == ' ') {
				strTemp.append("&nbsp;");
			} else if (str.charAt(i) == '\n') {
				strTemp.append("\r");
			} else {
				strTemp.append(str.charAt(i));
			}
		}
		
		return strTemp.toString();
	}
	
	/**
	 * " "  , ȯѴ.
	 * @param String str
	 * @return String strTemp
	 * @author Copyright (c) 2009/07/15 
	 */
	public static String blankToComma(String str){
		
		if (str == null || str.length() == 0) return "";
		
		StringBuffer strTemp = new StringBuffer();
		
		for (int i=0; i<str.length(); i++) {
			if (str.charAt(i) == ' ') {
				strTemp.append(",");
			} else {
				strTemp.append(str.charAt(i));
			}
		}
		
		return strTemp.toString();
	}
	
	/**
	 * A-Z ڰ ִ  Ǻ
	 * @param String str
	 * @return boolean flag
	 * @author Copyright (c) 2009/07/15 
	 */
    public static boolean isAlphabet(String str) {
    	
    	boolean flag = false;
    	
    	for (int i=0; i<str.length(); i++) {
    		char tmp = str.charAt(i);
    		if (tmp >= 'A' && tmp <= 'Z') flag = true; //A-Z  ڰ  true ȯ
    	} 
    	
    	return flag;
    }
    
	/**
	 * MM -> MON · ٲش. (NOTAM Request  )
	 * @param String mm
	 * @return String mon
	 * @author Copyright (c) 2009/11/06 
	 */
    public static String mmToMon(String mm) {
    	
    	String mon = "";
    	
    	if (mm.equals("1") || mm.equals("01")) {
    		mon = "JAN";
    	} else if (mm.equals("2") || mm.equals("02")) {
    		mon = "FEB";
    	} else if (mm.equals("3") || mm.equals("03")) {
    		mon = "MAR";
    	} else if (mm.equals("4") || mm.equals("04")) {
    		mon = "APR";
    	} else if (mm.equals("5") || mm.equals("05")) {
    		mon = "MAY";
    	} else if (mm.equals("6") || mm.equals("06")) {
    		mon = "JUN";
    	} else if (mm.equals("7") || mm.equals("07")) {
    		mon = "JUL";
    	} else if (mm.equals("8") || mm.equals("08")) {
    		mon = "AUG";
    	} else if (mm.equals("9") || mm.equals("09")) {
    		mon = "SEP";
    	} else if (mm.equals("10")) {
    		mon = "OCT";
    	} else if (mm.equals("11")) {
    		mon = "NOV";
    	} else if (mm.equals("12")) {
    		mon = "DEC";
    	} else {
    		mon = "";
    	} 
    	
    	return mon;
    }
    
    /** 
     *  Ҽ ڴ .
     *  2010.11.04
     */ 
	public static String formatNumber(String str) {    
		String rslt = "";
		int cnt = -1;
		
		for (int a=0; a<str.length(); a++) {
			if ((str.substring(a,a+1)).equals(".")) {
				cnt = a;
			} 
		}
		if (cnt >= 0) {
			rslt = str.substring(0,cnt);
		} else {
			rslt = str;
		}
		
		return rslt;
	}
	/*-------------------------------------------------------------------	
	xssPattern, xssEncode,	xssDecode
	@2013-06-31	add
	----------------------------------------------------------------------	*/
	private final static  String[][]	xssPattern	=	new String[][]{
		{"\\%","#37"}
	,	{"\\+","#43"}
	,	{"\\<","lt"}			,	{"\\>","gt"}
	,	{"\\(","#40"}		,	{"\\)","#41"}
	,	{"\\\"","quot"}	,	{"\\'","apos"}	
	,	{"\\\\","#92"}
	,	{"\\&","amp"}
	};
	public static String xssEncode(String originString){
		String	result				=	originString==null?"":originString.trim();
		try{		
			String	andExcept	=	"";
			String	fromString	=	null;
			String toString		=	null;
			for(int i=0; i<xssPattern.length; i++){
				fromString	=	xssPattern[i][0];
				toString		=	xssPattern[i][1];
				if(fromString.indexOf("&")<0){
					if(0<andExcept.length()){
						andExcept	+="|";
					}
					andExcept	+="("+toString+";)";
					result	=	result.replaceAll(fromString,"&"+toString+";");
				}
			}
			result	=	result.replaceAll("([&](?!("+andExcept+")))","&amp;");
		}catch(Exception e){
			result				=	originString==null?"":originString.trim();
		}
		return result;
	} 
	public static String xssDecode(String originString){
		String	result				=	originString==null?"":originString;
		try{						
			String	fromString	=	null;
			String toString		=	null;
			for(int i=0; i<xssPattern.length; i++){
				fromString	=	xssPattern[i][1];
				toString		=	xssPattern[i][0];
				result	=	result.replaceAll("&"+fromString+";",toString);
			}
		}catch(Exception e){
			result				=	originString==null?"":originString.trim();
		}
		return result;
	} 
    
}//end class
