package kal.base.ffs.query;

import java.util.HashMap;//@2014-05-12 ~ 2014-05-30



//import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;
//import kal.base.com.query.*;
//import kal.base.com.util.*;
import kal.base.jdf.com.Logger;

 /**
  * Flight Following Chart - Released SQL 
  * @author Copyright (c) 2007/01/09  
  */   
public class FfsQ020Query {
	private static FfsQ020Query instance = new FfsQ020Query();
	
	public static FfsQ020Query getInstance() {
		return instance;
	}

	private void printSQL(StringBuffer sqlSB){//@2017-09-13
		String sql	=	sqlSB==null?null:sqlSB.toString();
		if(sql!=null && sql.length()!=0){
			StackTraceElement	stack	=	Thread.currentThread().getStackTrace()[3];
			StringBuffer sb	=	new StringBuffer();
			sb.append("=========================	BASE printSQL : "+stack.getClassName()+"."+stack.getMethodName()+"[line "+stack.getLineNumber()+"]");
			sb.append("\n"+sql.replaceAll("\n"," ").replace("\\t+"," ").replace("^\\s+",""));	
			sb.append("\n;");
			System.out.println(sb.toString());
			//Logger.debug.println(sb.toString());
		}
	}
	private void printSQL(String sql){//@2017-09-13
		if(sql!=null && sql.length()!=0){
			StackTraceElement	stack	=	Thread.currentThread().getStackTrace()[3];
			StringBuffer sb	=	new StringBuffer();
			sb.append("=========================	BASE printSQL : "+stack.getClassName()+"."+stack.getMethodName()+"[line "+stack.getLineNumber()+"]");
			sb.append("\n"+sql.replaceAll("\n"," ").replace("\\t+"," ").replace("^\\s+",""));
			sb.append("\n;");
			System.out.println(sb.toString());
			//Logger.debug.println(sb.toString());
		}
	}
	
	/** 
	  * Flight Following Chart - Released ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/01/09  
	  */
	public String selReleased() {
		StringBuffer sql = new StringBuffer();
		
		//2013-04-24 
		sql.append(" SELECT ");
		sql.append(" 	B.LCF_RATIO, "); // 2007.04.04 ߰
		sql.append("	NVL(R.EXTR_FUEL, 0) REGNO_EXTR_FUEL, R.EXTR_RSN, "); //2009.10.19 ߰ : UKFOS EXTRA FUEL
		//sql.append(" 	C.REGION_CD, A.FLT_NUM, B.REGNO, B.ACTYP SACTYP, A.STNFR, A.STNTO, ");//@2013-11-07
		sql.append(" 	A.FLT_NUM, B.REGNO, B.ACTYP SACTYP, A.STNFR, A.STNTO, ");
		sql.append(" 	   DECODE(DECODE(SUBSTR(A.FLT_NUM, 1, 1),'4','JNA','KAL'),'JNA','JNA',C.REGION_CD) REGION_CD, ");//@2013-11-07
		sql.append(" 	  DECODE(SUBSTR(A.FLT_NUM, 1, 1),'4','JNA','KAL') GBN,  ");//@2013-11-07
		sql.append(" 	     (A.SCH_ARV_DT - A.EST_ARV_DT)*24*60 STA_ETA, ");
		//sql.append(" 	'   ' ETA_MSG, ");
		sql.append(" 	CASE    WHEN ((A.SCH_ARV_DT - A.EST_ARV_DT)*24*60) > -10 AND ((A.SCH_ARV_DT - A.EST_ARV_DT)*24*60) <= -5 AND ((A.SCH_ARV_DT - A.SCH_DEP_DT)*24*60 > 180) AND A.KACTYP NOT IN ('ABH','74F', '7FQ', '7FR', '74Y', '7FG', '79S','7GG') THEN '   '   "); //20130424 KIM_HYOJ   ߰
		sql.append("            ELSE NULL   "); //20130424 KIM_HYOJ   ߰
		sql.append("    END AS ETA_MSG,   "); //20130424 KIM_HYOJ   ߰ 2013-04-29 not in ߰
		sql.append(" 	TO_CHAR(A.EST_DEP_DT,'YYMMDDHH24MI') EST_DEP_DT, ");
		sql.append(" 	TO_CHAR(B.RAMPOUT_TMPST,'YYMMDDHH24MI') ACT_DEP_DT, ");
		sql.append(" 	TO_CHAR(A.EST_ARV_DT,'YYMMDDHH24MI') EST_ARV_DT, ");
		sql.append(" 	TRIM(TO_CHAR(TRUNC(B.ABHR/60),'00'))||TRIM(TO_CHAR(MOD(B.ABHR,60),'00')) ABHR, ");
		sql.append(" 	TRIM(B.ALT_PORT) ALT_PORT, B.EXTR_FUEL+B.PAD_FUEL EXTR_PAD, NVL(B.EXTR_FUEL, 0) EXTR_FUEL, B.SPEED, "); // 2007.03.02  : Co-RSV  EXTR_FUEL -> B.EXTR_FUEL+B.PAD_FUEL
		sql.append(" 	NVL(B.PAD_FUEL, 0) PAD_FUEL, NVL(B.EXTR_FUEL+B.TANK_FUEL, 0) EXTR_TANK, "); //2010.03.29 ߰ : Co-RSV -> CCF(PAD) / Extra(EXTR+TANK)  и.
		sql.append(" 	B.ETOPS_PORTS, B.REFILE_POINT, B.REFILE_PORT, B.REFILE_ALT_PORTS, ");
		sql.append(" 	B.PLN_PAYLOAD, P.STATUS_X, "); //2008.08.19 ߰
		sql.append(" 	P.REQ_PAX_PLD_WT, P.REQ_CGO_PLD_WT, P.REQ_OTH_PLD_WT, "); //2008.08.19 ߰
		sql.append(" 	TO_CHAR(P.REQ_PAX_DTG - 9/24,'DD/HH24MI') REQ_PAX_DTG, TO_CHAR(P.REQ_CGO_DTG - 9/24,'DD/HH24MI') REQ_CGO_DTG, "); //2008.12.17 ߰ : PAX/CGO ð ǥ
		sql.append(" 	P.ACC_PAX_PLD_WT, P.ACC_CGO_PLD_WT, P.ACC_OTH_PLD_WT, "); //2008.08.19 ߰
		sql.append(" 	TO_CHAR(A.EST_DEP_DT_LOC,'DDMON') DDMON, P.INPUT_TYP, P.TELEX_ADDR, "); //2008.08.20 ߰
		sql.append(" 	C.NAI_Y, "); //2008.10.28 ߰ : N
		sql.append("	ROUND(TO_NUMBER((A.SCH_ARV_DT - A.SCH_DEP_DT) * 24 * 60), 0) DIFF_MIN, "); //2008.12.01 ߰ : N  ߰
		//sql.append("	TO_NUMBER((A.SCH_ARV_DT - A.SCH_DEP_DT) * 24 * 60) DIFF_MIN, ");
		//sql.append(" 	   P.ACC_PACK1, P.ACC_PACK2, P.ACC_PACK3, P.REQ_PACK1, P.REQ_PACK2, P.REQ_PACK3, "); //2009.10.21 ߰ : PLD PACK  ߰ => 2012.05.09 ߰  ּ
		sql.append(" 	   P.MD_AC_CONFIG, P.LD_AC_CONFIG_FWD, P.LD_AC_CONFIG_AFT, P.MD_LD_RECIR_FAN, P.ANI_PERI_FUEL_ADD, "); //2012.05.09 ߰ : FODIS Payload(PLD)   µ ȭ ž  Է¹ 濡  ʵ ߰ ǥ  
		
		//------------> ʹ  
		sql.append(" 	F.FLT_NUM_COLOR, F.REGNO REGNO_COLOR, F.WX_STNFR, F.WX_STNTO, F.ETD, F.ATD, F.ETA, ");
		sql.append(" 	F.FLYING_TIME, F.WX_ALT_PORT, F.EXTRA_FUEL, F.CRZ_MODE, F.WX_ETOP_PORT, ");
		sql.append(" 	F.WX_REFILE_PORT, F.WX_REFILE_ALT_PORT, "); // 2007.01.26 ߰ : WX_REFILE_ALT_PORT
		//sql.append(" 	F.NOTAM_STNFR, F.NOTAM_STNTO, F.NOTAM_ALT_PORT, F.NOTAM_ETOP_PORT, ");
		//sql.append(" 	F.NOTAM_REFILE_PORT, F.NOTAM_REFILE_ALT_PORT, ");
		sql.append(" 	F.NOTAM, "); //2007.06.25 : NOTAM  ʵ ߰
		sql.append(" 	F.MEL, "); //2007.06.27 ߰ : M
		sql.append("    F.MAN_WX_STNFR, F.MAN_WX_STNTO, F.MAN_WX_ALT_PORT, ");//2011.12.06 ߰
		sql.append("   F.ALT_HIGHTIME, ");//@2014-02-21
		sql.append(" 	C.TANKERING_Y, "); //2007.06.27 ߰ : T
		sql.append(" 	B.ROUTE, "); //2007.06.27 ߰ : Route
		sql.append(" 	C.ROUTE_NO, "); //2007.06.27 ߰ : Route
		sql.append(" 	A.SACTYP DAILY_SACTYP, "); //2007.06.27 ߰ : 5
		sql.append(" 	T.MEL ACTYP_MEL, "); //2007.06.27 ߰ : 5
		sql.append(" 	AC.RESTRICT_E, "); //2007.06.28 ߰ : R
		sql.append(" 	F.PMSN, TO_CHAR(A.FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, TO_CHAR(A.SCH_DEP_DT, 'DDMON') SCH_DEP_DT, "); //2007.06.28 ߰ : P
		sql.append(" 	PE.OUT_FOB AS AC_OUTFOB, B.PLN_RAMP_FUEL*100 AS FP_PRFUEL, (PE.OUT_FOB - B.PLN_RAMP_FUEL*100) DIFF, "); //2007.11.27 ߰ : F,  
		sql.append(" 	NVL(AC.CC_FUEL_50, 0) CC_FUEL_50, NVL(AC.CC_FUEL_75, 0) CC_FUEL_75, NVL(AC.CC_FUEL_95, 0) CC_FUEL_95, "); //2007.11.27 ߰ : Extra  
		sql.append(" 	AC.CCF_CALC_Y, TO_CHAR(AC.TIMESTAMP, 'YYYYMMDD') TIMESTAMP, "); //2008.10.15 ߰ : AC.CCF_CALC_Y, AC.TIMESTAMP
		//sql.append(" 	TO_CHAR(NVL(B.RAMPOUT_TMPST, '20000101'), 'YYYYMMDD') CHECK_RAMPOUT, "); //2008.09.23 ߰ : UPDATE  ȸؼ ó.
		//sql.append(" 	TRUNC(((SYSDATE - 9/24) - NVL(RAMPOUT_TMPST, SYSDATE)) * 1440, 0) DATA_RAMPOUT, "); //2008.09.23 ߰ : UPDATE  ȸؼ ó.
		//sql.append(" 	TRUNC(((SYSDATE - 9/24) - A.EST_DEP_DT) * 1440, 0) DATA_ETD, "); //2008.09.23 ߰ : UPDATE  ȸؼ ó.
		sql.append(" 	F.ALL_COLUMNS, ");
		sql.append(" 	NVL(FU.PLN_EXTR_FUEL1,0) PLN_EXTR_FUEL1, FU.PLN_EXTR_RSN1, NVL(FU.PLN_EXTR_FUEL2,0) PLN_EXTR_FUEL2, FU.PLN_EXTR_RSN2, NVL(FU.PLN_TANK_FUEL,0) PLN_TANK_FUEL, ");//2011.09.29 ߰ : Extra Fuel Reason Code  ȭ ء, 2011.10.13  ߰ : NVL(FU.PLN_TANK_FUEL,0)
		sql.append(" 	TO_CHAR(A.SCH_DEP_DT,'YYMMDD') SCHDEPDT, ");//2011.09.29 ߰ : Fuel And Weight ˾â  Ÿ
		sql.append(" 	NVL(F.ALT_MTOW, 0) ALT_MTOW, NVL(B.MTOW, 0) PLAN_MTOW ");//2011.12.26 ߰ 
		//2007.06.27 ߰ : CM_ACTYP_T, CM_CITYPAIR_AC_T, 2007.11.27 ߰ : PE_ACARS_SKD_T PE, 2008.08.18 ߰ : PDP_FLT_PAYLOAD_T, 2009.10.19 ߰ : CM_REGNO_T
		//-----------------@2013-02-01 ߰
		sql.append(" 	,	B.PLANID ");
		sql.append(" 	,	( ");
		sql.append(" 			SELECT ");
		sql.append(" 				BF.PLAN_NO ");
		sql.append(" 			FROM ");
		sql.append(" 				BS_FUELMSG_T	BF ");
		sql.append(" 			,	( ");
		sql.append(" 					SELECT ");				
		sql.append(" 						BF.FIRST_LEG_FLT_DT ");
		sql.append(" 					,	BF.FLT_NUM ");
		sql.append(" 					,	BF.STNFR ");
		sql.append(" 					,	BF.STNTO ");
		sql.append(" 					,	MAX(BF.TIMESTMP) TIMESTMP ");
		sql.append(" 					FROM ");
		sql.append(" 						KFOS.BS_FUELMSG_T				BF ");
		sql.append(" 					GROUP BY  ");
		sql.append(" 						BF.FIRST_LEG_FLT_DT ");
		sql.append(" 					,	BF.FLT_NUM ");
		sql.append(" 					,	BF.STNFR ");
		sql.append(" 					,	BF.STNTO ");
		sql.append(" 				) BF_MAX ");
		sql.append(" 			WHERE ");
		sql.append(" 				BF.FIRST_LEG_FLT_DT	=	BF_MAX.FIRST_LEG_FLT_DT ");
		sql.append(" 			AND	BF.FLT_NUM			=	BF_MAX.FLT_NUM ");
		sql.append(" 			AND	BF.STNFR				=	BF_MAX.STNFR ");
		sql.append(" 			AND	BF.STNTO			=	BF_MAX.STNTO ");
		sql.append(" 			AND	BF.TIMESTMP			=	BF_MAX.TIMESTMP ");
		sql.append(" 			AND	 BF.FIRST_LEG_FLT_DT			=	B.FIRST_LEG_FLT_DT ");
		sql.append(" 			AND	 BF.FLT_NUM					=	B.FLT_NUM ");
		sql.append(" 			AND	 BF.STNFR					=	B.STNFR ");
		sql.append(" 			AND	 BF.STNTO					=	B.STNTO ");
		//20160620 ߰
		sql.append(" 			AND ROWNUM = 1  ");
		
		sql.append(" 		) AS PLAN_NO  ");
		sql.append(" 	,	NVL(B.LDW,0) LDW  ");//@2014-02-06		
		//-----------------@2013-02-01 ߰
		//-----------------@2014-05-12 ߰
		sql.append(" 	,  TO_CHAR(A.SCH_ARV_DT,'YYMMDDHH24MI') SCH_ARV_DT  ");
		sql.append(" 	,CASE  ");
		sql.append(" 	    WHEN B.REFILE_Y = 'Y' THEN  'R:' || B.REFILE_POINT || '/' || B.REFILE_PORT || '/' || B.REFILE_ALT_PORTS  "); 
		sql.append(" 	    WHEN B.ERA_Y = 'Y' THEN  '3:' || B.ERA_POINT_LAT || B.ERA_POINT_LONG || '/' || B.ERA_PORT  ");
		sql.append(" 	    ELSE ''  ");                                                                   
		sql.append(" 	END AS REFILE_ERA  ");
		sql.append(" 	,  B.PLAN_CONFIRM  ");
		sql.append("	,  B.IS_COMMENTED  ");
		sql.append("	,  B.SYSKEY  ");
		//20140903 flight document  ߰ : doc_no, prv_doc_no߰
		sql.append("	,  F.DOC_NO  ");
		sql.append("	,  F.PRV_DOC_NO  ");
		//20150703 ߰
		sql.append("	,  A.ACVER  ");
		//-----------------@2014-05-30 ߰
		sql.append(" FROM ");
		sql.append(" 	DAILY_SCH_T A, FLIGHT_PLAN_T B, CM_CITYPAIR_DEF_T C, FLIGHT_ALERT_T F, CM_ACTYP_T T, CM_CITYPAIR_AC_T AC, PE_ACARS_SKD_T PE, PDP_FLT_PAYLOAD_T P, CM_REGNO_T R, FLT_FUEL_WT_T FU "); //2011.09.29 : FLT_FUEL_WT_T FU߰
		sql.append(" WHERE B.ACTIVE = 'Y' ");
		sql.append(" 	AND B.STATUS = 'SCH' "); //sql.append(" 	AND (LENGTH(A.TKOF_T) <> 4 OR A.TKOF_T IS NULL) "); //2010.03.26 ->
		sql.append(" 	AND A.EST_DEP_DT >= SYSDATE - 12/24 ");
		sql.append(" 	AND A.EST_DEP_DT <= SYSDATE ");
		//sql.append(" 	AND A.DEP_STS = 'SCH' "); // 2007.01.15 ߰ 
		//sql.append(" 	AND A.DEP_STS IN ('SCH','EST') "); //2010.04.28 
		sql.append(" 	AND LENGTH(NVL(A.TKOF_T,'1')) <= 3 ");
		sql.append(" 	AND A.ACTNID <> 'CNL' "); // 2007.01.15 ߰
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" 	AND A.STNFR = B.STNFR ");
		sql.append(" 	AND A.STNTO = B.STNTO ");
		sql.append(" 	AND A.STNFR = C.DEP_PORT ");
		sql.append(" 	AND A.STNTO = C.ARV_PORT ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = F.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND A.FLT_NUM = F.FLT_NUM ");
		sql.append(" 	AND A.STNFR = F.STNFR ");
		sql.append(" 	AND A.STNTO = F.STNTO ");
		//20140903 PRV_DOC_NO  ߰
		sql.append("  	AND F.PRV_DOC_NO IS NOT NULL ");
		
		sql.append(" 	AND A.KACTYP = T.KACTYP "); //2007.06.27 ߰
		sql.append(" 	AND A.STNFR = AC.DEP_PORT "); //2007.06.27 ߰
		sql.append(" 	AND A.STNTO = AC.ARV_PORT "); //2007.06.27 ߰
		sql.append(" 	AND B.ACTYP = AC.SACTYP "); //2007.06.27 ߰
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = PE.FIRST_LEG_FLT_DT(+) "); //2007.11.27 ߰ -> 2008.09.05 ߰ : (+)
		sql.append(" 	AND A.FLT_NUM = PE.FLT_NUM(+) "); //2007.11.27 ߰ -> 2008.09.05 ߰ : (+)
		sql.append(" 	AND A.STNFR = PE.STNFR(+) "); //2007.11.27 ߰ -> 2008.09.05 ߰ : (+)
		sql.append(" 	AND A.STNTO = PE.STNTO(+) "); //2007.11.27 ߰ -> 2008.09.05 ߰ : (+)
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = P.FIRST_LEG_FLT_DT(+) "); //2008.08.19 ߰
		sql.append(" 	AND A.FLT_NUM = P.FLT_NUM(+) "); //2008.08.19 ߰
		sql.append(" 	AND A.STNFR = P.STNFR(+) "); //2008.08.19 ߰
		sql.append(" 	AND A.STNTO = P.STNTO(+) "); //2008.08.19 ߰
		sql.append(" 	AND A.FLT_NUM NOT LIKE '1%' "); //2009.04.24 ߰ :  ׽Ʈ  
		//sql.append("  AND SUBSTR(A.FLT_NUM, 1, 1) <> '4' "); //2009.08.13 ߰ :  FLT @2013-11-07
		sql.append("  AND A.REGNO = R.REGNO(+) "); //2009.10.19 ߰ : CM_REGNO_T
		sql.append("  AND PE.act_off_dt is null ");//2011.06.01 ߰
		//2011.09.29 ߰
		sql.append("  AND A.FIRST_LEG_FLT_DT=FU.FIRST_LEG_FLT_DT(+) ");
		sql.append("  AND A.FLT_NUM=FU.FLT_NUM(+) ");
		sql.append("  AND A.STNFR=FU.STNFR(+) ");
		sql.append("  AND A.STNTO=FU.STNTO(+) ");
		sql.append("    AND C.REGION_CD !='DOM' ");//@2013-11-07
		
		//sql.append(" ORDER BY A.EST_DEP_DT DESC ");
		sql.append(" ORDER BY GBN ASC, A.EST_DEP_DT DESC "); //@2013-11-07		
		
		printSQL(sql);
		return sql.toString();
	}
	public String selFrightPlanCheckLogT(String syskey) {//@2014-05-12 ~ @2014-05-30
		StringBuffer sql = new StringBuffer();
		
		sql.append(" 	SELECT ");
		sql.append(" 		TO_CHAR(TIME_STAMP,'YYYY-MM-DD HH24:MI') TIME_STAMP");
		sql.append(" 	,	STAFF_NUM");
		sql.append(" 	,	REMARKS");
		sql.append(" 	FROM");
		sql.append(" 		KFOS.FLIGHT_PLAN_CHECK_LOG_T");
		sql.append(" 	WHERE ");
		sql.append(" 		SYSKEY = '"+syskey+"'");

		printSQL(sql);
		return sql.toString();
	}
	public String insFrightPlanCheckLogT(HashMap<String,String> params) {//@2014-05-12 ~ @2014-05-30
		StringBuffer sql = new StringBuffer();
		if(params!=null){
			sql.append(" INSERT INTO KFOS.FLIGHT_PLAN_CHECK_LOG_T (SYSKEY, TIME_STAMP, STAFF_NUM,    REMARKS) ");
			sql.append(" VALUES ( '"+(String)params.get("SYSKEY")+"',sysdate,'"+(String)params.get("STAFF_NUM")+"','"+(String)params.get("REMARKS")+"' )");
		}
		
		printSQL(sql);
		return sql.toString();
	}
	public String updIsCommented(HashMap<String,String> params) {//@2014-05-12 ~ @2014-05-30
		StringBuffer sql = new StringBuffer();
		if(params!=null){
			sql.append("	UPDATE KFOS.FLIGHT_PLAN_T");
			sql.append("	SET IS_COMMENTED     = 'Y'");
			sql.append("	WHERE");
			if(params.get("SYSKEY")!=null){
				sql.append("		SYSKEY ='"+(String)params.get("SYSKEY")+"'");
			}else{
				sql.append("		TO_CHAR(FIRST_LEG_FLT_DT,'YYYYMMDD') ='"+(String)params.get("FIRST_LEG_FLT_DT")+"'");
				sql.append("	AND	FLT_NUM ='"+(String)params.get("FLT_NUM")+"'");
				sql.append("	AND	STNFR ='"+(String)params.get("STNFR")+"'");
				sql.append("	AND	STNTO ='"+(String)params.get("STNTO")+"'");
				sql.append("	AND	REGNO ='"+(String)params.get("REGNO")+"'");
			}			
		}
		printSQL(sql);
		return sql.toString();
	}
	public String updPlanConfirm(HashMap<String,String> params) {//@2014-05-12 ~ @2014-05-30
		StringBuffer sql = new StringBuffer();
		if(params!=null){
			sql.append("	UPDATE KFOS.FLIGHT_PLAN_T");
			sql.append("	SET PLAN_CONFIRM     = '"+(String)params.get("EMP_NO")+"'||'/'||TO_CHAR(SYSDATE,'HH24:MI')");
			sql.append("	WHERE");
			sql.append("		TO_CHAR(FIRST_LEG_FLT_DT,'YYYYMMDD') ='"+(String)params.get("FIRST_LEG_FLT_DT")+"'");
			sql.append("	AND	FLT_NUM ='"+(String)params.get("FLT_NUM")+"'");
			sql.append("	AND	STNFR ='"+(String)params.get("STNFR")+"'");
			sql.append("	AND	STNTO ='"+(String)params.get("STNTO")+"'");
			sql.append("	AND	REGNO ='"+(String)params.get("REGNO")+"'");
		}
		printSQL(sql);
		return sql.toString();
	}	
	
	/** 
	  * STATUS SCH϶..(1) ATD ȵ  ETD SYSDATE-9 30̻ ̰  üũ --  : 2011.01.13
	  * @return String Query  
	  * @author Copyright (c) 2007/01/16  
	  */
	public String updReleased1() {
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE FLIGHT_ALERT_T ");
		//sql.append(" SET ATD = 'BLUE' "); 2007.01.30 
		sql.append(" SET ATD = '#81C6FE' ");
		sql.append(" WHERE (FIRST_LEG_FLT_DT, FLT_NUM, STNFR) IN ");
		sql.append(" 	(SELECT D.FIRST_LEG_FLT_DT, D.FLT_NUM, D.STNFR ");
		sql.append(" 	FROM DAILY_SCH_T D, FLIGHT_PLAN_T P ");
		sql.append(" 	WHERE D.FIRST_LEG_FLT_DT = P.FIRST_LEG_FLT_DT ");
		sql.append(" 		AND D.STNFR = P.STNFR ");
		sql.append(" 		AND D.STNTO = P.STNTO ");
		sql.append(" 		AND D.FLT_NUM = P.FLT_NUM ");
		sql.append(" 		AND D.FIRST_LEG_FLT_DT BETWEEN SYSDATE - 36/24 AND SYSDATE ");
		sql.append(" 		AND D.ARV_STS <> 'ACT' ");
		sql.append(" 		AND D.ACTNID <> 'CNL' ");
		sql.append(" 		AND P.RAMPOUT_TMPST IS NULL ");
		sql.append(" 		AND P.STATUS = 'SCH' ");
		sql.append(" 		AND P.ACTIVE = 'Y' ");
		sql.append(" 		AND ((SYSDATE - 9/24) - D.EST_DEP_DT) * 1440 > 29) ");

		printSQL(sql);
		return sql.toString();
	}
	
	/** 
	  * STATUS SCH϶..(2) TKOF ȵ  ATD SYSDATE-9 30̻ ̰  üũ --  : 2011.01.13
	  * @return String Query  
	  * @author Copyright (c) 2007/01/16  
	  */
	public String updReleased2() {
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE FLIGHT_ALERT_T ");
		//sql.append(" SET ATD = 'RED' "); 2007.01.30 
		sql.append(" SET ATD = '#FA8885' ");
		sql.append(" WHERE (FIRST_LEG_FLT_DT, FLT_NUM, STNFR) IN ");
		sql.append(" 	(SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR ");
		sql.append(" 	FROM FLIGHT_PLAN_T ");
		sql.append(" 	WHERE TAKEOFF_TMPST IS NULL ");
		sql.append(" 		AND RAMPOUT_TMPST IS NOT NULL ");
		sql.append(" 		AND STATUS = 'SCH' ");
		sql.append(" 		AND FIRST_LEG_FLT_DT BETWEEN SYSDATE - 36/24 AND SYSDATE ");
		sql.append(" 		AND ((SYSDATE - 9/24) - RAMPOUT_TMPST) * 1440 > 29) ");
		
		printSQL(sql);
		return sql.toString();
	}
	
	/** 
	  * Released  Alert Ruleȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/01/29  
	  */
	public String alertRuleRE() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	COLOR, TAG, REMARKS ");
		sql.append(" FROM ");
		sql.append(" 	ALERT_RULE_T ");
		sql.append(" WHERE ");
		sql.append(" 	PROGRESS IN ('RE','AA','BB') ");

		printSQL(sql);
		return sql.toString();
	}
	
	/** 
	  * SYSDATE ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2008/10/15  
	  */
	public String getSysdate() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SYSDATE,'YYYYMMDD') YYYYMMDD ");
		sql.append(" FROM DUAL ");

		printSQL(sql);
		return sql.toString();
	}
	
	/** 
	  * Released  ACARS SMI ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/06/04  
	  */
	public String acarsSmi(String yyyymmdd, String preSmi, String preFltNum) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	P.FLT_NUM, TO_CHAR(MAX(P.MSG_TIMESTAMP),'YYMMDDHH24MISS') MAX_TM ");
		sql.append(" FROM ");
		sql.append(" 	DAILY_SCH_T D, PE_MSG_T P ");
		sql.append(" WHERE ");
		sql.append(" 	D.FIRST_LEG_FLT_DT >= TO_DATE('"+yyyymmdd+"','YYYYMMDD') - 3 "); //2009.07.23 ߰
		sql.append(" 	AND D.FIRST_LEG_FLT_DT <= TO_DATE('"+yyyymmdd+"','YYYYMMDD') ");  //2009.07.23 ߰
		sql.append(" 	AND P.SMI IN (" + preSmi + ") ");
		sql.append(" 	AND P.FLT_NUM IN (" + preFltNum + ") ");	
		//sql.append(" 	AND D.DEP_STS = 'ACT' ");
		sql.append(" 	AND D.DEP_STS IN ('SCH','EST') ");
		//sql.append(" 	AND D.ARV_STS <> 'ACT' ");
		sql.append(" 	AND D.ACTNID <> 'CNL' ");
		sql.append(" 	AND P.GBN_X NOT IN ('U','M') ");
		//sql.append(" 	AND D.ACT_DEP_DT >= SYSDATE - 30/24 ");
		//sql.append(" 	AND D.ACT_DEP_DT <= SYSDATE - 8/24 ");
		sql.append(" 	AND D.EST_DEP_DT >= SYSDATE - 12/24 ");
		sql.append(" 	AND D.EST_DEP_DT <= SYSDATE ");
		sql.append(" 	AND D.FIRST_LEG_FLT_DT = P.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND D.FLT_NUM = P.FLT_NUM ");
		sql.append(" 	AND D.STNFR = P.STNFR ");
		sql.append(" 	AND D.STNTO = P.STNTO ");
		sql.append(" GROUP BY P.FLT_NUM ");
		sql.append(" ORDER BY P.FLT_NUM ");

		printSQL(sql);
		return sql.toString();
	}
		
	/** 
	  * Enroute  ACARS SMI RAW_MSG ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2007/06/04  
	  */
	public String acarsRawMsg(String fltNum, String smi) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	FLT_NUM, SMI, RAW_MSG ");
		sql.append(" FROM ");
		sql.append(" 	PE_MSG_T ");
		sql.append(" WHERE ");
		sql.append(" 	FLT_NUM = '" + fltNum + "' ");
		sql.append(" 	AND SMI IN (" + smi + ") ");
		sql.append(" 	AND GBN_X NOT IN ('U','M') "); //2007.05.31 ߰
		sql.append(" 	AND FIRST_LEG_FLT_DT BETWEEN SYSDATE - 57/24 AND SYSDATE ");
		sql.append(" 	AND MSG_TIMESTAMP > SYSDATE - 9/24 - 20/24 ");
		sql.append(" ORDER BY MSG_TIMESTAMP DESC ");

		printSQL(sql);
		return sql.toString();
	}
	
	/** 
	  * CM_CITYPAIR_AC_T TIMESTAMP MAX ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2008/10/15  
	  */
	public String maxTimestamp() {
		StringBuffer sql = new StringBuffer();
		
		//sql.append(" SELECT MAX(TO_CHAR(TIMESTAMP,'YYYYMMDD')) MAX_TM ");
		//sql.append(" FROM CM_CITYPAIR_AC_T ");
		//2008.10.27 
		sql.append(" SELECT TO_CHAR(SYSDATE - 15, 'YYYYMMDD') MAX_TM ");
		sql.append(" FROM DUAL ");

		printSQL(sql);
		return sql.toString();
	}

	/**
	 * 20160415 ߰
	 */
	public String selReleasedRev() {
		StringBuffer sql = new StringBuffer();

		/*
		sql.append("SELECT DECODE(DECODE(SUBSTR(ALT.FLT_NUM, 1, 1),'4','JNA','KAL'),'JNA','JNA',DEF.REGION_CD) REGION_CD, ");
		sql.append("  DECODE(SUBSTR(ALT.FLT_NUM, 1, 1),'4','JNA','KAL') GBN, ");
		sql.append("  ALT.FLT_NUM, ");
		sql.append("  ALT.ATC_ALERT, ");
		sql.append("  ALT.TANKERING_ALERT, ");
		sql.append("  ALT.RESTRICT_E, ");
		sql.append("  ALT.PMSN_ALERT, ");
		sql.append("  ALT.CALLSIGN_ALERT, ");
		sql.append("  ALT.FOB_ALERT, ");
		sql.append("  ALT.SYSKEY, ");
		sql.append("  ALT.RELEASE_SYSKEY, ");
		sql.append("  FLT.REGNO, ");
		sql.append("  ALT.MEL_ALERT, ");
		sql.append("  NVL(ALT.MULTI_MTOW, 'A0') MTOW, ");
		sql.append("  ALT.HIGHTIME_ALERT, ");
		sql.append("  ALT.REGNO_CHG_ALERT, ");
		sql.append("  ALT.LDW_ALERT, ");
		sql.append("  FLT.ACTYP, ");
		sql.append("  ALT.STNFR, ");
		sql.append("  ALT.STNTO, ");
		sql.append("  TRIM(FLT.ALT_PORT) ALT_PORT, ");
		sql.append("  TO_CHAR(SKD.SCH_DEP_DT,'YYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append("  TO_CHAR(SKD.EST_DEP_DT,'YYMMDDHH24MI') EST_DEP_DT, ");
		sql.append("  ALT.ETD_ALERT, ");
		sql.append("  TO_CHAR(FLT.RAMPOUT_TMPST,'YYMMDDHH24MI') ACT_DEP_DT, ");
		sql.append("  ALT.ATD_ALERT, ");
		sql.append("  TRIM(TO_CHAR(TRUNC(FLT.ABHR/60),'00')) ");
		sql.append("  ||TRIM(TO_CHAR(MOD(FLT.ABHR,60),'00')) ABHR, ");
		sql.append("  ALT.ABHR_ALERT, ");
		sql.append("  TO_CHAR(SKD.EST_ARV_DT,'YYMMDDHH24MI') EST_ARV_DT, ");
		sql.append("  TO_CHAR(SKD.SCH_ARV_DT,'YYMMDDHH24MI') SCH_ARV_DT, ");
		sql.append("  ALT.ETA_ALERT, ");
		sql.append("  FLT.ROUTE, ");
		sql.append("  ALT.ROUTE_ALERT, ");
		sql.append("  NVL(FLT.PAD_FUEL, 0) PAD_FUEL, ");
		sql.append("  ALT.CCF_ALERT, ");
		sql.append("  (NVL(FWT.PLN_EXTR_FUEL1, 0) + NVL(FWT.PLN_EXTR_FUEL2, 0) + NVL(FWT.PLN_TANK_FUEL, 0))/100 EXTR_FUEL, ");
		sql.append("  ALT.DISC_ALERT, ");
		sql.append("  NVL(FWT.PLN_EXTR_FUEL1,0) PLN_EXTR_FUEL1, ");
		sql.append("  FWT.PLN_EXTR_RSN1, ");
		sql.append("  NVL(FWT.PLN_EXTR_FUEL2,0) PLN_EXTR_FUEL2, ");
		sql.append("  FWT.PLN_EXTR_RSN2, ");
		sql.append("  'CI'||FLT.SPEED SPEED, ");
		sql.append("  ALT.SPD_ALERT, ");
		sql.append("  TRIM(FLT.ETOPS_PORTS||' '||FLT.ETP_PORTS) AS EDTO_ETP, ");
		sql.append("  CASE ");
		sql.append("    WHEN FLT.REFILE_Y = 'Y' ");
		sql.append("    THEN 'R:'||FLT.REFILE_POINT||'/'||FLT.REFILE_PORT||'/'||FLT.REFILE_ALT_PORTS ");
		sql.append("    WHEN FLT.ERA_Y = 'Y' ");
		//20160713 
		//sql.append("    THEN '3:'||FLT.ERA_POINT_LAT||FLT.ERA_POINT_LONG||'/'||FLT.ERA_PORT ");
		sql.append("    THEN '3:'||SUBSTR(FLT.ERA_POINT_LAT,0,3)||SUBSTR(FLT.ERA_POINT_LONG,0,4)||'/'||FLT.ERA_PORT ");
		
		sql.append("    ELSE '' ");
		sql.append("  END AS REFILE_ERA, ");
		sql.append("  ALT.WEATHER_ALERT, ");
		sql.append("  FLT.PLN_PAYLOAD, ");
		sql.append("  PDP.STATUS_X, ");
		sql.append("  PDP.REQ_PAX_PLD_WT, ");
		sql.append("  PDP.REQ_CGO_PLD_WT, ");
		sql.append("  PDP.REQ_OTH_PLD_WT, ");
		sql.append("  TO_CHAR(PDP.REQ_PAX_DTG - 9/24,'DD/HH24MI') REQ_PAX_DTG, ");
		sql.append("  TO_CHAR(PDP.REQ_CGO_DTG - 9/24,'DD/HH24MI') REQ_CGO_DTG, ");
		sql.append("  PDP.ACC_PAX_PLD_WT, ");
		sql.append("  PDP.ACC_CGO_PLD_WT, ");
		sql.append("  PDP.ACC_OTH_PLD_WT, ");
		sql.append("  PDP.ACC_CGO_PLD_ZERO_Y, ");
		sql.append("  TO_CHAR(SKD.EST_DEP_DT_LOC,'DDMON') DDMON, ");
		sql.append("  PDP.MD_AC_CONFIG, ");
		sql.append("  PDP.LD_AC_CONFIG_FWD, ");
		sql.append("  PDP.LD_AC_CONFIG_AFT, ");
		sql.append("  PDP.MD_LD_RECIR_FAN, ");
		sql.append("  PDP.ANI_PERI_FUEL_ADD, ");
		sql.append("  PDP.INPUT_TYP, ");
		sql.append("  PDP.TELEX_ADDR, ");
		sql.append("  ALT.PAYLOAD_ALERT, ");
		sql.append("  FLT.PLAN_CONFIRM, ");
		sql.append("  ALT.COMMENTED, ");
		sql.append("  TO_CHAR(ALT.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		sql.append("  TO_CHAR(SKD.EST_DEP_DT,'DDMON','NLS_DATE_LANGUAGE=AMERICAN') EST_DATE, ");
		sql.append("  ALT.LEG_NUM, ");
		sql.append("  NVL(FWT.PLN_TANK_FUEL,0) PLN_TANK_FUEL  ");
		sql.append("FROM KFOS.FFS_ALERT_T ALT, ");
		sql.append("  FLIGHT_PLAN_T FLT, ");
		sql.append("  DAILY_SCH_T SKD, ");
		sql.append("  PDP_FLT_PAYLOAD_T PDP, ");
		sql.append("  CM_CITYPAIR_DEF_T DEF, ");
		sql.append("  FLT_FUEL_WT_T FWT ");
		sql.append("WHERE 1                  =1 ");
		sql.append("AND SKD.EST_DEP_DT BETWEEN SYSDATE - 12/24 AND SYSDATE + 5/24 ");
		sql.append("AND SKD.DEP_STS                  <> 'INI' ");
		sql.append("AND SKD.ACTNID                   <> 'CNL' ");
		sql.append("AND LENGTH(NVL(SKD.TKOF_T ,'1')) <= 3 ");
		sql.append("AND ALT.STATUS           = 'REL' ");
		sql.append("AND ALT.FIRST_LEG_FLT_DT = SKD.FIRST_LEG_FLT_DT ");
		sql.append("AND ALT.FLT_NUM          = SKD.FLT_NUM ");
		sql.append("AND ALT.STNFR            = SKD.STNFR ");
		sql.append("AND ALT.STNTO            = SKD.STNTO ");
		sql.append("AND ALT.STNFR                     = DEF.DEP_PORT ");
		sql.append("AND ALT.STNTO                     = DEF.ARV_PORT ");
		sql.append("AND DEF.REGION_CD                <> 'DOM' ");
		sql.append("AND ALT.FIRST_LEG_FLT_DT          = FLT.FIRST_LEG_FLT_DT ");
		sql.append("AND ALT.FLT_NUM                   = FLT.FLT_NUM ");
		sql.append("AND ALT.STNFR                     = FLT.STNFR ");
		sql.append("AND ALT.STNTO                     = FLT.STNTO ");
		sql.append("AND FLT.STATUS                    = 'SCH' ");
		sql.append("AND FLT.ACTIVE                    = 'Y' ");
		sql.append("AND ALT.FIRST_LEG_FLT_DT          = PDP.FIRST_LEG_FLT_DT(+) ");
		sql.append("AND ALT.FLT_NUM                   = PDP.FLT_NUM(+) ");
		sql.append("AND ALT.STNFR                     = PDP.STNFR(+) ");
		sql.append("AND ALT.STNTO                     = PDP.STNTO(+) ");
		sql.append("AND ALT.FLT_NUM NOT LIKE '1%' ");
		sql.append("AND ALT.FIRST_LEG_FLT_DT=FWT.FIRST_LEG_FLT_DT(+) ");
		sql.append("AND ALT.FLT_NUM         =FWT.FLT_NUM(+) ");
		sql.append("AND ALT.STNFR           =FWT.STNFR(+) ");
		sql.append("AND ALT.STNTO           =FWT.STNTO(+) ");
		sql.append("ORDER BY GBN DESC, SKD.EST_DEP_DT ASC ");
		*/
		//@2017-09-04
		sql.append("\n	SELECT");
		//------------	ALT
		sql.append("\n		TO_CHAR(ALT.FIRST_LEG_FLT_DT,'YYYYMMDD')	AS	FIRST_LEG_FLT_DT");
		sql.append("\n	,	ALT.FLT_NUM			AS	FLT_NUM");
		sql.append("\n	,	ALT.LEG_NUM			AS	LEG_NUM");
		sql.append("\n	,	ALT.STNFR			AS	STNFR");
		sql.append("\n	,	ALT.STNTO			AS	STNTO");
		sql.append("\n	,	ALT.SYSKEY			AS	SYSKEY");
		sql.append("\n	,	ALT.RELEASE_SYSKEY	AS	RELEASE_SYSKEY");
		sql.append("\n	,	ALT.WEATHER_ALERT	AS	WEATHER_ALERT");
		sql.append("\n	,	ALT.RESTRICT_E		AS	RESTRICT_E");
		sql.append("\n	,	NVL(ALT.MULTI_MTOW ,	'A0') AS MTOW");
		sql.append("\n	,	ALT.COMMENTED		AS	COMMENTED");
		sql.append("\n	,	ALT.MEL_ALERT		AS	MEL_ALERT");
		sql.append("\n	,	ALT.TANKERING_ALERT	AS	TANKERING_ALERT");
		sql.append("\n	,	ALT.PMSN_ALERT		AS	PMSN_ALERT");
		sql.append("\n	,	ALT.HIGHTIME_ALERT	AS	HIGHTIME_ALERT");
		sql.append("\n	,	ALT.PAYLOAD_ALERT	AS	PAYLOAD_ALERT");
		sql.append("\n	,	ALT.REGNO_CHG_ALERT	AS	REGNO_CHG_ALERT");
		sql.append("\n	,	ALT.CALLSIGN_ALERT	AS	CALLSIGN_ALERT");
		sql.append("\n	,	ALT.ETD_ALERT		AS	ETD_ALERT");
		sql.append("\n	,	ALT.ETA_ALERT		AS	ETA_ALERT");
		sql.append("\n	,	ALT.ATD_ALERT		AS	ATD_ALERT");
		sql.append("\n	,	ALT.ATC_ALERT		AS	ATC_ALERT");
		sql.append("\n	,	ALT.FOB_ALERT		AS	FOB_ALERT");
		sql.append("\n	,	ALT.ABHR_ALERT		AS	ABHR_ALERT");
		sql.append("\n	,	ALT.ROUTE_ALERT		AS	ROUTE_ALERT");
		sql.append("\n	,	ALT.CCF_ALERT		AS	CCF_ALERT");
		sql.append("\n	,	ALT.SPD_ALERT		AS	SPD_ALERT");
		sql.append("\n	,	ALT.DISC_ALERT		AS	DISC_ALERT");
		sql.append("\n	,	ALT.LDW_ALERT		AS	LDW_ALERT");
		sql.append("\n	,	ALT.DOC_RDY			AS	DOC_RDY");		
		//@2018-08-23
		sql.append("\n	,	ALT.COBT			AS	COBT");
		sql.append("\n	,	ALT.COBT_ALERT		AS	COBT_ALERT");
		sql.append("\n	,	ALT.TSAT			AS	TSAT");
		sql.append("\n	,	ALT.TSAT_ALERT		AS	TSAT_ALERT");
		sql.append("\n	,	ALT.TSAT_MANUAL		AS	TSAT_MANUAL");		
		
		//------------	FLT
		sql.append("\n	,	FLT.REGNO			AS	REGNO");
		sql.append("\n	,	FLT.ACTYP			AS	ACTYP");
		sql.append("\n	,	FLT.ROUTE			AS	ROUTE");
		sql.append("\n	,	TRIM(FLT.ALT_PORT)	AS ALT_PORT");
		sql.append("\n	,	NVL(FLT.PAD_FUEL,	0)	AS PAD_FUEL");
		sql.append("\n	,	FLT.PLN_PAYLOAD		AS	PLN_PAYLOAD");
		sql.append("\n	,	TO_CHAR(FLT.MSG_TMPST,'YYYY-MM-DD HH24:MI')	AS	MSG_TMPST");
		sql.append("\n	,	TO_CHAR(FLT.POS_TMPST,'YYYY-MM-DD HH24:MI')	AS	POS_TMPST");
		sql.append("\n	,	TO_CHAR(FLT.RAMPOUT_TMPST,'YYYY-MM-DD HH24:MI')	AS	RAMPOUT_TMPST");
		sql.append("\n	,	TO_CHAR(FLT.TAKEOFF_TMPST,'YYYY-MM-DD HH24:MI')	AS	TAKEOFF_TMPST");
		sql.append("\n	,	TO_CHAR(FLT.RMK_TMPST,'YYYY-MM-DD HH24:MI')	AS	RMK_TMPST");
		sql.append("\n	,	TO_CHAR(FLT.CREW_TMPST,'YYYY-MM-DD HH24:MI')	AS	CREW_TMPST");
		sql.append("\n	,	TO_CHAR(FLT.PRV_CREW_TMPST,'YYYY-MM-DD HH24:MI')	AS	PRV_CREW_TMPST");
		sql.append("\n	,	TO_CHAR(FLT.ACARS_TMPST,'YYYY-MM-DD HH24:MI')	AS	ACARS_TMPST");
		sql.append("\n	,	FLT.PLAN_CONFIRM				AS	PLAN_CONFIRM");
		sql.append("\n	,	TO_CHAR(FLT.RAMPOUT_TMPST ,	'YYMMDDHH24MI') AS ACT_DEP_DT");
		sql.append("\n	,	TRIM(TO_CHAR(TRUNC(FLT.ABHR/60),	'00')) ||TRIM(TO_CHAR(MOD(FLT.ABHR ,	60),	'00')) AS ABHR");
		//sql.append("\n	,	'CI'||FLT.SPEED AS SPEED");
		//sql.append("\n	,	DECODE(FLT.ACTYP,'223',FLT.SPEED,'CI'||FLT.SPEED) AS SPEED");//@2019-06-10	:	223  ׳ SPEED, ƴϸ   "CI"+SPEED
		sql.append("\n	,	CASE WHEN FLT.ACTYP IN ('223','CCX','GRJ') THEN FLT.SPEED ELSE 'CI'||FLT.SPEED END AS SPEED");//@2019-08-20
		sql.append("\n	,	TRIM(FLT.ETOPS_PORTS||' '||FLT.ETP_PORTS) AS EDTO_ETP");
		sql.append("\n	,	CASE ");
		sql.append("\n			WHEN FLT.REFILE_Y = 'Y' THEN");
		sql.append("\n				'R:'||FLT.REFILE_POINT||'/'||FLT.REFILE_PORT||'/'||FLT.REFILE_ALT_PORTS ");
		sql.append("\n			WHEN FLT.ERA_Y = 'Y' THEN");
		sql.append("\n				'3:'||SUBSTR(FLT.ERA_POINT_LAT,	0,	3)||SUBSTR(FLT.ERA_POINT_LONG,	0,	4)||'/'||FLT.ERA_PORT");
		sql.append("\n			ELSE '' ");
		sql.append("\n		END AS REFILE_ERA");
		//------------	SKD
		sql.append("\n	,	TO_CHAR(SKD.SCH_DEP_DT,	'YYMMDDHH24MI') AS SCH_DEP_DT");
		sql.append("\n	,	TO_CHAR(SKD.EST_DEP_DT,		'YYMMDDHH24MI') AS EST_DEP_DT");
		sql.append("\n	,	TO_CHAR(SKD.EST_ARV_DT,		'YYMMDDHH24MI') AS EST_ARV_DT");
		sql.append("\n	,	TO_CHAR(SKD.SCH_ARV_DT,	'YYMMDDHH24MI') AS SCH_ARV_DT");
		sql.append("\n	,	TO_CHAR(SKD.EST_DEP_DT_LOC ,	'DDMON') AS DDMON");
		sql.append("\n	,	TO_CHAR(SKD.EST_DEP_DT,	'DDMON' ,	'NLS_DATE_LANGUAGE=AMERICAN') AS EST_DATE");
		//------------	PDP
		sql.append("\n	,	PDP.STATUS_X			AS	STATUS_X");
		sql.append("\n	,	PDP.INPUT_TYP			AS	INPUT_TYP");
		sql.append("\n	,	PDP.TELEX_ADDR			AS	TELEX_ADDR");
		sql.append("\n	,	PDP.REQ_PAX_PLD_WT		AS	REQ_PAX_PLD_WT");
		sql.append("\n	,	TO_CHAR(PDP.REQ_PAX_DTG - 9/24,	'DD/HH24MI') AS REQ_PAX_DTG");
		sql.append("\n	,	PDP.REQ_CGO_PLD_WT		AS	REQ_CGO_PLD_WT");
		sql.append("\n	,	PDP.REQ_OTH_PLD_WT		AS	REQ_OTH_PLD_WT");
		sql.append("\n	,	TO_CHAR(PDP.REQ_CGO_DTG - 9/24,	'DD/HH24MI') AS REQ_CGO_DTG");
		sql.append("\n	,	PDP.ACC_PAX_PLD_WT		AS	ACC_PAX_PLD_WT");
		sql.append("\n	,	PDP.ACC_CGO_PLD_WT		AS	ACC_CGO_PLD_WT");
		sql.append("\n	,	PDP.ACC_OTH_PLD_WT		AS	ACC_OTH_PLD_WT");
		sql.append("\n	,	PDP.ACC_CGO_PLD_ZERO_Y	AS	ACC_CGO_PLD_ZERO_Y");
		sql.append("\n	,	PDP.MD_AC_CONFIG		AS	MD_AC_CONFIG");
		sql.append("\n	,	PDP.LD_AC_CONFIG_FWD	AS	LD_AC_CONFIG_FWD");
		sql.append("\n	,	PDP.LD_AC_CONFIG_AFT	AS	LD_AC_CONFIG_AFT");
		sql.append("\n	,	PDP.MD_LD_RECIR_FAN		AS	MD_LD_RECIR_FAN");
		sql.append("\n	,	PDP.ANI_PERI_FUEL_ADD	AS	ANI_PERI_FUEL_ADD");
		//------------	FWT
		sql.append("\n	,	(NVL(FWT.PLN_EXTR_FUEL1,	0) + NVL(FWT.PLN_EXTR_FUEL2,	0) + NVL(FWT.PLN_TANK_FUEL,	0))/100 AS EXTR_FUEL");
		sql.append("\n	,	NVL(FWT.PLN_EXTR_FUEL1,	0) AS PLN_EXTR_FUEL1");
		sql.append("\n	,	FWT.PLN_EXTR_RSN1");
		sql.append("\n	,	NVL(FWT.PLN_EXTR_FUEL2,	0) AS PLN_EXTR_FUEL2");
		sql.append("\n	,	FWT.PLN_EXTR_RSN2");
		sql.append("\n	,	NVL(FWT.PLN_TANK_FUEL,	0) AS PLN_TANK_FUEL");
		sql.append("\n	,	NVL(FWT.PLN_RAMP_FUEL,	0) AS PLN_RAMP_FUEL");//@2019-01-21		
		//------------	OTHERS
		sql.append("\n	,	DECODE(DECODE(SUBSTR(ALT.FLT_NUM ,	1 ,	1)");
		sql.append("\n			,	'4',	'JNA'");
		sql.append("\n			,	'KAL'");
		sql.append("\n			)");
		sql.append("\n		,	'JNA',	'JNA'");
		sql.append("\n		,	DEF.REGION_CD");
		sql.append("\n		) AS REGION_CD");
		sql.append("\n	,	DECODE(SUBSTR(ALT.FLT_NUM ,	1 ,	1)");
		sql.append("\n		,	'4',	'JNA'");
		sql.append("\n		,	'KAL'");
		sql.append("\n		) AS GBN");
		sql.append("\n	FROM");
		sql.append("\n		KFOS.FFS_ALERT_T		ALT");
		sql.append("\n	,	KFOS.FLIGHT_PLAN_T		FLT");
		sql.append("\n	,	KEADM.DAILY_SCH_T		SKD");
		sql.append("\n	,	KPMS.CM_CITYPAIR_DEF_T	DEF");
		sql.append("\n	,	KFOS.PDP_FLT_PAYLOAD_T	PDP");
		sql.append("\n	,	KFOS.FLT_FUEL_WT_T		FWT");
		sql.append("\n	WHERE 1=1");
		//------------	FLT join
		sql.append("\n	AND	ALT.FIRST_LEG_FLT_DT = FLT.FIRST_LEG_FLT_DT");
		sql.append("\n	AND	ALT.FLT_NUM = FLT.FLT_NUM");
		sql.append("\n	AND	ALT.STNFR = FLT.STNFR");
		sql.append("\n	AND	ALT.STNTO = FLT.STNTO");
		//------------	SKD join
		sql.append("\n	AND	ALT.FIRST_LEG_FLT_DT = SKD.FIRST_LEG_FLT_DT");
		sql.append("\n	AND	ALT.FLT_NUM = SKD.FLT_NUM");
		sql.append("\n	AND	ALT.STNFR = SKD.STNFR");
		sql.append("\n	AND	ALT.STNTO = SKD.STNTO");
		//------------	DEF join
		sql.append("\n	AND	ALT.STNFR = DEF.DEP_PORT");
		sql.append("\n	AND	ALT.STNTO = DEF.ARV_PORT");
		//------------	PDP join
		sql.append("\n	AND	ALT.FIRST_LEG_FLT_DT = PDP.FIRST_LEG_FLT_DT(+)");
		sql.append("\n	AND	ALT.FLT_NUM = PDP.FLT_NUM(+)");
		sql.append("\n	AND	ALT.STNFR = PDP.STNFR(+)");
		sql.append("\n	AND	ALT.STNTO = PDP.STNTO(+)");
		//------------	FWT join
		sql.append("\n	AND	ALT.FIRST_LEG_FLT_DT=FWT.FIRST_LEG_FLT_DT(+)");
		sql.append("\n	AND	ALT.FLT_NUM =FWT.FLT_NUM(+)");
		sql.append("\n	AND	ALT.STNFR =FWT.STNFR(+)");
		sql.append("\n	AND	ALT.STNTO =FWT.STNTO(+)");
		//------------	static
		sql.append("\n	AND	ALT.STATUS = 'REL'");
		sql.append("\n	AND	ALT.FLT_NUM NOT LIKE '1%'");
		sql.append("\n	AND	FLT.STATUS = 'SCH'");
		sql.append("\n	AND	FLT.ACTIVE = 'Y'");
		sql.append("\n	AND	SKD.EST_DEP_DT BETWEEN SYSDATE - 12/24 AND	SYSDATE + 5/24");
		sql.append("\n	AND	SKD.DEP_STS <> 'INI'");
		sql.append("\n	AND	SKD.ACTNID <> 'CNL'");
		sql.append("\n	AND	LENGTH(NVL(SKD.TKOF_T ,	'1')) <= 3");
		sql.append("\n	AND	DEF.REGION_CD <> 'DOM'");
		sql.append("\n	ORDER BY");
		sql.append("\n		GBN DESC");
		sql.append("\n	,	SKD.EST_DEP_DT ASC");
		
		printSQL(sql);
		return sql.toString();
	}
	
	/**
	 * 20160415 ߰
	 */
	public String acarsSmiRev(String yyyymmdd, String preSmi, String preFltNum, String tabStr) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append("   ACS.FLT_NUM, TO_CHAR(MAX(ACS.MSG_TIMESTAMP),'YYMMDDHH24MISS') MAX_TM ");
		sql.append(" FROM KFOS.FFS_ALERT_T FFS, PE_MSG_T ACS ");
		sql.append(" WHERE FFS.FIRST_LEG_FLT_DT >= SYSDATE - 3 ");
		sql.append(" AND FFS.FIRST_LEG_FLT_DT <= SYSDATE + 1 ");
		sql.append(" AND FFS.STATUS = '" + tabStr + "' ");
		sql.append(" AND ACS.SMI IN (" + preSmi + ") ");
		sql.append(" AND ACS.FLT_NUM IN (" + preFltNum + ") ");
		sql.append(" AND ACS.GBN_X NOT IN ('U','M') ");
		sql.append(" AND FFS.FIRST_LEG_FLT_DT = ACS.FIRST_LEG_FLT_DT ");
		sql.append(" AND FFS.FLT_NUM = ACS.FLT_NUM ");
		sql.append(" AND FFS.STNFR = ACS.STNFR ");
		sql.append(" AND FFS.STNTO = ACS.STNTO ");
		sql.append(" GROUP BY ACS.FLT_NUM ");
		sql.append(" ORDER BY ACS.FLT_NUM ");

		printSQL(sql);
		return sql.toString();
	}
	/** 
	  * 2016.04.15 ߰
	  */
	public String acarsRawMsgRev(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		//20160715 
		//sql.append("   CASE WHEN FLT_NUM LIKE '4%' THEN 'LJ'||A.FLT_NUM ELSE 'KE'||A.FLT_NUM END AS FLT_NUM, ");
		sql.append("   CASE WHEN FLT_NUM LIKE '4%' THEN 'LJ'||'0'||SUBSTR(A.FLT_NUM,2) ELSE 'KE'||A.FLT_NUM END AS FLT_NUM, ");
		sql.append("   A.SMI, B.DESCS, ");
		sql.append("   'ACARS '||B.DESCS||' MESSAGE'||CHR(13)||CHR(10)||'RECEIVED TIME : '||TO_CHAR(A.MSG_TIMESTAMP,'DDMON HH24:MI','NLS_DATE_LANGUAGE=AMERICAN')||CHR(13)||CHR(10)||CHR(13)||CHR(10)||A.RAW_MSG AS RAW_MSG ");
		sql.append(" FROM PE_MSG_T A, KEADM.PE_KE_SMI_T B ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD') ");
		sql.append(" AND A.FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append(" AND A.STNFR = '" + params.getStnfr() + "' ");
		sql.append(" AND A.STNTO = '" + params.getStnto() + "' ");
		sql.append(" AND A.SMI IN (" + params.getSmi() + ") ");
		//20160720 ߰
		sql.append(" AND A.GBN_X NOT IN ('U','M') ");
		sql.append(" AND B.GBN_X = 'D' ");
		
		sql.append(" AND A.SMI = B.SMI ");
		//20160713 ߰
		sql.append(" ORDER BY A.MSG_TIMESTAMP DESC ");
		
		printSQL(sql);
		return sql.toString();
	}
	
	/** 
	  * 20160715 ߰
	  */
	public String acarsRawMsgUpRev(FfsQ110BG params) {
		StringBuffer sql = new StringBuffer();
		
		//2016.07.27 
		sql.append(" SELECT CASE WHEN A.FLT_NUM LIKE '4%' THEN 'LJ'||'0'||SUBSTR(A.FLT_NUM, 2) ELSE 'KE'||A.FLT_NUM END AS FLT_NUM, A.SMI, B.DESCS, ");
		sql.append("   'ACARS '||B.DESCS||' MESSAGE'||CHR(13)||CHR(10)||'RECEIVED TIME : '||TO_CHAR(A.MSG_TIMESTAMP, 'DDMON HH24:MI', 'NLS_DATE_LANGUAGE=AMERICAN')||CHR(13)||CHR(10)||CHR(13)||CHR(10)||A.UPLOAD_MSG AS RAW_MSG ");
		sql.append(" FROM PE_MSG_T A,  ");
		sql.append("      KEADM.PE_KE_SMI_T B, "); 
		sql.append("      (SELECT EST_DEP_DT-1/24 AS FR_DT, EST_ARV_DT+1/24 AS TO_DT, REGNO FROM DAILY_SCH_T ");
		sql.append("        WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirstLegFltDt() + "','YYYYMMDD')  ");
		sql.append("          AND FLT_NUM = '" + params.getFltNum() + "' ");
		sql.append("          AND STNFR = '" + params.getStnfr() + "'  ");
		sql.append("          AND STNTO = '" + params.getStnto() + "'  ");
		sql.append("      ) C ");
		sql.append(" WHERE A.SMI = B.SMI ");
		sql.append(" AND A.UPLOAD_MSG IS NOT NULL ");
		sql.append(" AND A.GBN_X NOT IN ('D','M') ");
		sql.append(" AND B.GBN_X = 'U' ");
		sql.append(" AND A.SMI IN ('M36','AGM') ");
		sql.append(" AND A.REGNO = '" + params.getRegno() + "' ");
		sql.append(" AND A.REGNO = C.REGNO ");
		sql.append(" AND A.MSG_TIMESTAMP BETWEEN C.FR_DT AND C.TO_DT ");
		sql.append(" AND A.MSG_KEY BETWEEN TO_CHAR(C.FR_DT+9/24,'YYYYMMDDHH24MI')||'00000000' AND TO_CHAR(C.TO_DT+9/24,'YYYYMMDDHH24MI')||'23599999' ");
		sql.append(" ORDER BY A.MSG_TIMESTAMP DESC");

		printSQL(sql);
		return sql.toString();
	}
	//@2017-09-04
	public String updDocRdy(HashMap<String,String> params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("\n	UPDATE KFOS.FFS_ALERT_T");
		sql.append("\n	SET DOC_RDY = '" + (String)params.get("DOC_RDY") + "'");
		sql.append("\n	,	DOC_RDY_TMPST	=	SYSDATE");//@2017-11-06
		sql.append("\n	WHERE");
		sql.append("\n		FIRST_LEG_FLT_DT = TO_DATE('" + (String)params.get("FIRST_LEG_FLT_DT")+ "','YYYYMMDD')");
		sql.append("\n	AND	FLT_NUM = '" + (String)params.get("FLT_NUM") + "'");
		sql.append("\n	AND	STNFR = '" + (String)params.get("STNFR") + "'");
		sql.append("\n	AND	STNTO = '" + (String)params.get("STNTO") + "'");

		printSQL(sql);
		return sql.toString();
	}
	
	//@2018-08-23
	public String updTsatManual(HashMap<String,String> params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("UPDATE KFOS.FFS_ALERT_T ");
		sql.append("	SET ");
		sql.append("		TSAT_MANUAL = '"+(String)params.get("TSAT_MANUAL")+"'");
		sql.append("	,	TSAT_MAN_TMPST = SYSDATE");
		sql.append("	WHERE");
		sql.append("		FIRST_LEG_FLT_DT = TO_DATE('"+(String)params.get("FIRST_LEG_FLT_DT")+"',	'YYYYMMDD')");
		sql.append("	AND	FLT_NUM = '"+(String)params.get("FLT_NUM")+"'");
		sql.append("	AND	STNFR = '"+(String)params.get("STNFR") +"'");
		sql.append("	AND	STNTO = '"+(String)params.get("STNTO")+"'");

		printSQL(sql);
		return sql.toString();
	}
	
	//@2018-08-23
	public String updEldtManual(HashMap<String,String> params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append("UPDATE KFOS.FFS_ALERT_T ");
		sql.append("	SET ");
		sql.append("		ELDT_MANUAL = '"+(String)params.get("ELDT_MANUAL")+"'");
		sql.append("	,	ELDT_MAN_TMPST = SYSDATE");
		sql.append("	WHERE");
		sql.append("		FIRST_LEG_FLT_DT = TO_DATE('"+(String)params.get("FIRST_LEG_FLT_DT")+"',	'YYYYMMDD')");
		sql.append("	AND	FLT_NUM = '"+(String)params.get("FLT_NUM")+"'");
		sql.append("	AND	STNFR = '"+(String)params.get("STNFR") +"'");
		sql.append("	AND	STNTO = '"+(String)params.get("STNTO")+"'");

		printSQL(sql);
		return sql.toString();
	}
	
	//@2018-08-27
	public String selATSFromATFMS(String actAlert) {
		StringBuffer sql = new StringBuffer();
		
		/*sql.append("SELECT");
		sql.append("		SUBSTR(FPL_MSG ,	IDX ,	LEN-IDX)	AS	FPL_MSG");
		sql.append("	FROM");
		sql.append("		(");
		sql.append("			SELECT");
		sql.append("				INSTR(FPL_MSG ,	SUBSTR('"+actAlert+"' ,	20)) AS IDX");
		sql.append("			,	LENGTH(FPL_MSG) AS LEN");
		sql.append("			,	FPL_MSG");
		sql.append("			FROM");
		sql.append("				KFOS.ATFMS_FPL_RCV");
		sql.append("			WHERE");
		sql.append("				ATFMS_TMPST = SUBSTR('"+actAlert+"' ,	1 ,	18)");
		sql.append("		)");*/
		
		
		//@2019-01-21
		sql.append("	SELECT");
		sql.append("		REPLACE(WM_CONCAT(SUBSTR(B.FPL_MSG ,	INSTR(B.FPL_MSG ,	'(')-18)||CHR(13)||CHR(13)),	',',	'') AS FPL_MSG");
		sql.append("	FROM");
		sql.append("		(");
		sql.append("			SELECT");
		sql.append("				CALLSIGN ");
		sql.append("			,	SUBSTR(FPL_MSG ,	INSTR(FPL_MSG ,	'DOF/'),	10) AS DOF_VALUE");
		sql.append("			FROM");
		sql.append("				KFOS.ATFMS_FPL_RCV");
		sql.append("			WHERE");
		sql.append("						ATFMS_TMPST BETWEEN TO_CHAR(SYSDATE-1 ,	'YYYYMMDDHH24MISS')||'.000'		AND	TO_CHAR(SYSDATE ,	'YYYYMMDDHH24MISS')||'.999'");
		sql.append("			AND	FPL_SEQ = SUBSTR('"+actAlert+"' ,	0 ,	9)");
		sql.append("			AND	ROWNUM = 1");
		sql.append("		) A");
		sql.append("	,	KFOS.ATFMS_FPL_RCV B");
		sql.append("	WHERE");
		sql.append("		A.CALLSIGN = B.CALLSIGN");
		sql.append("	AND	ATFMS_TMPST BETWEEN TO_CHAR(SYSDATE-1 ,	'YYYYMMDDHH24MISS')||'.000'");
		sql.append("	AND	TO_CHAR(SYSDATE ,	'YYYYMMDDHH24MISS')||'.999'");
		sql.append("	AND	B.FPL_MSG LIKE '%'||A.DOF_VALUE||'%'");
		sql.append("	ORDER BY");
		sql.append("		B.ATFMS_TMPST");

		printSQL(sql);
		return sql.toString();
	}
}