package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Flight Following Chart - Landed SQL 
  * @author Copyright (c) 2007/01/09  
  */   
public class FfsQ040Query {
	private static FfsQ040Query instance = new FfsQ040Query();
	
	public static FfsQ040Query getInstance() {
		return instance;
	}
	
	/** 
	  * Flight Following Chart - Landed ȸ SQLԼ.
	  * @return String Query
	  * @author Copyright (c) 2007/01/09 
	  */
	public String selLanded() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	TO_CHAR(D.EST_DEP_DT,'YYMMDDHH24MI') EST_DEP_DT, "); // ߰
		//sql.append(" 	C.REGION_CD, D.FLT_NUM, D.REGNO, D.SACTYP, D.STNFR, D.STNTO, ");
		sql.append(" 	 D.FLT_NUM, D.REGNO, D.SACTYP, D.STNFR, D.STNTO, ");//@2013-11-07
		sql.append(" 	   DECODE(DECODE(SUBSTR(D.FLT_NUM, 1, 1),'4','JNA','KAL'),'JNA','JNA',C.REGION_CD) REGION_CD, ");//@2013-11-07
		sql.append(" 	  DECODE(SUBSTR(D.FLT_NUM, 1, 1),'4','JNA','KAL') GBN,  ");//@2013-11-07
		
		sql.append(" 	TO_CHAR(D.ACT_DEP_DT,'YYMMDDHH24MI') ACT_DEP_DT, D.LAND_T, ");
		sql.append(" 	TO_CHAR(D.ACT_ARV_DT,'YYMMDDHH24MI') ACT_ARV_DT, ");
		// 2007.06.26  : P.PLN_PAYLOAD, P.ACT_PAYLOAD -> P.PLN_FOD_FUEL, P.ACT_FOD_FUEL
		//sql.append(" 	P.PLN_PAYLOAD, P.ACT_PAYLOAD ");
		sql.append(" 	P.PLN_FOD_FUEL, "); // 2011.06.09  : P.ACT_FOD_FUEL, 
		// 2007.01.26  : Landed  ǥ .
		//sql.append(" 	F.FLT_NUM_COLOR, F.REGNO REGNO_COLOR, F.WX_STNFR, F.WX_STNTO ");
		//2007.06.29 ߰ : Flight Watch Log  ʿ
		sql.append(" 	P.SYSKEY, ");
		sql.append(" 	TO_CHAR(D.FIRST_LEG_FLT_DT,'DDMONYY') DDMONYY, ");
		sql.append(" 	TO_CHAR(D.SCH_DEP_DT,'HH24MI') STD, ");
		sql.append(" 	TO_CHAR(D.ACT_DEP_DT,'HH24MI') ATD, ");
		sql.append(" 	TO_CHAR(D.SCH_ARV_DT,'HH24MI') STA, ");
		sql.append(" 	TO_CHAR(D.EST_ARV_DT,'HH24MI') ETA, ");
		sql.append(" 	TO_CHAR(P.TAKEOFF_TMPST,'HH24MI') TAKEOFF_TMPST, ");
		sql.append(" 	P.PLANID, ");
		sql.append(" 	P.EXTR_FUEL+P.PAD_FUEL EXTR_FUEL, ");
		sql.append(" 	P.ALT_PORT, ");
		sql.append(" 	P.REFILE_POINT, P.REFILE_PORT, P.REFILE_ALT_PORTS, ");
		sql.append(" 	TO_CHAR(D.FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, "); //2007.07.06 ߰		//
		sql.append(" 	P.ALTN_FUEL+P.HOLD_FUEL RSV_FUEL, "); //2011.06.09 ߰
		sql.append(" 	F.ACT_FOD_FUEL/100  ACT_FOD_FUEL "); //2011.06.09 ߰
		
		sql.append(" 	,  TO_CHAR(D.SCH_ARV_DT,'YYMMDDHH24MI') SCH_ARV_DT  ");//@2014-05-21
		sql.append(" FROM ");
		//sql.append(" 	DAILY_SCH_T D, CM_CITYPAIR_DEF_T C, FLIGHT_PLAN_T P, FLIGHT_ALERT_T F ");
		sql.append(" 	DAILY_SCH_T D, CM_CITYPAIR_DEF_T C, FLIGHT_PLAN_T P, FLT_FUEL_WT_T F ");//2011.06.09 ߰ : FL_FUEL_WT_T F
		sql.append(" WHERE ");
		sql.append(" 	D.FIRST_LEG_FLT_DT BETWEEN SYSDATE - 5 AND SYSDATE AND "); //2009.04.24 ߰ :  ׽Ʈ  
		sql.append(" 	D.ACT_ARV_DT >= SYSDATE - 31/24 AND ");
		sql.append(" 	D.ACT_ARV_DT <= SYSDATE AND ");
		sql.append(" 	D.ARV_STS = 'ACT' AND ");
		sql.append(" 	D.STNFR = C.DEP_PORT AND ");
		sql.append(" 	D.STNTO = C.ARV_PORT AND ");
		sql.append(" 	D.FIRST_LEG_FLT_DT = P.FIRST_LEG_FLT_DT AND ");
		sql.append(" 	D.FLT_NUM = P.FLT_NUM AND ");
		sql.append(" 	D.STNFR = P.STNFR AND ");
		sql.append(" 	D.STNTO = P.STNTO AND ");
		//sql.append(" 	D.FIRST_LEG_FLT_DT = F.FIRST_LEG_FLT_DT AND ");
		//sql.append(" 	D.FLT_NUM = F.FLT_NUM AND ");
		//sql.append(" 	D.STNFR = F.STNFR AND ");
		//sql.append(" 	D.STNTO = F.STNTO AND ");
		sql.append(" 	P.ACTIVE = 'Y' ");
		sql.append(" 	AND D.FLT_NUM NOT LIKE '1%' "); //2009.04.24 ߰ :  ׽Ʈ  
		//sql.append("  AND SUBSTR(D.FLT_NUM, 1, 1) <> '4' "); //2009.08.13 ߰ :  FLT @2013-11-07
		//
		sql.append("  AND D.FIRST_LEG_FLT_DT=F.FIRST_LEG_FLT_DT(+) AND "); //20011.06.09 ߰
		sql.append("  D.FLT_NUM=F.FLT_NUM(+) AND "); //2011.06.09 ߰
		sql.append("  D.STNFR=F.STNFR(+) AND D.STNTO=F.STNTO(+) "); //2011.06.09 ߰
		
		sql.append("    AND C.REGION_CD !='DOM' ");//@2013-11-07
		
		//sql.append(" ORDER BY D.ACT_ARV_DT ");
		sql.append(" ORDER BY GBN ASC, D.ACT_ARV_DT "); //@2013-11-07		
		
		//Logger.debug.println("[BASE:FfsQ040Query:selLanded] sql : "+sql.toString());
		//System.out.println("[BASE:FfsQ040Query:selLanded] sql : "+sql.toString());	
		return sql.toString();
	}
	
	/**
	 * 20160415 ߰
	 */
	public String selLandedRev() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DECODE(DECODE(SUBSTR(SKD.FLT_NUM, 1, 1),'4','JNA','KAL'),'JNA','JNA',DEF.REGION_CD) REGION_CD, ");
		sql.append("   DECODE(SUBSTR(SKD.FLT_NUM, 1, 1),'4','JNA','KAL') GBN, ");
		sql.append("   SKD.FLT_NUM, ");
		sql.append("   SKD.REGNO, ");
		sql.append("   SKD.SACTYP, ");
		sql.append("   SKD.STNFR, ");
		sql.append("   SKD.STNTO, ");
		sql.append("   TO_CHAR(SKD.SCH_DEP_DT,'YYMMDDHH24MI') AS SCH_DEP_DT, ");
		sql.append("   TO_CHAR(SKD.EST_DEP_DT,'YYMMDDHH24MI') AS EST_DEP_DT, ");
		sql.append("   TO_CHAR(SKD.ACT_DEP_DT,'YYMMDDHH24MI') AS ACT_DEP_DT, ");
		sql.append("   SKD.TKOF_T, ");
		sql.append("   SKD.LAND_T, ");
		sql.append("   TO_CHAR(SKD.ACT_ARV_DT,'YYMMDDHH24MI') AS ACT_ARV_DT, ");
		sql.append("   TO_CHAR(SKD.SCH_ARV_DT,'YYMMDDHH24MI') AS SCH_ARV_DT, ");
		sql.append("   FLT.PLN_FOD_FUEL, ");
		sql.append("   FLT.SYSKEY, ");
		sql.append("   FLT.PLANID, ");
		sql.append("   FLT.ALTN_FUEL   +FLT.HOLD_FUEL AS RSV_FUEL, ");
		sql.append("   FUL.ACT_FOD_FUEL/100           AS ACT_FOD_FUEL, ");
		sql.append("   FLT.PLAN_CONFIRM, ");
		sql.append("   ALT.COMMENTED, ");
		sql.append("   ALT.LEG_NUM, ");
		sql.append("   TO_CHAR(SKD.FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		
		sql.append("   TO_CHAR(SKD.FIRST_LEG_FLT_DT,'DDMONYY') DDMONYY, ");
		sql.append("   TO_CHAR(SKD.SCH_DEP_DT,'HH24MI') STD, ");
		sql.append("   TO_CHAR(SKD.ACT_DEP_DT,'HH24MI') ATD, ");
		sql.append("   TO_CHAR(FLT.TAKEOFF_TMPST,'HH24MI') TAKEOFF_TMPST, ");
		sql.append("   TO_CHAR(SKD.EST_ARV_DT,'HH24MI') ETA, ");
		sql.append("   TO_CHAR(SKD.SCH_ARV_DT,'HH24MI') STA, ");
		sql.append("   FLT.EXTR_FUEL+FLT.PAD_FUEL EXTR_FUEL, ");
		sql.append("   FLT.ALT_PORT, ");
		sql.append("   FLT.REFILE_POINT, ");
		sql.append("   FLT.REFILE_PORT, ");
		sql.append("   FLT.REFILE_ALT_PORTS, ");
		
		//20160610 ߰
		sql.append("   ALT.RELEASE_SYSKEY ");
		
		sql.append(" FROM DAILY_SCH_T SKD, ");
		sql.append("   CM_CITYPAIR_DEF_T DEF, ");
		sql.append("   FLIGHT_PLAN_T FLT, ");
		sql.append("   FLT_FUEL_WT_T FUL, ");
		sql.append("   KFOS.FFS_ALERT_T ALT ");
		sql.append(" WHERE 1=1 ");
		sql.append(" AND SKD.FIRST_LEG_FLT_DT BETWEEN SYSDATE - 5 AND SYSDATE ");
		sql.append(" AND SKD.ACT_ARV_DT BETWEEN SYSDATE       - 31/24 AND SYSDATE ");
		sql.append(" AND SKD.ARV_STS          = 'ACT' ");
		sql.append(" AND SKD.STNFR            = DEF.DEP_PORT ");
		sql.append(" AND SKD.STNTO            = DEF.ARV_PORT ");
		sql.append(" AND SKD.FIRST_LEG_FLT_DT = FLT.FIRST_LEG_FLT_DT ");
		sql.append(" AND SKD.FLT_NUM          = FLT.FLT_NUM ");
		sql.append(" AND SKD.STNFR            = FLT.STNFR ");
		sql.append(" AND SKD.STNTO            = FLT.STNTO ");
		sql.append(" AND FLT.ACTIVE           = 'Y' ");
		sql.append(" AND SKD.FLT_NUM NOT LIKE '1%' ");
		sql.append(" AND SKD.FIRST_LEG_FLT_DT = FUL.FIRST_LEG_FLT_DT(+) ");
		sql.append(" AND SKD.FLT_NUM          = FUL.FLT_NUM(+) ");
		sql.append(" AND SKD.STNFR            = FUL.STNFR(+) ");
		sql.append(" AND SKD.STNTO            = FUL.STNTO(+) ");
		sql.append(" AND DEF.REGION_CD       !='DOM' ");
		sql.append(" AND SKD.FIRST_LEG_FLT_DT = ALT.FIRST_LEG_FLT_DT ");
		sql.append(" AND SKD.FLT_NUM          = ALT.FLT_NUM ");
		sql.append(" AND SKD.STNFR            = ALT.STNFR ");
		sql.append(" AND SKD.STNTO            = ALT.STNTO ");
		sql.append(" AND ALT.STATUS           = 'LND' ");
		sql.append(" ORDER BY GBN DESC,  SKD.ACT_ARV_DT DESC ");

		//System.out.println("[BASE:FfsQ040Query:selLandedRev] sql : "+sql.toString());	
		return sql.toString();
	}
}