package kal.base.ffs.query;

import kal.base.jdf.com.Logger;
import kal.base.ffs.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Enroute  Flight   Ȯ ȭ SQL 
  * @author Copyright (c) 2007/01/18  
  */   
public class FfsQ050Query {
	private static FfsQ050Query instance = new FfsQ050Query();
	
	public static FfsQ050Query getInstance() {
		return instance;
	}
	
	/** 
	  * Enroute  Flight   ȸ SQLԼ.
	  * @return String Query
	  * @author Copyright (c) 2007/01/18 
	  */
	public String selDetail() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	W.SYSKEY, W.SEQ, P.FLT_NUM, "); //2007.01.19 ߰
		sql.append(" 	W.WAYPOINT WPT, W.LAT||W.LON COORD, TO_CHAR(W.ETA,'HH24MI') ETO, TO_CHAR(W.ATA,'HH24MI') ATO, ");
		sql.append(" 	W.PLN_FOB_FUEL ERF, W.ACT_FOB_FUEL ARF, W.PLN_LEVEL EFL, W.ACT_LEVEL AFL, W.REMARKS, ");
		sql.append(" 	W.PTR_ALERT, W.ATA_ALERT, W.FOB_ALERT, W.LVL_ALERT, ");
		sql.append(" 	W.LAT, W.LON "); //2007.07.09 ߰
		//		-----------------@2014-05-12 ߰
		sql.append("  ,CEIL(DECODE(W.ATA,'','',(W.ATA - W.ETA) * 60 * 24)) TIME_DIFF "); 
		sql.append("  ,DECODE(W.ATA,'','',(W.PLN_FOB_FUEL - P.PLN_FOD_FUEL) + P.ALTN_FUEL + P.HOLD_FUEL) IFR ");
		sql.append("  ,DECODE(W.ATA,'','',(W.PLN_FOB_FUEL - P.PLN_FOD_FUEL) + (P.HOLD_FUEL * 1.3)) FUEL_MIN ");
		sql.append("  ,DECODE(W.ATA,'','',(W.ACT_FOB_FUEL - DECODE(W.ATA,'','',(W.PLN_FOB_FUEL - P.PLN_FOD_FUEL) + P.ALTN_FUEL + P.HOLD_FUEL))) FUEL_DIFF ");
		//sql.append("  ,DECODE(W.ATA,'','',(W.PLN_LEVEL - W.ACT_LEVEL)) LEVEL_DIFF ");
		sql.append("  ,CASE ");
		sql.append("  	WHEN W.PLN_LEVEL IN ('CLB','DSC') THEN '' ");
		//sql.append("  	ELSE DECODE(W.ATA,'','',(W.PLN_LEVEL - W.ACT_LEVEL)) ");
		sql.append("  	ELSE DECODE(W.ATA,'','',(W.ACT_LEVEL - W.PLN_LEVEL)) ");
		sql.append("  END AS LEVEL_DIFF ");	  
		//2014.06.25 sql.append("  ,DECODE(W.WAYPOINT,P.REFILE_POINT,'HIGHLIGHT','') HIGHLIGHT ");		
		sql.append("	,CASE");	
		sql.append("		WHEN	W.WAYPOINT=P.REFILE_POINT	THEN 'highlight1'");
		//2016.07.27 ߰
		sql.append("		WHEN    P.REFILE_POINT = SUBSTR(W.LAT,1,3)||SUBSTR(W.LON,1,4)   THEN 'highlight1'");   
	
		sql.append("		WHEN	SUBSTR(W.WAYPOINT,1,3)='ETP'	THEN 'highlight2'");	
		sql.append("		ELSE		NULL");	
		sql.append("	END	AS	HIGHLIGHT");	
		//		-----------------@2014-05-12 ߰	
		sql.append(" FROM ");
		sql.append(" 	FLIGHT_PLAN_T P, WAYPOINT_T W ");
		sql.append(" WHERE ");
		sql.append(" 	P.SYSKEY = W.SYSKEY ");
		sql.append(" 	AND P.FIRST_LEG_FLT_DT BETWEEN SYSDATE - 4 AND SYSDATE - 9/24 "); //2007.03.20  : - 57/24 => -4
		sql.append(" 	AND P.ACTIVE = 'Y' ");
		sql.append(" 	AND P.STATUS = 'AIR' ");
		//sql.append("	AND W.PLN_LEVEL NOT IN ('CLB','DSC') "); //@2014-05-12
		sql.append(" 	ORDER BY W.SEQ DESC ");
		//sql.append(" 	ORDER BY W.SEQ ASC  ");
		
        //System.out.println("detail : ======================"+sql.toString());
		Logger.debug.println("[BASE:FfsQ050Query:selDetail] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Enroute  Flight   Remarks ȸ SQLԼ.
	  * @return String Query
	  * @author Copyright (c) 2007/01/19 
	  */
	public String selRemarks(FfsQ050BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT SYSKEY, SEQ, REMARKS ");
		sql.append(" FROM WAYPOINT_T ");
		sql.append(" WHERE SYSKEY = '"+ params.getRSyskey() +"' ");
		sql.append(" 	AND SEQ = "+ params.getRSeq());


		Logger.debug.println("[BASE:FfsQ050Query:selRemarks] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Enroute  Flight   Remarks  SQLԼ.
	  * @return String Query
	  * @author Copyright (c) 2007/01/19 
	  */
	public String updRemarks(FfsQ050BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE WAYPOINT_T ");
		sql.append(" SET REMARKS = '"+ params.getRRemarks() +"' ");
		sql.append(" WHERE SYSKEY = '"+ params.getRSyskey() +"' ");
		sql.append(" 	AND SEQ = "+ params.getRSeq());

		Logger.debug.println("[BASE:FfsQ050Query:updRemarks] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Landed Flight Watch Log ȸ SQLԼ.
	  * @return String Query
	  * @author Copyright (c) 2007/07/06 
	  */
	public String landedDetail(FfsQ050BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	SYSKEY, SEQ, ");
		sql.append(" 	WAYPOINT WPT, LAT||LON COORD, TO_CHAR(ETA,'HH24MI') ETO, TO_CHAR(ATA,'HH24MI') ATO, ");
		sql.append(" 	PLN_FOB_FUEL ERF, ACT_FOB_FUEL ARF, PLN_LEVEL EFL, ACT_LEVEL AFL, REMARKS, ");
		sql.append(" 	PTR_ALERT, ATA_ALERT, FOB_ALERT, LVL_ALERT ");
		sql.append(" FROM ");
		sql.append(" 	WAYPOINT_T ");
		sql.append(" WHERE ");
		sql.append(" 	SYSKEY = '"+ params.getSyskey() +"' ");
		sql.append(" 	ORDER BY SEQ DESC ");
        
		//System.out.println("landedDetail : ========================"+sql.toString());
		Logger.debug.println("[BASE:FfsQ050Query:landedDetail] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Enroute Flight Watch Log Remarks Ҷ   SQLԼ.
	  * @return String Query
	  * @author Copyright (c) 2007/07/25 
	  */
	public String updRmkTmpst(FfsQ050BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE FLIGHT_PLAN_T ");
		sql.append(" SET RMK_TMPST = POS_TMPST ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getPFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" 	AND FLT_NUM = '"+params.getPFltNum()+"' ");
		sql.append(" 	AND STNFR = '"+params.getPStnfr()+"' ");
		sql.append(" 	AND STNTO = '"+params.getPStnto()+"' ");
		sql.append(" 	AND ACTIVE = 'Y' ");

		Logger.debug.println("[BASE:FfsQ050Query:updRmkTmpst] sql : "+sql.toString());
		return sql.toString();
	}
	
}
