package kal.base.ffs.query;

import kal.base.ffs.dbbean.TrkQ010BG;
import kal.base.jdf.com.Logger;

public class TrkQ010Query {
    private static TrkQ010Query instance = new TrkQ010Query();
    
    public static TrkQ010Query getInstance(){
    	return instance;
    }

    public String selFlightTrackList(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	//2013-04-01 
    	sql.append("\n	SELECT");
    	sql.append("\n		TO_CHAR(A.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT");
    	sql.append("\n	,	A.FLT_NUM");
    	sql.append("\n	,	A.SACTYP");
    	sql.append("\n	,	A.STNFR");
    	sql.append("\n	,	A.STNTO");
    	sql.append("\n	,	A.REGNO");
    	sql.append("\n	,	A.REGION_CD");
    	sql.append("\n	,	TO_CHAR(A.ACT_DEP_DT, 'YYMMDD HH24MI') ACT_DEP_DT");
    	sql.append("\n	,	TO_CHAR(A.ACT_ARV_DT, 'YYMMDD HH24MI') ACT_ARV_DT");
    	sql.append("\n	,	DECODE(C.CNT, NULL, 'N', 0 ,'N' ,'Y') TURB_Y");
    	sql.append("\n	,	DECODE(D.SEQ, NULL, 'N', 0 ,'N' ,'Y') NOISE_Y");    	
    	//sql.append("\n	,	DECODE(mod(rownum,2),0 ,'Y','N') NOISE_Y");    	//test
    	sql.append("\n	,	B.ROUTE");
    	sql.append("\n	FROM");
    	sql.append("\n		(");
    	sql.append("\n			SELECT ");
    	sql.append("\n				FIRST_LEG_FLT_DT");
    	sql.append("\n			,	FLT_NUM");
    	sql.append("\n			,	LEG_NUM");
    	sql.append("\n			,	SACTYP");
    	sql.append("\n			,	STNFR");
    	sql.append("\n			,	STNTO");
    	sql.append("\n			,	REGNO");
    	sql.append("\n			,	ACT_DEP_DT");
    	sql.append("\n			,	ACT_ARV_DT");
    	sql.append("\n			,	REGION_CD");
    	sql.append("\n			FROM ");
    	sql.append("\n				KFOS.FOQA_COMP_WPT_MASTER_T");
    	sql.append("\n			WHERE FIRST_LEG_FLT_DT >= TO_DATE('"+params.getStart_date()+"','YYMMDD')");
    	sql.append("\n			AND	FIRST_LEG_FLT_DT <= TO_DATE('"+params.getEnd_date()+"','YYMMDD')");
    	if(!params.getFlt_num().equals("")){
    		sql.append("\n			AND	FLT_NUM = '"+params.getFlt_num()+"'  ");
    	}
    	if(!params.getStn_fr().equals("")){
    		sql.append("\n			AND	STNFR = '"+params.getStn_fr()+"'  ");
    	}
    	if(!params.getStn_to().equals("")){
    		sql.append("\n			AND	STNTO = '"+params.getStn_to()+"'  ");
    	}
    	if(!params.getRegNo().equals("")){
    		sql.append("\n			AND	REGNO = 'HL"+params.getRegNo()+"'");
    	}
    	sql.append("\n			AND	 SEQ = '1'");
    	sql.append("\n		) A");
    	sql.append("\n	,	FLIGHT_PLAN_T B");
    	sql.append("\n	,	(");
    	sql.append("\n			SELECT");
    	sql.append("\n				FIRST_LEG_FLT_DT");
    	sql.append("\n			,	FLT_NUM");
    	sql.append("\n			,	SACTYP");
    	sql.append("\n			,	STNFR");
    	sql.append("\n			,	STNTO");
    	sql.append("\n			,	REGNO");
    	sql.append("\n			,	ACT_DEP_DT");
    	sql.append("\n			,	ACT_ARV_DT");
    	sql.append("\n			,	COUNT(*) CNT ");
    	sql.append("\n			FROM ");
    	sql.append("\n				KFOS.FOQA_MECH_INFLIGHT_T");
    	sql.append("\n			WHERE FIRST_LEG_FLT_DT >= TO_DATE('"+params.getStart_date()+"','YYMMDD')");
    	sql.append("\n			AND	FIRST_LEG_FLT_DT <= TO_DATE('"+params.getEnd_date()+"','YYMMDD')");
    	if(!params.getFlt_num().equals("")){
    		sql.append("\n			AND	FLT_NUM = '"+params.getFlt_num()+"'  ");
    	}
    	if(!params.getStn_fr().equals("")){
    		sql.append("\n			AND	STNFR = '"+params.getStn_fr()+"'  ");
    	}
    	if(!params.getStn_to().equals("")){
    		sql.append("\n			AND	STNTO = '"+params.getStn_to()+"'  ");
    	}
    	if(!params.getRegNo().equals("")){
    		sql.append("\n			AND	REGNO = 'HL"+params.getRegNo()+"'");
    	}
    	sql.append("\n			GROUP BY FIRST_LEG_FLT_DT,	FLT_NUM,  SACTYP,	STNFR,	STNTO,	REGNO,  ACT_DEP_DT, ACT_ARV_DT");
    	sql.append("\n		) C");
    	sql.append("\n	,	(");
    	sql.append("\n			SELECT");
    	sql.append("\n				FIRST_LEG_FLT_DT");
    	sql.append("\n				FIRST_LEG_FLT_DT");
    	sql.append("\n			,	FLT_NUM");
    	sql.append("\n			,	SACTYP");
    	sql.append("\n			,	STNFR");
    	sql.append("\n			,	STNTO");
    	sql.append("\n			,	REGNO");
    	sql.append("\n			,	ACT_DEP_DT");
    	sql.append("\n			,	ACT_ARV_DT");
    	sql.append("\n			,	SEQ");
    	sql.append("\n			FROM");
    	sql.append("\n				KFOS.FOQA_NOISE_ABATEMENT_T");
    	sql.append("\n			WHERE FIRST_LEG_FLT_DT >= TO_DATE('"+params.getStart_date()+"','YYMMDD')");
    	sql.append("\n			AND	FIRST_LEG_FLT_DT <= TO_DATE('"+params.getEnd_date()+"','YYMMDD')");
    	if(!params.getFlt_num().equals("")){
    		sql.append("\n			AND	FLT_NUM = '"+params.getFlt_num()+"'  ");
    	}
    	if(!params.getStn_fr().equals("")){
    		sql.append("\n			AND	STNFR = '"+params.getStn_fr()+"'  ");
    	}
    	if(!params.getStn_to().equals("")){
    		sql.append("\n			AND	STNTO = '"+params.getStn_to()+"'  ");
    	}
    	if(!params.getRegNo().equals("")){
    		sql.append("\n			AND	REGNO = 'HL"+params.getRegNo()+"'");
    	}
    	sql.append("\n			AND SEQ = '1'");
    	sql.append("\n		) D");
    	sql.append("\n	WHERE A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT");
    	sql.append("\n	AND A.FLT_NUM = B.FLT_NUM");
    	sql.append("\n	AND A.STNFR = B.STNFR");
    	sql.append("\n	AND A.STNTO = B.STNTO");
    	sql.append("\n	AND B.ACTIVE = 'Y'");
    	if(!params.getRoute().equals("")){
    		sql.append(" AND B.ROUTE = '"+params.getRoute()+"' \n");
    	}
    	sql.append("\n	AND A.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT(+)");
    	sql.append("\n	AND A.FLT_NUM = C.FLT_NUM(+)");
    	sql.append("\n	AND A.STNFR = C.STNFR(+)");
    	sql.append("\n	AND A.STNTO = C.STNTO(+)");
    	sql.append("\n	AND A.REGNO = C.REGNO(+)");
    	sql.append("\n	AND C.CNT(+) <= 10");
    	sql.append("\n	AND A.FIRST_LEG_FLT_DT = D.FIRST_LEG_FLT_DT(+)");
    	sql.append("\n	AND A.FLT_NUM = D.FLT_NUM(+)");
    	sql.append("\n	AND A.STNFR = D.STNFR(+)");
    	sql.append("\n	AND A.STNTO = D.STNTO(+)");
    	sql.append("\n	AND A.REGNO = D.REGNO(+)");
    	sql.append("\n	ORDER BY A.FIRST_LEG_FLT_DT, A.FLT_NUM, A.LEG_NUM ASC");
    	
    	
    	/*
    	sql.append(" SELECT TO_CHAR(A.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT ,A.FLT_NUM, A.SACTYP, A.REGNO, A.STNFR, A.STNTO, A.REGION_CD, \n");
    	sql.append("     TO_CHAR(A.ACT_DEP_DT,'YYMMDD HH24MI') ACT_DEP_DT,  \n");
    	sql.append("     TO_CHAR(A.ACT_ARV_DT,'YYMMDD HH24MI') ACT_ARV_DT,  \n");
    	sql.append("     B.ROUTE,  \n");//2012.08.27 : ROUTE ߰
    	sql.append("     DECODE(C.CNT,NULL,'N','Y') TURB_Y  \n");
    	sql.append(" FROM KFOS.FOQA_COMP_WPT_MASTER_T A, FLIGHT_PLAN_T B,  \n");//2012.08.27 : ROUTE˻  FLIGHT_PLAN_T ߰    	
    	sql.append("           (SELECT FIRST_LEG_FLT_DT, FLT_NUM, LEG_NUM, STNFR, STNTO, COUNT(*) CNT \n");
    	sql.append("            FROM KFOS.FOQA_MECH_INFLIGHT_T \n");
    	sql.append("            WHERE FIRST_LEG_FLT_DT >= TO_DATE('"+params.getStart_date()+"','YYMMDD')  \n");
    	sql.append("            AND FIRST_LEG_FLT_DT <= TO_DATE('"+params.getEnd_date()+"','YYMMDD')  \n");
    	if(!params.getFlt_num().equals("")){
    	    sql.append("        AND FLT_NUM = '"+params.getFlt_num()+"'  \n");
    	}
    	if(!params.getStn_fr().equals("")){
    	    sql.append("        AND STNFR = '"+params.getStn_fr()+"'  \n");
    	}
    	if(!params.getStn_to().equals("")){
    	    sql.append("        AND STNTO = '"+params.getStn_to()+"'  \n");
    	}
    	if(!params.getRegNo().equals("")){
    		sql.append("        AND REGNO = 'HL"+params.getRegNo()+"' \n");;
    	}
    	sql.append("            GROUP BY FIRST_LEG_FLT_DT, FLT_NUM, LEG_NUM, STNFR, STNTO) C\n"); 
    	sql.append(" WHERE A.FIRST_LEG_FLT_DT >= TO_DATE('"+params.getStart_date()+"','YYMMDD')  \n");
    	sql.append(" AND A.FIRST_LEG_FLT_DT <= TO_DATE('"+params.getEnd_date()+"','YYMMDD')  \n");
    	if(!params.getFlt_num().equals("")){
    	    sql.append(" AND A.FLT_NUM = '"+params.getFlt_num()+"'  \n");
    	}
    	if(!params.getStn_fr().equals("")){
    	    sql.append(" AND A.STNFR = '"+params.getStn_fr()+"'  \n");
    	}
    	if(!params.getStn_to().equals("")){
    	    sql.append(" AND A.STNTO = '"+params.getStn_to()+"'  \n");
    	}
    	if(!params.getRegNo().equals("")){
    		sql.append(" AND A.REGNO = 'HL"+params.getRegNo()+"' \n");;
    	}
    	if(!params.getRoute().equals("")){
    		sql.append(" AND B.ROUTE = '"+params.getRoute()+"' \n");
    	}
    	sql.append(" AND A.SEQ = '1'  \n");
    	sql.append(" AND B.ACTIVE='Y'  \n");
    	sql.append(" AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT  \n");
    	sql.append(" AND A.FLT_NUM = B.FLT_NUM  \n");
    	sql.append(" AND A.STNFR = B.STNFR  \n");
    	sql.append(" AND A.STNTO = B.STNTO  \n");
    	sql.append(" AND A.LEG_NUM = B.LEG_NUM  \n");
    	sql.append(" AND A.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT(+)  \n");
    	sql.append(" AND A.FLT_NUM = C.FLT_NUM(+)  \n");
    	sql.append(" AND A.STNFR = C.STNFR(+)  \n");
    	sql.append(" AND A.STNTO = C.STNTO(+)  \n");
    	sql.append(" AND A.LEG_NUM = C.LEG_NUM(+)  \n");
    	sql.append(" AND C.CNT(+) <= 10 \n");// TURBUENCE 10 ̻   ƴ
    	sql.append(" ORDER BY A.FIRST_LEG_FLT_DT, A.FLT_NUM, A.LEG_NUM ASC  \n");
    	*/
    	//System.out.println("[BASE:TrkQ010Query:selFlightTrackList] sql :  \n"+sql.toString());
		Logger.debug.println("[BASE:TrkQ010Query:selFlightTrackList] sql :  \n"+sql.toString());
    	
    	return sql.toString();
    }
    
    public String getCurrentDate(){
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append(" SELECT TO_CHAR(sysdate,'YYYY-MM-DD') currentTime FROM DUAL ");
    	
    	return sql.toString();
    }
    
    /*
     *  FOQA_FUEL_WPT_T  
     */
    public String selFoqa(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	//sql.append(" SELECT SEQ, FLT_NUM, FQ_TIME_R,  FQ_LATPC, FQ_LONPC, FQ_ALT_STDC  \n");
    	sql.append(" SELECT SEQ, FLT_NUM, FQ_TIME_R,  FQ_LATPC, FQ_LONPC, FQ_ALT_STDC*0.3048 FQ_ALT_STDC  \n");//2013-04-29
    	sql.append(" FROM KFOS.FOQA_FUEL_WPT_T  \n");
    	sql.append(" WHERE FIRST_LEG_FLT_DT =TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD')  \n");
    	sql.append(" AND FLT_NUM ='"+params.getFlt_num()+"'  \n");
    	sql.append(" AND STNFR = '"+params.getStn_fr()+"'  \n");
    	sql.append(" ORDER BY SEQ ASC  \n");
    	
    	//System.out.println("[BASE:TrkQ010Query:selFoqa] sql :  \n"+sql.toString());
		Logger.debug.println("[BASE:TrkQ010Query:selFoqa] sql :  \n"+sql.toString());
    	
    	return sql.toString();
    }
    
    public String selFoqa_mark(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append(" SELECT A.SEQ,\n");
    	sql.append("     DECODE(SIGN(B.TKOF_T-TO_CHAR(B.ACT_DEP_DT,'HH24MI')),-1,A.DIFF-(ROUND((TO_DATE(TO_CHAR(B.ACT_DEP_DT,'YYMMDD')||B.TKOF_T,'YYMMDDHH24MI')-B.ACT_DEP_DT)*1440,0))-1440, A.DIFF-(ROUND((TO_DATE(TO_CHAR(B.ACT_DEP_DT,'YYMMDD')||B.TKOF_T,'YYMMDDHH24MI')-B.ACT_DEP_DT)*1440,0))) DIFFF,\n");
    	sql.append("     A.FQ_LATPC, A.FQ_LONPC, A.FQ_ALT_STDC, A.FQ_DTTT, A.FQ_TAIL_WIND, A.FQ_TOTAL_BURN_LB, A.FQ_TEMP \n");
    	sql.append(" FROM (SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR, ACT_DEP_DT, SEQ, DECODE(SIGN(FQ_TIME_R-TO_CHAR(ACT_DEP_DT,'HH24MISS')),-1,DIFF+1440,DIFF) DIFF, FQ_LATPC, FQ_LONPC, FQ_ALT_STDC,\n");
    	sql.append("                 FQ_DTTT, FQ_TAIL_WIND, FQ_TOTAL_BURN_LB, FQ_TEMP \n");
    	sql.append("             FROM (SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR, ACT_DEP_DT, SEQ, FQ_TIME_R,\n");
    	sql.append("                             ROUND((TO_DATE(TO_CHAR(ACT_DEP_DT,'YYYYMMDD')||SUBSTR(TO_CHAR(FQ_TIME_R,'000000'),1,3)||SUBSTR(TO_CHAR(FQ_TIME_R,'000000'),4,2),'YYYYMMDDHH24MI')-ACT_DEP_DT)*1440,0) DIFF,\n");
    	sql.append("                             FQ_LATPC, TO_NUMBER((360-FQ_LONPC)*-1) FQ_LONPC, FQ_ALT_STDC, FQ_DTTT, ROUND(FQ_TAIL_WIND,3) FQ_TAIL_WIND, FQ_TOTAL_BURN_LB, FQ_TEMP,\n");
        sql.append("                             LAG(FQ_TIME_R,1) OVER (ORDER BY SEQ) AS FQ_TIME_R_BEF \n");
        sql.append("                         FROM KFOS.FOQA_FUEL_WPT_T \n");
        sql.append("                         WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD')\n");
        sql.append("                         AND FLT_NUM = '"+params.getFlt_num()+"' AND STNFR = '"+params.getStn_fr()+"' AND FQ_LONPC>180 \n");
        sql.append("                         UNION \n");
        sql.append("                         SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR, ACT_DEP_DT, SEQ, FQ_TIME_R, \n");
        sql.append("                             ROUND((TO_DATE(TO_CHAR(ACT_DEP_DT,'YYYYMMDD')||SUBSTR(TO_CHAR(FQ_TIME_R,'000000'),1,3)||SUBSTR(TO_CHAR(FQ_TIME_R,'000000'),4,2),'YYYYMMDDHH24MI')-ACT_DEP_DT)*1440,0) DIFF, \n");
        sql.append("                             FQ_LATPC, TO_NUMBER(FQ_LONPC) FQ_LONPC, FQ_ALT_STDC, FQ_DTTT, ROUND(FQ_TAIL_WIND,3) FQ_TAIL_WIND, FQ_TOTAL_BURN_LB, FQ_TEMP, \n");
        sql.append("                             LAG(FQ_TIME_R,1) OVER (ORDER BY SEQ) AS FQ_TIME_R_BEF \n");
        sql.append("                         FROM KFOS.FOQA_FUEL_WPT_T \n");
        sql.append("                         WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') \n");
        sql.append("                         AND FLT_NUM = '"+params.getFlt_num()+"' AND STNFR = '"+params.getStn_fr()+"' AND FQ_LONPC<=180)) A \n");
        sql.append("              , DAILY_SCH_T B \n");
        sql.append(" WHERE A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT \n");
        sql.append(" AND A.FLT_NUM = B.FLT_NUM \n");
        sql.append(" AND A.STNFR = B.STNFR \n");
        sql.append(" AND B.STNFR<>B.STNTO \n");
        sql.append(" ORDER BY SEQ ASC \n");
        
        //System.out.println("[BASE:TrkQ010Query:selFoqa_mark] sql :  \n"+sql.toString());
		Logger.debug.println("[BASE:TrkQ010Query:selFoqa_mark] sql :  \n"+sql.toString());
        
        return sql.toString();
    }
    
    public String selFoqa_plan(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	//sql.append(" SELECT SEQ, FLT_NUM, FPL_TIME, FPL_LAT, (360-FPL_LON) FPL_LON, DECODE(FPL_LEVEL,'CLB','CLB','DSC','DSC',FPL_LEVEL*100) FPL_LEVEL \n");
    	sql.append(" SELECT SEQ, FLT_NUM, FPL_TIME, FPL_LAT, (360-FPL_LON) FPL_LON, DECODE(FPL_LEVEL,'CLB','CLB','DSC','DSC',FPL_LEVEL*100*0.3048) FPL_LEVEL \n");//2013-04-29
    	sql.append(" FROM KFOS.FOQA_COMP_WPT_MASTER_T \n");
    	sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') \n");
    	sql.append(" AND FLT_NUM = '"+params.getFlt_num()+"' \n");
    	sql.append(" AND STNFR = '"+params.getStn_fr()+"' \n");
    	sql.append(" ORDER BY SEQ ASC \n");
    	
    	//System.out.println("[BASE:TrkQ010Query:selFoqa_plan] sql : \n"+sql.toString());
		Logger.debug.println("[BASE:TrkQ010Query:selFoqa_plan] sql : \n"+sql.toString());
		
    	return sql.toString();
    }
    
    public String selDataForFplLevel1(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	/*sql.append(" SELECT SEQ, FPL_LEVEL \n");
    	sql.append(" FROM KFOS.FOQA_COMP_WPT_MASTER_T \n");
    	sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') \n");
    	sql.append(" AND FLT_NUM = '"+params.getFlt_num()+"' \n");
    	sql.append(" AND STNFR ='"+params.getStn_fr()+"' \n");
    	sql.append(" AND FPL_LEVEL NOT LIKE 'CLB' \n ");
    	sql.append(" AND ROWNUM = 1 \n ");
    	sql.append(" ORDER BY SEQ ASC \n");*/
    	
    	//@2013-08-23
    	sql.append("	SELECT ");
    	sql.append("		SEQ");
    	sql.append("	,	FPL_LEVEL");
    	sql.append("	FROM");
    	sql.append("		(");
    	sql.append("			SELECT SEQ, FPL_LEVEL");
    	sql.append("			FROM KFOS.FOQA_COMP_WPT_MASTER_T");
    	sql.append("			WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD')");
    	sql.append("			AND FLT_NUM = '"+params.getFlt_num()+"'");
    	sql.append("			AND STNFR ='"+params.getStn_fr()+"'");
    	//2013-08-26 sql.append("			AND FPL_LEVEL NOT LIKE 'CLB'");
    	sql.append("			AND SUBSTR(FPL_LEVEL,1,1)  IN('0','1','2','3','4','5','6','7','8','9')");
    	sql.append("			ORDER BY SEQ ASC");
    	sql.append("		)");
    	sql.append("	WHERE ROWNUM = 1");
    	
    	//System.out.println("[BASE:TrkQ010Query:selDataForFplLevel] sql :  \n"+sql.toString());
		Logger.debug.println("[BASE:TrkQ010Query:selDataForFplLevel] sql : \n"+sql.toString());
    	
    	return sql.toString();
    }
    
    public String selSeq(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append("SELECT SEQ \n");
    	sql.append("FROM KFOS.FOQA_COMP_WPT_MASTER_T \n");
    	sql.append("WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') \n");
    	sql.append("AND FLT_NUM = '"+params.getFlt_num()+"' \n");
    	sql.append("AND STNFR = '"+params.getStn_fr()+"' \n");
    	sql.append("AND ROWNUM = 1 \n");
    	sql.append("ORDER BY SEQ DESC \n");
    	
    	//System.out.println("[BASE:TrkQ010Query:selSeq] sql : \n"+sql.toString());
		Logger.debug.println("[BASE:TrkQ010Query:selSeq] sql : \n"+sql.toString());
    	
    	return sql.toString();
    }
    
    public String selDataForFplLevel2(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	/*sql.append(" SELECT SEQ, FPL_LEVEL \n");
    	sql.append(" FROM KFOS.FOQA_COMP_WPT_MASTER_T \n");
    	sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') \n");
    	sql.append(" AND FLT_NUM = '"+params.getFlt_num()+"' \n");
    	sql.append(" AND STNFR ='"+params.getStn_fr()+"' \n");
    	sql.append(" AND FPL_LEVEL NOT LIKE 'DSC' \n ");
    	sql.append(" AND ROWNUM = 1 \n ");
    	sql.append(" ORDER BY SEQ DESC \n");*/
    	
    	//@2013-08-23
    	sql.append("	SELECT ");
    	sql.append("		SEQ");
    	sql.append("	,	FPL_LEVEL");
    	sql.append("	FROM");
    	sql.append("		(");
    	sql.append("			SELECT SEQ, FPL_LEVEL");
    	sql.append("			FROM KFOS.FOQA_COMP_WPT_MASTER_T");
    	sql.append("			WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD')");
    	sql.append("			AND FLT_NUM = '"+params.getFlt_num()+"'");
    	sql.append("			AND STNFR ='"+params.getStn_fr()+"'");
//    	2013-08-26 sql.append("			AND FPL_LEVEL NOT LIKE 'CLB'");
    	sql.append("			AND SUBSTR(FPL_LEVEL,1,1)  IN('0','1','2','3','4','5','6','7','8','9')");
    	sql.append("			ORDER BY SEQ DESC");
    	sql.append("		)");
    	sql.append("	WHERE ROWNUM = 1");
    	
    	//System.out.println("[BASE:TrkQ010Query:selDataForFplLevel] sql :  \n"+sql.toString());
		Logger.debug.println("[BASE:TrkQ010Query:selDataForFplLevel] sql : \n"+sql.toString());
    	
    	return sql.toString();
    }
    
    public String selPlanMark(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append("SELECT SEQ, FPL_TIME, WAYPOINT, FPL_DIST, FPL_LAT, (360-FPL_LON) FPL_LON, \n");
    	sql.append("             DECODE(FPL_LEVEL,'CLB','CLB','DSC','DSC','TIC','TIC',FPL_LEVEL*100) FPL_LEVEL, \n");
    	sql.append("             FPL_FBURN, TO_NUMBER(FPL_WINDCOMP) FPL_WINDCOMP, FPL_OT \n");
    	sql.append("FROM KFOS.FOQA_COMP_WPT_MASTER_T \n");
    	sql.append("WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') \n");
    	sql.append("AND FLT_NUM = '"+params.getFlt_num()+"' \n");
    	sql.append("AND STNFR = '"+params.getStn_fr()+"' \n");
    	sql.append("AND FPL_LON >= 180 \n");
    	sql.append("UNION \n");
    	sql.append("SELECT SEQ, FPL_TIME, WAYPOINT, FPL_DIST, FPL_LAT, -FPL_LON FPL_LON, \n");
    	sql.append("             DECODE(FPL_LEVEL,'CLB','CLB','DSC','DSC','TIC','TIC',FPL_LEVEL*100) FPL_LEVEL, \n");
    	sql.append("             FPL_FBURN, TO_NUMBER(FPL_WINDCOMP) FPL_WINDCOMP, FPL_OT \n");
    	sql.append("FROM  KFOS.FOQA_COMP_WPT_MASTER_T \n");
    	sql.append("WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') \n");
    	sql.append("AND FLT_NUM = '"+params.getFlt_num()+"' \n");
    	sql.append("AND STNFR = '"+params.getStn_fr()+"' \n");
    	sql.append("AND FPL_LON < 180 \n");
    	sql.append("ORDER BY SEQ ASC \n");
    	
    	//System.out.println("[BASE:TrkQ010Query:selPlanMark] sql : \n"+sql.toString());
		Logger.debug.println("[BASE:TrkQ010Query:selPlanMark] sql : \n"+sql.toString());
    	
    	return sql.toString();
    }
    
    public String selWptMasterTInfo(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append(" SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, REGNO, SACTYP, SEQ, WAYPOINT WPT_NAME, \n");
    	sql.append("     TO_CHAR(FPL_LEVEL*100) PLAN_WPT_ALT, FOQA_LEVEL FOQA_WPT_ALT, FPL_FBURN PLAN_WPT_FBURN, FOQA_FBURN FOQA_WPT_FBURN, \n");
    	sql.append("     FPL_WINDCOMP PLAN_WPT_WIND, FOQA_WINDCOMP FOQA_WPT_WIND, FPL_OT PLAN_WPT_TEMP, FOQA_OT FOQA_WPT_TEMP, \n");
    	sql.append("     FPL_DIST PLAN_WPT_DIST, FOQA_DIST FOQA_WPT_DIST, FPL_TIME PLAN_WPT_TIME, FOQA_TIME FOQA_WPT_TIME \n");
    	sql.append(" FROM KFOS.FOQA_COMP_WPT_MASTER_T \n");
    	sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') \n");
    	sql.append(" AND FLT_NUM = '"+params.getFlt_num()+"' \n");
    	sql.append(" AND STNFR = '"+params.getStn_fr()+"' \n");
    	sql.append(" AND STNTO = '"+params.getStn_to()+"' \n");
    	sql.append(" AND TRANSLATE(FPL_LEVEL, 'a-0123456789','a') IS NULL \n");
    	sql.append(" UNION \n");
    	sql.append(" SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, REGNO, SACTYP, SEQ, WAYPOINT WPT_NAME, \n");
    	sql.append("     FPL_LEVEL PLAN_WPT_ALT, FOQA_LEVEL FOQA_WPT_ALT, FPL_FBURN PLAN_WPT_FBURN, FOQA_FBURN FOQA_WPT_FBURN, \n");
    	sql.append("     FPL_WINDCOMP PLAN_WPT_WIND, FOQA_WINDCOMP FOQA_WPT_WIND, FPL_OT PLAN_WPT_TEMP, FOQA_OT FOQA_WPT_TEMP, \n");
    	sql.append("     FPL_DIST PLAN_WPT_DIST, FOQA_DIST FOQA_WPT_DIST, FPL_TIME PLAN_WPT_TIME, FOQA_TIME FOQA_WPT_TIME \n");
    	sql.append(" FROM KFOS.FOQA_COMP_WPT_MASTER_T \n");
    	sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') \n");
    	sql.append(" AND FLT_NUM = '"+params.getFlt_num()+"' \n");
    	sql.append(" AND STNFR = '"+params.getStn_fr()+"' \n");
    	sql.append(" AND STNTO = '"+params.getStn_to()+"' \n");
    	sql.append(" AND TRANSLATE(FPL_LEVEL, 'a-0123456789','a') IS  NOT NULL \n");
    	sql.append(" ORDER BY SEQ ASC \n");
    	
    	Logger.debug.println("[BASE:FfsA240Query:selDDHHMM] sql : "+sql.toString());
    	
    	return sql.toString();
    }
    
    public String selWptFuelTInfo(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append(" SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, REGNO, SACTYP, SEQ, \n");
    	sql.append("     FQ_ALT_STDC FOQA_ALT, FQ_TOTAL_BURN_LB FOQA_FBURN, \n");
    	sql.append("     FQ_TAIL_WIND FOQA_WIND, FQ_TEMP FOQA_TEMP, FQ_DTTT FOQA_DIST, FQ_TIME_R FOQA_TIME \n");
    	sql.append(" FROM KFOS.FOQA_FUEL_WPT_T \n");
    	sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') \n");
    	sql.append(" AND FLT_NUM = '"+params.getFlt_num()+"' \n");
    	sql.append(" AND STNFR = '"+params.getStn_fr()+"' \n");
    	sql.append(" AND STNTO = '"+params.getStn_to()+"' \n");
    	sql.append(" ORDER BY SEQ ASC \n");
    	
    	Logger.debug.println("[BASE:FfsA240Query:selDDHHMM] sql : "+sql.toString());
    	
    	return sql.toString();
    }
    
    public String selFoqaTurbulence(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	//sql.append("SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, REGNO, SACTYP, LAT, LON, INFLT_G, INFLT_G_ALT ");
    	sql.append("SELECT FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, REGNO, SACTYP, LAT, LON, INFLT_G, INFLT_G_ALT*0.3048 INFLT_G_ALT ");//2013-04-29
    	sql.append("FROM KFOS.FOQA_MECH_INFLIGHT_T ");
    	sql.append("WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirst_leg_flt_dt()+"','YYYYMMDD') ");
    	sql.append("AND FLT_NUM ='"+params.getFlt_num()+"' ");
    	sql.append("AND STNFR = '"+params.getStn_fr()+"' ");
    	sql.append("ORDER BY LAT, LON ASC ");
    	
    	//System.out.println(sql);
    	
    	return sql.toString();
    }
    
    public String selNoisePath(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	
		//sql.append("	SELECT SEQ, FLT_NUM, LATPC, LONPC, ALT_STDC");
		sql.append("	SELECT SEQ, FLT_NUM, LATPC, LONPC, ALT_STDC*0.3048 ALT_STDC ");//2013-04-29
		sql.append("	FROM KFOS.FOQA_NOISE_ABATEMENT_T");
    	sql.append("	WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirst_leg_flt_dt() + "','YYYYMMDD') ");// Date
    	sql.append("	AND FLT_NUM = '" + params.getFlt_num() + "' ");// FLT No.
    	sql.append("	AND STNFR = '" + params.getStn_fr() + "' ");//// Departure Airport
    	sql.append("	ORDER BY SEQ ASC");
    	
    	
    	//System.out.println(sql);
    	
    	return sql.toString();
    }
    public String selNoiseMrk(TrkQ010BG params){
    	StringBuffer sql = new StringBuffer();
    	
    	sql.append("	SELECT SACTYP, SEQ, TIME_R, LATPC, LONPC, ALT_STDC, RALTC, IASC, GSC, GWC, WIN_SPD, WIN_DIR, DTTT_A, EPR1C, TAIL_WIND, SAT, N11C, FLAPC, TOTAL_FBURN");
		sql.append("	FROM KFOS.FOQA_NOISE_ABATEMENT_T");
    	sql.append("	WHERE FIRST_LEG_FLT_DT = TO_DATE('" + params.getFirst_leg_flt_dt() + "','YYYYMMDD') ");// Date
    	sql.append("	AND FLT_NUM = '" + params.getFlt_num() + "' ");// FLT No.
    	sql.append("	AND STNFR = '" + params.getStn_fr() + "' ");//// Departure Airport
    	sql.append("	ORDER BY SEQ ASC");
    	
    	//System.out.println(sql);
    	
    	return sql.toString();
    }
}
