package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.iro.query.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * IRR/DSS IROPS Flight Status SQL 
  * @author Copyright (c) 2005/02/03 HIST  
  */  
public class IroA020Query {
	private static IroA020Query instance = new IroA020Query();
	
	public static IroA020Query getInstance() {
		return instance;
	}

	/** 
	  * IRR/DSS IROPS Flight Status Main ȸ SQLԼ.
	  * @param params IroA020BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String selMain(IroA020BG params) {
		StringBuffer sql = new StringBuffer();
		String deskX = StringUtil.checkString(params.getDesk_x());
		
		sql.append(" Select A.Flt_Num, A.Kactyp, A.Regno, B.Stnfr,  B.Stnto, To_Char(A.Sch_Dep_Dt,'DDMONYY') Sch_Dep_Dt,");
		sql.append("        	To_Char(A.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Tm, To_Char(A.Est_Dep_Dt,'hh24:mi') Est_Dep_Tm,");
		sql.append("        	B.Title_e, To_Char(A.First_Leg_Flt_Dt,'yyyymmdd') First_Leg_Flt_Dt,");
		sql.append("        	To_Char(A.Est_Dep_Dt,'yyyymmddhh24mi') Est_Dep_Dt, B.User_Id, B.Seq_Num");
		sql.append(" From Daily_Sch_T A , Irops_Sch_t B");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		if (!params.getStnfr().equals("")) {
			sql.append("       	(A.Stnfr = '"+params.getStnfr()+"'  Or");
			sql.append("       	 A.Stnto = '"+params.getStnfr()+"')  And");
		}
		//DOM/INT/CGO ȸ
		//sql.append(IroA010Query.getInstance().selDomIntQ(params.getDom_int_x()));
		if (deskX.equals("B") || deskX.equals("C")) {
			sql.append(IroA010Query.getInstance().selDomIntQ("INT"));
		} else if (deskX.equals("D") || deskX.equals("E")) {
			sql.append(IroA010Query.getInstance().selDomIntQ("DOM"));
		} else {
			sql.append(IroA010Query.getInstance().selDomIntQ(params.getDom_int_x()));
		}
		//sql.append("       		NVL(A.Region_Flt,'9') = '"+params.getRegion_flt()+"'  And"); //ڵ  ϳ 
		sql.append("       		A.First_Leg_Flt_Dt >= To_Date(To_Char(Sysdate-3,'yyyymmdd'),'yyyymmdd') And");
		sql.append("       		B.Complete_y = 'N'    And");
		sql.append("       		B.Option_Num = 1      And");
		sql.append("       		A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And");
		sql.append("       		A.Flt_Num = B.Flt_Num And");
		sql.append("       		A.Stnfr   = B.Stnfr   And");
		sql.append("       		A.Stnto   = B.STnto");
		sql.append(" Order By Est_Dep_Dt");		
		
		Logger.debug.println("[BASE:IroA020Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IRR/DSS IROPS Flight Status CONX PAX ȸ SQLԼ.
	  * @param params IroA020BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String selConxPax(IroA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select NVL(Sum(F_Book_Q + C_Book_Q + Y_Book_Q),0) Conx_Pax");
		sql.append(" From Base_Dcs_Trans_T");
		sql.append(" Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("        	Arln_Cd   = 'KE'       And");
		sql.append("        	Flt_Num   = '"+params.getFlt_num()+"'  And");
		sql.append("        	Stnfr     = '"+params.getStnfr()+"'    And");
		sql.append("        	Stnto     = '"+params.getStnto()+"'    And");
		sql.append("        	Dep_Arv_x = 'A'");
		
		Logger.debug.println("[BASE:IroA020Query:selConxPax] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS IROPS Flight Status Decision ȸ SQLԼ.
	  * @param params IroA020BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String selDecisionX(IroA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select NVL(Min(Decision_x),0) Decision_x");
		sql.append(" From Irops_Desk_T");
		sql.append(" Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("       		Flt_Num    = '"+params.getFlt_num()+"'   And");
		sql.append("       		Stnfr      = '"+params.getStnfr()+"'     And");
		sql.append("       		Stnto      = '"+params.getStnto()+"'    And");
		sql.append("       		Seq_num  = '"+params.getSeq_num()+"'");
		
		Logger.debug.println("[BASE:IroA020Query:selDecisionX] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * IRR/DSS IROPS Flight Status IROPS DESK  SQLԼ.
	  * @param params IroA020BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String delIropsDeskT(IroA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Delete Irops_Desk_T");
		sql.append(" Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append(" 			Flt_num = '"+params.getFlt_num()+"' And");
		sql.append(" 			Stnfr = '"+params.getStnfr()+"' And");
		sql.append(" 			Stnto = '"+params.getStnto()+"' And");
		sql.append(" 			Seq_Num = '"+params.getSeq_num()+"'");
		
		
		Logger.debug.println("[BASE:IroA020Query:delIropsDeskT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS IROPS Flight Status IROPS SCH  SQLԼ.
	  * @param params IroA020BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String delIropsSchT(IroA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Delete Irops_Sch_T");
		sql.append(" Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append(" 			Flt_num = '"+params.getFlt_num()+"' And");
		sql.append(" 			Stnfr = '"+params.getStnfr()+"' And");
		sql.append(" 			Stnto = '"+params.getStnto()+"' And");
		sql.append(" 			Seq_Num = '"+params.getSeq_num()+"'");
		
		
		Logger.debug.println("[BASE:IroA020Query:delIropsSchT] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * IRR/DSS IROPS Flight Status IROPS TAG  SQLԼ.
	  * @param params IroA020BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String updCompleteY(IroA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Update Irops_Sch_T");
		sql.append(" Set Complete_y = 'Y'");
		sql.append(" Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append(" 			Flt_num = '"+params.getFlt_num()+"' And");
		sql.append(" 			Stnfr = '"+params.getStnfr()+"' And");
		sql.append(" 			Stnto = '"+params.getStnto()+"' And");
		sql.append(" 			Seq_Num = '"+params.getSeq_num()+"' And");
		sql.append(" 			Complete_y = 'X'");
		
		
		Logger.debug.println("[BASE:IroA020Query:updCompleteY] sql : "+sql.toString());
		return sql.toString();
	}	
	
}//end of class

