package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * IRR/DSS Option Comparison SQL 
  * @author Copyright (c) 2005/02/03 HIST  
  */  
public class IroA030Query {
	private static IroA030Query instance = new IroA030Query();
	
	public static IroA030Query getInstance() {
		return instance;
	}
	
	/** 
	  * IRR/DSS Option Comparison Date Info ȸ SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String selDateInfo(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		if (params.getMode().equals("NEW")) {
			//űԷ 
			sql.append(" Select Flt_Num,To_Char(Sch_Dep_Dt,'DDMONYY') Sch_Dep_Dt");
			sql.append(" From Bs_New_Sch_t");
			sql.append(" Where Arln_Cd = 'KE' And");
			sql.append("       		First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
			sql.append("       		Flt_Num = '"+params.getFlt_num()+"'   And");
			sql.append("       		Stnfr   = '"+params.getStnfr()+"'     And");
			sql.append("       		Stnto   = '"+params.getStnto()+"'");
		} else {
			//
			sql.append(" Select Flt_Num,To_Char(Sch_Dep_Dt,'DDMONYY') Sch_Dep_Dt");
			sql.append(" From Daily_Sch_T");
			sql.append(" Where Arln_Cd = 'KE' And");
			sql.append("       		First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
			sql.append("       		Flt_Num = '"+params.getFlt_num()+"'   And");
			sql.append("       		Stnfr   = '"+params.getStnfr()+"'     And");
			sql.append("       		Stnto   = '"+params.getStnto()+"'");
		}
		
		Logger.debug.println("[BASE:IroA030Query:selDateInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Option Comparison Flight Info ȸ SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String selFlightInfo(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		if (params.getMode().equals("NEW")) {
			//űԷ 
			sql.append(" Select Kactyp, Regno, Stnfr, Stnto, Leg_Num, '' Region_Flt, '' Region_Leg,");
			sql.append("        	To_Char(Sch_Dep_Dt,'hh24:mi') Sch_Dep_Tm, To_Char(Sch_Arv_Dt,'hh24:mi') Sch_Arv_Tm,");
			sql.append("        	'' Est_Dep_Tm,'' Cfg_Q, '' Book_Q, '' Chkin_Q");
			sql.append(" From Bs_New_Sch_t");
			sql.append(" Where Arln_Cd = 'KE' And");
			sql.append("       		First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
			sql.append("       		Flt_Num = '"+params.getFlt_num()+"'   And");
			sql.append("       		Stnfr   = '"+params.getStnfr()+"'     And");
			sql.append("       		Stnto   = '"+params.getStnto()+"'");
		} else {
			//
			sql.append(" Select Kactyp, Regno, Stnfr, Stnto, Leg_Num, Region_Flt, Region_Leg,");
			sql.append("        	To_Char(Sch_Dep_Dt,'hh24:mi') Sch_Dep_Tm, To_Char(Sch_Arv_Dt,'hh24:mi') Sch_Arv_Tm,");
			sql.append("        	To_Char(Est_Dep_Dt,'hh24:mi') Est_Dep_Tm,");
			sql.append("        	Nvl(F_Cfg,0)||'/'||Nvl(C_Cfg,0)||'/'||Nvl(Y_Cfg,0) Cfg_Q,");
			sql.append("        	Nvl(F_Book,0)||'/'||Nvl(C_Book,0)||'/'||Nvl(Y_Book,0) Book_Q,");
			sql.append("        	Nvl(F_Chkin,0)||'/'||Nvl(C_Chkin,0)||'/'||Nvl(Y_Chkin,0) Chkin_Q");
			sql.append(" From Daily_Sch_T");
			sql.append(" Where Arln_Cd = 'KE' And");
			sql.append("       		First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
			sql.append("       		Flt_Num = '"+params.getFlt_num()+"'   And");
			sql.append("       		Stnfr   = '"+params.getStnfr()+"'     And");
			sql.append("       		Stnto   = '"+params.getStnto()+"'");
		}
		
		//Logger.debug.println("[BASE:IroA030Query:selFlightInfo] sql : "+sql.toString());
		System.out.println("[BASE:IroA030Query:selFlightInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IRR/DSS Option Comparison IROPS Info ȸ SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String selIropsInfo(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select A.Seq_Num, A.Option_Num, A.Title_x, A.Title_e, B.Desk_x, B.Decision_x");
		sql.append("  From Irops_Sch_t A, Irops_Desk_T B");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		sql.append("       A.First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"' ,'yyyymmdd') And");
		sql.append("       A.Flt_Num = '"+params.getFlt_num()+"'   And");
		sql.append("       A.Stnfr   = '"+params.getStnfr()+"'     And");
		sql.append("       A.Stnto   = '"+params.getStnto()+"'     And");
		//sql.append("       A.Complete_y = 'N'     And");
		sql.append("       A.Complete_y In ('H','N')     And");
		sql.append("       A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And");
		sql.append("       A.Flt_Num    = B.Flt_Num    And");
		sql.append("       A.Stnfr      = B.Stnfr      And");
		sql.append("       A.Stnto      = B.STnto      And");
		sql.append("       A.Seq_Num    = B.Seq_Num    And");
		sql.append("       A.Option_Num = B.Option_Num");
		sql.append("  Order By 2, 4");
		
		Logger.debug.println("[BASE:IroA030Query:selIropsInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Option Comparison IROPS Info ȸ SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String selIropsHold(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Complete_y");
		sql.append("  From Irops_Sch_t");
		sql.append(" Where Arln_Cd = 'KE' And");
		sql.append("       		First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"' ,'yyyymmdd') And");
		sql.append("       		Flt_Num = '"+params.getFlt_num()+"'   And");
		sql.append("       		Stnfr   = '"+params.getStnfr()+"'     And");
		sql.append("       		Stnto   = '"+params.getStnto()+"'     And");
		sql.append("       		Seq_Num    = '"+params.getSeq_num()+"' And");
		sql.append("			Option_Num = '1'");
		
		Logger.debug.println("[BASE:IroA030Query:selIropsHold] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Option Comparison IROPS Info ȸ SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String selCompleteY(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Complete_y");
		sql.append("  From Irops_Sch_t");
		sql.append(" Where Arln_Cd = 'KE' And");
		sql.append("       First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"' ,'yyyymmdd') And");
		sql.append("       Flt_Num = '"+params.getFlt_num()+"'   And");
		sql.append("       Stnfr   = '"+params.getStnfr()+"'     And");
		sql.append("       Stnto   = '"+params.getStnto()+"'");
		
		Logger.debug.println("[BASE:IroA030Query:selCompleteY] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * IRR/DSS Option Comparison Option Suggest Max Option No ȸ SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/05 HIST 
	  */
	public String selMaxSeq(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Nvl(Max(Option_Num),0) Max_Option");
		sql.append(" From Irops_Sch_t");
		sql.append(" Where First_Leg_Flt_Dt = To_date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("       		Flt_Num = '"+params.getFlt_num()+"' And");
		sql.append("       		Stnfr = '"+params.getStnfr()+"' And");
		sql.append("       		Stnto = '"+params.getStnto()+"' And");
		sql.append("       		Seq_Num = '"+params.getSeq_num()+"'");
		
		Logger.debug.println("[BASE:IroA030Query:selMaxSeq] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * IRR/DSS Option Comparison IROPS_SCH_T Է SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/05 HIST 
	  */
	public String insIropsSchT(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Insert Into Irops_Sch_T");
		sql.append("  Values (To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd'),'KE','"+params.getFlt_num()+"','"+params.getStnfr()+"', '"+params.getStnto()+"',");
		sql.append("               '"+params.getLeg_num()+"', '"+params.getSeq_num()+"', '"+params.getOption_num()+"','"+params.getTitle_x()+"','"+StringUtil.DBInsStr(params.getTitle_e())+"', 'X', ' ', ' ', 'N', 'N',");
		sql.append("               '"+params.getRegion_flt()+"', '"+params.getRegion_leg()+"', '"+params.getEmp_no()+"', null,null,null,'X',null,Sysdate,Sysdate)"); //==> 2006.1.4  
		
		Logger.debug.println("[BASE:IroA030Query:insIropsSchT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Option Comparison IROPS_DESK_T Է SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/05 HIST 
	  */
	public String insIropsDeskT(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Insert Into Irops_Desk_T");
		sql.append(" Values (To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd'),'KE','"+params.getFlt_num()+"','"+params.getStnfr()+"', '"+params.getStnto()+"','"+params.getSeq_num()+"', '"+params.getOption_num()+"',");
		sql.append("         '"+params.getDesk_x()+"', '4', ' ', ' ', ' ', Sysdate)");
		
		Logger.debug.println("[BASE:IroA030Query:insIropsDeskT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Option Comparison Comment ȸ SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/05 HIST 
	  */
	public String selComments(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select A.Desk_x, C.Code_x, B.Kor_n, To_Char(A.TimeStamp,'hh24:mi:ss') TimeStamp, A.Decision_x, A.Decision_e");
		sql.append("  From Irops_Desk_T A, Password_T B, Code_T C");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		sql.append("       		A.First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("       		A.Flt_Num = '"+params.getFlt_num()+"'   And");
		sql.append("       		A.Stnfr   = '"+params.getStnfr()+"'     And");
		sql.append("       		A.Stnto   = '"+params.getStnto()+"'     And");
		sql.append("       		A.Seq_Num = '"+params.getSeq_num()+"'   And");
		sql.append("       		A.Option_Num = '"+params.getOption_num()+"'   And");
		sql.append("       		A.User_Id    = B.Emp_no(+)   And");
		sql.append("       		A.Desk_x     = C.Desc_e      And");
		sql.append("       		C.Step_x     = '0'           And");
		sql.append("       		C.Code_c     = 'Head'        And");
		sql.append("       		C.Use_y      = 'N'           And");
		sql.append("       		C.End_d      >= To_Char(Sysdate,'yyyymmdd')");
		sql.append("  Order By 1,2,3");
		
		Logger.debug.println("[BASE:IroA030Query:selComments] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Option Comparison CheckList Item ȸ SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/05 HIST 
	  */
	public String selCheckList(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Desc_e");
		sql.append(" From Code_t");
		sql.append(" Where Step_x = '1' And");
		sql.append("       Use_y = 'N' And");
		sql.append("       UPPER(Code_x) = UPPER('"+params.getCode_x()+"') And");
		sql.append("       End_d > To_Char(Sysdate,'yyyymmdd') And");
		sql.append("       Code_c like '"+params.getTitle_x()+"%'");
		sql.append(" Order By Prty_no");
		
		Logger.debug.println("[BASE:IroA030Query:selCheckList] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * IRR/DSS Option Comparison Item Check  ȸ SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/05 HIST 
	  */
	public String selCheckFlag(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select CheckList_e");
		sql.append(" From Irops_Desk_T");
		sql.append(" Where Arln_Cd = 'KE' And");
		sql.append("       First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And ");
		sql.append("       Flt_Num = '"+params.getFlt_num()+"' And");
		sql.append("       Stnfr       = '"+params.getStnfr()+"'       And");
		sql.append("       Stnto       = '"+params.getStnto()+"'       And");
		sql.append("       Seq_Num   = '"+params.getSeq_num()+"'    And");
		sql.append("       Option_Num = '"+params.getOption_num()+"' And");
		sql.append("       Desk_x = '"+params.getDesk_x()+"'");
		
		Logger.debug.println("[BASE:IroA030Query:selCheckFlag] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * IRR/DSS Option Comparison Comment  SQLԼ.
	  * @param params IroA030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/02/05 HIST 
	  */
	public String updComments(IroA030BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Update Irops_Desk_t");
		sql.append(" Set 	Decision_x = '"+params.getDecision_x()+"',");
		sql.append("     	Decision_e = '"+StringUtil.DBInsStr(params.getDecision_e())+"',");
		sql.append("     	Checklist_e = '"+StringUtil.DBInsStr(params.getChecklist_e())+"',");
		sql.append("     	User_Id = '"+params.getEmp_no()+"',");
		sql.append("     	Timestamp = Sysdate");
		sql.append(" Where First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') And");
		sql.append("       		Arln_Cd = 'KE' ANd");
		sql.append("       		Flt_num = '"+params.getFlt_num()+"' And");
		sql.append("       		Stnfr = '"+params.getStnfr()+"' And");
		sql.append("       		Stnto = '"+params.getStnto()+"' And");
		sql.append("       		Seq_Num = '"+params.getSeq_num()+"' And");
		sql.append("       		Option_Num = '"+params.getOption_num()+"' And");
		sql.append("       		Desk_x = '"+params.getDesk_x()+"'");
		
		Logger.debug.println("[BASE:IroA030Query:updComments] sql : "+sql.toString());
		return sql.toString();
	}			
}//end of class
