package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * IROPS Issue SQL 
  * @author Copyright (c) 2009/07/13  
  */   
public class IroA310Query {
	private static IroA310Query instance = new IroA310Query();
	
	public static IroA310Query getInstance() {
		return instance;
	}
	
	/** 
	  * IROPS Desk Select Code ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/13 
	  */
	public String selDeskCode() {
		StringBuffer sql = new StringBuffer();
				
		sql.append(" SELECT CODE_X, DESC_E ");
		sql.append(" FROM CODE_T");
		sql.append(" WHERE STEP_X = '0' ");
		sql.append(" AND USE_Y = 'N'	");
		sql.append(" AND DESC_E NOT IN ('D','E') "); //2010.02.01 ߰ : SKDR, DISP /  (D,E )
		//sql.append(" AND END_D > TO_CHAR(SYSDATE,'YYYYMMDD')");
		sql.append(" ORDER BY PRTY_NO");
		
		//Logger.debug.println("[BASE:IroA310Query:selDeskCode] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS Issue Search SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/13 
	  */
	public String searchSkd(String end_tm, String dom_int_x, String stn, String flt, String acreg) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT TO_CHAR(A.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, A.FLT_NUM, A.STNFR, A.STNTO, A.LEG_NUM, A.REGNO, ");
		sql.append(" TO_CHAR(A.SCH_DEP_DT,'YYYYMMDDHH24MI') SCH_DEP, ");
		sql.append(" TO_CHAR(A.SCH_DEP_DT,'MMDD') SCH_DT, ");
		sql.append(" TO_CHAR(A.SCH_DEP_DT,'HH24:MI') STD, ");
		sql.append(" TO_CHAR(A.SCH_ARV_DT,'HH24:MI') STA, ");
		sql.append(" TO_CHAR(A.EST_DEP_DT, 'HH24:MI') ETD, ");
		sql.append(" A.F_BOOK + A.C_BOOK + A.Y_BOOK BOOK, ");
		sql.append(" A.F_CFG + A.C_CFG + A.Y_CFG CFG, ");
		sql.append(" A.KACTYP, NVL(B.COMMENT_X,'') COMMENT_X, NVL(B.PROCESS_X,'X') PROCESS_X ");
		sql.append(" FROM DAILY_SCH_T A, ");
		sql.append(" 		(SELECT C.ARLN_CD, C.FIRST_LEG_FLT_DT, C.FLT_NUM, C.STNFR, C.STNTO, C.COMMENT_X, D.PROCESS_X, D.TIMESTAMP ");
		sql.append(" 		FROM DSS_IROPS_SCH_T C, DSS_IROPS_T D ");
		sql.append(" 		WHERE C.ARLN_CD = 'KE' ");
		sql.append(" 		AND C.FIRST_LEG_FLT_DT >= SYSDATE - 3 ");
		sql.append(" 		AND C.FIRST_LEG_FLT_DT <= SYSDATE +1 ");
		sql.append(" 		AND D.PROCESS_X IN ('A','M') ");
		sql.append(" 		AND C.DSS_START_DT = D.DSS_START_DT ");
		sql.append(" 		AND C.SEQ_NUM = D.SEQ_NUM) B ");
		sql.append(" WHERE A.ARLN_CD = 'KE' ");
		sql.append(" AND SUBSTR(A.FLT_NUM,1,1) <> '4' "); // 
		
		//1. ð ȸ 
		if (end_tm.equals("99")) { //In FLT 
			sql.append(" AND A.EST_DEP_DT >= SYSDATE - 3 ");
			sql.append(" AND A.EST_DEP_DT <= SYSDATE - 7/24 ");
			sql.append(" AND A.DEP_STS = 'ACT' ");
			sql.append(" AND A.ARV_STS IN ('SCH','EST') ");
		
		} else {
			sql.append(" AND A.EST_DEP_DT >= SYSDATE - 6/24 - 9/24 "); //2010.02.08  : 3/24 => 6/24
			sql.append(" AND A.EST_DEP_DT <= SYSDATE + "+end_tm+"/24 - 9/24 ");
			sql.append(" AND A.DEP_STS IN ('SCH','EST') ");
		}
		
		sql.append(" AND A.ACTNID <> 'CNL' ");
		sql.append(" AND A.ARLN_CD = B.ARLN_CD(+) ");
		sql.append(" AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT(+) ");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM(+) ");
		sql.append(" AND A.STNFR = B.STNFR(+) ");
		sql.append(" AND A.STNTO = B.STNTO(+) ");
		
		//2.  (DOM/INT/CGO) ȸ 
		sql.append(IroA310Query.getInstance().selDomIntQ(dom_int_x));
		
		//3. STN ȸ 
		if (!stn.equals("")) {
			sql.append(" AND (A.STNFR IN("+stn+") OR A.STNTO IN("+stn+")) ");
		}
		
		//4. FLT ȸ 
		if (!flt.equals("")) {
			sql.append(" AND A.FLT_NUM IN("+flt+") ");
		}
		
		//5. ACREG ȸ 
		if (!acreg.equals("")) {
			sql.append(" AND A.REGNO IN("+acreg+") ");
		}
		
		sql.append(" ORDER BY A.SCH_DEP_DT, A.FLT_NUM, A.STNFR, A.STNTO, B.TIMESTAMP ");
		
		System.out.println("[BASE:IroA310Query:searchSkd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DOM/INT/CGO Query ȸԼ.
	  *  ǿ ´ Query Ѵ
	  * @param domIntX String 
	  * @return String Query 
	  * @author Copyright (c) 2009/07/15 
	  */
	public String selDomIntQ(String domIntX) {

		StringBuffer sql = new StringBuffer();
		if (domIntX != null && domIntX.length() != 0)
			domIntX = domIntX.toUpperCase();
		else 
			domIntX = StringUtil.checkString(domIntX);
		
		if (domIntX.equals("DOM")) {
			sql.append(" AND SUBSTR(A.FLT_NUM,1,1) = '1' ");
			
		} else if (domIntX.equals("INT")) {
			sql.append(" AND NOT (SUBSTR(A.FLT_NUM,1,1) = '1' ");
			sql.append(" OR A.KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F','74N','77X')) "); //2010.03.26 ߰ : 74F, 2012.02.21 ߰ : 74N, 77X
			
		} else if (domIntX.equals("CGO")) {
			sql.append(" AND SUBSTR(A.FLT_NUM,1,1) <> '1' ");
			sql.append(" AND A.KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F','74N','77X') "); //2010.03.26 ߰ : 74F, 2012.02.21 ߰ : 74N, 77X
			
		} else {
			sql.setLength(0);
		}
		
		return sql.toString();
	}
	
	/** 
	  * IROPS FLT 1 ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/14 
	  */
	public String iropsFlt1(IroA310BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.TITLE_E, C.FLT_NUM, TO_CHAR(C.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, C.SEQ_NUM ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_DESK_T B, DSS_IROPS_SCH_T C ");
		//sql.append(" WHERE A.DSS_START_DT >= SYSDATE - 3 "); //2010.06.23  : 3 -> 10 
		sql.append(" WHERE A.DSS_START_DT >= SYSDATE - 10 ");
		sql.append(" AND A.DSS_START_DT <= SYSDATE + 1/24 ");
		sql.append(" AND A.PROCESS_X = 'I' ");
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = B.SEQ_NUM ");
		sql.append(" AND B.DECISION_X >= '3' ");
		sql.append(" AND A.DSS_START_DT = C.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = C.SEQ_NUM ");
		sql.append(" AND B.DESK_X = '"+params.getDeskX()+"' ");
		sql.append(" ORDER BY C.DSS_START_DT ");
		
		//System.out.println("[BASE:IroA310Query:iropsFlt1] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS FLT 2 ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/14 
	  */
	public String iropsFlt2(IroA310BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.TITLE_E, C.FLT_NUM, TO_CHAR(C.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, C.SEQ_NUM ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T C ");
		//sql.append(" WHERE A.DSS_START_DT >= SYSDATE - 3 "); //2010.06.23  : 3 -> 10 
		sql.append(" WHERE A.DSS_START_DT >= SYSDATE - 10 ");
		sql.append(" AND A.DSS_START_DT <= SYSDATE + 1/24 ");
		sql.append(" AND A.PROCESS_X = 'A' ");
		sql.append(" AND A.DSS_START_DT = C.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = C.SEQ_NUM ");
		sql.append(" ORDER BY C.DSS_START_DT ");
		
		//System.out.println("[BASE:IroA310Query:iropsFlt2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS FLT  PROCESS_X ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/24 
	  */
	public String chkIropsFlt(IroA310BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT PROCESS_X "); 
		sql.append(" FROM DSS_IROPS_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		
		System.out.println("[BASE:IroA310Query:chkIropsFlt] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * KACTYP ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/17 
	  */
	public String selKactyp(String regno) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT B.KACTYP ");
		sql.append(" FROM CM_REGNO_T A, CM_ACTYP_T B ");
		sql.append(" WHERE A.REGNO = '"+regno+"' ");
		sql.append(" AND A.KACTYP = B.KACTYP ");
		
		System.out.println("[BASE:IroA310Query:selKactyp] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IATA_PORT ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/17 
	  */
	public String selIataPort(String iata_port) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT COUNT(*) CNT ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE IATA_PORT = '"+iata_port+"' ");
		
		System.out.println("[BASE:IroA310Query:selIataPort] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DAILY_SCH_T ϴ ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/17 
	  */
	public String selDailySchT(IroA310BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT COUNT(*) CNT ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND STNFR = '"+params.getStnfr()+"' ");
		sql.append(" AND STNTO = '"+params.getStnto()+"' ");
		sql.append(" AND ACTNID <> 'CNL' ");
		
		System.out.println("[BASE:IroA310Query:selDailySchT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * New Flight Schedule DSS_NEW_SCH_T Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/17 
	  */
	public String insDssNewSchT(IroA310BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO DSS_NEW_SCH_T (FIRST_LEG_FLT_DT, ARLN_CD, FLT_NUM, LEG_NUM, STNFR, ");
		sql.append(" STNTO, SCH_DEP_DT, SCH_ARV_DT, ");
		sql.append(" KACTYP, REGNO, ROUTE_X, EXPIRE_Y, TIMESTAMP) ");
		sql.append(" VALUES (TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD'), 'KE', '"+params.getFltNum()+"', "+params.getLegNum()+", '"+params.getStnfr()+"', ");
		sql.append(" '"+params.getStnto()+"', TO_DATE('"+params.getStd()+"','YYYYMMDDHH24MI'), TO_DATE('"+params.getSta()+"','YYYYMMDDHH24MI'), ");
		sql.append(" '"+params.getActyp()+"', '"+params.getRegno()+"', '"+params.getDomIntX()+"', 'N', SYSDATE) ");
		
		System.out.println("[BASE:IroA310Query:insDssNewSchT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  *     ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/20 
	  */
	public String chkIssued(IroA310BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT COUNT(*) CNT ");
		sql.append(" FROM DSS_IROPS_SCH_T A, DSS_IROPS_T B ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND A.FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND A.STNFR = '"+params.getStnfr()+"' ");
		sql.append(" AND A.STNTO = '"+params.getStnto()+"' ");
		sql.append(" AND B.PROCESS_X = 'I' ");
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = B.SEQ_NUM ");
	
		System.out.println("[BASE:IroA310Query:chkIssued] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_IROPS_T  PROCESS_X Ȯ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/22 
	  */
	public String chkProcessX(IroA310BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT SEQ_NUM, PROCESS_X, KOR_N ");
		sql.append(" FROM DSS_IROPS_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" ORDER BY SEQ_NUM DESC ");
		
		System.out.println("[BASE:IroA310Query:chkProcessX] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MSG_NO ϱ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/22 
	  */
	public String selMsgNo(IroA310BG params, String msgNo, String lvlNo) {
		StringBuffer sql = new StringBuffer();
				
		if (lvlNo.equals("0")) {
			sql.append(" SELECT LTRIM(TO_CHAR(TO_NUMBER(NVL(MAX(MSG_NO),'00')) + 1,'00')) TMP_MSG_NO ");
		} else {
			sql.append(" SELECT SUBSTR(TO_NUMBER(NVL(MAX(MSG_NO),'100')) + 1,LENGTH(TO_NUMBER(NVL(MAX(MSG_NO),'100')) + 1)-1, 2) TMP_MSG_NO ");  
		}
		sql.append(" FROM DSS_MSG_DETAIL_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		
		if (lvlNo.equals("0")) {
			
			sql.append(" AND MSG_NO BETWEEN '01' AND '99' ");
			sql.append(" AND LVL_NO = 1 ");
			
		} else {
			int intLvlNo = Integer.parseInt(lvlNo) + 1;
			
			sql.append(" AND MSG_NO BETWEEN '"+msgNo+"'||'01' AND '"+msgNo+"'||'99' ");
			sql.append(" AND LVL_NO = "+intLvlNo);
		}
		
		System.out.println("[BASE:IroA310Query:selMsgNo] sql : "+sql.toString());
		return sql.toString();
	}
	
	
	/** 
	  * DSS_MSG_DETAIL_T TIMESTAMP ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/22 
	  */
	public String selTimestamp(String dssStartDt) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT  TO_CHAR(TIMESTAMP,'YYYYMMDDHH24MISS') TIMESTAMP ");
		sql.append(" FROM DSS_MSG_DETAIL_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+dssStartDt+"','YYYYMMDDHH24MISS') "); 
		sql.append(" ORDER BY TIMESTAMP DESC ");
		
		System.out.println("[BASE:IroA310Query:selTimestamp] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_START_DT    ð ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/20 
	  */
	public String selDssStartDt() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SYSDATE, 'YYYYMMDDHH24MISS') DSS_START_DT1, ");
		sql.append(" TO_CHAR(SYSDATE + 1/(24*60*60), 'YYYYMMDDHH24MISS') DSS_START_DT2, ");
		sql.append(" TO_CHAR(SYSDATE + 2/(24*60*60), 'YYYYMMDDHH24MISS') DSS_START_DT3 ");
		sql.append(" FROM DUAL ");
		
		System.out.println("[BASE:IroA310Query:selDssStartDt] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_START_DT  ϴ üũ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/20 
	  */
	public String chkDssStartDt(String table, String dss_start_dt) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DSS_START_DT FROM "+table); //DSS_IROPS_T Ǵ DSS_MSG_HEAD_T
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+dss_start_dt+"','YYYYMMDDHH24MISS') ");
		
		System.out.println("[BASE:IroA310Query:chkDssStartDt] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SYSDATE پ  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/21 
	  */
	public String getSysdate(String diff, String format) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SYSDATE "+diff+", '"+format+"') SYSDT FROM DUAL "); 
		
		System.out.println("[BASE:IroA310Query:getSysdate] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_MSG_HEAD_T Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/21 
	  */
	public String insDssMsgHeadT(IroA310BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO DSS_MSG_HEAD_T (DSS_START_DT, TITLE_E, FLT_NUM, SCH_DEP_D, DSS_LINK_X, DSS_COMPLETE_Y) ");
		sql.append(" VALUES (TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS'), '"+params.getTitleE()+"', '', '', 'L', 'N') ");
		
		System.out.println("[BASE:IroA310Query:insDssMsgHeadT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_MSG_HEAD_T  SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/21 
	  */
	public String updDssMsgHeadT(IroA310BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE DSS_MSG_HEAD_T ");
		sql.append(" SET DSS_LINK_X = 'L', ");
		sql.append(" DSS_COMPLETE_Y = 'N' ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		
		System.out.println("[BASE:IroA310Query:updDssMsgHeadT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_MSG_DETAIL_T Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/21 
	  */
	public String insDssMsgDetailT(IroA310BG params, String msgNo, String lvlNo) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO DSS_MSG_DETAIL_T (DSS_START_DT, MSG_NO, LVL_NO, DESK_X, MSG_E, USER_ID, KOR_N, DSS_LVL_X, TIMESTAMP) ");
		sql.append(" VALUES (TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS'), '"+msgNo+"', "+lvlNo+", ");
		sql.append(" '"+params.getDeskX()+"', '"+params.getTitleE()+"', '"+params.getEmpNo()+"', '"+params.getKorN()+"', 'I', SYSDATE) ");
		
		System.out.println("[BASE:IroA310Query:insDssMsgDetailT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_IROPS_T Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/21 
	  */
	public String insDssIropsT(IroA310BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO DSS_IROPS_T (DSS_START_DT, SEQ_NUM, TITLE_E, ");
		sql.append(" DECISION_E, PROCESS_X, USER_ID, KOR_N, IROPS_DT, DSS_DT, MSG_DT, TIMESTAMP) ");
		sql.append(" VALUES (TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS'), "+params.getSeqNum()+", '"+params.getTitleE()+"', ");
		sql.append(" '', 'I', '"+params.getEmpNo()+"', '"+params.getKorN()+"', TO_DATE('"+params.getIropsDt()+"','YYYYMMDDHH24MISS'), ");
		sql.append(" TO_DATE('"+params.getIropsDt()+"','YYYYMMDDHH24MISS'), TO_DATE('"+params.getIropsDt()+"','YYYYMMDDHH24MISS'), SYSDATE) ");
		
		System.out.println("[BASE:IroA310Query:insDssIropsT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_IROPS_SCH_T Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/21 
	  */
	public String insDssIropsSchT(String dss_start_dt, String seq_num, IroA310BG params) {
		StringBuffer sql = new StringBuffer();
		
		String hideY = "N";
		if (params.getCommentX().equals("CHG")) hideY = "Y";
		
		sql.append(" INSERT INTO DSS_IROPS_SCH_T (DSS_START_DT, SEQ_NUM, FIRST_LEG_FLT_DT, ");
		sql.append(" ARLN_CD, FLT_NUM, LEG_NUM, STNFR, STNTO, SCH_DEP_DT, ROUTE_X, COMMENT_X, COMMENT_E, HIDE_Y) ");
		sql.append(" VALUES (TO_DATE('"+dss_start_dt+"','YYYYMMDDHH24MISS'), "+seq_num+", TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD'), ");
		sql.append(" 'KE', '"+params.getFltNum()+"', "+params.getLegNum()+", '"+params.getStnfr()+"', '"+params.getStnto()+"', ");
		sql.append(" TO_DATE('"+params.getStd()+"','YYYYMMDDHH24MI'), '"+params.getDomIntX()+"', '"+params.getCommentX()+"', '"+params.getCommentE()+"', '"+hideY+"') ");
		
		System.out.println("[BASE:IroA310Query:insDssIropsSchT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DSS_IROPS_DESK_T Է SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/07/21 
	  */
	public String insDssIropsDeskT(IroA310BG params, String desk_x) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO DSS_IROPS_DESK_T (DSS_START_DT, SEQ_NUM, DESK_X, DECISION_X, DECISION_E, CHECKLIST_E, USER_ID, KOR_N, TIMESTAMP) ");
		sql.append(" VALUES (TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS'), "+params.getSeqNum()+", '"+desk_x+"', '4', '', '', '', '', SYSDATE) ");
		
		System.out.println("[BASE:IroA310Query:insDssIropsDeskT] sql : "+sql.toString());
		return sql.toString();
	}
	
}
