package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.IroQ120BG;
import kal.base.com.query.ComQ01Query;
import kal.base.iro.query.*;
import kal.base.com.util.*;

 /**
   * Daily IROPS REPORT SQL 
   * @author Copyright (c) 2005/02/03 
   */
public class IroQ120Query {
	private static IroQ120Query instance = new IroQ120Query();
	
	public static IroQ120Query getInstance() {
		return instance;
	}
	/** 
	  * Daily IROPS REPORT main ȸ SQLԼ.
	  * @param entity IroQ120BG Daily IROPS REPORT
	  * @return String Query 
	  * @author Copyright (c) 2005/02/03 
	  */
	public String selIroQ120Main(IroQ120BG entity){
		StringBuffer sql = new StringBuffer();
	
		// ==>  2006.02.06  : Remark_e -> Decision_e 
		sql.append(" Select A.Flt_Num, A.Stnfr, A.Stnto, B.Kactyp, B.Regno, B.Actnid, A.Hide_y,DECODE(A.MANAGER_D1,NULL,'','R') MANAGER_D1,DECODE(A.MANAGER_D2,NULL,'','R') MANAGER_D2,  ");
		sql.append(" 	To_Char(B.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Dt, To_Char(B.Sch_Arv_Dt,'hh24:mi') Sch_Arv_Dt, ");
		sql.append(" 	To_Char(B.Act_Dep_Dt,'hh24:mi') Act_Dep_Dt, To_Char(B.Act_Arv_Dt,'hh24:mi') Act_Arv_Dt, ");
		sql.append(" 	A.Title_e, A.Decision_e, To_Char(A.First_Leg_Flt_Dt, 'yyyymmdd') First_Leg_Flt_Dt, A.Seq_Num, A.Option_Num, B.Sch_Dep_Dt Ord_dt ");
		sql.append(" From Irops_Sch_T A, Daily_Sch_t B ");
		sql.append(" Where A.Arln_Cd = 'KE' And  ");
		//sql.append(" 	A.First_Leg_Flt_Dt >= To_Date('"+entity.getAll_date()+"','yyyymmdd') And  ");
		//sql.append(" 	A.First_Leg_Flt_Dt = To_Date('"+entity.getAll_date()+"','yyyymmdd') And  ");
		sql.append("       		B.Sch_Dep_Dt >= To_Date('"+entity.getAll_date()+" 0000' ,'yyyymmdd hh24mi')-540/1440 And");
		sql.append("       		B.Sch_Dep_Dt <= To_Date('"+entity.getAll_date()+" 2359' ,'yyyymmdd hh24mi')-540/1440 And");
		sql.append(" 	A.Complete_y = 'Y'    And ");
		//sql.append(" 	A.Hide_y     = 'N'    And ");
		sql.append(" 	A.Decision_c <> 'X'   And ");
		/*
		if(!entity.getRegion_flt().equals("ALL")){
			sql.append("  A.Region_Flt = '"+entity.getRegion_flt()+"'     And ");
		}
		*/
		//DOM/INT/CGO ȸ
		sql.append(IroQ120Query.getInstance().selDomIntQ(entity.getDom_int_x()));
		sql.append(" 	A.Arln_Cd  = B.Arln_Cd  And ");
		sql.append(" 	A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And ");
		sql.append(" 	A.Flt_Num = B.FLT_Num   And  ");
		sql.append(" 	A.Stnfr   = B.Stnfr     And ");
		sql.append(" 	A.Stnto   = B.Stnto And");
		sql.append(" 	A.Title_x != 'NEW'");
		
		sql.append(" Union");
		sql.append(" Select A.Flt_Num, A.Stnfr, A.Stnto, B.Kactyp, B.Regno, '' Actnid, A.Hide_y,DECODE(A.MANAGER_D1,NULL,'','Y') MANAGER_D1,DECODE(A.MANAGER_D2,NULL,'','Y') MANAGER_D2,");
		sql.append("        	To_Char(B.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Dt, To_Char(B.Sch_Arv_Dt,'hh24:mi') Sch_Arv_Dt,");
		sql.append("        	'' Act_Dep_Dt, '' Act_Arv_Dt,");
		sql.append("        	A.Title_e, A.Decision_e, To_Char(A.First_Leg_Flt_Dt, 'yyyymmdd') First_Leg_Flt_Dt, A.Seq_Num, A.Option_Num, B.Sch_Dep_Dt Ord_dt");
		sql.append(" From Irops_Sch_t A, Bs_New_Sch_t B");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		//sql.append("       A.First_Leg_Flt_Dt = To_Date('"+entity.getAll_date()+"','yyyymmdd') And");
		sql.append("       		B.Sch_Dep_Dt >= To_Date('"+entity.getAll_date()+" 0000' ,'yyyymmdd hh24mi')-540/1440 And");
		sql.append("       		B.Sch_Dep_Dt <= To_Date('"+entity.getAll_date()+" 2359' ,'yyyymmdd hh24mi')-540/1440 And");
		sql.append("       A.Complete_y = 'Y'    And");
		//sql.append("       A.Hide_y     = 'N'    And");
		sql.append("       A.Decision_c <> 'X'   And");
		sql.append("       A.Arln_Cd  = B.Arln_Cd  And");
		sql.append("       A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And");
		sql.append("       A.Flt_Num = B.FLT_Num   And");
		sql.append("       A.Stnfr   = B.Stnfr     And");
		sql.append("       A.Stnto   = B.Stnto And");
		sql.append(" 	   A.Title_x = 'NEW'");
		
		
		sql.append(" Order By Ord_dt ");

		//System.out.println("[BASE:IroQ120Query:selMain] sql : "+sql.toString());
		Logger.debug.println("[BASE:IroQ120Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Dom/Int/Cgo Query ȸԼ.
	  *  ǿ ´ Query Ѵ
	  * @param domIntX String 
	  * @return String Query 
	  * @author Copyright (c) 2005/01/26 HIST 
	  */
	public String selDomIntQ(String domIntX) {

		StringBuffer sql = new StringBuffer();
		if (domIntX != null && domIntX.length() != 0)
			domIntX = domIntX.toUpperCase();
		else 
			domIntX = StringUtil.checkString(domIntX);
		
		if (domIntX.equals("DOM")) {
			//2008.02.22 
			//sql.append(" 	(Substr(B.Flt_Num,1,1) = '1' Or");
			//sql.append(" 		(Substr(B.Flt_Num,1,2) = '01' And");
			//sql.append(" 	(Substr(B.Flt_Num,5,1) >= 'A' And Substr(B.Flt_Num,5,1) <= 'Z') And");
			//sql.append(" 		Not B.Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S'))) And");
			sql.append(" 	SUBSTR(B.FLT_NUM,1,1) = '1' AND ");
			
		} else if (domIntX.equals("INT")) {
			//2008.02.22 
			//sql.append(" 	Not (Substr(B.Flt_Num,1,1) = '1'  Or");
			//sql.append(" 		(Substr(B.Flt_Num,1,2) = '01' And (Substr(B.Flt_Num,5,1) >= 'A' And");
			//sql.append(" 	Substr(B.Flt_Num,5,1) <= 'Z')) or");
			//sql.append(" 	B.Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S')) And");
			sql.append(" 	NOT (SUBSTR(B.FLT_NUM,1,1) = '1' OR ");
			sql.append(" 	B.KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F','74N','77X')) AND "); //2009.05.21 ߰ : ABH, 2010.03.26 ߰ : 74F, 2012.02.22 ߰ : 74N,74X
			
		} else if (domIntX.equals("CGO")) {
			//2008.02.22 
			//sql.append(" 	Substr(B.Flt_Num,1,1) <> '1'   And");
			//sql.append(" 	B.Kactyp In('M1F','7FQ','7FR','74Y','7FG','79S') And");
			sql.append(" 	B.KACTYP IN('ABF','M1F','7FQ','7FR','74Y','7FG','79S','7GG','ABH','74F','74N','77X') AND "); //2009.05.21 ߰ : ABH, 2010.03.26 ߰ : 74F, 2012.02.22 ߰ : 74N,74X
			
		} else {
			sql.setLength(0);
		}

		return sql.toString();
	}	
	
	/** 
	  * IROPS REPORT update SQLԼ.
	  * @param entity IroA110BG IROPS REPORT
	  * @return String Query 
	  * @author Copyright (c) 2005/02/01 
	  */
	public String updIroQ120Main(IroQ120BG entity){
		StringBuffer sql = new StringBuffer();
	
		sql.append(" Update Irops_Sch_T ");
		sql.append(" Set  Hide_y  = '"+entity.getHide_y()+"' ");
		sql.append(" Where Arln_Cd = 'KE' And  "); 
		sql.append(" 	First_Leg_Flt_Dt = To_Date('"+entity.getFirst_leg_flt_dt()+"','yyyymmdd') And  ");
		sql.append(" 	Flt_Num = '"+entity.getFlt_num()+"'   And  ");
		sql.append(" 	Stnfr   = '"+entity.getStnfr()+"'     And ");
		sql.append(" 	Stnto   = '"+entity.getStnto()+"'     And  ");
		sql.append(" 	Seq_Num = "+entity.getSeq_num()+"   And ");   
		sql.append(" 	Option_Num = "+entity.getOption_num()+" ");
			
		Logger.debug.println("[BASE:IroA120Query:updMain] sql : "+sql.toString());
		return sql.toString();
	}	
}
