package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.IroQ130BG;
import kal.base.com.query.ComQ01Query;
import kal.base.iro.query.*;
import kal.base.com.util.*;

 /**
   * SKD   SQL 
   * @author Copyright (c) 2005/04/22 
   */
public class IroQ130Query {
	private static IroQ130Query instance = new IroQ130Query();
	
	public static IroQ130Query getInstance() {
		return instance;
	}
	
	/** 
	  * SKD   main ȸ SQLԼ.
	  * @param entity IroQ130BG SKD  
	  * @return String Query 
	  * @author Copyright (c) 2005/04/22 
	  */
	public String selMain(IroQ130BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" Select A.Decision_c, B.Dept_c, B.Kor_n, A.Title_e, A.Decision_e, A.Message, A.Processed, A.Project_no,  ");	
		sql.append(" 	A.Flt_Num, To_Char(A.Timestamp,'ddMONyy') timeMon,  ");
		sql.append("	   	To_Char(A.Manager_d1,'yyyy/mm/dd hh24:mi') Manager_d1,  ");
		sql.append("	   	To_Char(A.Manager_d2,'yyyy/mm/dd hh24:mi') Manager_d2,  ");
		sql.append(" 	To_Char(A.Timestamp,'yyyymmdd') Timestamp  ");
		sql.append(" From Irops_Sch_T A, Password_T B  ");
		sql.append(" Where A.Arln_Cd = 'KE' And   ");
		sql.append(" 	A.User_Id = B.Emp_no  And   ");
		//sql.append("	  	A.First_Leg_Flt_Dt >= To_Date('"+ entity.getFirst_leg_flt_dt() +"', 'yyyymmdd') And   ");
		sql.append("	  	A.First_Leg_Flt_Dt = To_Date('"+ entity.getFirst_leg_flt_dt() +"', 'yyyymmdd') And   ");
		sql.append("	  	A.Flt_Num = '"+ entity.getFlt_num() +"' And  ");
		sql.append("	  	A.Stnfr = '"+ entity.getStnfr() +"' And  ");
		sql.append("	  	A.Stnto = '"+ entity.getStnto() +"' And  ");
		sql.append("	  	A.Seq_num = "+ entity.getSeq_num() +" And  ");
		sql.append("	  	A.Option_Num = "+ entity.getOption_num() );

		Logger.debug.println("[BASE:IroQ130Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SKD   Process ȸ SQLԼ.
	  * @param String project_no
	  * @return String Query 
	  * @author Copyright (c) 2005/04/22 
	  */
	public String selProcessed(String project_no){
		StringBuffer sql = new StringBuffer();

		sql.append(" Select Processed, Error_reply  ");
		sql.append(" From MS_TELEX_MSG_T  ");
		sql.append(" Where Msg_Cat = 'BASEWEB' And  ");
		sql.append(" 	Project_no = '"+ project_no +"' ");

		Logger.debug.println("[BASE:IroQ130Query:selProcessed] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SKD   Process Update SQLԼ.
	  * @param entity IroQ130BG SKD  
	  * @return String Query 
	  * @author Copyright (c) 2005/04/22 
	  */
	public String updProcessed(IroQ130BG entity, String updStr){
		StringBuffer sql = new StringBuffer();

		sql.append(" Update Irops_Sch_T ");
		sql.append(" Set  "+ updStr );
		sql.append(" Where Arln_Cd = 'KE' And   ");
		//sql.append("	  	First_Leg_Flt_Dt >= To_Date('"+ entity.getFirst_leg_flt_dt() +"','YYYYMMDD') And   ");
		sql.append("	  	First_Leg_Flt_Dt = To_Date('"+ entity.getFirst_leg_flt_dt() +"','YYYYMMDD') And   ");
		sql.append("	  	Flt_Num = '"+ entity.getFlt_num() +"' And  ");
		sql.append("	  	Stnfr = '"+ entity.getStnfr() +"' And  ");
		sql.append("	  	Stnto = '"+ entity.getStnto() +"' And  ");
		sql.append("	  	Seq_num = "+ entity.getSeq_num() +" And  ");
		sql.append("	  	Option_Num = "+ entity.getOption_num() );

		Logger.debug.println("[BASE:IroQ130Query:updProcessed] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SKD   sub ȸ SQLԼ.
	  * @param entity IroQ130BG SKD  
	  * @return String Query 
	  * @author Copyright (c) 2005/04/25 
	  */
	public String selSub(IroQ130BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" Select  C.Code_x, B.Kor_n, To_Char(A.TimeStamp,'hh24:mi') TimeStamp, To_Char(A.TimeStamp,'yyyy/mm/dd hh24:mi') Time,  ");
		sql.append(" 	 A.Decision_e, A.Decision_x, C.Desc_e  ");
		sql.append(" From Irops_Desk_T A, Password_T B, Code_T C ");
		sql.append(" Where A.Arln_Cd = 'KE' And  ");
		//sql.append("	  	 A.First_Leg_Flt_Dt >= To_Date('"+ entity.getFirst_leg_flt_dt() +"', 'yyyymmdd') And  ");
		sql.append("	  	 A.First_Leg_Flt_Dt = To_Date('"+ entity.getFirst_leg_flt_dt() +"', 'yyyymmdd') And  ");
		sql.append("	  	 A.Flt_Num = '"+ entity.getFlt_num() +"' And  ");
		sql.append("	  	 A.Stnfr = '"+ entity.getStnfr() +"' And  ");
		sql.append("	  	 A.Stnto = '"+ entity.getStnto() +"' And  ");
		sql.append("	  	 A.Seq_num = "+ entity.getSeq_num() +" And  ");
		sql.append("	  	 A.Option_Num = "+ entity.getOption_num() +" And ");
		sql.append("       A.User_Id   = B.Emp_no(+)   And ");
		sql.append("       A.Desk_x   = C.Desc_e    And ");
		sql.append("       C.Step_x    = '0'          And  ");
		sql.append("       C.Code_c  = 'Head'     And  ");
		sql.append("       C.Use_y    = 'N'       And "); 
		sql.append("       C.End_d    >=  To_Char(Sysdate,'YYYYMMDD')    "); 
		sql.append(" 	 Order By C.Desc_e ");

		Logger.debug.println("[BASE:IroQ130Query:selSub] sql : "+sql.toString());
		return sql.toString();
	}
}
