package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.IroQ140BG;
import kal.base.com.query.ComQ01Query;
import kal.base.iro.query.*;
import kal.base.com.util.*;

 /**
   * Monthly IROPS REPORT SQL 
   * @author Copyright (c) 2005/07/13 
   */
public class IroQ140Query {
	private static IroQ140Query instance = new IroQ140Query();
	
	public static IroQ140Query getInstance() {
		return instance;
	}
	/** 
	  * Monthly IROPS REPORT main ȸ SQLԼ.
	  * @param entity IroQ140BG Daily IROPS REPORT
	  * @return String Query 
	  * @author Copyright (c) 2005/07/13 
	  */
	public String selIroQ140Main(IroQ140BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" Select A.Flt_Num, A.Stnfr, A.Stnto, B.Kactyp, B.Regno, B.Actnid,  ");
		sql.append(" 	To_Char(B.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Dt, To_Char(B.Sch_Arv_Dt,'hh24:mi') Sch_Arv_Dt, ");
		sql.append(" 	To_Char(B.Act_Dep_Dt,'hh24:mi') Act_Dep_Dt, To_Char(B.Act_Arv_Dt,'hh24:mi') Act_Arv_Dt, ");
		sql.append(" 	A.Title_e, A.Title_x, A.Decision_e, A.Decision_c, To_Char(A.First_Leg_Flt_Dt, 'yyyymmdd') First_Leg_Flt_Dt, ");
		sql.append("	    A.Seq_Num, A.Option_Num, To_Char(B.Sch_Dep_Dt, 'mmdd') Sch_Dt, B.Sch_Dep_Dt Ord_dt ");
		sql.append(" From Irops_Sch_T A, Daily_Sch_t B ");
		sql.append(" Where A.Arln_Cd = 'KE' And  ");
		//sql.append(" 	A.First_Leg_Flt_Dt >= To_Date('"+entity.getAll_date()+"','yyyymmdd') And  ");
		//sql.append(" 	A.First_Leg_Flt_Dt = To_Date('"+entity.getAll_date()+"','yyyymmdd') And  ");
		sql.append("       		B.Sch_Dep_Dt >= To_Date('"+entity.getMonth_start_d()+" 0000' ,'yyyymmdd hh24mi')-540/1440 And");
		sql.append("       		B.Sch_Dep_Dt <= To_Date('"+entity.getMonth_end_d()+" 2359' ,'yyyymmdd hh24mi')-540/1440 And");
		sql.append(" 	A.Complete_y = 'Y'    And ");
		sql.append(" 	A.Hide_y     = 'N'    And ");
		sql.append(" 	A.Decision_c <> 'X'   And ");
		if(!entity.getTitle_x().equals("") && !entity.getTitle_x().equals("ALL")){
			sql.append("	A.Title_x = '"+ entity.getTitle_x() +"' And ");
		}
		/*
		if(!entity.getRegion_flt().equals("ALL")){
			sql.append("  A.Region_Flt = '"+entity.getRegion_flt()+"'     And ");
		}
		*/
		//DOM/INT/CGO ȸ
		sql.append(IroQ120Query.getInstance().selDomIntQ(entity.getDom_int_x()));
		sql.append(" 	A.Arln_Cd  = B.Arln_Cd  And ");
		sql.append(" 	A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And ");
		sql.append(" 	A.Flt_Num = B.FLT_Num   And  ");
		sql.append(" 	A.Stnfr   = B.Stnfr     And ");
		sql.append(" 	A.Stnto   = B.Stnto And");
		sql.append(" 	A.Title_x != 'NEW'");
		
		if(entity.getTitle_x().equals("ALL") || entity.getTitle_x().equals("NEW")){
			sql.append(" Union");
			sql.append(" Select A.Flt_Num, A.Stnfr, A.Stnto, B.Kactyp, B.Regno, '' Actnid,");
			sql.append("        	To_Char(B.Sch_Dep_Dt,'hh24:mi') Sch_Dep_Dt, To_Char(B.Sch_Arv_Dt,'hh24:mi') Sch_Arv_Dt,");
			sql.append("        	'' Act_Dep_Dt, '' Act_Arv_Dt,");
			sql.append("        	A.Title_e, A.Title_x, A.Decision_e, A.Decision_c, To_Char(A.First_Leg_Flt_Dt, 'yyyymmdd') First_Leg_Flt_Dt, ");
			sql.append("			A.Seq_Num, A.Option_Num, To_Char(B.Sch_Dep_Dt, 'mmdd') Sch_Dt, B.Sch_Dep_Dt Ord_dt ");
			sql.append(" From Irops_Sch_t A, Bs_New_Sch_t B");
			sql.append(" Where A.Arln_Cd = 'KE' And");
			//sql.append("       A.First_Leg_Flt_Dt = To_Date('"+entity.getAll_date()+"','yyyymmdd') And");
			sql.append("       		B.Sch_Dep_Dt >= To_Date('"+entity.getMonth_start_d()+" 0000' ,'yyyymmdd hh24mi')-540/1440 And");
			sql.append("       		B.Sch_Dep_Dt <= To_Date('"+entity.getMonth_end_d()+" 2359' ,'yyyymmdd hh24mi')-540/1440 And");
			sql.append("       A.Complete_y = 'Y'    And");
			sql.append("       A.Hide_y     = 'N'    And");
			sql.append("       A.Decision_c <> 'X'   And");
			sql.append("       A.Arln_Cd  = B.Arln_Cd  And");
			sql.append("       A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And");
			sql.append("       A.Flt_Num = B.FLT_Num   And");
			sql.append("       A.Stnfr   = B.Stnfr     And");
			sql.append("       A.Stnto   = B.Stnto And");
			sql.append(" 	   A.Title_x = 'NEW'");
		}
		
		sql.append(" Order By Ord_dt ");

		Logger.debug.println("[BASE:IroQ140Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
