package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * IROPS Final Decision SQL 
  * @author Copyright (c) 2009/08/21  
  */ 
public class IroQ360Query {
	private static IroQ360Query instance = new IroQ360Query();
	
	public static IroQ360Query getInstance() {
		return instance;
	}
	
	/** 
	  * ȸǿ ACREG ִ  1 - DAILY_SCH_T ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/21 
	  */
	public String selMain1(String stn, String flt, String acreg) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(A.DSS_START_DT, 'YYYYMMDDHH24MISS') DSS_START_DT, A.SEQ_NUM, A.TITLE_E, B.FLT_NUM ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
		sql.append(" WHERE A.DSS_START_DT >= SYSDATE - 3 ");
		sql.append(" AND A.DSS_START_DT <= SYSDATE + 1/24 ");
		sql.append(" AND A.PROCESS_X = 'C' ");
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = B.SEQ_NUM ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		sql.append(" AND B.STNFR = C.STNFR ");
		sql.append(" AND B.STNTO = C.STNTO ");
		sql.append(" AND C.REGNO IN ("+acreg+") ");
		if (!stn.equals("")) {
			sql.append(" AND (C.STNFR IN("+stn+") OR C.STNTO IN("+stn+")) ");
		}
		if (!flt.equals("")) {
			sql.append(" AND C.FLT_NUM IN ("+flt+") ");
		}
		sql.append(" ORDER BY A.DSS_START_DT, A.SEQ_NUM, C.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroQ360Query:selMain1] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ȸǿ ACREG ִ  2 - DSS_NEW_SCH_T ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/21 
	  */
	public String selMain2(String stn, String flt, String acreg) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(A.DSS_START_DT, 'YYYYMMDDHH24MISS') DSS_START_DT, A.SEQ_NUM, A.TITLE_E, B.FLT_NUM ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DSS_NEW_SCH_T C ");
		sql.append(" WHERE A.DSS_START_DT >= SYSDATE - 3 ");
		sql.append(" AND A.DSS_START_DT <= SYSDATE + 1/24 ");
		sql.append(" AND A.PROCESS_X = 'C' ");
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = B.SEQ_NUM ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		sql.append(" AND B.STNFR = C.STNFR ");
		sql.append(" AND B.STNTO = C.STNTO ");
		sql.append(" AND C.REGNO IN ("+acreg+") ");
		if (!stn.equals("")) {
			sql.append(" AND (C.STNFR IN("+stn+") OR C.STNTO IN("+stn+")) ");
		}
		if (!flt.equals("")) {
			sql.append(" AND C.FLT_NUM IN ("+flt+") ");
		}
		sql.append(" ORDER BY A.DSS_START_DT, A.SEQ_NUM, C.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroQ360Query:selMain2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ȸǿ ACREG   ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/21 
	  */
	public String selMain3(String stn, String flt) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(A.DSS_START_DT, 'YYYYMMDDHH24MISS') DSS_START_DT, A.SEQ_NUM, A.TITLE_E, B.FLT_NUM ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B ");
		sql.append(" WHERE A.DSS_START_DT >= SYSDATE - 3 ");
		sql.append(" AND A.DSS_START_DT <= SYSDATE + 1/24 ");
		sql.append(" AND A.PROCESS_X = 'C' ");
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = B.SEQ_NUM ");
		if (!stn.equals("")) {
			sql.append(" AND (B.STNFR IN("+stn+") OR B.STNTO IN("+stn+")) ");
		}
		if (!flt.equals("")) {
			sql.append(" AND B.FLT_NUM IN ("+flt+") ");
		}
		sql.append(" ORDER BY A.DSS_START_DT, A.SEQ_NUM, B.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroQ360Query:selMain3] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ȸǿ ACREG   ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/21 
	  */
	public String selProcessX(IroQ360BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT PROCESS_X ");
		sql.append(" FROM DSS_IROPS_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		
		System.out.println("[BASE:IroQ360Query:selProcessX] sql : "+sql.toString());
		return sql.toString();
	}
	
}
