package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * IROPS Case Report SQL 
  * @author Copyright (c) 2009/08/22  
  */ 
public class IroQ410Query {
	private static IroQ410Query instance = new IroQ410Query();
	
	public static IroQ410Query getInstance() {
		return instance;
	}
	
	/** 
	  * DSS_IROPS_T, DSS_IROPS_SCH_T ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/22 
	  */
	public String selMain(IroQ410BG params, String flt) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(A.DSS_START_DT, 'YYYYMMDDHH24MISS') DSS_START_DT, A.SEQ_NUM, ");
		sql.append(" A.TITLE_E, B.FLT_NUM, A.PROCESS_X, A.DECISION_E, ");
		sql.append(" TO_CHAR(A.IROPS_DT - 9/24, 'YYMMDD HH24:MI') IROPS_DT, "); //2009.10.07  : IROPS_DT KST -> UTC
		sql.append(" TO_CHAR(A.DSS_DT - 9/24, 'YYMMDD HH24:MI') DSS_DT "); //2009.10.07  : DSS_DT KST -> UTC
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B ");
		/*
		sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getSchDepDt()+"0000','YYYYMMDDHH24MI') ");
		sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getSchDepDt()+"2359','YYYYMMDDHH24MI') ");
		*/
		//2010.06.04 
		sql.append(" WHERE A.IROPS_DT>= TO_DATE('20"+params.getSchDepDt()+"0000','YYYYMMDDHH24MI') ");
		sql.append(" AND A.IROPS_DT <= TO_DATE('20"+params.getSchDepDt()+"2359','YYYYMMDDHH24MI') ");
		
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND A.PROCESS_X IN ('A','M') ");
		if (!flt.equals("")) {
			sql.append(" AND B.FLT_NUM IN ("+flt+") ");
		}
		if (!params.getTitle().equals("")) {
			//sql.append(" AND A.TITLE_E LIKE '%"+params.getTitle()+"%' "); 2010.06.09  : TITLE_E -> DECISION_E
			sql.append(" AND A.DECISION_E LIKE '%"+params.getTitle()+"%' ");
		}
		sql.append(" ORDER BY A.IROPS_DT ");
		
		System.out.println("[BASE:IroQ410Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
