package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * IROPS FLT Report SQL 
  * @author Copyright (c) 2009/08/24  
  */ 
public class IroQ420Query {
	private static IroQ420Query instance = new IroQ420Query();
	
	public static IroQ420Query getInstance() {
		return instance;
	}
	
	/** 
	  * 1. DAILY_SCH_T  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/24 
	  */
	public String selMain1(IroQ420BG params, String flt, String acreg) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT B.HIDE_Y, B.ARLN_CD, TO_CHAR(B.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, B.FLT_NUM, B.STNFR, B.STNTO, C.KACTYP, C.REGNO, ");
		sql.append(" TO_CHAR(B.SCH_DEP_DT,'MMDD') SCH_DATE, ");
		sql.append(" TO_CHAR(B.SCH_DEP_DT,'HH24:MI') STD, TO_CHAR(C.ACT_DEP_DT,'HH24:MI') ATD, ");
		sql.append(" TO_CHAR(C.SCH_ARV_DT,'HH24:MI') STA, TO_CHAR(C.ACT_ARV_DT,'HH24:MI') ATA, ");
		sql.append(" A.TITLE_E, B.COMMENT_E, B.COMMENT_X, ");
		//sql.append(" DECODE(TO_CHAR(NVL(MANAGER_D2,'20000101'),'YYYYMMDD'),'20000101','','R') OCC, ");
		//sql.append(" DECODE(TO_CHAR(NVL(MANAGER_D1,'20000101'),'YYYYMMDD'),'20000101','','R') GOC, ");
		sql.append(" DECODE(TO_CHAR(NVL(MANAGER_D2, TO_DATE('20000101','YYYYMMDD')),'YYYYMMDD'),'20000101','','R') OCC, ");
		sql.append(" DECODE(TO_CHAR(NVL(MANAGER_D1, TO_DATE('20000101','YYYYMMDD')),'YYYYMMDD'),'20000101','','R') GOC, ");
		sql.append(" TO_CHAR(B.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, B.SEQ_NUM ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
		sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
		sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		//sql.append(" AND B.STNFR = C.STNFR ");
		//sql.append(" AND B.STNTO = C.STNTO ");
		sql.append(" AND B.SCH_DEP_DT = C.SCH_DEP_DT ");//@2019-07-17
		sql.append(" AND B.LEG_NUM = C.LEG_NUM ");//@2019-07-17
		sql.append(" AND A.PROCESS_X IN ('A','M') ");
		if (!params.getGubun().equals("")) {
			sql.append(" AND B.COMMENT_X = '"+params.getGubun()+"' ");
		}
		
		if (!flt.equals("")) {
			sql.append(" AND C.FLT_NUM IN ("+flt+") ");
		}
		
		if (!params.getDep().equals("")) {
			sql.append(" AND C.STNFR = '"+params.getDep()+"' ");
		}
		
		if (!params.getArr().equals("")) {
			sql.append(" AND C.STNTO = '"+params.getArr()+"' ");
		}
		
		if (!acreg.equals("")) {
			sql.append(" AND C.REGNO IN ("+acreg+") ");
		}
		
		sql.append(" ORDER BY B.SCH_DEP_DT ");

		
		System.out.println("[BASE:IroQ420Query:selMain1] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 2. DSS_NEW_SCH_T  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/24 
	  */
	public String selMain2(IroQ420BG params, String flt, String acreg) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT B.HIDE_Y, B.ARLN_CD, TO_CHAR(B.FIRST_LEG_FLT_DT,'YYYYMMDD') FIRST_LEG_FLT_DT, C.FLT_NUM, C.STNFR, C.STNTO, C.KACTYP, C.REGNO, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'MMDD') SCH_DATE, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'HH24:MI') STD, '' ATD, ");
		sql.append(" TO_CHAR(C.SCH_ARV_DT,'HH24:MI') STA, '' ATA, ");
		sql.append(" A.TITLE_E, B.COMMENT_E, B.COMMENT_X, ");
		//sql.append(" DECODE(TO_CHAR(NVL(MANAGER_D2,'20000101'),'YYYYMMDD'),'20000101','','R') OCC, ");
		//sql.append(" DECODE(TO_CHAR(NVL(MANAGER_D1,'20000101'),'YYYYMMDD'),'20000101','','R') GOC, ");
		sql.append(" DECODE(TO_CHAR(NVL(MANAGER_D2, TO_DATE('20000101','YYYYMMDD')),'YYYYMMDD'),'20000101','','R') OCC, ");
		sql.append(" DECODE(TO_CHAR(NVL(MANAGER_D1, TO_DATE('20000101','YYYYMMDD')),'YYYYMMDD'),'20000101','','R') GOC, ");	
		sql.append(" TO_CHAR(B.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, B.SEQ_NUM ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DSS_NEW_SCH_T C ");
		sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
		sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		sql.append(" AND B.STNFR = C.STNFR ");
		sql.append(" AND B.STNTO = C.STNTO ");
		sql.append(" AND A.PROCESS_X IN ('A','M') ");
		
		if (!params.getGubun().equals("")) {
			sql.append(" AND B.COMMENT_X = '"+params.getGubun()+"' ");
		}
		
		if (!flt.equals("")) {
			sql.append(" AND C.FLT_NUM IN ("+flt+") ");
		}
		
		if (!params.getDep().equals("")) {
			sql.append(" AND C.STNFR = '"+params.getDep()+"' ");
		}
		
		if (!params.getArr().equals("")) {
			sql.append(" AND C.STNTO = '"+params.getArr()+"' ");
		}
		
		if (!acreg.equals("")) {
			sql.append(" AND C.REGNO IN ("+acreg+") ");
		}
		
		sql.append(" ORDER BY B.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroQ420Query:selMain2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Ư IROPS SKD HIDE ϴ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/24 
	  */
	public String updHideY(IroQ420BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE DSS_IROPS_SCH_T ");
		sql.append(" SET HIDE_Y = '"+params.getHideY()+"' ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND ARLN_CD = '"+params.getArlnCd()+"' ");
		sql.append(" AND FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND STNFR = '"+params.getStnfr()+"' ");
		sql.append(" AND STNTO = '"+params.getStnto()+"' ");
		
		System.out.println("[BASE:IroQ420Query:updHideY] sql : "+sql.toString());
		return sql.toString();
	}
}
