package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * Pre-Determination SQL 
  * @author Copyright (c) 2009/08/26  
  */ 
public class IroQ430Query {
	private static IroQ430Query instance = new IroQ430Query();
	
	public static IroQ430Query getInstance() {
		return instance;
	}
	
	/** 
	  *  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/25 
	  */
	public String selUser() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DISTINCT C.USER_ID, C.KOR_N, C.DESK_X ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DSS_IROPS_DESK_T C ");
		
		//2010.04.15  : DSS_IROPS_SCH_T.SCH_DEP_DT -> DSS_IROPS_T.IROPS_DT
		//sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE(TO_CHAR(SYSDATE-10,'YYYYMMDD')||'0000','YYYYMMDDHH24MI') ");
		//sql.append(" AND B.SCH_DEP_DT <= TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||'2359','YYYYMMDDHH24MI') ");
		sql.append(" WHERE A.IROPS_DT >= TO_DATE(TO_CHAR(SYSDATE-10,'YYYYMMDD')||'0000','YYYYMMDDHH24MI') ");
		sql.append(" AND A.IROPS_DT <= TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||'2359','YYYYMMDDHH24MI') ");
		
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND A.PROCESS_X = 'M' ");
		sql.append(" AND A.DSS_START_DT = C.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = C.SEQ_NUM ");
		sql.append(" AND C.DESK_X IN ('A','B','D') ");
		
		sql.append(" AND C.USER_ID NOT IN ('0000915','8805403') ");
		
		sql.append(" ORDER BY C.KOR_N ");
		
		System.out.println("[BASE:IroQ430Query:selUser] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Pre-Determination ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/26 
	  */
	public String selMain(IroQ430BG params) {
		StringBuffer sql = new StringBuffer();
		
		if (params.getUserId().equals("")) { //ALL 
		
			sql.append(" SELECT 'A' GRP, B.COMMENT_X, TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) RNG, COUNT(*) CNT ");
			sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B ");
			
			//2010.04.15  : DSS_IROPS_SCH_T.SCH_DEP_DT -> DSS_IROPS_T.IROPS_DT
			//sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			//sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append(" WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append(" AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			
			sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append(" AND A.PROCESS_X = 'M' ");
			sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			sql.append(" GROUP BY 1, B.COMMENT_X, TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) ");
			sql.append(" UNION ");
			sql.append(" SELECT 'B' GRP, B.COMMENT_X, TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) RNG, COUNT(*) CNT ");
			sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B ");
			
			//2010.04.15  : DSS_IROPS_SCH_T.SCH_DEP_DT -> DSS_IROPS_T.IROPS_DT
			//sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			//sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append(" WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append(" AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			
			sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append(" AND A.PROCESS_X = 'M' ");
			sql.append(" AND B.SCH_DEP_DT < A.MSG_DT - 9/24 ");
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			sql.append(" GROUP BY 1, B.COMMENT_X, TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) ");
			sql.append(" ORDER BY 1, 2, 3 ");
		
		} else { //ڸ 
			
			sql.append(" SELECT 'A' GRP, B.COMMENT_X, TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) RNG, COUNT(*) CNT ");
			sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DSS_IROPS_DESK_T C ");
			
			//2010.04.15  : DSS_IROPS_SCH_T.SCH_DEP_DT -> DSS_IROPS_T.IROPS_DT
			//sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			//sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append(" WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append(" AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			
			sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append(" AND A.PROCESS_X = 'M' ");
			sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			sql.append(" AND B.DSS_START_DT = C.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = C.SEQ_NUM ");
			//DESK_X + USER_ID
			sql.append(" AND C.DESK_X = '"+params.getUserId().substring(0,1)+"' ");
			sql.append(" AND C.USER_ID = '"+params.getUserId().substring(1)+"' ");
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			sql.append(" GROUP BY 1, B.COMMENT_X, TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) ");
			sql.append(" UNION ");
			sql.append(" SELECT 'B' GRP, B.COMMENT_X, TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) RNG, COUNT(*) CNT ");
			sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DSS_IROPS_DESK_T C ");
			
			//2010.04.15  : DSS_IROPS_SCH_T.SCH_DEP_DT -> DSS_IROPS_T.IROPS_DT
			//sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			//sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append(" WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append(" AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			
			sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append(" AND A.PROCESS_X = 'M' ");
			sql.append(" AND B.SCH_DEP_DT < A.MSG_DT - 9/24 ");
			sql.append(" AND B.DSS_START_DT = C.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = C.SEQ_NUM ");
			//DESK_X + USER_ID
			sql.append(" AND C.DESK_X = '"+params.getUserId().substring(0,1)+"' ");
			sql.append(" AND C.USER_ID = '"+params.getUserId().substring(1)+"' ");
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			sql.append(" GROUP BY 1, B.COMMENT_X, TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) ");
			sql.append(" ORDER BY 1, 2, 3 DESC ");
		}
				
		System.out.println("[BASE:IroQ430Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}

	/** 
	  * IROPS REPORT (Pre-Determination) ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/28 
	  */
	public String selPreReport(IroQ430BG params) {
		StringBuffer sql = new StringBuffer();
		
		if (params.getUserId().equals("")) { //ALL 
			
			sql.append(" SELECT B.FLT_NUM, TO_CHAR(B.SCH_DEP_DT,'YYMMDD HH24MI') SCH_DEP_DT, ");
			sql.append(" TO_CHAR(B.SCH_DEP_DT,'YYMMDD') SCH_DATE, B.STNFR, B.STNTO, ");
			sql.append(" B.ROUTE_X, C.KACTYP, C.REGNO, ");
			sql.append(" TO_CHAR(B.SCH_DEP_DT, 'HH24:MI') STD, TO_CHAR(C.ACT_DEP_DT, 'HH24:MI') ATD, ");
			sql.append(" TO_CHAR(C.SCH_ARV_DT, 'HH24:MI') STA, TO_CHAR(C.ACT_ARV_DT, 'HH24:MI') ATA, ");
			sql.append(" C.CHGREAS, B.COMMENT_X, A.TITLE_E, B.COMMENT_E, ");
			sql.append(" TO_CHAR(A.IROPS_DT - 9/24, 'HH24:MI') IROPS_DT, TO_CHAR(A.MSG_DT - 9/24, 'HH24:MI') DSS_DT, "); //2009.10.06  : IROPS_DT, MSG_DT KST -> UTC
			sql.append(" TO_CHAR(A.DSS_START_DT, 'YYYYMMDDHH24MISS') DSS_START_DT, A.SEQ_NUM, ");
			sql.append(" TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24 * 60, 0) MIN ");
			sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
			
			//2010.04.15  : DSS_IROPS_SCH_T.SCH_DEP_DT -> DSS_IROPS_T.IROPS_DT
			//sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			//sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append(" WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append(" AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			
			sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append(" AND A.PROCESS_X = 'M' ");
			
			if (params.getTm().equals("12")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) >= 12 "); //12ð ̻
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("5")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) < 12 "); //5ð ~ 12ð
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) >= 5 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("4")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 4 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("3")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 3 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("2")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 2 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("1")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 1 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("0")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 0 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("-0")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 0 ");
				sql.append(" AND B.SCH_DEP_DT <= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("-1")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = -1 ");
				sql.append(" AND B.SCH_DEP_DT <= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("-2")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) <= -2 ");
				sql.append(" AND B.SCH_DEP_DT <= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("ALL")) { //ALL  12ð ̻ , 2010.04.15 ߰ : -1ð ̳ ~ -2ð ̻ , 0~12 ð ̸ ȸѴ.
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) < 12 ");
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) >= 0 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			}
			
			if (!params.getCommentX().equals("") && !params.getCommentX().equals("ALL")) {
				sql.append(" AND B.COMMENT_X = '"+params.getCommentX()+"' ");
			}
			
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			
			sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT(+) ");
			sql.append(" AND B.FLT_NUM = C.FLT_NUM(+) ");
			sql.append(" AND B.STNFR = C.STNFR(+) ");
			sql.append(" AND B.STNTO = C.STNTO(+) ");
			sql.append(" ORDER BY 1, 2 ");
		
		} else { //ڸ 
			
			sql.append(" SELECT C.FLT_NUM, TO_CHAR(C.SCH_DEP_DT,'YYMMDD HH24MI') SCH_DEP_DT, ");
			sql.append(" TO_CHAR(C.SCH_DEP_DT,'YYMMDD') SCH_DATE, C.STNFR, C.STNTO, ");
			sql.append(" B.ROUTE_X, C.KACTYP, C.REGNO, ");
			sql.append(" TO_CHAR(C.SCH_DEP_DT, 'HH24:MI') STD, TO_CHAR(C.ACT_DEP_DT, 'HH24:MI') ATD, ");
			sql.append(" TO_CHAR(C.SCH_ARV_DT, 'HH24:MI') STA, TO_CHAR(C.ACT_ARV_DT, 'HH24:MI') ATA, ");
			sql.append(" C.CHGREAS, B.COMMENT_X, A.TITLE_E, B.COMMENT_E, ");
			sql.append(" TO_CHAR(A.IROPS_DT - 9/24, 'HH24:MI') IROPS_DT, TO_CHAR(A.MSG_DT - 9/24, 'HH24:MI') DSS_DT, "); //2009.10.06  : IROPS_DT, MSG_DT KST -> UTC
			sql.append(" TO_CHAR(A.DSS_START_DT, 'YYYYMMDDHH24MISS') DSS_START_DT, A.SEQ_NUM, ");
			sql.append(" TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24 * 60, 0) MIN ");
			sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C, DSS_IROPS_DESK_T D ");
			
			//2010.04.15  : DSS_IROPS_SCH_T.SCH_DEP_DT -> DSS_IROPS_T.IROPS_DT
			//sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			//sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append(" WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append(" AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			
			sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append(" AND A.PROCESS_X = 'M' ");
			
			if (params.getTm().equals("12")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) >= 12 "); //12ð ̻
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("5")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) < 12 "); //5ð ~ 12ð
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) >= 5 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("4")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 4 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("3")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 3 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("2")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 2 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("1")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 1 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("0")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 0 ");
				sql.append(" AND B.SCH_DEP_DT >= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("-0")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = 0 ");
				sql.append(" AND B.SCH_DEP_DT <= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("-1")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) = -1 ");
				sql.append(" AND B.SCH_DEP_DT <= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("-2")) {
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) <= -2 ");
				sql.append(" AND B.SCH_DEP_DT <= A.MSG_DT - 9/24 ");
			
			} else if (params.getTm().equals("ALL")) { //ALL  12ð ̻ 
				sql.append(" AND TRUNC((B.SCH_DEP_DT + 9/24 - A.MSG_DT) * 24, 0) < 12 ");
			}
			
			if (!params.getCommentX().equals("") && !params.getCommentX().equals("ALL")) {
				sql.append(" AND B.COMMENT_X = '"+params.getCommentX()+"' ");
			}
			
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			
			sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
			sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
			sql.append(" AND B.STNFR = C.STNFR ");
			sql.append(" AND B.STNTO = C.STNTO ");
			sql.append(" AND B.DSS_START_DT = D.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = D.SEQ_NUM ");
			//DESK_X + USER_ID
			sql.append(" AND D.DESK_X = '"+params.getUserId().substring(0,1)+"' ");
			sql.append(" AND D.USER_ID = '"+params.getUserId().substring(1)+"' ");
			sql.append(" ORDER BY 1, 2 ");
		}
		
		System.out.println("[BASE:IroQ430Query:selPreReport] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS REPORT (Time Consumption) ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/08/28 
	  */
	public String selTimeReport(IroQ430BG params) {
		StringBuffer sql = new StringBuffer();
		
		if (params.getUserId().equals("")) { //ALL 
			
			/*
			sql.append(" SELECT C.FLT_NUM, TO_CHAR(C.SCH_DEP_DT,'YYMMDD HH24MI') SCH_DEP_DT, ");
			sql.append(" TO_CHAR(C.SCH_DEP_DT,'YYMMDD') SCH_DATE, C.STNFR, C.STNTO, ");
			sql.append(" B.ROUTE_X, C.KACTYP, C.REGNO, ");
			sql.append(" TO_CHAR(C.SCH_DEP_DT, 'HH24:MI') STD, TO_CHAR(C.ACT_DEP_DT, 'HH24:MI') ATD, ");
			sql.append(" TO_CHAR(C.SCH_ARV_DT, 'HH24:MI') STA, TO_CHAR(C.ACT_ARV_DT, 'HH24:MI') ATA, ");
			sql.append(" C.CHGREAS, B.COMMENT_X, A.TITLE_E, B.COMMENT_E, ");
			sql.append(" TO_CHAR(A.IROPS_DT - 9/24, 'HH24:MI') IROPS_DT, TO_CHAR(A.MSG_DT - 9/24, 'HH24:MI') DSS_DT, "); //2009.10.06  : IROPS_DT, MSG_DT KST -> UTC
			sql.append(" TO_CHAR(A.DSS_START_DT, 'YYYYMMDDHH24MISS') DSS_START_DT, A.SEQ_NUM, ");
			sql.append(" TRUNC((A.MSG_DT - A.IROPS_DT) * 24 * 60, 0) MIN ");
			sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
			
			//2010.04.15  : DSS_IROPS_SCH_T.SCH_DEP_DT -> DSS_IROPS_T.IROPS_DT
			//sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			//sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append(" WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append(" AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			
			sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append(" AND A.PROCESS_X = 'M' ");
			
			if (params.getTm().equals("5")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) >= 5 ");
			
			} else if (params.getTm().equals("4")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) = 4 ");
			
			} else if (params.getTm().equals("3")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) = 3 ");
			
			} else if (params.getTm().equals("2")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) = 2 ");
			
			} else if (params.getTm().equals("1")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) = 1 ");
			
			} else if (params.getTm().equals("0")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) = 0 ");
			}
			
			if (!params.getCommentX().equals("") && !params.getCommentX().equals("ALL")) {
				sql.append(" AND B.COMMENT_X = '"+params.getCommentX()+"' ");
			}
			
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			
			sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
			sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
			sql.append(" AND B.STNFR = C.STNFR ");
			sql.append(" AND B.STNTO = C.STNTO ");
			sql.append(" ORDER BY 1, 2 ");
			*/
			
			//2010.05.28  : FLT  CASE  
			sql.append(" SELECT DECODE(COMT_X, 1, 'CNL', 2, 'DLA', 3, 'CHG', 4, 'RTR', 5, 'DIV', 'NEW') COMMENT_X, RNG, ");
			sql.append(" TO_CHAR(A.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, A.SEQ_NUM, A.MIN, ");
			sql.append(" A.DECISION_E, A.TITLE_E, C.FLT_NUM ");
			sql.append(" FROM DSS_IROPS_SCH_T C, ");
			sql.append("     (SELECT MIN(DECODE(B.COMMENT_X,'CNL', 1, 'DLA', 2, 'CHG', 3, 'RTR', 4, 'DIV', 5, 6)) COMT_X, ");
			sql.append("     MAX(TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0)) RNG, ");
			sql.append("     MAX(A.DSS_START_DT) DSS_START_DT, MAX(A.SEQ_NUM) SEQ_NUM, ");
			sql.append("     MAX(TRUNC((A.MSG_DT - A.IROPS_DT) * 24 * 60, 0)) MIN, ");
			sql.append("     MAX(A.DECISION_E) DECISION_E, MAX(A.TITLE_E) TITLE_E ");
			sql.append("     FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B ");
			sql.append("     WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append("     AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append("     AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append("     AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append("     AND A.PROCESS_X = 'M' ");
			
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}  
			
			sql.append("     GROUP BY A.DSS_START_DT, B.SEQ_NUM) A ");
			sql.append(" WHERE A.DSS_START_DT = C.DSS_START_DT ");
			sql.append(" AND A.SEQ_NUM = C.SEQ_NUM ");
			
			if (params.getTm().equals("5")) sql.append(" AND RNG >= 5 ");
			else if (params.getTm().equals("4")) sql.append(" AND RNG = 4 ");
			else if (params.getTm().equals("3")) sql.append(" AND RNG = 3 ");
			else if (params.getTm().equals("2")) sql.append(" AND RNG = 2 ");
			else if (params.getTm().equals("1")) sql.append(" AND RNG = 1 ");
			else if (params.getTm().equals("0")) sql.append(" AND RNG = 0 ");
			
			if (!params.getCommentX().equals("") && !params.getCommentX().equals("ALL")) {
				
				if (params.getCommentX().equals("CNL")) sql.append(" AND COMT_X = 1 ");
				else if (params.getCommentX().equals("DLA")) sql.append(" AND COMT_X = 2 ");
				else if (params.getCommentX().equals("CHG")) sql.append(" AND COMT_X = 3 ");
				else if (params.getCommentX().equals("RTR")) sql.append(" AND COMT_X = 4 ");
				else if (params.getCommentX().equals("DIV")) sql.append(" AND COMT_X = 5 ");
				else if (params.getCommentX().equals("NEW")) sql.append(" AND COMT_X = 6 ");
			}
			sql.append(" ORDER BY A.DSS_START_DT, A.SEQ_NUM ");
			
		} else { //ڸ 
			
			/*
			sql.append(" SELECT C.FLT_NUM, TO_CHAR(C.SCH_DEP_DT,'YYMMDD HH24MI') SCH_DEP_DT, ");
			sql.append(" TO_CHAR(C.SCH_DEP_DT,'YYMMDD') SCH_DATE, C.STNFR, C.STNTO, ");
			sql.append(" B.ROUTE_X, C.KACTYP, C.REGNO, ");
			sql.append(" TO_CHAR(C.SCH_DEP_DT, 'HH24:MI') STD, TO_CHAR(C.ACT_DEP_DT, 'HH24:MI') ATD, ");
			sql.append(" TO_CHAR(C.SCH_ARV_DT, 'HH24:MI') STA, TO_CHAR(C.ACT_ARV_DT, 'HH24:MI') ATA, ");
			sql.append(" C.CHGREAS, B.COMMENT_X, A.TITLE_E, B.COMMENT_E, ");
			sql.append(" TO_CHAR(A.IROPS_DT - 9/24, 'HH24:MI') IROPS_DT, TO_CHAR(A.MSG_DT - 9/24, 'HH24:MI') DSS_DT, "); //2009.10.06  : IROPS_DT, MSG_DT KST -> UTC
			sql.append(" TO_CHAR(A.DSS_START_DT, 'YYYYMMDDHH24MISS') DSS_START_DT, A.SEQ_NUM, ");
			sql.append(" TRUNC((A.MSG_DT - A.IROPS_DT) * 24 * 60, 0) MIN ");
			sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C, DSS_IROPS_DESK_T D ");
			
			//2010.04.15  : DSS_IROPS_SCH_T.SCH_DEP_DT -> DSS_IROPS_T.IROPS_DT
			//sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			//sql.append(" AND B.SCH_DEP_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append(" WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append(" AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			
			sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append(" AND A.PROCESS_X = 'M' ");
			
			if (params.getTm().equals("5")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) >= 5 ");
			
			} else if (params.getTm().equals("4")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) = 4 ");
			
			} else if (params.getTm().equals("3")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) = 3 ");
			
			} else if (params.getTm().equals("2")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) = 2 ");
			
			} else if (params.getTm().equals("1")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) = 1 ");
			
			} else if (params.getTm().equals("0")) {
				sql.append(" AND TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0) = 0 ");
			}
			
			if (!params.getCommentX().equals("") && !params.getCommentX().equals("ALL")) {
				sql.append(" AND B.COMMENT_X = '"+params.getCommentX()+"' ");
			}
			
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			
			sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");
			sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
			sql.append(" AND B.STNFR = C.STNFR ");
			sql.append(" AND B.STNTO = C.STNTO ");
			sql.append(" AND B.DSS_START_DT = D.DSS_START_DT ");
			sql.append(" AND B.SEQ_NUM = D.SEQ_NUM ");
			//DESK_X + USER_ID
			sql.append(" AND D.DESK_X = '"+params.getUserId().substring(0,1)+"' ");
			sql.append(" AND D.USER_ID = '"+params.getUserId().substring(1)+"' ");
			sql.append(" ORDER BY 1, 2 ");
			*/
			
			//2010.05.28  : FLT  CASE  
			sql.append(" SELECT DECODE(COMT_X, 1, 'CNL', 2, 'DLA', 3, 'CHG', 4, 'RTR', 5, 'DIV', 'NEW') COMMENT_X, RNG, ");
			sql.append(" TO_CHAR(A.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, A.SEQ_NUM, A.MIN, ");
			sql.append(" A.DECISION_E, A.TITLE_E, C.FLT_NUM ");
			sql.append(" FROM DSS_IROPS_SCH_T C, ");
			sql.append("     (SELECT MIN(DECODE(B.COMMENT_X,'CNL', 1, 'DLA', 2, 'CHG', 3, 'RTR', 4, 'DIV', 5, 6)) COMT_X, ");
			sql.append("     MAX(TRUNC((A.MSG_DT - A.IROPS_DT) * 24, 0)) RNG, ");
			sql.append("     MAX(A.DSS_START_DT) DSS_START_DT, MAX(A.SEQ_NUM) SEQ_NUM, ");
			sql.append("     MAX(TRUNC((A.MSG_DT - A.IROPS_DT) * 24 * 60, 0)) MIN, ");
			sql.append("     MAX(A.DECISION_E) DECISION_E, MAX(A.TITLE_E) TITLE_E ");
			sql.append("     FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DSS_IROPS_DESK_T C ");
			sql.append("     WHERE A.IROPS_DT >= TO_DATE('20"+params.getStartDate()+"0000','YYYYMMDDHH24MI') ");
			sql.append("     AND A.IROPS_DT <= TO_DATE('20"+params.getEndDate()+"2359','YYYYMMDDHH24MI') ");
			sql.append("     AND B.DSS_START_DT = A.DSS_START_DT ");
			sql.append("     AND B.SEQ_NUM = A.SEQ_NUM ");
			sql.append("     AND A.PROCESS_X = 'M' ");
			sql.append("     AND B.DSS_START_DT = C.DSS_START_DT ");
			sql.append("     AND B.SEQ_NUM = C.SEQ_NUM ");
			//DESK_X + USER_ID
			sql.append("     AND C.DESK_X = '"+params.getUserId().substring(0,1)+"' ");
			sql.append("     AND C.USER_ID = '"+params.getUserId().substring(1)+"' ");
			
			if (!params.getRouteX().equals("")) {
				sql.append(" AND B.ROUTE_X = '"+params.getRouteX()+"' ");
			}
			
			sql.append("     GROUP BY A.DSS_START_DT, B.SEQ_NUM) A ");
			sql.append(" WHERE A.DSS_START_DT = C.DSS_START_DT ");
			sql.append(" AND A.SEQ_NUM = C.SEQ_NUM ");
			
			if (params.getTm().equals("5")) sql.append(" AND RNG >= 5 ");
			else if (params.getTm().equals("4")) sql.append(" AND RNG = 4 ");
			else if (params.getTm().equals("3")) sql.append(" AND RNG = 3 ");
			else if (params.getTm().equals("2")) sql.append(" AND RNG = 2 ");
			else if (params.getTm().equals("1")) sql.append(" AND RNG = 1 ");
			else if (params.getTm().equals("0")) sql.append(" AND RNG = 0 ");
			
			if (!params.getCommentX().equals("") && !params.getCommentX().equals("ALL")) {
				
				if (params.getCommentX().equals("CNL")) sql.append(" AND COMT_X = 1 ");
				else if (params.getCommentX().equals("DLA")) sql.append(" AND COMT_X = 2 ");
				else if (params.getCommentX().equals("CHG")) sql.append(" AND COMT_X = 3 ");
				else if (params.getCommentX().equals("RTR")) sql.append(" AND COMT_X = 4 ");
				else if (params.getCommentX().equals("DIV")) sql.append(" AND COMT_X = 5 ");
				else if (params.getCommentX().equals("NEW")) sql.append(" AND COMT_X = 6 ");
			}
			sql.append(" ORDER BY A.DSS_START_DT, A.SEQ_NUM ");
		}
		
		System.out.println("[BASE:IroQ430Query:selTimeReport] sql : "+sql.toString());
		return sql.toString();
	}
}
