package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  *   SQL 
  * @author Copyright (c) 2009/09/01 
  */ 
public class IroQ460Query {
	private static IroQ460Query instance = new IroQ460Query();
	
	public static IroQ460Query getInstance() {
		return instance;
	}
	
	/** 
	  * OCC, GOC  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/01 
	  */
	public String selOccGoc(IroQ460BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(MANAGER_D1,'YYYYMMDDHH24MISS') MANAGER_D1, "); //GOC : μ
		sql.append(" TO_CHAR(MANAGER_D2,'YYYYMMDDHH24MISS') MANAGER_D2 "); //OCC : 
		sql.append(" FROM DSS_IROPS_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		
		System.out.println("[BASE:IroQ460Query:selOccGoc] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * OCC, GOC  ó SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/01 
	  */
	public String updOccGoc(IroQ460BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE DSS_IROPS_T ");
		
		if (params.getAuth().equals("A")) {
			sql.append(" SET MANAGER_D1 = SYSDATE "); //GOC
		} else {
			sql.append(" SET MANAGER_D2 = SYSDATE "); //OCC
		}
		
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		
		System.out.println("[BASE:IroQ460Query:updOccGoc] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 1. DAILY_SCH_T  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/01 
	  */
	public String selMain1(IroQ460BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" TO_CHAR(MANAGER_D2 - 9/24,'YYYY/MM/DD HH24:MI') OCC, "); //2009.10.06  : MANAGER_D2 KST -> UTC
		sql.append(" TO_CHAR(MANAGER_D1 - 9/24,'YYYY/MM/DD HH24:MI') GOC, "); //2009.10.06  : MANAGER_D1 KST -> UTC
		sql.append(" A.DECISION_E, A.KOR_N, A.TITLE_E, ");
		sql.append(" TO_CHAR(A.IROPS_DT - 9/24, 'YYYY/MM/DD HH24:MI') IROPS_DT, "); //2009.10.06  : IROPS_DT KST -> UTC
		sql.append(" TO_CHAR(A.DSS_DT - 9/24, 'YYYY/MM/DD HH24:MI') DSS_DT, "); //2009.10.06  : DSS_DT KST -> UTC
		sql.append(" C.FLT_NUM, C.KACTYP, C.REGNO, C.STNFR, C.STNTO, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT, 'DDMON','NLS_DATE_LANGUAGE=AMERICAN') SCH_DEP_DM, "); // 2017.04.12 ߰
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'HH24:MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(C.SCH_ARV_DT,'HH24:MI') SCH_ARV_DT, ");
		sql.append(" TO_CHAR(C.EST_DEP_DT,'HH24:MI') EST_DEP_DT, ");
		sql.append(" C.F_BOOK, C.C_BOOK, C.Y_BOOK, ROUTE_X CGO_X, ROUTE_X, ");//@2013-10-xx B.ROUTE_X 
		sql.append(" B.COMMENT_X, B.COMMENT_E, ");
		sql.append(" C.DEL_RC1, C.DEL_DUR1, C.DEL_RC2, C.DEL_DUR2 ");
		//20141121 DAILY_SCH_T.DIV_STN ߰
		sql.append(" , C.DIV_STN ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");  
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		sql.append(" AND B.STNFR = C.STNFR ");
		sql.append(" AND B.STNTO = C.STNTO ");
		//sql.append(" AND A.PROCESS_X = 'M' ");
		sql.append(" AND A.PROCESS_X IN ('A','M') ");
		sql.append(" ORDER BY C.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroQ460Query:selMain1] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 2. DSS_NEW_SCH_T  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/01 
	  */
	public String selMain2(IroQ460BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" TO_CHAR(MANAGER_D2 - 9/24,'YYYY/MM/DD HH24:MI') OCC, "); //2009.10.06  : MANAGER_D2 KST -> UTC
		sql.append(" TO_CHAR(MANAGER_D1 - 9/24,'YYYY/MM/DD HH24:MI') GOC, "); //2009.10.06  : MANAGER_D1 KST -> UTC
		sql.append(" A.DECISION_E, A.KOR_N, A.TITLE_E, ");
		sql.append(" TO_CHAR(A.IROPS_DT - 9/24, 'YYYY/MM/DD HH24:MI') IROPS_DT, "); //2009.10.06  : IROPS_DT KST -> UTC
		sql.append(" TO_CHAR(A.DSS_DT - 9/24, 'YYYY/MM/DD HH24:MI') DSS_DT, "); //2009.10.06  : DSS_DT KST -> UTC
		sql.append(" C.FLT_NUM, C.KACTYP, C.REGNO, C.STNFR, C.STNTO, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'HH24:MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(C.SCH_ARV_DT,'HH24:MI') SCH_ARV_DT, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'HH24:MI') EST_DEP_DT, ");
		sql.append(" 0 F_BOOK, 0 C_BOOK, 0 Y_BOOK, 'CGO' CGO_X, ");
		sql.append(" B.COMMENT_X, B.COMMENT_E, B.ROUTE_X, ");//@2013-10-xx B.ROUTE_X 
		sql.append(" '' DEL_RC1, 0 DEL_DUR1, '' DEL_RC2, 0 DEL_DUR2 ");
		//20141121 DSS_NEW_SCH_T.DIV_STN ÷   ÷ ߰
		sql.append(" , '' DIV_STN ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DSS_NEW_SCH_T C ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");  
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		sql.append(" AND B.STNFR = C.STNFR ");
		sql.append(" AND B.STNTO = C.STNTO ");
		//sql.append(" AND A.PROCESS_X = 'M' ");
		sql.append(" AND A.PROCESS_X IN ('A','M') ");
		sql.append(" ORDER BY C.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroQ460Query:selMain2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 3. DAILY_SCH_T  ȸ SQLԼ.
	  * (div-ȸ    ִ )
	  * @return String Query  
	  * @author Copyright (c) 2009/09/01 ( : 2012/02/24 )
	  */
	public String selMain3(IroQ460BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" TO_CHAR(MANAGER_D2 - 9/24,'YYYY/MM/DD HH24:MI') OCC, "); //2009.10.06  : MANAGER_D2 KST -> UTC
		sql.append(" TO_CHAR(MANAGER_D1 - 9/24,'YYYY/MM/DD HH24:MI') GOC, "); //2009.10.06  : MANAGER_D1 KST -> UTC
		sql.append(" A.DECISION_E, A.KOR_N, A.TITLE_E, ");
		sql.append(" TO_CHAR(A.IROPS_DT - 9/24, 'YYYY/MM/DD HH24:MI') IROPS_DT, "); //2009.10.06  : IROPS_DT KST -> UTC
		sql.append(" TO_CHAR(A.DSS_DT - 9/24, 'YYYY/MM/DD HH24:MI') DSS_DT, "); //2009.10.06  : DSS_DT KST -> UTC
		sql.append(" C.FLT_NUM, C.KACTYP, C.REGNO, C.STNFR, C.STNTO, ");
		sql.append(" TO_CHAR(C.SCH_DEP_DT,'HH24:MI') SCH_DEP_DT, ");
		sql.append(" TO_CHAR(C.SCH_ARV_DT,'HH24:MI') SCH_ARV_DT, ");
		sql.append(" TO_CHAR(C.EST_DEP_DT,'HH24:MI') EST_DEP_DT, ");
		sql.append(" C.F_BOOK, C.C_BOOK, C.Y_BOOK, ROUTE_X CGO_X, ROUTE_X, ");//@2013-10-xx B.ROUTE_X 
		sql.append(" B.COMMENT_X, B.COMMENT_E, ");
		sql.append(" C.DEL_RC1, C.DEL_DUR1, C.DEL_RC2, C.DEL_DUR2 ");
		//20141121 DAILY_SCH_T.DIV_STN ߰
		sql.append(" , C.DIV_STN ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
		sql.append(" WHERE B.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND B.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT ");  
		sql.append(" AND B.FLT_NUM = C.FLT_NUM ");
		sql.append(" AND B.STNFR = C.STNFR ");
		sql.append(" AND C.STNFR <> C.STNTO ");//selMain1() AND B.STNTO = C.STNTO ü
		//sql.append(" AND A.PROCESS_X = 'M' ");
		sql.append(" AND A.PROCESS_X IN ('A','M') ");
		sql.append(" ORDER BY C.SCH_DEP_DT ");
		
		System.out.println("[BASE:IroQ460Query:selMain3] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DESK  ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/01 
	  */
	public String selDeskInfo(IroQ460BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.DESK_X, TO_CHAR(A.TIMESTAMP - 9/24,'YYYY/MM/DD HH24:MI:SS') SM, "); //2009.10.06  : TIMESTAMP KST -> UTC
		sql.append(" B.CODE_X, A.KOR_N, ");
		sql.append(" TO_CHAR(A.TIMESTAMP - 9/24,'HH24:MI') TIMESTAMP, "); //2009.10.06  : TIMESTAMP KST -> UTC
		sql.append(" A.DECISION_X, A.DECISION_E ");
		sql.append(" FROM DSS_IROPS_DESK_T A, CODE_T B ");
		sql.append(" WHERE A.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND A.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND A.DESK_X = B.DESC_E ");
		sql.append(" AND B.STEP_X = '0' ");
		sql.append(" AND B.CODE_C = 'Head' ");
		sql.append(" AND B.USE_Y = 'N' ");
		//sql.append(" AND B.END_D > TO_CHAR(SYSDATE,'YYYYMMDD') ");
		sql.append(" ORDER BY A.DESK_X ");
		
		System.out.println("[BASE:IroQ460Query:selDeskInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SITA MESSAGE ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/02 
	  */
	public String selMessage(IroQ460BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT MESSAGE ");
		sql.append(" FROM DSS_IROPS_MSG_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		//sql.append(" AND MSG_SEQ_NUM = 1 ");
		//2010.02.19  :  MSG =>  MSG  
		sql.append(" AND ROWNUM = 1 ");
		sql.append(" ORDER BY MSG_SEQ_NUM DESC ");
		
		System.out.println("[BASE:IroQ460Query:selMessage] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MSG_SEQ_NUM ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/03 
	  */
	public String selMsgSeqNum(IroQ460BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT MSG_SEQ_NUM ");
		sql.append(" FROM DSS_IROPS_MSG_T ");
		sql.append(" WHERE DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND SEQ_NUM = "+params.getSeqNum());
		sql.append(" ORDER BY MSG_SEQ_NUM ");
		
		System.out.println("[BASE:IroQ460Query:selMsgSeqNum] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * MESSAGE ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/03 
	  */
	public String selMsg(IroQ460BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.DECISION_E, B.MESSAGE ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_MSG_T B ");
		sql.append(" WHERE A.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND A.SEQ_NUM = "+params.getSeqNum());
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND A.SEQ_NUM = B.SEQ_NUM ");
		sql.append(" AND B.MSG_SEQ_NUM = "+params.getMsgSeqNum());
		sql.append(" AND A.PROCESS_X = 'M' ");
		
		System.out.println("[BASE:IroQ460Query:selMsg] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * IROPS History Message ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/03 
	  */
	public String selHistoryMsg(IroQ460BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.TITLE_E, B.MSG_E, C.CODE_X, B.KOR_N, B.DSS_LVL_X, ");
		sql.append(" TO_CHAR(B.TIMESTAMP,'YYMMDD HH24:MI') TIMESTAMP, ");
		sql.append(" TO_CHAR(B.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, B.MSG_NO, B.LVL_NO ");
		sql.append(" FROM DSS_MSG_HEAD_T A, DSS_MSG_DETAIL_T B, CODE_T C ");
		sql.append(" WHERE A.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND B.DESK_X = C.DESC_E(+) ");
		sql.append(" AND C.STEP_X(+) = '0' ");
		sql.append(" AND C.USE_Y(+) = 'N' ");
		sql.append(" AND C.CODE_C(+) = 'Head' ");
		//sql.append(" AND C.END_D(+) > TO_CHAR(SYSDATE,'YYYYMMDD') ");
		sql.append(" ORDER BY B.MSG_NO, B.LVL_NO ");
		
		System.out.println("[BASE:IroQ460Query:selHistoryMsg] sql : "+sql.toString());
		return sql.toString();
	}
	
	//20160331 ߰
	public String selHistoryMsgSchPop(IroQ460BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.TITLE_E, B.MSG_E, C.CODE_X, B.KOR_N, B.DSS_LVL_X, ");
		sql.append(" A.FLT_NUM, A.SCH_DEP_D, ");
		sql.append(" TO_CHAR(B.TIMESTAMP - 9/24,'YYMMDD HH24:MI') TIMESTAMP, ");
		sql.append(" TO_CHAR(B.DSS_START_DT,'YYYYMMDDHH24MISS') DSS_START_DT, B.MSG_NO, B.LVL_NO ");
		sql.append(" FROM DSS_MSG_HEAD_T A, DSS_MSG_DETAIL_T B, CODE_T C ");
		sql.append(" WHERE A.DSS_START_DT = TO_DATE('"+params.getDssStartDt()+"','YYYYMMDDHH24MISS') ");
		sql.append(" AND A.DSS_START_DT = B.DSS_START_DT ");
		sql.append(" AND B.DESK_X = C.DESC_E(+) ");
		sql.append(" AND C.STEP_X(+) = '0' ");
		sql.append(" AND C.USE_Y(+) = 'N' ");
		sql.append(" AND C.CODE_C(+) = 'Head' ");
		//sql.append(" AND C.END_D(+) > TO_CHAR(SYSDATE,'YYYYMMDD') ");
		sql.append(" ORDER BY B.MSG_NO, B.LVL_NO ");
		
		System.out.println("[BASE:IroQ460Query:selHistoryMsgSchPop] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String selEmailAddr(String portList) {//@2013-06-10 ߰
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT GROUP_C, ADDR_E ");
		sql.append(" FROM CM_GROUP_ADDR_T ");
		sql.append(" WHERE PROJECT_C = 'BASEDSS' ");
		//sql.append(" WHERE PROJECT_C = 'TEST' ");//		2013-10-29 ӽü
		sql.append(" AND NETWORK_X = 'EMAIL' ");
		
		if (!"".equals(portList)) sql.append(" AND GROUP_C IN ("+portList+") ");
		
		sql.append(" ORDER BY SEQ_NO ");
		
		System.out.println("[BASE:IroA340Query:selEmailAddr] sql : "+sql.toString());
		return sql.toString();
	}
	
}
