package kal.base.iro.query;

import kal.base.jdf.com.Logger;
import kal.base.iro.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

 /**
  * FLT Progress Information SQL 
  * @author Copyright (c) 2009/09/15 
  */ 
public class IroQ470Query {
	private static IroQ470Query instance = new IroQ470Query();
	
	public static IroQ470Query getInstance() {
		return instance;
	}
	
	/** 
	  * FLT INFORMATION ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/15 
	  */
	public String selFltInfo(IroQ470BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.FLT_NUM, TO_CHAR(A.SCH_DEP_DT_LOC, 'YYYY-MM-DD') SCH_DT, ");// 2017.5.26 SCH_DEP_DT -> SCH_DEP_DT_LOC  
		sql.append(" A.KACTYP, A.ACVER, A.REGNO, A.STNFR, A.STNTO, ");
		
		if (StringUtil.checkString(params.getIropsY()).equals("Y")) { //2010.04.22 ߰ : irops_status ˾ ؼ   Local Time ǥ
			sql.append(" TO_CHAR(A.SCH_DEP_DT_LOC, 'HH24:MI') STD, TO_CHAR(A.SCH_ARV_DT_LOC, 'HH24:MI') STA, ");
			sql.append(" TO_CHAR(A.EST_DEP_DT_LOC, 'HH24:MI') ETD, TO_CHAR(A.EST_ARV_DT_LOC, 'HH24:MI') ETA, ");
			sql.append(" TO_CHAR(A.ACT_DEP_DT_LOC, 'HH24:MI') ATD, TO_CHAR(A.ACT_ARV_DT_LOC, 'HH24:MI') ATA, ");
			sql.append(" NVL2(A.TKOF_T,TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(A.TKOF_T),'0000'),'YYYYMMDDHH24MI')+(A.DEP_GMT_OFFSET/1440),'HH24:MI'),'') TKOF_T, ");
			sql.append(" NVL2(A.LAND_T,TO_CHAR(TO_DATE(TO_CHAR(SYSDATE,'YYYYMMDD')||NVL(TRIM(A.LAND_T),'0000'),'YYYYMMDDHH24MI')+(A.ARV_GMT_OFFSET/1440),'HH24:MI'),'') LAND_T, ");
			
		} else {
			sql.append(" TO_CHAR(A.SCH_DEP_DT, 'HH24:MI') STD, TO_CHAR(A.SCH_ARV_DT, 'HH24:MI') STA, ");
			sql.append(" TO_CHAR(A.EST_DEP_DT, 'HH24:MI') ETD, TO_CHAR(A.EST_ARV_DT, 'HH24:MI') ETA, ");
			sql.append(" TO_CHAR(A.ACT_DEP_DT, 'HH24:MI') ATD, TO_CHAR(A.ACT_ARV_DT, 'HH24:MI') ATA, ");
			sql.append(" NVL2(A.TKOF_T, SUBSTR(A.TKOF_T,1,2)||':'||SUBSTR(A.TKOF_T,3,2),'') TKOF_T, ");
			sql.append(" NVL2(A.LAND_T, SUBSTR(A.LAND_T,1,2)||':'||SUBSTR(A.LAND_T,3,2),'') LAND_T, ");
		}
		sql.append(" A.DEL_RC1, A.DEL_DUR1, A.DEL_RC2, A.DEL_DUR2, ");
		sql.append(" A.SPOT_OUT, A.SPOT_IN, A.DEP_STS, A.ARV_STS, ");
		sql.append(" TO_CHAR(B.FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		sql.append(" TO_CHAR(B.SCH_ARV_DT_LOC, 'YYYY-MM-DD HH24:MI') SCH_ARV_DT_LOC, ");
		sql.append(" NVL(B.F_CFG,0)||' / '||NVL(B.C_CFG,0)||' / '||NVL(B.Y_CFG,0) CFG, ");
		sql.append(" NVL(B.F_BOOK,0)||' / '||NVL(B.C_BOOK,0)||' / '||NVL(B.Y_BOOK,0) RSVN, ");
		sql.append(" NVL(B.F_CHKIN,0)||' / '||NVL(B.C_CHKIN,0)||' / '||NVL(B.Y_CHKIN,0) CHK_IN ");
		sql.append(" FROM DAILY_SCH_T A, DAILY_SCH_T B ");
		sql.append(" WHERE B.ARLN_CD = 'KE' ");
		//2017.06.21 SCH_DEP_DT_LOC 
		//sql.append(" AND B.SCH_DEP_DT = TO_DATE('"+params.getSchDepDt()+"','YYYYMMDDHH24MI') ");
		
		//2017-08-04 SCH_DEP_DT_LOC SCH_DEP_DT  ٲ
		sql.append(" AND TO_CHAR(B.SCH_DEP_DT, 'YYYYMMDD') = SUBSTRB('"+params.getSchDepDt()+"',0,8) ");
		
		sql.append(" AND B.FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND B.STNFR = '"+params.getStnfr()+"' ");
		sql.append(" AND B.STNTO = '"+params.getStnto()+"' ");
		sql.append(" AND B.STNFR <> B.STNTO ");
		sql.append(" AND A.ARLN_CD = 'KE' ");
		sql.append(" AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" AND A.STNFR <> A.STNTO ");
		sql.append(" ORDER BY A.SCH_DEP_DT, A.FLT_NUM ");
		
		System.out.println("[BASE:IroQ470Query:selFltInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * CATEGORY INFORMATION ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/15 
	  */
	public String selCategoryInfo(IroQ470BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(B.CAT3_EXPDT, 'YYYY-MM-DD') CAT3_DATE, ");
		sql.append(" TO_CHAR(B.CAT2_EXPDT, 'YYYY-MM-DD') CAT2_DATE, ");
		sql.append(" 'KE'||A.FLT_NUM||' / '||TO_CHAR(B.LATEST_AUTODT,'YYYY-MM-DD')||' / '||A.STNFR||' - '||A.STNTO CAT_LAST ");
		sql.append(" FROM PE_ACARS_SKD_T A, PE_ACREG_INFO_T B, ");
		sql.append(" (SELECT MAX(ACT_ON_DT) ACT_ON_DT, REGNO ");
		sql.append(" FROM PE_ACARS_SKD_T ");
		sql.append(" WHERE CAT_X = 'Y' ");
		sql.append(" AND REGNO = '"+params.getRegno()+"' ");
		sql.append(" GROUP BY REGNO) C ");
		sql.append(" WHERE A.REGNO = '"+params.getRegno()+"' ");
		sql.append(" AND A.REGNO = B.REGNO ");
		sql.append(" AND A.REGNO = C.REGNO ");
		sql.append(" AND A.CAT_X = 'Y' ");
		sql.append(" AND A.ACT_ON_DT = C.ACT_ON_DT ");
		sql.append(" AND ROWNUM = 1 ");
		
		System.out.println("[BASE:IroQ470Query:selCategoryInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * CREW INFORMATION(CREW INFO, CREW PREV, NEXT FLT INFO) ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/15 
	  */
	public String selCrewInfo(IroQ470BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT B.STAFF_NUM, SUBSTR(B.ENG_NAME,1,30) ENG_NAME, ");
		sql.append(" DECODE(B.RANK_NR, '11', 'CAP', '12', 'F/O', 'F/E') RANK, ");
		sql.append(" DECODE(B.RANK_NR, '11', 'FLY', '12', 'FLY', '13', 'FLY', 'EXT') DUTY, ");
		sql.append(" PRV_ARLN_CD||PRV_FLT_NUM||'/'||TO_CHAR(PRV_DEP_LDT, 'DDMONYY')||' - '||PRV_STNFR||'/'||PRV_STNTO PREV_INFO, ");
		sql.append(" NXT_ARLN_CD||NXT_FLT_NUM||'/'||TO_CHAR(NXT_DEP_LDT, 'DDMONYY')||' - '||NXT_STNFR||'/'||NXT_STNTO NEXT_INFO ");
		sql.append(" FROM GD_SKD_T A, GD_CREW_T B ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND A.FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND (A.STNFR = '"+params.getStnfr()+"' OR A.STNTO = '"+params.getStnto()+"') ");
		sql.append(" AND A.FLT_SEQ_NR = B.FLT_SEQ_NR ");
		sql.append(" AND B.RANK_NR LIKE '1%' ");
		sql.append(" AND DA_IND = 'A' ");
		sql.append(" AND (B.CREW_SEQ_NR, B.STAFF_NUM) IN ");
		sql.append(" (SELECT MAX(CREW_SEQ_NR), STAFF_NUM ");
		sql.append(" FROM GD_CREW_T ");
		sql.append(" WHERE FLT_SEQ_NR = A.FLT_SEQ_NR ");
		sql.append(" GROUP BY STAFF_NUM) ");
		sql.append(" ORDER BY B.RANK_NR, B.STAFF_NUM ");
		
		System.out.println("[BASE:IroQ470Query:selCrewInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * CREW INFORMATION(CREW LAST FLT INFO) ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/15 
	  */
	public String selCrewInfoLast(String staffNum) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ARLN_CD||FLT_NUM||'/'||TO_CHAR(LAND_ON_DT, 'DDMONYY')||' - '||REGNO LAST_INFO ");
		sql.append(" FROM FS_LOG_SKD_T ");
		sql.append(" WHERE LAND_ON_CREW = '"+staffNum+"' ");
		sql.append(" AND LANDING_TYPE = 'A' ");
		sql.append(" AND ROWNUM = 1 ");
		sql.append(" ORDER BY LAND_ON_DT DESC ");
		
		System.out.println("[BASE:IroQ470Query:selCrewInfoLast] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * DCS INFORMATION ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/15 
	  */
	public String selDcsInfo(IroQ470BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT NVL(F_CFG_Q,0)||' / '||NVL(C_CFG_Q,0)||' / '||NVL(Y_CFG_Q,0) CFG, ");
		sql.append(" NVL(F_BOOK_Q,0)||' / '||NVL(C_BOOK_Q,0)||' / '||NVL(Y_BOOK_Q,0) RSVN, ");
		sql.append(" NVL(F_CHECK_Q,0)||' / '||NVL(C_CHECK_Q,0)||' / '||NVL(Y_CHECK_Q,0) CHK_IN, ");
		sql.append(" NVL(CAPT_CREW_Q,0)||' / '||NVL(CBN_CREW_MAN_Q,0)||' / '||NVL(CBN_CREW_WOMAN_Q,0) CREW, ");
		sql.append(" MAX_PAYLOAD_Q, ACT_PAYLOAD_Q, ACT_BEW_Q, ACT_SOW_Q, ");
		sql.append(" ACT_ZFW_Q, ACT_TOW_Q, EST_LDW_Q, TOF_Q, ");
		sql.append(" TIF_Q, CGO_WT_Q, MAIL_WT_Q, BAG_WT_Q ");
		sql.append(" FROM BASE_DCS_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND STNFR = '"+params.getStnfr()+"' ");
		sql.append(" AND STNTO = '"+params.getStnto()+"' ");
		
		System.out.println("[BASE:IroQ470Query:selDcsInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * AIRCRAFT CONNECTION INFORMATION ȸ SQLԼ. -- .
	  * @return String Query  
	  * @author Copyright (c) 2009/09/15 
	  */
	public String selAircraftConnInfo(IroQ470BG params) {
		StringBuffer sql = new StringBuffer();
		
		String schDepDt = params.getSchDepDt().substring(0,8);
		
		sql.append(" SELECT FLT_NUM, STNFR, STNTO, ");
		sql.append(" TO_CHAR(SCH_DEP_DT, 'HH24:MI') STD, TO_CHAR(SCH_ARV_DT, 'HH24:MI') STA, ");
		sql.append(" TO_CHAR(EST_DEP_DT, 'HH24:MI') ETD, TO_CHAR(EST_ARV_DT, 'HH24:MI') ETA, ");
		sql.append(" TO_CHAR(ACT_DEP_DT, 'HH24:MI') ATD, TO_CHAR(ACT_ARV_DT, 'HH24:MI') ATA, ");
		sql.append(" NVL2(TKOF_T, SUBSTR(TKOF_T,1,2)||':'||SUBSTR(TKOF_T,3,2),'') TKOF_T, ");
		sql.append(" NVL2(LAND_T, SUBSTR(LAND_T,1,2)||':'||SUBSTR(LAND_T,3,2),'') LAND_T, ");
		sql.append(" SPOT_OUT, SPOT_IN, DEP_STS, ARV_STS ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		sql.append(" AND SCH_DEP_DT >= TO_DATE('"+schDepDt+"0000','YYYYMMDDHH24MI') ");
		sql.append(" AND SCH_DEP_DT <= TO_DATE('"+schDepDt+"2359','YYYYMMDDHH24MI') ");
		sql.append(" AND DEP_STS <> 'INI' ");
		sql.append(" AND ACTNID <> 'CNL' ");
		sql.append(" AND REGNO = '"+params.getRegno()+"' ");
		sql.append(" ORDER BY SCH_DEP_DT, ACT_DEP_DT ");
		
		System.out.println("[BASE:IroQ470Query:selAircraftConnInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * PAX CONNECTION INFORMATION ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/15 
	  */
	public String selPaxConnInfo1(IroQ470BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.TRANS_ARLN_CD, A.TRANS_FLT_NUM, A.TRANS_STN_C, ");
		sql.append(" TO_CHAR(A.TRANS_DT,'YYYY-MM-DD HH24:MI') TRANS_DT, ");
		sql.append(" A.F_BOOK_Q+A.C_BOOK_Q+A.Y_BOOK_Q BOOK_Q, ");
		sql.append(" A.F_CHKIN_Q, A.F_BOOK_Q, A.C_CHKIN_Q, A.C_BOOK_Q, A.Y_CHKIN_Q, A.Y_BOOK_Q, A.BAG_Q ");
		sql.append(" FROM BASE_DCS_TRANS_T A ");
		sql.append(" WHERE A.ARLN_CD = 'KE' ");
		sql.append(" AND A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND A.FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND A.STNFR = '"+params.getStnfr()+"' ");
		sql.append(" AND A.STNTO = '"+params.getStnto()+"' ");
		sql.append(" AND A.DEP_ARV_X = 'D' ");
		sql.append(" ORDER BY A.TRANS_DT ");
		
		System.out.println("[BASE:IroQ470Query:selPaxConnInfo1] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * PAX CONNECTION INFORMATION ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/15 
	  */
	public String selPaxConnInfo2(IroQ470BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.TRANS_ARLN_CD, A.TRANS_FLT_NUM, A.TRANS_STN_C, ");
		sql.append(" TO_CHAR(A.TRANS_DT,'YYYY-MM-DD HH24:MI') TRANS_DT, ");
		sql.append(" A.F_BOOK_Q+A.C_BOOK_Q+A.Y_BOOK_Q BOOK_Q, ");
		sql.append(" A.F_CHKIN_Q, A.F_BOOK_Q, A.C_CHKIN_Q, A.C_BOOK_Q, A.Y_CHKIN_Q, A.Y_BOOK_Q, A.BAG_Q ");
		sql.append(" FROM BASE_DCS_TRANS_T A ");
		sql.append(" WHERE A.ARLN_CD = 'KE' ");
		sql.append(" AND A.FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"','YYYYMMDD') ");
		sql.append(" AND A.FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND A.STNFR = '"+params.getStnfr()+"' ");
		sql.append(" AND A.STNTO = '"+params.getStnto()+"' ");
		sql.append(" AND A.DEP_ARV_X = 'A' ");
		
		System.out.println("[BASE:IroQ470Query:selPaxConnInfo2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * PAX CONNECTION INFORMATION - TRANS_ARLN_CD = 'KE' ϶ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/15 
	  */
	public String selTransArlnCdKE(String schArvDtLoc, String transDt, String transFltNum, String transStnC) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SCH_DEP_DT_LOC,'HH24:MI') SCH_DEP_DT_LOC ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE ARLN_CD = 'KE' ");
		sql.append(" AND SCH_DEP_DT_LOC >= TO_DATE('"+schArvDtLoc+"','YYYY-MM-DD HH24:MI') ");
		sql.append(" AND SCH_DEP_DT_LOC >= TO_DATE('"+transDt+"','YYYY-MM-DD HH24:MI') ");
		sql.append(" AND SCH_DEP_DT_LOC <= TO_DATE('"+transDt+"','YYYY-MM-DD HH24:MI') + 1 ");
		sql.append(" AND FLT_NUM = '"+transFltNum+"' ");
		sql.append(" AND STNTO = '"+transStnC+"' ");
		sql.append(" AND ROWNUM = 1 ");
		sql.append(" ORDER BY SCH_DEP_DT_LOC ");
		
		System.out.println("[BASE:IroQ470Query:selTransArlnCdKE] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * PAX CONNECTION INFORMATION - STNTO = 'ICN' ϶ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2009/09/15 
	  */
	public String selStntoICN(String schArvDtLoc, String transDt, String transArlnCd, String transFltNum) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SCH_DT_LOC,'HH24:MI') SCH_DT_LOC ");
		sql.append(" FROM FO_DAILY_RAMP_T ");
		sql.append(" WHERE SCH_DT_LOC >= TO_DATE('"+schArvDtLoc+"','YYYY-MM-DD HH24:MI') ");
		sql.append(" AND SCH_DT_LOC >= TO_DATE('"+transDt+"','YYYY-MM-DD HH24:MI') ");
		sql.append(" AND SCH_DT_LOC <= TO_DATE('"+transDt+"','YYYY-MM-DD HH24:MI') + 1 ");
		sql.append(" AND ARLN_CD = '"+transArlnCd+"' ");
		sql.append(" AND FLT_NUM = '"+transFltNum+"' ");
		sql.append(" AND DEPARV_X = 'D' ");
		sql.append(" AND STN = 'ICN' ");
		
		System.out.println("[BASE:IroQ470Query:selStntoICN] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FLT_NUM ش  ˻ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2012/03/15 
	  */
	public String selSearchFltInfo(IroQ470BG params) {
		StringBuffer sql = new StringBuffer();
		
		/*
		sql.append(" SELECT TO_CHAR(B.SCH_DEP_DT,'YYYYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append("     C.REGNO, B.STNFR, B.STNTO ");
		sql.append(" FROM DSS_IROPS_T A, DSS_IROPS_SCH_T B, DAILY_SCH_T C ");
		sql.append(" WHERE B.SCH_DEP_DT >= TO_DATE('"+params.getSchDepDt()+"0000','YYYYMMDDHH24MI') ");
		sql.append(" AND B.SCH_DEP_DT <= TO_DATE('"+params.getSchDepDt()+"2359','YYYYMMDDHH24MI') ");
		sql.append(" AND B.DSS_START_DT = A.DSS_START_DT ");
		sql.append(" AND B.SEQ_NUM = A.SEQ_NUM ");
		sql.append(" AND A.PROCESS_X IN ('A', 'M') ");
		sql.append(" AND B.HIDE_Y = 'N' ");
		sql.append(" AND B.ARLN_CD = C.ARLN_CD(+) ");
		sql.append(" AND B.FIRST_LEG_FLT_DT = C.FIRST_LEG_FLT_DT(+) ");
		sql.append(" AND B.FLT_NUM = C.FLT_NUM(+) ");
		sql.append(" AND B.LEG_NUM = C.LEG_NUM(+) ");
		sql.append(" AND B.FLT_NUM = '"+params.getFltNum()+"' ");
		sql.append(" AND C.DEP_STS(+) <> 'INI' ");
		sql.append(" ORDER BY B.SCH_DEP_DT ");
		*/
		
		//2012.03.19   ü
		sql.append(" SELECT TO_CHAR(SCH_DEP_DT,'YYYYMMDDHH24MI') SCH_DEP_DT, ");
		sql.append("     REGNO,  STNFR,  STNTO ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT >= TO_DATE('"+params.getFirstLegFltDt()+"0000','YYYYMMDDHH24MI') ");
		sql.append(" AND FIRST_LEG_FLT_DT <= TO_DATE('"+params.getFirstLegFltDt()+"2359','YYYYMMDDHH24MI') ");
		// FIRST_LEG_FLT_DT = TO_DATE('"+params.getFirstLegFltDt()+"0000','YYYYMMDDHH24MI')
		sql.append(" AND FLT_NUM = '"+params.getFltNum()+"' ");
		if(!params.getStnfr().equals("")){
		    sql.append(" AND STNFR = '"+params.getStnfr()+"' ");
		}
		sql.append(" AND STNFR <> STNTO ");
		
		System.out.println("[BASE:IroQ470Query:SearchFltInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FLT_NUM ش  ˻ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2012/03/15 
	  */
	public String selNextFltInfo(IroQ470BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT FLT_NUM, TO_CHAR(SCH_DEP_DT_LOC,'YYYY-MM-DD') SCH_DEP_DT_LOC, TO_CHAR(SCH_DEP_DT_LOC,'HH24MI') STD, STNFR, STNTO, SCH_DEP_DT_LOC ORD ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE SCH_DEP_DT > TO_DATE('"+params.getSchDepDt()+"','YYYYMMDDHH24MI') ");
		sql.append(" AND REGNO = '"+params.getRegno()+"' ");
		//sql.append(" AND DEP_STS <> 'INI' ");
		sql.append(" AND ACTNID <> 'CNL' ");
		sql.append(" ORDER BY ORD ASC ");
		
		System.out.println("[BASE:IroQ470Query:NextFltInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
}
