package kal.base.jdf.com;

/**
 * @(#) CharConversion.java
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
import java.io.UnsupportedEncodingException; 

public final class CharConversion {

	/**
	 * Don't let anyone instantiate this class
	 */
	private CharConversion() {
	}

	/**
	 * 8859_1 --> KSC5601.
	 */
	public static synchronized String E2K( String english )
	{
		String korean = null;
	
		if (english == null ) return null;
		//if (english == null ) return "";
		
		try { 
			korean = new String(new String(english.getBytes("8859_1"), "KSC5601"));
		}
		catch( UnsupportedEncodingException e ){
			korean = new String(english);
		}
		return korean;
	}

	/**
	 * KSC5601 --> 8859_1.
	 */
	public static synchronized String K2E( String korean )
	{
		String english = null;
		
		if (korean == null ) return null;
		//if (korean == null ) return "";
		
		english = new String(korean);
		try { 
			english = new String(new String(korean.getBytes("KSC5601"), "8859_1"));
		}
		catch( UnsupportedEncodingException e ){
			english = new String(korean);
		}
		return english;
	}
}