package kal.base.jdf.com;

/**
 * @(#) Configuration.java
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
import java.util.Properties;
import java.io.File;
import java.io.FileInputStream;

public class Configuration extends GeneralConfiguration
{
	private static long jdf_last_modified = 0;
	private static long pbf_last_modified = 0;


	private static String jdf_file_name = null;
	static {
		//2008.12.29  : jdf.properties => jdf2.properties
		//2009.12.08  : jdf2.properties .
		//File default_file = new File(System.getProperty("user.home"), "jdf2.properties");
		//jdf_file_name = System.getProperty("kal.base.jdf.com.config.file", default_file.getAbsolutePath());
	}
	
	/**
	 *
	 */
	public Configuration() throws ConfigurationException {
		super();
		initialize();
	}

	/**
	 * 
	 */
	protected void initialize() throws ConfigurationException {
		synchronized(lock){	
			try{
				boolean needUpdate = false;

			// Java Development Framework Configuration File
				File jdf_file = new File(jdf_file_name);
				if ( ! jdf_file.canRead() ) 
					throw new ConfigurationException( this.getClass().getName() + " - Can't open jdf configuration file: " + jdf_file_name );
				
				if ( (jdf_last_modified != jdf_file.lastModified() ) || props == null ) {
					needUpdate = true;
				}
				else {
					String pbf_file_name = props.getProperty("com.lgeds.jdf.config.pbf.file");
					if ( pbf_file_name != null ) {
						File pbf_file = new File(pbf_file_name);
						if ( ! pbf_file.canRead() ) 
							throw new ConfigurationException( this.getClass().getName() + " - Can't open pbf configuration file: " + pbf_file_name );
						if ( pbf_last_modified != pbf_file.lastModified() ) {
							needUpdate = true;
						}
					}
				}// end if
				
				if ( needUpdate ) {
					props = new java.util.Properties();
					FileInputStream jdf_fin = new FileInputStream(jdf_file);
					props.load(new java.io.BufferedInputStream(jdf_fin));
					
					jdf_fin.close();
					jdf_last_modified = jdf_file.lastModified();

					String pbf_file_name = props.getProperty("kal.base.jdf.com.config.pbf.file");
					if ( pbf_file_name != null ) {
						File pbf_file = new File(pbf_file_name);
						if ( ! pbf_file.canRead() ) 
							throw new ConfigurationException( this.getClass().getName() + " - Can't open pbf configuration file: " + pbf_file_name );
						FileInputStream pbf_fin = new FileInputStream(pbf_file);
						props.load(new java.io.BufferedInputStream(pbf_fin));
						pbf_fin.close();
						pbf_last_modified = pbf_file.lastModified();
					}
					super.lastModified = System.currentTimeMillis();
					
				} // end if
			}
			catch(ConfigurationException e) {
				super.lastModified = 0;
				jdf_last_modified = 0;
				pbf_last_modified = 0;
				throw e;
			}
			catch(Exception e){
				super.lastModified = 0;
				jdf_last_modified = 0;
				pbf_last_modified = 0;
				throw new ConfigurationException( this.getClass().getName() + " - Can't load configuration file: " + e.getMessage());
			}
		} // end of sunchronized(lock);
	}
}