package kal.base.jdf.db;

/**
 * 
 * @(#) JDFStatement.java
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 *  
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 *  
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
import java.sql.*;
import kal.base.jdf.com.*;

public class JDFStatement {
	protected Object caller = null;
	private java.sql.Statement stmt = null;

	/**
	 * JDFStatement constructor comment.
	 */
	public JDFStatement(Object caller, Statement stmt) {
		this.caller = caller;
		this.stmt = stmt;
	}

	/**
	 * 
	 * @return boolean
	 */
	public boolean execute(String s) throws SQLException {
		boolean result = false;
		StopWatch watch = new StopWatch();
		try {
			result = stmt.execute(s);
		}
		finally{
			Logger.dbwrap.println(caller, s+":elapsed="+watch.getElapsed());
		}
		return result;
	}

	/**
	 * 
	 * @return java.sql.ResultSet
	 * @param s java.lang.String
	 */
	public ResultSet executeQuery(String s) throws SQLException {
		ResultSet rs = null;
		StopWatch watch = new StopWatch();
		
		try {
			rs = stmt.executeQuery(s);
		} finally{
			boolean mode = true;
			try {
				//mode = (new Configuration()).getBoolean("kal.base.jdf.com.logger.dbwrap.select.trace");
				mode = true;
			}catch(Exception e){}
			if ( mode ) 
				Logger.dbwrap.println(caller, s+":elapsed="+watch.getElapsed());
		}
		return rs;
	}

	/**
	 * 
	 * @return int
	 */
	public int executeUpdate(String s) throws SQLException {
		int result = 0;
		StopWatch watch = new StopWatch();
		try {
			result = stmt.executeUpdate(s);
		}
		finally{
			Logger.dbwrap.println(caller, s+":elapsed="+watch.getElapsed());
		}
		return result;
	}
}