package kal.base.jdf.jtx;

/**
 * @(#) SimpleUserTransaction.java
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
import kal.base.jdf.db.ConnectionContext;

public class MultipleUserTransaction implements UserTransaction {
	private java.util.Vector connContexts = null;

	/**
	 * 
	 */
	public MultipleUserTransaction(ConnectionContext connCtx) {
		super();
		connContexts = new java.util.Vector();
		connContexts.addElement(connCtx);
		setAutoCommit(false);
	}

	public void commit() throws CommitException {
		try {
			java.util.Enumeration ctxs = connContexts.elements();
			while(ctxs.hasMoreElements()){
				ConnectionContext ctx = (ConnectionContext)ctxs.nextElement();
				java.sql.Connection conn = ctx.getConnection();
				conn.commit();
			}
		}
		catch(Exception e) {
			throw new CommitException(e.getMessage());
		}
	}
/**
 * 
 * @return the vector of com.lgeds.jdf.ConnectionContext
 */
public java.util.Vector getConnectionContexts() {
	return connContexts;
}
	/**
	 * Don't call this method.
	 *This method always throws the IllegalStateException(" can not join a transaction in the SimpleUserTransaction")
	 * @param utx com.lgeds.jdf.txn.UserTransaction
	 */
	public void join(UserTransaction utx) {
		try {
			java.util.Enumeration ctxs = utx.getConnectionContexts().elements();
			while(ctxs.hasMoreElements()){
				ConnectionContext ctx = (ConnectionContext)ctxs.nextElement();
				if ( ! connContexts.contains(ctx) )
					connContexts.addElement(ctx);
			}
		}
		catch(Exception e) {
			throw new IllegalStateException("can not join a transaction:" + e.getMessage());
		}
	}

	public void rollback() throws RollbackException {
		try {
			java.util.Enumeration ctxs = connContexts.elements();
			while(ctxs.hasMoreElements()){
				ConnectionContext ctx = (ConnectionContext)ctxs.nextElement();
				java.sql.Connection conn = ctx.getConnection();
				conn.rollback();
			}
		}
		catch(Exception e) {
			throw new RollbackException(e.getMessage());
		}
	}

	public void setAutoCommit(boolean autoCommit) {
		try {
			java.util.Enumeration ctxs = connContexts.elements();
			while(ctxs.hasMoreElements()){
				ConnectionContext ctx = (ConnectionContext)ctxs.nextElement();
				java.sql.Connection conn = ctx.getConnection();
				conn.setAutoCommit(autoCommit);
			}
		}
		catch(Exception e) {
			String err = e.getMessage();
			if (err == null ) err = "one of connections is not assigned";
			throw new IllegalStateException(err);
		}
	}
}