package kal.base.jdf.jtx;

/**
 * @(#) TransactionManager.java
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
import kal.base.jdf.db.*;

public abstract class TransactionalResourceManager extends ConnectionResourceManager 
	implements TransactionalResource
{

	/**
	* NOTE: you must call the method setConnection(java.sql.Connection conn).<br>
	*
	*   ڸ ϱ Ͽٸ, ݵ setConnection(java.sql.Connection conn) 
	* ȣϿ connection Ҵ  ּž մϴ.<br>
	*  ̷ ۾  Ŭ ӹ sub Ŭ ڿ  super();  ȣ 
	* ٷ ̾ Ҵ ִ    ֽϴ.
	* <xmp>
	* public MyConnectionResource extends TransactionalResourceManager {
	*    public MyConnectionResource() {
	*        super();
	*        java.sql.Conneciton conn = getYourConnectionLogic();
	*        setConnection(conn);
	*    }
	*    ....
	*}
	* </xmp>
	*/
	public TransactionalResourceManager(){
		super();
	}

	public TransactionalResourceManager(ConnectionContext ctx){
		super(ctx.getConnection());
	}
	/**
	 * 
	 * @return com.lgeds.jdf.txn.UserTransaction
	 */
	public UserTransaction getUserTransaction() {
		return new MultipleUserTransaction( (ConnectionContext)this );
	}
}