package kal.base.jdf.serv;

/**
 * @(#)
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  Byoung-chan Eum, bceum@lgeds.lg.co.kr 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr
 */

import java.io.*;
import java.util.*;
import javax.servlet.*;

public class MultipartInputStreamHandler {
	  ServletInputStream in;
	  String boundary;
	  int totalExpected;
	  int totalRead = 0;
	  byte[] buf = new byte[8 * 1024];
	/**
	 * 
	 */
	public MultipartInputStreamHandler(ServletInputStream in, String boundary, int totalExpected) {
		this.in = in;
		this.boundary = boundary;
		this.totalExpected = totalExpected;
	}
	/**
	 * 
	 * @return java.lang.String
	 */
	public String readLine() throws IOException{
		StringBuffer sbuf = new StringBuffer();
		int result;
		String line;

		do {
		  result = this.readLine(buf, 0, buf.length);  // this.readLine() does +=
		  if (result != -1) {
			sbuf.append(new String(buf, 0, result, "ISO-8859-1"));
		  }
		} while (result == buf.length);  // loop only if the buffer was filled

		if (sbuf.length() == 0) {
		  return null;  // nothing read, must be at the end of stream
		}

		sbuf.setLength(sbuf.length() - 2);  // cut off the trailing \r\n
		return sbuf.toString();
	}
	/**
	 * @return int
	 * @param b byte[]
	 * @param off int
	 * @param len int
	 * @exception java.io.IOException  .
	 */
	public int readLine(byte b[], int off, int len) throws IOException {
		if (totalRead >= totalExpected) {
		  return -1;
		}
		else {
		  int result = in.readLine(b, off, len);
		  if (result > 0) {
			totalRead += result;
		  }
		  return result;
		}
	}
}