package kal.base.jdf.serv;

/**
 * @(#)
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
public class ProgressStatusBar {
	private final int BAR_MAX_SIZE = 35;
	
	private java.io.PrintWriter out;
	private int boxMaxCount;
	private int currentBoxPosition;
	private String sliceUnit;

	private int userMaxValue;
	private int userInterval;
	private int currentUserValue;
/**
 * 
 */
public ProgressStatusBar(javax.servlet.http.HttpServletResponse res) {
	super();
	try {
		out = res.getWriter();
	}
	catch(Exception e){
		out = null;
	}
	sliceUnit = "";
	boxMaxCount = BAR_MAX_SIZE / 2 ;
	userMaxValue = 100;
	userInterval = 1;
	currentUserValue = 0;
	currentBoxPosition = 0;
}
/**
 * 
 */
public ProgressStatusBar(javax.servlet.http.HttpServletResponse res, int max, int interval) {
	this(res);
	userMaxValue = max;
	userInterval = interval;
}
/**
 * 
 */
public void clear() {
	try {
		out.println("<script language=javascript>self.status='';</script>");
		out.flush();
	}catch(Exception e){}
	
}
/**
 * 
 */
public void increment() {
	currentUserValue += userInterval;
	setPercentage( (double)currentUserValue/userMaxValue * 100);
}
/**
 * @param p double
 */
public void setPercentage(double p) {
	int position = (int)(Math.ceil(boxMaxCount * p/100.0 ) );
	if ( position > boxMaxCount ) position = boxMaxCount;
	
	if ( position != currentBoxPosition || p == 100 ) {
		String progressBar = "";
		for(int i=0;i<position;i++) progressBar += sliceUnit;

		progressBar += " " + ((int)p) + "%";
		try {
			out.println("<script language=javascript>self.status='" + progressBar + "';</script>");
			out.flush();
		}catch(Exception e){}
		currentBoxPosition = position;
	}
}
/**
 * @param p int
 */
public void setPercentage(int p) {
	setPercentage((double)p);
}
/**
 * @param s default slice unit character is "";
 */
public void setSliceUnit(String s) {
	sliceUnit = s;
	int length = s.getBytes().length;
	boxMaxCount = BAR_MAX_SIZE / length;
	
}
}