package kal.base.jdf.serv;

/**
 * @(#)
 * Copyright 1999-2000 by  LG-EDS Systems, Inc.,
 * Information Technology Group, Application Architecture Team, 
 * Application Intrastructure Part.
 * 236-1, Hyosung-2dong, Kyeyang-gu, Inchun, 407-042, KOREA.
 * All rights reserved.
 * 
 * NOTICE !      You can copy or redistribute this code freely, 
 * but you should not remove the information about the copyright notice 
 * and the author.
 * 
 * @author  WonYoung Lee, wyounglee@lgeds.lg.co.kr.
 */
import java.util.Hashtable;
import java.util.Enumeration;

public class SessionBox extends Box {
	private javax.servlet.http.HttpSession  session = null;
	/**
	 * 
	 */
	public SessionBox(javax.servlet.http.HttpSession session, String name) {
		super(name);
		this.session = session;
	}
	/**
	 * 
	 * @param target com.lgeds.jdf.servlet.Box
	 */
	public Object clone() {
	
		SessionBox sessionbox = new SessionBox(session, name);
	
		Hashtable src = (Hashtable)this;
		Hashtable target = (Hashtable)sessionbox;
		
		Enumeration e = src.keys();
		while(e.hasMoreElements()) {
			String key = (String) e.nextElement();
			Object value =  src.get(key);
			target.put(key,value);
		}
		return sessionbox;
	}
	/**
	 * 
	 * @return java.lang.String
	 */
	public String getName() {
		return name;
	}
		/**
		 * @return java.lang.Object
		 * @param key java.lang.String
		 */
		public Object getObject(String key) {
			return super.get((Object)key);
		}
		/**
		 * @param key java.lang.String
		 * @param object java.lang.Object
		 */
		public void putObject(String key, Object object) {
			super.put((Object)key, object);
		}
	/**
	 * 
	 */
	public void release() {
		try {
			//session.removeValue(name);
			session.removeAttribute(name); // by chkim(2002-04-26)
		}
		catch(Exception  e){
		}
		clear();
	}
	/**
	 * 
	 * @return java.lang.String
	 */
	public String toString() {
		return "Sessoin" + super.toString();
	}

	/**
	 * 
	 * @return SessionBox
	 */
	public Box getSessionBox() {
		SessionBox sessionbox = null;
		Object o = session.getAttribute(name); 
		if ( o != null ) {
			if ( o instanceof SessionBox ) {
				sessionbox = (SessionBox)o;
			}
			else {
				session.removeAttribute(name); 
			}
		}
		
		return (Box)sessionbox;
	}

}