package kal.base.not.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.not.dbbean.NotA110BG;
import kal.base.not.dbbean.NotA120BG;

 /**
   * NOTAM Input SQL 
   * @author Copyright (c) 2007/08/21 
   */
public class NotA120Query {
	private static NotA120Query instance = new NotA120Query();
	
	public static NotA120Query getInstance() {
		return instance;
	}
	
	/** 
	  * NOTAM Input Station ȸ SQLԼ.
	  * @param params NotA120BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selStation(NotA120BG params){
		StringBuffer sql = new StringBuffer();
		String stn = StringUtil.checkString(params.getIcao_port());

		sql.append(" SELECT ICAO_PORT FROM CM_PORT_T");
		if (stn.length() == 4)
			sql.append(" WHERE ICAO_PORT = '"+stn+"'");	//(STN 4ڸ )
		else
			sql.append(" WHERE IATA_PORT = '"+stn+"'"); 	//(STN 3ڸ )
		
		Logger.debug.println("[BASE:NotA120Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input FIR ȸ SQLԼ.
	  * @param params NotA120BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selFIR(NotA120BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD FROM BS_FIR_T WHERE FIR_CD = '"+params.getIcao_port()+"'");
		
		Logger.debug.println("[BASE:NotA120Query:selFIR] sql : "+sql.toString());
		return sql.toString();
	}	

	/** 
	  * NOTAM Input Station ȸ SQLԼ.
	  * @param params String stn
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selStation(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT FROM CM_PORT_T");
		if (stn.length() == 4)
			sql.append(" WHERE ICAO_PORT = '"+stn+"'");	//(STN 4ڸ )
		else
			sql.append(" WHERE IATA_PORT = '"+stn+"'"); 	//(STN 3ڸ )
		
		Logger.debug.println("[BASE:NotA120Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input FIR ȸ SQLԼ.
	  * @param params String stn
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selFIR(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD FROM BS_FIR_T WHERE FIR_CD = '"+stn+"'");
		
		Logger.debug.println("[BASE:NotA120Query:selFIR] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input NOTAM Code ȸ SQLԼ.
	  * @param mode String ȸ
	  * @param params NotA120BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selNOTAMCode(String mode,NotA120BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT * FROM BS_NOTAM_T");
		if (mode.equals("STN")) {
			sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		} else {
			sql.append(" WHERE NOT_FIR = '"+params.getIcao_port()+"'"); //==> 
		}
		sql.append(" 		AND NOT_NUM = '"+params.getNot_num()+"'");
		
		Logger.debug.println("[BASE:NotA120Query:selNOTAMCode] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input TYPE 'C' 'R' ȸ SQLԼ.
	  * @param icaoPort String ȸ
	  * @param notNum String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selTypeEdit(String icaoPort,String notNum){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT * FROM BS_NOTAM_T");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"'");
		sql.append(" 	AND NOT_NUM = '"+notNum+"'");
		
		Logger.debug.println("[BASE:NotA120Query:selTypeEdit] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * NOTAM Input OLD NOTAM Update SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String updOldNOTAM(String icaoPort,String notOldNum,String notNum,String notDtg,String notCat,String userID,boolean dataFlag){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET NOT_CAT = '"+notCat+"',");
		sql.append("      NOT_MARK_NUM = '"+notNum+"',");
		sql.append(" 		NOT_MARK_Y = 'Y',");
		// 2006.03.21  update -> NOT_DTG, insert -> SYSDATE
		if (dataFlag) {
			sql.append(" 	NOT_EXP_DT = '"+notDtg+"',");
			sql.append(" 	NOT_PREV_EXP_DT = '"+notDtg+"',");
		} else {
			sql.append(" 	NOT_EXP_DT = TO_CHAR(SYSDATE-9/24,'YYMMDD')||'0000',");
			sql.append(" 	NOT_PREV_EXP_DT = TO_CHAR(SYSDATE-9/24,'YYMMDD')||'0000',");
		}
		sql.append("     	TIMESTMP = SYSDATE,");
		sql.append("     	NOT_INPUT = 'M',");
		sql.append("     	USERID = '"+userID+"'");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"' AND NOT_NUM = '"+notOldNum+"'");
		
		Logger.debug.println("[BASE:NotA120Query:updOldNOTAM] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input Main ȸ SQLԼ.
	  * @param mode String ȸ
	  * @param params NotA120BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String selMain(String mode, NotA120BG params){
		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT ");
		sql.append(" 	A.NOT_CAT, A.NOT_FIR, A.NOT_2ND_QCD||A.NOT_4TH_QCD NOT_QCD, A.NOT_TRAF, A.NOT_PURP, A.NOT_SCOP, ");
		sql.append(" 	A.NOT_LOW, A.NOT_UPP, A.NOT_LAT_LON, A.NOT_NUM, A.NOT_OLD_NUM, A.ICAO_PORT, ");
		sql.append(" 	A.NOT_ISS_DT, A.NOT_EXP_DT, A.NOT_OPEN_Y, A.NOT_VALID, A.NOT_TEXT, A.NOT_COMMNT, ");
		sql.append(" 	A.NOT_CLS, A.NOT_EXP_EST_Y, A.NOT_SIG_Y, TO_CHAR(A.TIMESTMP - 9/24, 'YYMMDD HH24:MI') TIMESTMP, "); //2007.09.17 ߰
		sql.append(" 	A.NOT_DAY_FR, A.NOT_DAY_TO, "); //2009.11.11 ߰
		sql.append(" 	A.NOT_OLD_CAT, A.USERID, A.NOT_TYP, ");
		sql.append(" 	A.NOT_MARK_Y, A.NOT_MARK_NUM, "); //2006.05.11 ߰ : NOT_MARK_Y, NOT_MARK_NUM ȸ
		sql.append("    A.NOT_REMARK, B.NOT_CARE_TYP, "); //2008.08.04  : NOT_REMARK ߰, BS_NOTAM_CARE_T ߰
		sql.append("    DECODE(A.NOT_OLD_CAT, 'C', A.NOT_OLD_CAT, A.NOT_INPUT) NOT_INPUT, A.NOT_EMS_Y, ");//2011.08.17 ߰
		sql.append(" 	DECODE(B.NOT_CARE_TYP, '', DECODE(A.NOT_OLD_CAT, 'C', A.NOT_OLD_CAT, DECODE(A.NOT_OPEN_Y, 'Y', A.NOT_INPUT, 'D')), B.NOT_CARE_TYP) NOT_STATUS ");
		//20150323 ߰
		sql.append("    ,A.NOT_FOLLOW_Y ");
		sql.append(" FROM BS_NOTAM_T A, BS_NOTAM_CARE_T B ");
		sql.append(" WHERE A.ICAO_PORT = B.ICAO_PORT(+) ");
		sql.append("	AND A.NOT_NUM = B.NOT_NUM(+) ");
		sql.append("	AND A.ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" 	AND A.NOT_NUM = '"+params.getNot_num()+"'");
		
		Logger.debug.println("[BASE:NotA120Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input Է SQLԼ.
	  * @param params NotA110BG Է
	  * @return String Query 
	  * @author Copyright (c) 2007/08/21 
	  */
	public String insNOTAM(NotA110BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_NOTAM_T ( ");
		sql.append(" 	ICAO_PORT, IATA_PORT, NOT_NUM, NOT_CLS, ");
		sql.append(" 	NOT_FIR, NOT_2ND_QCD, NOT_4TH_QCD, NOT_TRAF, NOT_PURP, NOT_SCOP, NOT_LOW, NOT_UPP, NOT_LAT_LON, ");//9
		sql.append(" 	NOT_ISS_DT, NOT_EXP_DT, NOT_VALID, NOT_TEXT, NOT_OPEN_Y, NOT_COMMNT, NOT_REMARK, NOT_MARK_NUM, "); //2008.08.06 ߰ : NOT_REMARK
		sql.append("	NOT_CAT, NOT_OLD_CAT, NOT_OLD_NUM, NOT_DTG, NOT_INPUT, TIMESTMP, USERID, NOT_TYP, ");
		sql.append("	NOT_EXP_EST_Y, NOT_SIG_Y, "); //2007.09.28 ߰
		//20150319 , ߰
		//sql.append("	NOT_DAY_FR, NOT_DAY_TO) "); //2009.11.09 ߰
		sql.append("	NOT_DAY_FR, NOT_DAY_TO, ");
		sql.append("	NOT_FOLLOW_Y ) ");
		
		sql.append(" VALUES ( '"+params.getIcao_port()+"','"+StringUtil.checkString(params.getIata_port())+"','"+params.getNot_num()+"','"+params.getNot_cls()+"','"+params.getNot_fir()+"','"+(params.getNot_qcd()).substring(0,2)+"',");
		sql.append(" 	'"+(params.getNot_qcd()).substring(2)+"','"+params.getNot_traf()+"','"+params.getNot_purp()+"','"+params.getNot_scop()+"',");
		sql.append(" 	'"+params.getNot_low()+"','"+params.getNot_upp()+"','"+params.getNot_lat_lon()+"',");
		
		if ((params.getNot_iss_dt()).equals("WIE")) {
			sql.append("	TO_CHAR(SYSDATE-9/24,'YYMMDDHH24MI'),");
		} else {
			sql.append("	'"+params.getNot_iss_dt()+"',");
		}
		
		// 2005.11.14 
		if ((params.getNot_typ()).equals("S") && (params.getNot_exp_dt()).equals("PERM")) {
			if ((params.getNot_iss_dt()).equals("WIE")) {
				sql.append("	TO_CHAR(SYSDATE+15/24,'YYMMDDHH24MI'),");
			} else {
				sql.append("	TO_CHAR(TO_DATE('"+params.getNot_iss_dt()+"','YYMMDDHH24MI')+24/24,'YYMMDDHH24MI'),");
			}
		} else {
			sql.append(" 	'"+params.getNot_exp_dt()+"',");
		}
		
		sql.append(" 	'"+StringUtil.DBInsStr(params.getNot_valid())+"','"+StringUtil.DBInsStr(params.getNot_text())+"','"+params.getNot_open_y()+"',");
		sql.append(" 	'"+StringUtil.DBInsStr(params.getNot_commnt())+"','"+StringUtil.DBInsStr(params.getNot_remarks())+"','',");
		sql.append(" 	'"+params.getNew_cat()+"','"+params.getNot_cat()+"','"+params.getNot_old_num()+"',SYSDATE-(9/24),'"+params.getNot_input()+"',"); //2008.08.06  : NOT_INPUT = 'M' -> Է
		sql.append("	SYSDATE,'"+params.getUserid()+"','"+params.getNot_typ()+"', ");
		sql.append(" 	'"+params.getNot_exp_est()+"', '"+params.getNot_sig()+"', ");
		//20150319 , ߰
		//sql.append(" 	'"+params.getNot_day_fr()+"', '"+params.getNot_day_to()+"')"); //2009.11.09 ߰
		sql.append(" 	'"+params.getNot_day_fr()+"', '"+params.getNot_day_to()+"', ");
		sql.append(" 	'"+params.getNot_follow()+"' )");
		
		Logger.debug.println("[BASE:NotA120Query:insNOTAM] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * PREV SNOWTAMȸ SQLԼ.
	  * @param String icao_port, String not_iss_dt 
	  * @return String Query 
	  * @author Copyright (c) 2005/11/14 
	  */
	public String selPrevSnowtam(String icao_port, String not_iss_dt, String not_num){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT NOT_NUM ");
		sql.append(" FROM BS_NOTAM_T ");
		sql.append(" WHERE ICAO_PORT='"+ icao_port +"' ");
		sql.append(" 	AND NOT_TYP='S' "); 
		
		if (not_iss_dt.equals("WIE")) {
			sql.append(" 	AND NOT_ISS_DT > TO_CHAR(SYSDATE-33/24,'YYMMDDHH24MI') ");
		} else {
			sql.append(" 	AND NOT_ISS_DT > TO_CHAR(TO_DATE('"+ not_iss_dt +"','YYMMDDHH24MI')-24/24,'YYMMDDHH24MI') ");
		}
		
		sql.append(" 	AND NOT_NUM <> '"+not_num+"' "); //2009.11.02 ߰ : ش NOTAM NOT_NUM .
		
		sql.append(" ORDER BY NOT_ISS_DT DESC ");

		System.out.println("[BASE:NotA120Query:selPrevSnowtam] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA120Query:selPrevSnowtam] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * PREV SNOWTAM UPDATE SQLԼ.
	  * @param String icao_port, String not_exp_dt
	  * @return String Query 
	  * @author Copyright (c) 2005/11/14 
	  */
	public String updPrevSnowtam(String icao_port, String not_iss_dt, String prev_not_num,  String user_id){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE BS_NOTAM_T SET ");
		
		if (not_iss_dt.equals("WIE")) {
			sql.append(" 	NOT_EXP_DT = TO_CHAR(SYSDATE-9/24,'YYMMDDHH24MI'), ");
		} else {
			sql.append(" 	NOT_EXP_DT = '"+ not_iss_dt +"', ");
		}
		
		sql.append("		TIMESTMP = SYSDATE, ");
		sql.append(" 	USERID = '"+ user_id +"' ");
		sql.append(" WHERE ICAO_PORT = '"+ icao_port +"' ");
		sql.append(" 	AND NOT_NUM = '"+ prev_not_num +"' ");
     
		System.out.println("[BASE:NotA120Query:updPrevSnowtam] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotA120Query:updPrevSnowtam] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOT_DTG ȸ SQLԼ.
	  * @param String icao_port, String not_num
	  * @return String Query 
	  * @author Copyright (c) 2006/03/21 
	  */
	public String selNotDtg(String icao_port, String not_num){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(NOT_DTG, 'YYMMDDHH24MI') NOTDTG");
		sql.append(" FROM BS_NOTAM_T");
		sql.append(" WHERE ICAO_PORT = '"+icao_port+"'");
		sql.append(" 	AND NOT_NUM = '"+not_num+"'");
		
		Logger.debug.println("[BASE:NotA120Query:selNotDtg] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM_LOG ȸ SQLԼ.
	  * @param NotA120BG params
	  * @return String Query 
	  * @author Copyright (c) 2007/09/17 
	  */
	public String selNotLog(NotA120BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ICAO_PORT, NOT_NUM, REASON, TO_CHAR(NOT_LOG_DT - 9/24, 'YYMMDD HH24:MI') NOT_LOG_DT, ");//2007.10.04 : NOT_LOG_DT <- UTC
		sql.append(" 	USERID, NOT_REMARK "); //2008.12.09 ߰ : NOT_REMARK ߰
		sql.append(" FROM BS_NOTAM_LOG_T ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"' ");
		sql.append(" 	AND NOT_NUM = '"+params.getNot_num()+"' ");
		sql.append(" ORDER BY NOT_LOG_DT DESC ");
		
		Logger.debug.println("[BASE:NotA120Query:selNotLog] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM_LOG Է SQLԼ.
	  * @param NotA110BG params
	  * @return String Query 
	  * @author Copyright (c) 2007/09/17 
	  */
	public String insNotLog(NotA110BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_NOTAM_LOG_T (ICAO_PORT, NOT_NUM, REASON, NOT_LOG_DT, USERID, NOT_REMARK) "); //2008.12.09 ߰ : NOT_REMARK ߰
		sql.append(" VALUES ('"+params.getIcao_port()+"', '"+params.getNot_num()+"', '"+StringUtil.DBInsStr(StringUtil.checkString(params.getLog_reason()))+"', SYSDATE, '"+params.getUserid()+"', '"+StringUtil.DBInsStr(StringUtil.checkString(params.getNot_remarks()))+"') ");
		
		Logger.debug.println("[BASE:NotA120Query:insNotLog] sql : "+sql.toString());
		return sql.toString();
	}
}
