package kal.base.not.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.not.dbbean.*;

 /**
   * New NOTAM Request SQL 
   * @author Copyright (c) 2007/09/10 
   */
public class NotQ010Query {
	private static NotQ010Query instance = new NotQ010Query();
	
	public static NotQ010Query getInstance() {
		return instance;
	}
	
	/** 
	  * NOTAM Request   ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/10 
	  */
	public String selSTNSection(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();
		
		// WEEKLY_SCH_T DAILY_SCH_T  => 2005.11.15 
		sql.append(" SELECT STNFR, STNTO, SACTYP ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24 - 2,'YYYYMMDD'),'YYYYMMDD') ");//2012.08.30   
		sql.append(" 	AND FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24 + 2,'YYYYMMDD'),'YYYYMMDD') ");
		//@2017-10-17 12/24  8/24 ٲ
		//@2017-10-20 8/24  12/24 ٲ
		sql.append("    AND EST_DEP_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24 - 12/24,'YYYYMMDDHH24MI'),'YYYYMMDDHH24MI') ");//2012.09.10 ߰ : SYSDATE - 9/24 - 12/24 //@=============== ߿ 12ð ,ȹ Ž˻ 12ð  ĺ
		sql.append("    AND EST_DEP_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24 + 12/24,'YYYYMMDDHH24MI'),'YYYYMMDDHH24MI') ");//2012.09.10 ߰ : SYSDATE - 9/24 + 12/24
		sql.append(" 	AND FLT_NUM LIKE '"+params.getFlt_num()+"%' ");
		if (!params.getDep_stn().equals("")) {
			sql.append("	AND STNFR = '"+params.getDep_stn()+"' ");
		}
		if (!params.getArr_stn().equals("")) {
			sql.append("	AND STNTO = '"+params.getArr_stn()+"' ");
		}
		sql.append("      AND ACTNID <> 'CNL' ");
		//sql.append(" ORDER BY FIRST_LEG_FLT_DT, LEG_NUM ");
		sql.append(" ORDER BY EST_DEP_DT ");
		
		System.out.println("[BASE:NotQ010Query:selSTNSection] sql : "+sql.toString());
		Logger.debug.println("[BASE:NotQ010Query:selSTNSection] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM Request ATC Station ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/10 
	  */
	public String selATCStation(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RTE_STN,ATC_DTG");
		sql.append(" FROM BS_ATC_ROUTE_T"); 
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"'");
		sql.append(" 	AND ARR_STN = '"+params.getArr_stn()+"'");
		sql.append(" 	AND FLT_NUM = '"+params.getFlt_num()+"'");
		sql.append(" 	AND ATC_DTG+(4/24) > SYSDATE-(9/24)");
		sql.append(" ORDER BY ATC_DTG DESC");
		
		Logger.debug.println("[BASE:NotQ010Query:selATCStation] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM Input Station ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/10 
	  */
	public String selStation(String stn) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT, IATA_PORT, CTRY_CD ");
		sql.append(" FROM CM_PORT_T ");
		if (stn.length() == 4) {
			sql.append(" WHERE ICAO_PORT = '"+stn+"'");	//(STN 4ڸ )
		} else {
			sql.append(" WHERE IATA_PORT = '"+stn+"'"); 	//(STN 3ڸ )
		}
		
		Logger.debug.println("[BASE:NotQ010Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM FIR ȸ SQLԼ.
	  * @param notFir Stringȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/10 
	  */
	public String selFirCd(String notFir) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD, FIR_E ");
		sql.append(" FROM BS_FIR_T ");
		sql.append(" WHERE FIR_CD = '"+notFir+"' ");

		//Logger.debug.println("[BASE:NotQ010Query:selFirCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Request NOTAM ȸ SQLԼ.
	  * @param mode String 1 : NOTAM NBR Է    2 : ̿ 
	  * @param stnList String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/10 
	  */
	public String selNotamNbr(String mode, String stnList, String cond, String notPeriod) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT A.*, DECODE(ICAO_PORT,"+StringUtil.icaoDecode(stnList)+") SEQ, ");
		
		// 2006.12.07 ߰
		sql.append(" DECODE(SUBSTR(A.NOT_NUM,1,2),'CO','A','B') COMP,");
		
		//2007.09.14 ߰
		//sql.append(" DECODE(NOT_CLS, 'RWY', 1, 'TWY', 2, 'ILS', 3, 'LGT', 4, 'AGA', 5, 'COM', 6, 'RAC', 7, 'WARN', 8, 'AIP', 9, 10) CLSSEQ, ");
		//2009.11.12  : Category ȭ
		sql.append(" DECODE(NOT_CLS, 'RWY', 1, 'RWY LGT', 2, 'TWY', 3, 'TWY LGT', 4, 'RAMP', 5, 'NAVAID', 6, 'DEP', 7, 'APP', 8, 'APP LGT', 9, ");
		sql.append(" 'COMM', 10, 'CHRT', 11, 'ARPT', 12, 'OBST', 13, 'GPS', 14, 'AIRWAY', 15, 'AIRSPACE', 16, 'OTHER', 17, 'AIP', 18, 19) CLSSEQ, ");
		
		//sql.append(" SUBSTR(A.NOT_NUM,LENGTH(A.NOT_NUM)-1,2) YY, "); // 2007.01.18 
		//sql.append(" DECODE(SUBSTR(A.NOT_NUM,6,1),'/',SUBSTR(A.NOT_NUM,7,2),DECODE(SUBSTR(NOT_NUM,5,1),'/',SUBSTR(NOT_NUM,6,2),'XX')) YY, "); //2008.12.16 
		sql.append(" DECODE(SUBSTR(A.NOT_NUM,6,1),'/',SUBSTR(A.NOT_NUM,7,2),DECODE(SUBSTR(NOT_NUM,5,1),'/',SUBSTR(NOT_NUM,6,2),DECODE(SUBSTR(A.NOT_NUM,7,1),'/',SUBSTR(A.NOT_NUM,8,2),'XX'))) YY, ");
		sql.append(" DECODE(SUBSTR(A.NOT_NUM,6,1),'/',SUBSTR(A.NOT_NUM,1,1),'0') TP, ");
		sql.append(" DECODE(SUBSTR(A.NOT_NUM,6,1),'/',SUBSTR(A.NOT_NUM,2,4),SUBSTR(A.NOT_NUM,1,4)) NUM, ");
		//2011.08.17 ߰
		sql.append(" NVL(NOT_EMS_Y,'N') NOT_EMS_Y ");
		
		sql.append(" FROM BS_NOTAM_T A");
		sql.append(" WHERE ICAO_PORT IN ("+StringUtil.strDBformat(stnList)+")");
		// 2006.05.12 
		if ("CLSD".equals(notPeriod)) {
			sql.append(" AND NOT_OPEN_Y = 'N'");
		} 
		//20150325 ߰
		else if("DISP".equals(notPeriod) && !"2".equals(mode)) {
			sql.append(" ");
		}
		else {
			sql.append(" AND NOT_OPEN_Y = 'Y'");
		}
		sql.append(cond);

		//Logger.debug.println("[BASE:NotQ010Query:selNotamNbr] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Request ׸ б SQLԼ.
	  * @param icaoPort String ICAO PORT
	  * @return String Query 
	  * @author Copyright (c) 2007/09/10 
	  */
	public String selPort(String icaoPort) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ");
		sql.append(" 	A.ICAO_PORT, A.IATA_PORT, A.PORT_E, B.NATION_ENG_N, A.CURFEW, ");
		sql.append(" 	A.OP_COMPANY1, A.OP_FREQ1, A.OP_CALLSIGN1, A.OP_TEL1, A.OP_FAX1, ");
		sql.append(" 	A.OP_1ST_SITA1, A.OP_2ND_SITA1, A.HTL_CRW_LOV1, A.HTL_TEL1, A.HTL_FAX1, ");
		sql.append(" 	A.OP_FREQ2, A.OP_CALLSIGN2 "); //2009.11.23 ߰
		sql.append(" FROM CM_PORT_T A, NATION_T B ");
		sql.append(" WHERE A.ICAO_PORT='"+icaoPort+"' ");
		sql.append(" 	AND A.CTRY_CD=B.NATION_C(+) ");

		Logger.debug.println("[BASE:NotQ010Query:selPort] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Request Ȱַ б SQLԼ.
	  * @param icaoPort String ICAO PORT
	  * @return String Query 
	  * @author Copyright (c) 2007/09/10 
	  */
	public String selRwyCd(String icaoPort) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT RWY_DIR,RWY_LENG||'FT X '||RWY_WIDTH||'FT' RWY_SIZE, ");
		sql.append(" 	RWY_VIS_LIMIT, RWY_CIG_LIMIT, RWY_RVR_LIMIT ");
		sql.append(" FROM BS_PORT_RWY_T ");
		sql.append(" WHERE ICAO_PORT='"+icaoPort+"' ");
		sql.append(" 	AND RWY_SEQ <= 8 ");
		sql.append(" ORDER BY RWY_SEQ ");
		
		Logger.debug.println("[BASE:NotQ010Query:selRwyCd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * TODC DB  ׺ RWY ID б SQLԼ.
	  * @param icaoPort String ICAO PORT
	  * @return String Query 
	  * @author Copyright (c) 2011/07/25 
	  */
	public String selTODCRwyCd(String icaoPort) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DISTINCT RWY_DIR SECTION FROM TODC_RWY_T ");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"'");
		sql.append(" UNION ");
		sql.append(" SELECT RWY_DIR || '-' || INTER_NAME SECTION FROM TODC_INTERSECTION_T  ");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"'");
		sql.append(" ORDER BY SECTION ASC ");
		
		Logger.debug.println("[BASE:NotQ010Query:selRwyCd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM Request SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2007/09/10 
	  */
	public String insMsTelexMsg(String seq, int msgMax, int msgPos, String msg, String dbTime, String orginAddr, String projectNo) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO MS_TELEX_MSG_T (MSG_CAT, MSG_TMPST, UNI_SEQ, MSG_MAX, MSG_POS, ORIGIN_ADDR, MESSAGE, PRIORITY, SYS_MQID, PROJECT_NO, PROCESSED, ERROR_REPLY) ");
		sql.append(" VALUES ('NOTAM',SYSDATE-(9/24),"+seq+","+msgMax+","+msgPos+",'"+orginAddr+"','"+StringUtil.DBInsStr(msg)+"',1,"+dbTime+"||TRIM(TO_CHAR("+seq+",'00000')),'"+projectNo+"','N',' ')");
		
		//Logger.debug.println("[BASE:NotQ010Query:insMsTelexMsg] sql : "+sql.toString());
		return sql.toString();	
	}	
	
	/** 
	  * RTE_CD ȸ SQLԼ.
	  * @param params NotQ010BG Parameter Object
	  * @return String Query  
	  * @author Copyright (c) 2007/09/10 
	  */
	public String selRteCd(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT RTE_CD ");
		sql.append(" FROM BS_COMP_ROUTE_T ");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND ARR_STN = '"+params.getArr_stn()+"' ");
		
		Logger.debug.println("[BASE:NotQ010Query:selRteCd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Area Station ȸ SQLԼ.
	  * @param String areaCd
	  * @return String Query 
	  * @author Copyright (c) 2007/09/10 
	  */
	public String selAreaStn(String areaCd) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT AREA_STN");
		sql.append(" FROM BS_AREA_T");
		sql.append(" WHERE AREA_CD = '"+areaCd+"'");
		
		Logger.debug.println("[BASE:NotQ010Query:selAreaStn] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FPL ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/10 
	  */
	public String selFplList(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ");
		sql.append(" 	TO_CHAR(A.FIRST_LEG_FLT_DT, 'YYYYMMDD') FIRST_LEG_FLT_DT, ");
		sql.append(" 	TO_CHAR(A.FIRST_LEG_FLT_DT, 'DDMONYY') DDMONYY, ");
		sql.append(" 	TO_CHAR(A.EST_DEP_DT, 'HH24MI') EST_DEP_DT, ");
		sql.append("  TO_CHAR(A.EST_DEP_DT + B.ABHR/1440, 'HH24MI') EST_ARV_DT, ");
		sql.append(" 	A.FLT_NUM, A.STNFR, A.STNTO, B.ROUTE ");
		sql.append(" FROM DAILY_SCH_T A, FLIGHT_PLAN_T B ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24 - 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24 + 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND A.EST_DEP_DT >= SYSDATE - 9/24 - 8/24 ");
		sql.append(" 	AND A.FLT_NUM = '"+params.getFlt_num()+"' ");
		sql.append(" 	AND A.ACTNID <> 'CNL' ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT "); 
		sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" 	AND A.LEG_NUM = B.LEG_NUM ");
		sql.append(" 	AND A.STNFR = B.STNFR ");
		sql.append(" 	AND A.STNTO = B.STNTO ");
		sql.append(" 	AND B.ACTIVE = 'Y' ");
		sql.append(" ORDER BY A.EST_DEP_DT ");
		
		Logger.debug.println("[BASE:NotQ010Query:selFplList] sql : "+sql.toString());
		return sql.toString();
	}
	
	
	/** 
	  * FPL ROUTE ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/11 
	  */
	public String selFplRte(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ");
		sql.append(" 	A.FIRST_LEG_FLT_DT, A.STNFR, A.STNTO, B.ROUTE, B.ETOPS_Y, ");
		sql.append(" 	C.ICAO_PORT, D.ICAO_PORT, ");
		sql.append(" 	TO_CHAR(A.EST_DEP_DT, 'HH24MI') EST_DEP_DT, ");
		sql.append("  TO_CHAR(A.EST_DEP_DT + B.ABHR/1440, 'HH24MI') EST_ARV_DT ");
		sql.append(" FROM DAILY_SCH_T A,FLIGHT_PLAN_T B, CM_PORT_T C, CM_PORT_T D ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24 - 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24 + 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND A.EST_DEP_DT >= SYSDATE - 9/24 - 8/24 ");
		sql.append(" 	AND A.ACTNID <> 'CNL' ");
		sql.append(" 	AND A.FLT_NUM = '"+params.getFlt_num()+"' ");
		sql.append(" 	AND A.STNFR = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND A.STNTO = '"+params.getArr_stn()+"' ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" 	AND A.STNFR = B.STNFR ");
		sql.append(" 	AND A.STNTO = B.STNTO ");
		sql.append(" 	AND B.ACTIVE ='Y' ");
		sql.append(" 	AND A.STNFR = C.IATA_PORT ");
		sql.append(" 	AND A.STNTO = D.IATA_PORT ");
		sql.append(" ORDER BY A.EST_DEP_DT ");
		
		Logger.debug.println("[BASE:NotQ010Query:selFplRte] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FPL ROUTE ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/11 
	  */
	public String selFplRte2(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ");
		sql.append(" 	A.FIRST_LEG_FLT_DT, A.STNFR, A.STNTO, B.ROUTE, B.ETOPS_Y, ");
		sql.append(" 	C.ICAO_PORT, D.ICAO_PORT, ");
		sql.append(" 	TO_CHAR(A.EST_DEP_DT, 'HH24MI') EST_DEP_DT, ");
		sql.append("  TO_CHAR(A.EST_DEP_DT + B.ABHR/1440, 'HH24MI') EST_ARV_DT ");
		sql.append(" FROM DAILY_SCH_T A,FLIGHT_PLAN_T B, CM_PORT_T C, CM_PORT_T D ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24 - 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24 + 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND A.EST_DEP_DT >= SYSDATE - 9/24 - 8/24 ");
		sql.append(" 	AND A.ACTNID <> 'CNL' ");
		sql.append(" 	AND A.FLT_NUM = '"+params.getFlt_num()+"' ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" 	AND A.STNFR = B.STNFR ");
		sql.append(" 	AND A.STNTO = B.STNTO ");
		sql.append(" 	AND B.ACTIVE ='Y' ");
		sql.append(" 	AND A.STNFR = C.IATA_PORT ");
		sql.append(" 	AND A.STNTO = D.IATA_PORT ");
		sql.append(" ORDER BY A.EST_DEP_DT ");
		
		Logger.debug.println("[BASE:NotQ010Query:selFplRte2] sql : "+sql.toString());
		System.out.println("[BASE:NotQ010Query:selFplRte2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SKD  DEP, ARR ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/11 
	  */
	public String selSkdDepArr(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIRST_LEG_FLT_DT, STNFR, STNTO, SACTYP, ");
		sql.append(" 	TO_CHAR(EST_DEP_DT, 'HH24MI') EST_DEP_DT, ");
		sql.append("  TO_CHAR(EST_ARV_DT, 'HH24MI') EST_ARV_DT ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24 - 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24 + 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND EST_DEP_DT >= SYSDATE - 9/24 - 8/24 ");
		sql.append(" 	AND FLT_NUM = '"+params.getFlt_num()+"' ");
		sql.append(" 	AND ACTNID <> 'CNL' ");
		sql.append(" 	AND ROWNUM = 1 ");
		sql.append(" ORDER BY EST_DEP_DT ");
		
		Logger.debug.println("[BASE:NotQ010Query:selSkdDepArr] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FPL  ALT_PORT, ETOPS_PORTS, REFILE_PORT, REFILE_ALT_PORTS ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/13 
	  */
	public String selFplAltEtopRefile(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT B.ALT_PORT, B.ETOPS_Y, B.ETOPS_PORTS, B.REFILE_PORT, B.REFILE_ALT_PORTS, ");
		sql.append(" B.ALT_PORT2, B.TKOF_ALT_PORT, "); //2009.06.23 ߰ :  ȸ ߰ Ǿ.
		sql.append(" 	C.ICAO_PORT, D.ICAO_PORT, ");
		sql.append(" 	TO_CHAR(A.EST_DEP_DT, 'YYMMDDHH24MI') EST_DEP_DT, ");
		sql.append(" 	TO_CHAR(A.EST_DEP_DT + B.ABHR/1440, 'YYMMDDHH24MI') EST_ARV_DT, ");
		sql.append(" 	B.ETP_PORTS, "); //2009.12.30 ߰
		sql.append(" 	B.SYSKEY, "); //2010.01.05 ߰
		sql.append(" 	TO_CHAR(A.EST_DEP_DT, 'HH24MI') ETD_TIME, "); //2010.01.05 ߰
		sql.append(" 	TO_CHAR(A.EST_DEP_DT, 'YYMMDD') ETD_DATE, "); //2010.01.05 ߰
		sql.append(" 	TO_CHAR(A.EST_DEP_DT + 1, 'YYMMDD') ETD_NEXT "); //2010.01.05 ߰
		sql.append(" 	,B.ERA_PORT ");//2014-06-20
		sql.append(" FROM DAILY_SCH_T A, FLIGHT_PLAN_T B, CM_PORT_T C, CM_PORT_T D ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE-9/24-2,'YYYYMMDD'),'YYYYMMDD') ");//2012.08.22  : -2 ؿ -1( ȹ Ÿ ORDER BY A.EST_DEP_DT   Ÿ ϴ   ), 2012.09.10 : -2 
		sql.append(" 	AND A.FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE-9/24+2,'YYYYMMDD'),'YYYYMMDD') ");//2012.08.22  : +2 ؿ +1, 12.09.10 : +2 
		sql.append(" 	AND A.EST_DEP_DT >= SYSDATE - 9/24 - 8/24 ");//@=============== ߿ 8ð  
		sql.append(" 	AND A.ACTNID <> 'CNL' ");
		sql.append(" 	AND A.FLT_NUM = '"+params.getFlt_num()+"' ");
		sql.append(" 	AND A.STNFR = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND A.STNTO = '"+params.getArr_stn()+"' ");
		sql.append(" 	AND B.ROUTE = '"+params.getRte_id()+"' ");
		sql.append("    AND A.SACTYP = '"+params.getSactyp()+"' ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT "); 
		sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" 	AND A.STNFR = B.STNFR ");
		sql.append(" 	AND A.STNTO = B.STNTO ");
		sql.append(" 	AND B.ACTIVE ='Y' ");
		sql.append(" 	AND A.STNFR = C.IATA_PORT ");
		sql.append(" 	AND A.STNTO = D.IATA_PORT ");
		sql.append(" ORDER BY A.EST_DEP_DT ");
		
		Logger.debug.println("[BASE:NotQ010Query:selFplAltEtopRefile] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SKD SACTYP ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/13 
	  */
	public String selSkdSactyp(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT FIRST_LEG_FLT_DT, STNFR, STNTO, SACTYP, ");
		sql.append(" 	TO_CHAR(EST_DEP_DT, 'YYMMDDHH24MI') EST_DEP_DT, ");
		sql.append(" 	TO_CHAR(EST_ARV_DT, 'YYMMDDHH24MI') EST_ARV_DT ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24 - 2,'YYYYMMDD'),'YYYYMMDD') ");//2012.08.22  : -2->-1=>2102.08.30  -2
		sql.append(" 	AND FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24 + 2,'YYYYMMDD'),'YYYYMMDD') ");//2012.08.22  : +2->+1
		sql.append(" 	AND EST_DEP_DT >= SYSDATE - 9/24 - 8/24 ");
		sql.append(" 	AND ACTNID <> 'CNL' ");
		sql.append(" 	AND FLT_NUM = '"+params.getFlt_num()+"' ");
		sql.append(" 	AND STNFR = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND STNTO = '"+params.getArr_stn()+"' ");
		sql.append(" 	AND ROWNUM = 1 ");
		sql.append(" ORDER BY EST_DEP_DT ");
		
		Logger.debug.println("[BASE:NotQ010Query:selSkdSactyp] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * SKD SACTYP ȸ SQLԼ.     -- 2009.12.07 
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2009/11/14 
	  */
	public String selSkdSactyp2(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DISTINCT SACTYP ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24 - 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24 + 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND EST_DEP_DT >= SYSDATE - 9/24 - 8/24 ");
		sql.append(" 	AND ACTNID <> 'CNL' ");
		sql.append(" 	AND STNFR = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND STNTO = '"+params.getArr_stn()+"' ");
		
		Logger.debug.println("[BASE:NotQ010Query:selSkdSactyp2] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FPL   DOM_ALT_PORT ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2009/06/25 
	  */
	public String selDomAltPort(NotQ010BG params, String sactypY) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT NVL(SUBSTR(DOM_ALT_PORT,1,3),'NIL') DOM_ALT_PORT_1, NVL(SUBSTR(DOM_ALT_PORT,5,3),'NIL') DOM_ALT_PORT_2 ");
		sql.append(" FROM CM_PORT_AC_T ");
		sql.append(" WHERE IATA_PORT = '"+params.getArr_stn()+"' "); //2007.09.20  : DEP -> ARR ȸ
		if (!"N".equals(sactypY)) {
			sql.append(" 	AND SACTYP = '"+params.getSactyp()+"' ");	
		}
		
		System.out.println("[BASE:NotQ010Query:selDomAltPort] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * CITYPAIR ALT_PORT ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/13 
	  */
	public String selCitypairAlt(NotQ010BG params, String sactypY) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ALT_PORT ");
		sql.append(" FROM CM_PORT_AC_T ");
		sql.append(" WHERE IATA_PORT = '"+params.getArr_stn()+"' "); //2007.09.20  : DEP -> ARR ȸ
		if (!"N".equals(sactypY)) {
			sql.append(" 	AND SACTYP = '"+params.getSactyp()+"' ");
		}
		
		System.out.println("[BASE:NotQ010Query:selCitypairAlt] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * CITYPAIR ETOP_PORT ȸ SQLԼ. -- 2007.10.04 
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/13 
	  */
	/*public String selCitypairEtop(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" SELECT ETOP_PORT ");
		sql.append(" FROM CM_CITYPAIR_AC_T ");
		sql.append(" WHERE DEP_PORT = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND ARV_PORT = '"+params.getArr_stn()+"' ");
		sql.append(" 	AND SACTYP = '"+params.getSactyp()+"' ");

		Logger.debug.println("[BASE:NotQ010Query:selCitypairEtop] sql : "+sql.toString());
		return sql.toString();
	}*/
	
	/** 
	  * ETOPS_STN ȸ SQLԼ
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2009/12/29 
	  */
	public String selEtopsStn(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ETOPS_STN ");
		sql.append(" FROM BS_COMP_ROUTE_T ");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND ARR_STN = '"+params.getArr_stn()+"' ");
		sql.append(" 	AND RTE_CD = '"+params.getRte_id()+"' ");

		System.out.println("[BASE:NotQ010Query:selEtopsStn] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ȭ鿡 ETOPS üũ ETOP_PORT ȸ SQLԼ -- 2010.01.07 
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/10/04 
	  */
	/*public String selEtopPort(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" SELECT ETOP_STN ");
		sql.append(" FROM BS_ETOP_PORT_T ");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND ARR_STN = '"+params.getArr_stn()+"' ");

		Logger.debug.println("[BASE:NotQ010Query:selEtopPort] sql : "+sql.toString());
		return sql.toString();
	}*/
	
	/** 
	  * CITYPAIR REFILE_PORT, REFILE_ALT_PORT ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/13 
	  */
	public String selCitypairRefile(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT REFILE_PORT, DECODE(REFILE_ALT_PORT, 'XXX', '', REFILE_ALT_PORT) REFILE_ALT_PORT ");
		sql.append(" FROM CM_CITYPAIR_DEF_T ");
		sql.append(" WHERE DEP_PORT = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND ARV_PORT = '"+params.getArr_stn()+"' ");
		
		Logger.debug.println("[BASE:NotQ010Query:selCitypairRefile] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Ư Route Route Station ȸ SQLԼ. -- 2010.01.07 
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/10 
	  */
	/*public String selRteStn(NotQ010BG params, String rteCd) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT DEP_STN, ARR_STN, RTE_CD, RTE_STN ");
		sql.append(" FROM BS_COMP_ROUTE_T ");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND ARR_STN = '"+params.getArr_stn()+"' ");
		sql.append(" 	AND RTE_CD = '"+rteCd+"' ");
		
		Logger.debug.println("[BASE:NotQ010Query:selRteStn] sql : "+sql.toString());
		return sql.toString();
	}*/
	
	/** 
	  * New Company Route ̺ Route Station ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2009/12/30 
	  */
	public String selCompRoute(NotQ010BG params, String rteCd) {
		StringBuffer sql = new StringBuffer();

		/*sql.append(" SELECT DEP_STN, ARR_STN, RTE_CD, ETOPS_STN, ENRTE_STN, REFILE_STN, OTHERS_STN, RTE_FIR ");
		sql.append(" FROM BS_COMP_ROUTE_T ");
		sql.append(" WHERE DEP_STN = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND ARR_STN = '"+params.getArr_stn()+"' ");
		sql.append(" 	AND RTE_CD = '"+rteCd+"' ");
		2014-06-17
		*/		
		sql.append("SELECT * FROM(");
		sql.append("		SELECT		DEP_STN, ARR_STN, RTE_CD, ETOPS_STN, ENRTE_STN, REFILE_STN, OTHERS_STN, RTE_FIR");
		sql.append("		FROM	BS_COMP_ROUTE_T");
		sql.append("		WHERE	DEP_STN	=	'"+params.getDep_stn()+"'");
		sql.append("		AND	ARR_STN	=	'"+params.getArr_stn()+"'");
		sql.append("		AND	SUBSTR(RTE_CD,1,3)	=	SUBSTR('"+rteCd+"',1,3)");
		sql.append("		ORDER BY	DECODE(RTE_CD,'"+rteCd+"',1,SUBSTR('"+rteCd+"',1,3),2,3)");// 켱 : ü 1, 3ڸ  2,  3
		sql.append("	) WHERE ROWNUM=1");
		
		Logger.debug.println("[BASE:NotQ010Query:selCompRoute] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ð YYYYMMDDHH24MISSxFF ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2007/09/16 
	  */
	public String selCurrTm() {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT TO_CHAR(CURRENT_TIMESTAMP,'YYYYMMDDHH24MISSxFF') CURR_TM ");
		sql.append(" FROM DUAL ");
		
		Logger.debug.println("[BASE:NotQ010Query:selCurrTm] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_NOTAM_ARCHIVE_T  Է FIRST_LEG_FLT_DT ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2008/01/22 
	  */
	public String selArcFirstLegFltDt(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT TO_CHAR(FIRST_LEG_FLT_DT, 'YYYY-MM-DD') FIRST_LEG_FLT_DT ");
		sql.append(" FROM DAILY_SCH_T ");
		sql.append(" WHERE FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE - 9/24 - 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE - 9/24 + 2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND EST_DEP_DT >= SYSDATE - 9/24 - 8/24 ");
		sql.append(" 	AND FLT_NUM = '"+params.getFlt_num()+"' ");
		sql.append(" 	AND ACTNID <> 'CNL' ");
		sql.append(" 	AND ROWNUM = 1 ");
		sql.append(" ORDER BY EST_DEP_DT ");
		
		Logger.debug.println("[BASE:NotQ010Query:selArcFirstLegFltDt] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_NOTAM_ARCHIVE_T  Է REGION_CD(FLIGHT_PLAN_T) ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2008/01/22 
	  */
	public String selArcFplRcd(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT B.REGION_CD ");
		sql.append(" FROM DAILY_SCH_T A, FLIGHT_PLAN_T B, CM_PORT_T C, CM_PORT_T D ");
		sql.append(" WHERE A.FIRST_LEG_FLT_DT >= TO_DATE(TO_CHAR(SYSDATE-9/24-2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT <= TO_DATE(TO_CHAR(SYSDATE-9/24+2,'YYYYMMDD'),'YYYYMMDD') ");
		sql.append(" 	AND A.EST_DEP_DT >= SYSDATE - 9/24 - 8/24 ");
		sql.append(" 	AND A.ACTNID <> 'CNL' ");
		sql.append(" 	AND A.FLT_NUM = '"+params.getFlt_num()+"' ");
		sql.append(" 	AND A.STNFR = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND A.STNTO = '"+params.getArr_stn()+"' ");
		sql.append(" 	AND B.ROUTE = '"+params.getRte_id()+"' ");
		sql.append(" 	AND A.FIRST_LEG_FLT_DT = B.FIRST_LEG_FLT_DT ");
		sql.append(" 	AND A.FLT_NUM = B.FLT_NUM ");
		sql.append(" 	AND A.STNFR = B.STNFR ");
		sql.append(" 	AND A.STNTO = B.STNTO ");
		sql.append(" 	AND B.ACTIVE ='Y' ");
		sql.append(" 	AND A.STNFR = C.IATA_PORT ");
		sql.append(" 	AND A.STNTO = D.IATA_PORT ");
		sql.append(" 	ORDER BY A.EST_DEP_DT ");

		Logger.debug.println("[BASE:NotQ010Query:selArcFplRcd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_NOTAM_ARCHIVE_T  Է REGION_CD(CM_CITYPAIR_DEF_T) ȸ SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2008/01/22 
	  */
	public String selArcCitypairRcd(NotQ010BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT REGION_CD ");
		sql.append(" FROM CM_CITYPAIR_DEF_T "); 
		sql.append(" WHERE DEP_PORT = '"+params.getDep_stn()+"' ");
		sql.append(" 	AND ARV_PORT = '"+params.getArr_stn()+"' ");

		Logger.debug.println("[BASE:NotQ010Query:selArcCitypairRcd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_NOTAM_ARCHIVE_T  Է SQLԼ.
	  * @param params NotQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2008/01/22 
	  */
	public String insArc(String sendDt, String firstLegFltDt, String fltNum, String stnfr, String stnto, int portSeq, String notPort, String notNum, String regionCd, String userId, String printY) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_NOTAM_ARCHIVE_T ");
		sql.append(" (SEND_DT, FIRST_LEG_FLT_DT, FLT_NUM, STNFR, STNTO, PORT_SEQ, NOT_PORT, NOT_NUM, REGION_CD, USERID, SENT_TP) "); //2008.12.10  : ʵ  -> 2009.01.13 ߰ : SENT_TP
		sql.append(" VALUES (TO_DATE('"+sendDt+"', 'YYYYMMDDHH24MISS'), TO_DATE('"+firstLegFltDt+"', 'YYYY-MM-DD'), ");
		sql.append(" '"+fltNum+"', '"+stnfr+"', '"+stnto+"', "+portSeq+", '"+notPort+"', '"+notNum+"', '"+regionCd+"', '"+userId+"', '"+printY+"') ");

		System.out.println("[BASE:NotQ010Query:insArc] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * ¥ ( ˻϶ ð Էµ ETD,ETA  ڷ ) ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2009/11/14 
	  */
	public String selSysdate() {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(SYSDATE-9/24, 'HH24MI') HH24MI, ");
		sql.append(" TO_CHAR(SYSDATE-9/24, 'YYMMDD') YYMMDD, ");
		sql.append(" TO_CHAR(SYSDATE-9/24+1, 'YYMMDD') YYMMDD1, ");
		sql.append(" TO_CHAR(SYSDATE-9/24+2, 'YYMMDD') YYMMDD2 ");
		sql.append(" FROM DUAL ");

		Logger.debug.println("[BASE:NotQ010Query:selSysdate] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Ư FIR_CD ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2010/01/05 
	  */
	public String selStnFirCd(String stn) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT FIR_CD ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ICAO_PORT='"+stn+"' ");

		System.out.println("[BASE:NotQ010Query:selStnFirCd] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * FPL ۼ  FIR  ð ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2010/01/05 
	  */
	public String selFplFir(String syskey) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT SEQ, FIR_CD, ENTRY_TM, SUBSTR(ENTRY_TM,1,2)*60+SUBSTR(ENTRY_TM,3,2) ENTRY_MIN ");
		sql.append(" FROM FPL_FIR_T ");
		sql.append(" WHERE SYSKEY = '"+syskey+"' ");
		sql.append(" ORDER BY SEQ ");

		System.out.println("[BASE:NotQ010Query:selFplFir] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * TODC PORT_TECH_INFO̺   ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2012/04/30 
	  */
	public String selPortTechInfo(String stn, String infoType, String infoCategory) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT PORT_TECH_INFO ");
		sql.append(" FROM TODC_TECHINFO_T ");
		sql.append(" WHERE ICAO = '"+stn+"' AND INFO_TYPE = '"+infoType+"' AND INFO_CATEGORY = '"+infoCategory+"' ");

		System.out.println("[BASE:NotQ010Query:selPortTechInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * 20150716 ߰
	  * CAT II/III MINIMA  ȸ ̺ TODC_CATINFO_T   
	  */
	public String selPortCatInfo(String stn, String infoType, String infoCategory) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT PORT_TECH_INFO ");
		sql.append(" FROM KFOS.TODC_CATINFO_T ");
		sql.append(" WHERE ICAO = '"+stn+"' AND INFO_TYPE = '"+infoType+"' AND INFO_CATEGORY = '"+infoCategory+"' ");

		System.out.println("[BASE:NotQ010Query:selPortCatInfo] sql : "+sql.toString());
		return sql.toString();
	}
}
