package kal.base.ocb.query;

import kal.base.jdf.com.Logger;
import kal.base.rep.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * OCB Daily Operations Information2 ȭ鿡  Query
 * ۼ ¥: 2005-03-29
 * @author: HIST  
 */
public class OcbQ030Query {
	private static OcbQ030Query instance = new OcbQ030Query();
	
	public static OcbQ030Query getInstance() {
		return instance;
	}
	
	/** 
	  * EARLY OPS FLTS ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2005/03/29 HIST 
	  */
	public String selEarlyOpsFlts(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select B.First_Leg_Flt_Dt, A.Flt_Num, A.Leg_num, A.Regno, A.Stnfr, A.Stnto, A.Dep_Sts, A.Arv_Sts,A.Sch_Arv_Dt_Loc Order_Sta,");
		sql.append("        	To_Char(A.Sch_Dep_Dt_Loc,'hh24:mi')||'L' Sch_Dep_Dt_Loc,");
		sql.append("        	To_Char(A.Act_Dep_Dt_Loc,'hh24:mi')||'L' Act_Dep_Dt_Loc,");
		sql.append("        	To_Char(A.Sch_Arv_Dt_Loc,'hh24:mi')||'L' Sch_Arv_Dt_Loc,");
		sql.append("        	To_Char(A.Est_Arv_Dt_Loc,'hh24:mi')||'L' Est_Arv_Dt_Loc,");
		sql.append("        	To_Char(A.Act_Arv_Dt_Loc,'hh24:mi')||'L' Act_Arv_Dt_Loc");
		sql.append(" From Daily_Sch_t A,");
		sql.append("     	(Select First_Leg_Flt_Dt, Flt_Num");
		sql.append("      	 From Daily_Sch_T");
		sql.append("      	 Where Arln_Cd = 'KE' And");
		sql.append("            		First_Leg_Flt_Dt = To_Date('"+reportD+"','yyyymmdd')-1 And");
		sql.append("            		Sch_Arv_Dt >= To_Date('"+reportD+" 1500','yyyymmdd hh24mi')-1 And");
		sql.append("            		Sch_Arv_Dt <= To_Date('"+reportD+" 2300','yyyymmdd hh24mi')-1 And");
		sql.append("            		Stnto = 'ICN' And");
		sql.append("            		Actnid <> 'CNL') B");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		sql.append("       		A.First_Leg_Flt_Dt >= To_Date('"+reportD+"' ,'yyyymmdd')-2 And");
		sql.append("       		A.First_Leg_Flt_Dt <= To_Date('"+reportD+"' ,'yyyymmdd')-1 And");
		sql.append("       		A.First_Leg_Flt_Dt = B.First_Leg_Flt_Dt And");
		sql.append("       		A.Flt_Num = B.Flt_Num");
		sql.append(" Order By Order_Sta,1,2,3");
		
		Logger.debug.println("[BASE:OcbQ030Query:selEarlyOpsFlts] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * EXTR/CHTR/FRY For TODAY ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2005/03/29 HIST 
	  */
	public String selSvcToday(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Flt_Num, Stnfr, Stnto, kactyp, SVC, Dep_Sts, Arv_Sts,");
		sql.append("        	To_Char(Sch_Dep_Dt,'yyyymmddhh24mi'),");
		sql.append("        	To_Char(Sch_Dep_Dt_Loc,'hh24:mi')||'L' Sch_Dep_Dt_Loc,");
		sql.append("        	To_Char(Act_Dep_Dt_Loc,'hh24:mi')||'L' Act_Dep_Dt_Loc,");
		sql.append("        	To_Char(Sch_Arv_Dt_Loc,'hh24:mi')||'L' Sch_Arv_Dt_Loc,");
		sql.append("        	To_Char(Act_Arv_Dt_Loc,'hh24:mi')||'L' Act_Arv_Dt_Loc");
		sql.append(" From Daily_Sch_t");
		sql.append(" Where Arln_Cd = 'KE' And");
		sql.append("       		Sch_Dep_Dt >= To_Date('"+reportD+" 1500','yyyymmdd hh24mi')-1 And");
		sql.append("       		Sch_Dep_Dt <= To_Date('"+reportD+" 1459','yyyymmdd hh24mi') And");
		sql.append("       		Actnid <> 'CNL'  And");
		sql.append("      		(Svc In('G','A','C','H','P','T','K','W') or");
		sql.append("       		Substr(Flt_Num,5,1) In('M','T','F','P'))");
		sql.append(" Order By 8");
		
		Logger.debug.println("[BASE:OcbQ030Query:selSvcToday] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * EXTR/CHTR/FRY For TOMORROW ȸ SQLԼ.
	  * @param reportD String yyyymmdd
	  * @return String Query  
	  * @author Copyright (c) 2005/03/29 HIST 
	  */
	public String selSvcTomorrow(String reportD) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select Flt_Num, Stnfr, Stnto, kactyp, SVC, Dep_Sts, Arv_Sts,");
		sql.append("        	To_Char(Sch_Dep_Dt,'yyyymmdd hh24mi'),");
		sql.append("        	To_Char(Sch_Dep_Dt_Loc,'hh24:mi')||'L' Sch_Dep_Dt_Loc,");
		sql.append("        	To_Char(Act_Dep_Dt_Loc,'hh24:mi')||'L' Act_Dep_Dt_Loc,");
		sql.append("        	To_Char(Sch_Arv_Dt_Loc,'hh24:mi')||'L' Sch_Arv_Dt_Loc,");
		sql.append("        	To_Char(Act_Arv_Dt_Loc,'hh24:mi')||'L' Act_Arv_Dt_Loc");
		sql.append(" From Daily_Sch_t");
		sql.append(" Where Arln_Cd = 'KE' And");
		sql.append("       		Sch_Dep_Dt >= To_Date('"+reportD+" 1500','yyyymmdd hh24mi') And");
		sql.append("       		Sch_Dep_Dt <= To_Date('"+reportD+" 1459','yyyymmdd hh24mi')+1 And");
		sql.append("       		Actnid <> 'CNL'  And");
		sql.append("      		(Svc In('G','A','C','H','P','T','K','W') or");
		sql.append("       		Substr(Flt_Num,5,1) In('M','T','F','P'))");
		sql.append(" Order By 8");
		
		Logger.debug.println("[BASE:OcbQ030Query:selSvcTomorrow] sql : "+sql.toString());
		return sql.toString();
	}		
}
