package kal.base.skd.query;

import kal.base.jdf.com.Logger;
import kal.base.skd.dbbean.*;
import kal.base.com.query.*;

 /**
   * SKD/Daily SKD Display SQL 
   * @author Copyright (c) 2005/01/17 HIST  
   */     
public class SkdQ010Query {
	
	private static SkdQ010Query instance = new SkdQ010Query();
	
	public static SkdQ010Query getInstance() {
		return instance;
	}
	
	/** 
	  * SKD/Daily SKD Display Main ȸ SQLԼ.
	  * @param params SkdQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/17 HIST 
	  */
	public String selMain(SkdQ010BG params) {
		StringBuffer sql = new StringBuffer();
	
		sql.append(" Select A.Flt_Num,A.Leg_Num,A.Kactyp,A.Stnfr,A.Stnto,A.Regno,A.Spot_In,A.Spot_Out,A.Dep_Sts,A.Arv_Sts,");
		sql.append("            To_Char(A.Sch_Dep_Dt+(540/1440),'yyyymmddhh24mi') Sch_Dep_Dt_Kst,");
		sql.append("            To_Char(A.Act_Dep_Dt+(540/1440),'yyyymmddhh24mi') Act_Dep_Dt_Kst,");
		if (params.getTime_x().equals("KST")) {
			sql.append("        To_Char(A.Sch_Dep_Dt+(540/1440),'yyyymmddhh24mi') Sch_Dep_Dt,");
			sql.append("        To_Char(A.Sch_Arv_Dt+(540/1440),'yyyymmddhh24mi') Sch_Arv_Dt,"); //2010.04.22 ߰
			sql.append("        To_Char(A.Est_Dep_Dt+(540/1440),'yyyymmddhh24mi') Est_Dep_Dt,"); //2016.12.26 ߰
			sql.append("        To_Char(A.Est_Arv_Dt+(540/1440),'yyyymmddhh24mi') Est_Arv_Dt,"); //2016.12.26 ߰
			sql.append("        To_Char(A.Sch_Dep_Dt+(540/1440),'hh24:mi') Sch_Dep_tm,To_Char(A.Sch_Arv_Dt+(540/1440),'hh24:mi') Sch_Arv_tm,");
			sql.append("        To_Char(A.Est_Dep_Dt+(540/1440),'hh24:mi') Est_Dep_tm,To_Char(A.Est_Arv_Dt+(540/1440),'hh24:mi') Est_Arv_tm,"); // 2016.12.26 ߰ 
			sql.append("        To_Char(A.Act_Dep_Dt+(540/1440),'hh24:mi') Act_Dep_tm,To_Char(A.Act_Arv_Dt+(540/1440),'hh24:mi') Act_Arv_tm,");
		} else if (params.getTime_x().equals("LOC")) {
			sql.append("        To_Char(A.Sch_Dep_Dt_Loc,'yyyymmddhh24mi') Sch_Dep_Dt,");
			sql.append("        To_Char(A.Sch_Arv_Dt_Loc,'yyyymmddhh24mi') Sch_Arv_Dt,"); //2010.04.22 ߰
			sql.append("        To_Char(A.Est_Dep_Dt_Loc,'yyyymmddhh24mi') Est_Dep_Dt,"); //2016.12.26 ߰
			sql.append("        To_Char(A.Est_Arv_Dt_Loc,'yyyymmddhh24mi') Est_Arv_Dt,"); //2016.12.26 ߰
			sql.append("        To_Char(A.Sch_Dep_Dt_Loc,'hh24:mi') Sch_Dep_tm,To_Char(A.Sch_Arv_Dt_Loc,'hh24:mi') Sch_Arv_tm,");
			sql.append("        To_Char(A.Est_Dep_Dt_Loc,'hh24:mi') Est_Dep_tm,To_Char(A.Est_Arv_Dt_Loc,'hh24:mi') Est_Arv_tm,"); //2016.12.26 ߰
			sql.append("        To_Char(A.Act_Dep_Dt_Loc,'hh24:mi') Act_Dep_tm,To_Char(A.Act_Arv_Dt_Loc,'hh24:mi') Act_Arv_tm,");
		} else {
			sql.append("        To_Char(A.Sch_Dep_Dt,'yyyymmddhh24mi') Sch_Dep_Dt,");
			sql.append("        To_Char(A.Sch_Arv_Dt,'yyyymmddhh24mi') Sch_Arv_Dt,"); //2010.04.22 ߰
			sql.append("        To_Char(A.Est_Dep_Dt,'yyyymmddhh24mi') Est_Dep_Dt,"); //2016.12.26 ߰
			sql.append("        To_Char(A.Est_Arv_Dt,'yyyymmddhh24mi') Est_Arv_Dt,"); //2016.12.26 ߰
			sql.append("        To_Char(A.Sch_Dep_Dt,'hh24:mi') Sch_Dep_tm,To_Char(A.Sch_Arv_Dt,'hh24:mi') Sch_Arv_tm,");
			sql.append("        To_Char(A.Est_Dep_Dt,'hh24:mi') Est_Dep_tm,To_Char(A.Est_Arv_Dt,'hh24:mi') Est_Arv_tm,"); //2016.12.26 ߰
			sql.append("        To_Char(A.Act_Dep_Dt,'hh24:mi') Act_Dep_tm,To_Char(A.Act_Arv_Dt,'hh24:mi') Act_Arv_tm,");
		}
		sql.append("            A.Actnid, Nvl(A.Chgreas,' ') Chgreas,A.Svc,A.Dep_STS,");
		sql.append("        	Nvl(A.F_Cfg,0) F_Cfg,Nvl(A.C_Cfg,0) C_Cfg,Nvl(A.Y_Cfg,0) Y_Cfg,");
		sql.append("        	Nvl(A.F_Book,0) F_Book,Nvl(A.C_Book,0) C_Book,Nvl(A.Y_Book,0) Y_Book,");
		sql.append("        	Nvl(A.F_Chkin,0) F_Chkin,Nvl(A.C_Chkin,0) C_Chkin,Nvl(A.Y_Chkin,0) Y_Chkin,");
		sql.append("        	To_Char(A.Sch_Dep_Dt,'yyyymmddhh24mi') Key_Sch_Dep_Dt,");	// sch_dep_dt loc ٲ  key̱ⶫ ʹٲ.
		sql.append("        	To_Char(A.TimeStamp+39/24 ,'yyyymmddhh24mi') TimeStamp,");
		sql.append("        	To_Char(A.First_Leg_Flt_Dt ,'yyyymmdd') First_Leg_Flt_Dt, ");
		sql.append("			A.HIDEINFO, "); // 2006.09.15 ==> ߰
		sql.append("			A.ADMRAD "); //2008.02.21 ߰ : ADMRAD 'A' or 'R' 츸 REGNO Display
		
		//20150603 ߰
		sql.append("        	, To_Char(A.Sch_Dep_Dt_Loc ,'yyyymmdd') Sch_Dep_Dt_Loc ");
		//2017.01.11 ߰
		sql.append("        	, To_Char(A.TKOF_T) Tkof_t ");
		sql.append("        	, To_Char(A.LAND_T) land_t ");
		
		sql.append(" From Daily_Sch_T A");
		sql.append(" Where A.Arln_Cd = 'KE' And");
		//sql.append(" 	SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.12.02 ߰ :  FLT 	@2013-11-08
		if (params.getTime_x().equals("KST")) {
			sql.append("        A.Sch_Dep_Dt >= To_Date('"+params.getSch_dep_dt()+" 0000','yyyymmdd hh24mi')-(540/1440) And");
			sql.append("        A.Sch_Dep_Dt <= To_Date('"+params.getSch_dep_dt()+" 2359','yyyymmdd hh24mi')-(540/1440) And");
		} else if (params.getTime_x().equals("LOC")) {
			sql.append("        A.Sch_Dep_Dt_Loc >= To_Date('"+params.getSch_dep_dt()+" 0000','yyyymmdd hh24mi') And");
			sql.append("        A.Sch_Dep_Dt_Loc <= To_Date('"+params.getSch_dep_dt()+" 2359','yyyymmdd hh24mi') And");
		} else {
			sql.append("        A.Sch_Dep_Dt >= To_Date('"+params.getSch_dep_dt()+" 0000','yyyymmdd hh24mi') And");
			sql.append("        A.Sch_Dep_Dt <= To_Date('"+params.getSch_dep_dt()+" 2359','yyyymmdd hh24mi') And");
		}
		if (!params.getFlt_num().equals(""))
			sql.append("    A.Flt_Num = '"+params.getFlt_num()+"' And");
		//stnFr  stnTo   From/To or  ϰ Ʋ and ̴ 2005.03.23 
		if (!params.getStnfr().equals("") || !params.getStnto().equals("")) {
			if (params.getStnfr().equals(params.getStnto())) {
				sql.append("    (A.Stnfr = '"+params.getStnfr()+"' or A.Stnto = '"+params.getStnfr()+"') And");			
			} else {
				if (!params.getStnfr().equals(""))
					sql.append("    A.Stnfr = '"+params.getStnfr()+"'  And");			
				if (!params.getStnto().equals(""))
					sql.append("    A.Stnto = '"+params.getStnto()+"'  And");			
			}
		}
		if (!params.getRegno().equals(""))
			sql.append("    A.Regno = 'HL"+params.getRegno()+"' And");
		
		//DOM/INT/CGO ȸ
		if("DOM(LJ)".equals(params.getDom_int_x())){//@2013-11-08
			sql.append(" 	SUBSTR(FLT_NUM, 1, 1) = '4' AND ");
			sql.append(" REGION_LEG = '1' AND ");			
		}else if("INT(LJ)".equals(params.getDom_int_x())){//@2013-11-08
			sql.append(" 	SUBSTR(FLT_NUM, 1, 1) = '4' AND ");
			sql.append(" REGION_LEG != '1' AND ");	
		}else{
			sql.append(" 	SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //@2013-11-08
			sql.append(ComQ01Query.getInstance().selDomIntQ(params.getDom_int_x()));
		}
		

		sql.append("        A.Dep_Sts    <> 'INI'");
		
		//@2017-07-07 kactyp
		if (!params.getKactyp().equals("")){
			sql.append(" AND A.Kactyp='"+params.getKactyp()+"'");
		}
			
		
		
		//sql.append(" Order By Sch_Dep_Dt, Flt_Num");
		//2009.10.12 ߰ : SORT  ߰
		if (params.getSort().equals("FLT")) {
			sql.append(" Order By Flt_Num, Sch_Dep_Dt, Leg_Num ");
		} else if (params.getSort().equals("TYP")) {
			sql.append(" Order By Gactyp, Sactyp, Kactyp, Regno, Sch_Dep_Dt ");
		} else if (params.getSort().equals("DEP")) {
			sql.append(" Order By Stnfr, Sch_Dep_Dt ");
		} else if (params.getSort().equals("ARR")) {
			sql.append(" Order By Stnto, Sch_Arv_Dt ");
		} else if (params.getSort().equals("STA")) { //2010.04.22 ߰
			sql.append(" Order By Sch_Arv_Dt, Flt_Num ");
		} else if (params.getSort().equals("STD")) { // STD
			sql.append(" Order By Sch_Dep_Dt, Flt_Num ");
		} else if (params.getSort().equals("ETD")) { //2016.12.26 ߰ 
			sql.append(" Order By Est_Dep_Dt, Flt_Num ");
		} else if (params.getSort().equals("ETA")) { //2016.12.26 ߰  
			sql.append(" Order By Est_Arv_Dt, Flt_Num ");	
		} 
		
		
		//System.out.println("[BASE:SkdQ010Query:selMain] sql : "+sql.toString());
		//Logger.debug.println("[BASE:SkdQ010Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * SKD/Daily SKD Display Daily Crew ȸ SQLԼ.
	  * @param params SkdQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/17 HIST 
	  */
	public String selDailyCrew(SkdQ010BG params) {
		StringBuffer sql = new StringBuffer();
		
		//2016.10.27 ּó ¥񱳺κ
		//int int_dt = Integer.parseInt(params.getSch_dep_dt());
		
			sql.append(" Select B.Flt_Num||B.Port_a||B.Port_b||Decode(B.Cop_Duty_Cd,'CM','P1','P1','P1','PZ') name_key, Substr(D.Surname,1,30) Surname, D.Staff_Num ");
			//2017.02.09
			sql.append(" From DUTY_PRD_SEG_V@kfos2airfd B, ROSTER_V@kfos2airfd C, CREW_V@kfos2airfd D");
			//sql.append(" From DUTY_PRD_SEG_V@KFOS2FDPRD B, ROSTER_V@KFOS2FDPRD C, CREW_V@KFOS2FDPRD D");
			if (params.getTime_x().equals("UTC")) {
				sql.append(" Where B.Act_Str_Dt_TM_Gmt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi') And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
				sql.append("       B.Act_Str_Dt_TM_Gmt <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi') And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
                sql.append("       C.Act_Str_Dt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi')-20 And");//2016.12.12
                sql.append("       C.Act_Str_Dt <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi') And");//2016.12.12
                sql.append("       C.Act_End_Dt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi') And");//2016.12.12

			} else if (params.getTime_x().equals("LOC")) {
				sql.append(" Where B.Str_Dt_TM_Loc >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi')-(2/24) And");
				sql.append("       B.Str_Dt_TM_Loc <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi')+(2/24) And");
                sql.append("       C.Act_Str_Dt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi')-20 And");//2016.12.12
                sql.append("       C.Act_Str_Dt <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi')+3 And");//2016.12.12
                sql.append("       C.Act_End_Dt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi')-3 And");//2016.12.12

			} else {
				sql.append(" Where B.Act_Str_Dt_TM_Gmt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi')-(540/1440) And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
				sql.append("       B.Act_Str_Dt_TM_Gmt <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi')-(540/1440) And"); //2009.01.22  : Str_Dt_TM_Gmt -> Act_Str_Dt_TM_Gmt
                sql.append("       C.Act_Str_Dt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi')-(540/1440)-20 And");//2016.12.12
                sql.append("       C.Act_Str_Dt <= To_Date('"+params.getSch_dep_dt()+"2359','yyyymmddhh24mi')-(540/1440) And");//2016.12.12
                sql.append("       C.Act_End_Dt >= To_Date('"+params.getSch_dep_dt()+"0000','yyyymmddhh24mi')-(540/1440) And");//2016.12.12
			}
			sql.append("       B.Delete_Ind = 'N' And");
			sql.append("       B.Series_num = C.Series_Num And");
			sql.append("       C.Delete_Ind = 'N' And");
			sql.append("       C.Staff_Num  = D.Staff_Num And");
			//sql.append("       B.Port_a <> B.Port_b And");
			//sql.append("       B.Flt_Num Not In('RST','LO','0') And");
			sql.append("       B.Duty_Cd = 'FLY' And");
			sql.append("       C.Acting_Rank = 'CAP'");
			//sql.append("       (C.Acting_Rank = 'CAP' or B.Cop_Duty_Cd In('CM','P1','P2'))");
			sql.append(" Order By 1,2");
		
		//System.out.println("[BASE:SkdQ010Query:selDailyCrew] sql : "+sql.toString());
		//Logger.debug.println("[BASE:SkdQ010Query:selDailyCrew] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * SKD/Daily SKD Display Crew ȸ SQLԼ.
	  * @param params SkdQ010BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/01/17 HIST 
	  */
	public String selCrew(SkdQ010BG params) {
		StringBuffer sql = new StringBuffer();
		
		int int_dt = Integer.parseInt(params.getSch_dep_dt().substring(0,8));
		
		if (int_dt < 20100501) {
			
			sql.append(" Select Substr(D.Surname,1,30) Surname, D.Staff_Num "); //2007.11.02 ߰ : Staff_Num
			sql.append(" From DUTY_PRD_SEG_V B,ROSTER_V C, CREW_V D");
			sql.append(" Where B.Delete_Ind = 'N' And");
			sql.append("            B.First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') and");
			sql.append("            B.Flt_Num    = '"+params.getFlt_num()+"'       And");
			sql.append("            B.Port_a     = '"+params.getStnfr()+"'        And");
			sql.append("            B.Port_b     = '"+params.getStnto()+"'        And");
			sql.append("            B.Series_num = C.Series_Num And");
			sql.append("            C.Delete_Ind = 'N' And");
			sql.append("            C.Staff_Num  = D.Staff_Num And");
			sql.append("           (C.Acting_Rank = 'CAP' or B.Cop_Duty_Cd In('CM','P1','P2')) And");
			sql.append("            Rownum = 1");
			
		} else {
			
			sql.append(" Select Substr(D.Surname,1,30) Surname, D.Staff_Num "); //2007.11.02 ߰ : Staff_Num
			//2017.02.09
			sql.append(" From DUTY_PRD_SEG_V@kfos2airfd B,ROSTER_V@kfos2airfd C, CREW_V@kfos2airfd D");
			//sql.append(" From DUTY_PRD_SEG_V@KFOS2FDPRD B,ROSTER_V@KFOS2FDPRD C, CREW_V@KFOS2FDPRD D");
			
			sql.append(" Where B.Delete_Ind = 'N' And");
			sql.append("            B.First_Leg_Flt_Dt = To_Date('"+params.getFirst_leg_flt_dt()+"','yyyymmdd') and");
			sql.append("            B.Flt_Num    = '"+params.getFlt_num()+"'       And");
			sql.append("            B.Port_a     = '"+params.getStnfr()+"'        And");
			sql.append("            B.Port_b     = '"+params.getStnto()+"'        And");
			sql.append("            B.Series_num = C.Series_Num And");
			sql.append("            C.Delete_Ind = 'N' And");
			sql.append("            C.Staff_Num  = D.Staff_Num And");
			sql.append("           (C.Acting_Rank = 'CAP' or B.Cop_Duty_Cd In('CM','P1','P2')) And");
			sql.append("            Rownum = 1");
		}
		
		//System.out.println("[BASE:SkdQ010Query:selCrew] sql : "+sql.toString());
		//Logger.debug.println("[BASE:SkdQ010Query:selCrew] sql : "+sql.toString());
		return sql.toString();
	}	
	public String selKactyp() {//@2017-07-10
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT DISTINCT KACTYP");
		sql.append(" FROM CM_REGNO_T");
		sql.append(" WHERE ARLN_CD IN ('KE','LJ') ");
		sql.append(" ORDER BY KACTYP ASC");
		
		System.out.println("[BASE:SkdQ010Query:selKactyp] sql : "+sql.toString());
		return sql.toString();
	}
}
