package kal.base.sta.query;

import kal.base.jdf.com.Logger;
import kal.base.sta.dbbean.*;
import kal.base.com.query.*;

 /**
   * OPS Statistics/Ontime Status-Airport SQL 
   * @author Copyright (c) 2005/01/26 HIST  
   */  
public class StaQ030Query {
	
	private static StaQ030Query instance = new StaQ030Query();
	
	public static StaQ030Query getInstance() {
		return instance;
	}
	
	/** 
	  * OPS Statistics/Ontime Status-Airport Main ȸ SQLԼ.
	  * @param params StaQ030BG ȸ
	  * @return String Query  
	  * @author Copyright (c) 2005/01/26 HIST 
	  */
	public String selMain(StaQ030BG params) {
		StringBuffer sql = new StringBuffer();
		
		// D/A ǿ  ȸ Ǻ
		String station = "Stnfr";
		String schDt = "Sch_Dep_Dt";
		String actDt = "Act_Dep_Dt";
		String delRc1 = "Del_Rc1";
		String actNid = "Decode(Actnid,'CNL','CNL','NEW') Actnid";
		if (params.getDep_arr_x().equals("ARR")) {
			station = "Stnto";
			schDt = "Sch_Arv_Dt";
			actDt = "Act_Arv_Dt";
			delRc1 = "'B'";
			actNid = "'NEW'";
		}
		
		sql.append(" Select "+station+" Stn,'A' Del_Rc1,Decode(Actnid,'CNL','CNL','NEW') Actnid,Count(*) Data_Cnt,'A' Flt_Mode");
		sql.append(" From Daily_Sch_t");
		sql.append(" Where Arln_cd = 'KE' And");
		sql.append(" 			SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.29 ߰ :  FLT 
		sql.append("            Sch_Dep_Dt >= To_Date('"+params.getFrom_date()+" 0000','yyyymmdd hh24mi') And");
		sql.append("       		Sch_Dep_Dt <= To_Date('"+params.getTo_date()+" 2359','yyyymmdd hh24mi') And");
		sql.append("       		Timestamp >= Sch_Dep_Dt - 39/24 And");
		if (!params.getStn().equals(""))
			sql.append(" "+ (params.getDep_arr_x().equals("DEP") ? "Stnfr" : "Stnto") +" = '"+params.getStn()+"' And");
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(params.getDom_int_x()));
		//Regular ȸ
		if (params.getReg_x().equals("REGULAR"))
			sql.append("            Svc In ('J','F','M') And");
		else if (params.getReg_x().equals("NONREG"))
			sql.append("            Svc In ('G','A','C','H') And");
		else if (params.getReg_x().equals("NONREV"))
			sql.append("            Svc In ('J','F','M','G','A','C','H') And");
		sql.append("       Stnfr <> Stnto And");
		sql.append("       Dep_Sts <> 'INI'");
		sql.append(" Group By "+station+", Decode(Actnid,'CNL','CNL','NEW')");
		sql.append(" Union");
		sql.append(" Select "+station+" Stn,"+delRc1+" Del_Rc1,"+actNid+",Count(*) Data_Cnt,'B' Flt_Mode");
		sql.append(" From Daily_Sch_t");
		sql.append(" Where Arln_cd = 'KE' And");
		sql.append(" 			SUBSTR(FLT_NUM, 1, 1) <> '4' AND "); //2008.10.29 ߰ :  FLT 
		sql.append("            Sch_Dep_Dt >= To_Date('"+params.getFrom_date()+" 0000','yyyymmdd hh24mi') And");
		sql.append("       		Sch_Dep_Dt <= To_Date('"+params.getTo_date()+" 2359','yyyymmdd hh24mi') And");
		if (!params.getStart_tm().equals(""))
			sql.append("       "+actDt+" - "+schDt+" > "+params.getStart_tm()+"/1440 And");
		else 
			sql.append("       "+actDt+" - "+schDt+" > 3/1440 And");
		if (!params.getEnd_tm().equals(""))	
			sql.append("       "+actDt+" - "+schDt+" < "+params.getEnd_tm()+"/1440 And");
		sql.append(" Actnid  <> 'CNL'  And");
		if (!params.getStn().equals(""))
			sql.append(" "+ (params.getDep_arr_x().equals("DEP") ? "Stnfr" : "Stnto") +" = '"+params.getStn()+"' And");
		//DOM/INT/CGO ȸ
		sql.append(ComQ01Query.getInstance().selDomIntQ(params.getDom_int_x()));
		//Regular ȸ
		if (params.getReg_x().equals("REGULAR"))
			sql.append("            Svc In ('J','F','M') And");
		else if (params.getReg_x().equals("NONREG"))
			sql.append("            Svc In ('G','A','C','H') And");
		else if (params.getReg_x().equals("NONREV"))
			sql.append("            Svc In ('J','F','M','G','A','C','H') And");
		sql.append("       Stnfr <> Stnto And");
		sql.append("       Dep_Sts <> 'INI'");
		if (params.getDep_arr_x().equals("DEP"))
			sql.append(" Group By "+station+", Del_Rc1, Decode(Actnid,'CNL','CNL','NEW')");
		else 
			sql.append(" Group By "+station);
		sql.append(" Order By Stn,Flt_Mode,Del_Rc1");
		
		//Logger.debug.println("[BASE:StaQ030Query:selMain] sql : "+sql.toString());
		System.out.println("[BASE:StaQ030Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
}
