package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.sup.dbbean.*;

 /**
   * NOTAM List SQL 
   * @author Copyright (c) 2005/06/13 
   */
public class SupA110Query {
	private static SupA110Query instance = new SupA110Query();
	
	public static SupA110Query getInstance() {
		return instance;
	}
	
	/** 
	  * NOTAM List ȸ SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/06/13 
	  */
	public String selNOTAMList(SupA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ");
		sql.append(" 	NOT_AMS_NUM,TO_CHAR(NOT_DTG,'YYYY/MM/DD HH24:MI') NOT_DTG,NOT_NUM,ICAO_PORT,NOT_TEXT,NOT_ISS_DT,NOT_EXP_DT,NOT_OPEN_Y,");
		sql.append(" 	DECODE(NOT_OLD_CAT,'C',NOT_OLD_CAT,NOT_INPUT) NOT_INPUT, USERID,NOT_TYP,"); //=> 2005.11.16  
		sql.append(" 	NOT_FIR,NOT_2ND_QCD||NOT_4TH_QCD NOT_QCD,NOT_TRAF,NOT_PURP,NOT_SCOP,NOT_LOW,NOT_UPP,NOT_LAT_LON,NOT_CAT,NOT_VALID,NOT_COMMNT,NOT_OLD_NUM,NOT_OLD_CAT");
		sql.append(" FROM BS_NOTAM_T");
		sql.append(" WHERE ");
		sql.append(" 	NOT_DTG >= SYSDATE - (9 + "+params.getDtg_range()+")/24 "); //2007.03.27  : 2,4,6    ְ .
		//sql.append(" 	NOT_DTG >= SYSDATE-15/24 "); ==> 2006.02.08 
		//sql.append(" WHERE NOT_OPEN_Y IS NULL OR");
		//sql.append("     (NOT_OPEN_Y IS NOT NULL AND NOT_DTG >= SYSDATE-11/24)");
		//2005.08.22 -> 2ð ̳  6ð 
		//sql.append("     (NOT_OPEN_Y IS NOT NULL AND NOT_DTG >= SYSDATE-15/24)");
		//sql.append(" WHERE (NOT_OPEN_Y IS NULL OR NOT_OPEN_Y IS NOT NULL)");
		//sql.append(" AND NOT_CAT IN ('N','R','C','S')"); ==> 2005.08.22 
		sql.append(" ORDER BY NOT_DTG DESC, NOT_AMS_NUM DESC ");
		
		Logger.debug.println("[BASE:SupA110Query:selNOTAMList] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM Detail ȸ SQLԼ. -- 
	  * @param params SupA110BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/13 
	  */
	public String selNOTAMDetail(SupA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT 	NOT_FIR,NOT_2ND_QCD||NOT_4TH_QCD NOT_QCD,NOT_TRAF,NOT_PURP,");
		sql.append("        		NOT_SCOP,NOT_LOW,NOT_UPP,NOT_LAT_LON,");
		sql.append("        		NOT_NUM,NOT_CAT,NOT_OLD_NUM,ICAO_PORT,NOT_ISS_DT,");
		sql.append("        		NOT_EXP_DT,NOT_OPEN_Y,NOT_VALID,NOT_TEXT,NOT_COMMNT");
		sql.append(" FROM BS_NOTAM_T");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");

		Logger.debug.println("[BASE:SupA110Query:selNOTAMDetail] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM FIR ȸ SQLԼ.
	  * @param params SupA110BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/15 
	  */
	public String selFirCd(SupA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD FROM BS_FIR_T WHERE FIR_CD = '"+params.getNot_fir()+"'");

		Logger.debug.println("[BASE:SupA110Query:selFirCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Q-Code ȸ SQLԼ.
	  * @param params SupA110BG ȸ
	  * @param qSeq int 1,2
	  * @return String Query 
	  * @author Copyright (c) 2005/06/15 
	  */
	public String selQCd(SupA110BG params, int qSeq){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT NOT_CLS,NOT_QCD FROM BS_NOTAM_QCD_T");
		if (qSeq == 1)
			sql.append(" WHERE NOT_QSEQ = 2 AND NOT_QCD = '"+(params.getNot_qcd()).substring(0,2)+"'");
		else 
			sql.append(" WHERE NOT_QSEQ = 4 AND NOT_QCD = '"+(params.getNot_qcd()).substring(2)+"'");

		Logger.debug.println("[BASE:SupA110Query:selQCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM  SQLԼ.
	  * @param params SupA110BG 
	  * @return String Query 
	  * @author Copyright (c) 2005/06/15 
	  */
	public String updNOTAM(SupA110BG params){
		StringBuffer sql = new StringBuffer();
		if (!params.getNot_qcd().equals("")) {
			params.setNot_qcd1((params.getNot_qcd()).substring(0,2));
			params.setNot_qcd2((params.getNot_qcd()).substring(2));
		} else {
			params.setNot_qcd1("");
			params.setNot_qcd2("");
		}
		
		Logger.debug.println("[BASE:updNOTAM] not_cat : "+params.getNot_cat());

		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET NOT_FIR = '"+params.getNot_fir()+"',");
		sql.append("     	NOT_CLS = '"+params.getNot_cls()+"',");
		sql.append("     	NOT_2ND_QCD = '"+params.getNot_qcd1()+"',");
		sql.append("     	NOT_4TH_QCD = '"+params.getNot_qcd2()+"',");
		sql.append("     	NOT_TRAF = '"+params.getNot_traf()+"',");
		sql.append("     	NOT_PURP = '"+params.getNot_purp()+"',");
		sql.append("     	NOT_SCOP = '"+params.getNot_scop()+"',");
		sql.append("     	NOT_LOW = '"+params.getNot_low()+"',");
		sql.append("     	NOT_UPP = '"+params.getNot_upp()+"',");
		sql.append("     	NOT_LAT_LON = '"+params.getNot_lat_lon()+"',");
		
		if ((params.getNot_iss_dt()).equals("WIE")) {
			sql.append("     	NOT_ISS_DT = TO_CHAR(SYSDATE-9/24,'YYMMDDHH24MI'),");
		} else {
			sql.append("     	NOT_ISS_DT = '"+params.getNot_iss_dt()+"',");
		}
		
		// 2005.11.14 
		if ((params.getNot_typ()).equals("S") && (params.getNot_exp_dt()).equals("PERM")) {
			if ((params.getNot_iss_dt()).equals("WIE")) {
				sql.append("     	NOT_EXP_DT = TO_CHAR(SYSDATE+15/24,'YYMMDDHH24MI'),");
			} else {
				sql.append("     	NOT_EXP_DT = TO_CHAR(TO_DATE('"+params.getNot_iss_dt()+"','YYMMDDHH24MI')+24/24,'YYMMDDHH24MI'),");
			}
		} else {
			sql.append("     	NOT_EXP_DT = '"+params.getNot_exp_dt()+"',");
		}
		
		sql.append("     	NOT_VALID = '"+StringUtil.DBInsStr(params.getNot_valid())+"',");
		sql.append("     	NOT_TEXT = '"+StringUtil.DBInsStr(params.getNot_text())+"',");
		sql.append("     	NOT_OPEN_Y = '"+params.getNot_open_y()+"',");
		sql.append("     	NOT_COMMNT = '"+StringUtil.DBInsStr(params.getNot_commnt())+"',");
		sql.append("     	NOT_OLD_NUM = '"+params.getNot_old_num()+"',");
		//2005.08.05 NOT OLD CAT  
		sql.append("			NOT_OLD_CAT = '"+params.getNot_cat()+"',");
		sql.append("     	NOT_INPUT = 'M',");
		sql.append("     	TIMESTMP = SYSDATE,");
		if (!StringUtil.checkString(params.getNot_typ()).equals(""))
			sql.append("		NOT_TYP = '"+params.getNot_typ()+"',");
		sql.append("     	USERID = '"+params.getUserid()+"'");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");

		Logger.debug.println("[BASE:SupA110Query:updNOTAMList] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM  SQLԼ.
	  * @param params SupA110BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/15 
	  */
	public String delNOTAMItem(SupA110BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE BS_NOTAM_T");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");

		Logger.debug.println("[BASE:SupA110Query:delNOTAMItem] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM List Old NOTAM ȸSQLԼ.
	  * @param icaoPort String ICAO STN
	  * @param notNum String Old NOTAM Number
	  * @return String Query 
	  * @author Copyright (c) 2005/06/20 
	  */
	public String selOldNOTAM(String icaoPort, String notNum){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT,IATA_PORT,NOT_NUM,NOT_ISS_DT,NOT_EXP_DT,NOT_VALID,NOT_TEXT,NOT_CLS,NOT_PREV_EXP_DT,NOT_MARK_Y,NOT_CAT,NOT_MARK_NUM");
		sql.append(" FROM BS_NOTAM_T");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"'");
		sql.append(" AND NOT_NUM = '"+notNum+"'");

		Logger.debug.println("[BASE:SupA110Query:selOldNOTAM] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Code Search Q-Code ȸSQLԼ.
	  * @param notQcd1 String Q-Code 1
	  * @param notQcd2 String Q-Code 2
	  * @return String Query 
	  * @author Copyright (c) 2005/06/20 
	  */
	public String selQCode(String notQcd1, String notQcd2){
		StringBuffer sql = new StringBuffer();
		
		if (!notQcd1.equals("")) {
			sql.append(" SELECT 'Q23' NOT_QSEQ,NOT_CLS,NOT_QCD,NOT_SIGN,NOT_ABBR");
			sql.append(" FROM BS_NOTAM_QCD_T");
			sql.append(" WHERE NOT_QCD = '"+notQcd1+"'");
			sql.append(" AND NOT_QSEQ = 2");
		}
		if (!notQcd1.equals("") && !notQcd2.equals("")) {
			sql.append(" UNION");
		}
		if (!notQcd2.equals("")) {
			sql.append(" SELECT 'Q45' NOT_QSEQ,NOT_CLS,NOT_QCD,NOT_SIGN,NOT_ABBR");
			sql.append(" FROM BS_NOTAM_QCD_T");
			sql.append(" WHERE NOT_QCD = '"+notQcd2+"'");
			sql.append(" AND NOT_QSEQ = 4");
		}
		
		Logger.debug.println("[BASE:SupA110Query:selQCode] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NOTAM Code Search ABBR Code ȸSQLԼ.
	  * @param abbrCd String ABBR Code
	  * @return String Query 
	  * @author Copyright (c) 2005/06/20 
	  */
	public String selABBRCd(String abbrCd){
		StringBuffer sql = new StringBuffer();
		
			sql.append(" SELECT ABBR_CD,ORGN_CD,SIGN");
			sql.append(" FROM BS_ABBR_T");
			sql.append(" WHERE ABBR_CD = '"+abbrCd+"'");
			sql.append(" ORDER BY ORGN_CD");
		
		Logger.debug.println("[BASE:SupA110Query:selABBRCd] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Old NOTAM PORT ȸSQLԼ.
	  * @param icaoPort String ICAO PORT
	  * @return String Query 
	  * @author Copyright (c) 2005/06/20 
	  */
	public String selPORT(String icaoPort){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.PORT_E, B.NATION_ENG_N");
		sql.append(" FROM CM_PORT_T A, NATION_T B");
		sql.append(" WHERE A.CTRY_CD = B.NATION_C");
		sql.append(" AND A.ICAO_PORT = '"+icaoPort+"'");
		
		Logger.debug.println("[BASE:SupA110Query:selPORT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM IATA PORT ȸSQLԼ.
	  * @param icaoPort String ICAO PORT
	  * @return String Query 
	  * @author Copyright (c) 2005/08/30 
	  */
	public String selIATAPort(String icaoPort){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT IATA_PORT");
		sql.append(" FROM CM_PORT_T");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"'");
		
		Logger.debug.println("[BASE:SupA110Query:selIATAPort] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Old NOTAM FIR ȸSQLԼ.
	  * @param firCd String FIR Code
	  * @return String Query 
	  * @author Copyright (c) 2005/06/20 
	  */
	public String selFIR(String firCd){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT A.FIR_CD,A.FIR_E,B.NATION_ENG_N");
		sql.append(" FROM BS_FIR_T A, NATION_T B");
		sql.append(" WHERE A.NAT_CD = B.NATION_C(+)");
		sql.append(" AND A.FIR_CD = '"+firCd+"'");
		
		Logger.debug.println("[BASE:SupA110Query:selFIR] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM NOT ACTIVE 'Y' STN ȸSQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/08/04 
	  */
	public String selNotActive(){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ICAO_PORT FROM CM_PORT_T WHERE NOT_ACTIVE = 'Y'");
		sql.append(" UNION");
		sql.append(" SELECT FIR_CD FROM BS_FIR_T WHERE NOT_ACTIVE = 'Y'");
		
		Logger.debug.println("[BASE:SupA110Query:selNotActive] sql : "+sql.toString());
		return sql.toString();
	}	
}
