package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.sup.dbbean.*;

 /**
   * NOTAM Input SQL 
   * @author Copyright (c) 2005/06/17 
   */
public class SupA120Query {
	private static SupA120Query instance = new SupA120Query();
	
	public static SupA120Query getInstance() {
		return instance;
	}
	
	/** 
	  * NOTAM Input Station ȸ SQLԼ.
	  * @param params SupA120BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/17 
	  */
	public String selStation(SupA120BG params){
		StringBuffer sql = new StringBuffer();
		String stn = StringUtil.checkString(params.getIcao_port());

		sql.append(" SELECT ICAO_PORT FROM CM_PORT_T");
		if (stn.length() == 4)
			sql.append(" WHERE ICAO_PORT = '"+stn+"'");		//(STN 4ڸ )
		else
			sql.append(" WHERE IATA_PORT = '"+stn+"'"); 	//(STN 3ڸ )
		
		Logger.debug.println("[BASE:SupA120Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input FIR ȸ SQLԼ.
	  * @param params SupA120BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/17 
	  */
	public String selFIR(SupA120BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD FROM BS_FIR_T WHERE FIR_CD = '"+params.getIcao_port()+"'");
		
		Logger.debug.println("[BASE:SupA120Query:selFIR] sql : "+sql.toString());
		return sql.toString();
	}	

	/** 
	  * NOTAM Input Station ȸ SQLԼ.
	  * @param params String stn
	  * @return String Query 
	  * @author Copyright (c) 2005/11/16 
	  */
	public String selStation(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT FROM CM_PORT_T");
		if (stn.length() == 4)
			sql.append(" WHERE ICAO_PORT = '"+stn+"'");		//(STN 4ڸ )
		else
			sql.append(" WHERE IATA_PORT = '"+stn+"'"); 	//(STN 3ڸ )
		
		Logger.debug.println("[BASE:SupA120Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input FIR ȸ SQLԼ.
	  * @param params String stn
	  * @return String Query 
	  * @author Copyright (c) 2005/11/16 
	  */
	public String selFIR(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD FROM BS_FIR_T WHERE FIR_CD = '"+stn+"'");
		
		Logger.debug.println("[BASE:SupA120Query:selFIR] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input NOTAM Code ȸ SQLԼ.
	  * @param mode String ȸ
	  * @param params SupA120BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/17 
	  */
	public String selNOTAMCode(String mode,SupA120BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT * FROM BS_NOTAM_T");
		if (mode.equals("STN")) 
			sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		else 
			sql.append(" WHERE NOT_FIR = '"+params.getIcao_port()+"'"); //==> 
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");
		
		Logger.debug.println("[BASE:SupA120Query:selNOTAMCode] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input TYPE 'C' 'R' ȸ SQLԼ.
	  * @param icaoPort String ȸ
	  * @param notNum String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/29 
	  */
	public String selTypeEdit(String icaoPort,String notNum){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT * FROM BS_NOTAM_T");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"'");
		sql.append(" AND NOT_NUM = '"+notNum+"'");
		
		Logger.debug.println("[BASE:SupA120Query:selTypeEdit] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * NOTAM Input OLD NOTAM Update SQLԼ.
	  * @return String Query 
	  * @author Copyright (c) 2005/06/29 
	  */
	public String updOldNOTAM(String icaoPort,String notOldNum,String notNum,String notDtg,String notCat,String userID,boolean dataFlag){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE BS_NOTAM_T");
		sql.append(" SET NOT_CAT = '"+notCat+"',");
		sql.append("        NOT_MARK_NUM = '"+notNum+"',");
		sql.append(" 		NOT_MARK_Y = 'Y',");
		// 2006.03.21  update -> NOT_DTG, insert -> SYSDATE
		if (dataFlag) {
			sql.append(" 	NOT_EXP_DT = '"+notDtg+"',");
			sql.append(" 	NOT_PREV_EXP_DT = '"+notDtg+"',");
		} else {
			sql.append(" 	NOT_EXP_DT = TO_CHAR(SYSDATE-9/24,'YYMMDD')||'0000',");
			sql.append(" 	NOT_PREV_EXP_DT = TO_CHAR(SYSDATE-9/24,'YYMMDD')||'0000',");
		}
		sql.append("     	TIMESTMP = SYSDATE,");
		sql.append("     	NOT_INPUT = 'M',");
		sql.append("     	USERID = '"+userID+"'");
		sql.append(" WHERE ICAO_PORT = '"+icaoPort+"' AND NOT_NUM = '"+notOldNum+"'");
		
		Logger.debug.println("[BASE:SupA120Query:updOldNOTAM] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input Main ȸ SQLԼ.
	  * @param mode String ȸ
	  * @param params SupA120BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/06/17 
	  */
	public String selMain(String mode,SupA120BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT 	NOT_CAT,NOT_FIR,NOT_2ND_QCD||NOT_4TH_QCD NOT_QCD,NOT_TRAF,NOT_PURP,NOT_SCOP,");
		sql.append(" 				NOT_LOW,NOT_UPP,NOT_LAT_LON,NOT_NUM,NOT_OLD_NUM,ICAO_PORT,");
		sql.append(" 				NOT_ISS_DT,NOT_EXP_DT,NOT_OPEN_Y,NOT_VALID,NOT_TEXT,NOT_COMMNT,NOT_OLD_CAT,USERID,NOT_TYP,");
		// 2006.05.11 ߰ ==> NOT_MARK_Y, NOT_MARK_NUM ȸ
		sql.append(" 				NOT_MARK_Y, NOT_MARK_NUM ");
		sql.append(" FROM BS_NOTAM_T");
		//if (mode.equals("STN")) 
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		//else 
		//sql.append(" WHERE NOT_FIR = '"+params.getIcao_port()+"'");
		sql.append(" AND NOT_NUM = '"+params.getNot_num()+"'");
		
		Logger.debug.println("[BASE:SupA120Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOTAM Input Է SQLԼ.
	  * @param params SupA110BG Է
	  * @return String Query 
	  * @author Copyright (c) 2005/06/17 
	  */
	public String insNOTAM(SupA110BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_NOTAM_T (ICAO_PORT,IATA_PORT,NOT_NUM,NOT_CLS,NOT_FIR,NOT_2ND_QCD,NOT_4TH_QCD,NOT_TRAF,NOT_PURP,NOT_SCOP,NOT_LOW,");
		sql.append(" 											  NOT_UPP,NOT_LAT_LON,NOT_ISS_DT,NOT_EXP_DT,NOT_VALID,NOT_TEXT,NOT_OPEN_Y,NOT_COMMNT,NOT_MARK_NUM,");
		sql.append("											  NOT_CAT,NOT_OLD_CAT,NOT_OLD_NUM,NOT_DTG,NOT_INPUT,TIMESTMP,USERID,NOT_TYP)");
		sql.append(" VALUES ( '"+params.getIcao_port()+"','"+StringUtil.checkString(params.getIata_port())+"','"+params.getNot_num()+"','"+params.getNot_cls()+"','"+params.getNot_fir()+"','"+(params.getNot_qcd()).substring(0,2)+"',");
		sql.append(" 				'"+(params.getNot_qcd()).substring(2)+"','"+params.getNot_traf()+"','"+params.getNot_purp()+"','"+params.getNot_scop()+"',");
		sql.append(" 				'"+params.getNot_low()+"','"+params.getNot_upp()+"','"+params.getNot_lat_lon()+"',");
		
		if ((params.getNot_iss_dt()).equals("WIE")) {
			sql.append("     	TO_CHAR(SYSDATE-9/24,'YYMMDDHH24MI'),");
		} else {
			sql.append("     	'"+params.getNot_iss_dt()+"',");
		}
		
		// 2005.11.14 
		if ((params.getNot_typ()).equals("S") && (params.getNot_exp_dt()).equals("PERM")) {
			if ((params.getNot_iss_dt()).equals("WIE")) {
				sql.append("     	TO_CHAR(SYSDATE+15/24,'YYMMDDHH24MI'),");
			} else {
				sql.append("     	TO_CHAR(TO_DATE('"+params.getNot_iss_dt()+"','YYMMDDHH24MI')+24/24,'YYMMDDHH24MI'),");
			}
		} else {
			sql.append("     	'"+params.getNot_exp_dt()+"',");
		}
		
		sql.append(" 				'"+StringUtil.DBInsStr(params.getNot_valid())+"','"+StringUtil.DBInsStr(params.getNot_text())+"','"+params.getNot_open_y()+"',");
		sql.append(" 				'"+StringUtil.DBInsStr(params.getNot_commnt())+"','',");
		sql.append("   				'"+params.getNew_cat()+"','"+params.getNot_cat()+"','"+params.getNot_old_num()+"',SYSDATE-(9/24),'M',SYSDATE,'"+params.getUserid()+"','"+params.getNot_typ()+"')");
		
		Logger.debug.println("[BASE:SupA120Query:insNOTAM] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * PREV SNOWTAMȸ SQLԼ.
	  * @param String icao_port, String not_iss_dt 
	  * @return String Query 
	  * @author Copyright (c) 2005/11/14 
	  */
	public String selPrevSnowtam(String icao_port, String not_iss_dt){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT NOT_NUM ");
		sql.append(" FROM BS_NOTAM_T ");
		sql.append(" WHERE ICAO_PORT='"+ icao_port +"' ");
		sql.append(" 	AND NOT_TYP='S' "); 
		
		if (not_iss_dt.equals("WIE")) {
			sql.append(" 	AND NOT_ISS_DT > TO_CHAR(SYSDATE-33/24,'YYMMDDHH24MI') ");
		} else {
			sql.append(" 	AND NOT_ISS_DT > TO_CHAR(TO_DATE('"+ not_iss_dt +"','YYMMDDHH24MI')-24/24,'YYMMDDHH24MI') ");
		}
		
		sql.append(" ORDER BY NOT_ISS_DT DESC ");

		Logger.debug.println("[BASE:SupA120Query:selPrevSnowtam] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * PREV SNOWTAM UPDATE SQLԼ.
	  * @param String icao_port, String not_exp_dt
	  * @return String Query 
	  * @author Copyright (c) 2005/11/14 
	  */
	public String updPrevSnowtam(String icao_port, String not_iss_dt, String prev_not_num,  String user_id){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE BS_NOTAM_T SET ");
		
		if (not_iss_dt.equals("WIE")) {
			sql.append(" 	NOT_EXP_DT = TO_CHAR(SYSDATE-9/24,'YYMMDDHH24MI'), ");
		} else {
			sql.append(" 	NOT_EXP_DT = '"+ not_iss_dt +"', ");
		}
		
		sql.append("		TIMESTMP = SYSDATE, ");
		sql.append(" 	USERID = '"+ user_id +"' ");
		sql.append(" WHERE ICAO_PORT = '"+ icao_port +"' ");
		sql.append(" 	AND NOT_NUM = '"+ prev_not_num +"' ");
     
		Logger.debug.println("[BASE:SupA120Query:updPrevSnowtam] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * NOT_DTG ȸ SQLԼ.
	  * @param String icao_port, String not_num
	  * @return String Query 
	  * @author Copyright (c) 2006/03/21 
	  */
	public String selNotDtg(String icao_port, String not_num){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT TO_CHAR(NOT_DTG, 'YYMMDDHH24MI') NOTDTG");
		sql.append(" FROM BS_NOTAM_T");
		sql.append(" WHERE ICAO_PORT = '"+icao_port+"'");
		sql.append(" AND NOT_NUM = '"+not_num+"'");
		
		Logger.debug.println("[BASE:SupA120Query:selNotDtg] sql : "+sql.toString());
		return sql.toString();
	}	
}
