package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.SupA620BG;
import kal.base.com.query.ComQ01Query;

 /**
   * Airport RWY Information SQL 
   * @author Copyright (c) 2005/06/01 
   */
public class SupA620Query {
	private static SupA620Query instance = new SupA620Query();
	
	public static SupA620Query getInstance() {
		return instance;
	}
	
	/** 
	  * Airport ȸ SQLԼ.
	  * @param entity SupA620BG Airport RWY Information
	  * @return String Query 
	  * @author Copyright (c) 2005/06/01 
	  */
	public String selAirport(SupA620BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT IATA_PORT, ICAO_PORT, PORT_E, ETOP_VIS_LIMIT, ETOP_CIG_LIMIT, ETOP_WIND_LIMIT, WX_ADDR ");
		sql.append(" FROM CM_PORT_T ");
		sql.append(" WHERE ");
		if(entity.getAirport().length() == 3){
			// IATA
			sql.append(" 	IATA_PORT = '"+ entity.getAirport() +"' ");
		}else{
			// ICAO
			sql.append(" 	ICAO_PORT = '"+ entity.getAirport() +"' ");
		}
		
		Logger.debug.println("[BASE:SupA620Query:selAirport] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Airport RWY Information main ȸ SQLԼ.
	  * @param entity SupA620BG Airport RWY Information
	  * @return String Query 
	  * @author Copyright (c) 2005/06/01 
	  */
	public String selMain(SupA620BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT * ");
		sql.append(" FROM BS_PORT_RWY_T  ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' ");
		sql.append(" 	ORDER BY RWY_SEQ ");
		
		Logger.debug.println("[BASE:SupA620Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Airport RWY Information  SQLԼ.
	  * @param entity SupA620BG Airport RWY Information
	  * @return String Query 
	  * @author Copyright (c) 2005/06/08 
	  */
	public String delMain(SupA620BG entity){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" DELETE FROM BS_PORT_RWY_T  ");
		sql.append(" WHERE ICAO_PORT = '"+ entity.getIcao_port() +"' ");
		
		Logger.debug.println("[BASE:SupA620Query:delMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Airport RWY Information Է SQLԼ.
	  * @param entity SupA620BG Airport RWY Information
	  * @return String Query 
	  * @author Copyright (c) 2005/06/08 
	  */
	public String insMain(SupA620BG entity){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" INSERT INTO BS_PORT_RWY_T VALUES ");
		sql.append(" ('"+ entity.getIcao_port() +"', '"+ entity.getRwy_seq() +"', '"+ entity.getRwy_dir() +"', '"+ entity.getRwy_leng() +"', '"+ entity.getRwy_width() +"', ");
		sql.append(" '"+ entity.getRwy_usable() +"', '"+ entity.getRwy_wet_usable() +"', '"+ entity.getRwy_apprch() +"', '"+ entity.getRwy_vis_limit() +"', '"+ entity.getRwy_cirapp_vis_limit() +"', ");
		sql.append(" '"+ entity.getRwy_rvr_limit() +"', '"+ entity.getRwy_cig_limit() +"', '"+ entity.getRwy_cirapp_cig_limit() +"', '"+ entity.getRwy_cwind_limit() +"', '"+ entity.getRwy_cwind_wet_limit() +"', ");
		sql.append(" '"+ entity.getRwy_twind_limit() +"', '"+ entity.getRwy_twind_wet_limit() +"', SYSDATE, '"+ entity.getEmp_no() +"') ");
		
		Logger.debug.println("[BASE:SupA620Query:insMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Airport Information  SQLԼ.
	  * @param entity SupA620BG Airport RWY Information
	  * @return String Query 
	  * @author Copyright (c) 2005/06/08 
	  */
	public String updAirport(SupA620BG entity){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" UPDATE CM_PORT_T ");
		sql.append(" SET ");
		sql.append(" 	ETOP_VIS_LIMIT = '"+ entity.getEtop_vis_limit() +"', ");
		sql.append(" 	ETOP_CIG_LIMIT = '"+ entity.getEtop_cig_limit() +"', ");
		sql.append(" 	ETOP_WIND_LIMIT = '"+ entity.getEtop_wind_limit() +"', ");
		sql.append(" 	WX_ADDR = '"+ entity.getWx_addr() +"' ");
		sql.append(" WHERE ");
		sql.append(" 	ICAO_PORT = '"+ entity.getIcao_port() +"' ");
		
		Logger.debug.println("[BASE:SupA620Query:updAirport] sql : "+sql.toString());
		return sql.toString();
	}
}
