package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.SupA630BG;
import kal.base.com.query.ComQ01Query;

 /**
   * FIR Information SQL 
   * @author Copyright (c) 2005/05/20 
   */
public class SupA630Query {
	private static SupA630Query instance = new SupA630Query();
	
	public static SupA630Query getInstance() {
		return instance;
	}
	
	/** 
	  * FIR Information main ȸ SQLԼ.
	  * @param entity SupA630BG FIR Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/20 
	  */
	public String selMain(SupA630BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT FIR_CD, FIR_E, NAT_CD, NOT_ACTIVE ");
		sql.append(" FROM BS_FIR_T ");
		sql.append(" WHERE FIR_CD = '" + entity.getFir_cd() + "' ");
		
		Logger.debug.println("[BASE:SupA630Query:selMain] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Airway Information ȸ SQLԼ.
	  * @param entity SupA630BG FIR Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/20 
	  */
	public String selAirway(SupA630BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT * ");
		sql.append(" FROM BS_FIR_AIRWAY_T ");
		sql.append(" WHERE FIR_CD = '" + entity.getFir_cd() + "' ");
		
		Logger.debug.println("[BASE:SupA630Query:selAirway] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * NATION_T ȸ SQLԼ.
	  * @param entity SupA630BG FIR Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/25 
	  */
	public String selNationC(SupA630BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT *  ");
		sql.append(" FROM NATION_T ");
		sql.append(" WHERE NATION_C = '" + entity.getNat_cd() + "' ");
		
		Logger.debug.println("[BASE:SupA630Query:selNationC] sql : "+sql.toString());
		return sql.toString();
	}	
		
	/** 
	  * BS_COMP_ROUTE_T ȸ SQLԼ.
	  * @param entity SupA630BG FIR Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/25 
	  */
	public String selCompRoute(SupA630BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT DEP_STN, ARR_STN, RTE_CD ");
		sql.append(" FROM BS_COMP_ROUTE_T  ");
		
		Logger.debug.println("[BASE:SupA630Query:selCompRoute] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_FIR_T Է SQLԼ.
	  * @param entity SupA630BG FIR Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/26 
	  */
	public String insFirT(SupA630BG entity){
		StringBuffer sql = new StringBuffer();

		sql.append(" INSERT INTO BS_FIR_T ");
		sql.append(" VALUES ('"+ entity.getFir_cd() +"','"+ entity.getFir_e() +"','"+ entity.getNat_cd() +"', ");
		sql.append(" '"+ entity.getNot_active() +"', SYSDATE, '"+ entity.getEmp_no() +"') ");
		
		Logger.debug.println("[BASE:SupA630Query:insFirT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_FIR_T  SQLԼ.
	  * @param entity SupA630BG FIR Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/26 
	  */
	public String updFirT(SupA630BG entity){
		StringBuffer sql = new StringBuffer();
	
		sql.append(" UPDATE BS_FIR_T ");
		sql.append(" SET FIR_E = '"+ entity.getFir_e() +"', NAT_CD = '"+ entity.getNat_cd() +"', ");
		sql.append(" NOT_ACTIVE = '"+ entity.getNot_active() +"', TIMESTMP = SYSDATE, USERID = '"+ entity.getEmp_no() +"' ");
		sql.append(" WHERE FIR_CD = '"+ entity.getFir_cd() +"' ");
		
		Logger.debug.println("[BASE:SupA630Query:updFirT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_FIR_T  SQLԼ.
	  * @param entity SupA630BG FIR Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/26 
	  */
	public String delFirT(SupA630BG entity){
		StringBuffer sql = new StringBuffer();
	
		sql.append(" DELETE FROM BS_FIR_T ");
		sql.append(" WHERE FIR_CD = '"+ entity.getFir_cd() +"' ");
		
		Logger.debug.println("[BASE:SupA630Query:delFirT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_FIR_AIRWAY_T Է SQLԼ.
	  * @param entity SupA630BG FIR Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/26 
	  */
	public String insAirwayT(SupA630BG entity){
		StringBuffer sql = new StringBuffer();
	
		sql.append(" INSERT INTO BS_FIR_AIRWAY_T ");
		sql.append(" VALUES ('"+ entity.getFir_cd() +"','"+ entity.getFir_rte_tot() +"',SYSDATE, '"+ entity.getEmp_no() +"') ");
		
		Logger.debug.println("[BASE:SupA630Query:insAirwayT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BS_FIR_AIRWAY_T  SQLԼ.
	  * @param entity SupA630BG FIR Information
	  * @return String Query 
	  * @author Copyright (c) 2005/05/26 
	  */
	public String delAirwayT(SupA630BG entity){
		StringBuffer sql = new StringBuffer();
	
		sql.append(" DELETE FROM BS_FIR_AIRWAY_T ");
		sql.append(" WHERE FIR_CD = '"+ entity.getFir_cd() +"' ");
		
		Logger.debug.println("[BASE:SupA630Query:delAirwayT] sql : "+sql.toString());
		return sql.toString();
	}
}
