package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.sup.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * BASE2  Area Information   Query
 * ۼ ¥: 2005-05-27
 * @author: HIST  
 */
public class SupA660Query{
	private static SupA660Query instance = new SupA660Query();
	
	public static SupA660Query getInstance() {
		return instance;
	}
	
	/** 
	  * BASE2 Area Information / Area Code ȸ SQLԼ.
	  * @return String Query  
	  * @author Copyright (c) 2005/05/27 HIST 
	  */
	public String selAreaCd() {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT DISTINCT AREA_CD,AREA_TYP ");
		sql.append(" FROM BS_AREA_T");
		sql.append(" ORDER BY AREA_TYP,AREA_CD");
		
		Logger.debug.println("[BASE:SupA660Query:selAreaCd] sql : "+sql.toString());
		return sql.toString();
	}

	/** 
	  * BASE2 Area Informationȸ SQLԼ.
	  * @param params SupA660BG Parameter Object
	  * @return String Query  
	  * @author Copyright (c) 2005/05/27 HIST 
	  */
	public String selAreaInfo(SupA660BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT *");
		sql.append(" FROM BS_AREA_T");
		sql.append(" WHERE AREA_CD = '"+StringUtil.toKSC5601(params.getArea_cd())+"'");
		
		Logger.debug.println("[BASE:SupA660Query:selAreaInfo] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BASE2 Area Information  SQLԼ.
	  * @param params SupA660BG Parameter Object
	  * @return String Query  
	  * @author Copyright (c) 2005/05/27 HIST 
	  */
	public String delAreaInfo(SupA660BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" DELETE BS_AREA_T");
		sql.append(" WHERE AREA_CD = '"+StringUtil.toKSC5601(params.getArea_cd())+"'");
		sql.append(" AND AREA_TYP != 'S'");
		
		Logger.debug.println("[BASE:SupA660Query:delAreaInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2 Area Information Է SQLԼ.
	  * @param params SupA660BG Parameter Object
	  * @param area_stn String Area Aiport Station's
	  * @return String Query  
	  * @author Copyright (c) 2005/05/27 HIST 
	  */
	public String insAreaInfo(SupA660BG params, String area_stn) {
		StringBuffer sql = new StringBuffer();

		sql.append(" INSERT INTO BS_AREA_T");
		sql.append(" VALUES ('"+StringUtil.toKSC5601(params.getArea_cd())+"','U','"+area_stn+"',SYSDATE,'"+params.getUser_id()+"')");
		
		Logger.debug.println("[BASE:SupA660Query:insAreaInfo] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2 Area Information  SQLԼ.
	  * @param params SupA660BG Parameter Object
	  * @param area_stn String Area Aiport Station's
	  * @return String Query  
	  * @author Copyright (c) 2005/05/27 HIST 
	  */
	public String updAreaInfo(SupA660BG params, String area_stn) {
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE BS_AREA_T");
		sql.append(" SET AREA_STN = '"+area_stn+"'");
		sql.append(" WHERE AREA_CD = '"+StringUtil.toKSC5601(params.getArea_cd())+"'");
		
		Logger.debug.println("[BASE:SupA660Query:updAreaInfo] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * BASE2 Company Route Information / Port ȸ SQLԼ.
	  * @param mode String 'A' : STN+FIR , 'S' : STN
	  * @return String Query  
	  * @author Copyright (c) 2005/05/23 HIST 
	  */
	public String selPortList(String mode) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" 	SELECT ICAO_PORT,IATA_PORT");
		sql.append(" 	FROM CM_PORT_T");
		if (mode.equals("A")) {
			sql.append(" 	UNION");
			sql.append(" 	SELECT FIR_CD ICAO_PORT,'FIR' IATA_PORT");
			sql.append(" 	FROM BS_FIR_T");
		}
		
		Logger.debug.println("[BASE:SupA660Query:selPortList] sql : "+sql.toString());
		return sql.toString();
	}	
}//end of class
