package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.sup.dbbean.*;

 /**
   * Past Weather Request SQL 
   * @author Copyright (c) 2005/08/11 
   */
public class SupQ220Query {
	private static SupQ220Query instance = new SupQ220Query();
	
	public static SupQ220Query getInstance() {
		return instance;
	}
	
	/** 
	  * Past Weather Request  Condition Code ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/08/11 
	  */
	public String selWxCond(){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT CODE_C FROM CODE_T");
		sql.append(" WHERE STEP_X='9' AND CODE_X='WXR STS' AND CODE_C NOT LIKE 'X%'");
		sql.append(" ORDER BY CODE_C");
		
		Logger.debug.println("[BASE:SupQ220Query:selWxCond] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Past Weather Request  Input Station ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/08/11 
	  */
	public String selStation(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT FROM CM_PORT_T");
		if (stn.length() == 4)
			sql.append(" WHERE ICAO_PORT = '"+stn+"'");		//(STN 4ڸ )
		else
			sql.append(" WHERE IATA_PORT = '"+stn+"'"); 	//(STN 3ڸ )
		
		Logger.debug.println("[BASE:SupQ220Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Past Weather Request ȸ SQLԼ.
	  * @param params SupQ220BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/08/11 
	  */
	public String selPastWeather(SupQ220BG params){
		StringBuffer sql = new StringBuffer();
		
		boolean typFlag = false;
		boolean typFlag_1 = false;
		boolean typFlag_2 = false;
		
		sql.append(" SELECT A.ICAO_PORT, A.TYP_SEQ, TO_CHAR(A.WX_DTG,'YYYY.MM.DD') WX_DTG,");
		sql.append(" A.WX_TEXT, A.IATA_PORT, B.PORT_E, A.WX_TYP");
		sql.append(" FROM BS_WEATHER_T A, CM_PORT_T B");
		sql.append(" WHERE A.ICAO_PORT = '"+params.getIcao_port()+"'");					//(A) ICAO_PORT
		sql.append(" AND A.ICAO_PORT = B.ICAO_PORT");
		//METAR  
		if (params.getMetar_typ().equals("Y")) {
			if (!typFlag) {
				sql.append(" AND (");
				sql.append(" (TYP_SEQ=1 AND WX_TYP IN ('SA','SP'))");
			} else {
				sql.append(" OR (TYP_SEQ=1 AND WX_TYP IN ('SA','SP'))");
			}
			typFlag = true;
		}
		//TAF  
		if (params.getTaf_typ().equals("Y")) {
			if (!typFlag) {
				sql.append(" AND (");
				sql.append(" (TYP_SEQ=2)");
			} else {
				sql.append(" OR (TYP_SEQ=2)");
			}
			typFlag = true;
		}
		//TEXT  
		if (params.getText_typ().equals("Y")) {
			if (!typFlag) {
				sql.append(" AND (");
				sql.append(" (TYP_SEQ=1 AND WX_TYP = 'SB')");
			} else {
				sql.append(" OR (TYP_SEQ=1 AND WX_TYP = 'SB')");
			}
			typFlag = true;
		}
		if (typFlag) sql.append(" )");
		sql.append(" AND WX_DTG BETWEEN TO_DATE('20"+params.getFrom_dt()+"0000','YYYYMMDDHH24MI') AND TO_DATE('20"+params.getTo_dt()+"2359','YYYYMMDDHH24MI')");
		//METAR õǰ CONDITION  õ 쿡 ش
		if (params.getMetar_typ().equals("Y") && (!params.getWx_cond1().equals("") || !params.getWx_cond2().equals("")))
			//sql.append(" AND (TYP_SEQ=1 AND WX_TYP IN ('SA','SP') AND (WX_COND1 = '"+params.getWx_cond1()+"' OR WX_COND2 = '"+params.getWx_cond1()+"'))");
			sql.append(" AND (TYP_SEQ=1 AND WX_TYP IN ('SA','SP') AND ((WX_COND1 IN ('"+params.getWx_cond1()+"','"+params.getWx_cond2()+"')) OR (WX_COND2 IN ('"+params.getWx_cond1()+"','"+params.getWx_cond2()+"'))))");
		
		//2008.11.28 ߰ : BS_WEATHER_STORAGE_T
		sql.append(" UNION ");
		
		sql.append(" SELECT A.ICAO_PORT, A.TYP_SEQ, TO_CHAR(A.WX_DTG,'YYYY.MM.DD') WX_DTG,");
		sql.append(" A.WX_TEXT, A.IATA_PORT, B.PORT_E, A.WX_TYP");
		sql.append(" FROM BS_WEATHER_STORAGE_T A, CM_PORT_T B");
		sql.append(" WHERE A.ICAO_PORT = '"+params.getIcao_port()+"'");					//(A) ICAO_PORT
		sql.append(" AND A.ICAO_PORT = B.ICAO_PORT");
		//METAR  
		if (params.getMetar_typ().equals("Y")) {
			if (!typFlag_1) {
				sql.append(" AND (");
				sql.append(" (TYP_SEQ=1 AND WX_TYP IN ('SA','SP'))");
			} else {
				sql.append(" OR (TYP_SEQ=1 AND WX_TYP IN ('SA','SP'))");
			}
			typFlag_1 = true;
		}
		//TAF  
		if (params.getTaf_typ().equals("Y")) {
			if (!typFlag_1) {
				sql.append(" AND (");
				sql.append(" (TYP_SEQ=2)");
			} else {
				sql.append(" OR (TYP_SEQ=2)");
			}
			typFlag_1 = true;
		}
		//TEXT  
		if (params.getText_typ().equals("Y")) {
			if (!typFlag_1) {
				sql.append(" AND (");
				sql.append(" (TYP_SEQ=1 AND WX_TYP = 'SB')");
			} else {
				sql.append(" OR (TYP_SEQ=1 AND WX_TYP = 'SB')");
			}
			typFlag_1 = true;
		}
		if (typFlag_1) sql.append(" )");
		sql.append(" AND WX_DTG BETWEEN TO_DATE('20"+params.getFrom_dt()+"0000','YYYYMMDDHH24MI') AND TO_DATE('20"+params.getTo_dt()+"2359','YYYYMMDDHH24MI')");
		//METAR õǰ CONDITION  õ 쿡 ش
		if (params.getMetar_typ().equals("Y") && (!params.getWx_cond1().equals("") || !params.getWx_cond2().equals("")))
			//sql.append(" AND (TYP_SEQ=1 AND WX_TYP IN ('SA','SP') AND (WX_COND1 = '"+params.getWx_cond1()+"' OR WX_COND2 = '"+params.getWx_cond1()+"'))");
			sql.append(" AND (TYP_SEQ=1 AND WX_TYP IN ('SA','SP') AND ((WX_COND1 IN ('"+params.getWx_cond1()+"','"+params.getWx_cond2()+"')) OR (WX_COND2 IN ('"+params.getWx_cond1()+"','"+params.getWx_cond2()+"'))))");
		
        //	2012.04.09 ߰ : BS_WEATHER_T_BACKUP
		sql.append(" UNION ");
		
		sql.append(" SELECT A.ICAO_PORT, A.TYP_SEQ, TO_CHAR(A.WX_DTG,'YYYY.MM.DD') WX_DTG,");
		sql.append(" A.WX_TEXT, A.IATA_PORT, B.PORT_E, A.WX_TYP");
		sql.append(" FROM BS_WEATHER_T_BACKUP A, CM_PORT_T B");
		sql.append(" WHERE A.ICAO_PORT = '"+params.getIcao_port()+"'");					//(A) ICAO_PORT
		sql.append(" AND A.ICAO_PORT = B.ICAO_PORT");
		//METAR  
		if (params.getMetar_typ().equals("Y")) {
			if (!typFlag_2) {
				sql.append(" AND (");
				sql.append(" (TYP_SEQ=1 AND WX_TYP IN ('SA','SP'))");
			} else {
				sql.append(" OR (TYP_SEQ=1 AND WX_TYP IN ('SA','SP'))");
			}
			typFlag_2 = true;
		}
		//TAF  
		if (params.getTaf_typ().equals("Y")) {
			if (!typFlag_2) {
				sql.append(" AND (");
				sql.append(" (TYP_SEQ=2)");
			} else {
				sql.append(" OR (TYP_SEQ=2)");
			}
			typFlag_2 = true;
		}
		//TEXT  
		if (params.getText_typ().equals("Y")) {
			if (!typFlag_2) {
				sql.append(" AND (");
				sql.append(" (TYP_SEQ=1 AND WX_TYP = 'SB')");
			} else {
				sql.append(" OR (TYP_SEQ=1 AND WX_TYP = 'SB')");
			}
			typFlag_2 = true;
		}
		if (typFlag_2) sql.append(" )");
		sql.append(" AND WX_DTG BETWEEN TO_DATE('20"+params.getFrom_dt()+"0000','YYYYMMDDHH24MI') AND TO_DATE('20"+params.getTo_dt()+"2359','YYYYMMDDHH24MI')");
		//METAR õǰ CONDITION  õ 쿡 ش
		if (params.getMetar_typ().equals("Y") && (!params.getWx_cond1().equals("") || !params.getWx_cond2().equals("")))
			//sql.append(" AND (TYP_SEQ=1 AND WX_TYP IN ('SA','SP') AND (WX_COND1 = '"+params.getWx_cond1()+"' OR WX_COND2 = '"+params.getWx_cond1()+"'))");
			sql.append(" AND (TYP_SEQ=1 AND WX_TYP IN ('SA','SP') AND ((WX_COND1 IN ('"+params.getWx_cond1()+"','"+params.getWx_cond2()+"')) OR (WX_COND2 IN ('"+params.getWx_cond1()+"','"+params.getWx_cond2()+"'))))");
		
		//sql.append(" ORDER BY TYP_SEQ, WX_DTG DESC "); 2010.02.03 
		sql.append(" ORDER BY TYP_SEQ, WX_DTG ");
		
		System.out.println("[BASE:SupQ220Query:selPastWeather] sql : "+sql.toString());
		//Logger.debug.println("[BASE:SupQ220Query:selPastWeather] sql : "+sql.toString());
		
		return sql.toString();
	}	
}
