package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.sup.dbbean.*;

 /**
   * Sig Weather Request SQL 
   * @author Copyright (c) 2005/07/20 
   */
public class SupQ230Query {
	private static SupQ230Query instance = new SupQ230Query();
	
	public static SupQ230Query getInstance() {
		return instance;
	}
	
	/** 
	  * Sig Weather Request  Input Station ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/07/20 
	  */
	public String selStation(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT FROM CM_PORT_T");
		if (stn.length() == 4)
			sql.append(" WHERE ICAO_PORT = '"+stn+"'");		//(STN 4ڸ )
		else
			sql.append(" WHERE IATA_PORT = '"+stn+"'"); 	//(STN 3ڸ )
		
		Logger.debug.println("[BASE:SupQ230Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * Sig Weather Request Area Station ȸ SQLԼ.
	  * @param params SupQ230BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/07/20 
	  */
	public String selAreaStn(SupQ230BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT AREA_STN");
		sql.append(" FROM BS_AREA_T");
		sql.append(" WHERE AREA_CD = '"+params.getArea_cd()+"'");
		
		Logger.debug.println("[BASE:SupQ230Query:selAreaStn] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * Sig Weather Request Main ȸ SQLԼ.
	  * @param params SupQ230BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/07/20 
	  */
	public String selSigMain(SupQ230BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT ICAO_PORT,DECODE(WX_TYP,'W','WIND','V','VISIBILITY','C','CEILING','ALL') WX_MENU,WX_TYP,");
        sql.append(" 			  WX_COND1,WX_COND2,TO_CHAR(BEGIN_DT,'YY/MM/DD HH24:MI') BEGIN_DT,TO_CHAR(END_DT,'YY/MM/DD HH24:MI') END_DT,");
	    sql.append(" 			  DUR_TM,WX_TEXT,TO_CHAR(BEGIN_DT,'HH24:MI') BEGIN_TM,TO_CHAR(END_DT,'HH24:MI') END_TM,");
	    sql.append("			  TO_CHAR(BEGIN_DT,'YYMMDDHH24MI') BEGIN_DATE,TO_CHAR(END_DT,'YYMMDDHH24MI') END_DATE");
		sql.append(" FROM BS_SIG_WEATHER_T");
		if (params.getMode().equals("airport"))
				sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'"); 		// AIRPORT Է½
		else
				sql.append(" WHERE ICAO_PORT IN ("+params.getIcao_port()+")"); 	// AREA Է½
		//'W':WIND  , 'V':VISIBILITY  , 'C':CEILING 
		if (!params.getWx_typ().equals(""))
			sql.append(" AND WX_TYP IN ("+params.getWx_typ()+")");
		sql.append(" AND ((BEGIN_DT BETWEEN TO_DATE('20"+params.getBegin_dt()+"','YYYYMMDDHH24MI') AND TO_DATE('20"+params.getEnd_dt()+"','YYYYMMDDHH24MI'))");
		sql.append(" 		  OR (BEGIN_DT < TO_DATE('20"+params.getBegin_dt()+"','YYYYMMDDHH24MI') AND END_DT >= TO_DATE('20"+params.getEnd_dt()+"','YYYYMMDDHH24MI')))");
		if (!params.getWx_cond1().equals("") || !params.getWx_cond2().equals(""))
			sql.append(" AND ((WX_COND1 IN ('"+params.getWx_cond1()+"','"+params.getWx_cond2()+"')) OR (WX_COND2 IN ('"+params.getWx_cond1()+"','"+params.getWx_cond2()+"')))");
		sql.append(" ORDER BY ICAO_PORT,BEGIN_DT DESC");

		
		Logger.debug.println("[BASE:SupQ230Query:selSigMain] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Sig Weather Request Popup ȸ SQLԼ.
	  * @param params SupQ230BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/07/20 
	  */
	public String selSigWxPop(SupQ230BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT 	ICAO_PORT,DECODE(WX_TYP,'W','WIND','V','VISIBILITY','CEILING') WX_MENU,WX_TYP,WX_COND1,WX_COND2,");
		sql.append("        		TO_CHAR(BEGIN_DT,'YY/MM/DD') BEGIN_DT,TO_CHAR(BEGIN_DT,'HH24:MI') BEGIN_TM,TO_CHAR(END_DT,'HH24:MI') END_TM,");
		sql.append("        		DUR_TM,WX_TEXT,TO_CHAR(BEGIN_DT,'YYMMDDHH24MI') BEGIN_DATE");
		sql.append(" FROM BS_SIG_WEATHER_T");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND WX_TYP = '"+params.getWx_typ()+"'");
		sql.append(" AND TO_CHAR(BEGIN_DT,'YYMMDDHH24MI') = '"+params.getBegin_date()+"'");
		
		Logger.debug.println("[BASE:SupQ230Query:selSigWxPop] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Sig Weather Request Popup Chart File ȸ SQLԼ.
	  * @param params SupQ230BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/07/20 
	  */
	public String selSigWxFile(SupQ230BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT CHART_FILE");
		sql.append(" FROM BS_SIG_CHART_T");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"'");
		sql.append(" AND WX_TYP = '"+params.getWx_typ()+"'");
		sql.append(" AND TO_CHAR(BEGIN_DT,'YYMMDDHH24MI') = '"+params.getBegin_date()+"'");
		sql.append(" ORDER BY CHART_SEQ");
		
		Logger.debug.println("[BASE:SupQ230Query:selSigWxFile] sql : "+sql.toString());
		return sql.toString();
	}	

}
