package kal.base.sup.query;

import kal.base.jdf.com.Logger;
import kal.base.com.util.*;
import kal.base.sup.dbbean.*;

 /**
   * Weather Statistics SQL 
   * @author Copyright (c) 2005/08/16 
   */
public class SupQ410Query {
	private static SupQ410Query instance = new SupQ410Query();
	
	public static SupQ410Query getInstance() {
		return instance;
	}
	
	/** 
	  * Weather Statistics  Input Station ȸ SQLԼ.
	  * @param stn String ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/08/16 
	  */
	public String selStation(String stn){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT ICAO_PORT,IATA_PORT,PORT_E FROM CM_PORT_T");
		if (stn.length() == 4)
			sql.append(" WHERE ICAO_PORT = '"+stn+"'");		//(STN 4ڸ )
		else
			sql.append(" WHERE IATA_PORT = '"+stn+"'"); 	//(STN 3ڸ )
		
		Logger.debug.println("[BASE:SupQ410Query:selStation] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * Weather Statistics мڷ ȸ SQLԼ.
	  * @param params SupQ410BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/08/16 
	  */
	public String selWxStaAnaly(SupQ410BG params){
		StringBuffer sql = new StringBuffer();

		/* мڷ */
		sql.append(" SELECT A.FLAG_DATE, SUM(ALL_CNT) ALL_CNT, SUM(NVL(DET_CNT,0)) DET_CNT, ROUND(SUM(NVL(DET_CNT,0))/SUM(ALL_CNT)*100,1) PER ");
		
		//Ѻмڷ
		sql.append(" FROM (	SELECT "+params.getAnaly_cond1_qry()+" FLAG_DATE, COUNT(*) ALL_CNT");
		sql.append("       		FROM BS_WEATHER_T");
		sql.append("       		WHERE ICAO_PORT = '"+params.getIcao_port()+"' AND TYP_SEQ=1 AND WX_TYP ='SA'");
		sql.append("       		AND WX_DTG BETWEEN TO_DATE('"+params.getBegin_dt()+"'||'0000','YYMMDDHH24MI') AND TO_DATE('"+params.getEnd_dt()+"'||'2359','YYMMDDHH24MI')");
		sql.append("       		GROUP BY "+params.getAnaly_cond1_qry()+" ");
		
		//2008.11.28 ߰ : BS_WEATHER_STORAGE_T
		sql.append(" 				UNION ");
		sql.append(" 				SELECT "+params.getAnaly_cond1_qry()+" FLAG_DATE, COUNT(*) ALL_CNT");
		sql.append("       		FROM BS_WEATHER_STORAGE_T");
		sql.append("       		WHERE ICAO_PORT = '"+params.getIcao_port()+"' AND TYP_SEQ=1 AND WX_TYP ='SA'");
		sql.append("       		AND WX_DTG BETWEEN TO_DATE('"+params.getBegin_dt()+"'||'0000','YYMMDDHH24MI') AND TO_DATE('"+params.getEnd_dt()+"'||'2359','YYMMDDHH24MI')");
		sql.append("       		GROUP BY "+params.getAnaly_cond1_qry()+" ) A, ");
		
		//شмڷ
		sql.append("      	   (SELECT "+params.getAnaly_cond1_qry()+" FLAG_DATE, COUNT(*) DET_CNT");
		sql.append("       		FROM BS_WEATHER_T");
		sql.append("       		WHERE ICAO_PORT = '"+params.getIcao_port()+"' AND TYP_SEQ=1 AND WX_TYP ='SA'");
		sql.append("       		AND WX_DTG BETWEEN TO_DATE('"+params.getBegin_dt()+"'||'0000','YYMMDDHH24MI') AND TO_DATE('"+params.getEnd_dt()+"'||'2359','YYMMDDHH24MI')");
		sql.append("       		AND "+params.getAnaly_cond2_qry());
		sql.append("       		GROUP BY "+params.getAnaly_cond1_qry()+" ");
		
		//2008.11.28 ߰ : BS_WEATHER_STORAGE_T
		sql.append("				UNION ");
		sql.append("				SELECT "+params.getAnaly_cond1_qry()+" FLAG_DATE, COUNT(*) DET_CNT");
		sql.append("       		FROM BS_WEATHER_STORAGE_T");
		sql.append("       		WHERE ICAO_PORT = '"+params.getIcao_port()+"' AND TYP_SEQ=1 AND WX_TYP ='SA'");
		sql.append("       		AND WX_DTG BETWEEN TO_DATE('"+params.getBegin_dt()+"'||'0000','YYMMDDHH24MI') AND TO_DATE('"+params.getEnd_dt()+"'||'2359','YYMMDDHH24MI')");
		sql.append("       		AND "+params.getAnaly_cond2_qry());
		sql.append("       		GROUP BY "+params.getAnaly_cond1_qry()+" ) B ");
		
		sql.append(" WHERE A.FLAG_DATE = B.FLAG_DATE(+) ");
		sql.append(" GROUP BY A.FLAG_DATE ");
		sql.append(" ORDER BY FLAG_DATE ");
		
		System.out.println("[BASE:SupQ410Query:selWxStaAnaly] sql : "+sql.toString());
		//Logger.debug.println("[BASE:SupQ410Query:selWxStaAnaly] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * Weather Statistics  ȸ SQLԼ.
	  * @param params SupQ410BG ȸ
	  * @return String Query 
	  * @author Copyright (c) 2005/08/16 
	  */
	public String selWxStaOrigin(SupQ410BG params){
		StringBuffer sql = new StringBuffer();

		/*  */
		sql.append(" SELECT TO_CHAR(WX_DTG,'YYYY.MM.DD') WX_DTG,ICAO_PORT,WX_TEXT ");
		sql.append(" FROM BS_WEATHER_T ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"' AND TYP_SEQ=1 AND WX_TYP IN ('SA') ");
		sql.append(" AND WX_DTG BETWEEN TO_DATE('"+params.getBegin_dt()+"'||'0000','YYMMDDHH24MI') AND TO_DATE('"+params.getEnd_dt()+"'||'2359','YYMMDDHH24MI') ");
		sql.append(" AND "+params.getAnaly_cond2_qry() );
		
		//2008.11.28 ߰ : BS_WEATHER_STORAGE_T
		sql.append(" UNION ");
		sql.append(" SELECT TO_CHAR(WX_DTG,'YYYY.MM.DD') WX_DTG,ICAO_PORT,WX_TEXT ");
		sql.append(" FROM BS_WEATHER_STORAGE_T ");
		sql.append(" WHERE ICAO_PORT = '"+params.getIcao_port()+"' AND TYP_SEQ=1 AND WX_TYP IN ('SA') ");
		sql.append(" AND WX_DTG BETWEEN TO_DATE('"+params.getBegin_dt()+"'||'0000','YYMMDDHH24MI') AND TO_DATE('"+params.getEnd_dt()+"'||'2359','YYMMDDHH24MI') ");
		sql.append(" AND "+params.getAnaly_cond2_qry() );
		
		sql.append(" ORDER BY WX_DTG DESC ");
		
		System.out.println("[BASE:SupQ410Query:selWxStaOrigin] sql : "+sql.toString());
		//Logger.debug.println("[BASE:SupQ410Query:selWxStaOrigin] sql : "+sql.toString());
		return sql.toString();
	}	
}
