package kal.base.sys.query;

import java.util.Locale;

import kal.base.jdf.com.Logger;
import kal.base.sys.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * BASE2 User Information  Query
 * ۼ ¥: 2005-04-11
 * @author: HIST  
 */
public class SysA020Query {
	private static SysA020Query instance = new SysA020Query();
	
	public static SysA020Query getInstance() {
		return instance;
	}
	
	/** 
	  * BASE2   ȸ SQLԼ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public String selUserInfo(SysA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		//2016.09.07 ȣȭ  Enc_Pswd_No, Enc_Tel_No, Enc_Mail_Addr
		sql.append(" Select A.Emp_No, A.Kor_n, A.Dept_c, B.Ip_n, To_Char(B.Login_d,'YYYY-MM-DD HH24:MI:SS') Login_d, ");
		sql.append(" 	B.Auth_Pmsn,Substr(B.Update_d,1,4)||'-'||Substr(B.Update_d,5,2)||'-'||Substr(B.Update_d,7,2) Update_d,");
		//sql.append("		TransLate(A.Pswd_No,'OK6IEV2MAS8RBTD4FG3L1JN70QPH9ZXUYW5C','0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ') Pswd_No,");
		sql.append(" '' Pswd_No,");//@2017-07-21
		sql.append(" 	A.Tel_No, A.Mail_Addr, B.Project_c, A.Project_c Favor_c, B.USE_CNT, A.Enc_Pswd_No, A.Enc_Tel_No, A.Enc_Mail_Addr ");
		sql.append(" From Password_t A, Password_Auth_t B");
		sql.append(" Where A.Emp_No = B.Emp_No And");
		
		if (!params.getEmp_no().equals("")) {
			sql.append("       A.Emp_No = '"+params.getEmp_no()+"' And");
		}
		if (!params.getKor_n().equals("")) {
			sql.append("       A.Kor_n Like '"+params.getKor_n()+"%' And");
		}
		if (!params.getDept_c().equals("")) {
			sql.append("       A.Dept_c = UPPER('"+params.getDept_c()+"') And");
		}
		sql.append("       B.Project_c = '"+params.getProject_c()+"'"); //sql.append(" B.Project_c = 'BASE2'");
		sql.append(" Order By A.Emp_No, A.Kor_n");
		
		Logger.debug.println("[BASE:SysA020Query:selUserInfo] sql : "+sql.toString());
		System.out.println("[BASE:SysA020Query:selUserInfo] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * BASE2  Է Password_t ȸ SQLԼ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public String selPasswordT(SysA020BG params) {
		StringBuffer sql = new StringBuffer();
		// 201206.22 
		sql.append(" Select '' PSWD_NO ");//@2017-07-21
		sql.append(" ,KOR_N,DEPT_C,PROJECT_C,ENC_PSWD_NO,ENC_TEL_NO,ENC_MAIL_ADDR ");//@2019-04-17
		sql.append(" From Password_t");
		sql.append(" Where Emp_No = '"+params.getEmp_no()+"'");
		
		Logger.debug.println("[BASE:SysA020Query:selPasswordT] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * BASE2  Է Password_Auth_t ȸ SQLԼ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public String selPasswordAuthT(SysA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select * From Password_Auth_t");
		sql.append(" Where Emp_No = '"+params.getEmp_no()+"' And");
		//sql.append("       		Project_c = 'BASE2'");
		sql.append("       		Project_c = '"+params.getProject_c()+"'");
		
		Logger.debug.println("[BASE:SysA020Query:selPasswordAuthT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2  Password_t  SQLԼ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public String updPasswordT(SysA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Update Password_t A");
		sql.append(" Set 	A.Kor_n = '"+params.getKor_n()+"',");
		sql.append("     	A.Dept_c = UPPER('"+params.getDept_c()+"'),");
		 
		
		//2016.09.07 ȣȭ  Enc_Pswd_No
		if (!params.getPswd_no().equals("")){ 
			
			//String enc_pswd =  ADMSHA512Hash.getDigest(params.getPswd_no().toUpperCase());
			String enc_pswd = SecurityUtil.self.encrypt(params.getPswd_no(), "INT_HMAC"); //2017.01.17
			
			System.out.println("SysA020Query enc_pswd:"+enc_pswd);
			
			//sql.append("     	A.Pswd_No = TransLate('"+params.getPswd_no()+"','0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ','OK6IEV2MAS8RBTD4FG3L1JN70QPH9ZXUYW5C'),"); //2017.01.17
			//sql.append(" '' Pswd_No,");//@2017-07-21
			//20181129
			sql.append("Pswd_No='',");//@2017-07-21
			//sql.append("     	A.Enc_Pswd_No = '"+enc_pswd.toUpperCase()+"',");
			
			sql.append("     	A.Enc_Pswd_No = '"+enc_pswd.toUpperCase(Locale.ENGLISH)+"',");//2019-04-17
	
		}
		
		if (params.getFavor_c().equals("BASE2") || params.getFavor_c().equals("FTS") || params.getFavor_c().equals("")){

			sql.append("     	A.Project_c = UPPER('"+params.getFavor_c()+"'),");		
		}
		//2016.09.07 ȣȭ  Enc_Tel_No, Enc_Mail_Addr 
		if(!params.getTel_no().equals("")){ 
		System.out.println("Է "+ params.getTel_no());
		String enc_tel_no = SecurityUtil.self.encrypt(params.getTel_no(), "INT_TEL");
		System.out.println("ȣ  : "+enc_tel_no);
		sql.append("     	A.Enc_Tel_No = '"+enc_tel_no+"',");
		}
		if(!params.getMail_addr().equals("")){ 
		System.out.println("Է ̸"+ params.getMail_addr());
		String enc_mail_addr = SecurityUtil.self.encrypt(params.getMail_addr(), "INT_EML");
		System.out.println("ȣ ̸ : "+enc_mail_addr);
		sql.append("     	A.Enc_Mail_Addr = '"+enc_mail_addr+"',");
		}
		//20181128
		sql.append("     	A.Tel_No = '',");	
		sql.append("     	A.Mail_Addr = ''");
		
		sql.append(" Where A.Emp_No = '"+params.getEmp_no()+"'");
		
		Logger.debug.println("[BASE:SysA020Query:updPasswordT] sql : "+sql.toString());
		
		return sql.toString();
	}			
	
	/** 
	  * BASE2  Password_Auth_t  SQLԼ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public String updPasswordAuthT(SysA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Update Password_Auth_t B");
		sql.append(" Set 	B.AUTH_PMSN = UPPER('"+params.getAuth_pmsn()+"'),");
		sql.append("     	B.Update_d = To_Char(sysdate,'YYYYMMDD HH24MISS')");
		sql.append(" Where B.Emp_No = '"+params.getEmp_no()+"' And");
		//sql.append("       		B.Project_c = 'BASE2'");
		sql.append("       		B.Project_c = '"+params.getProject_c()+"'");
		
		Logger.debug.println("[BASE:SysA020Query:updPasswordAuthT] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * BASE2  Password_t Է SQLԼ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public String insPasswordT(SysA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		//2016.09.07 ȣȭ  Enc_Pswd_No, Enc_Tel_No, Enc_Mail_Addr 
		//String enc_pswd =  ADMSHA512Hash.getDigest(params.getPswd_no().toUpperCase());
		String enc_pswd = SecurityUtil.self.encrypt(params.getPswd_no(), "INT_HMAC"); //2017.01.17
		
		String dec_tel_no = SecurityUtil.self.decrypt(params.getTel_no(), "INT_TEL");
		String dec_mail_addr = SecurityUtil.self.decrypt(params.getMail_addr(), "INT_EML");
		
		System.out.println("insPasswordT      enc_pswd:"+enc_pswd);
		System.out.println("insPasswordT    dec_tel_no:"+dec_tel_no);
		System.out.println("insPasswordT dec_mail_addr:"+dec_mail_addr);
		//@2017-07-21 Pswd_No
		sql.append(" Insert Into Password_t(Emp_No,It_Id,Kor_n,Dept_c,Tel_No,Pswd_No,Pswd_D,Open_y,Mail_Addr,Project_c, Enc_Pswd_No, Enc_Tel_No, Enc_Mail_Addr)");
		
		sql.append(" Values ('"+params.getEmp_no()+"','"+params.getEmp_no()+"','"+params.getKor_n()+"',UPPER('"+params.getDept_c()+"'),'"+params.getTel_no()+"','',To_Char(Sysdate,'YYYYMMDD'),'N','"+params.getMail_addr()+"','"+params.getFavor_c()+"','"+enc_pswd+"','"+dec_tel_no+"','"+dec_mail_addr+"' )");
		
		Logger.debug.println("[BASE:SysA020Query:insPasswordT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * BASE2  Password_Auth_t Է SQLԼ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public String insPasswordAuthT(SysA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Insert Into Password_Auth_t(Emp_No,Project_c,Update_d,Use_Cnt,Auth_Pmsn,Login_y)");
		//sql.append(" Values ('"+params.getEmp_no()+"','BASE2',To_Char(Sysdate,'YYYYMMDD HH24MISS'),0,UPPER('"+params.getAuth_pmsn()+"'),'N')");
		sql.append(" Values ('"+params.getEmp_no()+"','"+params.getProject_c()+"',To_Char(Sysdate,'YYYYMMDD HH24MISS'),0,UPPER('"+params.getAuth_pmsn()+"'),'N')");
		
		Logger.debug.println("[BASE:SysA020Query:insPasswordAuthT] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2  Password_Auth_t Է°Ǽ ȸ SQLԼ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public String selPswdAuthTCnt(SysA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" Select count(*) Cnt");
		sql.append(" From Password_Auth_t");
		sql.append(" Where Emp_No = '"+params.getEmp_no()+"'");
		
		Logger.debug.println("[BASE:SysA020Query:selPswdAuthTCnt] sql : "+sql.toString());
		return sql.toString();
	}	
	
	/** 
	  * BASE2  Password_t  SQLԼ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public String delPasswordT(SysA020BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Delete Password_t");
		sql.append(" Where Emp_No = '"+params.getEmp_no()+"'");
		
		Logger.debug.println("[BASE:SysA020Query:delPasswordT] sql : "+sql.toString());
		return sql.toString();
	}		
	
	/** 
	  * BASE2  Password_Auth_t  SQLԼ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2005/04/11 HIST 
	  */
	public String delPasswordAuthT(SysA020BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" Delete Password_Auth_t");
		sql.append(" Where Emp_No = '"+params.getEmp_no()+"' And");
		sql.append("       		Project_c = '"+params.getProject_c()+"'");
		
		Logger.debug.println("[BASE:SysA020Query:delPasswordAuthT] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  * User Information Ҷ Password_t  ȣ Project ϵǾ ִ  ȣ Project ִ SQLԼ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2007/07/24 
	  */
	public String updProjectC(SysA020BG params) {
		StringBuffer sql = new StringBuffer();

		sql.append(" UPDATE PASSWORD_T ");
		sql.append(" SET PROJECT_C = '' ");
		sql.append(" WHERE EMP_NO = '"+params.getEmp_no()+"' ");
	
		Logger.debug.println("[BASE:SysA020Query:updProjectC] sql : "+sql.toString());
		return sql.toString();
	}
	
	/** 
	  *  ýۿ Admin Ȯغ.
	  * @param params SysA020BG User Info
	  * @return String Query  
	  * @author Copyright (c) 2007/08/22 
	  */
	public String cntAdmin(SysA020BG params) {
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT COUNT(*) ADMIN_CNT ");
		sql.append(" FROM PASSWORD_AUTH_T ");
		sql.append(" WHERE EMP_NO = '"+params.getEmp_no()+"' AND ");
		sql.append(" 	( (PROJECT_C IN ('KAMS','TSA','FUMS') AND AUTH_PMSN = 'CLASS1') OR ");
		sql.append(" 	(PROJECT_C IN ('ASIMS') AND AUTH_PMSN = 'AAAAAAAAAAAAAAA') OR ");
		sql.append(" 	(PROJECT_C IN ('RCCHK') AND AUTH_PMSN = 'AM') OR ");
		sql.append(" 	(PROJECT_C IN ('ATDO','SKD','DBCTL') AND SUBSTRB(AUTH_PMSN,5,1) = 'A') OR ");
		sql.append(" 	(PROJECT_C IN ('GD') AND SUBSTRB(AUTH_PMSN,6,1) = 'A') OR ");
		sql.append(" 	(PROJECT_C IN ('SUPPT') AND SUBSTRB(AUTH_PMSN,2,1) = 'A') OR ");
		sql.append(" 	(PROJECT_C IN ('ROUTE') AND AUTH_PMSN = 'AAAAAAAAAA') OR ");
		sql.append(" 	(PROJECT_C IN ('ICOSS') AND AUTH_PMSN = 'R01W01') OR ");
		sql.append(" 	(PROJECT_C IN ('ICIS') AND AUTH_PMSN = 'R01W01') OR ");
		sql.append(" 	(PROJECT_C NOT IN ('KAMS','TSA','FUMS','ASIMS','RCCHK','ATDO','SKD','DBCTL','GD','SUPPT','ROUTE','ICOSS','ICIS') AND ");
		sql.append(" 	SUBSTRB(AUTH_PMSN,1,1) = 'A' ) ) "); //<-⿡ BASE, BASE2, FSWEB ش.
	
		Logger.debug.println("[BASE:SysA020Query:cntAdmin] sql : "+sql.toString());
		return sql.toString();
	}
}
