package kal.base.sys.query;

import kal.base.jdf.com.Logger;
import kal.base.sys.dbbean.*;
import kal.base.com.query.*;
import kal.base.com.util.*;

/**
 * Ȳ
 * ۼ ¥: 2006-03-30
 * @author: 
 */
public class SysQ010Query {
	private static SysQ010Query instance = new SysQ010Query();
	
	public static SysQ010Query getInstance() {
		return instance;
	}
	
	public String selCode1(SysQ010BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT SCHED_NM");
		sql.append(" FROM sch_num_v");
		sql.append(" WHERE sch_eff_dt <= sysdate");
		sql.append(" AND sch_dis_dt >= sysdate");

		
		Logger.debug.println("[BASE:SysQ010Query:selCode1] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String selCode2(SysQ010BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" SELECT SCHED_NM, to_char(sch_eff_dt, 'YYYYMMDD') || to_char(sch_dis_dt, 'YYYYMMDD') period");
		sql.append(" FROM sch_num_v");
		sql.append(" ORDER BY SCHED_NM");
		
		Logger.debug.println("[BASE:SysQ010Query:selCode2] sql : "+sql.toString());
		return sql.toString();
	}

	public String selMain1(SysQ010BG params){
		StringBuffer sql = new StringBuffer();
		
		sql.append(" select arln_cd || flt_num flt_num, to_char(eff_loc_dt, 'DDMONYY HH:MM') eff, to_char(exp_loc_dt, 'DDMONYY HH:MM') exp, freq, kactyp, stnfr || ' - ' || stnto sector, trunc(blk_tm_min / 60) ||' : ' || decode(length(mod(blk_tm_min,60)),1,'0'||mod(blk_tm_min,60), mod(blk_tm_min,60)) block");
		sql.append(" from (select sched_nm from sch_num_v where sch_eff_dt <= sysdate and sch_dis_dt >= sysdate) a,");
		sql.append(" (select * from weekly_sch_t where (stnfr = '" + params.getStn() + "' or stnto = '" + params.getStn() + "') and active = 'Y' and kactyp not in('79S','7FG','7GG','ABH')) b"); //2009.05.21 ߰ : 7GG, ABH
		sql.append(" where a.sched_nm = b.season");
		sql.append(" order by flt_num");

		Logger.debug.println("[BASE:SysQ010Query:selMain1] sql : "+sql.toString());
		return sql.toString();
	}

	public String selMain2(SysQ010BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" select arln_cd || flt_num flt_num, to_char(eff_loc_dt, 'DDMONYY HH:MM') eff, to_char(exp_loc_dt, 'DDMONYY HH:MM') exp, freq, kactyp, stnfr || ' - ' || stnto sector, trunc(blk_tm_min / 60) ||' : ' || decode(length(mod(blk_tm_min,60)),1,'0'||mod(blk_tm_min,60), mod(blk_tm_min,60)) block");
		sql.append(" from weekly_sch_t");
		sql.append(" where season = '" + params.getSkd_nm() +"'");
		sql.append(" and kactyp not in('79S','7FG','7GG','ABH')"); //2009.05.21 ߰ : 7GG, ABH
		sql.append(" order by flt_num");		

		Logger.debug.println("[BASE:SysQ010Query:selMain2] sql : "+sql.toString());
		return sql.toString();
	}	

	public String selMain3(SysQ010BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" select FLTID flt_num, to_char(PRDFR, 'DDMONYY') || ' ' || substr(STD,0,2) || ':' ||  substr(STD,3,2) eff,to_char(PRDTO, 'DDMONYY') || ' ' || substr(STA,0,2) || ':' ||  substr(STA,3,2) exp,FREQ freq,actyp kactyp,DEPSTN || ' - ' || ARRSTN sector,trunc(FLYINGTIME / 60) ||' : ' || decode(length(mod(FLYINGTIME,60)),1,'0'||mod(FLYINGTIME,60), mod(FLYINGTIME,60)) block,");
		sql.append(" case when transtyp in ('P','U') then 'Y' else ' ' end status,");
		sql.append(" intdom, oprnowner, marketcarriers, distkm");
		sql.append(" from oag_weekly_v");
//		sql.append(" where carr ='" + params.getCar() +"'");
//		sql.append(" and (depstn = '" + params.getStn() + "' or arrstn = '" + params.getStn() + "') and prdfr > sysdate and prdfr < sysdate+180");
		sql.append(" where carr ='" + params.getCar() +"'");
		sql.append(" and (depstn = '" + params.getStn() + "' or arrstn = '" + params.getStn() + "')");
		sql.append(" and to_char(prdfr, 'YYYYMMDD') > '" + params.getEff() + "'");
		sql.append(" and to_char(prdfr, 'YYYYMMDD') < '" + params.getExp() + "'");		
		sql.append(" order by transtyp desc,fltid asc");

		Logger.debug.println("[BASE:SysQ010Query:selMain3] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String selMain4(SysQ010BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" select FLTID flt_num, to_char(PRDFR, 'DDMONYY') || ' ' || substr(STD,0,2) || ':' ||  substr(STD,3,2) eff,to_char(PRDTO, 'DDMONYY') || ' ' || substr(STA,0,2) || ':' ||  substr(STA,3,2) exp,FREQ freq,actyp kactyp,DEPSTN || ' - ' || ARRSTN sector,trunc(FLYINGTIME / 60) ||' : ' || decode(length(mod(FLYINGTIME,60)),1,'0'||mod(FLYINGTIME,60), mod(FLYINGTIME,60)) block,");
		sql.append(" case when transtyp in ('P','U') then 'Y' else ' ' end status,");
		sql.append(" intdom, oprnowner, marketcarriers, distkm");
		sql.append(" from oag_weekly_v");
//		sql.append(" where (depstn = '" + params.getStn() + "' or arrstn = '" + params.getStn() + "') and prdfr > sysdate and prdfr < sysdate+180");
		sql.append(" where (depstn = '" + params.getStn() + "' or arrstn = '" + params.getStn() + "')");
		sql.append(" and to_char(prdfr, 'YYYYMMDD') > '" + params.getEff() + "'");
		sql.append(" and to_char(prdfr, 'YYYYMMDD') < '" + params.getExp() + "'");		
		sql.append(" and marketcarriers like '%KE%'");
		sql.append(" order by transtyp desc,fltid asc");	

		Logger.debug.println("[BASE:SysQ010Query:selMain4] sql : "+sql.toString());
		return sql.toString();
	}

	public String selMain5(SysQ010BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" select FLTID flt_num, to_char(PRDFR, 'DDMONYY') || ' ' || substr(STD,0,2) || ':' ||  substr(STD,3,2) eff,to_char(PRDTO, 'DDMONYY') || ' ' || substr(STA,0,2) || ':' ||  substr(STA,3,2) exp,FREQ freq,actyp kactyp,DEPSTN || ' - ' || ARRSTN sector,trunc(FLYINGTIME / 60) ||' : ' || decode(length(mod(FLYINGTIME,60)),1,'0'||mod(FLYINGTIME,60), mod(FLYINGTIME,60)) block,");
		sql.append(" case when transtyp in ('P','U') then 'Y' else ' ' end status,");
		sql.append(" intdom, oprnowner, marketcarriers, distkm");
		sql.append(" from oag_weekly_v");
		sql.append(" where carr ='" + params.getCar() +"'");
		sql.append(" and (depstn = '" + params.getStn() + "' or arrstn = '" + params.getStn() + "')");
		sql.append(" and to_char(prdfr, 'YYYYMMDD') > '" + params.getEff() + "'");
		sql.append(" and to_char(prdfr, 'YYYYMMDD') < '" + params.getExp() + "'");
		sql.append(" order by transtyp desc,fltid asc");

		Logger.debug.println("[BASE:SysQ010Query:selMain5] sql : "+sql.toString());
		return sql.toString();
	}
	
	public String selMain6(SysQ010BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" select FLTID flt_num, to_char(PRDFR, 'DDMONYY') || ' ' || substr(STD,0,2) || ':' ||  substr(STD,3,2) eff,to_char(PRDTO, 'DDMONYY') || ' ' || substr(STA,0,2) || ':' ||  substr(STA,3,2) exp,FREQ freq,actyp kactyp,DEPSTN || ' - ' || ARRSTN sector,trunc(FLYINGTIME / 60) ||' : ' || decode(length(mod(FLYINGTIME,60)),1,'0'||mod(FLYINGTIME,60), mod(FLYINGTIME,60)) block,");
		sql.append(" case when transtyp in ('P','U') then 'Y' else ' ' end status,");
		sql.append(" intdom, oprnowner, marketcarriers, distkm");
		sql.append(" from oag_weekly_v");
		sql.append(" where (depstn = '" + params.getStn() + "' or arrstn = '" + params.getStn() + "')");
		sql.append(" and to_char(prdfr, 'YYYYMMDD') > '" + params.getEff() + "'");
		sql.append(" and to_char(prdfr, 'YYYYMMDD') < '" + params.getExp() + "'");
		sql.append(" and marketcarriers like '%KE%'");
		sql.append(" order by transtyp desc,fltid asc");	

		Logger.debug.println("[BASE:SysQ010Query:selMain6] sql : "+sql.toString());
		return sql.toString();
	}	
	
	//2008.06.10 ߰ : carr => ALL
	public String selMain7(SysQ010BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" select FLTID flt_num, to_char(PRDFR, 'DDMONYY') || ' ' || substr(STD,0,2) || ':' ||  substr(STD,3,2) eff,to_char(PRDTO, 'DDMONYY') || ' ' || substr(STA,0,2) || ':' ||  substr(STA,3,2) exp,FREQ freq,actyp kactyp,DEPSTN || ' - ' || ARRSTN sector,trunc(FLYINGTIME / 60) ||' : ' || decode(length(mod(FLYINGTIME,60)),1,'0'||mod(FLYINGTIME,60), mod(FLYINGTIME,60)) block,");
		sql.append(" case when transtyp in ('P','U') then 'Y' else ' ' end status,");
		sql.append(" intdom, oprnowner, marketcarriers, distkm");
		sql.append(" from oag_weekly_v");
		sql.append(" where (depstn = '" + params.getStn() + "' or arrstn = '" + params.getStn() + "')");
		sql.append(" and to_char(prdfr, 'YYYYMMDD') > '" + params.getEff() + "'");
		sql.append(" and to_char(prdfr, 'YYYYMMDD') < '" + params.getExp() + "'");
		sql.append(" order by transtyp desc,fltid asc");

		Logger.debug.println("[BASE:SysQ010Query:selMain7] sql : "+sql.toString());
		return sql.toString();
	}
	
	//2008.05.07 ߰ :  ¥ ִ season sch_eff_dt, sch_dis_dt  ´.
	public String selTodayEffDis(SysQ010BG params){
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT TO_CHAR(sch_eff_dt, 'YYYYMMDD') || TO_CHAR(sch_dis_dt, 'YYYYMMDD') oag ");
		sql.append(" FROM sch_num_v ");
		sql.append(" WHERE sch_eff_dt <= sysdate ");
		sql.append(" AND sch_dis_dt >= sysdate ");
		sql.append(" AND rownum = 1 ");		
		
		Logger.debug.println("[BASE:SysQ010Query:selTodayEffDis] sql : "+sql.toString());
		return sql.toString();
	}
}