package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ffs.dbbean.FfsA250BG;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Planned PLD, Changed PLD ȸ,  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2008/08/19  
 */
public class FfsA250Serv extends PublicBaseServlet {
	/** 
	  * Planned PLD, Changed PLD ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2008/08/19  
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			FfsA250BG params = new FfsA250BG();
			
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selAccReqPld(params);
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsA250Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsA250Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/** 
	  * Planned PLD, Changed PLD  Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2008/08/20  
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String firstLegFltDt = StringUtil.checkString(box.getString("firstLegFltDt"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		
		String ddmon = StringUtil.checkString(box.getString("ddmon"));
		String regno = StringUtil.checkString(box.getString("regno"));
		String inputTyp = StringUtil.checkString(box.getString("inputTyp"));
		String telexAddr = StringUtil.checkString(box.getString("telexAddr"));
		
		String reqPax = StringUtil.checkString(box.getString("reqPax"));
		String reqCgo = StringUtil.checkString(box.getString("reqCgo"));
		String reqOth = StringUtil.checkString(box.getString("reqOth"));
		
		String yesNo = StringUtil.checkString(box.getString("yesNo"));
		String empNo = StringUtil.checkString(box.getString("empNo"));
		
		String reqCgoPldZeroY = StringUtil.checkString(box.getString("reqCgoPldZeroY")); //2008.10.15 ߰
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			FfsA250BG params = new FfsA250BG();
			
			params.setFirstLegFltDt(firstLegFltDt);
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setDdmon(ddmon);
			params.setRegno(regno);
			params.setInputTyp(inputTyp);
			params.setTelexAddr(telexAddr);
			params.setReqPaxPldWt(reqPax);
			params.setReqCgoPldWt(reqCgo);
			params.setReqOthPldWt(reqOth);
			params.setYesNo(yesNo);
			params.setEmpNo(empNo);
			
			params.setReqCgoPldZeroY(reqCgoPldZeroY); //2008.10.15 ߰
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			String returnValue = sl.updAccReqPld(params);
			if (returnValue.equals("succ")) req.setAttribute("returnValue","S");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsA250Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
				return;
			} else {
				Logger.debug.println("[BASE:FfsA250Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
				return;
			}
		} 
	}//end updateTask
}
