package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.util.StringUtil;
import kal.base.ffs.dbbean.FfsQ110BG;
import kal.base.ffs.ejb.FfsAllSL;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;

/**
 * 20160301 ߰
 */
public class FfsQ110Serv extends PublicBaseServlet {

	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		SysA010BG userInfo = (SysA010BG)req.getSession().getAttribute("USERINFO");
		String staffNum = userInfo.getEmp_no();
		String cat = "ACS";
		
		String returnPage = "/jsp/ffs/FfsQ110IF_rev.jsp";
		
		try {
			FfsQ110BG params = new FfsQ110BG();
			params.setStaffNum(staffNum);
			params.setCat(cat);
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selUserSetting(params);
			req.setAttribute("hashData",hashData);
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ110Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ110Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}
	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		SysA010BG userInfo = (SysA010BG)req.getSession().getAttribute("USERINFO");
		String staffNum = userInfo.getEmp_no();
		String setValue = StringUtil.checkString(box.getString("setValue"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {				
			FfsQ110BG params = new FfsQ110BG();
			params.setStaffNum(staffNum);
			params.setSetValue(setValue);
			params.setCat("ACS");
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			boolean flag = sl.setAcarsDefault(params);
			if (flag) req.setAttribute("dataComplete","S");
			else throw new Exception(" ߻.");
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ110Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:FfsQ110Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}
	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		SysA010BG userInfo = (SysA010BG)req.getSession().getAttribute("USERINFO");
		String staffNum = userInfo.getEmp_no();
		String cat = "COLUMN";
		
		String returnPage = "/jsp/ffs/FfsQ111IF.jsp";
		
		try {
			FfsQ110BG params = new FfsQ110BG();
			params.setStaffNum(staffNum);
			params.setCat(cat);
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selUserSetting(params);
			req.setAttribute("hashData",hashData);
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ110Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ110Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}
	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		SysA010BG userInfo = (SysA010BG)req.getSession().getAttribute("USERINFO");
		String staffNum = userInfo.getEmp_no();
		String setValue = StringUtil.checkString(box.getString("setValue"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {				
			FfsQ110BG params = new FfsQ110BG();
			params.setStaffNum(staffNum);
			params.setSetValue(setValue);
			params.setCat("COLUMN");
			
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			boolean flag = sl.setAcarsDefault(params);
			if (flag) req.setAttribute("dataComplete","S");
			else throw new Exception(" ߻.");
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ110Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:FfsQ110Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}
}
