package kal.base.ffs.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.StringTokenizer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.serv.ComUtil;
import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ffs.daemon.FfsQ020Task;
import kal.base.ffs.dbbean.FfsQ420BG;
import kal.base.ffs.ejb.FfsAllSL;

/**
 * Fuel & Weight  ȸ/Է Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/06/09 
 */
public class FfsQ420Serv extends PublicBaseServlet {
	/** 
	  * Fuel & Weight  ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/06/09 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String schDepDt = StringUtil.checkString(box.getString("sch_dep_dt"));
		String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		String useInFfs = StringUtil.checkString(box.getString("useInFfs"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			
			FfsQ420BG params = new FfsQ420BG();
			
			params.setPSchDepDt(schDepDt);
			params.setPFltNum(fltNum);
			params.setPStnfr(stnfr);
			params.setPStnto(stnto);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			Hashtable hashData  = sl.selFltFuelWeight(params);
			req.setAttribute("hashData",hashData);
			
			String result = "";
			if (hashData != null) result = (String)hashData.get("RESULT");
			req.setAttribute("returnValue", result);
			req.setAttribute("useInFfs", useInFfs);
			
			System.out.println("############### result : " +result);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ420Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ420Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/** 
	  * Fuel & Weight  UPDATE Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/06/10 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String empNo = StringUtil.checkString(box.getString("emp_no"));
		
		String schDepDt = StringUtil.checkString(box.getString("sch_dep_dt"));
		String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));
		
		String firstLegFltDt = StringUtil.checkString(box.getString("first_leg_flt_dt"));
		String arlnCd = StringUtil.checkString(box.getString("arln_cd"));
		
		String plnPld = StringUtil.checkString(box.getString("pln_pld"));
		String plnZfw = StringUtil.checkString(box.getString("pln_zfw"));
		String plnTow = StringUtil.checkString(box.getString("pln_tow"));
		String plnRtow = StringUtil.checkString(box.getString("pln_rtow"));
		String plnAcl = StringUtil.checkString(box.getString("pln_acl"));
		String plnRamp = StringUtil.checkString(box.getString("pln_ramp"));
		String plnTof = StringUtil.checkString(box.getString("pln_tof"));
		String plnTif = StringUtil.checkString(box.getString("pln_tif"));
		
		String extr1 = StringUtil.checkString(box.getString("extr_1"));
		String rsn1 = StringUtil.checkString(box.getString("rsn_1"));
		String extr2 = StringUtil.checkString(box.getString("extr_2"));
		String rsn2 = StringUtil.checkString(box.getString("rsn_2"));
		//String extr3 = StringUtil.checkString(box.getString("extr_3"));
		//String rsn3 = StringUtil.checkString(box.getString("rsn_3"));
		String tnkr = StringUtil.checkString(box.getString("tnkr")); //2009.08.11  : PLN_TANK_FUEL и
		
		String actFod = StringUtil.checkString(box.getString("act_fod")); //2009.08.11 ߰ : ACT_FOD_FUEL Է°
		
		String siMsg = StringUtil.checkString(box.getString("si_msg"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String useInFfs = StringUtil.checkString(box.getString("useInFfs"));
		
		try {
			
			String plnExtrFuel1 = "";
			String plnExtrRsn1 = "";
			String plnExtrFuel2 = "";
			String plnExtrRsn2 = "";
			
			if (!rsn1.equals("") && !extr1.equals("")) {
				plnExtrFuel1 = extr1;
				plnExtrRsn1 = rsn1;
			}
			if (!rsn2.equals("") && !extr2.equals("")) {
				if (plnExtrFuel1.equals("") && plnExtrRsn1.equals("")) {
					plnExtrFuel1 = extr2;
					plnExtrRsn1 = rsn2;
				} else {
					plnExtrFuel2 = extr2;
					plnExtrRsn2 = rsn2;
				}
			}
			
			FfsQ420BG params = new FfsQ420BG();
			
			params.setUserId(empNo);
			
			params.setFltNum(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setFirstLegFltDt(firstLegFltDt);
			params.setArlnCd(arlnCd);
			
			params.setPlnPld(plnPld);
			params.setPlnZfw(plnZfw);
			params.setPlnTow(plnTow);
			params.setPlnRtow(plnRtow);
			params.setPlnAcl(plnAcl);
			params.setPlnRampFuel(plnRamp);
			params.setPlnTkofFuel(plnTof);
			params.setPlnTripFuel(plnTif);
			
			params.setPlnExtrFuel1(plnExtrFuel1);
			params.setPlnExtrRsn1(plnExtrRsn1);
			params.setPlnExtrFuel2(plnExtrFuel2);
			params.setPlnExtrRsn2(plnExtrRsn2);
			params.setPlnTankFuel(tnkr); //2009.08.11  : PLN_TANK_FUEL и
			
			params.setActFodFuel(actFod); //2009.08.11 ߰ : ACT_FOD_FUEL Է°
			
			params.setSiMsg(siMsg);
			
			//EJB LookUp
			FfsAllSL sl = (FfsAllSL)EJBFinder.lookup("ejb/FfsAllSL");
			
			String returnValue = sl.updFltFuelWeight(params);
			req.setAttribute("returnValue","U");
			if(useInFfs.equals("Y")){
				FfsQ020Task.hMap = sl.allReleased();
			    req.setAttribute("useInFfs", useInFfs);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:FfsQ420Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
				return;
			} else {
				Logger.debug.println("[BASE:FfsQ420Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
				return;
			}
		} 
	}//end updateTask
}
