package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.IroA010BG;
import kal.base.iro.ejb.IroAllSL;
import kal.base.sys.dbbean.*;

/**
 * IRR/DSS Current Flight Schedule Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/31 HIST  
 */
public class IroA010Serv extends PublicBaseServlet{
	private static IroA010Serv instance = new IroA010Serv();
	
	public static IroA010Serv getInstance() {
		return instance;
	}
	
	/**
	 * <b>Desk Select Code ȸ</b>
	 * @return Hashtable JSP Return ȸ Desk  ڵ
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static Hashtable selDeskCode() throws Exception {
		try {
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashDesk = sl.selIroA010Desk();

			return hashDesk;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}

	/** 
	  *  IRR/DSS Current Flight Schedule Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String stnFr = StringUtil.checkString(box.getString("stnfr"));							//Station
		//String regionFlt = StringUtil.checkString(box.getString("region_flt"));			//region Flt Code
		String endTm = StringUtil.checkString(box.getString("end_tm"));					//End Time
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));				//ALL/DOM/INT/CGO
		String deskX = StringUtil.checkString(box.getString("desk_x"));					//Desk 
		String aaa = StringUtil.checkString(req.getParameter("regno"));
		String regNo = StringUtil.checkString(box.getString("regno"));						// 2005.09.05 ߰ 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		Logger.debug.println("[IroA010Serv:selectTask] regNo : "+regNo);
		Logger.debug.println("[IroA010Serv:selectTask] getParameter aaa : "+aaa);
		
		try {
			req.setAttribute("endTm",endTm);
			HttpSession session = null;
			
			//ǽð -9
			int iTm = Integer.valueOf(endTm).intValue() - 9;
			
			//Desk  SessionԷ
			if (deskX != null && !deskX.equals("")) {
				session = req.getSession();
				session.setAttribute("desk_x",deskX);
			} else throw new Exception("Desk  ϴ.");
			
			//EJB Parameter 
			IroA010BG params = new IroA010BG();
			params.setStnfr(stnFr);
			//params.setRegion_flt(regionFlt);
			params.setEnd_tm(String.valueOf(iTm).toString());
			params.setDom_int_x(domIntX);
			params.setRegno(regNo);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroA010Main(params);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Current FLT SKD", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  *  IRR/DSS Current FLT SKD Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST  
	  */		
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String[] arrFirstLegFltDt = req.getParameterValues("h_first_leg_flt_dt");
		String[] arrFltNum = req.getParameterValues("h_flt_num");
		String[] arrStnFr = req.getParameterValues("h_stnfr");
		String[] arrStnTo = req.getParameterValues("h_stnto");
		String[] arrLegNum = req.getParameterValues("h_leg_num");
		String[] arrTitleX = req.getParameterValues("title_x");
		String[] arrTitleE = req.getParameterValues("title_e");
		String[] arrRegionFlt = req.getParameterValues("h_region_flt");
		String[] arrRegionLeg = req.getParameterValues("h_region_leg");
		//String empNo = StringUtil.checkString(box.getString("emp_no"));
		String[] arrTimeStamp = req.getParameterValues("h_timestamp");
		//Desk 
		String deskX = StringUtil.checkString(box.getString("desk_x"));
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));
		String stnFr = StringUtil.checkString(box.getString("stnfr"));
		//ڱڽ(Back iFrame) /п (Y/N) Ѵ
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//Parameter ü 
			Hashtable hashParam = new Hashtable();
			List listParam = new LinkedList();
			IroA010BG newData = null;
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//ü insert  ŭ Loop 
			for (int i=0; i<arrFirstLegFltDt.length; i++) {
				//Comment Էµ Line Ѵ
				if (!(StringUtil.checkString(arrTitleE[i])).equals("")) {
					IroA010BG params = new IroA010BG();
					params.setFirst_leg_flt_dt(StringUtil.checkString(arrFirstLegFltDt[i]));
					params.setFlt_num(StringUtil.checkString(arrFltNum[i]));
					params.setStnfr(StringUtil.checkString(arrStnFr[i]));
					params.setStnto(StringUtil.checkString(arrStnTo[i]));
					params.setLeg_num(StringUtil.checkString(arrLegNum[i]));
					params.setTitle_x(StringUtil.checkString(arrTitleX[i]));
					params.setTitle_e(StringUtil.checkString(StringUtil.toKSC5601(arrTitleE[i])));
					Logger.debug.println("[SERV] region_flt : "+StringUtil.checkString(arrRegionFlt[i]));
					params.setRegion_flt(StringUtil.checkString(arrRegionFlt[i]));
					params.setRegion_leg(StringUtil.checkString(arrRegionLeg[i]));
					params.setEmp_no(StringUtil.checkString(UserInfo.getEmp_no()));
					params.setTimestamp(StringUtil.checkString(arrTimeStamp[i]));
					listParam.add(params);
				}
			}
			//ü Data 0 Ŭ츸  ϰ
			//ƴϸ  Ѵ.
			// ⼭ ɸ ʵȴ. JSP ̹ Checkϰ Ѿ; Ѵ.
			if (listParam.size() > 0) {
				hashParam.put("listParam",listParam);
				newData = new IroA010BG();
				newData.setMode("OLD");
				
			} else throw new Exception("Էµ Data ϴ.");
			
			//Logger.debug.println("[IroA010Serv:insertTask] deskX : "+deskX);
			
			//Desk  SessionԷ
			if (deskX != null && !deskX.equals("")) {
				session = req.getSession();
				session.setAttribute("desk_x",deskX);
			} else throw new Exception("Desk  ϴ.");
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashMsg  = sl.insIroA010Irops(newData,hashParam);
			
			req.setAttribute("hashMsg",hashMsg);
			req.setAttribute("domIntX",domIntX);
			req.setAttribute("stnFr",stnFr);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA010Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:IroA010Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask	
	
	/** 
	  *  IRR/DSS Current FLT SKD Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST  
	  */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String deskX = StringUtil.checkString(box.getString("desk_x"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			HttpSession session = null;
			
			//Desk  SessionԷ
			if (deskX != null && !deskX.equals("")) {
				session = req.getSession();
				session.setAttribute("desk_x",deskX);
			} else throw new Exception("Desk  ϴ.");

			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA010Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroA010Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask	
	
	/** 
	  *  NEW Flight ű Էó Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/27 HIST  
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		String deskX = StringUtil.checkString(box.getString("desk_x"));							//Desk X
		String firstLegFltDt = StringUtil.checkString(box.getString("n_date"));					//First Leg Flt Dt
		String fltNum = StringUtil.checkString(box.getString("n_flt_num"));							//Flt Num
		String kActyp = StringUtil.checkString(box.getString("n_actyp"));							//KACTYP
		String regNo = StringUtil.checkString(box.getString("n_regno"));							//Reg Num
		String sTd = StringUtil.checkString(box.getString("n_sch_dep_dt"));					//STA
		String sTa = StringUtil.checkString(box.getString("n_sch_arv_dt"));						//STD
		String titleE = StringUtil.checkString(box.getString("n_comment"));						//Comment
		String stnFr = StringUtil.checkString(box.getString("n_stnfr"));								//Station From
		String stnTo = StringUtil.checkString(box.getString("n_stnto"));							//Station To
		String returnPage = StringUtil.checkString(box.getString("returnPage"));				//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = StringUtil.checkString(UserInfo.getEmp_no());
			
			//Dom, Int, Cgo Ǻ
			String codeX = StringUtil.GetDomIntX(fltNum,kActyp);
			
			//Parameter ü 
			Hashtable hashParam = new Hashtable();
			List listParam = new LinkedList();
			IroA010BG newData =new IroA010BG();
			newData.setMode("NEW");
			newData.setDesk_x(deskX);
			newData.setFirst_leg_flt_dt(firstLegFltDt);
			newData.setFlt_num(fltNum);
			newData.setStnfr(stnFr);
			newData.setStnto(stnTo);
			newData.setSch_dep_dt(sTd);
			newData.setSch_arv_dt(sTa);
			newData.setKactyp(kActyp);
			newData.setRegno("HL"+regNo);
			newData.setCode_x(codeX);
			
			//Region Flight, Region X Code ȸ
			String regionFlt = ComUtil.getInstance().getRegionFlt(fltNum);
			String regionX = ComUtil.getInstance().getRegionX(stnFr,stnTo);
			
			// NEW Flight DATA PARAMETER 
			IroA010BG params = new IroA010BG();
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			//2009.04.28  : 1, 2, 3...=> 10, 20, 30...  
			//params.setLeg_num("1");
			params.setLeg_num("10");
			params.setTitle_x("NEW");
			params.setTitle_e(StringUtil.toKSC5601(titleE));
			params.setRegion_flt(regionFlt);
			params.setRegion_leg(regionX);
			params.setEmp_no(empNo);
			params.setTimestamp("");
			listParam.add(params);
			hashParam.put("listParam",listParam);
			
			//Desk  SessionԷ
			if (deskX != null && !deskX.equals("")) {
				session.setAttribute("desk_x",deskX);
			} else throw new Exception("Desk  ϴ.");
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashMsg  = sl.insIroA010Irops(newData,hashParam);
			
			req.setAttribute("hashMsg",hashMsg);
			req.setAttribute("newData",newData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA010Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:IroA010Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask	
				
}//end of class
