package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.IroA010BG;
import kal.base.iro.ejb.IroAllSL;
import kal.base.sys.dbbean.*;

/**
 * IRR/DSS Alert Message Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/31 HIST  
 */
public class IroA015Serv extends PublicBaseServlet{

	/** 
	  *  IRR/DSS Alert Message Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST  
	  */		
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		//String empNo = StringUtil.checkString(box.getString("emp_no"));					//Է»
		String alertMsgE = StringUtil.toKSC5601(box.getString("alert_msg_e"));		//Է ޼
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//EJB Parameter 
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			IroA010BG params = new IroA010BG();
			params.setEmp_no(UserInfo.getEmp_no());
			params.setAlert_msg_e(alertMsgE);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String insMsg  = sl.insIroA010AlertMsg(params);
			req.setAttribute("INSMSG",insMsg);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA015Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:IroA015Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask
	
	/** 
	  *  IRR/DSS Alert Message Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashAlert  = sl.selIroA010AlertMsg();
			req.setAttribute("hashAlert",hashAlert);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA015Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA015Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask

	/** 
	  *  IRR/DSS Alert Message Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST  
	  */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		//String empNo = StringUtil.checkString(box.getString("emp_no"));		//Expire 
		String alertDt = StringUtil.checkString(box.getString("alert_dt"));		//Expire ޼
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			
			Logger.debug.println("[Servlet] alertDt : "+alertDt);
			
			//EJB Parameter 
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			IroA010BG params = new IroA010BG();
			params.setEmp_no(UserInfo.getEmp_no());
			params.setAlert_dt(alertDt);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String updMsg  = sl.updIroA010AlertMsg(params);
			req.setAttribute("updMsg",updMsg);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA015Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroA015Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask

	/** 
	  *  IRR/DSS Job Select Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST  
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String deskX = StringUtil.checkString(box.getString("desk_x"));					//Desk X
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		//Logger.debug.println("[IroA015Serv:checkTask] deskX : "+deskX);
		//Logger.debug.println("[IroA015Serv:checkTask] returnPage : "+returnPage);
		
		try {
			HttpSession session = null;
			
			//Desk  SessionԷ
			if (deskX != null && !deskX.equals("")) {
				session = req.getSession();
				session.setAttribute("desk_x",deskX);
			} //else throw new Exception("Desk  ϴ.");
			
			//EJB Parameter 
			IroA010BG params = new IroA010BG();
			params.setDesk_x(deskX);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashJob  = sl.selIroA010Job(params);
			req.setAttribute("hashJob",hashJob);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA015Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:IroA015Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
				
}
