package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.IroA020BG;
import kal.base.iro.ejb.IroAllSL;

/**
 * IRR/DSS IROPS Flight Status Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/02/03 HIST  
 */
public class IroA020Serv extends PublicBaseServlet{
	/** 
	  *  IRR/DSS IROPS Flight Status Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String stnFr = StringUtil.checkString(box.getString("stnfr"));							//Station
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));				//DOM/INT/CGO
		String deskX = StringUtil.checkString(box.getString("desk_x"));					//DESK Code
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//EJB Parameter 
			IroA020BG params = new IroA020BG();
			params.setStnfr(stnFr);
			params.setDom_int_x(domIntX);
			params.setDesk_x(deskX);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroA020Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("IROPS FLT Status", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA020Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA020Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  *  IRR/DSS IROPS Flight Status Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST  
	  */		
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		// Parameter
		String d_firstLegFltDt = StringUtil.checkString(box.getString("r_first_leg_flt_dt"));	//First Leg Flt Dt
		String d_fltNum = StringUtil.checkString(box.getString("r_flt_num"));						//Flight Number
		String d_stnFr = StringUtil.checkString(box.getString("r_stnfr"));							//Station From
		String d_stnTo = StringUtil.checkString(box.getString("r_stnto"));							//Station To
		String d_seqNum = StringUtil.checkString(box.getString("r_seq_num"));				//Seq Number
		String d_empNo  = StringUtil.checkString(box.getString("r_emp_no"));					//Emp Number
		//ȸ Parameter
		String stnFr = StringUtil.checkString(box.getString("stnfr"));									//Station
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));						//region Flt Code
		String returnPage = StringUtil.checkString(box.getString("returnPage"));				//Return Page ȹ
		//Desk  Session ȸ
		HttpSession session = req.getSession();
		String deskX = StringUtil.checkString((String)session.getAttribute("desk_x"));
		
		try {
			if (deskX.equals("")) throw new Exception("DESK  ϴ.");
			
			//EJB Parameter 
			IroA020BG params = new IroA020BG();
			params.setFirst_leg_flt_dt(d_firstLegFltDt);
			params.setFlt_num(d_fltNum);
			params.setStnfr(d_stnFr);
			params.setStnto(d_stnTo);
			params.setSeq_num(d_seqNum);
			params.setDesk_x(deskX);
			
			IroA020BG entity = new IroA020BG();
			entity.setStnfr(stnFr);
			entity.setDom_int_x(domIntX);
			entity.setDesk_x(deskX);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String delMsg = sl.delIroA020Irops(params);
			if (delMsg.equals("Y")) {
				Hashtable hashData  = sl.selIroA020Main(entity);
				req.setAttribute("hashData",hashData);
				req.setAttribute("delMsg",delMsg);
				if (hashData != null) 
					req.setAttribute("successMessage",ComUtil.getInstance().getMessage("IROPS FLT Status", null, "", "KE"+d_fltNum+" "+MessageCode.getInstance().CANCEL_MSG));
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA020Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:IroA020Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end selectTask	

}//end of class
