package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;

/**
 * IROPS Issue Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/07/13  
 */
public class IroA310Serv extends PublicBaseServlet {
	
	private static IroA310Serv instance = new IroA310Serv();
	
	public static IroA310Serv getInstance() {
		return instance;
	}
	
	/**
	 * Desk Select Code ȸ
	 * @return Hashtable JSP Return ȸ Desk  ڵ
	 * @exception Exception
	 * @author Copyright (c) 2009/07/13 
	 */
	public static Hashtable selDeskCode() throws Exception {
		try {
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashDesk = sl.selIroA310DeskCode();

			return hashDesk;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}
	
	/** 
	  * IROPS Issue Search Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/13 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String endTm = StringUtil.checkString(box.getString("end_tm"));
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));
		String stn = StringUtil.checkString(box.getString("stn"));
		String flt = StringUtil.checkString(box.getString("flt"));
		String acreg = StringUtil.checkString(box.getString("acreg"));
		
		try {
			IroA310BG params = new IroA310BG();
			params.setEndTm(endTm);
			params.setDomIntX(domIntX);
			params.setStn(stn);
			params.setFlt(flt);
			params.setAcreg(acreg);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroA310Main(params);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Current FLT SKD", hashData, "SKD_LIST", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA310Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA310Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * IROPS FLT 1, 2 ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/14 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String jobMode = StringUtil.checkString(box.getString("job_mode"));
		String deskX = StringUtil.checkString(box.getString("desk_x"));
		
		try {
			IroA310BG params = new IroA310BG();
			
			params.setJobMode(jobMode);
			params.setDeskX(deskX);
			
			//IROPS FLT 2  SHIFT MANAGER(A), INTL SKDR(B), DOM SKDR(D)  
			if (jobMode.equals("2") && !deskX.equals("A") && !deskX.equals("B") && !deskX.equals("D")) {
				
				req.setAttribute("hashJob", null);
				req.setAttribute("returnParam","N");
			
			} else {
				
				//EJB LookUp
				IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
				Hashtable hashData = sl.selIroA310IropsFlt(params);
				req.setAttribute("hashJob", hashData);
				req.setAttribute("returnParam","Y");
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA310Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:IroA310Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
	/** 
	  * IROPS FLT 1, 2  Confirm θ ȸ Servlet Class - performTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/24 
	  */	
	public void performTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dssStartDt = StringUtil.checkString(box.getString("dssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("seqNum"));
		
		try {
			IroA310BG params = new IroA310BG();
			
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String returnValue = sl.selIroA310chkIropsFlt(params);
			req.setAttribute("returnValue",returnValue);
			req.setAttribute("dssStartDt",dssStartDt);
			req.setAttribute("seqNum",seqNum);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA310Serv:performTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"perform");
			} else {
				Logger.debug.println("[BASE:IroA310Serv:performTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"perform");
			}
		} 
	}//end performTask
	
	/** 
	  * NEW Flight   IROPS ߻ Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/17 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String skdMode = StringUtil.checkString(box.getString("skd_mode"));		//1 : Searchؼ , 2 : Creation  
		String msgMode = StringUtil.checkString(box.getString("msg_mode"));		//N : IROPS Issue ȭ鿡 ó ó, M : Messenger â Ѿ 
		
		String deskX = StringUtil.checkString(box.getString("desk_x"));
		String title = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("title"))));
		String empNo = StringUtil.checkString(box.getString("empNo"));
		String korN = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("korN"))));
		String dssStartDt = StringUtil.checkString(box.getString("dss_start_dt"));
		String msgNo = StringUtil.checkString(box.getString("msg_no"));
		String lvlNo = StringUtil.checkString(box.getString("lvl_no"));
		
		String date = StringUtil.checkString(box.getString("n_date"));
		String fltNum = StringUtil.checkString(box.getString("n_flt_num"));
		String actyp = StringUtil.checkString(box.getString("n_actyp"));
		String regno = "HL" + StringUtil.checkString(box.getString("n_regno"));
		String stnfr = StringUtil.checkString(box.getString("n_stnfr"));
		String stnto = StringUtil.checkString(box.getString("n_stnto"));
		String std = StringUtil.checkString(box.getString("n_sch_dep_dt"));		//YYYYMMDDHH24MI
		String sta = StringUtil.checkString(box.getString("n_sch_arv_dt"));		//YYYYMMDDHH24MI
		String comment = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("n_comment"))));
		
		try {
			//DOM/INT/CGO Ǻ
			String domIntX = StringUtil.GetDomIntX(fltNum,actyp);
			
			//Parameter ü 
			IroA310BG newData = new IroA310BG(); //DSS_NEW_SCH_T  insert  
			
			newData.setFirstLegFltDt(date);
			newData.setFltNum(fltNum);
			newData.setLegNum("10");
			newData.setStnfr(stnfr);
			newData.setStnto(stnto);
			newData.setStd(std);
			newData.setSta(sta);
			newData.setActyp(actyp);
			newData.setRegno(regno);
			newData.setDomIntX(domIntX);
			
			IroA310BG keyData = new IroA310BG(); //DSS_IROPS_T  insert  
			
			keyData.setSkdMode(skdMode); //ݵ '2' ̾ Ѵ.
			keyData.setMsgMode(msgMode);
			
			keyData.setDeskX(deskX);
			keyData.setTitleE(title);
			keyData.setEmpNo(empNo);
			keyData.setKorN(korN);
			keyData.setDssStartDt(dssStartDt); //msg_mode=N ϶  . M ϶ .
			keyData.setMsgNo(msgNo); //msg_mode=N ϶  . M ϶ .
			keyData.setLvlNo(lvlNo); //msg_mode=N ϶  . M ϶ .
			
			//⼭ New Flight Ѱ óѴ.			
			Hashtable hashParam = new Hashtable();
			List listParam = new LinkedList();
			IroA310BG params = new IroA310BG();
			
			params.setFirstLegFltDt(date);
			params.setFltNum(fltNum);
			params.setLegNum("10");
			params.setStnfr(stnfr);
			params.setStnto(stnto);
			params.setStd(std);
			params.setDomIntX(domIntX);
			params.setCommentX("NEW");
			params.setCommentE(comment);
			
			listParam.add(params);
			hashParam.put("listParam", listParam);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.insIroA310Irops(newData, keyData, hashParam);
			
			String pDssStartDt = "";
			String pSeqNum = "";
			
			if (hashData != null) {
				pDssStartDt = (String)hashData.get("DSS_START_DT");
				pSeqNum = (String)hashData.get("SEQ_NUM");
			}
			
			req.setAttribute("pDssStartDt", pDssStartDt);
			req.setAttribute("pSeqNum", pSeqNum);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA310Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:IroA310Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask
	
	/** 
	  * SKD Ͽ IROPS ߻ Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/17 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String skdMode = StringUtil.checkString(box.getString("skd_mode"));		//1 : Searchؼ , 2 : Creation  
		String msgMode = StringUtil.checkString(box.getString("msg_mode"));		//N : IROPS Issue ȭ鿡 ó ó, M : Messenger â Ѿ 
		
		String deskX = StringUtil.checkString(box.getString("desk_x"));
		String title = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("title"))));
		String empNo = StringUtil.checkString(box.getString("empNo"));
		String korN = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("korN"))));
		String dssStartDt = StringUtil.checkString(box.getString("dss_start_dt"));
		String msgNo = StringUtil.checkString(box.getString("msg_no"));
		String lvlNo = StringUtil.checkString(box.getString("lvl_no"));
		
		String[] sCheck = req.getParameterValues("s_check");
		
		String[] firstLegFltDt = new String[sCheck.length];
		String[] fltNum = new String[sCheck.length];
		String[] legNum = new String[sCheck.length];
		String[] stnfr = new String[sCheck.length];
		String[] stnto = new String[sCheck.length];
		String[] std = new String[sCheck.length];
		String[] domIntX = new String[sCheck.length];
		String[] commentX = new String[sCheck.length];
		String[] commentE = new String[sCheck.length];
		
		for (int i=0 ; i<sCheck.length ; i++) {
			
			firstLegFltDt[i] = StringUtil.checkString(box.getString("s_first_leg_flt_dt"+sCheck[i]));
			fltNum[i] = StringUtil.checkString(box.getString("s_flt_num"+sCheck[i]));
			legNum[i] = StringUtil.checkString(box.getString("s_leg_num"+sCheck[i]));
			stnfr[i] = StringUtil.checkString(box.getString("s_stnfr"+sCheck[i]));
			stnto[i] = StringUtil.checkString(box.getString("s_stnto"+sCheck[i]));
			std[i] = StringUtil.checkString(box.getString("s_std"+sCheck[i]));
			domIntX[i] = StringUtil.checkString(box.getString("s_dom_int_x"+sCheck[i]));
			commentX[i] = StringUtil.checkString(box.getString("s_title_x"+sCheck[i]));
			commentE[i] = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("s_comment"+sCheck[i]))));
		}
		
		try {
			//Parameter ü 
			IroA310BG newData = new IroA310BG();
			
			IroA310BG keyData = new IroA310BG(); //DSS_IROPS_T  insert  
			
			keyData.setSkdMode(skdMode); //ݵ '1' ̾ Ѵ.
			keyData.setMsgMode(msgMode);
			
			keyData.setDeskX(deskX);
			keyData.setTitleE(title);
			keyData.setEmpNo(empNo);
			keyData.setKorN(korN);
			keyData.setDssStartDt(dssStartDt); //msg_mode=N ϶  . M ϶ .
			keyData.setMsgNo(msgNo); //msg_mode=N ϶  . M ϶ .
			keyData.setLvlNo(lvlNo); //msg_mode=N ϶  . M ϶ .
			
			System.out.println(skdMode);
			System.out.println(msgMode);
			System.out.println(deskX);
			System.out.println(title);
			System.out.println(empNo);
			System.out.println(korN);
			System.out.println(dssStartDt);
			System.out.println(msgNo);
			System.out.println(lvlNo);
			System.out.println("***************************************");
			
			// Flight óѴ.			
			Hashtable hashParam = new Hashtable();
			List listParam = new LinkedList();
			
			for (int i=0 ; i<sCheck.length ; i++) {
				
				IroA310BG params = new IroA310BG();
				
				params.setFirstLegFltDt(firstLegFltDt[i]);
				params.setFltNum(fltNum[i]);
				params.setLegNum(legNum[i]);
				params.setStnfr(stnfr[i]);
				params.setStnto(stnto[i]);
				params.setStd(std[i]);
				params.setDomIntX(domIntX[i]);
				params.setCommentX(commentX[i]);
				params.setCommentE(commentE[i]);
				
				System.out.println(firstLegFltDt[i]);
				System.out.println(fltNum[i]);
				System.out.println(legNum[i]);
				System.out.println(stnfr[i]);
				System.out.println(stnto[i]);
				System.out.println(std[i]);
				System.out.println(domIntX[i]);
				System.out.println(commentX[i]);
				System.out.println(commentE[i]);
				System.out.println("-------------------------------------");
				
				listParam.add(params);
			}
			hashParam.put("listParam", listParam);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.insIroA310Irops(newData, keyData, hashParam);
			
			String pDssStartDt = "";
			String pSeqNum = "";
			
			if (hashData != null) {
				pDssStartDt = (String)hashData.get("DSS_START_DT");
				pSeqNum = (String)hashData.get("SEQ_NUM");
			}
			
			req.setAttribute("pDssStartDt", pDssStartDt);
			req.setAttribute("pSeqNum", pSeqNum);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA310Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroA310Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
	
}
