package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;

/**
 * Option Comparision Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/07/27  
 */
public class IroA320Serv extends PublicBaseServlet {
	
	/** 
	  * SKD  ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/27 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dssStartDt = StringUtil.checkString(box.getString("pDssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("pSeqNum"));
		
		try {
			IroA320BG params = new IroA320BG();
			
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroA320Main(params);
			req.setAttribute("hashData", hashData);
			req.setAttribute("returnParam", "Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA320Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroA320Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Check List ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/30 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String commentX = StringUtil.checkString(box.getString("commentX"));
		String codeX = StringUtil.checkString(box.getString("codeX"));
		
		String dssStartDt = StringUtil.checkString(box.getString("pDssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("pSeqNum"));
		
		try {
			IroA320BG params = new IroA320BG();
			
			params.setCommentX(commentX);
			params.setCodeX(codeX);
			
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroA320CheckList(params);
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA320Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:IroA320Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
	/** 
	  * Desk Info ȸ Servlet Class - performTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/30 
	  */	
	public void performTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dssStartDt = StringUtil.checkString(box.getString("pDssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("pSeqNum"));
		
		try {
			IroA320BG params = new IroA320BG();
			
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroA320DeskInfo(params);
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA320Serv:performTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"perform");
			} else {
				Logger.debug.println("[BASE:IroA320Serv:performTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"perform");
			}
		} 
	}//end performTask
	
	/** 
	  * Check List û Send Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/31 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String deskX = StringUtil.checkString(box.getString("desk_x"));
		
		String dssStartDt = StringUtil.checkString(box.getString("pDssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("pSeqNum"));
		
		String checklistE = StringUtil.checkString(box.getString("checklistE"));
		String decisionX = StringUtil.checkString(box.getString("decisionX"));
		String decisionE = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("decisionE"))));
		String empNo = StringUtil.checkString(box.getString("empNo"));
		String korN = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("korN"))));
		
		try {
			IroA320BG params = new IroA320BG();
			
			params.setDeskX(deskX);
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			
			params.setChecklistE(checklistE);
			params.setDecisionX(decisionX);
			params.setDecisionE(decisionE);
			params.setEmpNo(empNo);
			params.setKorN(korN);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String returnValue = sl.updIroA320CheckList(params);
			req.setAttribute("returnSend", returnValue);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA320Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroA320Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
	
	/** 
	  * Option Comparision Confirm Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/07/31 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dssStartDt = StringUtil.checkString(box.getString("pDssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("pSeqNum"));
		
		try {
			IroA320BG params = new IroA320BG();
			
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String returnValue = sl.updIroA320Confirm(params);
			req.setAttribute("returnConfirm", returnValue);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA320Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:IroA320Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask
	
	/** 
	  * MSG ϱ   ȸ Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/09/11 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dssStartDt = StringUtil.checkString(box.getString("pDssStartDt"));
		
		try {
			IroA320BG params = new IroA320BG();
			
			params.setDssStartDt(dssStartDt);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroA320MsgInfo(params);
			req.setAttribute("hashData", hashData);
			req.setAttribute("returnParam", "Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA320Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:IroA320Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask
}