package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;
import kal.base.sys.dbbean.*;

/**
 * IROPS Message Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/07/04 HIST  
 */
public class IroQ070Serv extends PublicBaseServlet{
	/** 
	  *  IROPS Message Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/04 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		String timeStmp = StringUtil.checkString(box.getString("timestmp"));						//ȸ
		String fltNum = StringUtil.checkString(box.getString("flt_num"));							//Flt Num
		String returnPage = StringUtil.checkString(box.getString("returnPage"));				//Return Page ȹ
		
		try {
			//EJB Parameter 
			IroQ070BG params = new IroQ070BG();
			params.setTimestmp(timeStmp);
			params.setFlt_num(fltNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroQ070Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("IROPS Message", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ070Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroQ070Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
	
	/** 
	  *  IRR/DSS Message Send Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/04 HIST  
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		// Parameter
		String firstLegFltDt = StringUtil.checkString(box.getString("p_first_leg_flt_dt"));		//First Leg Flt Dt
		String fltNum = StringUtil.checkString(box.getString("p_flt_num"));						//Flt Num
		String stnFr = StringUtil.checkString(box.getString("p_stnfr"));								//Station From
		String stnTo = StringUtil.checkString(box.getString("p_stnto"));							//Station To
		String seqNum = StringUtil.checkString(box.getString("p_seq_num"));					//Seq Number
		String optionNum = StringUtil.checkString(box.getString("p_option_num"));			//Option Number
		String decisionC = StringUtil.checkString(box.getString("p_decision_c"));			//Decision Code
		String decisionE = StringUtil.checkString(box.getString("p_decision_e"));			//Decision Desc
		String returnPage = StringUtil.checkString(box.getString("returnPage"));			//Return Page ȹ
		
		try {
			//EJB Parameter 
			IroA040BG params = new IroA040BG();
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setSeq_num(seqNum);
			params.setOption_num(optionNum);
			params.setDecision_c(StringUtil.toKSC5601(decisionC));
			params.setDecision_e(StringUtil.toKSC5601(decisionE));
			req.setAttribute("params",params);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroA070Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:IroA070Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end updateTask	
}//end of class

