package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.IroQ120BG;
import kal.base.iro.ejb.IroAllSL;

/**
 * Daily IROPS REPORT Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/02/03  
 */
public class IroQ120Serv extends PublicBaseServlet{
	/** 
	  * Daily IROPS REPORT Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03  
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String allDate = StringUtil.checkString(box.getString("all_date"));				//˻ ¥
		if(allDate.length()==6){ 	allDate = "20"+allDate;	}
		//String regionFlt = StringUtil.checkString(box.getString("region_flt"));		//Region
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));			//DOM/INT/CGO
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
				
		try {
			IroQ120BG params = new IroQ120BG();	
			params.setAll_date(allDate);
			params.setDom_int_x(domIntX);
			//params.setRegion_flt(regionFlt);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData  = sl.selIroQ120Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Daily IROPS REPORT", hashData, "DAILYIROPSINFO", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ120Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroQ120Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Daily IROPS REPORT Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01  
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String allDate = StringUtil.checkString(box.getString("all_date"));				//˻ ¥
		if(allDate.length()==6){ 	allDate = "20"+allDate;	}
		//String regionFlt = StringUtil.checkString(box.getString("region_flt"));		//Region
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));			//DOM/INT/CGO
		
		String[] hideY = req.getParameterValues("h_hide_y");
		String[] firstLegFltDt = req.getParameterValues("h_first_leg_flt_dt");
		String[] fltNum = req.getParameterValues("h_flt_num");
		String[] stnfr = req.getParameterValues("h_stnfr");
		String[] stnto = req.getParameterValues("h_stnto");
		String[] seqNum = req.getParameterValues("h_seq_num");
		String[] optionNum = req.getParameterValues("h_option_num");
					
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
				
		try {
			Hashtable hashParam = new Hashtable();
			List listData = new LinkedList();
			
			for (int i=0; i<hideY.length; i++) {
				IroQ120BG uparams = new IroQ120BG();	
				uparams.setHide_y(hideY[i]);
				uparams.setFirst_leg_flt_dt(firstLegFltDt[i]);
				uparams.setFlt_num(fltNum[i]);
				uparams.setStnfr(stnfr[i]);
				uparams.setStnto(stnto[i]);
				uparams.setSeq_num(seqNum[i]);
				uparams.setOption_num(optionNum[i]);
				listData.add(uparams);
			}
			hashParam.put("HASHDATA",listData);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			int returnValue = sl.updIroQ120Main(hashParam);
			if (returnValue == 1){
				//req.setAttribute("successMessage",ComUtil.getInstance().getMessage("IROPS REPORT", null, "", MessageCode.getInstance().UPDATE_MSG));
				IroQ120BG params = new IroQ120BG();	
				params.setAll_date(allDate);
				params.setDom_int_x(domIntX);

				Hashtable hashData  = sl.selIroQ120Main(params);
				if (hashData != null){
					req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Daily IROPS REPORT", hashData, "DAILYIROPSINFO", MessageCode.getInstance().DATA_MSG));
				}
				req.setAttribute("hashData",hashData);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ120Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:IroQ120Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask	
}
