package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;

/**
 * DSS Messenger Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/08/31  
 */
public class IroQ450Serv  extends PublicBaseServlet {
	/** 
	  * DSS Messenger ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/08/31 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String timestamp = StringUtil.checkString(box.getString("timestamp"));
		String title = StringUtil.toKSC5601(StringUtil.checkString(box.getString("title")));
		String gubun = StringUtil.checkString(box.getString("gubun"));
		
		try {
			IroQ450BG params = new IroQ450BG();
			
			params.setTimestamp(timestamp);
			params.setTitle(title);
			params.setGubun(gubun);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroQ450Main(params);
			
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("DSS Messenger", hashData, "MESSENGER_LIST", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData", hashData);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ450Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroQ450Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * DSS Messenger Է Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/09/10 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String mode = StringUtil.checkString(box.getString("mode")); //X, A, B
		String dssStartDt = StringUtil.checkString(box.getString("dssStartDt"));
		String msgNo = StringUtil.checkString(box.getString("msgNo"));
		String lvlNo = StringUtil.checkString(box.getString("lvlNo"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String schDepD = StringUtil.checkString(box.getString("schDepD"));
		String titleE = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("titleE"))));
		String msgE = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("msgE"))));
		
		String empNo = StringUtil.checkString(box.getString("empNo"));
		String korN = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("korN"))));
		String deskX = StringUtil.checkString(box.getString("deskX"));
		
		//20160108 ߰
		String dssLvlX = StringUtil.checkString(box.getString("dssLvlX"));
		
		try {
			IroQ450BG params = new IroQ450BG();
			
			params.setMode(mode);
			params.setDssStartDt(dssStartDt);
			params.setMsgNo(msgNo);
			params.setLvlNo(lvlNo);
			params.setFltNum(fltNum);
			params.setSchDepD(schDepD);
			params.setTitleE(titleE);
			params.setMsgE(msgE);
			
			params.setEmpNo(empNo);
			params.setKorN(korN);
			params.setDeskX(deskX);
			
			//20160108 ߰  REPLY  
			if("Y".equals(dssLvlX)) {
				params.setDssLvlXFlag("Y");
			}
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String returnParam = sl.insIroQ450Message(params);
			
			req.setAttribute("returnParam", returnParam);
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ450Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:IroQ450Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask
}
