package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.util.StringUtil;
import kal.base.iro.dbbean.IroQ450BG;
import kal.base.iro.ejb.IroAllSL;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;

/**
 *  ǻ Ϸ ˾ - REPLY
 * @version 	1.0
 * @author Copyright (c) 20160108 sunpark 
 */
public class IroQ457Serv  extends PublicBaseServlet {
	
	/** 
	  *  ǻ Ϸ ˾ - REPLY Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse 	Response Object
	  * @exception Exception
	  * @author Copyright (c) 20160108 sunpark
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);
		
		String dssStartDt = StringUtil.checkString(box.getString("dssStartDt"));
		String msgNo = StringUtil.checkString(box.getString("msgNo"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		System.out.println("dssStartDt : " + dssStartDt);
		System.out.println("msgNo : " + msgNo);
		System.out.println("returnPage : " + returnPage);
		
		try {
			IroQ450BG params = new IroQ450BG();
			
			params.setDssStartDt(dssStartDt);
			params.setMsgNo(msgNo);
			
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroQ450Message(params);
			//Hashtable hashData = new Hashtable(); 
					
			if(hashData != null) {
				hashData.put("dssStartDt", dssStartDt);
				hashData.put("msgNo", msgNo);
			}
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("returnParam", "Y");
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ457Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroQ457Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}
	
	/** 
	  *  ǻ Ϸ ˾ - REPLY Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 20160108 sunpark
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		String mode = StringUtil.checkString(box.getString("mode")); //X, A, B
		String dssStartDt = StringUtil.checkString(box.getString("dssStartDt"));
		String msgNo = StringUtil.checkString(box.getString("msgNo"));
		String lvlNo = StringUtil.checkString(box.getString("lvlNo"));
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String schDepD = StringUtil.checkString(box.getString("schDepD"));
		String titleE = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("titleE"))));
		String msgE = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("msgE"))));
		
		String empNo = StringUtil.checkString(box.getString("empNo"));
		String korN = StringUtil.DBInsStr(StringUtil.toKSC5601(StringUtil.checkString(box.getString("korN"))));
		String deskX = StringUtil.checkString(box.getString("deskX"));
		
		try {
			IroQ450BG params = new IroQ450BG();
			
			params.setMode(mode);
			params.setDssStartDt(dssStartDt);
			params.setMsgNo(msgNo);
			params.setLvlNo(lvlNo);
			params.setFltNum(fltNum);
			params.setSchDepD(schDepD);
			params.setTitleE(titleE);
			params.setMsgE(msgE);
			
			params.setEmpNo(empNo);
			params.setKorN(korN);
			params.setDeskX(deskX);
			
			params.setDssLvlXFlag("Y");
			
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String returnParam = sl.insIroQ450Message(params);
			
			req.setAttribute("returnParam", returnParam);
			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ457Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:IroQ457Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}
}
