package kal.base.iro.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.iro.dbbean.*;
import kal.base.iro.ejb.IroAllSL;

/**
 *   2 Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2009/09/03 
 */
public class IroQ465Serv  extends PublicBaseServlet {
	
	/** 
	  * AMEND NOTICE - Seq, Message ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/09/03 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dssStartDt = StringUtil.checkString(box.getString("dssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("seqNum"));
		String msgSeqNum = StringUtil.checkString(box.getString("msgSeqNum"));
		
		try {
			IroQ460BG params = new IroQ460BG();
			
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			params.setMsgSeqNum(msgSeqNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroQ460IropsMsg(params);
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("returnParam", "Y");
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ465Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:IroQ465Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
	/** 
	  * Message Send Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/09/03 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dssStartDt = StringUtil.checkString(box.getString("dssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("seqNum"));
		String message = StringUtil.checkString(box.getString("msg_all")).toUpperCase();
		
		String title_e = StringUtil.checkString(StringUtil.toKSC5601(box.getString("title_e")));//@2013-06-17
		String email_txt = StringUtil.checkString(box.getString("email_all"));//@2013-06-17

		try {
			IroA340BG params = new IroA340BG();
			
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			params.setMessage(message);
			
			params.setTitleE(title_e);//@2013-06-17
			params.setEmail_txt(email_txt);//@2013-06-17
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.insIroA340MsgSend(params);
			
			String msgSeqNum = "";
			String projectNo = "";
			if (hashData != null) {
				msgSeqNum = (String)hashData.get("MSG_SEQ_NUM");
				projectNo = (String)hashData.get("PROJECT_NO");
			}
			req.setAttribute("reMsgSeqNum", msgSeqNum);
			req.setAttribute("reProjectNo", projectNo);
			req.setAttribute("returnParam", "S");
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ465Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:IroQ465Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask
	
	/** 
	  * Processed Ȯ Servlet Class - performTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/09/03 
	  */	
	public void performTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String msgSeqNum = StringUtil.checkString(box.getString("reMsgSeqNum"));
		String projectNo = StringUtil.checkString(box.getString("reProjectNo"));
		
		String dssStartDt = StringUtil.checkString(box.getString("dssStartDt"));
		String seqNum = StringUtil.checkString(box.getString("seqNum"));
		
		try {
			IroA340BG params = new IroA340BG();
			
			params.setMsgSeqNum(msgSeqNum);
			params.setProjectNo(projectNo);
			
			params.setDssStartDt(dssStartDt);
			params.setSeqNum(seqNum);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			String returnParam = sl.updIroA340Processed(params);
			
			req.setAttribute("returnParam", "C");
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ465Serv:performTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"perform");
			} else {
				Logger.debug.println("[BASE:IroQ465Serv:performTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"perform");
			}
		} 
	}//end performTask
	
	/** 
	  * IROPS History Message Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/09/03 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dssStartDt = StringUtil.checkString(box.getString("dssStartDt"));
		
		try {
			IroQ460BG params = new IroQ460BG();
			
			params.setDssStartDt(dssStartDt);
			
			//EJB LookUp
			IroAllSL sl = (IroAllSL)EJBFinder.lookup("ejb/IroAllSL");
			Hashtable hashData = sl.selIroQ460HistoryMsg(params);
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("returnParam", "Y");
			
			//  
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:IroQ465Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:IroQ465Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
