package kal.base.not.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.not.dbbean.NotA110BG;
import kal.base.not.dbbean.NotQ010BG;
import kal.base.wea.ejb.WeaAllSL;
import kal.base.not.ejb.NotAllSL;

/**
 * New NOTAM List Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2007/08/31 
 */
public class NotA110Serv extends PublicBaseServlet {
	/** 
	  * New NOTAM List ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/08/31 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dtg_range = StringUtil.checkString(box.getString("dtg_range")); //2007.03.27 ߰
		
		String hid_rd_dtg = StringUtil.checkString(box.getString("hid_rd_dtg")); //2008.08.04 ߰
		String dtgFr = StringUtil.checkString(box.getString("dtgFr")) + StringUtil.checkString(box.getString("dtgFrTime")); //2008.08.04 ߰
		String dtgTo = StringUtil.checkString(box.getString("dtgTo")) + StringUtil.checkString(box.getString("dtgToTime")); //2008.08.04 ߰
		String c_stn = StringUtil.checkString(box.getString("c_stn")); //2008.08.04 ߰
		String c_status = StringUtil.checkString(box.getString("c_status")); //2008.08.04 ߰
		//20150318 ߰
		String s_text = StringUtil.checkString(box.getString("s_text"));
		String s_sort = StringUtil.checkString(box.getString("s_sort"));
		//@2017-07-17
		String page_id = StringUtil.checkString(box.getString("page_id"));
		System.out.println("NotA110Serv.selectTask================"+page_id);
		try {
			//2007.03.27 ߰
			NotA110BG params = new NotA110BG();
			params.setDtg_range(dtg_range);
			
			params.setHid_rd_dtg(hid_rd_dtg); //2008.08.04 ߰
			params.setDtgFr(dtgFr); //2008.08.04 ߰
			params.setDtgTo(dtgTo); //2008.08.04 ߰
			params.setC_stn(c_stn); //2008.08.04 ߰
			params.setC_status(c_status); //2008.08.04 ߰
			//20150318 ߰
			params.setS_text(s_text);
			params.setS_sort(s_sort);
			//@2017-07-17
			params.setPageId(page_id);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData  = sl.selNotA110Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("NOTAM List", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("dataComplete","S");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA110Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:NotA110Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * New NOTAM Detail ȸ Servlet Class - checkTask -- 
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/08/31 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    	//Box ü 
		String icaoPort = StringUtil.checkString(box.getString("icao_port"));			//ICAO PORT ȹ
		String notNum = StringUtil.checkString(box.getString("not_num"));			//NOT NUM ȹ
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//ȸ 
			NotA110BG params = new NotA110BG();
			params.setIcao_port(icaoPort);
			params.setNot_num(notNum);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			NotA110BG entity  = sl.selNotA110Detail(params);
			if (entity != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("NOTAM List", null, "", MessageCode.getInstance().SELECT_MSG));
			req.setAttribute("entity",entity);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA110Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:NotA110Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
	/** 
	  * New NOTAM Item  Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/08/31 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 							 //Box ü 
		
		String notFir = StringUtil.checkString(box.getString("not_fir"));
		String notQcd = StringUtil.checkString(box.getString("not_qcd"));
		
		//String notTraf = StringUtil.checkString(box.getString("not_traf"));
		String notTraf = ""; //2007.09.06 
		if (StringUtil.checkString(box.getString("traf_I")).equals("Y")) notTraf = notTraf + "I";
		if (StringUtil.checkString(box.getString("traf_V")).equals("Y")) notTraf = notTraf + "V";
		
		//String notPurp = StringUtil.checkString(box.getString("not_purp"));
		String notPurp = ""; //2007.09.06 
		if (StringUtil.checkString(box.getString("purp_N")).equals("Y")) notPurp = notPurp + "N";
		if (StringUtil.checkString(box.getString("purp_B")).equals("Y")) notPurp = notPurp + "B";
		if (StringUtil.checkString(box.getString("purp_O")).equals("Y")) notPurp = notPurp + "O";
		if (StringUtil.checkString(box.getString("purp_M")).equals("Y")) notPurp = notPurp + "M";
		
		//String notScop = StringUtil.checkString(box.getString("not_scop"));
		String notScop = ""; //2007.09.06 
		if (StringUtil.checkString(box.getString("scop_A")).equals("Y")) notScop = notScop + "A";
		if (StringUtil.checkString(box.getString("scop_E")).equals("Y")) notScop = notScop + "E";
		if (StringUtil.checkString(box.getString("scop_W")).equals("Y")) notScop = notScop + "W";
		
		String notLow = StringUtil.checkString(box.getString("not_low"));
		String notUpp = StringUtil.checkString(box.getString("not_upp"));
		String notLat_lon = StringUtil.checkString(box.getString("not_lat_lon"));
		
		String icaoPort = StringUtil.checkString(box.getString("icao_port"));
		String notNum = StringUtil.checkString(box.getString("not_num"));
		
		//String notCat = StringUtil.checkString(box.getString("not_cat")); 2005.08.03 
		String notCat = ""; //2007.09.06 
		if (StringUtil.checkString(box.getString("cat_N")).equals("Y")) notCat = "N";
		if (StringUtil.checkString(box.getString("cat_R")).equals("Y")) notCat = "R";
		if (StringUtil.checkString(box.getString("cat_C")).equals("Y")) notCat = "C";
		
		String notOld_num = StringUtil.checkString(box.getString("not_old_num"));
		String notIss_dt = StringUtil.checkString(box.getString("not_iss_dt"));
		String notExp_dt = StringUtil.checkString(box.getString("not_exp_dt"));
		
		String notEst = ""; //2007.09.06 ߰
		if (StringUtil.checkString(box.getString("est_Y")).equals("Y")) notEst = "Y";
		else notEst = "N";
		
		String notValid = StringUtil.checkString(box.getString("not_valid")).toUpperCase();
		
		String notCls = ""; //2007.09.06 ߰
		/*
		if (StringUtil.checkString(box.getString("cls_RWY")).equals("Y")) notCls = "RWY";
		if (StringUtil.checkString(box.getString("cls_TWY")).equals("Y")) notCls = "TWY";
		if (StringUtil.checkString(box.getString("cls_ILS")).equals("Y")) notCls = "ILS";
		if (StringUtil.checkString(box.getString("cls_LGT")).equals("Y")) notCls = "LGT";
		if (StringUtil.checkString(box.getString("cls_AGA")).equals("Y")) notCls = "AGA";
		if (StringUtil.checkString(box.getString("cls_COM")).equals("Y")) notCls = "COM";
		if (StringUtil.checkString(box.getString("cls_RAC")).equals("Y")) notCls = "RAC";
		if (StringUtil.checkString(box.getString("cls_WARN")).equals("Y")) notCls = "WARN";
		if (StringUtil.checkString(box.getString("cls_AIP")).equals("Y")) notCls = "AIP";
		if (StringUtil.checkString(box.getString("cls_OTHR")).equals("Y")) notCls = "OTHR";
		*/
		//2009.11.10  : Category ȭ
		if (StringUtil.checkString(box.getString("cls_n_RWY")).equals("Y")) notCls = "RWY";
		if (StringUtil.checkString(box.getString("cls_n_RWY_LGT")).equals("Y")) notCls = "RWY LGT";
		if (StringUtil.checkString(box.getString("cls_n_TWY")).equals("Y")) notCls = "TWY";
		if (StringUtil.checkString(box.getString("cls_n_TWY_LGT")).equals("Y")) notCls = "TWY LGT";
		if (StringUtil.checkString(box.getString("cls_n_RAMP")).equals("Y")) notCls = "RAMP";
		if (StringUtil.checkString(box.getString("cls_n_NAVAID")).equals("Y")) notCls = "NAVAID";
		if (StringUtil.checkString(box.getString("cls_n_DEP")).equals("Y")) notCls = "DEP";
		if (StringUtil.checkString(box.getString("cls_n_APP")).equals("Y")) notCls = "APP";
		if (StringUtil.checkString(box.getString("cls_n_APP_LGT")).equals("Y")) notCls = "APP LGT";
		if (StringUtil.checkString(box.getString("cls_n_COMM")).equals("Y")) notCls = "COMM";
		if (StringUtil.checkString(box.getString("cls_n_CHRT")).equals("Y")) notCls = "CHRT";
		if (StringUtil.checkString(box.getString("cls_n_ARPT")).equals("Y")) notCls = "ARPT";
		if (StringUtil.checkString(box.getString("cls_n_OBST")).equals("Y")) notCls = "OBST";
		if (StringUtil.checkString(box.getString("cls_n_GPS")).equals("Y")) notCls = "GPS";
		if (StringUtil.checkString(box.getString("cls_n_AIRWAY")).equals("Y")) notCls = "AIRWAY";
		if (StringUtil.checkString(box.getString("cls_n_AIRSPACE")).equals("Y")) notCls = "AIRSPACE";
		if (StringUtil.checkString(box.getString("cls_n_OTHER")).equals("Y")) notCls = "OTHER";
		if (StringUtil.checkString(box.getString("cls_n_AIP")).equals("Y")) notCls = "AIP";
		
		//String notOpen_y = StringUtil.checkString(box.getString("not_open_y"));
		/*String notOpen_y = ""; //2007.09.06 
		if (StringUtil.checkString(box.getString("hid_not_open")).equals("Y")) notOpen_y = "Y";
		else notOpen_y = "N";*/
		//2008.08.04  : OPEN -> STATUS
		String prevNotStatus = StringUtil.checkString(box.getString("prev_not_status"));
		String notStatus = StringUtil.checkString(box.getString("not_status"));
		
		String notSig_y = ""; //2007.09.06 ߰
		if (StringUtil.checkString(box.getString("hid_not_sig")).equals("Y")) notSig_y = "Y";
		else notSig_y = "N";
		
		String notText = StringUtil.checkString(box.getString("not_text")).toUpperCase();
		String notCommnt = StringUtil.checkString(box.getString("not_commnt")).toUpperCase();
		
		String notRemarks = StringUtil.toKSC5601(StringUtil.checkString(box.getString("not_remarks"))).toUpperCase(); //2008.08.05 ߰, 2008.12.09  : ѱó
		
		String notTyp = StringUtil.checkString(box.getString("not_typ")); //2005.11.16 
		
		String notDayFr = StringUtil.checkString(box.getString("not_day_fr")); //2009.11.09 ߰
		String notDayTo = StringUtil.checkString(box.getString("not_day_to")); //2009.11.09 ߰
		
		String notEms    = StringUtil.checkString(box.getString("not_ems")); //2011.08.18 ߰
		
		//20150319 ߰
		String notFollow    = StringUtil.checkString(box.getString("hid_not_follow"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			NotA110BG params = new NotA110BG();
			
			params.setMode("update");
			params.setNot_fir(notFir);
			params.setNot_qcd(notQcd);
			params.setNot_traf(notTraf);
			params.setNot_purp(notPurp);
			params.setNot_scop(notScop);
			params.setNot_low(notLow);
			params.setNot_upp(notUpp);
			params.setNot_lat_lon(notLat_lon);
			params.setIcao_port(icaoPort);
			params.setNot_num(notNum);
			params.setNot_cat(notCat); //2005.08.03 
			params.setNot_old_num(notOld_num);
			params.setNot_iss_dt(notIss_dt);
			params.setNot_exp_dt(notExp_dt);
			params.setNot_exp_est(notEst); //2007.09.06 ߰
			params.setNot_valid(notValid);
			params.setNot_cls(notCls); //2007.09.06 ߰
			
			//params.setNot_open_y(notOpen_y); 2008.08.04 
			params.setPrev_not_status(prevNotStatus); //2008.08.04 ߰
			params.setNot_status(notStatus); //2008.08.04 ߰
			
			params.setNot_sig(notSig_y); //2007.09.06 ߰
			params.setNot_text(notText);
			params.setNot_commnt(notCommnt);
			
			params.setNot_remarks(notRemarks); //2008.08.05 ߰
			
			params.setUserid(UserInfo.getEmp_no());
			params.setNot_typ(notTyp); //2005.11.16 
			
			params.setNot_day_fr(notDayFr); //2009.11.09 ߰
			params.setNot_day_to(notDayTo); //2009.11.09 ߰
			
			params.setLog_y("N"); //2007.10.04 ߰
			
			params.setCoad_y("N"); //2007.12.17 ߰
			
			params.setNot_ems(notEms);
			
			//20150319 ߰
			params.setNot_follow(notFollow);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean updFlag = sl.updNotA110Main(params);
			//req.setAttribute("notOpenY",notOpen_y); 2008.08.04 .
			//req.setAttribute("notInput","M"); 2008.08.11 .
			req.setAttribute("notStatus",notStatus); //2008.08.11 ߰
			req.setAttribute("userID",UserInfo.getEmp_no());
			req.setAttribute("notEms",notEms);//2011.08.17 ߰
			req.setAttribute("dataComplete","U");
			
			//20150324 ߰
			req.setAttribute("notFollow", "Y".equals(notFollow) ? "F" : "");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA110Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:NotA110Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask		
	
	/** 
	  * New NOTAM Item  Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/08/31 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										   			 //Box ü 
		
		String icaoPort = StringUtil.checkString(box.getString("icao_port"));				//ICAO PORT ȹ
		String notNum = StringUtil.checkString(box.getString("not_num"));				//NOT NUM ȹ
		
		String prevNotStatus = StringUtil.checkString(box.getString("prev_not_status")); //2008.08.06 ߰
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//Parameter 
			NotA110BG params = new NotA110BG();
			params.setIcao_port(icaoPort);
			params.setNot_num(notNum);
			
			params.setPrev_not_status(prevNotStatus); //2008.08.06 ߰
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean delFlag = sl.delNotA110Item(params);
			//req.setAttribute("notInput","D"); 2008.08.11 .
			req.setAttribute("notStatus","X"); //2008.08.11 ߰
			req.setAttribute("dataComplete","D");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA110Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:NotA110Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask		
	
	/** 
	  * New NOTAM List Send Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2006/02/02 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    		//Box ü 
		
		/*****************************************************************
			Data Mode
			1 : NOTAM NBR Է
			2 : FLT Է
			3 : DEP Է ARR Է (FLT Է)
			4 : STATION, AREA CODE 																									
		*****************************************************************/
		
		String mode = "1";
		
		//Search by FLT
		String fltNum = "";
		String depStn = "";
		String arrStn = "";
		String rteId = "";
		
		//Search by Station
		String notStn = StringUtil.checkString(box.getString("icao_port"));
		String areaCd = "";
		String notNum = StringUtil.checkString(box.getString("not_num"));
		
		//Option
		String trafI = "";
		String trafV = "";
		
		String purpN = "";
		String purpB = "";
		String purpO = "";
		String purpM = "";
		
		String scopA = "";
		String scopE = "";
		String scopW = "";
		
		String notRdo = "";
		String notPeriod = "";
		String notIssDt = "";
		String notIssTm = "";
		String notExpDt = "";
		String notExpTm = "";
		
		/* 2009.11.12  : Category ȭ
		String clsRWY = "";
		String clsTWY = "";
		String clsILS = "";
		String clsLGT = "";
		String clsAGA = "";
		String clsCOM = "";
		String clsRAC = "";
		String clsWARN = "";
		String clsAIP = "";
		String clsOTHR = "";
		*/
		String clsnRWY = ""; 
		String clsnRWYLGT = ""; 
		String clsnTWY = ""; 
		String clsnTWYLGT = ""; 
		String clsnRAMP = ""; 
		String clsnNAVAID = ""; 
		String clsnDEP = ""; 
		String clsnAPP = ""; 
		String clsnAPPLGT = ""; 
		String clsnCOMM = ""; 
		String clsnCHRT = ""; 
		String clsnARPT = ""; 
		String clsnOBST = ""; 
		String clsnGPS = ""; 
		String clsnAIRWAY = ""; 
		String clsnAIRSPACE = ""; 
		String clsnOTHER = ""; 
		String clsnAIP = ""; 
		
		String notSig = "";
		
		String typNOTAM = "";
		String typCOADZ = "";
		String typSNOWTAM = "";
		
		String notCommnt = "";
			
		//Message Send Params
		String emailTxt = StringUtil.checkString(box.getString("email_txt"));
		String sitaTxt = StringUtil.checkString(box.getString("sita_txt"));
		String aftnTxt = StringUtil.checkString(box.getString("aftn_txt"));
		String acarsTxt = StringUtil.checkString(box.getString("acars_txt"));
		String faxTxt = StringUtil.checkString(box.getString("fax_txt"));
		String senderTxt = StringUtil.checkString(box.getString("sender_txt"));
		String originTxt = StringUtil.checkString(box.getString("origin_txt"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		HttpSession session = req.getSession();
		
		try {				
			//Parameter 
			NotQ010BG params = new NotQ010BG();			
			
			params.setMode(mode);
			
			params.setFlt_num(fltNum);
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setRte_id(rteId);
			
			params.setNot_stn(notStn);
			params.setArea_cd(areaCd);
			params.setNot_num(notNum);
			
			params.setTrafI(trafI);
			params.setTrafV(trafV);
			
			params.setPurpN(purpN);
			params.setPurpB(purpB);
			params.setPurpO(purpO);
			params.setPurpM(purpM);
			
			params.setScopA(scopA);
			params.setScopE(scopE);
			params.setScopW(scopW);
			
			params.setNot_rdo(notRdo); // P : Valid Combo , T : From ~ To 
			params.setNot_period(notPeriod);
			params.setNot_iss_dt(notIssDt);
			params.setNot_iss_tm(notIssTm);
			params.setNot_exp_dt(notExpDt);
			params.setNot_exp_tm(notExpTm);
			
			/*
			params.setClsRWY(clsRWY);
			params.setClsTWY(clsTWY);
			params.setClsILS(clsILS);
			params.setClsLGT(clsLGT);
			params.setClsAGA(clsAGA);
			params.setClsCOM(clsCOM);
			params.setClsRAC(clsRAC);
			params.setClsWARN(clsWARN);
			params.setClsAIP(clsAIP);
			params.setClsOTHR(clsOTHR);
			*/
			params.setClsnRWY(clsnRWY);
			params.setClsnRWYLGT(clsnRWYLGT);
			params.setClsnTWY(clsnTWY);
			params.setClsnTWYLGT(clsnTWYLGT);
			params.setClsnRAMP(clsnRAMP);
			params.setClsnNAVAID(clsnNAVAID);
			params.setClsnDEP(clsnDEP);
			params.setClsnAPP(clsnAPP);
			params.setClsnAPPLGT(clsnAPPLGT);
			params.setClsnCOMM(clsnCOMM);
			params.setClsnCHRT(clsnCHRT);
			params.setClsnARPT(clsnARPT);
			params.setClsnOBST(clsnOBST);
			params.setClsnGPS(clsnGPS);
			params.setClsnAIRWAY(clsnAIRWAY);
			params.setClsnAIRSPACE(clsnAIRSPACE);
			params.setClsnOTHER(clsnOTHER);
			params.setClsnAIP(clsnAIP);
			
			params.setNotSig(notSig);
			
			params.setTypNOTAM(typNOTAM);
			params.setTypCOADZ(typCOADZ);
			params.setTypSNOWTAM(typSNOWTAM);
			
			params.setNot_commnt(notCommnt);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selNotQ010Main(params);
			
			if (hashData != null) {
				NotQ010BG sendParam = new NotQ010BG();
				sendParam.setMode(mode);
				sendParam.setFlt_num(fltNum);
				sendParam.setNot_num(notNum);
				sendParam.setDep_stn(depStn);
				sendParam.setArr_stn(arrStn);
				sendParam.setRte_id(rteId);
				sendParam.setArea_cd(areaCd);
				sendParam.setNot_stn(notStn);
					
				sendParam.setEmail_txt(emailTxt);
				sendParam.setSita_txt(sitaTxt);
				sendParam.setAftn_txt(aftnTxt);
				sendParam.setAcars_txt(acarsTxt);
				sendParam.setFax_txt(faxTxt);
				sendParam.setSender_txt(senderTxt);
				sendParam.setOrigin_txt(originTxt);
										
				boolean wxFlag = sl.sendNotamReq(sendParam,hashData);
				if (wxFlag) req.setAttribute("dataComplete","S");
				else throw new Exception(" ");
					
			} else throw new Exception(" ");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA110Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:NotA110Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask	
}
