package kal.base.not.serv;

import java.rmi.RemoteException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.StringUtil;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.not.dbbean.NotA110BG;
import kal.base.not.dbbean.NotA130BG;
import kal.base.not.ejb.NotAllSL;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;

/**
 * 20150323 ߰
 * sunpark
 */
public class NotA131Serv extends PublicBaseServlet {
	
	/** 
	  * 20150323 ߰
	  * multi update
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		String not_status = StringUtil.checkString(box.getString("notStatus"));
		String key_str = StringUtil.checkString(box.getString("keyStr"));
		
		HttpSession session = req.getSession();
		
		try {
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			NotA130BG params = new NotA130BG();

			params.setNot_status(not_status);
			params.setKey_str(key_str);
			
			params.setUserid(UserInfo.getEmp_no());
			
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean updFlag = sl.updNotA131Main(params);
			
			req.setAttribute("userID",UserInfo.getEmp_no());
			req.setAttribute("dataComplete","U");
			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA131Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:NotA131Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask	
	
	/** 
	  * 20150323 ߰
	  * multi delete
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		String key_str = StringUtil.checkString(box.getString("keyStr"));
		
		try {
			NotA130BG params = new NotA130BG();
			params.setKey_str(key_str);
			
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean delFlag = sl.delNotA131Item(params);

			req.setAttribute("dataComplete","D");
			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA131Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:NotA131Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask		
}
