package kal.base.not.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.not.dbbean.*;
import kal.base.not.ejb.NotAllSL;

/**
 * NOTAM TRACING Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2007/09/12 
 */
public class NotA150Serv extends PublicBaseServlet {
	/** 
	  * NOTAM TRACING AREA CD ȸ - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/17 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			NotA150BG params = new NotA150BG();
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData  = sl.selArea();
			
			req.setAttribute("hashData",hashData);
			req.setAttribute("area","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA150Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:NotA150Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end Check Task
	
	/** 
	  * NOTAM TRACING Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/12 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String start_date = StringUtil.checkString(box.getString("start_date"));        //Fr date
		String start_date2 = "";
		if (start_date.length() == 6) {
			start_date2 = StringUtil.addDays("20"+start_date,-60,1).substring(2,8);
		}
		String end_date = StringUtil.checkString(box.getString("end_date"));		//ToDate;
		String station = StringUtil.checkString(box.getString("station"));			//Station
		String area = StringUtil.checkString(box.getString("area"));			//Area
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
	
		try {
			
			NotA150BG params = new NotA150BG();
			params.setStart_date(start_date);
			params.setCat_station(station);
			params.setStart_date2(start_date2); //start_date -60
			params.setEnd_date(end_date);
			params.setCat_Area_Value(area);
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData  = sl.selTracingList(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("NOTAM Tracing", hashData, "NOTAMTRACING", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
	
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA150Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:NotA150Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
