package kal.base.not.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.not.dbbean.*;
import kal.base.not.ejb.NotAllSL;

/**
 * Group Address  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2007/09/12 
 */
public class NotA670Serv extends PublicBaseServlet {
	/** 
	 * Group Address ȸ Servlet Class - selectTask
	 * @param req HttpServletRequest  	Request Object
	 * @param res HttpServletResponse  	Response Object
	 * @exception Exception
	 * @author Copyright (c) 2007/09/12 
	 */
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String name = StringUtil.checkString(box.getString("name"));                   //Name
		String network = StringUtil.checkString(box.getString("network"));				//NetWork
		String address = StringUtil.checkString(box.getString("address"));			//Address
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		//20140903 FFS    ȸϵ ߰
		String isFfs = StringUtil.checkString(box.getString("isFfs"));
		String ffsStnfr = StringUtil.checkString(box.getString("ffsStnfr"));
		String isFirst = StringUtil.checkString(box.getString("isFirst"));
		
		try {
			NotA670BG params = new NotA670BG();
			
			params.setGroup_c(name);
			params.setAddr_e(address);
			params.setNetwork_x(network);
			//20140903 FFS    ȸϵ ߰
			params.setIsFfs(isFfs);
			params.setFfsStnfr(ffsStnfr);
			params.setIsFirst(isFirst);
						
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData  = sl.selGrpAddrList(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Group Address List", hashData, "GROUPADDRESS", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA670Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:NotA670Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	 * Group Address  Servlet Class - deleteTask
	 * @param req HttpServletRequest  	Request Object
	 * @param res HttpServletResponse  	Response Object
	 * @exception Exception
	 * @author Copyright (c) 2007/09/12 
	 */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String name = StringUtil.checkString(box.getString("name"));                   //Name
		String network = StringUtil.checkString(box.getString("network"));				//NetWork
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
				
		try {
			NotA670BG params = new NotA670BG();
			
			params.setGroup_c(name);
			params.setNetwork_x(network);
				
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean returnValue = sl.delGrpAddrList(params);
			if (returnValue) {
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Group Address Delete", null, "", MessageCode.getInstance().DELETE_MSG));
				/*
				params.setGroup_c("");
				params.setAddr_e("");
				params.setNetwork_x("");
				
				Hashtable hashData = sl.selGrpAddrList(params);
				req.setAttribute("hashData",hashData);
				*/
				req.setAttribute("returnValue", "D");
				
			}else{
				req.setAttribute("errorMessage",MessageCode.getInstance().DELETE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
				
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA670Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:NotA670Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask
		
	/** 
	 * Group Address  Servlet Class - updateTask
	 * @param req HttpServletRequest  	Request Object
	 * @param res HttpServletResponse  	Response Object
	 * @exception Exception
	 * @author Copyright (c) 2007/09/12 
	 */
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception{
			
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String name = StringUtil.checkString(box.getString("name"));                   //Name
		String network = StringUtil.checkString(box.getString("network"));				//NetWork
		String address = StringUtil.checkString(box.getString("address"));			//Address
		
		String updChk = StringUtil.checkString(box.getString("updChk")); //2008.01.02 ߰
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			NotA670BG params = new NotA670BG();
			
			params.setGroup_c(name);
			params.setAddr_e(address);
			params.setNetwork_x(network);
			
			params.setUpdChk(updChk); //2008.01.02 ߰
		
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			String returnValue = sl.updGrpAddrList(params);
			if (returnValue.equals("U") || returnValue.equals("I")) {
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Group Address Update", null, "", MessageCode.getInstance().UPDATE_MSG));
				Hashtable hashData = sl.selGrpAddrList(params);
				req.setAttribute("hashData",hashData);
			
			} else if (returnValue.equals("C")) {
				Hashtable hashData = sl.selGrpAddrList(params);
				req.setAttribute("hashData",hashData);
				req.setAttribute("returnValue", "C");
				
			} else if (returnValue.equals("N")) {
				req.setAttribute("errorMessage",MessageCode.getInstance().UPDATE_MSG);
			}
								
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA670Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:NotA670Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}// end of updateTask
	
	/** 
	 * Acars Regno ȸ Servlet Class - checkTask
	 * @param req HttpServletRequest  	Request Object
	 * @param res HttpServletResponse  	Response Object
	 * @exception Exception
	 * @author Copyright (c) 2007/10/16 
	 */
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			NotA670BG params = new NotA670BG();
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selAcarsRegnoList(params);
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA670Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:NotA670Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
}
