package kal.base.not.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.not.dbbean.*;
import kal.base.not.ejb.NotAllSL;

/**
 * AMS Message List Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2007/09/12 
 */
public class NotA810Serv extends PublicBaseServlet {
	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
			
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String cat_notam = StringUtil.checkString(box.getString("cat_notam"));                   //NOTAMȸ
		String cat_snowTam = StringUtil.checkString(box.getString("cat_snowTam"));
		String cat_tdm = StringUtil.checkString(box.getString("cat_tdm"));
		String cat_ats = StringUtil.checkString(box.getString("cat_ats"));
		String cat_pos = StringUtil.checkString(box.getString("cat_pos"));
		String cat_mvt = StringUtil.checkString(box.getString("cat_mvt"));
		String cat_text = StringUtil.checkString(box.getString("cat_text"));
		String cat_wx = StringUtil.checkString(box.getString("cat_wx"));
		String cat_origin = StringUtil.checkString(box.getString("cat_origin"));
		
		String dtgFr = StringUtil.checkString(box.getString("dtgFr"));
		String dtgFrTime = StringUtil.checkString(box.getString("dtgFrTime"));
		
		if (!dtgFr.equals("")) dtgFr = dtgFr + dtgFrTime;
		
		String dtgTo = StringUtil.checkString(box.getString("dtgTo"));
		String dtgToTime = StringUtil.checkString(box.getString("dtgToTime"));
		
		if (!dtgTo.equals("")) dtgTo = dtgTo + dtgToTime;
		
		String keyword = StringUtil.checkString(box.getString("keyword"));
		String cat_in = StringUtil.checkString(box.getString("cat_in"));
		String cat_out = StringUtil.checkString(box.getString("cat_out"));
		String cat_all = StringUtil.checkString(box.getString("cat_all"));
		
		String sea_ref = StringUtil.checkString(box.getString("sea_ref")); //2007.09.19 ߰
		String dtg_range = StringUtil.checkString(box.getString("dtg_range")); //2007.09.19 ߰
		
		String status_p = StringUtil.checkString(box.getString("status_p")); //2008.12.10 ߰
		String status_d = StringUtil.checkString(box.getString("status_d")); //2008.12.10 ߰
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
			
		try {
			NotA810BG params = new NotA810BG();
			
			params.setCat_notam(cat_notam);
			params.setCat_snowTam(cat_snowTam);
			params.setCat_tdm(cat_tdm);
			params.setCat_ats(cat_ats);
			params.setCat_pos(cat_pos);
			params.setCat_mvt(cat_mvt);
			params.setCat_text(cat_text);
			params.setCat_wx(cat_wx);
			params.setCat_Origin(cat_origin);
			params.setDtgFr(dtgFr);
			params.setDtgTo(dtgTo);
			params.setKeyword(keyword);
			params.setCat_in(cat_in);
			params.setCat_out(cat_out);
			params.setCat_all(cat_all);
			
			params.setSea_ref(sea_ref);
			params.setDtg_range(dtg_range);
			
			params.setStatus_p(status_p); //2008.12.10 ߰
			params.setStatus_d(status_d); //2008.12.10 ߰
					
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData  = sl.selAmsMsgList(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("AMS Message List", hashData, "AMSMSG", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA810Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:NotA810Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/**
	 * AMS Message Send Servlet Class
	 * @version 	1.0
	 * @author Copyright (c) 2007/09/12 
	 */		
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
			
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String content = StringUtil.checkString(box.getString("content"));
		
		//Message Send Params
		String emailTxt = StringUtil.checkString(box.getString("email_txt"));
		String sitaTxt = StringUtil.checkString(box.getString("sita_txt"));
		String aftnTxt = StringUtil.checkString(box.getString("aftn_txt"));
		String acarsTxt = StringUtil.checkString(box.getString("acars_txt"));
		String faxTxt = StringUtil.checkString(box.getString("fax_txt"));
		String senderTxt = StringUtil.checkString(box.getString("sender_txt"));
		String originTxt = StringUtil.checkString(box.getString("origin_txt"));
		
		//20151021 UMS  ߰ 
		//String msg_dt = StringUtil.checkString(box.getString("msg_dt"));
		//String msg_seq = StringUtil.checkString(box.getString("msg_seq"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			
			NotA810BG sendParam = new NotA810BG();
			
			sendParam.setContent(content);	
			
			sendParam.setEmail_txt(emailTxt);
			sendParam.setSita_txt(sitaTxt);
			sendParam.setAftn_txt(aftnTxt);
			sendParam.setAcars_txt(acarsTxt);
			sendParam.setFax_txt(faxTxt);
			sendParam.setSender_txt(senderTxt);
			sendParam.setOrigin_txt(originTxt);
			
			//20151021 UMS  ߰
			//sendParam.setContentURL("msg_dt=" + msg_dt + "&msg_seq=" + msg_seq + "&flg=1");
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean wxFlag = sl.sendAmsMsg(sendParam);
			
			if (wxFlag) req.setAttribute("dataComplete","S");
			else throw new Exception(" ");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if (e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA810Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:NotA810Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask	
	
	/**
	 * AMS Message Remark Update Servlet Class
	 * @version 	1.0
	 * @author Copyright (c) 2008/12/15 
	 */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
			
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String msg_dt = StringUtil.checkString(box.getString("msg_dt"));
		String msg_seq = StringUtil.checkString(box.getString("msg_seq"));
		String remark = StringUtil.toKSC5601(StringUtil.checkString(box.getString("remark")));
		String status = StringUtil.checkString(box.getString("status"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			
			NotA810BG params = new NotA810BG();
			
			params.setMsg_dt(msg_dt);
			params.setSeq(msg_seq);
			params.setRemark(remark);
			params.setStatus(status);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			boolean returnFlg = sl.updRemarkStatus(params);
			
			if (returnFlg) req.setAttribute("dataComplete","U");
			else throw new Exception("Ʈ ");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if (e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotA810Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:NotA810Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask	
}