package kal.base.not.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.not.dbbean.*;
import kal.base.not.ejb.NotAllSL;
import kal.base.wea.ejb.WeaAllSL;

/**
 * New NOTAM Request Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2007/09/10 
 */
public class NotQ010Serv extends PublicBaseServlet {
	
	/** 
	  * FLT NBR ư Ŭ, VIEW Ŭ  2 ̻϶ ȸ Servlet Class - performTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/10 
	  */		
	public void performTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		
		String flt_num = StringUtil.checkString(box.getString("fltNum")).toUpperCase();
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));					//Return Page ȹ
		
		try {
			//Parameter 
			NotQ010BG params = new NotQ010BG();
			params.setFlt_num(flt_num);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selNotQ010FplList(params);
			
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnFpl","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotQ010Serv:performTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"perform");
			} else {
				Logger.debug.println("[BASE:NotQ010Serv:performTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"perform");
			}
		} 
	}//end of function	
		
	/** 
	  * 1. New NOTAM Request Route Id ȸ (DEP, ARR Է½)
	  * 2. VIEW Ŭ  2϶  1 Ҷ ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/11 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    		//Box ü 
		
		String fltNum = StringUtil.checkString(box.getString("flt_num_hid")).toUpperCase();		//FLT NUM
		String depStn = StringUtil.checkString(box.getString("dep_hid")).toUpperCase();		//DEP Station
		String arrStn = StringUtil.checkString(box.getString("arr_hid")).toUpperCase();			//ARR Station
		
		String etd = StringUtil.checkString(box.getString("etd_hid")); //2009.11.17 ߰
		String eta = StringUtil.checkString(box.getString("eta_hid")); //2009.11.17 ߰
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));					//Return Page ȹ
		
		try {			
			//Parameter 
			NotQ010BG params = new NotQ010BG();
			
			params.setFlt_num(fltNum);
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selNotQ010RteCd(params);
			
			String selVal = "";
			String chkF = "";
			String etopsY = "";
			if (hashData != null) {
				selVal = (String)hashData.get("SELVAL");
				chkF = (String)hashData.get("CHKF");
				etopsY = (String)hashData.get("ETOPSY");
			}
			
			req.setAttribute("hashData", hashData);
			req.setAttribute("selVal", selVal);
			req.setAttribute("chkF", chkF);
			req.setAttribute("etopsY", etopsY);
			
			//VIEW  2 1  ʿ
			req.setAttribute("depStn", depStn);
			req.setAttribute("arrStn", arrStn);
			req.setAttribute("returnValue","B");
			
			req.setAttribute("etd", etd); //2009.11.17 ߰
			req.setAttribute("eta", eta); //2009.11.17 ߰
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:NotQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/** 
	  * New NOTAM Request VIEW ϱ FLT NBR ִ  DEP,ARR,ROUTE,ETOPS Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/11 
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String flt_num = StringUtil.checkString(box.getString("flt_num")).toUpperCase();
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//Parameter 
			NotQ010BG params = new NotQ010BG();
			params.setFlt_num(flt_num);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selNotQ010DepArrRte(params);
			
			String selVal = "";
			String depStn = "";
			String arrStn = "";
			String chkF = "";
			String etopsY = "";
			
			String etd = ""; //2009.11.17 ߰
			String eta = ""; //2009.11.17 ߰
			
			if (hashData != null) {
				selVal = (String)hashData.get("SELVAL");
				depStn = (String)hashData.get("DEPSTN");
				arrStn = (String)hashData.get("ARRSTN");
				chkF = (String)hashData.get("CHKF");
				etopsY = (String)hashData.get("ETOPSY");
				
				etd = (String)hashData.get("ETD"); //2009.11.17 ߰
				eta = (String)hashData.get("ETA"); //2009.11.17 ߰
			}
			
			req.setAttribute("hashData",hashData);
			req.setAttribute("selVal",selVal);
			req.setAttribute("depStn",depStn);
			req.setAttribute("arrStn",arrStn);
			req.setAttribute("chkF", chkF);
			req.setAttribute("etopsY",etopsY);
			
			req.setAttribute("etd",etd); //2009.11.17 ߰
			req.setAttribute("eta",eta); //2009.11.17 ߰
			
			req.setAttribute("returnValue","A");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotQ010Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:NotQ010Serv:checkTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end of checkTask
	
	/** 
	  * Route and ETOPS Confirm ȭ Route, ETOPS APO ȸ Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/11/17 
	  */		
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 											//Box ü 
		
		String depStn = StringUtil.checkString(box.getString("depStn"));
		String arrStn = StringUtil.checkString(box.getString("arrStn"));
		
		String selRteCd = StringUtil.checkString(box.getString("selRteCd")); //2009.12.29 ߰
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//Parameter 
			NotQ010BG params = new NotQ010BG();
			
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setRte_id(selRteCd);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selNotQ010RouteEtops(params);
			
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnValue","Y");
			
			req.setAttribute("rteId", selRteCd); //2009.12.29 ߰
			
			//  	
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotQ010Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:NotQ010Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end of insertTask
}
