package kal.base.not.serv;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.OutputStreamWriter;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.db.ConnectionResource;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.db.ToolConnectionResource;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.not.dbbean.*;
import kal.base.not.ejb.NotAllSL;
import kal.base.not.query.NotQ010Query;

/**
 * New NOTAM Request Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2007/09/11 
 */
public class NotQ015Serv extends PublicBaseServlet {
		
	/** 
	  * New NOTAM Request VIEW ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/12 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);															//Box ü 
		
		/*****************************************************************
			Data Mode
			1 : NOTAM NBR Է
			2 : FLT Է
			3 : DEP Է ARR Է (FLT Է)
			4 : STATION, AREA CODE 
		*****************************************************************/
		
		String notEtd = StringUtil.checkString(box.getString("notEtd")); // 2007.01.31 ߰
		
		String mode = StringUtil.checkString(box.getString("mode"));
		
		//Search by FLT
		String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String depStn = StringUtil.checkString(box.getString("dep_stn"));
		String arrStn = StringUtil.checkString(box.getString("arr_stn"));
		String rteId = StringUtil.checkString(box.getString("rte_id"));
		
		String etopsY = StringUtil.checkString(box.getString("hid_etops_chk"));//2007.10.04 ߰
		
		//Search by Station
		String notStn = StringUtil.checkString(box.getString("not_stn"));
		String areaCd = StringUtil.toKSC5601(box.getString("area_cd"));
		String notNum = StringUtil.checkString(box.getString("not_num"));
		
		//Option
		String trafI = StringUtil.checkString(box.getString("traf_I"));
		String trafV = StringUtil.checkString(box.getString("traf_V"));
		
		String purpN = StringUtil.checkString(box.getString("purp_N"));
		String purpB = StringUtil.checkString(box.getString("purp_B"));
		String purpO = StringUtil.checkString(box.getString("purp_O"));
		String purpM = StringUtil.checkString(box.getString("purp_M"));
		
		String scopA = StringUtil.checkString(box.getString("scop_A"));
		String scopE = StringUtil.checkString(box.getString("scop_E"));
		String scopW = StringUtil.checkString(box.getString("scop_W"));
		
		String notRdo = StringUtil.checkString(box.getString("hid_not_rdo"));	// P : Valid Combo , T : From ~ To 
		String notPeriod = StringUtil.checkString(box.getString("not_period"));
		String notIssDt = StringUtil.checkString(box.getString("not_iss_dt"));
		String notIssTm = StringUtil.checkString(box.getString("not_iss_tm"));
		String notExpDt = StringUtil.checkString(box.getString("not_exp_dt"));
		String notExpTm =StringUtil.checkString(box.getString("not_exp_tm"));
		
		/* 2009.11.12  : Category ȭ
		String clsRWY = StringUtil.checkString(box.getString("cls_RWY"));
		String clsTWY = StringUtil.checkString(box.getString("cls_TWY"));
		String clsILS = StringUtil.checkString(box.getString("cls_ILS"));
		String clsLGT = StringUtil.checkString(box.getString("cls_LGT"));
		String clsAGA = StringUtil.checkString(box.getString("cls_AGA"));
		String clsCOM = StringUtil.checkString(box.getString("cls_COM"));
		String clsRAC = StringUtil.checkString(box.getString("cls_RAC"));
		String clsWARN = StringUtil.checkString(box.getString("cls_WARN"));
		String clsAIP = StringUtil.checkString(box.getString("cls_AIP"));
		String clsOTHR = StringUtil.checkString(box.getString("cls_OTHR"));
		*/
		String clsnRWY = StringUtil.checkString(box.getString("cls_n_RWY"));
		String clsnRWYLGT = StringUtil.checkString(box.getString("cls_n_RWY_LGT"));
		String clsnTWY = StringUtil.checkString(box.getString("cls_n_TWY"));
		String clsnTWYLGT = StringUtil.checkString(box.getString("cls_n_TWY_LGT"));
		String clsnRAMP = StringUtil.checkString(box.getString("cls_n_RAMP"));
		String clsnNAVAID = StringUtil.checkString(box.getString("cls_n_NAVAID"));
		String clsnDEP = StringUtil.checkString(box.getString("cls_n_DEP"));
		String clsnAPP = StringUtil.checkString(box.getString("cls_n_APP"));
		String clsnAPPLGT = StringUtil.checkString(box.getString("cls_n_APP_LGT"));
		String clsnCOMM = StringUtil.checkString(box.getString("cls_n_COMM"));
		String clsnCHRT = StringUtil.checkString(box.getString("cls_n_CHRT"));
		String clsnARPT = StringUtil.checkString(box.getString("cls_n_ARPT"));
		String clsnOBST = StringUtil.checkString(box.getString("cls_n_OBST"));
		String clsnGPS = StringUtil.checkString(box.getString("cls_n_GPS"));
		String clsnAIRWAY = StringUtil.checkString(box.getString("cls_n_AIRWAY"));
		String clsnAIRSPACE = StringUtil.checkString(box.getString("cls_n_AIRSPACE"));
		String clsnOTHER = StringUtil.checkString(box.getString("cls_n_OTHER"));
		String clsnAIP = StringUtil.checkString(box.getString("cls_n_AIP"));
		
		String notSig = StringUtil.checkString(box.getString("hid_not_sig"));
		
		String notRemarks = StringUtil.checkString(box.getString("hid_not_remarks")); //2008.08.01 ߰ : Remarks ߰
		
		String typNOTAM = StringUtil.checkString(box.getString("typ_NOTAM"));
		String typCOADZ = StringUtil.checkString(box.getString("typ_COADZ"));
		String typSNOWTAM = StringUtil.checkString(box.getString("typ_SNOWTAM"));
		
		//20150326 ߰
		String typCOMPMIN = StringUtil.checkString(box.getString("typ_COMPMIN"));
		String typTECHINFO = StringUtil.checkString(box.getString("typ_TECHINFO"));
		//typCOMPMIN = "N";
		//typTECHINFO = "N";
		
		String notCommnt = StringUtil.toKSC5601(box.getString("not_commnt")); //ȭ鿡 NOTES
		
		String etd = StringUtil.checkString(box.getString("etd")); //2009.11.12 ߰
		String eta = StringUtil.checkString(box.getString("eta")); //2009.11.12 ߰
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		HttpSession session = req.getSession();
		
		try {	
			//notStn = StringUtil.icaoChk(notStn); //ڸ ĸ  ٲ.
			
			//System.out.println("mode->"+mode);
			
			//Parameter 
			NotQ010BG params = new NotQ010BG();			
			
			params.setNotEtd(notEtd); // 2007.01.31 ߰
			
			params.setMode(mode);
			
			params.setFlt_num(fltNum);
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setRte_id(rteId);
			
			params.setEtopsY(etopsY);//2007.10.04 ߰
			
			params.setNot_stn(notStn);
			params.setArea_cd(areaCd);
			params.setNot_num(notNum);
			
			params.setTrafI(trafI);
			params.setTrafV(trafV);
			
			params.setPurpN(purpN);
			params.setPurpB(purpB);
			params.setPurpO(purpO);
			params.setPurpM(purpM);
			
			params.setScopA(scopA);
			params.setScopE(scopE);
			params.setScopW(scopW);
			
			params.setNot_rdo(notRdo); // P : Valid Combo , T : From ~ To 
			params.setNot_period(notPeriod);
			params.setNot_iss_dt(notIssDt);
			params.setNot_iss_tm(notIssTm);
			params.setNot_exp_dt(notExpDt);
			params.setNot_exp_tm(notExpTm);
			
			/*
			params.setClsRWY(clsRWY);
			params.setClsTWY(clsTWY);
			params.setClsILS(clsILS);
			params.setClsLGT(clsLGT);
			params.setClsAGA(clsAGA);
			params.setClsCOM(clsCOM);
			params.setClsRAC(clsRAC);
			params.setClsWARN(clsWARN);
			params.setClsAIP(clsAIP);
			params.setClsOTHR(clsOTHR);
			*/
			params.setClsnRWY(clsnRWY);
			params.setClsnRWYLGT(clsnRWYLGT);
			params.setClsnTWY(clsnTWY);
			params.setClsnTWYLGT(clsnTWYLGT);
			params.setClsnRAMP(clsnRAMP);
			params.setClsnNAVAID(clsnNAVAID);
			params.setClsnDEP(clsnDEP);
			params.setClsnAPP(clsnAPP);
			params.setClsnAPPLGT(clsnAPPLGT);
			params.setClsnCOMM(clsnCOMM);
			params.setClsnCHRT(clsnCHRT);
			params.setClsnARPT(clsnARPT);
			params.setClsnOBST(clsnOBST);
			params.setClsnGPS(clsnGPS);
			params.setClsnAIRWAY(clsnAIRWAY);
			params.setClsnAIRSPACE(clsnAIRSPACE);
			params.setClsnOTHER(clsnOTHER);
			params.setClsnAIP(clsnAIP);
			
			params.setNotSig(notSig);
			
			params.setNotRemarks(notRemarks); //2008.08.01 ߰ : Remarks ߰
			
			params.setTypNOTAM(typNOTAM);
			params.setTypCOADZ(typCOADZ);
			params.setTypSNOWTAM(typSNOWTAM);
			
			//20150326 ߰
			params.setTypCOMPMIN(typCOMPMIN);
			params.setTypTECHINFO(typTECHINFO);
			
			params.setNot_commnt(notCommnt);
			
			params.setEtd(etd); //2009.11.12 ߰
			params.setEta(eta); //2009.11.12 ߰
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selNotQ010Main(params);
			
			//Data Session Input
			if (hashData != null) {
				
				String errorMessage = StringUtil.checkString((String)hashData.get("errorMessage"));
				if (errorMessage.length()!=0) throw new Exception(errorMessage);//@2013-07-19		if (!errorMessage.equals("")) throw new Exception(errorMessage);
				
				NotQ010BG head = (NotQ010BG)hashData.get("HEAD");
				if (head != null) {
					/*
					//User Session Information
					SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
					
					// 2007.01.31 ߰
					String empNoKey = "";
					if (UserInfo != null) empNoKey = StringUtil.checkString(UserInfo.getEmp_no());
					else req.setAttribute("errorMessage","ð  ʾ α ʿմϴ.");
					
					String sessionKey = StringUtil.getKST("yyyyMMddHHmmss") + empNoKey;
					*/
					//2008.11.24  : sessionKey
					String sessionKey = StringUtil.getKST("yyyyMMddHHmmss");
					session.setAttribute(sessionKey, hashData);
					
					//߿ Popup JSP ͸ ̰  !!! -> session.removeAttribute(sessionKey);
					req.setAttribute("sessionKey", sessionKey);
				}
			}
			
			//req.setAttribute("hashData", hashData);
			req.setAttribute("returnValue", "Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotQ015Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:NotQ015Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/** 
	  * New NOTAM Request Send Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/09/16 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);															//Box ü 
		
		/*****************************************************************
			Data Mode
			1 : NOTAM NBR Է
			2 : FLT Է
			3 : DEP Է ARR Է (FLT Է)
			4 : STATION, AREA CODE 																									
		*****************************************************************/
		
		String mode = StringUtil.checkString(box.getString("mode"));
		
		//Search by FLT
		String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String depStn = StringUtil.checkString(box.getString("dep_stn"));
		String arrStn = StringUtil.checkString(box.getString("arr_stn"));
		String rteId = StringUtil.checkString(box.getString("rte_id"));
		
		String etopsY = StringUtil.checkString(box.getString("hid_etops_chk"));//2007.10.04 ߰
		
		//Search by Station
		String notStn = StringUtil.checkString(box.getString("not_stn"));
		String areaCd = StringUtil.toKSC5601(box.getString("area_cd"));
		String notNum = StringUtil.checkString(box.getString("not_num"));
		
		//Option
		String trafI = StringUtil.checkString(box.getString("traf_I"));
		String trafV = StringUtil.checkString(box.getString("traf_V"));
		
		String purpN = StringUtil.checkString(box.getString("purp_N"));
		String purpB = StringUtil.checkString(box.getString("purp_B"));
		String purpO = StringUtil.checkString(box.getString("purp_O"));
		String purpM = StringUtil.checkString(box.getString("purp_M"));
		
		String scopA = StringUtil.checkString(box.getString("scop_A"));
		String scopE = StringUtil.checkString(box.getString("scop_E"));
		String scopW = StringUtil.checkString(box.getString("scop_W"));
		
		String notRdo = StringUtil.checkString(box.getString("hid_not_rdo"));	// P : Valid Combo , T : From ~ To 
		String notPeriod = StringUtil.checkString(box.getString("not_period"));
		String notIssDt = StringUtil.checkString(box.getString("not_iss_dt"));
		String notIssTm = StringUtil.checkString(box.getString("not_iss_tm"));
		String notExpDt = StringUtil.checkString(box.getString("not_exp_dt"));
		String notExpTm =StringUtil.checkString(box.getString("not_exp_tm"));
		
		/* 2009.11.12  : Category ȭ
		String clsRWY = StringUtil.checkString(box.getString("cls_RWY"));
		String clsTWY = StringUtil.checkString(box.getString("cls_TWY"));
		String clsILS = StringUtil.checkString(box.getString("cls_ILS"));
		String clsLGT = StringUtil.checkString(box.getString("cls_LGT"));
		String clsAGA = StringUtil.checkString(box.getString("cls_AGA"));
		String clsCOM = StringUtil.checkString(box.getString("cls_COM"));
		String clsRAC = StringUtil.checkString(box.getString("cls_RAC"));
		String clsWARN = StringUtil.checkString(box.getString("cls_WARN"));
		String clsAIP = StringUtil.checkString(box.getString("cls_AIP"));
		String clsOTHR = StringUtil.checkString(box.getString("cls_OTHR"));
		*/
		String clsnRWY = StringUtil.checkString(box.getString("cls_n_RWY"));
		String clsnRWYLGT = StringUtil.checkString(box.getString("cls_n_RWY_LGT"));
		String clsnTWY = StringUtil.checkString(box.getString("cls_n_TWY"));
		String clsnTWYLGT = StringUtil.checkString(box.getString("cls_n_TWY_LGT"));
		String clsnRAMP = StringUtil.checkString(box.getString("cls_n_RAMP"));
		String clsnNAVAID = StringUtil.checkString(box.getString("cls_n_NAVAID"));
		String clsnDEP = StringUtil.checkString(box.getString("cls_n_DEP"));
		String clsnAPP = StringUtil.checkString(box.getString("cls_n_APP"));
		String clsnAPPLGT = StringUtil.checkString(box.getString("cls_n_APP_LGT"));
		String clsnCOMM = StringUtil.checkString(box.getString("cls_n_COMM"));
		String clsnCHRT = StringUtil.checkString(box.getString("cls_n_CHRT"));
		String clsnARPT = StringUtil.checkString(box.getString("cls_n_ARPT"));
		String clsnOBST = StringUtil.checkString(box.getString("cls_n_OBST"));
		String clsnGPS = StringUtil.checkString(box.getString("cls_n_GPS"));
		String clsnAIRWAY = StringUtil.checkString(box.getString("cls_n_AIRWAY"));
		String clsnAIRSPACE = StringUtil.checkString(box.getString("cls_n_AIRSPACE"));
		String clsnOTHER = StringUtil.checkString(box.getString("cls_n_OTHER"));
		String clsnAIP = StringUtil.checkString(box.getString("cls_n_AIP"));
		
		String notSig = StringUtil.checkString(box.getString("hid_not_sig"));
		
		String notRemarks = StringUtil.checkString(box.getString("hid_not_remarks")); //2008.08.01 ߰ : Remarks ߰
		
		String typNOTAM = StringUtil.checkString(box.getString("typ_NOTAM"));
		String typCOADZ = StringUtil.checkString(box.getString("typ_COADZ"));
		String typSNOWTAM = StringUtil.checkString(box.getString("typ_SNOWTAM"));
		
		String notCommnt = StringUtil.toKSC5601(box.getString("not_commnt"));
		
		String etd = StringUtil.checkString(box.getString("etd")); //2009.11.12 ߰
		String eta = StringUtil.checkString(box.getString("eta")); //2009.11.12 ߰
			
		//Message Send Params
		String emailTxt = StringUtil.checkString(box.getString("email_txt"));
		String sitaTxt = StringUtil.checkString(box.getString("sita_txt"));
		String aftnTxt = StringUtil.checkString(box.getString("aftn_txt"));
		String acarsTxt = StringUtil.checkString(box.getString("acars_txt"));
		String faxTxt = StringUtil.checkString(box.getString("fax_txt"));
		String senderTxt = StringUtil.checkString(box.getString("sender_txt"));
		String originTxt = StringUtil.checkString(box.getString("origin_txt"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		HttpSession session = req.getSession();
		
		try {				
			//Parameter 
			NotQ010BG params = new NotQ010BG();			
			
			params.setMode(mode);
			
			params.setFlt_num(fltNum);
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setRte_id(rteId);
			
			params.setEtopsY(etopsY);//2007.10.04 ߰
			
			params.setNot_stn(notStn);
			params.setArea_cd(areaCd);
			params.setNot_num(notNum);
			
			params.setTrafI(trafI);
			params.setTrafV(trafV);
			
			params.setPurpN(purpN);
			params.setPurpB(purpB);
			params.setPurpO(purpO);
			params.setPurpM(purpM);
			
			params.setScopA(scopA);
			params.setScopE(scopE);
			params.setScopW(scopW);
			
			params.setNot_rdo(notRdo); // P : Valid Combo , T : From ~ To 
			params.setNot_period(notPeriod);
			params.setNot_iss_dt(notIssDt);
			params.setNot_iss_tm(notIssTm);
			params.setNot_exp_dt(notExpDt);
			params.setNot_exp_tm(notExpTm);
			
			/*
			params.setClsRWY(clsRWY);
			params.setClsTWY(clsTWY);
			params.setClsILS(clsILS);
			params.setClsLGT(clsLGT);
			params.setClsAGA(clsAGA);
			params.setClsCOM(clsCOM);
			params.setClsRAC(clsRAC);
			params.setClsWARN(clsWARN);
			params.setClsAIP(clsAIP);
			params.setClsOTHR(clsOTHR);
			*/
			params.setClsnRWY(clsnRWY);
			params.setClsnRWYLGT(clsnRWYLGT);
			params.setClsnTWY(clsnTWY);
			params.setClsnTWYLGT(clsnTWYLGT);
			params.setClsnRAMP(clsnRAMP);
			params.setClsnNAVAID(clsnNAVAID);
			params.setClsnDEP(clsnDEP);
			params.setClsnAPP(clsnAPP);
			params.setClsnAPPLGT(clsnAPPLGT);
			params.setClsnCOMM(clsnCOMM);
			params.setClsnCHRT(clsnCHRT);
			params.setClsnARPT(clsnARPT);
			params.setClsnOBST(clsnOBST);
			params.setClsnGPS(clsnGPS);
			params.setClsnAIRWAY(clsnAIRWAY);
			params.setClsnAIRSPACE(clsnAIRSPACE);
			params.setClsnOTHER(clsnOTHER);
			params.setClsnAIP(clsnAIP);
			
			params.setNotSig(notSig);
			
			params.setNotRemarks(notRemarks); //2008.08.01 ߰ : Remarks ߰
			
			params.setTypNOTAM(typNOTAM);
			params.setTypCOADZ(typCOADZ);
			params.setTypSNOWTAM(typSNOWTAM);
			
			params.setNot_commnt(notCommnt);
			
			params.setEtd(etd); //2009.11.12 ߰
			params.setEta(eta); //2009.11.12 ߰
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selNotQ010Main(params);
			
			if (hashData != null) {
				
				NotQ010BG sendParam = new NotQ010BG();
				
				sendParam.setMode(mode);
				
				sendParam.setFlt_num(fltNum);
				sendParam.setDep_stn(depStn);
				sendParam.setArr_stn(arrStn);
				sendParam.setRte_id(rteId);
				
				sendParam.setNot_stn(notStn);
				sendParam.setArea_cd(areaCd);
				sendParam.setNot_num(notNum);
				
				//2007.09.28 ߰---------------------------------
				sendParam.setEtopsY(etopsY);//2007.10.04 ߰
				
				sendParam.setTrafI(trafI);
				sendParam.setTrafV(trafV);
			
				sendParam.setPurpN(purpN);
				sendParam.setPurpB(purpB);
				sendParam.setPurpO(purpO);
				sendParam.setPurpM(purpM);
			
				sendParam.setScopA(scopA);
				sendParam.setScopE(scopE);
				sendParam.setScopW(scopW);
			
				sendParam.setNot_rdo(notRdo); // P : Valid Combo , T : From ~ To 
				sendParam.setNot_period(notPeriod);
				sendParam.setNot_iss_dt(notIssDt);
				sendParam.setNot_iss_tm(notIssTm);
				sendParam.setNot_exp_dt(notExpDt);
				sendParam.setNot_exp_tm(notExpTm);
			
				/*
				sendParam.setClsRWY(clsRWY);
				sendParam.setClsTWY(clsTWY);
				sendParam.setClsILS(clsILS);
				sendParam.setClsLGT(clsLGT);
				sendParam.setClsAGA(clsAGA);
				sendParam.setClsCOM(clsCOM);
				sendParam.setClsRAC(clsRAC);
				sendParam.setClsWARN(clsWARN);
				sendParam.setClsAIP(clsAIP);
				sendParam.setClsOTHR(clsOTHR);
				*/
				sendParam.setClsnRWY(clsnRWY);
				sendParam.setClsnRWYLGT(clsnRWYLGT);
				sendParam.setClsnTWY(clsnTWY);
				sendParam.setClsnTWYLGT(clsnTWYLGT);
				sendParam.setClsnRAMP(clsnRAMP);
				sendParam.setClsnNAVAID(clsnNAVAID);
				sendParam.setClsnDEP(clsnDEP);
				sendParam.setClsnAPP(clsnAPP);
				sendParam.setClsnAPPLGT(clsnAPPLGT);
				sendParam.setClsnCOMM(clsnCOMM);
				sendParam.setClsnCHRT(clsnCHRT);
				sendParam.setClsnARPT(clsnARPT);
				sendParam.setClsnOBST(clsnOBST);
				sendParam.setClsnGPS(clsnGPS);
				sendParam.setClsnAIRWAY(clsnAIRWAY);
				sendParam.setClsnAIRSPACE(clsnAIRSPACE);
				sendParam.setClsnOTHER(clsnOTHER);
				sendParam.setClsnAIP(clsnAIP);
				
				sendParam.setNotSig(notSig);
				
				sendParam.setNotRemarks(notRemarks); //2008.08.01 ߰ : Remarks ߰
			
				sendParam.setTypNOTAM(typNOTAM);
				sendParam.setTypCOADZ(typCOADZ);
				sendParam.setTypSNOWTAM(typSNOWTAM);
				
				sendParam.setNot_commnt(notCommnt); //2007.10.23 ߰ : NOTES
				
				sendParam.setEtd(etd); //2009.11.12 ߰
				sendParam.setEta(eta); //2009.11.12 ߰
				//------------------------------------------------
				
				sendParam.setEmail_txt(emailTxt);
				sendParam.setSita_txt(sitaTxt);
				sendParam.setAftn_txt(aftnTxt);
				sendParam.setAcars_txt(acarsTxt);
				sendParam.setFax_txt(faxTxt);
				sendParam.setSender_txt(senderTxt);
				sendParam.setOrigin_txt(originTxt);
				
				//2008.01.22 ߰
				String userId = "";
				SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
				if (UserInfo != null) userId = StringUtil.checkString(UserInfo.getEmp_no());
				sendParam.setUserId(userId);
				
				boolean wxFlag = sl.sendNotamReq(sendParam, hashData);
				if (wxFlag) req.setAttribute("dataComplete","S");
				else throw new Exception(" ");
					
			} else throw new Exception(" ");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotQ015Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
				return;
			} else {
				Logger.debug.println("[BASE:NotQ015Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
				return;
			}
		} 
	}//end insertTask
	
	/** 
	  * ȸ PRINT Ҷ BS_NOTAM_ARCHIVE_T INSERT Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2009/01/13 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);															//Box ü 
		
		/*****************************************************************
			Data Mode
			1 : NOTAM NBR Է
			2 : FLT Է
			3 : DEP Է ARR Է (FLT Է)
			4 : STATION, AREA CODE 																									
		*****************************************************************/
		
		String sentTp = StringUtil.checkString(box.getString("sentTp")); //2009.05.13 ߰
		
		String empNo = StringUtil.checkString(box.getString("empNo"));
		
		String mode = StringUtil.checkString(box.getString("mode"));
		
		//Search by FLT
		String fltNum = StringUtil.checkString(box.getString("fltNum"));
		String depStn = StringUtil.checkString(box.getString("depStn"));
		String arrStn = StringUtil.checkString(box.getString("arrStn"));
		String rteId = StringUtil.checkString(box.getString("rteId"));
		
		String etopsY = StringUtil.checkString(box.getString("etopsY"));
		
		//Search by Station
		String notStn = StringUtil.checkString(box.getString("notStn"));
		String areaCd = StringUtil.toKSC5601(box.getString("areaCd"));
		String notNum = StringUtil.checkString(box.getString("notNum"));
		
		//Option
		String trafI = StringUtil.checkString(box.getString("trafI"));
		String trafV = StringUtil.checkString(box.getString("trafV"));
		
		String purpN = StringUtil.checkString(box.getString("purpN"));
		String purpB = StringUtil.checkString(box.getString("purpB"));
		String purpO = StringUtil.checkString(box.getString("purpO"));
		String purpM = StringUtil.checkString(box.getString("purpM"));
		
		String scopA = StringUtil.checkString(box.getString("scopA"));
		String scopE = StringUtil.checkString(box.getString("scopE"));
		String scopW = StringUtil.checkString(box.getString("scopW"));
		
		String notRdo = StringUtil.checkString(box.getString("notRdo"));	// P : Valid Combo , T : From ~ To 
		String notPeriod = StringUtil.checkString(box.getString("notPeriod"));
		String notIssDt = StringUtil.checkString(box.getString("notIssDt"));
		String notIssTm = StringUtil.checkString(box.getString("notIssTm"));
		String notExpDt = StringUtil.checkString(box.getString("notExpDt"));
		String notExpTm =StringUtil.checkString(box.getString("notExpTm"));
		
		/* 2009.11.12  : Category ȭ
		String clsRWY = StringUtil.checkString(box.getString("clsRWY"));
		String clsTWY = StringUtil.checkString(box.getString("clsTWY"));
		String clsILS = StringUtil.checkString(box.getString("clsILS"));
		String clsLGT = StringUtil.checkString(box.getString("clsLGT"));
		String clsAGA = StringUtil.checkString(box.getString("clsAGA"));
		String clsCOM = StringUtil.checkString(box.getString("clsCOM"));
		String clsRAC = StringUtil.checkString(box.getString("clsRAC"));
		String clsWARN = StringUtil.checkString(box.getString("clsWARN"));
		String clsAIP = StringUtil.checkString(box.getString("clsAIP"));
		String clsOTHR = StringUtil.checkString(box.getString("clsOTHR"));
		*/
		String clsnRWY = StringUtil.checkString(box.getString("clsnRWY"));
		String clsnRWYLGT = StringUtil.checkString(box.getString("clsnRWYLGT"));
		String clsnTWY = StringUtil.checkString(box.getString("clsnTWY"));
		String clsnTWYLGT = StringUtil.checkString(box.getString("clsnTWYLGT"));
		String clsnRAMP = StringUtil.checkString(box.getString("clsnRAMP"));
		String clsnNAVAID = StringUtil.checkString(box.getString("clsnNAVAID"));
		String clsnDEP = StringUtil.checkString(box.getString("clsnDEP"));
		String clsnAPP = StringUtil.checkString(box.getString("clsnAPP"));
		String clsnAPPLGT = StringUtil.checkString(box.getString("clsnAPPLGT"));
		String clsnCOMM = StringUtil.checkString(box.getString("clsnCOMM"));
		String clsnCHRT = StringUtil.checkString(box.getString("clsnCHRT"));
		String clsnARPT = StringUtil.checkString(box.getString("clsnARPT"));
		String clsnOBST = StringUtil.checkString(box.getString("clsnOBST"));
		String clsnGPS = StringUtil.checkString(box.getString("clsnGPS"));
		String clsnAIRWAY = StringUtil.checkString(box.getString("clsnAIRWAY"));
		String clsnAIRSPACE = StringUtil.checkString(box.getString("clsnAIRSPACE"));
		String clsnOTHER = StringUtil.checkString(box.getString("clsnOTHER"));
		String clsnAIP = StringUtil.checkString(box.getString("clsnAIP"));
		
		String notSig = StringUtil.checkString(box.getString("notSig"));
		
		String notRemarks = StringUtil.checkString(box.getString("notRemarks")); //2008.08.01 ߰ : Remarks ߰
		
		String typNOTAM = StringUtil.checkString(box.getString("typNOTAM"));
		String typCOADZ = StringUtil.checkString(box.getString("typCOADZ"));
		String typSNOWTAM = StringUtil.checkString(box.getString("typSNOWTAM"));
		
		String notCommnt = StringUtil.toKSC5601(box.getString("notCommnt"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {				
			//Parameter 
			NotQ010BG params = new NotQ010BG();
			
			params.setMode(mode);
			
			params.setFlt_num(fltNum);
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setRte_id(rteId);
			
			params.setEtopsY(etopsY);//2007.10.04 ߰
			
			params.setNot_stn(notStn);
			params.setArea_cd(areaCd);
			params.setNot_num(notNum);
			
			params.setTrafI(trafI);
			params.setTrafV(trafV);
			
			params.setPurpN(purpN);
			params.setPurpB(purpB);
			params.setPurpO(purpO);
			params.setPurpM(purpM);
			
			params.setScopA(scopA);
			params.setScopE(scopE);
			params.setScopW(scopW);
			
			params.setNot_rdo(notRdo); // P : Valid Combo , T : From ~ To 
			params.setNot_period(notPeriod);
			params.setNot_iss_dt(notIssDt);
			params.setNot_iss_tm(notIssTm);
			params.setNot_exp_dt(notExpDt);
			params.setNot_exp_tm(notExpTm);
			
			/*
			params.setClsRWY(clsRWY);
			params.setClsTWY(clsTWY);
			params.setClsILS(clsILS);
			params.setClsLGT(clsLGT);
			params.setClsAGA(clsAGA);
			params.setClsCOM(clsCOM);
			params.setClsRAC(clsRAC);
			params.setClsWARN(clsWARN);
			params.setClsAIP(clsAIP);
			params.setClsOTHR(clsOTHR);
			*/
			params.setClsnRWY(clsnRWY);
			params.setClsnRWYLGT(clsnRWYLGT);
			params.setClsnTWY(clsnTWY);
			params.setClsnTWYLGT(clsnTWYLGT);
			params.setClsnRAMP(clsnRAMP);
			params.setClsnNAVAID(clsnNAVAID);
			params.setClsnDEP(clsnDEP);
			params.setClsnAPP(clsnAPP);
			params.setClsnAPPLGT(clsnAPPLGT);
			params.setClsnCOMM(clsnCOMM);
			params.setClsnCHRT(clsnCHRT);
			params.setClsnARPT(clsnARPT);
			params.setClsnOBST(clsnOBST);
			params.setClsnGPS(clsnGPS);
			params.setClsnAIRWAY(clsnAIRWAY);
			params.setClsnAIRSPACE(clsnAIRSPACE);
			params.setClsnOTHER(clsnOTHER);
			params.setClsnAIP(clsnAIP);
			
			params.setNotSig(notSig);
			
			params.setNotRemarks(notRemarks); //2008.08.01 ߰ : Remarks ߰
			
			params.setTypNOTAM(typNOTAM);
			params.setTypCOADZ(typCOADZ);
			params.setTypSNOWTAM(typSNOWTAM);
			
			params.setNot_commnt(notCommnt);
			
			//EJB LookUp
			NotAllSL sl = (NotAllSL)EJBFinder.lookup("ejb/NotAllSL");
			Hashtable hashData = sl.selNotQ010Main(params);
			
			if (hashData != null) {
				
				NotQ010BG printParam = new NotQ010BG();
				
				printParam.setSent_tp(sentTp); //2009.05.13 ߰
				
				printParam.setFlt_num(fltNum);
				printParam.setDep_stn(depStn);
				printParam.setArr_stn(arrStn);
				printParam.setRte_id(rteId);
				
				printParam.setUserId(empNo);
				
				boolean printFlg = sl.printNotamArchive(printParam, hashData);
				
				if(printFlg){//2013-07-19								
					//---------------FIRST_LEG_FLT_DT ȸ
					ConnectionResource cr = null;
					Connection conn = null;
					Statement stmt = null;
					ResultSet rs = null;					
					try{					
						String	firstLegFltDt=params.getFirstLegFltDt();
						cr = new ToolConnectionResource();
						conn = cr.getConnection();	
						stmt = conn.createStatement();
						String	sql = NotQ010Query.getInstance().selArcFirstLegFltDt(printParam);								
						rs = stmt.executeQuery(sql);
						if (rs.next()) {
							firstLegFltDt = StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT"));					
						}
						if(firstLegFltDt!=null){						
							String dirName = "/usr/apps/attach2/base/fltinfo";//"D:/PROJECT_OUTPUT/MCP/linkageBase/fltinfo";//
						    File dir = new File(dirName);
						    if(!dir.exists()) dir.mkdirs();
						    
						    BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new BufferedOutputStream(
						    		new FileOutputStream(dirName+"/NOT_"+firstLegFltDt.replaceAll("-","")+"_"+fltNum+"_"+depStn+"_"+arrStn+".html",false)
						    ),"UTF-8"));
	
							//BufferedWriter out = new BufferedWriter(new FileWriter(dirName+"/NOT_"+firstLegFltDt.replaceAll("-","")+"_"+fltNum+"_"+depStn+"_"+arrStn+".html"));
							out.write("<!DOCTYPE html><HTML><HEAD><META	charset=\"UTF-8\"/><META	http-equiv=\"X-UA-Compatible\" content=\"IE=Edge\"/><BODY>"+ StringUtil.toKSC5601(box.getString("returnViewResult"))+"</BODY></HTML>"); 
							out.close();
						}
					} catch (Exception e) {throw e;
					} finally {
						if ( cr != null) try { cr.release(); } catch(Exception e) {throw e;}
						if (conn != null) try {conn.close(); } catch(Exception e) {throw e;}
						if (rs != null) try {rs.close(); } catch(Exception e) {throw e;}
						if (stmt != null) try {stmt.close();} catch(Exception e) {throw e;}
					}
				}
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:NotQ015Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
				return;
			} else {
				Logger.debug.println("[BASE:NotQ015Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
				return;
			}
		} 
	}//end checkTask
}
