package kal.base.ocb.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.ocb.dbbean.*;
import kal.base.ocb.ejb.OcbAllSL;
import kal.base.com.ejb.ComAllSL;

/**
 * Daily Operation Info1 Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/03/29  
 */
public class OcbQ020Serv extends PublicBaseServlet{
	/** 
	  *  Daily Operation Info1 Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/03/29  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String irops_d = StringUtil.checkString(box.getString("irops_d"));				//Irops_d
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			OcbQ020BG params = new OcbQ020BG();	
			params.setIrops_d(irops_d);
			
			//EJB LookUp
			OcbAllSL sl = (OcbAllSL)EJBFinder.lookup("ejb/OcbAllSL");
			Hashtable hashData  = sl.selOcbQ020Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Daily Operation Info1", null, "", MessageCode.getInstance().SELECT_MSG));
			}
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			req.setAttribute("irops_d",irops_d);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:OcbQ020Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:OcbQ020Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Restriction Airport Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/03/30  
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String irops_d = StringUtil.checkString(box.getString("irops_d"));				//Irops_d
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String[] iropsD = req.getParameterValues("iropsD");
		String[] aptC = req.getParameterValues("aptC");
		String[] seqNo = req.getParameterValues("seqNo");	
				
		try {
			//EJB LookUp
			OcbAllSL sl = (OcbAllSL)EJBFinder.lookup("ejb/OcbAllSL");
			int returnValue = sl.delOcbQ020ResAir(iropsD, aptC, seqNo);
			if (returnValue == 1){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Restriction Airport Delete", null, "", MessageCode.getInstance().DELETE_MSG));
			}else{
				req.setAttribute("errorMessage",MessageCode.getInstance().DELETE_MSG);
			}
			req.setAttribute("delParam","Y");
			req.setAttribute("irops_d",irops_d);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:OcbQ020Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:OcbQ020Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask
}
