package kal.base.skd.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.skd.dbbean.SkdQ010BG;
import kal.base.skd.ejb.SkdAllSL;

/**
 * SKD/Daily SKD Display Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/18 HIST  
 */
public class SkdQ010Serv extends PublicBaseServlet{
	/** 
	  * SKD/Daily SKD Display Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/18 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String allDate = StringUtil.checkString(box.getString("all_date"));					//
		String fltNum = StringUtil.checkString(box.getString("flt_num"));					//Flight Number
		String regNo = StringUtil.checkString(box.getString("regno"));						//Reg Number
		String stnFr = StringUtil.checkString(box.getString("stnfr"));							//Station From
		String stnTo = StringUtil.checkString(box.getString("stnto"));							//Station To
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));				//
		String timeX = StringUtil.checkString(box.getString("time_x"));						//ð
		//@2017-07-07
		String kactyp = StringUtil.checkString(box.getString("kactyp"));	
		//2009.10.12 ߰
		String sort = StringUtil.checkString(box.getString("sort"));						// 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//EJB Parameter 
			SkdQ010BG params = new SkdQ010BG();
			params.setSch_dep_dt("20"+allDate);
			params.setFlt_num(fltNum);
			params.setRegno(regNo);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setDom_int_x(domIntX);
			params.setTime_x(timeX);
			params.setKactyp(kactyp);
			params.setSort(sort); //2009.10.12 ߰
			params.setKactyp(kactyp);//@2017-07-10
			
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData  = sl.selSkdQ010Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Daily SKD Display", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SkdQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	//@2017-07-07
	public static Hashtable selKactyp() throws Exception {
		try {
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData = sl.selSkdQ010Kactyp();
			
			return hashData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}
}
