package kal.base.skd.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.skd.dbbean.SkdQ050BG;
import kal.base.skd.ejb.SkdAllSL;

/**
 *  HUB Station Information Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/02/02 
 */
public class SkdQ050Serv extends PublicBaseServlet{
	/** 
	  * HUB Station Information Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/02/02 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String allDate = StringUtil.checkString(box.getString("all_date"));			//˻
		if(allDate.length()==6) allDate = "20"+allDate;	
		String station = StringUtil.checkString(box.getString("station"));				//station
		String depArr = StringUtil.checkString(box.getString("dep_arr"));				//D/A
		String carrier = StringUtil.checkString(box.getString("carrier"));					//carrier
		String startTime = StringUtil.checkString(box.getString("start_time"));			//˻  ð
		String endTime = StringUtil.checkString(box.getString("end_time"));			//˻  ð
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SkdQ050BG params = new SkdQ050BG();
			params.setSch_dt_loc(allDate);
			params.setStn(station);
			params.setDeparv_x(depArr);
			params.setCarrier(carrier);
			params.setStart_time(startTime);
			params.setEnd_time(endTime);
			
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData  = sl.selSkdQ050Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("HUB Station Information", hashData, "HUBINFO", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdQ050Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SkdQ050Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
