package kal.base.skd.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;
import javax.servlet.http.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.skd.dbbean.SkdQ060BG;
import kal.base.skd.ejb.SkdAllSL;

/**
 * HUB Station Info Detail Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2007/10/12 
 */
public class SkdQ060Serv extends PublicBaseServlet{
	/** 
	  * HUB Station Info Detail Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2007/10/12 
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		
		String pSchDtLoc = StringUtil.checkString(box.getString("pSchDtLoc"));
		String pStn = StringUtil.checkString(box.getString("pStn"));
		String pArlnCd = StringUtil.checkString(box.getString("pArlnCd"));
		String pFltNum = StringUtil.checkString(box.getString("pFltNum"));
		String pDepArvX = StringUtil.checkString(box.getString("pDepArvX"));
		String pRegno = StringUtil.checkString(box.getString("pRegno"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));			//Return Page ȹ
		
		try {
			//EJB Parameter 
			SkdQ060BG params = new SkdQ060BG();
			
			params.setPSchDtLoc(pSchDtLoc);
			params.setPStn(pStn);
			params.setPArlnCd(pArlnCd);
			params.setPFltNum(pFltNum);
			params.setPDepArvX(pDepArvX);
			params.setPRegno(pRegno);
			
			//EJB LookUp
			SkdAllSL sl = (SkdAllSL)EJBFinder.lookup("ejb/SkdAllSL");
			Hashtable hashData  = sl.selSkdQ060Main(params);
			req.setAttribute("hashData", hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SkdQ060Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SkdQ060Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
	
}//end class
