package kal.base.sta.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sta.dbbean.StaQ020BG;
import kal.base.sta.ejb.StaAllSL;

/**
 * OPS Statistics/Operation Status-Airport Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/01/25 HIST  
 */
public class StaQ020Serv extends PublicBaseServlet{
	/** 
	  * OPS Statistics/Operation Status-Airport Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/01/25 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String fromDate = StringUtil.checkString(box.getString("from_date"));			//
		String toDate = StringUtil.checkString(box.getString("to_date"));					//
		String depArrX = StringUtil.checkString(box.getString("dep_arr_x"));			//DEP_ARR 
		String station = StringUtil.checkString(box.getString("station"));					//station
		String domIntX = StringUtil.checkString(box.getString("dom_int_x"));				//DOM_INT 
		String startTm = StringUtil.checkString(box.getString("start_tm"));					//START ð
		String endTm = StringUtil.checkString(box.getString("end_tm"));					//END ð
		
		String timeX = StringUtil.checkString(box.getString("time_x")); //2010.10.15 ߰
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//EJB Parameter 
			StaQ020BG params = new StaQ020BG();
			params.setFrom_date("20"+fromDate);
			params.setTo_date("20"+toDate);
			params.setDep_arr_x(depArrX);
			params.setStn(station);
			params.setDom_int_x(domIntX);
			params.setStart_tm(startTm);
			params.setEnd_tm(endTm);
			
			params.setTime_x(timeX); //2010.10.15 ߰
			
			//EJB LookUp
			StaAllSL sl = (StaAllSL)EJBFinder.lookup("ejb/StaAllSL");
			Hashtable hashData  = sl.selStaQ020Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Operation Status-Airport", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:StaQ020Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:StaQ020Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	
}
