package kal.base.sta.serv;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sta.dbbean.StaQ230BG;
import kal.base.sta.ejb.StaAllSL;

/**
 * Flight Summary Servlet Class
 * @version 	1.0
 * ۼ ¥ : 2010-07-22
 */
public class StaQ230Serv extends PublicBaseServlet{
	/** 
	  * Flight Summary Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * ۼ ¥ : 2010-07-22
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String dt = StringUtil.checkString(box.getString("dt"));
		String sts = StringUtil.checkString(box.getString("sts"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			StaQ230BG params = new StaQ230BG();
			
			params.setDt(dt);
			params.setSts(sts);
						
			//EJB LookUp
			StaAllSL sl = (StaAllSL)EJBFinder.lookup("ejb/StaAllSL");
			
			Hashtable hashData = sl.selStaQ230Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Flight Summary", null, "", MessageCode.getInstance().SELECT_MSG));
			}
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:StaQ230Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:StaQ230Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
