package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;
import kal.base.wea.ejb.WeaAllSL;

/**
 * NOTAM List Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/06/13 
 */
public class SupA110Serv extends PublicBaseServlet {

	/** 
	  * NOTAM List ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/13 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String dtg_range = StringUtil.checkString(box.getString("dtg_range")); //2007.03.27 ߰
		
		try {
			//2007.03.27 ߰
			SupA110BG params = new SupA110BG();
			params.setDtg_range(dtg_range);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA110Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("NOTAM List", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("dataComplete","S");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA110Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA110Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * NOTAM Detail ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/13 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    	//Box ü 
		String icaoPort = StringUtil.checkString(box.getString("icao_port"));			//ICAO PORT ȹ
		String notNum = StringUtil.checkString(box.getString("not_num"));			//NOT NUM ȹ
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//ȸ 
			SupA110BG params = new SupA110BG();
			params.setIcao_port(icaoPort);
			params.setNot_num(notNum);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			SupA110BG entity  = sl.selSupA110Detail(params);
			if (entity != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("NOTAM List", null, "", MessageCode.getInstance().SELECT_MSG));
			req.setAttribute("entity",entity);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA110Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SupA110Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
	/** 
	  * NOTAM Item  Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/15 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										   			 //Box ü 
		String notFir = StringUtil.checkString(box.getString("not_fir"));
		String notQcd = StringUtil.checkString(box.getString("not_qcd"));
		String notTraf = StringUtil.checkString(box.getString("not_traf"));
		String notPurp = StringUtil.checkString(box.getString("not_purp"));
		String notScop = StringUtil.checkString(box.getString("not_scop"));
		String notLow = StringUtil.checkString(box.getString("not_low"));
		String notUpp = StringUtil.checkString(box.getString("not_upp"));
		String notLat_lon = StringUtil.checkString(box.getString("not_lat_lon"));
		String notIss_dt = StringUtil.checkString(box.getString("not_iss_dt"));
		String notExp_dt = StringUtil.checkString(box.getString("not_exp_dt"));
		String notValid = StringUtil.checkString(box.getString("not_valid")).toUpperCase();
		String notText = StringUtil.checkString(box.getString("not_text")).toUpperCase();
		String notOpen_y = StringUtil.checkString(box.getString("not_open_y"));
		String notCommnt = StringUtil.checkString(box.getString("not_commnt")).toUpperCase();
		String notOld_num = StringUtil.checkString(box.getString("not_old_num"));
		String icaoPort = StringUtil.checkString(box.getString("icao_port"));
		String notNum = StringUtil.checkString(box.getString("not_num"));
		//2005.08.03 
		String notCat = StringUtil.checkString(box.getString("not_cat"));
		//2005.11.16 
		String notTyp = StringUtil.checkString(box.getString("not_typ"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			SupA110BG params = new SupA110BG();
			params.setMode("update");
			params.setNot_fir(notFir);
			params.setNot_qcd(notQcd);
			params.setNot_traf(notTraf);
			params.setNot_purp(notPurp);
			params.setNot_scop(notScop);
			params.setNot_low(notLow);
			params.setNot_upp(notUpp);
			params.setNot_lat_lon(notLat_lon);
			params.setNot_iss_dt(notIss_dt);
			params.setNot_exp_dt(notExp_dt);
			params.setNot_valid(notValid);
			params.setNot_text(notText);
			params.setNot_open_y(notOpen_y);
			params.setNot_commnt(notCommnt);
			params.setNot_old_num(notOld_num);
			params.setIcao_port(icaoPort);
			params.setNot_num(notNum);
			//2005.08.03 
			params.setNot_cat(notCat);
			params.setUserid(UserInfo.getEmp_no());
			//2005.11.16 
			params.setNot_typ(notTyp);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean updFlag = sl.updSupA110Main(params);
			req.setAttribute("notOpenY",notOpen_y);
			req.setAttribute("notInput","M");
			req.setAttribute("userID",UserInfo.getEmp_no());
			req.setAttribute("dataComplete","U");
			
			// ȸ
			/*
			Hashtable hashData  = sl.selSupA110Main();
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("NOTAM List", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			*/
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA110Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA110Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask		
	
	/** 
	  * NOTAM Item  Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/15 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										   			 //Box ü 
		String icaoPort = StringUtil.checkString(box.getString("icao_port"));				//ICAO PORT ȹ
		String notNum = StringUtil.checkString(box.getString("not_num"));				//NOT NUM ȹ
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//Parameter 
			SupA110BG params = new SupA110BG();
			params.setIcao_port(icaoPort);
			params.setNot_num(notNum);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean delFlag = sl.delSupA110Item(params);
			req.setAttribute("notInput","D");
			req.setAttribute("dataComplete","D");
			
			/*
			// ȸ
			Hashtable hashData  = sl.selSupA110Main();
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("NOTAM List", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			*/
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA110Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA110Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask		
	
	/** 
	  * NOTAM List Send Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2006/02/02 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    		//Box ü 
		
		/******************************************************************************/
		/*  Data Mode																													*/
		/*  1 : NOTAM NBR Է , 2 : FLT Է STN Է , 3 : FLT Է DEP Է ARR Է , 	*/
		/*  4 : FLT Է DEP Է ARR Է , 5 : FLT Է DEP Է ARR Է								*/
		/*  6 : AREA CODE 																									*/
		/******************************************************************************/	
		//String mode = StringUtil.checkString(box.getString("mode"));
		String mode = "1";
				
		//1st Line Value
		/*String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String depStn = StringUtil.checkString(box.getString("dep_stn"));
		String arrStn = StringUtil.checkString(box.getString("arr_stn"));
		String rteId = StringUtil.checkString(box.getString("rte_id"));
		String notNum = StringUtil.checkString(box.getString("not_num"));
		String areaCd = StringUtil.toKSC5601(box.getString("area_cd"));*/
		String fltNum = "";
		String depStn = "";
		String arrStn = "";
		String rteId = "";
		String notNum = StringUtil.checkString(box.getString("not_num"));
		String areaCd = "";
		
		//2nd Line Value
		/*String hCatAll = StringUtil.checkString(box.getString("h_cat_all"));
		String hCatNo = StringUtil.checkString(box.getString("h_cat_no"));
		String hCatIn = StringUtil.checkString(box.getString("h_cat_in"));
		String hCatAip = StringUtil.checkString(box.getString("h_cat_aip"));
		String hCatSnow = StringUtil.checkString(box.getString("h_cat_snow"));
		String hCatComm = StringUtil.checkString(box.getString("h_cat_comm"));*/
		String hCatAll = "";
		String hCatNo = "";
		String hCatIn = "";
		String hCatAip = "";
		String hCatSnow = "";
		String hCatComm = "";
		
		//3rd Line Value
		/*String notRdo = StringUtil.checkString(box.getString("not_rdo"));						// P : Period Combo   ,  T : From ~ To 
		//Logger.debug.println("[Servlet] notRdo : "+notRdo);
		String notTraf = StringUtil.checkString(box.getString("not_traf"));
		String notPeriod = StringUtil.checkString(box.getString("not_period"));
		String notIssDt = StringUtil.checkString(box.getString("not_iss_dt"));
		String notIssTm = StringUtil.checkString(box.getString("not_iss_tm"));
		String notExpDt = StringUtil.checkString(box.getString("not_exp_dt"));
		String notExpTm =StringUtil.checkString(box.getString("not_exp_tm"));*/
		String notRdo = "";
		String notTraf = "";
		String notPeriod = "";
		String notIssDt = "";
		String notIssTm = "";
		String notExpDt = "";
		String notExpTm = "";
		
		//etc
		/*String notStn = StringUtil.checkString(box.getString("not_stn"));
		String notFir = StringUtil.checkString(box.getString("not_fir"));
		String notCommnt = StringUtil.toKSC5601(box.getString("not_commnt"));*/
		String notStn = StringUtil.checkString(box.getString("icao_port"));
		String notFir = StringUtil.checkString(box.getString("icao_port"));
		String notCommnt = "";
		
		//Message Send Params
		String addrTxt = StringUtil.checkString(box.getString("addr_txt"));
		String originTxt = StringUtil.checkString(box.getString("origin_txt"));
		String acarsTxt = StringUtil.checkString(box.getString("acars_txt"));
		String mailFax = StringUtil.checkString(box.getString("mail_fax"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//ȸ 
			notStn = StringUtil.icaoChk(notStn);
			notFir = StringUtil.icaoChk(notFir);
			
			SupQ010BG params = new SupQ010BG();
			params.setMode(mode);
			params.setFlt_num(fltNum);
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setRte_id(rteId);
			params.setNot_num(notNum);
			params.setH_cat_all(hCatAll);
			params.setH_cat_no(hCatNo);
			params.setH_cat_in(hCatIn);
			params.setH_cat_aip(hCatAip);
			params.setH_cat_snow(hCatSnow);
			params.setH_cat_comm(hCatComm);
			params.setNot_rdo(notRdo);
			params.setNot_traf(notTraf);
			params.setNot_period(notPeriod);
			params.setNot_iss_dt(notIssDt);
			params.setNot_iss_tm(notIssTm);
			params.setNot_exp_dt(notExpDt);
			params.setNot_exp_tm(notExpTm);
			params.setNot_stn(notStn);
			params.setNot_fir(notFir);
			params.setNot_commnt(notCommnt);
			//2005.08.05 
			params.setArea_cd(areaCd);
			//2006.02.02 ߰
			params.setStn_fir_ok("Y");
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupQ010Main(params);
			
			if (hashData != null) {
				SupQ010BG sendParam = new SupQ010BG();
				sendParam.setMode(mode);
				sendParam.setFlt_num(fltNum);
				sendParam.setNot_num(notNum);
				sendParam.setDep_stn(depStn);
				sendParam.setArr_stn(arrStn);
				sendParam.setRte_id(rteId);
				sendParam.setArea_cd(areaCd);
				sendParam.setNot_stn(notStn);	//-->2005.10.07 
				sendParam.setNot_fir(notFir);		//-->2005.10.07 
				sendParam.setAddr_txt(addrTxt);
				sendParam.setOrigin_txt(originTxt);
				sendParam.setAcars_txt(acarsTxt);
				sendParam.setMail_fax(mailFax);
				
				WeaAllSL wea = (WeaAllSL)EJBFinder.lookup("ejb/WeaAllSL");
				boolean wxFlag = wea.sendNotamReq(sendParam,hashData);
				if (wxFlag) req.setAttribute("dataComplete","S");
				else throw new Exception("۽");
			} else throw new Exception("۽");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA110Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:SupA110Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask	

}
