package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;

/**
 * Q-NOTAM List Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/06/30 
 */
public class SupA130Serv extends PublicBaseServlet {

	/** 
	  * Q-NOTAM List ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/30 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA130Main();
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Q-NOTAM List", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			req.setAttribute("dataComplete","S");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA130Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA130Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Q-NOTAM List Է Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/01 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										   			 //Box ü 
		String msgSeq = StringUtil.checkString(box.getString("msg_seq"));
		String timeStmp = StringUtil.checkString(box.getString("timestmp"));
		String msgQ = StringUtil.checkString(box.getString("msg_q"));
		String notNum = StringUtil.checkString(box.getString("not_num"));
		String notCat = StringUtil.checkString(box.getString("not_cat"));
		String notOldNum = StringUtil.checkString(box.getString("not_old_num"));
		String msgA = StringUtil.checkString(box.getString("msg_a"));
		String notIss_dt = StringUtil.checkString(box.getString("msg_b"));
		String notExp_dt = StringUtil.checkString(box.getString("msg_c"));
		String notValid = StringUtil.checkString(box.getString("msg_d")).toUpperCase();
		String notText = StringUtil.checkString(box.getString("msg_e")).toUpperCase();
		String notOpenY = StringUtil.checkString(box.getString("not_open_y"));
		String notCommnt = StringUtil.checkString(box.getString("not_commnt")).toUpperCase();
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			SupA130BG params = new SupA130BG();
			params.setMsg_seq(msgSeq);
			params.setTimestmp(timeStmp);
			params.setMsg_q(msgQ);
			params.setNot_num(notNum);
			params.setNot_cat(notCat);
			params.setNot_old_num(notOldNum);
			params.setMsg_a(msgA);
			params.setNot_iss_dt(notIss_dt);
			params.setNot_exp_dt(notExp_dt);
			params.setNot_valid(notValid);
			params.setNot_text(notText);
			params.setNot_commnt(notCommnt);
			params.setNot_open_y(notOpenY);
			params.setUserid(UserInfo.getEmp_no());
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean insFlag = sl.updSupA130Main(params);
			req.setAttribute("notInput","D");
			req.setAttribute("dataComplete","U");
			
			/*
			// ȸ
			Hashtable hashData  = sl.selSupA130Main();
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Q-NOTAM List", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			*/
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA130Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:SupA130Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end updateTask		
	
	/** 
	  * Q-NOTAM List  Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/01 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										   			 //Box ü 
		String msgSeq = StringUtil.checkString(box.getString("msg_seq"));
		String timeStmp = StringUtil.checkString(box.getString("timestmp"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//Parameter 
			SupA130BG params = new SupA130BG();
			params.setMsg_seq(msgSeq);
			params.setTimestmp(timeStmp);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean delFlag = sl.delSupA130Item(params);
			req.setAttribute("notInput","D");
			req.setAttribute("dataComplete","D");
			
			/*
			// ȸ
			Hashtable hashData  = sl.selSupA130Main();
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Q-NOTAM List", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			*/
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA130Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA130Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask	
	
	/** 
	  * Q-NOTAM - OLD NOTAM   4ڸ ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2006/06/28 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		String msgA = StringUtil.checkString(box.getString("msg_a"));
		String notOldNum = StringUtil.checkString(box.getString("not_old_num"));
		
		try {
			//Parameter 
			SupA130BG params = new SupA130BG();
			params.setMsg_a(msgA);
			params.setNot_old_num(notOldNum);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA130OldNotam(params);
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA130Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SupA130Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
	/** 
	  * Q-NOTAM - OLD NOTAM   ó Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2006/06/28 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String msgSeq = StringUtil.checkString(box.getString("msg_seq"));
		String timeStmp = StringUtil.checkString(box.getString("timestmp"));
		String msgQ = StringUtil.checkString(box.getString("msg_q"));
		String notNum = StringUtil.checkString(box.getString("not_num"));
		String notCat = StringUtil.checkString(box.getString("not_cat"));	
		String notIss_dt = StringUtil.checkString(box.getString("msg_b"));
		String notExp_dt = StringUtil.checkString(box.getString("msg_c"));
		String notValid = StringUtil.checkString(box.getString("msg_d")).toUpperCase();
		String notText = StringUtil.checkString(box.getString("msg_e")).toUpperCase();
		String notOpenY = StringUtil.checkString(box.getString("not_open_y"));
		String notCommnt = StringUtil.checkString(box.getString("not_commnt")).toUpperCase();
		
		String[] chkData = req.getParameterValues("chkData");
		
		//User Info
		HttpSession session = req.getSession();
		SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
		
		try {
			
			for(int i=0 ; i<chkData.length ; i++){
				//Logger.debug.println(chkData[i]);
				String icaoPort = chkData[i].substring(0,4);
				String notOldNum = chkData[i].substring(4);
				
				//Parameter 
				SupA130BG params = new SupA130BG();
				
				params.setNot_old_num(notOldNum); //
				params.setMsg_a(icaoPort); 			//
				
				params.setMsg_seq(msgSeq);
				params.setTimestmp(timeStmp);
				params.setMsg_q(msgQ);
				params.setNot_num(notNum);
				params.setNot_cat(notCat);
				params.setNot_iss_dt(notIss_dt);
				params.setNot_exp_dt(notExp_dt);
				params.setNot_valid(notValid);
				params.setNot_text(notText);
				params.setNot_commnt(notCommnt);
				params.setNot_open_y(notOpenY);
				params.setUserid(UserInfo.getEmp_no());
				
				//EJB LookUp
				SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
				boolean insFlg = sl.updSupA130OldNotam(params);
			}
			
			//Parameter 
			SupA130BG pa = new SupA130BG();
				
			pa.setMsg_seq(msgSeq);
			pa.setTimestmp(timeStmp);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean delFlg = sl.delSupA130Item(pa);

			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA130Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA130Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask

}//end of class
