package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupA140BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * NOTAM Knowledge Base Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/07/28 
 */
public class SupA140Serv extends PublicBaseServlet {
	/** 
	  * NOTAM Knowledge Base Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/28 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String airport = StringUtil.checkString(box.getString("airport"));					//Airport
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SupA140BG params = new SupA140BG();
			params.setAirport(airport);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA140Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("NOTAM Knowledge", null, "", MessageCode.getInstance().SELECT_MSG));
			}
			req.setAttribute("airport",airport);
			req.setAttribute("hashData",hashData);
			req.setAttribute("chkParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA140Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA140Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * NOTAM Knowledge Base Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/28 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String icao_port = StringUtil.checkString(box.getString("airport"));
		String knowledge = StringUtil.DBInsStr(StringUtil.toKSC5601(box.getString("knowledge")));
		
		HttpSession session = req.getSession();
		
		try {
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = null;
			if (UserInfo != null) empNo = UserInfo.getEmp_no();
			
			SupA140BG params = new SupA140BG();
			params.setUserid(empNo);
			params.setAirport(icao_port);
			params.setKnowledge(knowledge);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.updSupA140Main(params);
			
			req.setAttribute("returnValue",String.valueOf(returnValue).toString());
			req.setAttribute("updOk",icao_port);
			
			if (returnValue == 1){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Airport Information", null, "", MessageCode.getInstance().INSERT_MSG));
			}else if (returnValue == 2){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Airport Information", null, "", MessageCode.getInstance().UPDATE_MSG));
			}else if(returnValue != 1 && returnValue != 2 && returnValue != 8 && returnValue != 9){
				req.setAttribute("errorMessage",MessageCode.getInstance().UPDATE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA140Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA140Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
	
	/** 
	  * NOTAM Knowledge Base Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/28 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		String icao_port = StringUtil.checkString(box.getString("airport"));
		
		HttpSession session = req.getSession();
		
		try {
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = null;
			if (UserInfo != null) empNo = UserInfo.getEmp_no();
			
			SupA140BG params = new SupA140BG();
			params.setUserid(empNo);
			params.setAirport(icao_port);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.delSupA140Main(params);
			
			req.setAttribute("returnValue",String.valueOf(returnValue).toString());
			if (returnValue == 3){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("NOTAM Knowledge Base", null, "", MessageCode.getInstance().DELETE_MSG));
			}else if(returnValue != 3 && returnValue != 8 && returnValue != 9){
				req.setAttribute("errorMessage",MessageCode.getInstance().DELETE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA140Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA140Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask
}
