package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import java.io.*;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupA330BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * SIG WEATHER LIST Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/07/04 
 */
public class SupA330Serv extends PublicBaseServlet {
	/** 
	  * SIG WEATHER LIST Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/04 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
    	
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SupA330BG params = new SupA330BG();

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selAreaWxCond(params);
			req.setAttribute("areaCond",hashData);
			req.setAttribute("selCond","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA330Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SupA330Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
	/** 
	  * SIG WEATHER LIST Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/05 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
    	
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String[] type = new String[3];
		type[0] = StringUtil.checkString(box.getString("type1"));
		type[1] = StringUtil.checkString(box.getString("type2"));
		type[2] = StringUtil.checkString(box.getString("type3")); 
		String wx_cond1 = StringUtil.checkString(box.getString("wx_cond1"));
		String wx_cond2 = StringUtil.checkString(box.getString("wx_cond2"));
		String radio_bu = StringUtil.checkString(box.getString("radio_bu"));
		String airport = StringUtil.checkString(box.getString("airport"));
		String area = StringUtil.toKSC5601(StringUtil.checkString(box.getString("area")));
		String begin_dt1 = StringUtil.checkString(box.getString("begin_dt1"));
		String begin_dt2 = StringUtil.checkString(box.getString("begin_dt2"));
		String end_dt1 = StringUtil.checkString(box.getString("end_dt1"));
		String end_dt2 = StringUtil.checkString(box.getString("end_dt2"));
		
    	String type_tot = "";
		for(int i = 0 ; i <3 ; i++){
	    	if(!type[i].equals("")){
	    		if(type_tot.equals(""))	type_tot =  "'" + type[i] + "'";
	    		else type_tot = type_tot + ",'" + type[i] + "'";
	    	}
		}
		String wx_cond = "";
		if(wx_cond1.equals("")){
			if(!wx_cond2.equals("")) wx_cond = "'" + wx_cond2 + "'";
		}else{
			wx_cond = "'" + wx_cond1 + "'";
			if(!wx_cond2.equals("")) wx_cond = wx_cond + ",'" + wx_cond2 + "'";
		}
		String begin_dt = begin_dt1 + begin_dt2;
		String end_dt = end_dt1 + end_dt2;
		
		try {
			SupA330BG params = new SupA330BG();
			
			params.setType(type_tot);
			params.setWx_cond(wx_cond);
			params.setRadio_bu(radio_bu);
			params.setIcao_port(airport);
			params.setArea_cd(area);
			params.setBegin_dt(begin_dt);
			params.setEnd_dt(end_dt);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA330Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SIG WEATHER LIST", hashData, "SIGWX", MessageCode.getInstance().DATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			req.setAttribute("chkParam", "Y");
					
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA330Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA330Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * WEATHER LIST Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/06 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		String savePath = "base/sup/sig_weather";
		//String savePath = MessageCode.getInstance().IMG_SAVE_PATH+"sup/sig_weather";
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		String[] chkDel = req.getParameterValues("chkDel");
		String[] icao_arr = new String[chkDel.length];
		String[] typ_arr = new String[chkDel.length];
		String[] begin_arr = new String[chkDel.length];
		
		for(int i=0 ; i<chkDel.length ; i++){
			icao_arr[i] = StringUtil.checkString(box.getString("icao_hid"+chkDel[i]));
			typ_arr[i] = StringUtil.checkString(box.getString("typ_hid"+chkDel[i]));
			begin_arr[i] = StringUtil.checkString(box.getString("begin_hid"+chkDel[i]));
		}
		
		try {
			
			SupA330BG params = new SupA330BG();
			params.setIcao_arr(icao_arr);
			params.setTyp_arr(typ_arr);
			params.setBegin_arr(begin_arr);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.delSupA330Main(params);
			
			String returnValue = "";
			if (hashData != null) {
				returnValue = (String)hashData.get("RETURN");
				
				List delFile = (List)hashData.get("DELFILE");
				if (delFile != null) {
					for (int i=0; i<delFile.size(); i++) {
						
						// 
						File d = new File(savePath+"/"+((SupA330BG)delFile.get(i)).getChart_file());
			            d.delete();
			    		d = null;
					}
				}
			}
			req.setAttribute("returnValue",returnValue);
			if (returnValue.equals("1")){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SIG WEATHER LIST", null, "", MessageCode.getInstance().DELETE_MSG));
			}else{
				req.setAttribute("errorMessage",MessageCode.getInstance().DELETE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA330Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA330Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask
	
	/** 
	  * WEATHER LIST Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/11 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		String savePath = "base/sup/sig_weather";
		//String savePath = MessageCode.getInstance().IMG_SAVE_PATH+"sup/sig_weather";
		
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		String airport_detail = StringUtil.checkString(box.getString("airport_detail"));
		String type_detail = StringUtil.checkString(box.getString("type_detail"));
		String wx_cond1_detail = StringUtil.checkString(box.getString("wx_cond1_detail"));
		String wx_cond2_detail = StringUtil.checkString(box.getString("wx_cond2_detail"));
		String begin_dt1_detail = StringUtil.checkString(box.getString("begin_dt1_detail"));
		String begin_dt2_detail = StringUtil.checkString(box.getString("begin_dt2_detail"));
		String end_dt1_detail = StringUtil.checkString(box.getString("end_dt1_detail"));
		String end_dt2_detail = StringUtil.checkString(box.getString("end_dt2_detail"));
		String duration_detail = StringUtil.checkString(box.getString("duration_detail"));
		String text_detail = StringUtil.DBInsStr(StringUtil.toKSC5601(box.getString("text_detail")));
		
		String[] fileDel = req.getParameterValues("fileDel");
		
		HttpSession session = req.getSession();
		
		try {
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = null;
			if (UserInfo != null) empNo = UserInfo.getEmp_no();
			
			SupA330BG params = new SupA330BG();
			params.setIcao_port(airport_detail);
			params.setType(type_detail);
			params.setWx_cond1(wx_cond1_detail);
			params.setWx_cond2(wx_cond2_detail);
			params.setBegin_dt(begin_dt1_detail + begin_dt2_detail);
			params.setEnd_dt(end_dt1_detail + end_dt2_detail);
			params.setDuration(duration_detail);
			params.setWx_text(text_detail);
			params.setFile_arr(fileDel);
			params.setEmp_no(empNo);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.updSupA330Main(params);
			
			req.setAttribute("returnValue",String.valueOf(returnValue).toString());
			if (returnValue == 2){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SIG WEATHER LIST", null, "", MessageCode.getInstance().INSERT_MSG));
			}else if (returnValue == 3){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SIG WEATHER LIST", null, "", MessageCode.getInstance().UPDATE_MSG));
				
				if(fileDel != null){
					String[] fileName = new String[fileDel.length];
					for(int i=0 ; i<fileDel.length ; i++){
						fileName[i] = StringUtil.toKSC5601(StringUtil.checkString(box.getString(fileDel[i])));
						//Logger.debug.println("fileName===>"+fileName[i]);
						
						// 
						File d = new File(savePath+"/"+fileName[i]);
			            d.delete();
			    		d = null;
					}
				}
			}else if(returnValue != 1 && returnValue != 2 && returnValue != 3){
				req.setAttribute("errorMessage",MessageCode.getInstance().UPDATE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA330Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA330Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
	
	/** 
	  * WEATHER LIST Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/11 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
			
		String savePath = "base/sup/sig_weather";
		//String savePath = MessageCode.getInstance().IMG_SAVE_PATH+"sup/sig_weather";
		
		File fdDOC = new File(savePath);
		if (!fdDOC.exists()) fdDOC.mkdir();
			
	    int saveSize = 10 * 1024 * 1024;		// ==>  ũ  : 10ް
	        
	    MultipartData  multi = new MultipartData(req, savePath, saveSize);
	    Enumeration files = multi.getFileNames();
	        
	    // Using key = value INPUT parameters.
	    Box box = multi.getBox();
	        
	    String returnPage = StringUtil.checkString(box.get("returnPage"));
	    String airport_detail = StringUtil.checkString(box.get("airport_detail"));
	    String type_detail = StringUtil.checkString(box.get("type_detail"));
	    String begin_dt1_detail = StringUtil.checkString(box.get("begin_dt1_detail"));
	    String begin_dt2_detail = StringUtil.checkString(box.get("begin_dt2_detail"));
	        
		try {
			HttpSession session = req.getSession();
				
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = "";
			if (UserInfo != null) empNo = UserInfo.getEmp_no();
	        
	        //ε =====================================================
			String name = "";
			String fileName = "";
			String type = "";
			
		    while (files.hasMoreElements()) {
		        
		    	name = (String)files.nextElement();
		        fileName = multi.getFilesystemName(name);
		        type = multi.getFileContentType(name);

		        if(fileName != null){
				
					SupA330BG params = new SupA330BG();
					params.setIcao_port(airport_detail);
					params.setType(type_detail);
					params.setBegin_dt(begin_dt1_detail+begin_dt2_detail);
					params.setChart_file(fileName);
					params.setEmp_no(empNo);
					
					//EJB LookUp
					SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
					String newFileName = sl.attchFile(params);
				    
				    if(!newFileName.equals("")){
				    	//Logger.debug.println("escape=====>"+newFileName);
				    	newFileName = StringUtil.unescape(newFileName);
				    	//Logger.debug.println("unescape===>"+newFileName);
				    	
				    	req.setAttribute("successMessage",ComUtil.getInstance().getMessage("SIG WEATHER FILE", null, "", MessageCode.getInstance().INSERT_MSG));
				    	req.setAttribute("returnValue","1");
				    	
				    	//rename
					    File oldF = multi.getFile(name);
					  	File newF = new File(savePath+"/"+newFileName);
					    oldF.renameTo(newF); 
					    
				    }else{
				    	req.setAttribute("errorMessage",MessageCode.getInstance().INSERT_MSG);
				    }
		        }
			}
			//===================================================================
			
			//unknown 
	        File unknown = new File(savePath+"/unknown");
	        unknown.delete();
	    	unknown = null;
		            
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA330Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:SupA330Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask
}
