package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.*;
import kal.base.wea.ejb.WeaAllSL;

/**
 * WEATHER INPUT Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/08/22 
 */
public class SupA340Serv extends PublicBaseServlet {
	
	/** 
	  * WEATHER INPUT Է Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/08/22 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										   			 //Box ü 
		String msgTyp = StringUtil.checkString(box.getString("msg_typ"));
		String msgText = StringUtil.checkString(box.getString("msg_text"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//Parameter 
			SupA340BG params = new SupA340BG();
			params.setMsg_typ(msgTyp);
			params.setMsg_text(msgText);
			
			//EJB LookUp
			WeaAllSL sl = (WeaAllSL)EJBFinder.lookup("ejb/WeaAllSL");
			SupA340BG entity = sl.insSupA340Main(params);
			req.setAttribute("entity",entity);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA340Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:SupA340Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end insertTask		

}
