package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupA610BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * Airport Information Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/06/02 
 */
public class SupA610Serv extends PublicBaseServlet {
	/** 
	  * Airport Information Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/02 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String airport = StringUtil.checkString(box.getString("airport"));					//Airport
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SupA610BG params = new SupA610BG();
			params.setAirport(airport);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA610Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Airport Information", null, "", MessageCode.getInstance().SELECT_MSG));
			}
			req.setAttribute("airport",airport);
			req.setAttribute("hashData",hashData);
			req.setAttribute("chkParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA610Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA610Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Airport Information Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/03 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		String iata_port = StringUtil.checkString(box.getString("iata_port"));
		String icao_port = StringUtil.checkString(box.getString("icao_port"));
		String nat_cd = StringUtil.checkString(box.getString("nat_cd"));
		String fir_cd = StringUtil.checkString(box.getString("fir_cd"));
		String port_e = StringUtil.DBInsStr(StringUtil.checkString(StringUtil.toKSC5601(box.getString("port_e"))));
		String wx_active = StringUtil.checkString(box.getString("wx_active"));
		String curfew1 = StringUtil.checkString(box.getString("curfew1"));
		String curfew2 = StringUtil.checkString(box.getString("curfew2"));
		String curfew = curfew1 + curfew2;
		String notActive = StringUtil.checkString(box.getString("notActive"));
		String coord_x1 = StringUtil.checkString(box.getString("coord_x1"));
		String coord_y1 = StringUtil.checkString(box.getString("coord_y1"));
		String coord_x2 = StringUtil.checkString(box.getString("coord_x2"));
		String coord_y2 = StringUtil.checkString(box.getString("coord_y2"));
		
		String op_company1 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_company1")));
		String op_company2 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_company2")));
		String op_callsign1 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_callsign1")));
		String op_callsign2 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_callsign2")));
		String op_freq1 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_freq1")));
		String op_freq2 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_freq2")));
		String op_tel1 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_tel1")));
		String op_tel2 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_tel2")));
		String op_fax1 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_fax1")));
		String op_fax2 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_fax2")));
		String op_1st_sita1 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_1st_sita1")));
		String op_2nd_sita1 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_2nd_sita1")));
		String op_1st_sita2 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_1st_sita2")));
		String op_2nd_sita2 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_2nd_sita2")));
		String op_email1 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_email1")));
		String op_email2 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("op_email2")));
		
		String htl_crw_lov1 = StringUtil.DBInsStr(StringUtil.toKSC5601(box.getString("htl_crw_lov1")));
		String htl_crw_lov2 = StringUtil.DBInsStr(StringUtil.toKSC5601(box.getString("htl_crw_lov2")));
		String htl_tel1 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("htl_tel1")));
		String htl_tel2 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("htl_tel2")));
		String htl_fax1 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("htl_fax1")));
		String htl_fax2 = StringUtil.DBInsStr(StringUtil.checkString(box.getString("htl_fax2")));
		
		String rwy_info = StringUtil.DBInsStr(StringUtil.toKSC5601(box.getString("rwy_info"))); //2010.02.10 ߰
		
		HttpSession session = req.getSession();
		
		try {
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = null;
			if (UserInfo != null) empNo = UserInfo.getEmp_no();
			
			SupA610BG params = new SupA610BG();
			params.setEmp_no(empNo);
			params.setIata_port(iata_port);
			params.setIcao_port(icao_port);
			params.setNat_cd(nat_cd);
			params.setFir_cd(fir_cd);
			params.setPort_e(port_e);
			params.setWx_active(wx_active);
			params.setCurfew(curfew);
			params.setNot_active(notActive);
			params.setCoord_x1(coord_x1);
			params.setCoord_y1(coord_y1);
			params.setCoord_x2(coord_x2);
			params.setCoord_y2(coord_y2);
			
			params.setOp_company1(op_company1);
			params.setOp_company2(op_company2);
			params.setOp_callsign1(op_callsign1);
			params.setOp_callsign2(op_callsign2);
			params.setOp_freq1(op_freq1);
			params.setOp_freq2(op_freq2);
			params.setOp_tel1(op_tel1);
			params.setOp_tel2(op_tel2);
			params.setOp_fax1(op_fax1);
			params.setOp_fax2(op_fax2);
			params.setOp_1st_sita1(op_1st_sita1);
			params.setOp_2nd_sita1(op_2nd_sita1);
			params.setOp_1st_sita2(op_1st_sita2);
			params.setOp_2nd_sita2(op_2nd_sita2);
			params.setOp_email1(op_email1);
			params.setOp_email2(op_email2);
						
			params.setHtl_crw_lov1(htl_crw_lov1);
			params.setHtl_crw_lov2(htl_crw_lov2);
			params.setHtl_tel1(htl_tel1);
			params.setHtl_tel2(htl_tel2);
			params.setHtl_fax1(htl_fax1);
			params.setHtl_fax2(htl_fax2);
			
			params.setRwy_info(rwy_info); //2010.02.10 ߰

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.updSupA610Main(params);
			
			req.setAttribute("returnValue",String.valueOf(returnValue).toString());
			req.setAttribute("updOk",iata_port);
			
			if (returnValue == 1){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Airport Information", null, "", MessageCode.getInstance().INSERT_MSG));
			}else if (returnValue == 2){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Airport Information", null, "", MessageCode.getInstance().UPDATE_MSG));
			}else if(returnValue != 1 && returnValue != 2 && returnValue != 3 && returnValue != 4 && returnValue != 5 && returnValue != 6 && returnValue != 7){
				req.setAttribute("errorMessage",MessageCode.getInstance().UPDATE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA610Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA610Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
	
	/** 
	  * Airport Information Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/07 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		String iata_port = StringUtil.checkString(box.getString("iata_port"));
		String icao_port = StringUtil.checkString(box.getString("icao_port"));
		
		try {
			
			SupA610BG params = new SupA610BG();
			params.setIata_port(iata_port);
			params.setIcao_port(icao_port);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.delSupA610Main(params);
			
			req.setAttribute("returnValue",String.valueOf(returnValue).toString());
			if (returnValue == 8){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Airport Information", null, "", MessageCode.getInstance().DELETE_MSG));
			}else{
				req.setAttribute("errorMessage",MessageCode.getInstance().DELETE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA610Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA610Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask
}
