package kal.base.sup.serv;


import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupA620BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * Airport RWY Information Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/06/07 
 */
public class SupA620Serv extends PublicBaseServlet {
	/** 
	  * Airport RWY Information Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/07 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String airport = StringUtil.checkString(box.getString("airport"));					//Airport
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SupA620BG params = new SupA620BG();
			params.setAirport(airport);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA620Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Airport RWY Information", null, "", MessageCode.getInstance().SELECT_MSG));
			}
			req.setAttribute("airport",airport);
			req.setAttribute("hashData",hashData);
			req.setAttribute("chkParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA620Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA620Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * Airport RWY Information Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/08 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		String icao_hid = StringUtil.checkString(box.getString("icao_hid"));
		String airport = StringUtil.checkString(box.getString("airport"));
		
		String etop_vis_limit = StringUtil.checkString(box.getString("etop_vis_limit")); 
		String etop_cig_limit = StringUtil.checkString(box.getString("etop_cig_limit")); 
		String etop_wind_limit = StringUtil.checkString(box.getString("etop_wind_limit")); 
		String wx_addr1 = StringUtil.checkString(box.getString("wx_addr1")); 
		String wx_addr2 = StringUtil.checkString(box.getString("wx_addr2")); 
		String wx_addr3 = StringUtil.checkString(box.getString("wx_addr3")); 
		String wx_addr = wx_addr1 + " " + wx_addr2 + " " + wx_addr3;
		
		String t_dir = "";
		String t_leng = "";
		String t_width = "";
		String t_usable = "";
		String t_wet_usable = "";
		String t_apprch = "";
		String t_vis_limit = "";
		String t_rvr_limit = "";
		String t_cig_limit = "";
		String t_cir_vis_limit = "";
		String t_cir_cig_limit = "";
		String t_twind_limit = "";
		String t_cwind_limit = "";
		String t_wet_twind_limit = "";
		String t_wet_cwind_limit = "";
		
		String[] dir = req.getParameterValues("dir");
		String[] leng = req.getParameterValues("leng");
		String[] width = req.getParameterValues("width");
		String[] usable = req.getParameterValues("usable");
		String[] wet_usable = req.getParameterValues("wet_usable");
		String[] apprch = req.getParameterValues("apprch");
		String[] vis_limit = req.getParameterValues("vis_limit");
		String[] rvr_limit = req.getParameterValues("rvr_limit");
		String[] cig_limit = req.getParameterValues("cig_limit");
		String[] cir_vis_limit = req.getParameterValues("cir_vis_limit");
		String[] cir_cig_limit = req.getParameterValues("cir_cig_limit");
		String[] twind_limit = req.getParameterValues("twind_limit");
		String[] cwind_limit = req.getParameterValues("cwind_limit");
		String[] wet_twind_limit = req.getParameterValues("wet_twind_limit");
		String[] wet_cwind_limit = req.getParameterValues("wet_cwind_limit");
		
		int cnt = 0;
		for(int x=0 ; x<8 ; x++){
			if(!dir[x].equals("")){
				
				t_dir = t_dir + StringUtil.checkString(dir[x]) + ",";
				t_leng = t_leng + StringUtil.checkString(leng[x]) + ",";
				t_width = t_width + StringUtil.checkString(width[x]) + ",";
				t_usable = t_usable + StringUtil.checkString(usable[x]) + ",";
				t_wet_usable = t_wet_usable + StringUtil.checkString(wet_usable[x]) + ",";
				t_apprch = t_apprch + StringUtil.checkString(apprch[x]) + ",";
				t_vis_limit = t_vis_limit + StringUtil.checkString(vis_limit[x]) + ",";
				t_rvr_limit = t_rvr_limit + StringUtil.checkString(rvr_limit[x]) + ",";
				t_cig_limit = t_cig_limit + StringUtil.checkString(cig_limit[x]) + ",";
				t_cir_vis_limit = t_cir_vis_limit + StringUtil.checkString(cir_vis_limit[x]) + ",";
				t_cir_cig_limit = t_cir_cig_limit + StringUtil.checkString(cir_cig_limit[x]) + ",";
				t_twind_limit = t_twind_limit + StringUtil.checkString(twind_limit[x]) + ",";
				t_cwind_limit = t_cwind_limit + StringUtil.checkString(cwind_limit[x]) + ",";
				t_wet_twind_limit = t_wet_twind_limit + StringUtil.checkString(wet_twind_limit[x]) + ",";
				t_wet_cwind_limit = t_wet_cwind_limit + StringUtil.checkString(wet_cwind_limit[x]) + ",";
				
				cnt++;
			}
		}
	
		HttpSession session = req.getSession();
		
		try {
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = null;
			if (UserInfo != null) empNo = UserInfo.getEmp_no();
			
			SupA620BG params = new SupA620BG();
			
			params.setEmp_no(empNo);
			params.setIcao_port(icao_hid);
			params.setCnt(String.valueOf(cnt).toString());
			params.setRwy_dir(t_dir);
			params.setRwy_leng(t_leng);
			params.setRwy_width(t_width);
			params.setRwy_usable(t_usable);
			params.setRwy_wet_usable(t_wet_usable);
			params.setRwy_apprch(t_apprch);
			params.setRwy_vis_limit(t_vis_limit);
			params.setRwy_rvr_limit(t_rvr_limit);
			params.setRwy_cig_limit(t_cig_limit);
			params.setRwy_cirapp_vis_limit(t_cir_vis_limit);
			params.setRwy_cirapp_cig_limit(t_cir_cig_limit);
			params.setRwy_twind_limit(t_twind_limit);
			params.setRwy_cwind_limit(t_cwind_limit);
			params.setRwy_twind_wet_limit(t_wet_twind_limit);
			params.setRwy_cwind_wet_limit(t_wet_cwind_limit);
			
			params.setEtop_vis_limit(etop_vis_limit);
			params.setEtop_cig_limit(etop_cig_limit);
			params.setEtop_wind_limit(etop_wind_limit);
			params.setWx_addr(wx_addr);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.updSupA620Main(params);
			
			if(returnValue == 1){ req.setAttribute("returnValue","1"); }
			req.setAttribute("updOk", airport);
			
			if (returnValue == 1){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Airport RWY Information", null, "", MessageCode.getInstance().UPDATE_MSG));
			}else {
				req.setAttribute("errorMessage",MessageCode.getInstance().UPDATE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA620Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA620Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
}
