package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import java.io.*;
import java.net.URLEncoder;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupA630BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * FIR Information Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/05/20 
 */
public class SupA630Serv extends PublicBaseServlet{
	/** 
	  * FIR Information Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/20 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 

		String firCd = StringUtil.checkString(box.getString("firCd"));						//FIR_CD
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SupA630BG params = new SupA630BG();
			params.setFir_cd(firCd);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selSupA630Main(params);
			if (hashData != null){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("FIR Information", null, "", MessageCode.getInstance().SELECT_MSG));
			}
			req.setAttribute("hashData",hashData);
			req.setAttribute("chkParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA630Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA630Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
	
	/** 
	  * FIR Information Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/24 
	  */	
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
        Box box = HttpUtility.getBox(req);
        
        String returnPage = StringUtil.checkString(box.getString("returnPage"));
        String firCd = StringUtil.checkString(box.getString("firCd"));						//FIR_CD
		String firE = StringUtil.DBInsStr(StringUtil.checkString(box.getString("firE")));	//FIR_NAME
		String natCd = StringUtil.checkString(box.getString("natCd"));					//NAT_CD
		String notActive = StringUtil.checkString(box.getString("notActive"));			//NOT_ACTIVE

		String dep = "";																					//DEP_STN
		String arr = "";																					//ARR_STN
		String rte = "";																					//RTE_CD	
    	
    	ArrayList firRte = new ArrayList();
		for(int i=1 ; i <=50 ; i++){
			if(!StringUtil.checkString(box.getString("dep" + i)).equals("")){ 
				firRte.add(StringUtil.checkString(box.getString("dep" + i)) + StringUtil.checkString(box.getString("arr" + i)) + StringUtil.checkString(box.getString("rte" + i)));
			}
		}
		
		String[] fr = new String[firRte.size()];
		for (int i=0 ; i<firRte.size() ; i++){
        	fr[i] = (String)firRte.get(i);
		}
		
		HttpSession session = req.getSession();
		
		try {
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String empNo = null;
			if (UserInfo != null) empNo = UserInfo.getEmp_no();
			
			SupA630BG params = new SupA630BG();
			params.setEmp_no(empNo);
			params.setFir_cd(firCd);
			params.setFir_e(firE);
			params.setNat_cd(natCd);
			params.setNot_active(notActive);
			params.setFir_rte(fr);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.updSupA630Main(params);
			
			req.setAttribute("firCd", firCd);
			
			if (returnValue == 1){
				req.setAttribute("returnValue",String.valueOf(returnValue).toString());
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("FIR Information", null, "", MessageCode.getInstance().UPDATE_MSG));
			
			}else if(returnValue == 2 || returnValue == 3){ 	
				req.setAttribute("returnValue",String.valueOf(returnValue).toString());	
			
			}else{	
				
				req.setAttribute("errorMessage",MessageCode.getInstance().UPDATE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA630Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA630Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask
	
	/** 
	  * FIR Information Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/26 
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		String firCd = StringUtil.checkString(box.getString("firCd"));				//FIR_CD
		
		try {
			SupA630BG params = new SupA630BG();
			params.setFir_cd(firCd);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			int returnValue = sl.delSupA630Main(params);
			
			if(returnValue == 4){ req.setAttribute("returnValue","4"); }
			else if(returnValue == 5){ req.setAttribute("returnValue","5"); }
			
			if (returnValue == 4){
				req.setAttribute("successMessage",ComUtil.getInstance().getMessage("FIR Information", null, "", MessageCode.getInstance().DELETE_MSG));

			}else if(returnValue != 4 && returnValue != 5){
				req.setAttribute("errorMessage",MessageCode.getInstance().DELETE_MSG);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA630Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA630Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end deleteTask
}
