package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import com.ibm.CORBA.iiop.Response;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;
import kal.base.sys.dbbean.*;

/**
 * BASE2 Company Route Information ȸ / Է /  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/05/23 HIST  
 */
public class SupA640Serv extends PublicBaseServlet{

	/** 
	  * BASE2 Company Route Information ȸ Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/23 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));				//Return Page ȹ
		
		String depStn = StringUtil.checkString(box.getString("dep_stn")).toUpperCase();		//DEP Station
		String arrStn = StringUtil.checkString(box.getString("arr_stn")).toUpperCase();			//ARR Station
		String rteCd = StringUtil.checkString(box.getString("rte_cd")).toUpperCase();				//RTE Code
		String hidRteCd = StringUtil.checkString(box.getString("hidRteCd")).toUpperCase();	//Selected RTE Code
		
		HttpSession session = req.getSession();
		
		try {
			//Route Code   ->2005/10/06 
 			//rte_cd ĭ ƴ 쿡 rte_cd ,
 			//rte_cd ĭ 쿡 sel_rte_cd ,
 			//sel_rte_cd  ĭ 쿡 'P001' .
 			String s_rteCd = "";
			
			if (rteCd.equals("")) {
				if (hidRteCd.equals("")) {
					s_rteCd = "P001"; 
				} else {
					s_rteCd = hidRteCd;
				}
			} else {
				s_rteCd = rteCd;
			}
			
			//Parameter Return
			req.setAttribute("depStn",depStn);
			req.setAttribute("arrStn",arrStn);
			req.setAttribute("rteCd",s_rteCd);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			//ȸStation Check
			boolean depFlag = sl.selStation(depStn);
			if (depFlag == false) throw new Exception("Invalid Departure Station!!");
			boolean arrFlag = sl.selStation(arrStn);
			if (arrFlag == false) throw new Exception("Invalid Arrival Station!!");
			
			//Parameter 
			SupA640BG params = new SupA640BG();
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setRte_cd(s_rteCd);
			
			//EJB LookUp
			Hashtable hashData = sl.selSupA640Main(params);
			if (hashData != null) {
				SupA640BG entity = (SupA640BG)hashData.get("CRINFO");
				if (entity != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Company Route Information", null, "", MessageCode.getInstance().SELECT_MSG));
				else req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Company Route Information", null, "", MessageCode.getInstance().NULLDATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			req.setAttribute("mode","select");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA640Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA640Serv:selectTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
	/** 
	  * BASE2 Company Route Information Է Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/23 HIST  
	  */		
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 																		//Box ü 
		String returnPage = StringUtil.checkString(box.getString("returnPage"));								//Return Page ȹ
		String depStn = StringUtil.checkString(box.getString("dep_stn")).toUpperCase();					//DEP Station
		String arrStn = StringUtil.checkString(box.getString("arr_stn")).toUpperCase();						//ARR Station
		String rteCd = StringUtil.checkString(box.getString("rte_cd")).toUpperCase();							//RTE Code
		String hidRteCd = StringUtil.checkString(box.getString("hidRteCd")).toUpperCase();				//Selected RTE Code
		//String[] rteStn = req.getParameterValues("rte_stn");														//RTE Station List
		String rteStn = StringUtil.checkString(box.getString("rte_stn")).toUpperCase();
		
		HttpSession session = req.getSession();
		
		try {
			//Route Code   ->2005/10/06 
 			//rte_cd ĭ ƴ 쿡 rte_cd ,
 			//rte_cd ĭ 쿡 sel_rte_cd ,
 			//sel_rte_cd  ĭ 쿡 'P001' .
 			String s_rteCd = "";
			
			if (rteCd.equals("")) {
				if (hidRteCd.equals("")) {
					s_rteCd = "P001"; 
				} else {
					s_rteCd = hidRteCd;
				}
			} else {
				s_rteCd = rteCd;
			}
			
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter Return
			req.setAttribute("depStn",depStn);
			req.setAttribute("arrStn",arrStn);
			req.setAttribute("rteCd",s_rteCd);
			
			// ĸ ͸ ĭ ٲش.
			StringBuffer rteTemp = new StringBuffer();
		    for(int a=0; a < rteStn.length(); a++) {
		    	if(rteStn.charAt(a) == '\n') rteTemp.append(" ");
		    	else if(rteStn.charAt(a) == '\r') rteTemp.append(" ");
		    	else if(rteStn.charAt(a) == ',') rteTemp.append(" ");
		    	else	rteTemp.append(rteStn.charAt(a));
		    }
		    rteStn = rteTemp.toString();
			
			// ĭ ؼ Ѱ ´.
			StringTokenizer st = new StringTokenizer(rteStn, " ");
			if (st.countTokens() > 70) throw new Exception("Over 70 RTE Stations!!"); 
			String[] stn_arr = new String[st.countTokens()];
			int iCnt = 0;
			while(st.hasMoreTokens()) {
			        stn_arr[iCnt] = st.nextToken();
			        //int dupChk = rteStr.indexOf(stn_arr[iCnt]);
			        //if (dupChk != 1) throw new Exception("Duplicate RTE Station : "+stn_arr[iCnt]);
			        iCnt = iCnt + 1;
			}
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			//Parameter 
			SupA640BG params = new SupA640BG();
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setRte_cd(s_rteCd);
			params.setRte_stn(stn_arr);
			params.setUser_id(UserInfo.getEmp_no());
			
			//EJB LookUp
			boolean insFlag = sl.insSupA640Main(params);
			req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Company Route Information", null, "", MessageCode.getInstance().INSERT_MSG));
			req.setAttribute("mode","insert");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA640Serv:insertTask1] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:SupA640Serv:insertTask2] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end of function	
	
	/** 
	  * BASE2 Company Route Information  Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/23 HIST  
	  */		
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));						//Return Page ȹ
		String depStn = StringUtil.checkString(box.getString("dep_stn")).toUpperCase();			//DEP Station
		String arrStn = StringUtil.checkString(box.getString("arr_stn")).toUpperCase();				//ARR Station
		String rteCd = StringUtil.checkString(box.getString("rte_cd")).toUpperCase();					//RTE Code
		String hidRteCd = StringUtil.checkString(box.getString("hidRteCd")).toUpperCase();		//Selected RTE Code
		
		HttpSession session = req.getSession();
		
		try {
			//Route Code   ->2005/10/06 
 			//rte_cd ĭ ƴ 쿡 rte_cd ,
 			//rte_cd ĭ 쿡 sel_rte_cd ,
 			//sel_rte_cd  ĭ 쿡 'P001' .
 			String s_rteCd = "";
			
			if (rteCd.equals("")) {
				if (hidRteCd.equals("")) {
					s_rteCd = "P001"; 
				} else {
					s_rteCd = hidRteCd;
				}
			} else {
				s_rteCd = rteCd;
			}
			
			//Parameter Return
			req.setAttribute("depStn",depStn);
			req.setAttribute("arrStn",arrStn);
			req.setAttribute("rteCd",s_rteCd);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			//Parameter 
			SupA640BG params = new SupA640BG();
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setRte_cd(s_rteCd);
			
			//EJB LookUp
			boolean delFlag = sl.delSupA640Main(params);
			req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Company Route Information", null, "", MessageCode.getInstance().DELETE_MSG));
			req.setAttribute("mode","delete");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA640Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA640Serv:deleteTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end of function	
		
	/** 
	  * Route Id ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/10/05  
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 															//Box ü 
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));					//Return Page ȹ
		
		String depStn = StringUtil.checkString(box.getString("dep_hid")).toUpperCase();		//DEP Station
		String arrStn = StringUtil.checkString(box.getString("arr_hid")).toUpperCase();			//ARR Station
		String rteCd = StringUtil.checkString(box.getString("rte_cd"));
		
		try {	
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			//ȸStation Check
			boolean depFlag = sl.selStation(depStn);
			if (depFlag == false) throw new Exception("Invalid Departure Station!!");
			boolean arrFlag = sl.selStation(arrStn);
			if (arrFlag == false) throw new Exception("Invalid Arrival Station!!");
			
			//Parameter 
			SupA640BG params = new SupA640BG();
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			
			//EJB LookUp
			Hashtable hashData = sl.selRteCd(params);
			
			req.setAttribute("hashData",hashData);
			req.setAttribute("chkValue","Y");
			req.setAttribute("rteCd", rteCd);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA640Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SupA640Serv:checkTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end of function
	
}//end of class
