package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import com.ibm.CORBA.iiop.Response;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;
import kal.base.sys.dbbean.*;

/**
 * BASE2 ETOP Airport Management ȸ / Է /  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/05/27 HIST  
 */
public class SupA650Serv  extends PublicBaseServlet{
	/** 
	  * BASE2 ETOP Airport Management ȸ Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/27 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String depStn = StringUtil.checkString(box.getString("dep_stn")).toUpperCase();					//DEP Station
		String arrStn = StringUtil.checkString(box.getString("arr_stn")).toUpperCase();					//ARR Station
		String returnPage = StringUtil.checkString(box.getString("returnPage"));								//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//Parameter Return
			req.setAttribute("depStn",depStn);
			req.setAttribute("arrStn",arrStn);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			//ȸStation Check
			boolean depFlag = sl.selStation(depStn);
			if (depFlag == false) throw new Exception("Invalid Departure Station!!");
			boolean arrFlag = sl.selStation(arrStn);
			if (arrFlag == false) throw new Exception("Invalid Arrival Station!!");
			
			//Parameter 
			SupA650BG params = new SupA650BG();
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			
			//EJB LookUp
			Hashtable hashData = sl.selSupA650Main(params);
			if (hashData != null) {
				SupA650BG entity = (SupA650BG)hashData.get("ETOPINFO");
				if (entity != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("ETOP Airport Management", null, "", MessageCode.getInstance().SELECT_MSG));
				else req.setAttribute("successMessage",ComUtil.getInstance().getMessage("ETOP Airport Management", null, "", MessageCode.getInstance().NULLDATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			req.setAttribute("mode","select");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA650Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA650Serv:selectTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
	/** 
	  * BASE2 ETOP Airport Management Է Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/27 HIST  
	  */		
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 																	//Box ü 
		String depStn = StringUtil.checkString(box.getString("dep_stn")).toUpperCase();				//DEP Station
		String arrStn = StringUtil.checkString(box.getString("arr_stn")).toUpperCase();					//ARR Station
		//String[] etopStn = req.getParameterValues("etop_stn");												//ETOP Station List
		String etopStn = StringUtil.checkString(box.getString("etop_stn")).toUpperCase();
		String returnPage = StringUtil.checkString(box.getString("returnPage"));							//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter Return
			req.setAttribute("depStn",depStn);
			req.setAttribute("arrStn",arrStn);
			
			// ĸ ͸ ĭ ٲش.
			StringBuffer etopTemp = new StringBuffer();
		    for(int a=0; a < etopStn.length(); a++) {
		    	if(etopStn.charAt(a) == '\n') etopTemp.append(" ");
		    	else if(etopStn.charAt(a) == '\r') etopTemp.append(" ");
		    	else if(etopStn.charAt(a) == ',') etopTemp.append(" ");
		    	else	etopTemp.append(etopStn.charAt(a));
		    }
		    etopStn = etopTemp.toString();
			
			// ĭ ؼ Ѱ ´.
			StringTokenizer st = new StringTokenizer(etopStn, " ");
			if (st.countTokens() > 20) throw new Exception("Over 20 ETOP Airports!!"); 
			String[] stn_arr = new String[st.countTokens()];
			int iCnt = 0;
			while(st.hasMoreTokens()) {
			        stn_arr[iCnt] = st.nextToken();
			        iCnt = iCnt + 1;
			}
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			//Parameter 
			SupA650BG params = new SupA650BG();
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			params.setEtop_stn(stn_arr);
			params.setUser_id(UserInfo.getEmp_no());
			
			//EJB LookUp
			boolean insFlag = sl.insSupA650Main(params);
			req.setAttribute("successMessage",ComUtil.getInstance().getMessage("ETOP Airport Management", null, "", MessageCode.getInstance().INSERT_MSG));
			req.setAttribute("mode","insert");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA650Serv:insertTask1] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:SupA650Serv:insertTask2] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end of function	
	
	/** 
	  * BASE2 ETOP Airport Management  Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/27 HIST  
	  */		
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String depStn = StringUtil.checkString(box.getString("dep_stn")).toUpperCase();					//DEP Station
		String arrStn = StringUtil.checkString(box.getString("arr_stn")).toUpperCase();					//ARR Station
		String returnPage = StringUtil.checkString(box.getString("returnPage"));								//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//Parameter Return
			req.setAttribute("depStn",depStn);
			req.setAttribute("arrStn",arrStn);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			//Parameter 
			SupA650BG params = new SupA650BG();
			params.setDep_stn(depStn);
			params.setArr_stn(arrStn);
			
			//EJB LookUp
			boolean delFlag = sl.delSupA650Main(params);
			req.setAttribute("successMessage",ComUtil.getInstance().getMessage("ETOP Airport Management", null, "", MessageCode.getInstance().DELETE_MSG));
			req.setAttribute("mode","delete");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA650Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA650Serv:deleteTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end of function	
	
}
