package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;
import kal.base.sys.dbbean.*;

/**
 * BASE2 Area Information ȸ / Է /  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/05/27 HIST  
 */
public class SupA660Serv extends PublicBaseServlet{
	
	/**
	 * <b>SupA660Serv Instance</b>
	 * @author Copyright (c) 2005 HIST 
	 */
	private static SupA660Serv instance = null;
	
	/**
	 * <b>SupA660Serv Instanceȹ</b>
	 * @author Copyright (c) 2005 HIST 
	 */
	public static SupA660Serv getInstance() {
		if(instance==null)
			instance = new SupA660Serv();
		return instance;
	}
	
	/**
	 * <b>Area Code ȸ Լ.</b>
	 * @return Vector ȸ Data
	 * @exception Exception
	 * @author Copyright (c) 2005 HIST 
	 */
	public static Vector selAreaCode() throws Exception {
		try {
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Vector vtData = sl.selAreaCd();

			return vtData;
		} catch(Exception e) {
			if(e instanceof Exception) {
				throw new Exception(e.getMessage());
			} else {
				throw new Exception(MessageCode.getInstance().ETC_EXPT);
			}
		}
	}//end of function	

	/** 
	  * BASE2 Area Information ȸ Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/27 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String selAreaCd = StringUtil.checkString(box.getString("h_area_cd"));		//Combo Area Code
		//String areaCd = StringUtil.checkString(box.getString("area_cd"));				//Area Code
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//Parameter Return
			req.setAttribute("selAreaCd",selAreaCd);
			//req.setAttribute("areaCd",areaCd);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			//Parameter 
			SupA660BG params = new SupA660BG();
			params.setArea_cd(selAreaCd);
			
			//EJB LookUp
			Hashtable hashData = sl.selSupA660Main(params);
			if (hashData != null) {
				SupA660BG entity = (SupA660BG)hashData.get("AREAINFO");
				if (entity != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Area Information", null, "", MessageCode.getInstance().SELECT_MSG));
				else req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Area Information", null, "", MessageCode.getInstance().NULLDATA_MSG));
			}
			req.setAttribute("hashData",hashData);
			req.setAttribute("mode","select");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA660Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA660Serv:selectTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
	/** 
	  * BASE2 Area Information Է Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/27HIST  
	  */		
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 														//Box ü 
		String selAreaCd = StringUtil.checkString(box.getString("sel_area_cd"));				//Combo Area Code
		String areaCd = StringUtil.checkString(box.getString("area_cd"));							//Area Code
		//String[] areaStn = req.getParameterValues("area_stn");									//Area Station List
		String areaStn = StringUtil.checkString(box.getString("area_stn")).toUpperCase();
		String returnPage = StringUtil.checkString(box.getString("returnPage"));				//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			if (areaCd.equals("")) areaCd = selAreaCd;
			
			//Parameter Return
			req.setAttribute("selAreaCd",areaCd);
			
			// ĸ ͸ ĭ ٲش.
			StringBuffer areaTemp = new StringBuffer();
		    for(int a=0; a < areaStn.length(); a++) {
		    	if(areaStn.charAt(a) == '\n') areaTemp.append(" ");
		    	else if(areaStn.charAt(a) == '\r') areaTemp.append(" ");
		    	else if(areaStn.charAt(a) == ',') areaTemp.append(" ");
		    	else	areaTemp.append(areaStn.charAt(a));
		    }
		    areaStn = areaTemp.toString();
			
			// ĭ ؼ Ѱ ´.
			StringTokenizer st = new StringTokenizer(areaStn, " ");
			if (st.countTokens() > 70) throw new Exception("Over 70 AREA Stations!!"); 
			String[] stn_arr = new String[st.countTokens()];
			int iCnt = 0;
			while(st.hasMoreTokens()) {
			        stn_arr[iCnt] = st.nextToken();
			        iCnt = iCnt + 1;
			}
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			//Parameter 
			SupA660BG params = new SupA660BG();
			params.setArea_cd(areaCd);
			params.setArea_stn(stn_arr);
			params.setUser_id(UserInfo.getEmp_no());
			
			//EJB LookUp
			boolean insFlag = sl.insSupA660Main(params);
			req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Area Information", null, "", MessageCode.getInstance().INSERT_MSG));
			req.setAttribute("mode","insert");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA660Serv:insertTask1] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			} else {
				Logger.debug.println("[BASE:SupA660Serv:insertTask2] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
			}
		} 
	}//end of function	
	
	/** 
	  * BASE2 Area Information  Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/05/27 HIST  
	  */		
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 																//Box ü 
		String selAreaCd = StringUtil.checkString(box.getString("sel_area_cd"));					//Combo Area Code
		String returnPage = StringUtil.checkString(box.getString("returnPage"));					//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//Parameter Return
			req.setAttribute("selAreaCd",selAreaCd);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			//Parameter 
			SupA660BG params = new SupA660BG();
			params.setArea_cd(selAreaCd);
			
			//EJB LookUp
			boolean delFlag = sl.delSupA660Main(params);
			req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Area Information", null, "", MessageCode.getInstance().DELETE_MSG));
			req.setAttribute("mode","delete");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA660Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA660Serv:deleteTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end of function		
	
}//end of class
