package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;
import javax.servlet.http.*;

import kal.base.com.util.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.*;
import kal.base.com.serv.*;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;
import kal.base.sys.dbbean.*;

/**
 * 20140918
 * sunpark
 * FFS Manager Address Management
 */
public class SupA810Serv extends PublicBaseServlet{
	
	/** 
	  *  Ʈ ׸ ȸ 
	  */		
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		try {
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupA810Tree();
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Address Management", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA810Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				Logger.debug.println("[BASE:SupA810Serv:checkTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end of function
	
	/** 
	  *   FLIGHT_ADDR_T ׸ ȸ
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		String iataPort = StringUtil.checkString(box.getString("iata_port")).toUpperCase();
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		//20141030 ߰
		String arlnCd = StringUtil.checkString(box.getString("arlnCd"));
		
		try {
			//Parameter Return
			SupA810BG params = new SupA810BG();
			params.setIataPort(iataPort);
			//20141030 ߰
			params.setArlnCd(arlnCd);
		
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupA810Main(params);
			if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Address Management", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA810Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupA810Serv:selectTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
	/** 
	  * FLIGHT_ADDR_T ׸ update, insert
	  */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		String iataPort = StringUtil.checkString(box.getString("iata_port"));
		String category = StringUtil.checkString(box.getString("category"));
		String network = StringUtil.checkString(box.getString("network"));
		String addressList = StringUtil.checkString(box.getString("address_list"));
		String option = StringUtil.checkString(box.getString("option"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		//20141030 ߰
		String arlnCd = StringUtil.checkString(box.getString("arlnCd"));
		
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			SupA810BG params = new SupA810BG();
			params.setIataPort(iataPort);
			params.setGrpName(category);
			params.setNtk(network);
			params.setAddrList(addressList);
			params.setOptn(option);
			params.setUserId(UserInfo.getEmp_no());
			//20141030 ߰
			params.setArlnCd(arlnCd);
		
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean updFlag = sl.updSupA810Main(params);

			//ABBR Information ȸ
			if (updFlag) {
				Hashtable hashData = sl.selSupA810Main(params);
				if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Address Management", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
				req.setAttribute("hashData",hashData);
			}
			
			req.setAttribute("reqResult", "U");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA810Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupA810Serv:updateTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end of function	
	
	/** 
	  * FLIGHT_ADDR_T ׸ delete
	  */	
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 												//Box ü 
		String iataPort = StringUtil.checkString(box.getString("iata_port"));
		String category = StringUtil.checkString(box.getString("category"));
		String network = StringUtil.checkString(box.getString("network"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		//20141030 ߰
		String arlnCd = StringUtil.checkString(box.getString("arlnCd"));
		
		HttpSession session = req.getSession();
		
		try {
			//User Info
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			SupA810BG params = new SupA810BG();
			params.setIataPort(iataPort);
			params.setGrpName(category);
			params.setNtk(network);
			params.setUserId(UserInfo.getEmp_no());
			//20141030 ߰
			params.setArlnCd(arlnCd);
		
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean delFlag = sl.delSupA810Main(params);
			
			//ABBR Information ȸ
			if (delFlag) {
				Hashtable hashData = sl.selSupA810Main(params);
				if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("Address Management", hashData, "HASHDATA", MessageCode.getInstance().DATA_MSG));
				req.setAttribute("hashData",hashData);
			}
			
			req.setAttribute("reqResult", "D");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupA810Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SupA810Serv:deleteTask] "+StringUtil.toKSC5601(((Exception)e).getMessage()));
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end of function		
	
}//end of class
