package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.*;
import kal.base.sup.ejb.SupAllSL;

/**
 * NOTAM Code Search Class
 * @version 	1.0
 * @author Copyright (c) 2005/06/20
 */
public class SupQ150Serv extends PublicBaseServlet {

	/** 
	  * NOTAM Code Search ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/06/20 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    		//Box ü 
		String notQcd1 = StringUtil.xssEncode(box.getString("not_qcd1"));//@2013-06-21	XSS 	-	 : StringUtil.checkString(box.getString("not_qcd1"));				//Q-Code 1 ȹ
		String notQcd2 = StringUtil.xssEncode(box.getString("not_qcd2"));//@2013-06-21	XSS 	-	 : StringUtil.checkString(box.getString("not_qcd2"));				//Q-Code 2 ȹ
		String abbrCd = StringUtil.xssEncode(box.getString("abbr_cd"));//@2013-06-21	XSS 	-	 : StringUtil.checkString(box.getString("abbr_cd"));				//ABBR Code ȹ
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		
		try {
			//Mode 
			String mode = null;
			if (!notQcd1.equals("") || !notQcd2.equals("")) {
				mode = "Q";
			} else if (!abbrCd.equals("")) {
				mode = "A";
			} else throw new Exception("ùٸ ȸ ƴմϴ.");
			
			//Parameter Return
			req.setAttribute("mode",mode);
			req.setAttribute("notQcd1",notQcd1);
			req.setAttribute("notQcd2",notQcd2);
			req.setAttribute("abbrCd",abbrCd);
			
			//Parameter 
			SupA110BG params = new SupA110BG();
			params.setMode(mode);
			params.setNot_qcd1(notQcd1);
			params.setNot_qcd2(notQcd2);
			params.setAbbr_cd(abbrCd);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData  = sl.selCodeSearch(params);
			if (hashData != null) {
				List listData = (List)hashData.get("HASHDATA");
				if (listData != null) {
					if (listData.size() > 0) req.setAttribute("successMessage","");
					else req.setAttribute("successMessage","ȸ Ͱ ϴ.");
				}
			}
			
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ150Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupQ150Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask

}
