package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupQ210BG;
import kal.base.sup.ejb.SupAllSL;
import kal.base.wea.ejb.WeaAllSL;
import java.io.PrintWriter;
/**
 * Current Weather Request  Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/07/13 
 */
public class SupQ210Serv extends PublicBaseServlet {
	/** 
	  * Current Weather Request Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/13 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String mode = StringUtil.checkString(box.getString("mode"));
		String areaCd = StringUtil.checkString(box.getString("area_cd"));
		String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String stnFr = StringUtil.checkString(box.getString("stnfr"));
		String stnTo = StringUtil.checkString(box.getString("stnto"));
		String rteId = StringUtil.checkString(box.getString("rte_id"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SupQ210BG params = new SupQ210BG();
			params.setMode(mode);
			params.setArea_cd(StringUtil.toKSC5601(areaCd));
			params.setFlt_num(fltNum);
			params.setStnfr(stnFr);
			params.setStnto(stnTo);
			params.setRte_id(rteId);
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			SupQ210BG entity = sl.selSupQ210Main(params);
			if (entity != null) {
				req.setAttribute("dataComplete","Y");
				req.setAttribute("entity",entity);
			} else req.setAttribute("dataComplete","N");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ210Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			} else {
				Logger.debug.println("[BASE:SupQ210Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
				return;
			}
		} 
	}//end selectTask
	
	/** 
	  * Current Weather Request View Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/14 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		String rteStn = StringUtil.checkString(box.getString("rte_stn"));
		String wxTitle = StringUtil.checkString(box.getString("wx_title"));
		String timeStep = StringUtil.checkString(box.getString("time_step"));
		String metar = StringUtil.checkString(box.getString("metar_value"));
		String tafFt = StringUtil.checkString(box.getString("tafft_value"));
		String tafFc = StringUtil.checkString(box.getString("taffc_value"));
		String text = StringUtil.checkString(box.getString("text_value"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		// 2006.01.26 ߰
		String rwy_yn = StringUtil.checkString(box.getString("rwy_yn"));		
		//@2018-04-10
		String confirmKind = StringUtil.checkString(box.getString("confirm_kind"));		
		String firstLegFltDt = StringUtil.checkString(box.getString("first_leg_flt_dt"));		
		String fltNum = StringUtil.checkString(box.getString("flt_num"));		
		String stnfr = StringUtil.checkString(box.getString("stnfr"));	
		String stnto = StringUtil.checkString(box.getString("stnto"));	

		HttpSession session = req.getSession();
		
		try {
			SupQ210BG params = new SupQ210BG();
			//RKSS RKSI ICN -> StringUtil.allStationChk(rteStn) -> RKSS,RKSI,ICN
			params.setRte_stn(StringUtil.allStationChk(rteStn));
			params.setWx_title(wxTitle);
			params.setTime_step(timeStep);
			params.setMetar(metar);
			params.setTaf_ft(tafFt);
			params.setTaf_fc(tafFc);
			params.setText(text);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupQ210View("V",params);
			
			//Data Session Input
			if (hashData != null) {
				/*
				//User Session Information
				SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
				
				// 2007.01.31 ߰
				String empNoKey = "";
				if (UserInfo != null) empNoKey = StringUtil.checkString(UserInfo.getEmp_no());
				else req.setAttribute("errorMessage","ð  ʾ α ʿմϴ.");
				
				String wxKey = StringUtil.getKST("yyyyMMddHHmmss") + empNoKey;
				
				//߿ Popup JSP ͸ ̰   ؿ ٷ  !!!
				//session.removeAttribute(wxKey);
				*/
				//2008.11.24  : wxKey
				String wxKey = StringUtil.getKST("yyyyMMddHHmmss");
				session.setAttribute(wxKey,hashData);
				
				req.setAttribute("wxKey",wxKey);
				req.setAttribute("dataComplete","V");
				
				req.setAttribute("rwy_yn", rwy_yn);
				
				//@2018-04-10
				req.setAttribute("confirm_kind", confirmKind);
				req.setAttribute("first_leg_flt_dt", firstLegFltDt);
				req.setAttribute("flt_num", fltNum);
				req.setAttribute("stnfr", stnfr);
				req.setAttribute("stnto", stnto);
			}
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ210Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
				return;
			} else {
				Logger.debug.println("[BASE:SupQ210Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
				return;
			}
		} 
	}//end checkTask	
	
	/** 
	  * Current Weather Request Send Servlet Class - insertTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/14 
	  */	
	public void insertTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    //Box ü 
		// ȸ Params
		String mode = StringUtil.checkString(box.getString("mode"));
		String areaCd = StringUtil.checkString(box.getString("area_cd"));
		String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String stnFr = StringUtil.checkString(box.getString("stnfr"));
		String stnTo = StringUtil.checkString(box.getString("stnto"));
		String rteId = StringUtil.checkString(box.getString("rte_id"));
		
		String rteStn = StringUtil.checkString(box.getString("rte_stn"));
		String wxTitle = StringUtil.checkString(box.getString("wx_title"));
		String timeStep = StringUtil.checkString(box.getString("time_step"));
		String metar = StringUtil.checkString(box.getString("metar_value"));
		String tafFt = StringUtil.checkString(box.getString("tafft_value"));
		String tafFc = StringUtil.checkString(box.getString("taffc_value"));
		String text = StringUtil.checkString(box.getString("text_value"));
		//Message Send Params
		String addrTxt = StringUtil.checkString(box.getString("addr_txt"));
		String originTxt = StringUtil.checkString(box.getString("origin_txt"));
		String acarsTxt = StringUtil.checkString(box.getString("acars_txt"));
		String mailFax = StringUtil.checkString(box.getString("mail_fax"));
		String mailSender = StringUtil.checkString(box.getString("mail_sender")); //2009.08.03 ߰ :  ...
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			SupQ210BG params = new SupQ210BG();
			//RKSS RKSI ICN -> StringUtil.allStationChk(rteStn) -> RKSS,RKSI,ICN
			params.setRte_stn(StringUtil.allStationChk(rteStn));
			params.setWx_title(wxTitle);
			params.setTime_step(timeStep);
			params.setMetar(metar);
			params.setTaf_ft(tafFt);
			params.setTaf_fc(tafFc);
			params.setText(text);
			
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = sl.selSupQ210View("S",params);
			
			if (hashData != null) {
				SupQ210BG sendParam = new SupQ210BG();
				sendParam.setMode(mode);
				sendParam.setArea_cd(StringUtil.toKSC5601(areaCd));
				sendParam.setFlt_num(fltNum);
				sendParam.setStnfr(stnFr);
				sendParam.setStnto(stnTo);
				sendParam.setRte_id(rteId);
				sendParam.setAddr_txt(addrTxt);
				sendParam.setOrigin_txt(originTxt);
				sendParam.setAcars_txt(acarsTxt);
				sendParam.setMail_fax(mailFax);
				sendParam.setWx_title(wxTitle);// 2006.03.22 ߰
				
				sendParam.setMail_sender(mailSender); //2009.08.03 ߰
				
				//20151021 UMS  ߰ 
				sendParam.setRte_stn(StringUtil.allStationChk(rteStn));
				sendParam.setTime_step(timeStep);
				sendParam.setMetar(metar);
				sendParam.setTaf_ft(tafFt);
				sendParam.setTaf_fc(tafFc);
				sendParam.setText(text);
				
				WeaAllSL wea = (WeaAllSL)EJBFinder.lookup("ejb/WeaAllSL");
				boolean wxFlag = wea.sendCurrWxReq(sendParam,hashData);
				if (wxFlag) req.setAttribute("dataComplete","S");
				else throw new Exception("۽");
			} else throw new Exception("۽");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ210Serv:insertTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
				return;
			} else {
				Logger.debug.println("[BASE:SupQ210Serv:insertTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"insert");
				return;
			}
		} 
	}//end checkTask		
	//@2018-04-12 ajax
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		String firstLegFltDt = StringUtil.checkString(box.getString("first_leg_flt_dt"));
		String fltNum = StringUtil.checkString(box.getString("flt_num"));
		String stnfr = StringUtil.checkString(box.getString("stnfr"));
		String stnto = StringUtil.checkString(box.getString("stnto"));

		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		HttpSession session = req.getSession();
		try{
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			
			//Parameter 
			SupQ210BG params = new SupQ210BG();
			params.setMode("update");
			params.setUserid(UserInfo.getEmp_no());
			params.setFirst_leg_flt_dt(firstLegFltDt);
			params.setFlt_num(fltNum);
			params.setStnfr(stnfr);
			params.setStnto(stnto);

			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			boolean updFlag = sl.updSupQ210_edtoConfirm(params);
			req.setAttribute("userID",UserInfo.getEmp_no());
			req.setAttribute("dataComplete","U");

			res.setContentType("text/html;charset=UTF-8");
			res.setHeader("Cache-Control", "no-cache");
			PrintWriter out = res.getWriter();
			out.write(updFlag?"Y":"N");
			out.close();

			//  			
			//printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ210Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SupQ210Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end updateTask		
}
