package kal.base.sup.serv;

import java.rmi.RemoteException;
import java.util.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import kal.base.com.util.*;
import kal.base.com.serv.*;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sup.dbbean.SupA360BG;
import kal.base.sup.dbbean.SupQ510BG;
import kal.base.sup.ejb.SupAllSL;

/**
 * Weather Watch Regional METAR / TAF Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/07/25 
 */
public class SupQ511Serv extends PublicBaseServlet {
	/** 
	  * Weather Watch Regional METAR / TAF м ȸ Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/07/25 
	  */	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    	//Box ü 
		String mode = StringUtil.checkString(box.getString("mode"));					//mode M : METAR  ,   T  : TAF   ,   F  : ش м
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			
			if (mode.equals("M")) {
				Hashtable hashData = sl.selSupQ510Metar();
				req.setAttribute("hashData",hashData);
			} else if (mode.equals("T")) {
				Hashtable hashData = sl.selSupQ510Taf();
				req.setAttribute("hashData",hashData);
			} else if (mode.equals("F")) {
				Hashtable hashData = sl.selSupQ510FltAnalysis();
				req.setAttribute("hashData",hashData);
			} else throw new Exception("[Servlet Exception] Select Mode Not Found");

			req.setAttribute("returnParam","Y");
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SupQ511Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SupQ511Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask	

	/** 
	  * Weather Watch Regional METAR / TAF м ȸ Servlet Class - checkTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2010/01/28 
	  */	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 										    	//Box ü 
		
		String mode = StringUtil.checkString(box.getString("mode"));
		
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		
		try {
			//EJB LookUp
			SupAllSL sl = (SupAllSL)EJBFinder.lookup("ejb/SupAllSL");
			Hashtable hashData = null;
			
			//   ,  
			if (mode.equals("1")) {
				hashData = sl.selSupQ510Info1();
			//Ǳ ߻ ,   ߻ , ߻ 
			} else if (mode.equals("2")) {
				hashData = sl.selSupQ510Info2();
			//   
			} else if (mode.equals("3")) {
				hashData = sl.selSupQ510Metar();
			//  
			} else if (mode.equals("4")) {
				hashData = sl.selSupQ510Taf();
			//ǳ
			} else if (mode.equals("5")) {
				hashData = sl.selSupQ510Metar();
			//2010.03.10 ߰
			//   
			} else if (mode.equals("21")) {
				hashData = sl.selSupQ510Info21();
			//   
			} else if (mode.equals("22")) {
				hashData = sl.selSupQ510Info22();
			//  
			} else if (mode.equals("23")) {
				hashData = sl.selSupQ510Taf();
		    //   (ALERT APO ִ  : BS_MANUAL_WEATHER_T) : 2011.11.04 ߰
			} else if (mode.equals("31")) {
				hashData = sl.selSupA360Info1();
			} 
            // 溸 Ȳ(ALERT APO ִ  : BS_MANUAL_WEATHER_T) : 2011.11.04 ߰
			else if (mode.equals("32")) {
				hashData = sl.selSupA360Info2();
			}else {
				throw new Exception("[Servlet Exception] Check Mode Not Found");
			}
			
			req.setAttribute("hashData",hashData);
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				System.out.println("[BASE:SupQ511Serv:checkTask] "+((RemoteException)e).getMessage());
				Logger.debug.println("[BASE:SupQ511Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				System.out.println("[BASE:SupQ511Serv:checkTask] "+((Exception)e).getMessage());
				Logger.debug.println("[BASE:SupQ511Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask	
}

