package kal.base.sys.serv;

import java.io.PrintWriter;
import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kal.base.com.serv.ComUtil;
import kal.base.com.util.MessageCode;
import kal.base.com.util.StringUtil;
import kal.base.jdf.com.Logger;
import kal.base.jdf.ejb.EJBFinder;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;
import kal.base.sys.dbbean.SysA010BG;
import kal.base.sys.dbbean.SysA020BG;
import kal.base.sys.ejb.SysAllSL;

/**
 * BASE2 User Information ȸ/Է/ Servlet Class
 * @version 	1.0
 * @author Copyright (c) 2005/04/11 HIST  
 */
public class SysA020Serv extends PublicBaseServlet{

	/** 
	  * BASE2 User Information ȸ Main Servlet Class - selectTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/11 HIST  
	  */		
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 													//Box ü 
		String projectC = StringUtil.checkString(box.getString("sel_project_c"));		//Project Code
		String empNo = StringUtil.checkString(box.getString("sel_emp_no"));			//User ID
		String deptC = StringUtil.checkString(box.getString("sel_dept_c"));				//Dept Code
		String korN = StringUtil.toKSC5601(box.getString("sel_kor_n"));						//Kor name
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Check
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String adminAuth = StringUtil.checkString(UserInfo.getAuth_pmsn().substring(0,1));
			if (!adminAuth.equals("A")) throw new Exception("ش Process   ϴ.");
			
			//Parameter 
			SysA020BG params = new SysA020BG();
			params.setProject_c(projectC);
			params.setEmp_no(empNo);
			params.setDept_c(deptC);
			params.setKor_n(korN);
			
			//EJB LookUp
			SysAllSL sl = (SysAllSL)EJBFinder.lookup("ejb/SysAllSL");
		    Hashtable hashData = sl.selSysA020Main(params);
		    if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("User Information", hashData, "USERINFO", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
			
			//  			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysA020Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SysA020Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end of function
	
	/** 
	  * BASE2 User Information Է/ Servlet Class - updateTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/11 HIST  
	  */		
	public void updateTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 												//Box ü 
		//ȸ Parameter
		String sProjectC = StringUtil.checkString(box.getString("sel_project_c"));		//Project Code
		String sEmpNo = StringUtil.checkString(box.getString("sel_emp_no"));	//User ID
		String sDeptC = StringUtil.checkString(box.getString("sel_dept_c"));		//Dept Code
		String sKorN = StringUtil.toKSC5601(box.getString("sel_kor_n"));				//Kor name
		//Է¿ Parameter
		String mode = StringUtil.checkString(box.getString("mode"));					//Process Mode
		String projectC = StringUtil.checkString(box.getString("project_c"));			//Project Code
		String empNo = StringUtil.checkString(box.getString("emp_no"));				//User ID
		String deptC = StringUtil.checkString(box.getString("dept_c"));					//Dept Code
		String korN = StringUtil.toKSC5601(box.getString("kor_n"));						//Kor name
		String pswdNo = StringUtil.checkString(box.getString("pswd_no"));			//Password Number
		String telNo = StringUtil.checkString(box.getString("tel_no"));					//Telephone Number
		String mailAddr = StringUtil.checkString(box.getString("mail_addr"));		//Mail Address
		String authPmsn = StringUtil.checkString(box.getString("auth_pmsn"));	//Auth
		String favorC = StringUtil.checkString(box.getString("favor_c"));				//BASE2 ȣ
		String returnPage = StringUtil.checkString(box.getString("returnPage"));	//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Check
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String adminAuth = UserInfo.getAuth_pmsn().substring(0,1);
			if (!adminAuth.equals("A")) throw new Exception("ش Process   ϴ.");
			
			Logger.debug.println("[Serv] favorC : "+favorC);
						
			//Parameter 
			SysA020BG params = new SysA020BG();
			params.setMode(mode);
			params.setProject_c(projectC);
			params.setEmp_no(empNo);
			params.setDept_c(deptC);
			params.setKor_n(korN);
			params.setPswd_no(pswdNo);
			params.setTel_no(telNo);
			params.setMail_addr(mailAddr);
			params.setAuth_pmsn(authPmsn);
			params.setFavor_c(favorC);
			
			//EJB LookUp
			SysAllSL sl = (SysAllSL)EJBFinder.lookup("ejb/SysAllSL");
		    sl.updSysA020Main(params);
		    
		    //Parameter 
			params = new SysA020BG();
			params.setProject_c(sProjectC);
			params.setEmp_no(sEmpNo);
			params.setDept_c(sDeptC);
			params.setKor_n(sKorN);
			
			//EJB LookUp
			Hashtable hashData = sl.selSysA020Main(params);
		    if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("User Information", hashData, "USERINFO", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
		    
			//  			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysA020Serv:updateTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			} else {
				Logger.debug.println("[BASE:SysA02Serv:updateTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"update");
			}
		} 
	}//end of function	

	/** 
	  * BASE2 User Information  Servlet Class - deleteTask
	  * @param req HttpServletRequest  	Request Object
	  * @param res HttpServletResponse  	Response Object
	  * @exception Exception
	  * @author Copyright (c) 2005/04/11 HIST  
	  */		
	public void deleteTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);				 												//Box ü 
		//ȸ Parameter
		String sProjectC = StringUtil.checkString(box.getString("sel_project_c"));		//Project Code
		String sEmpNo = StringUtil.checkString(box.getString("sel_emp_no"));			//User ID
		String sDeptC = StringUtil.checkString(box.getString("sel_dept_c"));				//Dept Code
		String sKorN = StringUtil.toKSC5601(box.getString("sel_kor_n"));						//Kor name
		//Է¿ Parameter
		String projectC = StringUtil.checkString(box.getString("project_c"));				//Project Code
		String empNo = StringUtil.checkString(box.getString("emp_no"));					//User ID
		String returnPage = StringUtil.checkString(box.getString("returnPage"));		//Return Page ȹ
		HttpSession session = req.getSession();
		
		try {
			//User Check
			SysA010BG UserInfo = (SysA010BG)session.getAttribute("USERINFO");
			String adminAuth = UserInfo.getAuth_pmsn().substring(0,1);
			if (!adminAuth.equals("A")) throw new Exception("ش Process   ϴ.");
			
            //	2012.06.22 ߰ : GUEST ID PWD Ұ=>    ߰
			if(empNo.equals("GUEST")){
				throw new Exception("ش ID ý۽  IDԴϴ. ID   ϴ.");
			}
						
			//Parameter 
			SysA020BG params = new SysA020BG();
			params.setProject_c(projectC);
			params.setEmp_no(empNo);
			
			//EJB LookUp
			SysAllSL sl = (SysAllSL)EJBFinder.lookup("ejb/SysAllSL");
		    sl.delSysA020Main(params);
		    
		    //Parameter 
			params = new SysA020BG();
			params.setProject_c(sProjectC);
			params.setEmp_no(sEmpNo);
			params.setDept_c(sDeptC);
			params.setKor_n(sKorN);
			
			//EJB LookUp
			Hashtable hashData = sl.selSysA020Main(params);
		    if (hashData != null) req.setAttribute("successMessage",ComUtil.getInstance().getMessage("User Information", hashData, "USERINFO", MessageCode.getInstance().DATA_MSG));
			req.setAttribute("hashData",hashData);
		    
			//  			
			printJspPage(req, res, returnPage);
			
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysA020Serv:deleteTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			} else {
				Logger.debug.println("[BASE:SysA02Serv:deleteTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"delete");
			}
		} 
	}//end of function	
	//@2019-04-17	ajax
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		Box box = HttpUtility.getBox(req);
		String emp_no = StringUtil.checkString(box.getString("emp_no"));
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		try{
			SysA020BG param = new SysA020BG();
			param.setEmp_no(emp_no);

			//EJB LookUp
			SysAllSL sl = (SysAllSL)EJBFinder.lookup("ejb/SysAllSL");
			SysA020BG entity	= sl.selSysPasswordT(param);
			
			String result	=	"";
			result	+=	"	'mailAddr':'"+entity.getDec_mail_addr()+"'";
			result	+=	",	'telNo':'"+entity.getDec_tel_no()+"'";
			result	+=	",	'korN':'"+entity.getKor_n()+"'";
			result	+=	",	'deptC':'"+entity.getDept_c()+"'";
			result	+=	",	'projectC':'"+entity.getProject_c()+"'";
			result	+=	",	'userID':'"+entity.getEmp_no()+"'";
			res.setContentType("text/html;charset=UTF-8");
			res.setHeader("Cache-Control", "no-cache");
			PrintWriter out = res.getWriter();
			out.write("[{"+result+"}]");
			out.close();

			//  			
			//printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				Logger.debug.println("[BASE:SysA020Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				Logger.debug.println("[BASE:SysA020Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end checkTask		
}//end of class
