package kal.base.test.serv;

import java.rmi.RemoteException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kal.base.com.util.StringUtil;
import kal.base.jdf.serv.Box;
import kal.base.jdf.serv.HttpUtility;
import kal.base.pbf.serv.PublicBaseServlet;

//PRINCE
//import com.princexml.Prince;

//PD4ML
import org.zefer.pd4ml.PD4ML;
import org.zefer.pd4ml.PD4PageMark;
import java.io.File;
import java.io.FileOutputStream;

public class TestQ010Serv extends PublicBaseServlet{
	
	public void checkTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		String pd4mlHtmlPath = StringUtil.checkString(box.getString("pd4mlHtmlPath"));
		String pd4mlPdfPath = StringUtil.checkString(box.getString("pd4mlPdfPath"));
		
		try {

			PD4ML pd4ml = new PD4ML();
			
			PD4PageMark footer = new PD4PageMark();
			footer.setAreaHeight(40);
			footer.setHtmlTemplate("<center><br><font face='Tahoma' size='2'>PAGE ${page} OF ${total}, NOTAM FOR KE0001 ICN/NRT</font></center>");
			
			pd4ml.setPageFooter(footer);
			
			//å 
			//pd4ml.generateOutlines(false); //<a name="destination">Label</a>
			pd4ml.generateOutlines(true); //<H1>-<H6>
			
			pd4ml.useTTF("c://windows/fonts/", true); //Embedding fonts to PDF 
			//pd4ml.useTTF("java:fonts", true); //Embedding fonts to PDF
			//pd4ml.setDefaultTTFs("Batang","Arial", "Courier New");

			
			
			String textUrl = "file:" + pd4mlHtmlPath;
			
			File file = new File(pd4mlPdfPath);
			FileOutputStream fos = new FileOutputStream(file);
			
			pd4ml.render(textUrl, fos);
			
			fos.close();
			
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				System.out.println("[BASE:TestQ010Serv:checkTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			} else {
				System.out.println("[BASE:TestQ010Serv:checkTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"check");
			}
		} 
	}//end checkTask
	
	public void selectTask(HttpServletRequest req, HttpServletResponse res) throws Exception {
		
		Box box = HttpUtility.getBox(req);
		String returnPage = StringUtil.checkString(box.getString("returnPage"));
		
		String princeExePath = StringUtil.checkString(box.getString("princeExePath"));
		String princeHtmlPath = StringUtil.checkString(box.getString("princeHtmlPath"));
		String princePdfPath = StringUtil.checkString(box.getString("princePdfPath"));
		
		try {
			
			//Prince prince = new Prince(princeExePath);
			
			//boolean result = prince.convert(princeHtmlPath, princePdfPath);
			
			req.setAttribute("returnParam","Y");
			
			//  			
			printJspPage(req, res, returnPage);
		} catch(Exception e) {
			if(e instanceof RemoteException) {
				System.out.println("[BASE:TestQ010Serv:selectTask] "+((RemoteException)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			} else {
				System.out.println("[BASE:TestQ010Serv:selectTask] "+((Exception)e).getMessage());
				printMessagePage2(req, res, e.getMessage(),returnPage,"select");
			}
		} 
	}//end selectTask
}
