package kal.base.iro.ejb;

//ڹ 
import java.io.*;
import java.sql.*;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.SimpleDateFormat;
import java.util.*;

//Project 
import kal.base.jdf.com.*;
import kal.base.jdf.db.*;
import kal.base.pbf.db.*;
import kal.base.sys.dbbean.SysA020BG;
import kal.base.jdf.jtx.*;
import kal.base.jdf.serv.Box;
import kal.base.com.query.ComQ01Query;
import kal.base.com.util.*;
import kal.base.jdf.ejb.*;
//IRO
import kal.base.iro.query.*;
import kal.base.iro.dbbean.*;

/**
 * Bean implementation class for Enterprise Bean: IroAllSL
 */
public class IroAllSLBean extends BeanAdapter {

	/** 
	  * <b>IRR/DSS Current Flight Schedule Desk Select Code ȸԼ</b>. 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public Hashtable selIroA010Desk() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashDesk = new Hashtable();
	    List listDesk = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Desk Select Code ȸ
			stmt = conn.createStatement();
			sql = IroA010Query.getInstance().selDesk();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA010BG entity = new IroA010BG();
				entity.setCode_x(StringUtil.checkString(rs.getString("Code_x")));		//Code_x
				entity.setDesc_e(StringUtil.checkString(rs.getString("Desc_e")));	//Desc_e
				listDesk.add(entity);
			}
			hashDesk.put("DESKINFO",listDesk);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA010Desk:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA010Desk:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashDesk;
	}//end of function
	
	/** 
	  * <b>IRR/DSS Current Flight Schedule Alert Message ԷԼ</b>. 
	  * @param params IroA010BG Է Parameter
	  * @return String Է ϷῩ Y/N
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String insIroA010AlertMsg(IroA010BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
	    String sql = null;
	    
	    //Return ü
	    String insMsg = "N";
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//Alert Message Է
			stmt = conn.createStatement();
			sql = IroA010Query.getInstance().insAlertMsg(params);
			int insCnt = stmt.executeUpdate(sql);
			if (insCnt != 1) {
				throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
			} else {
				insMsg = "Y";				
			}
			
			//Data Commit
			conn.commit();
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
	  		Logger.debug.println("[BASE:IroAllSLBean:insIroA010AlertMsg:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA010AlertMsg:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA010AlertMsg:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return insMsg;
	}//end of function
	
	/** 
	  * <b>IRR/DSS Current Flight Schedule Alert Message ȸԼ</b>. 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public Hashtable selIroA010AlertMsg() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashAlert = new Hashtable();
	    List listAlert = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Alert Message ȸ
			stmt = conn.createStatement();
			sql = IroA010Query.getInstance().selAlertMsg();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA010BG entity = new IroA010BG();
				entity.setEmp_no(StringUtil.checkString(rs.getString("Emp_no")));
				entity.setAlert_dt(StringUtil.checkString(rs.getString("Alert_dt")));
				entity.setAlert_msg_e(StringUtil.checkString(rs.getString("Alert_msg_e")));
				listAlert.add(entity);
			}
			hashAlert.put("ALERTMSG",listAlert);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA010AlertMsg:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA010AlertMsg:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashAlert;
	}//end of function	

	/** 
	  * <b>IRR/DSS Current Flight Schedule Alert Message ExpireԼ</b>. 
	  * @param params IroA010BG  Parameter & 
	  * @return String  ϷῩ Y/N
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public String updIroA010AlertMsg(IroA010BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
	    String sql = null;
	    
	    //Return ü
	    String updMsg = "N";
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			// Alert Message Expire
			stmt = conn.createStatement();
			sql = IroA010Query.getInstance().updAlertMsg(params);
			int updCnt = stmt.executeUpdate(sql);
			if (updCnt != 1) {
				throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
			} else {
				updMsg = "Y";				
			}
			
			//Data Commit
			conn.commit();
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroA010AlertMsg:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroA010AlertMsg:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroA010AlertMsg:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return updMsg;
	}//end of function

	/** 
	  * <b>IRR/DSS Current Flight Schedule Job Select ȸԼ</b>. 
	  * @param params IroA010BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public Hashtable selIroA010Job(IroA010BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashJob = new Hashtable();
	    List listJob = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Job Select Code ȸ
			stmt = conn.createStatement();
			sql = IroA010Query.getInstance().selJob(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA010BG entity = new IroA010BG();
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setSeq_num(StringUtil.checkString(rs.getString("Seq_Num")));
				entity.setOption_num(StringUtil.checkString(rs.getString("Option_Num")));
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_dt")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setTitle_x(StringUtil.checkString(rs.getString("Title_x")));
				listJob.add(entity);
			}
			hashJob.put("JOBMSG",listJob);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA010Job:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA010Job:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashJob;
	}//end of function	
	
	/** 
	  * <b>IRR/DSS Current Flight Schedule Main ȸԼ</b>. 
	  * @param params IroA010BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public Hashtable selIroA010Main(IroA010BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Current Flight Schedule Mai ȸ
			stmt = conn.createStatement();
			sql = IroA010Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA010BG entity = new IroA010BG();
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setKactyp(StringUtil.checkString(rs.getString("Kactyp")));
				entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt")));
				entity.setSch_arv_dt(StringUtil.checkString(rs.getString("Sch_Arv_Dt")));
				entity.setEst_dep_dt(StringUtil.checkString(rs.getString("Est_Dep_Dt")));
				entity.setEst_arv_dt(StringUtil.checkString(rs.getString("Est_Arv_Dt")));
				entity.setDel_rc1(StringUtil.checkString(rs.getString("Del_Rc1")));
				entity.setDel_dur1(StringUtil.checkString(rs.getString("Del_Dur1")));
				entity.setBook(StringUtil.checkString(rs.getString("Book")));
				entity.setDep_sts(StringUtil.checkString(rs.getString("Dep_Sts")));
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
				entity.setTimestamp(StringUtil.checkString(rs.getString("Timestamp")));
				entity.setLeg_num(StringUtil.checkString(rs.getString("Leg_Num")));
				entity.setRegion_flt(StringUtil.checkString(rs.getString("Region_Flt")));
				entity.setRegion_leg(StringUtil.checkString(rs.getString("Region_Leg")));
				entity.setSch_dt(StringUtil.checkString(rs.getString("Sch_Dt")));
				entity.setDis_dt(StringUtil.checkString(rs.getString("Dis_Dt")));
				entity.setActnid(StringUtil.checkString(rs.getString("Actnid")));
				listData.add(entity);
			}
			hashData.put("HASHDATA",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA010Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA010Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b>IRR/DSS Current Flight Schedule IROPS Data Լ</b>. 
	  * @param newData IroA010BG NEW   NEW DATA
	  * @param hashParam Hashtable Grid Data
	  * @return Hashtable FLAG:忩, MSG:ش Flight Message
	  * @exception Exception
	  * @author Copyright (c) 2005/01/31 HIST 
	  */
	public Hashtable insIroA010Irops(IroA010BG newData, Hashtable hashParam) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt1 = null;
		Statement stmt2 = null;
		ResultSet rs1 = null;
		ResultSet rs2 = null;
	    String sql = null;
	    
	    //Return ü
	    String insMsg = "N";
	    String proMsg = "";
	    Hashtable hashData = new Hashtable();
	   
	    try {
	    	//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			Logger.debug.println("===== Mode : "+newData.getMode());
			
			//New Flight Schedule Bs_New_Sch_T Է
			if (newData.getMode().equals("NEW")) {
				stmt1 = conn.createStatement();
				sql = IroA010Query.getInstance().insBsNewSchT(newData);
				int insBs = stmt1.executeUpdate(sql);
				if (insBs != 1) throw new BusinessException("NEW Flight Data Insert Exception!");
				
				if (stmt1 != null) stmt1.close();
				if (sql != null) sql = null;
			}
			
			if (hashParam != null) {
				List listParam = (List)hashParam.get("listParam");
				for (int i=0; i<listParam.size(); i++) {
					IroA010BG params = (IroA010BG)listParam.get(i);
					
					//IROPS Seq ȸ
					stmt1 = conn.createStatement();
					sql = IroA010Query.getInstance().selIropsSeq(params);
					rs1 = stmt1.executeQuery(sql);
					
					if (rs1.next()) {
						params.setSeq_num(StringUtil.checkString(rs1.getString("Seq_Num")));
						params.setComplete_y(StringUtil.checkString(rs1.getString("Complete_y")).toUpperCase());
						
						if (params.getComplete_y().equals("Y") || params.getComplete_y().equals("")) {
							//Option Number 
							params.setOption_num("1");
							if (params.getComplete_y().equals("Y")) {
								//IROPS MAX DATA Blocking ߺ
								stmt2 = conn.createStatement();
								sql = IroA010Query.getInstance().updIropsSeq(params);
								int updCnt = stmt2.executeUpdate(sql);
								if (updCnt == 0) throw new BusinessException("IROPS Seq Update Exception!!");
								params.setSeq_num(String.valueOf(Integer.valueOf(params.getSeq_num()).intValue() + 1).toString());
							} else params.setSeq_num("1");
							
							if (stmt2 != null) stmt2.close();
							if (sql != null) sql = null;
							
							//Irops_Sch_t Table Insert
							stmt2 = conn.createStatement();
							sql = IroA010Query.getInstance().insIropsSchT(params);
							int insSch = stmt2.executeUpdate(sql);
							if (insSch != 1) throw new BusinessException("IROPS Schdule Insert Exception!!");
							
							//ü ȯ
							if (stmt2 != null) stmt2.close();
							if (sql != null) sql = null;
							
							//IROPS Desk ȸ
							List listDesk = new LinkedList();
							stmt2 = conn.createStatement();
							sql = IroA010Query.getInstance().selDesk();
							rs2 = stmt2.executeQuery(sql);
							
							while (rs2.next()) {
								listDesk.add(StringUtil.checkString(rs2.getString("Desc_e")));
								//Logger.debug.println("===== Desc_e : "+StringUtil.checkString(rs2.getString("Desc_e")));
							}
							
							//ü ȯ
							if (stmt2 != null) stmt2.close();
							if (rs2 != null) rs2.close();
							if (sql != null) sql = null;
							
							//Logger.debug.println("===== listDesk Size : "+listDesk.size());
							
							//Desk Duty Code ŭ IROPS_DESK_T Insert
							if (listDesk.size() > 0) {
								for (int j=0; j<listDesk.size(); j++) {
									params.setDesk_x((String)listDesk.get(j));
									//Logger.debug.println("======== Exist Region_flt : "+params.getRegion_flt()+", Desk_x : "+params.getDesk_x());
									//Irops_Desk_t Table Insert
									/***********************/
									/*****  Region Rule  *****/
									/** desk_k : B,C ==> International      **/
									/**  D,E ==> Domestic */
									/***********************/
									//
									if (params.getRegion_flt().equals("1")) {
										if (!params.getDesk_x().equals("B") && !params.getDesk_x().equals("C")) {
											stmt2 = conn.createStatement();
											sql = IroA010Query.getInstance().insIropsDeskT(params);
											int insDesk = stmt2.executeUpdate(sql);
											if (insDesk != 1) throw new BusinessException("IROPS Desk Insert Exception!!");
										}
									} 
									//
									else {
										if (!params.getDesk_x().equals("D") && !params.getDesk_x().equals("E")) {
											stmt2 = conn.createStatement();
											sql = IroA010Query.getInstance().insIropsDeskT(params);
											int insDesk = stmt2.executeUpdate(sql);
											if (insDesk != 1) throw new BusinessException("IROPS Desk Insert Exception!!");
										}
									}
									
									//ü ȯ
									if (stmt2 != null) stmt2.close();
									if (sql != null) sql = null;
								}
							} else throw new BusinessException("Desk Duty is Null!!");

							//Return Message
							insMsg = "Y";				
						} else if (params.getComplete_y().equals("N")) {
							//Return Message
							insMsg = "Y";				
						} else if (params.getComplete_y().equals("X")) {
							//Return Message
							insMsg = "Y";
							proMsg += "KE"+params.getFlt_num()+"  IROPS ߻ Ǿϴ. ";				
						}  else if (params.getComplete_y().equals("H")) {
							//Return Message
							insMsg = "Y";
							proMsg += "KE"+params.getFlt_num()+" ǻ Դϴ. ";				
						}
					} 
					//Data Ѱǵ ...
					else {
						//Number 
						params.setOption_num("1");
						params.setSeq_num("1");
						
						//Irops_Sch_t Table Insert
						stmt2 = conn.createStatement();
						sql = IroA010Query.getInstance().insIropsSchT(params);
						int insSch = stmt2.executeUpdate(sql);
						if (insSch != 1) throw new BusinessException("IROPS Schdule Insert Exception!!");
						
						//ü ȯ
						if (stmt2 != null) stmt2.close();
						if (sql != null) sql = null;
						
						//IROPS Desk ȸ
						List listDesk = new LinkedList();
						stmt2 = conn.createStatement();
						sql = IroA010Query.getInstance().selDesk();
						rs2 = stmt2.executeQuery(sql);
						
						while (rs2.next()) {
							listDesk.add(StringUtil.checkString(rs2.getString("Desc_e")));
						}
						
						//ü ȯ
						if (stmt2 != null) stmt2.close();
						if (rs2 != null) rs2.close();
						if (sql != null) sql = null;
						
						//Desk Duty Code ŭ IROPS_DESK_T Insert
						if (listDesk.size() > 0) {
							for (int j=0; j<listDesk.size(); j++) {
								params.setDesk_x((String)listDesk.get(j));
								//Logger.debug.println("+++++ Region_flt : "+params.getRegion_flt()+", Desk_x : "+params.getDesk_x());
								//Irops_Desk_t Table Insert
								/***********************/
								/*****  Region Rule  *****/
								/** desk_k : B,C ==>       **/
								/**                Domestic    */
								/**  D,E ==> International */
								/***********************/
								//
								if (params.getRegion_flt().equals("1")) {
									if (!params.getDesk_x().equals("B") && !params.getDesk_x().equals("C")) {
										stmt2 = conn.createStatement();
										sql = IroA010Query.getInstance().insIropsDeskT(params);
										int insDesk = stmt2.executeUpdate(sql);
										if (insDesk != 1) throw new BusinessException("IROPS Desk Insert Exception!!");
									}
								} 
								//
								else {
									if (!params.getDesk_x().equals("D") && !params.getDesk_x().equals("E")) {
										stmt2 = conn.createStatement();
										sql = IroA010Query.getInstance().insIropsDeskT(params);
										int insDesk = stmt2.executeUpdate(sql);
										if (insDesk != 1) throw new BusinessException("IROPS Desk Insert Exception!!");
									}
								}
								
								//ü ȯ
								if (stmt2 != null) stmt2.close();
								if (sql != null) sql = null;
							}
						} else throw new BusinessException("Desk Duty is Null!!");

						//Return Message
						insMsg = "Y";
					}
					
				}//end for
			}//end of hash is null
			
			hashData.put("FLAG",insMsg);
			hashData.put("MSG",StringUtil.to8859_1(proMsg));
			
			//Connection Commit
			conn.commit();
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA010Irops:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA010Irops:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA010Irops:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs1 != null) try {rs1.close(); } catch(Exception e) {}
			if (rs2 != null) try {rs2.close(); } catch(Exception e) {}
			if (stmt1 != null) try {stmt1.close();} catch(Exception e) {}
			if (stmt2 != null) try {stmt2.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	

	/** 
	  * <b>IRR/DSS  IROPS Flight Status Main ȸԼ</b>. 
	  * @param params IroA020BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public Hashtable selIroA020Main(IroA020BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt1 = null;
		ResultSet rs1 = null;
	    String sql1 = null;
	    Statement stmt2 = null;
		ResultSet rs2 = null;
	    String sql2 = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROPS Flight Status Main ȸ
			stmt1 = conn.createStatement();
			sql1 = IroA020Query.getInstance().selMain(params);
			rs1 = stmt1.executeQuery(sql1);
			
			while (rs1.next()) {
				IroA020BG entity = new IroA020BG();
				entity.setFlt_num(StringUtil.checkString(rs1.getString("Flt_Num")));
				entity.setKactyp(StringUtil.checkString(rs1.getString("Kactyp")));
				entity.setRegno(StringUtil.checkString(rs1.getString("Regno")));
				entity.setTitle_e(StringUtil.checkString(rs1.getString("Title_e")));
				entity.setStnfr(StringUtil.checkString(rs1.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs1.getString("Stnto")));
				entity.setSch_dep_dt(StringUtil.checkString(rs1.getString("Sch_Dep_Dt")));
				entity.setSch_dep_tm(StringUtil.checkString(rs1.getString("Sch_Dep_Tm")));
				entity.setEst_dep_tm(StringUtil.checkString(rs1.getString("Est_Dep_Tm")));
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs1.getString("First_Leg_Flt_Dt")));
				entity.setUser_id(StringUtil.checkString(rs1.getString("User_Id")));
				entity.setSeq_num(StringUtil.checkString(rs1.getString("Seq_Num")));
				
				//CONX PAX ȸ
				stmt2 = conn.createStatement();
				sql2 = IroA020Query.getInstance().selConxPax(entity);
				rs2 = stmt2.executeQuery(sql2);
				
				if (rs2.next()) {
					double dConxPax = rs2.getDouble("Conx_Pax");
					if (dConxPax > 0) {
						DecimalFormat df = new DecimalFormat("#,###,##0");
						entity.setConx_pax(df.format(dConxPax));
					} else entity.setConx_pax("");
				} else entity.setConx_pax(""); 
				
				if (stmt2 != null) stmt2.close();
				if (rs2 != null) rs2.close();
				if (sql2 != null) sql2 = null;
				
				listData.add(entity);
			}
			hashData.put("HASHDATA",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA020Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA020Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs1 != null) try {rs1.close(); } catch(Exception e) {}
			if (stmt1 != null) try {stmt1.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b>IRR/DSS  IROPS Flight Status Լ</b>. 
	  * @param params IroA020BG ȸ
	  * @return String ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String delIroA020Irops(IroA020BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String delMsg = "N";
	    double decisionX = 0;
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROPS Decision ȸ
			//Shift Manager ϰ  Cancel ϴ.
			if (!params.getDesk_x().equals("A")) {
				stmt = conn.createStatement();
				sql = IroA020Query.getInstance().selDecisionX(params);
				rs = stmt.executeQuery(sql);
							
				if (rs.next()) decisionX = rs.getDouble("Decision_x");
				if (decisionX <= 2) throw new BusinessException("̹ óưų ó DataԴϴ.");
				
				//üȯ
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
			}
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//IROPS DESK 
			stmt = conn.createStatement();
			sql = IroA020Query.getInstance().delIropsDeskT(params);
			int delDesk = stmt.executeUpdate(sql);
			if (delDesk == 0) throw new BusinessException(" Desk Data ϴ. ڿ ǹٶϴ.");
			
			//üȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;

			//IROPS SCH 
			stmt = conn.createStatement();
			sql = IroA020Query.getInstance().delIropsSchT(params);
			int delSch = stmt.executeUpdate(sql);
			if (delSch == 0) throw new BusinessException(" SKD Data ϴ. ڿ ǹٶϴ.");

			//üȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			int seqNum = Integer.valueOf(params.getSeq_num()).intValue();
			
			if (seqNum >= 2) {
				//IROPS SCH Complete 
				params.setSeq_num(String.valueOf(seqNum - 1).toString());
				stmt = conn.createStatement();
				sql = IroA020Query.getInstance().updCompleteY(params);
				int updSch = stmt.executeUpdate(sql);	
				if (updSch != 1) throw new BusinessException(" SKD Data ϴ. ڿ ǹٶϴ.");
			}
			
			//üȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Data Commit
			conn.commit();
			delMsg = "Y";

	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
	  		Logger.debug.println("[BASE:IroAllSLBean:delIroA020Irops:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:delIroA020Irops:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:delIroA020Irops:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return delMsg;
	}//end of function	

	/** 
	  * <b>IRR/DSS  Option Comparison Flight Info ȸԼ</b>. 
	  * @param params IroA030BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public Hashtable selIroA030FltInfo(IroA030BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROPS Complete_y ȸ
			stmt = conn.createStatement();
			sql = IroA030Query.getInstance().selCompleteY(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				hashData.put("FLAG",StringUtil.checkString(rs.getString("Complete_y")));
				hashData.put("FLT",params.getFlt_num());
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//IROPS Sch_Dep_DT ȸ
			stmt = conn.createStatement();
			sql = IroA030Query.getInstance().selDateInfo(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				hashData.put("DATE",StringUtil.checkString(rs.getString("Sch_Dep_Dt")));
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Flight Info Main ȸ
			stmt = conn.createStatement();
			sql = IroA030Query.getInstance().selFlightInfo(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				IroA030BG entity = new IroA030BG();
				entity.setSeq_num(params.getSeq_num());
				entity.setFirst_leg_flt_dt(params.getFirst_leg_flt_dt());
				entity.setFlt_num(params.getFlt_num());
				entity.setKactyp(StringUtil.checkString(rs.getString("Kactyp")));
				entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setLeg_num(StringUtil.checkString(rs.getString("Leg_Num")));
				entity.setRegion_flt(StringUtil.checkString(rs.getString("Region_Flt")));
				entity.setRegion_leg(StringUtil.checkString(rs.getString("Region_Leg")));
				entity.setSch_dep_tm(StringUtil.checkString(rs.getString("Sch_Dep_Tm")));
				entity.setSch_arv_tm(StringUtil.checkString(rs.getString("Sch_Arv_Tm")));
				entity.setEst_dep_tm(StringUtil.checkString(rs.getString("Est_Dep_Tm")));
				entity.setCfg_q(StringUtil.checkString(rs.getString("Cfg_Q")));
				entity.setBook_q(StringUtil.checkString(rs.getString("Book_Q")));
				entity.setChkin_q(StringUtil.checkString(rs.getString("Chkin_Q")));
				hashData.put("FLTINFO",entity);
			}
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA030FltInfo:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA030FltInfo:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
					
	/** 
	  * <b>IRR/DSS  Option Comparison Main ȸԼ</b>. 
	  * @param params IroA030BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public Hashtable selIroA030Main(IroA030BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROPS Holding ȸ
			stmt = conn.createStatement();
			sql = IroA030Query.getInstance().selIropsHold(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) hashData.put("Complete_y",StringUtil.checkString(rs.getString("Complete_y")));
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//IROPS Info Main ȸ
			stmt = conn.createStatement();
			sql = IroA030Query.getInstance().selIropsInfo(params);
			rs = stmt.executeQuery(sql);
			
			int allCnt = 0;
			int arrCnt = 0;
			String b_seqNum = "";
			String b_optionNum = "";
			String b_titleE = "";
			String b_titleX = "";
			String n_seqNum = "";
			String n_optionNum = "";
			String n_titleE = "";
			String n_titleX = "";
			String[] arrData = new String[9];
			while (rs.next()) {
				n_seqNum = StringUtil.checkString(rs.getString("Seq_Num"));
				n_optionNum= StringUtil.checkString(rs.getString("Option_Num"));
				n_titleE = StringUtil.checkString(rs.getString("Title_e"));
				n_titleX = StringUtil.checkString(rs.getString("Title_x"));
				
				if (!StringUtil.checkString(rs.getString("Desk_x")).equals("A") || allCnt == 0) {
					arrData[arrCnt] = StringUtil.checkString(rs.getString("Decision_x"));
				} else {
					IroA030BG entity = new IroA030BG();
					entity.setSeq_num(b_seqNum);
					entity.setOption_num(b_optionNum);
					entity.setTitle_x(b_titleX);
					entity.setTitle_e(b_titleE);
					entity.setDesk_man(arrData[0]);
					entity.setDesk_skd(arrData[1]);
					entity.setDesk_dis(arrData[2]);
					entity.setDesk_cre(arrData[3]);
					entity.setDesk_pax(arrData[4]);
					entity.setDesk_cgo(arrData[5]);
					entity.setDesk_ckp(arrData[6]);
					entity.setDesk_cab(arrData[7]);
					entity.setDesk_tec(arrData[8]);
					listData.add(entity);
					
					// ʱȭ
					arrCnt = 0;
					arrData = new String[9];
					arrData[arrCnt] = StringUtil.checkString(rs.getString("Decision_x"));
				}
				arrCnt++;
				allCnt++;
				b_seqNum = n_seqNum;
				b_optionNum = n_optionNum;
				b_titleE = n_titleE;
				b_titleX = n_titleX;
			}
			// ó
			IroA030BG entity = new IroA030BG();
			entity.setSeq_num(n_seqNum);
			entity.setOption_num(n_optionNum);
			entity.setTitle_x(n_titleX);
			entity.setTitle_e(n_titleE);
			entity.setDesk_man(arrData[0]);
			entity.setDesk_skd(arrData[1]);
			entity.setDesk_dis(arrData[2]);
			entity.setDesk_cre(arrData[3]);
			entity.setDesk_pax(arrData[4]);
			entity.setDesk_cgo(arrData[5]);
			entity.setDesk_ckp(arrData[6]);
			entity.setDesk_cab(arrData[7]);
			entity.setDesk_tec(arrData[8]);
			listData.add(entity);
			hashData.put("IROPSINFO",listData);
		
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA030Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA030Main:Exception] "+((Exception)e).getMessage());
			System.out.println("[BASE:IroAllSLBean:selIroA030Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function

	/** 
	  * <b>IRR/DSS  Option Comparison Option Suggest ԷԼ</b>. 
	  * @param params IroA030BG Է
	  * @return String Է¸޼
	  * @exception Exception
	  * @author Copyright (c) 2005/02/05 HIST 
	  */
	public String insIroA030OptionDesk(IroA030BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String insMsg = "N";
	    
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Set Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//MAX Option ȸ
			stmt = conn.createStatement();
			sql = IroA030Query.getInstance().selMaxSeq(params);
			rs = stmt.executeQuery(sql);
			int maxOption = 0;
			if (rs.next()) params.setOption_num(String.valueOf(rs.getInt("Max_Option")+1).toString());
			else params.setOption_num("1");
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Option Suggest IROPS_SCH_T 
			stmt = conn.createStatement();
			sql = IroA030Query.getInstance().insIropsSchT(params);
			int insSch = stmt.executeUpdate(sql);
			if (insSch != 1) throw new BusinessException("IROPS SKD !!");
			
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			//IROPS Desk ȸ
			List listDesk = new LinkedList();
			stmt = conn.createStatement();
			sql = IroA010Query.getInstance().selDesk();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				listDesk.add(StringUtil.checkString(rs.getString("Desc_e")));
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Desk Duty Code ŭ IROPS_DESK_T Insert
			if (listDesk.size() > 0) {
				for (int j=0; j<listDesk.size(); j++) {
					params.setDesk_x((String)listDesk.get(j));
					//Irops_Desk_t Table Insert
					/***********************/
					/*****  Region Rule  *****/
					/** desk_k : B,C ==>       **/
					/**                Domestic    */
					/**  D,E ==> International */
					/***********************/
					//
					if (params.getRegion_flt().equals("1")) {
						if (!params.getDesk_x().equals("D") && !params.getDesk_x().equals("E")) {
							stmt = conn.createStatement();
							sql = IroA030Query.getInstance().insIropsDeskT(params);
							int insDesk = stmt.executeUpdate(sql);
							if (insDesk != 1) throw new BusinessException("IROPS Desk Insert Exception!!");
						}
					} 
					//
					else {
						if (!params.getDesk_x().equals("B") && !params.getDesk_x().equals("C")) {
							stmt = conn.createStatement();
							sql = IroA030Query.getInstance().insIropsDeskT(params);
							int insDesk = stmt.executeUpdate(sql);
							if (insDesk != 1) throw new BusinessException("IROPS Desk Insert Exception!!");
						}
					}
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
				}
			} else throw new BusinessException("Desk Duty is Null!!");
			
			
			//Connection Commit
			conn.commit();
			insMsg = "Y";
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA030OptionDesk:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA030OptionDesk:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA030OptionDesk:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return insMsg;
	}//end of function
	
	/** 
	  * <b>IRR/DSS  Option Comparison Comments ȸԼ</b>. 
	  * @param params IroA030BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public Hashtable selIroA030Comments(IroA030BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Comments ȸ
			stmt = conn.createStatement();
			sql = IroA030Query.getInstance().selComments(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA030BG entity = new IroA030BG();
				entity.setDesk_x(StringUtil.checkString(rs.getString("Desk_x")));
				entity.setCode_x(StringUtil.checkString(rs.getString("Code_x")));
				entity.setKor_n(StringUtil.checkString(rs.getString("Kor_n")));
				entity.setTimestamp(StringUtil.checkString(rs.getString("TimeStamp")));
				String decisionX = StringUtil.checkString(rs.getString("Decision_x"));
				if ("1".equals(decisionX)) entity.setDecision_x("#67CF67");//@2013-07-02 code review : if ("1".equals(decisionX)) entity.setDecision_x("#67CF67");
				else if ("2".equals(decisionX)) entity.setDecision_x("#E95151");//@2013-07-02 code review :else if (decisionX.equals("2")) entity.setDecision_x("#E95151");
				else if ("3".equals(decisionX)) entity.setDecision_x("#EBD304");//@2013-07-02 code review :else if (decisionX.equals("3")) entity.setDecision_x("#EBD304");
				else entity.setDecision_x("");
				entity.setDecision_e(StringUtil.checkString(rs.getString("Decision_e")));
				listData.add(entity);
			}
			hashData.put("COMMENTS",listData);
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA030Comments:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA030Comments:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b>IRR/DSS  Option Comparison Check List Item ȸԼ</b>. 
	  * @param params IroA030BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public Hashtable selIroA030Check(IroA030BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	    String descE = "";
	    String checkListE = "";
	    
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Check List Items Check ȸ
			stmt = conn.createStatement();
			sql = IroA030Query.getInstance().selCheckFlag(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				checkListE = StringUtil.checkString(rs.getString("CheckList_e"));
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
						
			//Check List Items ȸ
			stmt = conn.createStatement();
			sql = IroA030Query.getInstance().selCheckList(params);
			rs = stmt.executeQuery(sql);
			
			int listCnt = 0;
			while (rs.next()) {
				IroA030BG entity = new IroA030BG();
				entity.setDesc_e(StringUtil.checkString(rs.getString("Desc_e")));
				if (!"".equals(checkListE)) entity.setChecklist_e(checkListE.substring(listCnt,listCnt+1));//@2013-07-02 codeReview : if (!checkListE.equals("")) entity.setChecklist_e(checkListE.substring(listCnt,listCnt+1));
				else entity.setChecklist_e("4");
				listData.add(entity);
				listCnt++;
			}
			hashData.put("HASHDATA",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA030Check:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA030Check:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b>IRR/DSS  Option Comparison Comments Լ</b>. 
	  * @param params IroA030BG ȸ
	  * @return String  Message
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 HIST 
	  */
	public String updIroA030Comments(IroA030BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
	    String sql = null;
	    
	    //Return ü
	    String updMsg = "N";
	    
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Comments 
			stmt = conn.createStatement();
			sql = IroA030Query.getInstance().updComments(params);
			int updCnt = stmt.executeUpdate(sql);
			if (updCnt != 1) throw new BusinessException("Decision  ");
			updMsg = "Y";
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroA030Comments:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroA030Comments:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroA030Comments:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return updMsg;
	}//end of function	

	/** 
	  * <b>IRR/DSS  Decision Making&Action Main ȸԼ</b>. 
	  * @param params IroA040BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/07 HIST 
	  */
	public Hashtable selIroA040Main(IroA040BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   	    
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//ä Data ǥ
			stmt = conn.createStatement();
			sql = IroA040Query.getInstance().updDecisionE(params);
			int updDec = stmt.executeUpdate(sql);
			if (updDec == 0) throw new BusinessException("ä Data  !!");
			
			//üȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Data Holding 
			stmt = conn.createStatement();
			sql = IroA040Query.getInstance().updCompleteY(params);
			int updCnt = stmt.executeUpdate(sql);
			if (updCnt == 0) throw new BusinessException(" Holding  !!");
			
			//üȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Shift Manager ID Է
			stmt = conn.createStatement();
			sql = IroA040Query.getInstance().updUserID(params);
			int updEmp = stmt.executeUpdate(sql);
			//if (updEmp == 0) throw new BusinessException("Shift Manager ID Է !!");
			
			//üȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
						
			//Title_e ȸ
			stmt = conn.createStatement();
			sql = IroA040Query.getInstance().selTitleE(params);
			rs = stmt.executeQuery(sql);
			if (rs.next()) {
				IroA040BG entity = new IroA040BG();
				entity.setFirst_leg_flt_dt(params.getFirst_leg_flt_dt());
				entity.setFlt_num(params.getFlt_num());
				entity.setStnfr(params.getStnfr());
				entity.setStnto(params.getStnto());
				entity.setSeq_num(params.getSeq_num());
				entity.setOption_num(params.getOption_num());
				entity.setTitle_e(StringUtil.checkString(rs.getString("Title_e")));
				entity.setDecision_e(StringUtil.checkString(rs.getString("Decision_e")));
				hashData.put("BASICINFO",entity);
			}
			
			//üȯ
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Desk Comment ȸ
			stmt = conn.createStatement();
			sql = IroA040Query.getInstance().selDeskComment(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA040BG entity = new IroA040BG();
				entity.setCode_x(StringUtil.checkString(rs.getString("Code_x")));
				entity.setKor_n(StringUtil.checkString(rs.getString("Kor_n")));
				entity.setTimestamp(StringUtil.checkString(rs.getString("TimeStamp")));
				String decisionX = StringUtil.checkString(rs.getString("Decision_x"));
				if ("1".equals(decisionX)) entity.setDecision_x("#67CF67");//				@2013-07-02 codeReview :if (decisionX.equals("1")) entity.setDecision_x("#67CF67");
				else if ("2".equals(decisionX)) entity.setDecision_x("#E95151");//				@2013-07-02 codeReview :else if (decisionX.equals("2")) entity.setDecision_x("#E95151");
				else if ("3".equals(decisionX)) entity.setDecision_x("#EBD304");//				@2013-07-02 codeReview :else if (decisionX.equals("3")) entity.setDecision_x("#EBD304");
				else entity.setDecision_x("#FFFFFF");
				entity.setDecision_e(StringUtil.checkString(rs.getString("Decision_e")));
				listData.add(entity);
			}
			hashData.put("HASHDATA",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA040Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA040Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA040Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b>IRR/DSS  Decision Making&Action Main Լ</b>. 
	  * @param params IroA040BG ȸ
	  * @return String  
	  * @exception Exception
	  * @author Copyright (c) 2005/02/07 HIST 
	  */
	public String updIroA040Main(IroA040BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
	    String sql = null;
	    
	    //Return ü
	    String updMsg = "N";
	   	    
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Set Auto Commit False
			conn.setAutoCommit(false);
			
			//Making&Action ä Data 
			stmt = conn.createStatement();
			sql = IroA040Query.getInstance().updIropsSchT(params);
			int updSch = stmt.executeUpdate(sql);
			if (updSch != 1) throw new BusinessException("IROPS SKD  ! ڿ ǹٶϴ.");
			
			//üȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			//Making&Action Data Completing 
			stmt = conn.createStatement();
			sql = IroA040Query.getInstance().updCompleteY(params);
			int updCom = stmt.executeUpdate(sql);
			if (updCom == 0) throw new BusinessException(" Complete  ! ڿ ǹٶϴ.");
			
			//üȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
						
			//Connection Commit
			conn.commit();
			updMsg = "Y";
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:selIroA040Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:selIroA040Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:selIroA040Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return updMsg;
	}//end of function	
	
	/** 
	  *  IROPS REPORT main ȸԼ. 
	  * @param params IroA110BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01 
	  */
	public Hashtable selIroA110Main(IroA110BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROPS REPORT ȸ
			stmt = conn.createStatement();
			sql = IroA110Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA110BG entity = new IroA110BG();
				
				entity.setKor_n(StringUtil.checkString(rs.getString("Kor_n")));
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setTitle_e(StringUtil.checkString(rs.getString("Title_e")));
				entity.setDecision_e(StringUtil.checkString(rs.getString("Decision_e")));
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
				entity.setSeq_num(StringUtil.checkString(rs.getString("Seq_Num")));
				entity.setOption_num(StringUtil.checkString(rs.getString("Option_Num")));
				entity.setUser_id(StringUtil.checkString(rs.getString("User_Id")));
				
				listData.add(entity);
			}
			hashData.put("IROPSINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA110Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA110Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
		
	/** 
	  *  IROPS REPORT main update Լ. 
	  * @param params IroA110BG 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01 
	  */
	public int updIroA110Main(IroA110BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
	    String sql = null;
	    
	    //Return ü
	    int returnValue = 0;
	   
	    try {    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//IROPS REPORT update
			stmt = conn.createStatement();
			sql = IroA110Query.getInstance().updMain(params);
			returnValue = stmt.executeUpdate(sql);

			if (returnValue != 1) {
				throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
			} else {
				returnValue = 1;				
			}
			
			//Data Commit
			conn.commit();
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
	  		Logger.debug.println("[BASE:IroAllSLBean:updIroA110Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroA110Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroA110Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function	
	
	/** 
	  *  Daily IROPS REPORT main ȸԼ. 
	  * @param params IroQ120BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/03 
	  */
	public Hashtable selIroQ120Main(IroQ120BG params) throws BusinessException {
		
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   	//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Daily IROPS REPORT ȸ
			stmt = conn.createStatement();
			sql = IroQ120Query.getInstance().selIroQ120Main(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ120BG entity = new IroQ120BG();
				
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setKactyp(StringUtil.checkString(rs.getString("Kactyp")));
				entity.setRegno(StringUtil.checkString(rs.getString("Regno")));
				entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt")));
				entity.setAct_dep_dt(StringUtil.checkString(rs.getString("Act_Dep_Dt")));
				entity.setSch_arv_dt(StringUtil.checkString(rs.getString("Sch_Arv_Dt")));
				entity.setAct_arv_dt(StringUtil.checkString(rs.getString("Act_Arv_Dt")));
				entity.setTitle_e(StringUtil.checkString(rs.getString("Title_e")));
				entity.setRemark_e(StringUtil.checkString(rs.getString("Decision_e")));
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
				entity.setSeq_num(StringUtil.checkString(rs.getString("Seq_Num")));
				entity.setOption_num(StringUtil.checkString(rs.getString("Option_Num")));
				entity.setHide_y(StringUtil.checkString(rs.getString("Hide_y")));
				entity.setManager_d1(StringUtil.checkString(rs.getString("MANAGER_D1")));
				entity.setManager_d2(StringUtil.checkString(rs.getString("MANAGER_D2")));
				listData.add(entity);
			}
			hashData.put("DAILYIROPSINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ120Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ120Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  *  Dailly IROPS REPORT main update Լ. 
	  * @param params IroA120BG 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/01 
	  */
	public int updIroQ120Main(Hashtable hashData) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
	    String sql = null;
	    
	    //Return ü
	    int returnValue = 0;
	   
	    try {    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			if (hashData != null) {
				List listData = (List)hashData.get("HASHDATA");
				if (listData != null && listData.size() > 0) {
					for (int i=0; i<listData.size(); i++) {
						IroQ120BG params = (IroQ120BG)listData.get(i);
						
						//IROPS REPORT update
						stmt = conn.createStatement();
						sql = IroQ120Query.getInstance().updIroQ120Main(params);
						returnValue = stmt.executeUpdate(sql);
			
						if (returnValue != 1) {
							throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
						} else {
							returnValue = 1;				
						}
						
					}
				}
			}
			
			//Data Commit
			conn.commit();
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
	  		Logger.debug.println("[BASE:IroAllSLBean:updIroQ120Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroQ120Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroQ120Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function	
	
	/** 
	  *  Message Board  Լ. 
	  * @param params IroA050BG 
	  * @return String  
	  * @exception Exception
	  * @author Copyright (c) 2005/02/07 
	  */
	public String insIroA050Message(IroA050BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
	    String sql = null;
	    
	    //Return ü
	    String insMsg = "N";
	   
	    try {    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//IROPS_SCH_T Update
			stmt = conn.createStatement();
			sql = IroA050Query.getInstance().updIropsSchT(params);
			int updCnt = stmt.executeUpdate(sql);
			if (updCnt != 1) throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
			
			if (stmt != null) stmt.close();
			if (sql != null) sql = new String();
			
			//20150428 MHS
			String mhsMessage = StringUtil.checkString(params.getMsg_data());
			mhsMessage = mhsMessage.startsWith("Y.QD ") ? mhsMessage.replace("Y.QD ", "QU ") : mhsMessage;

			StringBuffer tempBf = new StringBuffer();
			boolean isOriginLine = false;
			boolean notYetStx = true;
			for(int i=0; i<mhsMessage.length(); i++) {
			
				tempBf.append(mhsMessage.charAt(i)+"");
				
				if(".".equals(mhsMessage.charAt(i) + "")) {
					isOriginLine = true;
				}
				if(notYetStx && isOriginLine && StringUtil.unescape("/uA").equals(mhsMessage.charAt(i) + "")) {
					tempBf.append(StringUtil.unescape("/u2"));
					notYetStx = false;
				}
			}
			mhsMessage = tempBf.toString();
			
			mhsMessage = StringUtil.unescape("/uD/uA") + StringUtil.unescape("/u1") 
					   + mhsMessage 
					   + StringUtil.unescape("/uD/uA") + StringUtil.unescape("/u3");
			
			
			//MS_TELEX_MSG_T update
			stmt = conn.createStatement();
			sql = IroA050Query.getInstance().insMessage(params, mhsMessage);
			int insCnt = stmt.executeUpdate(sql);
			if (insCnt != 1) throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
			
			//Data Commit
			conn.commit();
			insMsg = "Y";
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
	  		Logger.debug.println("[BASE:IroAllSLBean:insIroA050Message:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA050Message:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA050Message:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return insMsg;
	}//end of function	
	
	/** 
	  * ADDR BOOK ȸԼ. 
	  * @param params IroA050BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/02/04 
	  */
	public Hashtable selIroA050Addr(IroA050BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//ADDR BOOK ȸ
			stmt = conn.createStatement();
			sql = IroA050Query.getInstance().selAddr(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA050BG entity = new IroA050BG();
				
				entity.setAddr_c(StringUtil.checkString(rs.getString("Addr_c")));
				entity.setAddr_e(StringUtil.checkString(rs.getString("Addr_e")));
				
				listData.add(entity);
			}
			hashData.put("ADDRINFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA050Addr:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA050Addr:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	

	/** 
	  * <b>IROPS Queue Main ȸԼ</b>. 
	  * @param params IroQ060BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/04/26 HIST 
	  */
	public Hashtable selIroQ060Main(IroQ060BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   	    
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROPS ̿Ϸ ȸ
			stmt = conn.createStatement();
			sql = IroQ060Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ060BG entity = new IroQ060BG();
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
				entity.setTimestamp(StringUtil.checkString(rs.getString("Timestamp")));
				entity.setArln_cd(StringUtil.checkString(rs.getString("Arln_Cd")));
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setSeq_num(StringUtil.checkString(rs.getString("Seq_Num")));
				entity.setOption_num(StringUtil.checkString(rs.getString("Option_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setTitle_e(StringUtil.checkString(rs.getString("Title_e")));
				entity.setTitle_x(StringUtil.checkString(rs.getString("Title_x")));
				listData.add(entity);
			}
			hashData.put("HASHDATA",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ060Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ060Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/** 
	  * SKD   Process Update Լ. 
	  * @param params IroQ130BG 
	  * @return int returnValue(0 : update , 1 : update , 2 : update  Ǿƴ)
	  * @exception Exception
	  * @author Copyright (c) 2005/04/22 
	  */
	public int updIroQ130Process(IroQ130BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	   int returnValue = 1;
	   
	    try {    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//project 
			String auth_pmsn = StringUtil.checkString(params.getAuth_pmsn());
			
			//update 
			String flag_1 = "";
			String flag_2 = "";
			
			//Main ȸ
			stmt = conn.createStatement();
			sql = IroQ130Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			String processed = "";
			String project_no = "";
			String manager_d1 = "";
			String manager_d2 = "";
			
			while (rs.next()) {
				processed = StringUtil.checkString(rs.getString("Processed"));
				project_no = StringUtil.checkString(rs.getString("Project_no"));
				manager_d1 = StringUtil.checkString(rs.getString("Manager_d1"));
				manager_d2 = StringUtil.checkString(rs.getString("Manager_d2"));
			}
			
			if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//processed Data 'X'̸ (1)
			if("X".equals(processed)){//@2013-07-02 codeReview :if(processed.equals("X")){
				stmt = conn.createStatement();
				sql = IroQ130Query.getInstance().selProcessed(project_no);
				rs = stmt.executeQuery(sql);
				
				String ms_processed = "";
				String error_reply = "";
				
				while (rs.next()) {
					ms_processed = StringUtil.checkString(rs.getString("Processed"));
					error_reply = StringUtil.checkString(rs.getString("error_reply"));
				}
				
				if("Y".equals(ms_processed)){//@2013-07-02 codeReview :if(ms_processed.equals("Y")){
					if((error_reply.getBytes()).length <= 3)	flag_1 = "Y";
					else	flag_1 = "E";
				}else{
					flag_1 = "N";
				}
				
				if (stmt != null) stmt.close();
				if (rs != null) rs.close();
				if (sql != null) sql = null;
			}
			
			//Manager_d1 Null̸鼭, Project  'A'  (2)
			if("".equals(manager_d1) && "A".equals(auth_pmsn))	flag_2 = "A";//@2013-07-02 codeReview :	if(manager_d1.equals("") && auth_pmsn.equals("A"))	flag_2 = "A";
			
			//Manager_d2 Null̸鼭, Project  'B'  (3)
			if("".equals(manager_d2) && "B".equals(auth_pmsn))	flag_2 = "B";//@2013-07-02 codeReview :	if(manager_d2.equals("") && auth_pmsn.equals("B"))	flag_2 = "B";
			
			//߿ ϳ   Ʈ Ѵ.
			if(!"".equals(flag_1) || !"".equals(flag_2)){	//@2013-07-02 codeReview :	if(!flag_1.equals("") || !flag_2.equals("")){	
				String updStr_1 = "";
				String updStr_2 = "";
				String updStr = "";
		
				if("Y".equals(flag_1))	updStr_1 = "Processed = 'Y'";//@2013-07-02 codeReview :	if(flag_1.equals("Y"))	updStr_1 = "Processed = 'Y'";
				else if("E".equals(flag_1))	updStr_1 = "Processed = 'E'";//@2013-07-02 codeReview :	else if(flag_1.equals("E"))	updStr_1 = "Processed = 'E'";
				else if("N".equals(flag_1))	updStr_1 = "Processed = 'N'";//@2013-07-02 codeReview :	else if(flag_1.equals("N"))	updStr_1 = "Processed = 'N'";

				if("A".equals(flag_2))	updStr_2 = "Manager_d1 = Sysdate";//@2013-07-02 codeReview :	if(flag_2.equals("A"))	updStr_2 = "Manager_d1 = Sysdate";
				else if("B".equals(flag_2))	updStr_2 = "Manager_d2 = Sysdate";//@2013-07-02 codeReview :	else if(flag_2.equals("B"))	updStr_2 = "Manager_d2 = Sysdate";
				
				if(!"".equals(flag_1) && !"".equals(flag_2)) updStr = updStr_1 + ", " + updStr_2;//@2013-07-02 codeReview :	if(!flag_1.equals("") && !flag_2.equals("")) updStr = updStr_1 + ", " + updStr_2;
				else updStr = updStr_1 + updStr_2;
				
				stmt = conn.createStatement();
				sql = IroQ130Query.getInstance().updProcessed(params, updStr);
				returnValue = stmt.executeUpdate(sql);
			
				if(returnValue == 0) throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
			}
	
			//Data Commit
			conn.commit();
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
	  		Logger.debug.println("[BASE:IroAllSLBean:updIroQ130Process:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroQ130Process:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroQ130Process:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function	
	
	/** 
	  * SKD   ȸ Լ. 
	  * @param params IroQ130BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/04/25 
	  */
	public Hashtable selIroQ130Main(IroQ130BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {    	
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Main ȸ
			stmt = conn.createStatement();
			sql = IroQ130Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ130BG entity = new IroQ130BG();
				
				String timestamp = StringUtil.checkString(rs.getString("Timestamp"));
		        String t_year = "";
		        String t_month = "";
		        String t_day = "";
		        if(!"".equals(timestamp) && timestamp.length() == 8){//@2013-07-02 codeReview :if(!timestamp.equals("") && timestamp.length() == 8){
			        t_year = timestamp.substring(0,4);
			        t_month = timestamp.substring(4,6);
			        t_day = timestamp.substring(6,8);
		        }
				entity.setTimestamp(t_year + " " + t_month + " " + t_day + " ");
				entity.setManager_d1(StringUtil.checkString(rs.getString("Manager_d1")));
				entity.setManager_d2(StringUtil.checkString(rs.getString("Manager_d2")));
				entity.setDecision_c("KE" + StringUtil.checkString(rs.getString("Flt_Num")) + " " + StringUtil.checkString(rs.getString("timeMon")) + " " + StringUtil.checkString(rs.getString("Decision_c")));
				entity.setDept_c(StringUtil.checkString(rs.getString("Dept_c")));
				entity.setKor_n(StringUtil.checkString(rs.getString("Kor_n")));
				entity.setTitle_e(StringUtil.checkString(rs.getString("Title_e")));
				entity.setDecision_e(StringUtil.checkString(rs.getString("Decision_e")));
				entity.setMessage(StringUtil.checkString(rs.getString("Message")));
			
				hashData.put("SKDCON",entity);
			}
	  		
	  		if (stmt != null) stmt.close();
			if (rs != null) rs.close();
			if (sql != null) sql = null;
			
			//Desk ȸ
			stmt = conn.createStatement();
			sql = IroQ130Query.getInstance().selSub(params);
			rs = stmt.executeQuery(sql);
			
			//Shift Manager
			String shiftManager = "";
			
			while (rs.next()) {
				IroQ130BG entity = new IroQ130BG();
				
				if((StringUtil.checkString(rs.getString("Desc_e"))).equals("A"))	shiftManager = StringUtil.checkString(rs.getString("Time"));
				entity.setS_code_x(StringUtil.checkString(rs.getString("Code_x")));
				entity.setS_kor_n(StringUtil.checkString(rs.getString("Kor_n")));
				entity.setS_timestamp(StringUtil.checkString(rs.getString("TimeStamp")));
				entity.setS_decision_e(StringUtil.checkString(rs.getString("Decision_e")));
				
				listData.add(entity);
			}
			hashData.put("SKDDESK", listData);
			
			IroQ130BG ent = new IroQ130BG();
			ent.setShiftManager(shiftManager);
			hashData.put("SM", ent);

	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ130Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ130Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b>IROPS Message Main ȸԼ</b>. 
	  * @param params IroQ070BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/07/04 HIST 
	  */
	public Hashtable selIroQ070Main(IroQ070BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   	    
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROPS ̿Ϸ ȸ
			stmt = conn.createStatement();
			sql = IroQ070Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ070BG entity = new IroQ070BG();
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
				entity.setTimestmp(StringUtil.checkString(rs.getString("Timestmp")));
				entity.setArln_cd(StringUtil.checkString(rs.getString("Arln_Cd")));
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setSeq_num(StringUtil.checkString(rs.getString("Seq_Num")));
				entity.setOption_num(StringUtil.checkString(rs.getString("Option_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setTitle_e(StringUtil.checkString(rs.getString("Title_e")));
				entity.setTitle_x(StringUtil.checkString(rs.getString("Title_x")));
				entity.setDecision_c(StringUtil.checkString(rs.getString("Decision_c")));
				entity.setDecision_e(StringUtil.checkString(rs.getString("Decision_e")));
				listData.add(entity);
			}
			hashData.put("HASHDATA",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ070Main:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ070Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/** 
	  * <b>IRR/DSS  IROPS MULTI Data Լ</b>. 
	  * @param hashParam Hashtable Grid Data
	  * @return boolean 忩
	  * @exception Exception
	  * @author Copyright (c) 2005/07/08 HIST 
	  */
	public boolean insIroA080Irops(Hashtable hashParam) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt1 = null;
		Statement stmt2 = null;
		ResultSet rs1 = null;
		ResultSet rs2 = null;
		String sql = null;
	    
	    //Return ü
	    boolean insFlag = false;
	   
	    try {
	    	//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			if (hashParam != null) {
				List listParam = (List)hashParam.get("listParam");
				if (listParam != null && listParam.size() > 0) {
					//ȭ GRID  ŭ 鼭 IROPS  
					for (int i=0; i<listParam.size(); i++) {
						IroA010BG params = (IroA010BG)listParam.get(i);
						
						//Step 1.    ȸ ( ֽŵ 1) '' : Step 2.  ,  '' : Step 3.
						stmt1 = conn.createStatement();
						sql = IroA080Query.getInstance().selIropsSeq(params);
						rs1 = stmt1.executeQuery(sql);
						
						//Step 2. ȸ ֱ Ϳ Complete_y  'Y' or '' ̸  ->  'Y' : Step 2-1.   ,  else ; Step 2-2.
						if (rs1.next()) {
							params.setSeq_num(StringUtil.checkString(rs1.getString("Seq_Num")));
							params.setComplete_y(StringUtil.checkString(rs1.getString("Complete_y")).toUpperCase());
							
							if (params.getComplete_y().equals("Y") || params.getComplete_y().equals("")) {
								//Step 2-1.   Complete_y  'X' ٲٰ   Seq_num+1 Ѵ. (Option_num = '1')
								//Option Number 
								params.setOption_num("1");
								if (params.getComplete_y().equals("Y")) {
									//IROPS MAX DATA Blocking ߺ
									stmt2 = conn.createStatement();
									sql = IroA080Query.getInstance().updIropsSeq(params);
									int updCnt = stmt2.executeUpdate(sql);
									if (updCnt == 0) throw new BusinessException("IROPS Seq Update Exception!!");
									params.setSeq_num(String.valueOf(Integer.valueOf(params.getSeq_num()).intValue() + 1).toString());
									
									//ü ȯ
									if (stmt2 != null) stmt2.close();
									if (sql != null) sql = null;
								} 
								//Step 2-2. Seq_num = '1' ,  Option_Num = '1'
								else params.setSeq_num("1");
								
								if (stmt2 != null) stmt2.close();
								if (sql != null) sql = null;
							} else if (params.getComplete_y().equals("X"))  throw new BusinessException("KE"+params.getFlt_num()+"  IROPS ߻ Ǿϴ. ");				
							else if (params.getComplete_y().equals("H")) throw new BusinessException("KE"+params.getFlt_num()+" ǻ Դϴ. ");				
						}
						//Step 3. Seq_num = '1' , Option_num = '1'
						else {
							params.setSeq_num("1");
							params.setOption_num("1");
						}
						
						//ü ȯ
						if (stmt1 != null) stmt1.close();
						if (rs1 != null) rs1.close();
						if (sql != null) sql = null;
						
						//Step 4. IROPS_SCH_T Insert
						stmt2 = conn.createStatement();
						sql = IroA080Query.getInstance().insIropsSchT(params);
						int insSch = stmt2.executeUpdate(sql);
						if (insSch != 1) throw new BusinessException("IROPS Schdule Insert Exception!!");
						
						//ü ȯ
						if (stmt2 != null) stmt2.close();
						if (sql != null) sql = null;
					
						
						//Step 5. IROPS DESK ȸ and IROPS DESK  (USER_NAME Ȯ)
						List listDesk = new LinkedList();
						stmt2 = conn.createStatement();
						sql = IroA080Query.getInstance().selDesk();
						rs2 = stmt2.executeQuery(sql);
						
						while (rs2.next()) {
							listDesk.add(StringUtil.checkString(rs2.getString("Desc_e")));
						}
						
						//ü ȯ
						if (stmt2 != null) stmt2.close();
						if (rs2 != null) rs2.close();
						if (sql != null) sql = null;
						
						//Desk Duty Code ŭ IROPS_DESK_T Insert
						if (listDesk.size() > 0) {
							for (int j=0; j<listDesk.size(); j++) {
								params.setDesk_x((String)listDesk.get(j));
								//Irops_Desk_t Table Insert
								/***********************************/
								/*  	Region Rule  								*/
								/*	desk_k : B,C ==> International     	*/
								/*  	D,E ==> Domestic 						*/
								/***********************************/
								//
								if (params.getRegion_flt().equals("1")) {
									if (!params.getDesk_x().equals("B") && !params.getDesk_x().equals("C")) {
										stmt2 = conn.createStatement();
										sql = IroA080Query.getInstance().insIropsDeskT(params);
										int insDesk = stmt2.executeUpdate(sql);
										if (insDesk != 1) throw new BusinessException("IROPS Desk Insert Exception!!");
									}
								} 
								//
								else {
									if (!params.getDesk_x().equals("D") && !params.getDesk_x().equals("E")) {
										stmt2 = conn.createStatement();
										sql = IroA080Query.getInstance().insIropsDeskT(params);
										int insDesk = stmt2.executeUpdate(sql);
										if (insDesk != 1) throw new BusinessException("IROPS Desk Insert Exception!!");
									}
								}
								
								//ü ȯ
								if (stmt2 != null) stmt2.close();
								if (sql != null) sql = null;
							}
						} else throw new BusinessException("Desk Duty is Null!!");
					}
				}
			}
						
			//Connection Commit
			conn.commit();
			insFlag = true;
			
	  	} catch(SQLException se) {
	  		if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA080Irops:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA080Irops:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA080Irops:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs1 != null) try {rs1.close(); } catch(Exception e) {}
			if (rs2 != null) try {rs2.close(); } catch(Exception e) {}
			if (stmt1 != null) try {stmt1.close();} catch(Exception e) {}
			if (stmt2 != null) try {stmt2.close();} catch(Exception e) {}
		}
		return insFlag;
	}//end of function		
	
	/** 
	  *  Monthly IROPS REPORT main ȸԼ. 
	  * @param params IroQ140BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/07/13 
	  */
	public Hashtable selIroQ140Main(IroQ140BG params) throws BusinessException {
		
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Monthly IROPS REPORT ȸ
			stmt = conn.createStatement();
			sql = IroQ140Query.getInstance().selIroQ140Main(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ140BG entity = new IroQ140BG();
				
				//25Ʈ ڸ.
		    	String titleE = StringUtil.checkString(rs.getString("Title_e"));
				String decisionE = StringUtil.checkString(rs.getString("Decision_e"));
				String subTitleE = "";
				String subDecisionE = "";
				
				if((titleE.getBytes()).length > 25)	subTitleE = new String(titleE.getBytes(), 0, 25);
				else		subTitleE = titleE;
				if((decisionE.getBytes()).length > 25)	subDecisionE = new String(decisionE.getBytes(), 0, 25);
				else		subDecisionE = decisionE;
				
				entity.setFirst_leg_flt_dt(StringUtil.checkString(rs.getString("First_Leg_Flt_Dt")));
				entity.setSeq_num(StringUtil.checkString(rs.getString("Seq_Num")));
				entity.setOption_num(StringUtil.checkString(rs.getString("Option_Num")));
				
				entity.setSch_dt(StringUtil.checkString(rs.getString("Sch_Dt")));
				entity.setFlt_num(StringUtil.checkString(rs.getString("Flt_Num")));
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setStnto(StringUtil.checkString(rs.getString("Stnto")));
				entity.setKactyp(StringUtil.checkString(rs.getString("Kactyp")));
				entity.setRegno(StringUtil.checkString(rs.getString("Regno")).substring(2));
				entity.setSch_dep_dt(StringUtil.checkString(rs.getString("Sch_Dep_Dt")));
				entity.setAct_dep_dt(StringUtil.checkString(rs.getString("Act_Dep_Dt")));
				entity.setSch_arv_dt(StringUtil.checkString(rs.getString("Sch_Arv_Dt")));
				entity.setAct_arv_dt(StringUtil.checkString(rs.getString("Act_Arv_Dt")));
				entity.setTitle_e(subTitleE);
				entity.setTitle_x(StringUtil.checkString(rs.getString("Title_x")));
				entity.setDecision_e(subDecisionE);
				entity.setDecision_c(StringUtil.checkString(rs.getString("Decision_c")));

				listData.add(entity);
			}
			hashData.put("IROPSMONTHLY",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ140Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ140Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function		
	
	/**
	  *  DSS Messenger List main ȸԼ. 
	  * @param params IroQ260BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/12/20 
	  */
	public Hashtable selIroQ260Main(IroQ260BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DSS Messenger List ȸ
			stmt = conn.createStatement();
			sql = IroQ260Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ260BG entity = new IroQ260BG();
				
				entity.setS_msgDtg(StringUtil.checkString(rs.getString("MSGDTG")));
				entity.setS_hh24miss(StringUtil.checkString(rs.getString("HH24MISS")));
				entity.setS_codeX(StringUtil.checkString(rs.getString("CODEX")));
				entity.setS_deskX(StringUtil.checkString(rs.getString("DESK_X")));
				entity.setS_userN(StringUtil.checkString(rs.getString("USER_N")));
				entity.setS_titleE(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setS_commentE(StringUtil.checkString(rs.getString("COMMENT_E")));
				entity.setS_replyDtg(StringUtil.checkString(rs.getString("REPLYDTG")));

				listData.add(entity);
			}
			hashData.put("DSSMSGLIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ260Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ260Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function		
	
	/**
	  *  DSS Messenger ȸԼ. 
	  * @param params IroQ280BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/12/20 
	  */
	public Hashtable selIroQ280Main(IroQ280BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DSS Messenger ȸ
			stmt = conn.createStatement();
			sql = IroQ280Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			IroQ280BG entity = new IroQ280BG();
			
			if (rs.next()) {
				entity.setS_titleE(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setS_commentE(StringUtil.checkString(rs.getString("COMMENT_E")));
				entity.setS_replyDtg(StringUtil.checkString(rs.getString("REPLYDTG")));
			}
			hashData.put("DSSMSGSEL", entity);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ280Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ280Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function	
	
	/**
	  *  DSS Messenger Է Լ. 
	  * @param params IroA270BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/12/20 
	  */
	public int insIroA270Main(IroA270BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    int returnValue = 0;
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//DSS Messenger Է
			stmt = conn.createStatement();
			sql = IroA270Query.getInstance().insMain(params);
			int insCnt = stmt.executeUpdate(sql);
			
			if (insCnt != 1) {
				throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
			} else {
				returnValue = 1;
				conn.commit();
			}
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:insIroA270Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroA270Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:insIroA270Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function		
	
	/**
	  *  DSS Messenger Popup ȸԼ. 
	  * @param params IroQ290BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/12/20 
	  */
	public Hashtable selIroQ290Main(IroQ290BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DSS Messenger List ȸ
			stmt = conn.createStatement();
			sql = IroQ290Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ290BG entity = new IroQ290BG();
				
				entity.setMsgDtg(StringUtil.checkString(rs.getString("HH24MISS")));
				entity.setCodeX(StringUtil.checkString(rs.getString("CODEX")));
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
				entity.setReplyDtg(StringUtil.checkString(rs.getString("REPLYDTG")));

				listData.add(entity);
			}
			hashData.put("DSSMSGPOPUP",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ290Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ290Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  DSS Messenger Popup ȸԼ. 
	  * @param params IroQ290BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2005/12/20 
	  */
	public Hashtable selIroQ290Detail(IroQ290BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DSS Messenger List ȸ
			stmt = conn.createStatement();
			sql = IroQ290Query.getInstance().selDetail(params);
			rs = stmt.executeQuery(sql);
			
			IroQ290BG entity = new IroQ290BG();
			
			if (rs.next()) {
				
				entity.setMsgDtg(StringUtil.checkString(rs.getString("HH24MISS")));
				entity.setCodeX(StringUtil.checkString(rs.getString("CODEX")));
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
				entity.setReplyDtg(StringUtil.checkString(rs.getString("REPLYDTG")));
			}
			hashData.put("DSSMSGDETAIL",entity);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ290Detail:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ290Detail:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	
	//****************************************************************************************************************
	//****************************************************************************************************************
	//****************************************************************************************************************
	//****************************************************************************************************************
	// 2006.01.12 ߰
	
	public Hashtable selIroQ210Main(IroQ210BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DSS Messenger List ȸ
			stmt = conn.createStatement();
			sql = IroQ210Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			int ttl_Ttl_q = 0;
			int ttl_Dur_q = 0;
			int ttl_Msg_q = 0;
			
			while (rs.next()) {
				IroQ210BG entity = new IroQ210BG();
				
				ttl_Ttl_q = ttl_Ttl_q + rs.getInt("Ttl_q");
				ttl_Dur_q = ttl_Dur_q + rs.getInt("ttl_Dur_q");
				ttl_Msg_q = ttl_Msg_q + rs.getInt("ttl_Msg_q");
				
				entity.setTitle_x(StringUtil.checkString(rs.getString("Title_x")));
				entity.setTtl_q(rs.getInt("Ttl_q"));
				entity.setDur_q(rs.getString("Dur_q"));
				entity.setMsg_q(rs.getInt("Msg_q"));

				listData.add(entity);
			}

				IroQ210BG entity = new IroQ210BG();
				
				entity.setTitle_x("TOTAL");
				entity.setTtl_q(ttl_Ttl_q);
				entity.setDur_q(StringUtil.secTohms(ttl_Dur_q / ttl_Ttl_q));
				entity.setMsg_q(ttl_Ttl_q - ttl_Msg_q);
				listData.add(entity);				
				
			hashData.put("CASELIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ210Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ210Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function

	public Hashtable selIroQ220Main(IroQ220BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DSS Messenger List ȸ
			stmt = conn.createStatement();
			sql = IroQ220Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ220BG entity = new IroQ220BG();
				
				entity.setStnfr(StringUtil.checkString(rs.getString("Stnfr")));
				entity.setTotal(rs.getInt("Total"));
				entity.setDLA(rs.getInt("DLA"));
				entity.setCHG(rs.getInt("CHG"));
				entity.setCNL(rs.getInt("CNL"));
				entity.setRTR(rs.getInt("RTR"));
				entity.setDIV(rs.getInt("DIV"));
				entity.setMLT(rs.getInt("MLT"));
				entity.setNEW(rs.getInt("NEW"));
				
				listData.add(entity);
			}
			hashData.put("STATIONLIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ220Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ220Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function

	public Hashtable selIroQ230Main(IroQ230BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DSS Messenger List ȸ
			stmt = conn.createStatement();
			sql = IroQ230Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			int ttl_Ttl_q = 0;
			int ttl_Dur_q = 0;
			int ttl_Msg_q = 0;
			
			while (rs.next()) {
				IroQ230BG entity = new IroQ230BG();
				
				ttl_Ttl_q = ttl_Ttl_q + rs.getInt("Ttl_q");
				ttl_Dur_q = ttl_Dur_q + rs.getInt("ttl_Dur_q");
				ttl_Msg_q = ttl_Msg_q + rs.getInt("ttl_Msg_q");
				
				entity.setDicision_c(StringUtil.checkString(rs.getString("Decision_c")));
				entity.setTtl_q(rs.getInt("Ttl_q"));
				entity.setDur_q(rs.getString("Dur_q"));
				entity.setMsg_q(rs.getInt("Msg_q"));

				listData.add(entity);
			}

				IroQ230BG entity = new IroQ230BG();
				
				entity.setDicision_c("TOTAL");
				entity.setTtl_q(ttl_Ttl_q);
				entity.setDur_q(StringUtil.secTohms(ttl_Dur_q / ttl_Ttl_q));
				entity.setMsg_q(ttl_Ttl_q - ttl_Msg_q);
				listData.add(entity);				

			hashData.put("REASONLIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ230Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ230Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function

	public Hashtable selIroQ240Main(IroQ240BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DSS Messenger List ȸ
			stmt = conn.createStatement();
			sql = IroQ240Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ240BG entity = new IroQ240BG();
				
				entity.setCode_x(StringUtil.checkString(rs.getString("Code_x")));
				entity.setMin_t(StringUtil.secTohms(rs.getInt("Min_t")));
				entity.setMax_t(StringUtil.secTohms(rs.getInt("Max_t")));
				entity.setOk_t(rs.getInt("Ok_t"));
				entity.setOk_c(rs.getInt("Ok_c"));
				entity.setNot_t(rs.getInt("Not_t"));
				entity.setNot_c(rs.getInt("Not_c"));
				entity.setHold_t(rs.getInt("Hold_t"));
				entity.setHold_c(rs.getInt("Hold_c"));
				entity.setNo_t(rs.getInt("No_t"));
				entity.setNo_c(rs.getInt("No_c"));
				entity.setAvg_t(StringUtil.secTohms(rs.getInt("Avg_t")));
				entity.setCase_t(rs.getInt("Case_t"));
				entity.setOpinion_t(rs.getInt("Opinion_t"));				

				listData.add(entity);
			}

			hashData.put("DESKLIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ240Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ240Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function

	//****************************************************************************************************************
	//****************************************************************************************************************
	//****************************************************************************************************************
	//****************************************************************************************************************
	//2009.07.13 ߰ : IROPS/DSS 
	
	/** 
	  * Desk Select Code ȸԼ. 
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/07/13 
	  */
	public Hashtable selIroA310DeskCode() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashDesk = new Hashtable();
	    List listDesk = new LinkedList();
	   
	    try {
			//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Desk Select Code ȸ
			stmt = conn.createStatement();
			sql = IroA310Query.getInstance().selDeskCode();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA310BG entity = new IroA310BG();
				entity.setCodeX(StringUtil.checkString(rs.getString("CODE_X")));
				entity.setDescE(StringUtil.checkString(rs.getString("DESC_E")));
				listDesk.add(entity);
			}
			
			hashDesk.put("DESK_CODE",listDesk);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA310DeskCode:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA310DeskCode:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashDesk;
	}//end of function
	
	/**
	  *  IROPS Issue SKD ȸԼ. 
	  * @param params IroA310BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/07/13 
	  */
	public Hashtable selIroA310Main(IroA310BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			String end_tm = params.getEndTm();
			String dom_int_x = params.getDomIntX();
			String stn = "";
			String flt = "";
			String acreg = "";
			
			//STN ִ 2
			if (!params.getStn().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getStn()), ",");
				int chk = 0;
				while(st.hasMoreTokens()) {
					String token = StringUtil.checkString(st.nextToken());
					if (chk != 0) stn = stn + ",";
					stn = stn + "'" + token + "'";
					chk++;
				}
			}
			//FLT ִ 5 -> 15
			if (!params.getFlt().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getFlt()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Byteų 4Byte 4° A-Z̸ տ 0 δ.
					if (token.length() == 3 || (token.length() == 4 && StringUtil.isAlphabet(token.substring(3,4)))) {
						token = "0" + token;
					}
					if (chk != 0) flt = flt + ",";
					flt = flt + "'" + token + "'";
					chk++;
				}
			}
			//ACREG ִ 5 -> 15
			if (!params.getAcreg().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getAcreg()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Bytḛ ڷθ Ǿ տ 7 δ.
					if (token.length() == 3 && !StringUtil.isAlphabet(token)) {
						token = "7" + token;
					}
					if (token.length() <= 4) {
						token = "HL" + token;
					}
					if (chk != 0) acreg = acreg + ",";
					acreg = acreg + "'" + token + "'";
					chk++;
				}
			}
			//SKD ȸ
			stmt = conn.createStatement();
			sql = IroA310Query.getInstance().searchSkd(end_tm, dom_int_x, stn, flt, acreg);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA310BG entity = new IroA310BG();
				
				entity.setSchDt(StringUtil.checkString(rs.getString("SCH_DT")));
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
				entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
				entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
				entity.setStd(StringUtil.checkString(rs.getString("STD")));
				entity.setSta(StringUtil.checkString(rs.getString("STA")));
				entity.setEtd(StringUtil.checkString(rs.getString("ETD")));
				entity.setRsvn(StringUtil.checkString(rs.getString("BOOK")));
				
				String domIntX = StringUtil.GetDomIntX(StringUtil.checkString(rs.getString("FLT_NUM")), StringUtil.checkString(rs.getString("KACTYP")));
				
				//System.out.println(StringUtil.checkString(rs.getString("FLT_NUM"))+" "+StringUtil.checkString(rs.getString("KACTYP"))+" "+domIntX);
				
				if ("CGO".equals(domIntX)) {//@2013-07-02 codeReview :if (domIntX.equals("CGO")) {
					entity.setLf(""); //ȭ Blank ǥ
					
				} else {
					int book = 0;
					int cfg = 0;
					
					if (StringUtil.checkString(rs.getString("BOOK")).equals("")) book = 0;
					else book = Integer.parseInt(rs.getString("BOOK"));
					if (StringUtil.checkString(rs.getString("CFG")).equals("")) cfg = 0;
					else cfg = Integer.parseInt(rs.getString("CFG"));
					
					if (book == 0 || cfg == 0) entity.setLf("");
					else entity.setLf(String.valueOf(book * 100 / cfg).toString()); //RSVN = Book / CFG * 100
				}
				
				//Process_x <> 'X' ̸ ACTN  Comment_x Display 
				if (StringUtil.checkString(rs.getString("PROCESS_X")).equals("X")) entity.setActn("");
				else entity.setActn(StringUtil.checkString(rs.getString("COMMENT_X")));
				
				entity.setDomIntX(domIntX);
				entity.setFirstLegFltDt(StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT")));
				entity.setSchDep(StringUtil.checkString(rs.getString("SCH_DEP")));
				entity.setLegNum(StringUtil.checkString(rs.getString("LEG_NUM")));
				
				listData.add(entity);
			}

			hashData.put("SKD_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA310Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA310Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  IROPS FLT 1, 2 ȸԼ. 
	  * @param params IroA310BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/07/14 
	  */
	public Hashtable selIroA310IropsFlt(IroA310BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROPS FLT 1, 2 ȸ
			stmt = conn.createStatement();
			if (StringUtil.checkString(params.getJobMode()).equals("1")) sql = IroA310Query.getInstance().iropsFlt1(params);
			else sql = IroA310Query.getInstance().iropsFlt2(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA310BG entity = new IroA310BG();
				
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setDssStartDt(StringUtil.checkString(rs.getString("DSS_START_DT")));
				entity.setSeqNum(StringUtil.checkString(rs.getString("SEQ_NUM")));
				
				listData.add(entity);
			}

			hashData.put("IROPS_FLT",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA310IropsFlt:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA310IropsFlt:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  IROPS FLT 1, 2  Confirm θ ȸ Լ. 
	  * @param params IroA310BG ȸ
	  * @return String returnValue 
	  * @exception Exception
	  * @author Copyright (c) 2009/07/24 
	  */
	public String selIroA310chkIropsFlt(IroA310BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//IROPS FLT  PROCESS_X ȸ
			stmt = conn.createStatement();
			sql = IroA310Query.getInstance().chkIropsFlt(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) returnValue = StringUtil.checkString(rs.getString("PROCESS_X"));
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA310chkIropsFlt:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA310chkIropsFlt:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  *  IROPS Issue  Լ. 
	  * @param IroA310BG newData
	  * @param IroA310BG keyData
	  * @param Hashtable hashParam
	  * @return Hashtable  msg
	  * @exception Exception
	  * @author Copyright (c) 2009/07/17 
	  */
	public Hashtable insIroA310Irops(IroA310BG newData, IroA310BG keyData, Hashtable hashParam) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//*************************************** SKD  Ǵ  ȸ ***************************************
			
			//1 : Searchؼ , 2 : Creation  
			//2  newData ִ, 1  newData ƿ °Ŵ...
			if (keyData.getSkdMode().equals("1")) {
				
				// FLT  ߿ Issue Ȱ ֳ Ȯ
				if (hashParam != null) {
					List listParam = (List)hashParam.get("listParam");
					for (int i=0; i<listParam.size(); i++) {
						IroA310BG params = (IroA310BG)listParam.get(i);
						
						//Issue Ǿ ȸ
						stmt = conn.createStatement();
						sql = IroA310Query.getInstance().chkIssued(params);
						rs = stmt.executeQuery(sql);
						
						if (rs.next()) {
							if (rs.getInt("CNT") != 0) throw new BusinessException("  ֽϴ."); 
						}
						
						//ü ȯ
						if (stmt != null) stmt.close();
						if (sql != null) sql = null;
						if (rs != null) rs.close();
					}
				}
				
			} else if (keyData.getSkdMode().equals("2")) {
				
				//KACTYP ȸ
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().selKactyp(newData.getRegno());
				rs = stmt.executeQuery(sql);
				
				String kactyp = "";
				
				if (rs.next()) kactyp = StringUtil.checkString(rs.getString("KACTYP"));
				else throw new BusinessException("Ȯ  Էϼ.");
				
				if (!kactyp.equals(newData.getActyp())) throw new BusinessException("A/C TYPE ٸϴ.");
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				//DEP ȸ
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().selIataPort(newData.getStnfr());
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					if (rs.getInt("CNT") == 0) throw new BusinessException("Ȯ ߰ Էϼ."); 
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				//ARR ȸ
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().selIataPort(newData.getStnto());
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					if (rs.getInt("CNT") == 0) throw new BusinessException("Ȯ  Էϼ."); 
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				//DAILY_SCH_T ȸ
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().selDailySchT(newData);
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					if (rs.getInt("CNT") != 0) throw new BusinessException("̹ ϴ Դϴ."); 
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				//DSS_NEW_SCH_T Է
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().insDssNewSchT(newData);
				int insFlg = stmt.executeUpdate(sql);
				
				if (insFlg != 1) throw new BusinessException("IROPS Schdule Insert Exception!!");
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			}
			
			//*************************************** IROPS, MSG Է ***************************************
			
			//N : IROPS Issue ȭ鿡 ó ó, M : Messenger â Ѿ 
			if (keyData.getMsgMode().equals("M")) {
				
				//keyData.getDssStartDt(), keyData.getMsgNo(), keyData.getLvlNo()  Ѿ´.
				
				//DSS_IROPS_T  PROCESS_X Ȯ
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().chkProcessX(keyData);
				rs = stmt.executeQuery(sql);
				
				String tmpProcessX = "";
				String tmpKorN = "";
				int tmpSeqNum = 0;
				
				if (rs.next()) { //ù° Row  ȸѴ~
					tmpProcessX = StringUtil.checkString(rs.getString("PROCESS_X"));
					tmpKorN = StringUtil.checkString(rs.getString("KOR_N"));
					tmpSeqNum = rs.getInt("SEQ_NUM");
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				//SEQ_NUM ϱ.
				if ("I".equals(tmpProcessX)) {//@2013-07-02 codeReview :if (tmpProcessX.equals("I")) {
					
					throw new BusinessException("̹  Ǿϴ.(" + tmpKorN + ")");
					
				} else if ("Y".equals(tmpProcessX)) {//@2013-07-02 codeReview :} else if (tmpProcessX.equals("Y")) {
					
					throw new BusinessException("̹ ϷǾϴ.(" + tmpKorN + ")");
					
				} else if ("R".equals(tmpProcessX)) {//@2013-07-02 codeReview :} else if (tmpProcessX.equals("R")) {
					
					keyData.setSeqNum(String.valueOf(tmpSeqNum + 1).toString()); //SEQ_NUM 1  Ų.
					
				} else {
					
					keyData.setSeqNum("1");
				}
								
				//MSG_NO ϱ.
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().selMsgNo(keyData, keyData.getMsgNo(), keyData.getLvlNo());
				rs = stmt.executeQuery(sql);
				
				String tmpMsgNo = "";
				
				if (rs.next()) tmpMsgNo = StringUtil.checkString(rs.getString("TMP_MSG_NO"));
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				String msgNo = "";
				String lvlNo = String.valueOf(Integer.parseInt(keyData.getLvlNo()) + 1).toString();
				
				if (keyData.getLvlNo().equals("0")) msgNo = tmpMsgNo.substring(0,2);
				else msgNo = keyData.getMsgNo() + tmpMsgNo.substring(0,2);
				
				//IROPS_DT ϱ
				String tmpTimestamp1 = "";
				String tmpTimestamp2 = "";
				String tmpIropsDt = "";
				
				//1. SYSDATE ϱ
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().getSysdate("", "YYYYMMDDHH24MISS");
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) tmpTimestamp1 = StringUtil.checkString(rs.getString("SYSDT"));
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				//2. TIMESTAMP ϱ
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().selTimestamp(keyData.getDssStartDt());
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					tmpTimestamp2 = StringUtil.checkString(rs.getString("TIMESTAMP"));
					
			        SimpleDateFormat sdf = new SimpleDateFormat( "yyyyMMddHHmmss" ); 
			        java.util.Date d1 = sdf.parse(tmpTimestamp1); 
			        java.util.Date d2 = sdf.parse(tmpTimestamp2);
			        
			        //1° Sysdate - ù° Timestamp 
                    //2° ù° Timestamp - ι° Timestamp 
                    //3° ...
			        //2ð(7200000)̻ ̰  ׶  Timestamp IROPS_DT  Ѵ.
			        if (d1.getTime() - d2.getTime() > 7200000) {
			        	if ("".equals(tmpIropsDt)) tmpIropsDt = tmpTimestamp1;////@2013-07-02 codeReview :if (tmpIropsDt.equals("")) tmpIropsDt = tmpTimestamp1;
			        }
			        
			        tmpTimestamp1 = tmpTimestamp2;
				}
				
				//2ð ̻ ̳    Timestamp( ȸǷ  Timestamp) Ѵ.
				if ("".equals(tmpIropsDt)) tmpIropsDt = tmpTimestamp2;//@2013-07-02 codeReview :if (tmpIropsDt.equals("")) tmpIropsDt = tmpTimestamp2;
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				keyData.setIropsDt(tmpIropsDt);
				
				//DSS_MSG_HEAD_T 
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().updDssMsgHeadT(keyData);
				int headFlg = stmt.executeUpdate(sql);
				
				if (headFlg != 1) throw new BusinessException("IROPS Issue Exception!!");
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				
				//DSS_MSG_DETAIL_T Է
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().insDssMsgDetailT(keyData, msgNo, lvlNo);
				int detailFlg = stmt.executeUpdate(sql);
				
				if (detailFlg != 1) throw new BusinessException("IROPS Issue Exception!!");
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				
			//IROPS Issue ȭ鿡 ó ó
			} else if (keyData.getMsgMode().equals("N")) {
				
				String dssStartDt = "";
				String iropsDt = "";
				
				//DSS_START_DT ȸ
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().selDssStartDt();
				rs = stmt.executeQuery(sql);
				
				String tmpDt1 = "";
				String tmpDt2 = "";
				String tmpDt3 = "";
				
				if (rs.next()) {
					tmpDt1 = StringUtil.checkString(rs.getString("DSS_START_DT1"));
					tmpDt2 = StringUtil.checkString(rs.getString("DSS_START_DT2"));
					tmpDt3 = StringUtil.checkString(rs.getString("DSS_START_DT3"));
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				//ߺ ȸ 1
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().chkDssStartDt("DSS_IROPS_T", tmpDt1);
				rs = stmt.executeQuery(sql);
				
				boolean chk1_1 = false;
				if (rs.next()) chk1_1 = true;
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				//ߺ ȸ 2
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().chkDssStartDt("DSS_MSG_HEAD_T", tmpDt1);
				rs = stmt.executeQuery(sql);
				
				boolean chk1_2 = false;
				if (rs.next()) chk1_2 = true;
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				//Ѵ ش  Ű Ȯ.
				if (!chk1_1 && !chk1_2) {
					
					dssStartDt = tmpDt1;
					
				} else { //Ѱ شǸ  Ű Ϸ .
					
					//ߺ ȸ 1
					stmt = conn.createStatement();
					sql = IroA310Query.getInstance().chkDssStartDt("DSS_IROPS_T", tmpDt2);
					rs = stmt.executeQuery(sql);
					
					boolean chk2_1 = false;
					if (rs.next()) chk2_1 = true;
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					if (rs != null) rs.close();
					
					//ߺ ȸ 2
					stmt = conn.createStatement();
					sql = IroA310Query.getInstance().chkDssStartDt("DSS_MSG_HEAD_T", tmpDt2);
					rs = stmt.executeQuery(sql);
					
					boolean chk2_2 = false;
					if (rs.next()) chk2_2 = true;
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					if (rs != null) rs.close();
					
					//Ѵ ش  Ű Ȯ.
					if (!chk2_1 && !chk2_2) {
						
						dssStartDt = tmpDt2;
						
					} else { //Ѱ شǸ  Ű Ϸ .
						
						//ߺ ȸ 1
						stmt = conn.createStatement();
						sql = IroA310Query.getInstance().chkDssStartDt("DSS_IROPS_T", tmpDt3);
						rs = stmt.executeQuery(sql);
						
						boolean chk3_1 = false;
						if (rs.next()) chk3_1 = true;
						
						//ü ȯ
						if (stmt != null) stmt.close();
						if (sql != null) sql = null;
						if (rs != null) rs.close();
						
						//ߺ ȸ 2
						stmt = conn.createStatement();
						sql = IroA310Query.getInstance().chkDssStartDt("DSS_MSG_HEAD_T", tmpDt3);
						rs = stmt.executeQuery(sql);
						
						boolean chk3_2 = false;
						if (rs.next()) chk3_2 = true;
						
						//ü ȯ
						if (stmt != null) stmt.close();
						if (sql != null) sql = null;
						if (rs != null) rs.close();
						
						//Ѵ ش  Ű Ȯ.
						if (!chk3_1 && !chk3_2) {
							
							dssStartDt = tmpDt3;
							
						} else { //3ϰ ȵǸ Error ߻.
							
							throw new BusinessException(" Ŀ ٽ õ ֽñ ٶϴ.");
						}
					}
				}
				
				//IROPS_DT ϱ (SYSDATE)
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().getSysdate("", "YYYYMMDDHH24MISS");
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) iropsDt = StringUtil.checkString(rs.getString("SYSDT"));
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				keyData.setDssStartDt(dssStartDt);
				keyData.setSeqNum("1");
				keyData.setIropsDt(iropsDt);
				
				//DSS_MSG_HEAD_T Է
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().insDssMsgHeadT(keyData);
				int headFlg = stmt.executeUpdate(sql);
				
				if (headFlg != 1) throw new BusinessException("IROPS Issue Exception!!");
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				
				//DSS_MSG_DETAIL_T Է
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().insDssMsgDetailT(keyData, "00", "0");
				int detailFlg = stmt.executeUpdate(sql);
				
				if (detailFlg != 1) throw new BusinessException("IROPS Issue Exception!!");
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				
			}
			
			// Insert ~
			if (!keyData.getSkdMode().equals("") && !keyData.getMsgMode().equals("")) {
				
				//DSS_IROPS_T Է
				stmt = conn.createStatement();
				sql = IroA310Query.getInstance().insDssIropsT(keyData);
				int iropsFlg = stmt.executeUpdate(sql);
				
				if (iropsFlg != 1) throw new BusinessException("IROPS Issue Exception!!");
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				
				// FLT  Է
				
				//String tmpDomIntX = "";
				boolean domChk = false; //
				boolean intChk = false; //
				boolean cgoChk = false; //ȭ
				
				if (hashParam != null) {
					List listParam = (List)hashParam.get("listParam");
					for (int i=0; i<listParam.size(); i++) {
						IroA310BG params = (IroA310BG)listParam.get(i);
						
						//DSS_IROPS_SCH_T Է
						stmt = conn.createStatement();
						sql = IroA310Query.getInstance().insDssIropsSchT(keyData.getDssStartDt(), keyData.getSeqNum(), params);
						int schFlg = stmt.executeUpdate(sql);
						
						if (schFlg != 1) throw new BusinessException("IROPS Issue Exception!!");
						
						//ü ȯ
						if (stmt != null) stmt.close();
						if (sql != null) sql = null;
						
						//tmpDomIntX = params.getDomIntX();
						if (params.getDomIntX().equals("DOM")) domChk = true;
						if (params.getDomIntX().equals("INT")) intChk = true;
						if (params.getDomIntX().equals("CGO")) cgoChk = true;
					}
				}
				
				/*//,  DESK  Է
				String[] desk = new String[9];
				if (tmpDomIntX.equals("DOM")) { // : A, D, E, F, G, H, I, J, K
					desk[0] = "A";
					desk[1] = "D";
					desk[2] = "E";
					desk[3] = "F";
					desk[4] = "G";
					desk[5] = "H";
					desk[6] = "I";
					desk[7] = "J";
					desk[8] = "K";
				} else { //(, ȭ) : A, B, C, F, G, H, I, J, K
					desk[0] = "A";
					desk[1] = "B";
					desk[2] = "C";
					desk[3] = "F";
					desk[4] = "G";
					desk[5] = "H";
					desk[6] = "I";
					desk[7] = "J";
					desk[8] = "K";
				}
				
				for (int i=0 ; i<desk.length ; i++) {
					//DSS_IROPS_DESK_T Է
					stmt = conn.createStatement();
					sql = IroA310Query.getInstance().insDssIropsDeskT(keyData, desk[i]);
					int deskFlg = stmt.executeUpdate(sql);
					
					if (deskFlg != 1) throw new BusinessException("IROPS Issue Exception!!");
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
				}*/
				
				//ROUTE_X    -->   ϰ Ǿ.
				
				//DOM/INT/CGO   Է DESK  ޶.
				/*String deskAll = ""; 
				if (domChk) {
					if (intChk) {
						if (cgoChk) {
							deskAll = "A B C D E F G H I J K L M N"; //DOM,INT,CGO
						} else {
							deskAll = "A B C D E F G H I J K L M N"; //DOM,INT
						}
					} else {
						if (cgoChk) {
							deskAll = "A B C D E F G H I J K L M N"; //DOM,CGO
						} else {
							deskAll = "A D E F G H I J K L M N"; //DOM
						}
					}
				} else {
					if (intChk) {
						if (cgoChk) {
							deskAll = "A B C F G H I J K L M N"; //INT,CGO
						} else {
							deskAll = "A B C F G H I J K L M N"; //INT
						}
					} else {
						if (cgoChk) {
							deskAll = "A B C F H I K L M N"; //CGO
						} 
					}
				}*/
				
				//2010.02.19 ߰ : 2200L~0600L(1300Z~2100Z)  ߻  PAX REP, CGO REP, CABIN SKD(G, H, J) ܽŴ. (NO ACTION ܽŰ )
                //2012.05.03  :  ״ G ٽ (=>ACTION)
				stmt = conn.createStatement();
				sql = ComQ01Query.getInstance().selDbTime("HH24MI","540/1440"); //Z
				rs = stmt.executeQuery(sql);
	
				boolean offDuty = false;//1300~2100
				boolean offDuty1 = false;//1300~2030 @2018-07-24
				if (rs.next()) {
					String nowTime = StringUtil.checkString(rs.getString("DB_TIME"));
					if (nowTime.length() == 4) {
						if (Integer.parseInt(nowTime) >= 1300 && Integer.parseInt(nowTime) < 2100) offDuty = true;
					}
					if (nowTime.length() == 4) {
						if (Integer.parseInt(nowTime) >= 1300 && Integer.parseInt(nowTime) < 2030) offDuty1 = true;
					}
				}
				
				//üȯ
				if (rs != null) rs.close();
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				
				//2010.02.01  : SKDR, DISP /  (D,E )
				String deskAll = ""; 
				if (!domChk && !intChk && cgoChk) { //CGO   
					
					if (offDuty) deskAll = "A B C F I K L M N";
					else deskAll = "A B C F H I K L M N";
				
				} else { //׿  					
					//if (offDuty) deskAll = "A B C F G I K L M N";//2012.05.03 : G߰
					//else deskAll = "A B C F G H I J K L M N";
					//@2018-07-24	
				    if(offDuty1)		deskAll = "A B C F G I K L M N";
				    else if(offDuty)	deskAll = "A B C F G I J K L M N";
				    else 				deskAll = "A B C F G H I J K L M N";
				}
				
				//DESK  Է
				StringTokenizer st = new StringTokenizer(deskAll, " ");
				while (st.hasMoreTokens()) {
					String desk = st.nextToken();
					
					//DSS_IROPS_DESK_T Է
					stmt = conn.createStatement();
					sql = IroA310Query.getInstance().insDssIropsDeskT(keyData, desk);
					int deskFlg = stmt.executeUpdate(sql);
					
					if (deskFlg != 1) throw new BusinessException("IROPS Issue Exception!!");
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
				}
				
				hashData.put("DSS_START_DT", keyData.getDssStartDt());
				hashData.put("SEQ_NUM", keyData.getSeqNum());
			}
			
			//Data Commit
			conn.commit();
		
		} catch(SQLException se) {
	  		if (conn != null) try { conn.rollback(); } catch(Exception ea) {}
	  		System.out.println("[BASE:IroAllSLBean:insIroA310Irops:SQLException] "+((SQLException)se).getMessage());
	  		Logger.debug.println("[BASE:IroAllSLBean:insIroA310Irops:SQLException] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			System.out.println("[BASE:IroAllSLBean:insIroA310Irops:BusinessException] "+((BusinessException)be).getMessage());
			Logger.debug.println("[BASE:IroAllSLBean:insIroA310Irops:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			if (conn != null) try { conn.rollback(); } catch(Exception ea) {}
			System.out.println("[BASE:IroAllSLBean:insIroA310Irops:Exception] "+((Exception)e).getMessage());
			Logger.debug.println("[BASE:IroAllSLBean:insIroA310Irops:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try { conn.close(); } catch(Exception e) {}
			if (rs != null) try { rs.close(); } catch(Exception e) {}
			if (stmt != null) try { stmt.close(); } catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  Option Comparision Title ȸԼ. 
	  * @param String dssStartDt, String seqNum
	  * @return String titleE
	  * @exception Exception
	  * @author Copyright (c) 2009/07/30 
	  */
	public String selIroA320TitleE(String dssStartDt, String seqNum) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String titleE = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Check List ȸ
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().selTitleE(dssStartDt, seqNum);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) titleE = StringUtil.checkString(rs.getString("TITLE_E"));
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320TitleE:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320TitleE:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return titleE;
	}//end of function
	
	/**
	  *  Option Comparision SKD ȸԼ. 
	  * @param params IroA320BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/07/27 
	  */
	public Hashtable selIroA320Main(IroA320BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
		Statement stmt2 = null;
		ResultSet rs2 = null;
	    String sql2 = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//SKD  ȸ 1 - DAILY_SCH_T  
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().selDailySchT(params);
			rs = stmt.executeQuery(sql);
			
			boolean dataFlg = false;
			
			while (rs.next()) {
				IroA320BG entity = new IroA320BG();
				
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
				entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
				entity.setFirstLegFltDt(StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT")));
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
				entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
				entity.setFltDate(StringUtil.checkString(rs.getString("FLT_DATE")));
				entity.setStd(StringUtil.checkString(rs.getString("STD")));
				entity.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_DT")));
				entity.setSchArvDt(StringUtil.checkString(rs.getString("SCH_ARV_DT")));
				entity.setEstDepDt(StringUtil.checkString(rs.getString("EST_DEP_DT")));
				entity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
				entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
				
				if (StringUtil.checkString(rs.getString("CGO_X")).equals("CGO")) {
					entity.setRsvn("");
					entity.setChkIn("");
				} else {
					entity.setRsvn(StringUtil.checkString(rs.getString("F_BOOK"))+"/"+StringUtil.checkString(rs.getString("C_BOOK"))+"/"+StringUtil.checkString(rs.getString("Y_BOOK")));
					entity.setChkIn(StringUtil.checkString(rs.getString("F_CHKIN"))+"/"+StringUtil.checkString(rs.getString("C_CHKIN"))+"/"+StringUtil.checkString(rs.getString("Y_CHKIN")));
				}
				
				//T/S PAX BOOK_Q ȸ
				stmt2 = conn.createStatement();
				sql2 = IroA320Query.getInstance().selTSPax(entity);
				sql2 = "SELECT SUM(F_BOOK_Q) F_SUM, SUM(C_BOOK_Q) C_SUM, SUM(Y_BOOK_Q) Y_SUM FROM (" + sql2 + ")";
				rs2 = stmt2.executeQuery(sql2);
				
				String tsPaxBook = "NIL";
				
				if (rs2.next()) {
					if (!StringUtil.checkString(rs2.getString("F_SUM")).equals("")) {
						tsPaxBook = StringUtil.checkString(rs2.getString("F_SUM")) + "/" + StringUtil.checkString(rs2.getString("C_SUM")) + "/" + StringUtil.checkString(rs2.getString("Y_SUM"));
					}
				}
				
				//ü ȯ
				if (stmt2 != null) stmt2.close();
				if (sql2 != null) sql2 = null;
				if (rs2 != null) rs2.close();
				
				entity.setTsPaxBook(tsPaxBook);
				
				listData.add(entity);
				
				dataFlg = true;
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (!dataFlg) {
				//SKD  ȸ 2 - 1    DSS_NEW_SCH_T  
				stmt = conn.createStatement();
				sql = IroA320Query.getInstance().selDssNewSchT(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					IroA320BG entity = new IroA320BG();
					
					entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
					entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
					entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
					entity.setFirstLegFltDt(StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT")));
					entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
					entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
					entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
					entity.setFltDate(StringUtil.checkString(rs.getString("FLT_DATE")));
					entity.setStd(StringUtil.checkString(rs.getString("STD")));
					entity.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_DT")));
					entity.setSchArvDt(StringUtil.checkString(rs.getString("SCH_ARV_DT")));
					entity.setEstDepDt(StringUtil.checkString(rs.getString("EST_DEP_DT")));
					entity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
					entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
					entity.setRsvn("");
					entity.setChkIn("");
					
					entity.setTsPaxBook("");
					
					listData.add(entity);
					
					dataFlg = true;
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
			}
			
			if (!dataFlg) throw new BusinessException("Data Not Found!"); 
			
			hashData.put("IROPS_SKD",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try { conn.close(); } catch(Exception e) {}
			if (rs != null) try { rs.close(); } catch(Exception e) {}
			if (stmt != null) try { stmt.close(); } catch(Exception e) {}
			if (rs2 != null) try { rs2.close(); } catch(Exception e) {}
			if (stmt2 != null) try { stmt2.close(); } catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  * IROPS  / Լ. 
	  * @param params IroA320BG ȸ
	  * @return String returnValue
	  * @exception Exception
	  * ۼ : 2010/12/30
	  */
	public String delIroA320Irops(IroA320BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//IROPS  / -> PROCESS_X = 'M'...
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().deleteIrops(params);
			int updFlg = stmt.executeUpdate(sql);
			
			if (updFlg != 1) throw new BusinessException("Delete Exception!!");
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			//Data Commit
			conn.commit();
			
			returnValue = "Y";
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:delIroA320Irops:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:delIroA320Irops:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:delIroA320Irops:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  *  Option Comparision Check List ȸԼ. 
	  * @param params IroA320BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/07/30 
	  */
	public Hashtable selIroA320CheckList(IroA320BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//CommentX 
			String commentX1 = "XXX";
			String commentX2 = "XXX";
			String commentX3 = "XXX";
			String commentX4 = "XXX";
			String commentX5 = "XXX";
			String commentX6 = "XXX";
			
			if (!StringUtil.checkString(params.getCommentX()).equals("")) {
				StringTokenizer st = new StringTokenizer(params.getCommentX(), " ");
				while (st.hasMoreTokens()) {
					String tmp = st.nextToken();
					if ("XXX".equals(commentX1)) commentX1 = tmp;//@2013-07-02 codeReview :	if (commentX1.equals("XXX")) commentX1 = tmp;
					else if ("XXX".equals(commentX2)) commentX2 = tmp;//	else if (commentX2.equals("XXX")) commentX2 = tmp;
					else if ("XXX".equals(commentX3)) commentX3 = tmp;//	else if (commentX3.equals("XXX")) commentX3 = tmp;
					else if ("XXX".equals(commentX4)) commentX4 = tmp;//	else if (commentX4.equals("XXX")) commentX4 = tmp;
					else if ("XXX".equals(commentX5)) commentX5 = tmp;//	else if (commentX5.equals("XXX")) commentX5 = tmp;
					else if ("XXX".equals(commentX6)) commentX6 = tmp;//	else if (commentX6.equals("XXX")) commentX6 = tmp;
				}
			}
			
			//Check List ȸ
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().selCheckList(params.getCodeX(), commentX1, commentX2, commentX3, commentX4, commentX5, commentX6);
			rs = stmt.executeQuery(sql);
			
			boolean dataFlg = false;
			
			while (rs.next()) {
				IroA320BG entity = new IroA320BG();
				
				entity.setDescE(StringUtil.checkString(rs.getString("DESC_E")));
				
				listData.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("CHECK_LIST",listData);
			
			//Desk Info CHECKLIST_E ȸ
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().selDeskInfo(params);
			rs = stmt.executeQuery(sql);
			
			String decisionX = "";
			String checklistE = "";
			
			while (rs.next()) {
				// ũ üũ  ´.
				if (StringUtil.checkString(rs.getString("CODE_X")).equals(params.getCodeX())) {
					decisionX = StringUtil.checkString(rs.getString("DECISION_X"));
					checklistE = StringUtil.checkString(rs.getString("CHECKLIST_E"));
				}
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("DECISION_X",decisionX);
			hashData.put("CHECKLIST_E",checklistE);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320CheckList:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320CheckList:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  Option Comparision Desk Info ȸԼ. 
	  * @param params IroA320BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/07/30 
	  */
	public Hashtable selIroA320DeskInfo(IroA320BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Desk Info ȸ
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().selDeskInfo(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA320BG entity = new IroA320BG();
				
				entity.setCodeX(StringUtil.checkString(rs.getString("CODE_X")));
				entity.setKorN(StringUtil.checkString(rs.getString("KOR_N")));
				entity.setTimestamp(StringUtil.checkString(rs.getString("TIMESTAMP")));
				entity.setDecisionX(StringUtil.checkString(rs.getString("DECISION_X")));
				entity.setDecisionE(StringUtil.checkString(rs.getString("DECISION_E")));
				entity.setDeskX(StringUtil.checkString(rs.getString("DESK_X")));
				entity.setChecklistE(StringUtil.checkString(rs.getString("CHECKLIST_E")));
				
				listData.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("DESK_INFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320DeskInfo:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320DeskInfo:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  Option Comparision - T/S PAX ȸ Լ. 
	  * @param IroA320BG params
	  * @return Hashtable hashData
	  * @exception Exception
	  * @author Copyright (c) 2009/09/11 
	  */
	public Hashtable selIroA320TSPaxInfo(IroA320BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
		Statement stmt2 = null;
		ResultSet rs2 = null;
	    String sql2 = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			String stnto = params.getStnto();
			
			//T/S PAX ȸ
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().selTSPax(params);
			rs = stmt.executeQuery(sql);
			
			//2009.12.01  : STD    ش. (STD   '00:00'  )
			List tmpList = new LinkedList();
			TreeSet tSet = new TreeSet();
			
			while (rs.next()) {
				
				IroA320BG entity = new IroA320BG();
				
				entity.setFlt(StringUtil.checkString(rs.getString("TRANS_ARLN_CD"))+StringUtil.checkString(rs.getString("TRANS_FLT_NUM")));
				entity.setDest(StringUtil.checkString(rs.getString("TRANS_STN_C")));
				entity.setFBook(StringUtil.checkString(rs.getString("F_BOOK_Q")));
				entity.setCBook(StringUtil.checkString(rs.getString("C_BOOK_Q")));
				entity.setYBook(StringUtil.checkString(rs.getString("Y_BOOK_Q")));
				entity.setFChkin(StringUtil.checkString(rs.getString("F_CHKIN_Q")));
				entity.setCChkin(StringUtil.checkString(rs.getString("C_CHKIN_Q")));
				entity.setYChkin(StringUtil.checkString(rs.getString("Y_CHKIN_Q")));
				entity.setBag(StringUtil.checkString(rs.getString("BAG_Q")));
				
				String schArvDtLoc = StringUtil.checkString(rs.getString("SCH_ARV_DT_LOC"));
				String transDt = StringUtil.checkString(rs.getString("TRANS_DT"));
				String transArlnCd = StringUtil.checkString(rs.getString("TRANS_ARLN_CD"));
				String transFltNum = StringUtil.checkString(rs.getString("TRANS_FLT_NUM"));
				String transStnC = StringUtil.checkString(rs.getString("TRANS_STN_C"));
				
				String std = "";
				String hh24mi = "";
				
				if ("KE".equals(transArlnCd)) {//@2013-07-02 codeReview :if (transArlnCd.equals("KE")) {
					
					//TRANS_ARLN_CD = 'KE' ϶
					stmt2 = conn.createStatement();
					sql2 = IroA320Query.getInstance().selTransArlnCdKE(schArvDtLoc, transDt, transFltNum, transStnC);
					rs2 = stmt2.executeQuery(sql2);
					
					if (rs2.next()) hh24mi = StringUtil.checkString(rs2.getString("SCH_DEP_DT_LOC"));
					
					//ü ȯ
					if (stmt2 != null) stmt2.close();
					if (sql2 != null) sql2 = null;
					if (rs2 != null) rs2.close();
					
				} else if ("ICN".equals(stnto)) {//@2013-07-02 codeReview :} else if (stnto.equals("ICN")) {
					
					//STNTO = 'ICN' ϶
					stmt2 = conn.createStatement();
					sql2 = IroA320Query.getInstance().selStntoICN(schArvDtLoc, transDt, transArlnCd, transFltNum);
					rs2 = stmt2.executeQuery(sql2);
					
					if (rs2.next()) hh24mi = StringUtil.checkString(rs2.getString("SCH_DT_LOC"));
					
					//ü ȯ
					if (stmt2 != null) stmt2.close();
					if (sql2 != null) sql2 = null;
					if (rs2 != null) rs2.close();
				}
				
				if (transDt.length() >= 11) std = transDt.substring(5,11) + hh24mi; //MM/DD HH24:MI 
				
				entity.setStd(std);
				
				//listData.add(entity);
				
				//STD   '00:00' .
				String sortKey = "";
				String hh = "00";
				String mi = "00";
				if (!"".equals(hh24mi)) {//@2013-07-02 codeReview :if (!hh24mi.equals("")) {
					hh = hh24mi.substring(0,2);
					mi = hh24mi.substring(3,5);
				}
				sortKey = transDt.substring(0,4)+transDt.substring(5,7)+transDt.substring(8,10)+hh+mi;
				entity.setSortKey(sortKey);
				
				tSet.add(sortKey);
				tmpList.add(entity);
			}
			
			//tSet <---- KEY(YYYYMMDDHH24MI)  . (KEY ߺ ҰϹǷ ߺ  ü  ̰   ̴)
			//tmpList <----  KEY  ü Ͱ  . (KEY ߺ )
			//listData <----  ü ͸ 
			
			if (tSet != null) {
				Object[] obj = tSet.toArray();
				for (int i=0; i<obj.length; i++) {
					for (int j=0; j<tmpList.size(); j++) {
						if (((IroA320BG)tmpList.get(j)).getSortKey().equals(String.valueOf(obj[i]).toString())) {
							listData.add((IroA320BG)tmpList.get(j));
						}
					}
				}
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("TSPAX_INFO",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320TSPaxInfo:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320TSPaxInfo:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try { conn.close(); } catch(Exception e) {}
			if (rs != null) try { rs.close(); } catch(Exception e) {}
			if (stmt != null) try { stmt.close(); } catch(Exception e) {}
			if (rs2 != null) try { rs2.close(); } catch(Exception e) {}
			if (stmt2 != null) try { stmt2.close(); } catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  Option Comparision - MSG ϱ   ȸԼ. 
	  * @param IroA320BG params
	  * @return Hashtable hashData
	  * @exception Exception
	  * @author Copyright (c) 2009/09/11 
	  */
	public Hashtable selIroA320MsgInfo(IroA320BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Desk Info ȸ
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().selMsgInfo(params);
			rs = stmt.executeQuery(sql);
			
			IroA320BG entity = new IroA320BG();
			
			if (rs.next()) {
				
				entity.setDssStartDt(StringUtil.checkString(rs.getString("DSS_START_DT")));
				entity.setMsgNo(StringUtil.checkString(rs.getString("MSG_NO")));
				entity.setLvlNo(StringUtil.checkString(rs.getString("LVL_NO")));
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setSchDepD(StringUtil.checkString(rs.getString("SCH_DEP_D")));
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("MSG_INFO",entity);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320MsgInfo:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA320MsgInfo:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  Option Comparision Check List û Send Լ. 
	  * @param params IroA320BG ȸ
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2009/07/31 
	  */
	public String updIroA320CheckList(IroA320BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//2009.12.03 ߰ : Check List   ִ   üũѴ(̹ Confirm ߴٸ ϸ ȵ).
			//PROCESS_X ȸ
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().selProcessX(params);
			rs = stmt.executeQuery(sql);
			
			String tmpProcessX = "";
			if (rs.next()) tmpProcessX = StringUtil.checkString(rs.getString("PROCESS_X"));
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			////@2013-07-02 codeReview :if (tmpProcessX.equals("C") || tmpProcessX.equals("A") || tmpProcessX.equals("M")) throw new BusinessException("ALREADY_CONFIRMED");
			if ("C".equals(tmpProcessX) || "A".equals(tmpProcessX) || "M".equals(tmpProcessX)) throw new BusinessException("ALREADY_CONFIRMED");
			
			//DSS_IROPS_DESK_T Update
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().updCheckList(params);
			int updFlg = stmt.executeUpdate(sql);
			
			if (updFlg != 1) throw new BusinessException("Check List Exception!!");
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			//Data Commit
			conn.commit();
			
			returnValue = "Y";
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroA320CheckList:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroA320CheckList:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroA320CheckList:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  *  Option Comparision Confirm Լ. 
	  * @param params IroA320BG ȸ
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2009/07/31 
	  */
	public String updIroA320Confirm(IroA320BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//2009.10.15 ߰ : Confirm   ִ   üũѴ.
			//PROCESS_X ȸ
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().selProcessX(params);
			rs = stmt.executeQuery(sql);
			
			String tmpProcessX = "";
			if (rs.next()) tmpProcessX = StringUtil.checkString(rs.getString("PROCESS_X"));
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			////@2013-07-02 codeReview :if (tmpProcessX.equals("C") || tmpProcessX.equals("A") || tmpProcessX.equals("M")) throw new BusinessException("ALREADY_CONFIRMED");
			if ("C".equals(tmpProcessX) || "A".equals(tmpProcessX) || "M".equals(tmpProcessX)) throw new BusinessException("ALREADY_CONFIRMED");
			
			//DSS_IROPS_T Update
			stmt = conn.createStatement();
			sql = IroA320Query.getInstance().updDssIropsT(params);
			int updFlg = stmt.executeUpdate(sql);
			
			if (updFlg != 1) throw new BusinessException("Confirm Exception!!");
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			//Data Commit
			conn.commit();
			
			returnValue = "Y";
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroA320Confirm:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroA320Confirm:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroA320Confirm:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  *  Decision Making & Action Irops Info ȸ Լ. 
	  * @param IroA330BG params ȸ
	  * @return Hashtable hashData
	  * @exception Exception
	  * @author Copyright (c) 2009/07/31 
	  */
	public Hashtable selIroA330IropsInfo(IroA330BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Check List ȸ
			stmt = conn.createStatement();
			sql = IroA330Query.getInstance().selDssIropsT(params);
			rs = stmt.executeQuery(sql);
			
			IroA330BG entity = new IroA330BG();
			
			if (rs.next()) {
				entity.setKorN(StringUtil.checkString(rs.getString("KOR_N")));
				entity.setIropsDt(StringUtil.checkString(rs.getString("IROPS_DT")));
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
			}
			
			hashData.put("IROPS_INFO",entity);
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA330IropsInfo:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA330IropsInfo:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  Decision Making & Action SKD Info ȸ Լ. 
	  * @param params IroA330BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/07/31 
	  */
	public Hashtable selIroA330Main(IroA330BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//SKD  ȸ 1 - DAILY_SCH_T  
			stmt = conn.createStatement();
			sql = IroA330Query.getInstance().selDailySchT(params);
			rs = stmt.executeQuery(sql);
			
			boolean dataFlg = false;
			
			while (rs.next()) {
				IroA330BG entity = new IroA330BG();
				
				entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
				entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
				entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
				entity.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_DT")));
				entity.setSchArvDt(StringUtil.checkString(rs.getString("SCH_ARV_DT")));
				entity.setEstDepDt(StringUtil.checkString(rs.getString("EST_DEP_DT")));
				entity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
				entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
				
				if (StringUtil.checkString(rs.getString("CGO_X")).equals("CGO")) {
					entity.setSupply("");
				} else {
					entity.setSupply(StringUtil.checkString(rs.getString("F_CFG"))+"/"+StringUtil.checkString(rs.getString("C_CFG"))+"/"+StringUtil.checkString(rs.getString("Y_CFG")));
				}
				
				entity.setActn(StringUtil.checkString(rs.getString("DEL_RC1"))+StringUtil.checkString(rs.getString("DEL_DUR1"))+StringUtil.checkString(rs.getString("DEL_RC2"))+StringUtil.checkString(rs.getString("DEL_DUR2")));
				
				listData.add(entity);
				
				dataFlg = true;
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (!dataFlg) {
				//SKD  ȸ 2 - 1    DSS_NEW_SCH_T  
				stmt = conn.createStatement();
				sql = IroA330Query.getInstance().selDssNewSchT(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					IroA330BG entity = new IroA330BG();
					
					entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
					entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
					entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
					entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
					entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
					entity.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_DT")));
					entity.setSchArvDt(StringUtil.checkString(rs.getString("SCH_ARV_DT")));
					entity.setEstDepDt(StringUtil.checkString(rs.getString("EST_DEP_DT")));
					entity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
					entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
					entity.setSupply("");
					entity.setActn("");
					
					listData.add(entity);
					
					dataFlg = true;
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
			}
			
			if (!dataFlg) throw new BusinessException("Data Not Found!"); 
			
			hashData.put("IROPS_SKD",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA330Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:selIroA330Main:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA330Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  Decision Making & Action Approve Ǵ Reject  Լ. 
	  * @param params IroA330BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/13 
	  */
	public Hashtable updIroA330AppRej(IroA330BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//DSS_IROPS_T Update
			stmt = conn.createStatement();
			sql = IroA330Query.getInstance().updDssIropsT(params);
			int updIrops = stmt.executeUpdate(sql);
			
			if (updIrops != 1) throw new BusinessException("Decision Making Exception!!");
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			//Approve  , DSS_IROPS_DESK_T   Desk Ұ, , Է OK Ѵ. -> OK  ʰ ID, ̸, TIMESTAMP ־ش.
			if (params.getArMode().equals("A")) {
				
				//DSS_IROPS_DESK_T Update
				stmt = conn.createStatement();
				sql = IroA330Query.getInstance().updDssIropsDeskT(params);
				stmt.executeUpdate(sql); // Update
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			}
			
			//MSG_NO, LVL_NO ϱ
			
			//1. MSG_NO, LVL_NO ȸ
			stmt = conn.createStatement();
			sql = IroA330Query.getInstance().selMsgNoLvlNo(params);
			rs = stmt.executeQuery(sql);
			
			String getMsgNo = "";
			String getLvlNo = "";
			
			if (rs.next()) {
				getMsgNo = StringUtil.checkString(rs.getString("MSG_NO"));
				getLvlNo = StringUtil.checkString(rs.getString("LVL_NO"));
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			//2. MSG_NO, LVL_NO ϱ.
			stmt = conn.createStatement();
			sql = IroA330Query.getInstance().selMsgNo(params, getMsgNo, getLvlNo);
			rs = stmt.executeQuery(sql);
			
			String tmpMsgNo = "";
			
			if (rs.next()) tmpMsgNo = StringUtil.checkString(rs.getString("TMP_MSG_NO"));
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			String msgNo = "";
			String lvlNo = String.valueOf(Integer.parseInt(getLvlNo) + 1).toString();
			
			if ("0".equals(getLvlNo)) msgNo = tmpMsgNo.substring(0,2);//@2013-07-02 codeReview :if (getLvlNo.equals("0")) msgNo = tmpMsgNo.substring(0,2);
			else msgNo = getMsgNo + tmpMsgNo.substring(0,2);
			
			//DSS_MSG_HEAD_T Update
			stmt = conn.createStatement();
			sql = IroA330Query.getInstance().updDssMsgHeadT(params);
			int updHead = stmt.executeUpdate(sql);
			
			if (updHead != 1) throw new BusinessException("Decision Making Exception!!");
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			//Reject  , DSS_MSG_DETAIL_T DSS_LVL_X = 'I' -> DSS_LVL_X = 'S' 
			if (params.getArMode().equals("A")) {
				
				//DSS_MSG_DETAIL_T Update
				stmt = conn.createStatement();
				sql = IroA330Query.getInstance().updDssMsgDetailT(params);
				int updDetail = stmt.executeUpdate(sql);
				
				if (updDetail < 1) throw new BusinessException("Decision Making Exception!!"); // Update
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			}
			
			//DSS_MSG_DETAIL_T Insert
			stmt = conn.createStatement();
			sql = IroA330Query.getInstance().insDssMsgDetailT(params, msgNo, lvlNo);
			int insDetail = stmt.executeUpdate(sql);
			
			if (insDetail != 1) throw new BusinessException("Decision Making Exception!!");
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			//Data Commit
			conn.commit();
			
			hashData.put("MSG_NO", msgNo);
			hashData.put("LVL_NO", lvlNo);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroA330AppRej:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroA330AppRej:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroA330AppRej:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try {cr.release();} catch(Exception e) {}
			if (conn != null) try {conn.close();} catch(Exception e) {}
			if (rs != null) try {rs.close();} catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  * Message Board Irops SKD ȸ Լ. 
	  * @param IroA340BG params ȸ
	  * @return Hashtable hashData
	  * @exception Exception
	  * @author Copyright (c) 2009/08/17 
	  */
	public Hashtable selIroA340Main(IroA340BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			/*@2013-10-xx
			String portList = "";
			String emailPortList = "";//@2013-06-19 ߰  
			Ʒ	HashMap ٲ	*/
			HashMap<String,Object>	sitaPortMap	=	null;
			HashMap<String,Object>	emailPortMap	=	null;
			
			//IROPS SKD  ȸ
			stmt = conn.createStatement();
			sql = IroA340Query.getInstance().selIropsSKD(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA340BG entity = new IroA340BG();
				
				entity.setDecisionE(StringUtil.checkString(rs.getString("DECISION_E")));
				entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
				entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
				entity.setRouteX(StringUtil.checkString(rs.getString("ROUTE_X")));
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
				entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
				entity.setDdMon(StringUtil.checkString(rs.getString("DDMON")));
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
				
				String tmpStnfr = StringUtil.checkString(rs.getString("STNFR"));
				String tmpStnto = StringUtil.checkString(rs.getString("STNTO"));
				
				//⵵׵鿡 ߺ  ߰Ѵ.
				/*if (portList.indexOf(tmpStnfr) == -1) {
					if (portList.equals("")) portList = "'" + tmpStnfr + "'";
					else portList = portList + ", '" + tmpStnfr + "'";
				}
				if (portList.indexOf(tmpStnto) == -1) {
					portList = portList + ", '" + tmpStnto + "'";
				}*/
				//portList => 'CGO_ANC_ICN','PAX_CJJ_CJU',...  ٲ
				
				/*@2013-10-xx
				String paxCgo = "";
				if (StringUtil.checkString(rs.getString("ROUTE_X")).equals("CGO")) paxCgo = "CGO";
				else paxCgo = "PAX";
				if ("".equals(portList)) portList = "'" + paxCgo + "_" + tmpStnfr + "_" + tmpStnto + "'";//@2013-07-02 codeReview :if (portList.equals("")) portList = "'" + paxCgo + "_" + tmpStnfr + "_" + tmpStnto + "'";
				else portList = portList + ", '" + paxCgo + "_" + tmpStnfr + "_" + tmpStnto + "'";
	
//				@2013-06-19 ߰  
				if (emailPortList.length()!=0) {
					emailPortList	+=",";
				}
				emailPortList += "'" + paxCgo + "_" + StringUtil.checkString(rs.getString("STNFR")) + "'";
				emailPortList += ",'" + paxCgo + "_" +  StringUtil.checkString(rs.getString("STNTO")) + "'";
				Ʒ ٲ*/
				//sitaPortMap	=	portMap_put(emailPortMap,("CGO".equals(entity.getRouteX())?"CGO":"PAX")+"_"+entity.getStnfr()+"_"+entity.getStnto());	
				//@2017-09-15
				sitaPortMap	=	portMap_put(sitaPortMap,("CGO".equals(entity.getRouteX())?"CGO":"PAX")+"_"+entity.getStnfr()+"_"+entity.getStnto());	
				
				String	routeX	=	StringUtil.checkString(rs.getString("ROUTE_X"));
				emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+entity.getStnfr());
				emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+entity.getStnto());
				emailPortMap	=	portMap_put(emailPortMap,routeX+"_ALL_"+entity.getCommentX());
				
				listData.add(entity);
			}
			if(emailPortMap!=null && emailPortMap.size()!=0){//@2013-11-14
				emailPortMap	=	portMap_put(emailPortMap,"ALL_ALL_ALL");				
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("MSG_BOARD",listData);
			
			String sitaAddr = "";
			
			//SITA ADDRESS ȸ
			stmt = conn.createStatement();
			//sql = IroA340Query.getInstance().selSitaAddr(portList);
			sql = IroA340Query.getInstance().selSitaAddr(portMap_toString(sitaPortMap));//@2013-10-xx
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				StringTokenizer st = new StringTokenizer(StringUtil.checkString(rs.getString("ADDR_E")), " ");
				while (st.hasMoreTokens()) {
					String tmp = st.nextToken();
					
					//ADDRESS ߺ ʰ ߰Ѵ.
					if (sitaAddr.indexOf(tmp) == -1) {
						if ("".equals(sitaAddr)) sitaAddr = tmp;//@2013-07-02 codeReview :if (sitaAddr.equals("")) sitaAddr = tmp;
						else sitaAddr = sitaAddr + " " + tmp;
					}
				}
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("SITA_ADDR",sitaAddr);
			/*@2013-10-xx
			//--------------------------@2013-07-19 ߰ 
			if(-1<emailPortList.indexOf("PAX")){
				emailPortList +=	emailPortList.length()!=0? ",'PAX_ALL'":"'PAX_ALL'";
			}
			if(-1<emailPortList.indexOf("CGO")){
				emailPortList +=	emailPortList.length()!=0? ",'CGO_ALL'":"'CGO_ALL'";
			}
			emailPortList +=	emailPortList.length()!=0? ",'ALL_ALL'":"'ALL_ALL'";
			*/
			//--------------------------@2013-06-10 ߰
			String emailAddr = "";			
			
			//Email ADDRESS ȸ
			stmt = conn.createStatement();
			//sql = IroA340Query.getInstance().selEmailAddr(emailPortList);
			sql = IroA340Query.getInstance().selEmailAddr(portMap_toString(emailPortMap));//@2013-10-xx
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {				
				StringTokenizer st = new StringTokenizer(StringUtil.checkString(rs.getString("ADDR_E")), " ");
				while (st.hasMoreTokens()) {
					String tmp = st.nextToken();
					
					//ADDRESS ߺ ʰ ߰Ѵ.
					if (emailAddr.indexOf(tmp) == -1) {
						if ("".equals(emailAddr)) emailAddr = tmp;//@2013-07-02 codeReview :if (emailAddr.equals("")) emailAddr = tmp;
						else emailAddr = emailAddr + " " + tmp;
					}
				}
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("EMAIL_ADDR",emailAddr);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA340Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA340Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  * SITA Address Book ȸ Լ. 
	  * @param IroA340BG params ȸ
	  * @return Hashtable hashData
	  * @exception Exception
	  * @author Copyright (c) 2009/08/18 
	  */
	public Hashtable selIroA340AddrBook(IroA340BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//SITA ADDRESS ȸ
			stmt = conn.createStatement();
			sql = IroA340Query.getInstance().selSitaAddr("");
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroA340BG entity = new IroA340BG();
				
				entity.setGroupC(StringUtil.checkString(rs.getString("GROUP_C")));
				entity.setAddrE(StringUtil.checkString(rs.getString("ADDR_E")));
				
				listData.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("ADDR_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA340AddrBook:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA340AddrBook:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  Message Board - Message Send Լ. 
	  * @param params IroA340BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/19 
	  */
	public Hashtable insIroA340MsgSend(IroA340BG params) throws BusinessException {
		String debugTitle	=	"[BASE:IroAllSLBean.insIroA340MsgSend] ";
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - -ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
		String sql = null;
		Hashtable hashData = new Hashtable();//Return ü
	    try{
			//- - - - - - - - - - - - - - - - - - - - - - - - - - - -DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			conn.setAutoCommit(false);//Auto Commit Mode False
			//- - - - - - - - - - - - - - - - - - - - - - - - - - - -NEW MSG_SEQ_NUM ȸ
			stmt = conn.createStatement();
			sql = IroA340Query.getInstance().selNewNum(params);
			rs = stmt.executeQuery(sql);

			String newNum = "";
			if (rs!=null && rs.next()) newNum = StringUtil.checkString(rs.getString("NEW_NUM"));
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			//- - - - - - - - - - - - - - - - - - - - - - - - - - - -2010.08.19 
			//Amend Notice ۽ MSG_DT  ʰ DSS_IROPS_T update ǳʶڴ.
			int intNewNum = 0;
			if (!"".equals(newNum)) intNewNum = Integer.parseInt(newNum);
			
			if (intNewNum == 1) {//ó ϴ  DSS_IROPS_T Update
				stmt = conn.createStatement();
				sql = IroA340Query.getInstance().updDssIropsT(params);
				int updIrops = stmt.executeUpdate(sql);

				if (updIrops != 1) throw new BusinessException("Message Send Exception!!");
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			}else if (intNewNum >= 2) { //MSG_SEQ_NUM 2 ̸̻ ϴ 
				//2010.09.07 ߰ : ۽   ð message  ٿش.

				// ð ȸ
				stmt = conn.createStatement();
				sql = ComQ01Query.getInstance().selDbTime("DDHH24MIMON","540/1440");
				rs = stmt.executeQuery(sql);
				String currTime = "";
				if (rs!=null && rs.next()) currTime = StringUtil.checkString(rs.getString("DB_TIME"));
				if (rs != null) rs.close();
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				
				// ٿ ð ִٸ ߶󳻰  ð ٿش. 
				// ٿ '- 070230SEP' ãƺ   ٿ ð ִ ̴. 
				String tmpStr = "";
				if (params.getMessage().length() >= 11) tmpStr = params.getMessage().substring(params.getMessage().length()-11, params.getMessage().length()-9);
				
				StringBuffer msgBf = new StringBuffer();
				if ("- ".equals(tmpStr)) {
					msgBf.append(params.getMessage().substring(0, params.getMessage().length()-11));
					msgBf.append("- " + currTime);
				}else {
					msgBf.append(params.getMessage());
					msgBf.append(StringUtil.unescape("/uD/uA")); //<cr><lf>
					msgBf.append("- " + currTime);
				}
				params.setMessage(msgBf.toString());
			}
			//- - - - - - - - - - - - - - - - - - - - - - - - - - - -DSS_IROPS_MSG_T Insert
			stmt = conn.createStatement();
			sql = IroA340Query.getInstance().insDssIropsMsgT(params, newNum);
			int insIropsMsg = stmt.executeUpdate(sql);

			if (insIropsMsg != 1) throw new BusinessException("Message Send Exception!!");

			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			//- - - - - - - - - - - - - - - - - - - - - - - - - - - -20150428 MHS
			String messageForMail = params.getMessage();
			String mhsMessage = params.getMessage();
			mhsMessage = mhsMessage.startsWith("Y.QD ") ? mhsMessage.replace("Y.QD ", "QU ") : mhsMessage;
			//- - - - - - - - - - - - - - - - - - - - - - - - - - - -PROJECT_NO 
			String projectNo = params.getDssStartDt() + "_" + params.getSeqNum() + "_" + newNum;//PROJECT_NO 
			
			StringBuffer tempBf = new StringBuffer();
			boolean isOriginLine = false;
			boolean notYetStx = true;
			for(int i=0; i<mhsMessage.length(); i++) {
				tempBf.append(mhsMessage.charAt(i)+"");
				if(".".equals(mhsMessage.charAt(i) + "")) {
					isOriginLine = true;
				}
				if(notYetStx && isOriginLine && StringUtil.unescape("/uA").equals(mhsMessage.charAt(i) + "")) {//uA :ٹٲ
					tempBf.append(StringUtil.unescape("/u2"));//  
					notYetStx = false;
				}
			}
			mhsMessage = tempBf.toString();
			
			//@2017-08-04 ٸ     
			//׷ ̷ ϸ    ־ ϴ°  
			//mhsMessage	=	mhsMessage.replaceAll("\\s+([\\n\\r])","$1");
			//mhsMessage	=	mhsMessage.replaceAll("( \\r\\n)","\r\n");//@2017-08-17ȣ ϸ ù° ɲ?
			mhsMessage	=	mhsMessage.replaceAll(" \\r\\n","\r\n");//ȣ û

			mhsMessage = StringUtil.unescape("/uD/uA") + StringUtil.unescape("/u1") + mhsMessage + StringUtil.unescape("/uD/uA") + StringUtil.unescape("/u3");
			//- - - - - - - - - - - - - - - - - - - - - - - - - - - -MS_TELEX_MSG_T Insert
			stmt = conn.createStatement();
			sql = IroA340Query.getInstance().insMsTelexMsgT(params, projectNo, mhsMessage);
			int insMsg = stmt.executeUpdate(sql);

			if (insMsg != 1) throw new BusinessException("Message Send Exception!!");
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			//- - - - - - - - - - - - - - - - - - - - - - - - - - - -Data Commit
			conn.commit();

			hashData.put("MSG_SEQ_NUM", newNum);
			hashData.put("PROJECT_NO", projectNo);
			//- - - - - - - - - - - - - - - - - - - - - - - - - - - -E-MAIL  2013-06-14
			String email_txt	=	StringUtil.checkString(params.getEmail_txt());
			if (!"".equals(email_txt)){
				String[] emailReceAddr = email_txt.split(" ");
				if(0< email_txt.length() && emailReceAddr!=null && 0<emailReceAddr.length){//@2013-07-02 ޼ ŸƲ ϰų  ̰ų
					String	message		=	StringUtil.checkString(messageForMail);
					String	title				=	StringUtil.checkString(params.getTitleE());
					java.util.regex.Pattern 	p	= java.util.regex.Pattern.compile("\\nZZZ\\s*[\\r\\n]([^\\r]*)",java.util.regex.Pattern.CASE_INSENSITIVE);
					java.util.regex.Matcher m	= p.matcher(message);					
					while (m.find()) {
						title	=	m.group(1);
					}					
					String contentURL = "http://ekfos.koreanair.com/BASERoot/jsp/iro/IroA340UIEMS.jsp?"
						+ "dssStartDt=" + params.getDssStartDt() 
						+ "&seqNum=" + params.getSeqNum() 
						+ "&msgSeqNum=" + newNum 
						+ "&flg=1";
					for(int idx = 0; idx < emailReceAddr.length; idx++) {
						boolean sendFlg = EMS.sendEmail("SKDCNTL@KOREANAIR.COM", "SKDCNTL@KOREANAIR.COM", emailReceAddr[idx], emailReceAddr[idx], title, contentURL);
						if (!sendFlg) throw new BusinessException("Sending E-mail Failed, Please Contact To Admin");
					}
				}else{
					System.out.println(debugTitle+"Not email send");
				}
			}
		} catch(SQLException se) {
			Logger.debug.println(debugTitle+"Exception : "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println(debugTitle+"BusinessException : "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println(debugTitle+"Exception : "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			if (cr != null) try {cr.release();} catch(Exception e) {}
			if (conn != null) try {conn.close();} catch(Exception e) {}
			if (rs != null) try {rs.close();} catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  Message Board - Message Send Լ. 
	  * @param params IroA340BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/19 
	  */
	public String updIroA340Processed(IroA340BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//PROCESSED ȸ
			stmt = conn.createStatement();
			sql = IroA340Query.getInstance().selProcessed(params);
			rs = stmt.executeQuery(sql);
			
			String processed = "";
			String errorReply = "";
			if (rs.next()) {
				processed = StringUtil.checkString(rs.getString("PROCESSED"));
				errorReply = StringUtil.checkString(rs.getString("ERROR_REPLY"));
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if ("Y".equals(processed) && "A".equals(errorReply)) {//@2013-07-02 codeReview :if (processed.equals("Y") && errorReply.equals("A")) {
			
				//PROCESSED Update
				stmt = conn.createStatement();
				sql = IroA340Query.getInstance().updProcessed(params);
				int updMsg = stmt.executeUpdate(sql);
				
				if (updMsg != 1) throw new BusinessException("Processed Exception!!");
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			}
			
			//Data Commit
			conn.commit();
			
			returnValue = "Y";
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroA340Processed:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroA340Processed:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroA340Processed:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try {cr.release();} catch(Exception e) {}
			if (conn != null) try {conn.close();} catch(Exception e) {}
			if (rs != null) try {rs.close();} catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  * 20151021
	  * UMS  ߰
	  */
	public String selDssIropsMsgStr(IroA340BG params) throws BusinessException {

		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    String messageStr = "";
	   
	    try {
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			stmt = conn.createStatement();
			sql = IroA340Query.getInstance().selDssIropsMsgStr(params);
			rs = stmt.executeQuery(sql);
			
			if(rs.next()) {

				messageStr = StringUtil.checkString(rs.getString("MESSAGE"));
			}
			
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA340Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroA340Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		
		return messageStr;
	}
	
	
	/**
	  *  IROPS Process ȸԼ. 
	  * @param params IroQ350BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/19 
	  */
	public Hashtable selIroQ350Main(IroQ350BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			String stn = "";
			String flt = "";
			String acreg = "";
			
			//STN ִ 2
			if (!params.getStn().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getStn()), ",");
				int chk = 0;
				while(st.hasMoreTokens()) {
					String token = StringUtil.checkString(st.nextToken());
					if (chk != 0) stn = stn + ",";
					stn = stn + "'" + token + "'";
					chk++;
				}
			}
			//FLT ִ 5
			if (!params.getFlt().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getFlt()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Byteų 4Byte 4° A-Z̸ տ 0 δ.
					if (token.length() == 3 || (token.length() == 4 && StringUtil.isAlphabet(token.substring(3,4)))) {
						token = "0" + token;
					}
					if (chk != 0) flt = flt + ",";
					flt = flt + "'" + token + "'";
					chk++;
				}
			}
			//ACREG ִ 5
			if (!params.getAcreg().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getAcreg()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Bytḛ ڷθ Ǿ տ 7 δ.
					if (token.length() == 3 && !StringUtil.isAlphabet(token)) {
						token = "7" + token;
					}
					if (token.length() <= 4) {
						token = "HL" + token;
					}
					if (chk != 0) acreg = acreg + ",";
					acreg = acreg + "'" + token + "'";
					chk++;
				}
			}
			
			String prevDssStartDt = "";
			String prevSeqNum = "";
			String prevTitleE = "";
			
			String fltNumList = "";
			
			//ACREG  ִ 
			if (!"".equals(acreg)) {//@2013-07-02 codeReview :if (!acreg.equals("")) {
				
				boolean selFlg = false;
				
				//ȸǿ ACREG ִ  1 - DAILY_SCH_T ȸ
				stmt = conn.createStatement();
				sql = IroQ350Query.getInstance().selMain1(stn, flt, acreg);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					selFlg = true;
					
					String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
					String seqNum = StringUtil.checkString(rs.getString("SEQ_NUM"));
					String titleE = StringUtil.checkString(rs.getString("TITLE_E"));
					String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
					
					if (prevDssStartDt.equals(dssStartDt) && prevSeqNum.equals(seqNum)) {
						
						fltNumList = fltNumList + ", " + fltNum; // IROPS FLT_NUM ش.
 					
					} else {
 						
 						if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//@2013-07-02 codeReview :if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
 							
 							IroQ350BG entity = new IroQ350BG();
 							
 							entity.setDssStartDt(prevDssStartDt);
 							entity.setSeqNum(prevSeqNum);
 							entity.setTitleE(prevTitleE);
 							entity.setFltNum(fltNumList);
 							
 							listData.add(entity);
 						}
 						
 						prevDssStartDt = dssStartDt;
 						prevSeqNum = seqNum;
 						prevTitleE = titleE;
 						fltNumList = fltNum;
 					}
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				// Row ߰
				if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//@2013-07-02 codeReview :if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
					
					IroQ350BG entity = new IroQ350BG();
					
					entity.setDssStartDt(prevDssStartDt);
					entity.setSeqNum(prevSeqNum);
					entity.setTitleE(prevTitleE);
					entity.setFltNum(fltNumList);		
					
					listData.add(entity);
				}
				
				// ȸ   Ʒ  ȸ
				if (!selFlg) {
					
					//ȸǿ ACREG ִ  2 - DSS_NEW_SCH_T ȸ
					stmt = conn.createStatement();
					sql = IroQ350Query.getInstance().selMain2(stn, flt, acreg);
					rs = stmt.executeQuery(sql);
					
					while (rs.next()) {
						
						String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
						String seqNum = StringUtil.checkString(rs.getString("SEQ_NUM"));
						String titleE = StringUtil.checkString(rs.getString("TITLE_E"));
						String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
						
						if (prevDssStartDt.equals(dssStartDt) && prevSeqNum.equals(seqNum)) {
							
							fltNumList = fltNumList + ", " + fltNum; // IROPS FLT_NUM ش.
	 					
						} else {
	 						
	 						if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//@2013-07-02 codeReview :if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
	 							
	 							IroQ350BG entity = new IroQ350BG();
	 							
	 							entity.setDssStartDt(prevDssStartDt);
	 							entity.setSeqNum(prevSeqNum);
	 							entity.setTitleE(prevTitleE);
	 							entity.setFltNum(fltNumList);
	 							
	 							listData.add(entity);
	 						}
	 						
	 						prevDssStartDt = dssStartDt;
	 						prevSeqNum = seqNum;
	 						prevTitleE = titleE;
	 						fltNumList = fltNum;
	 					}
					}
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					if (rs != null) rs.close();
					
					// Row ߰
					if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
						
						IroQ350BG entity = new IroQ350BG();
						
						entity.setDssStartDt(prevDssStartDt);
						entity.setSeqNum(prevSeqNum);
						entity.setTitleE(prevTitleE);
						entity.setFltNum(fltNumList);		
						
						listData.add(entity);
					}
				}
				
			//ACREG   
			} else {
				
				//ȸ
				stmt = conn.createStatement();
				sql = IroQ350Query.getInstance().selMain3(stn, flt);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
					String seqNum = StringUtil.checkString(rs.getString("SEQ_NUM"));
					String titleE = StringUtil.checkString(rs.getString("TITLE_E"));
					String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
					
					if (prevDssStartDt.equals(dssStartDt) && prevSeqNum.equals(seqNum)) {
						
						fltNumList = fltNumList + ", " + fltNum; // IROPS FLT_NUM ش.
 					
					} else {
 						
 						if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//@2013-07-02 codeReview :	if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
 							
 							IroQ350BG entity = new IroQ350BG();
 							
 							entity.setDssStartDt(prevDssStartDt);
 							entity.setSeqNum(prevSeqNum);
 							entity.setTitleE(prevTitleE);
 							entity.setFltNum(fltNumList);
 							
 							listData.add(entity);
 						}
 						
 						prevDssStartDt = dssStartDt;
 						prevSeqNum = seqNum;
 						prevTitleE = titleE;
 						fltNumList = fltNum;
 					}
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				// Row ߰
				if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//@2013-07-02 codeReview :	if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
					
					IroQ350BG entity = new IroQ350BG();
					
					entity.setDssStartDt(prevDssStartDt);
					entity.setSeqNum(prevSeqNum);
					entity.setTitleE(prevTitleE);
					entity.setFltNum(fltNumList);		
					
					listData.add(entity);
				}
			}

			hashData.put("PROCESS_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ350Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ350Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  IROPS Process - PROCESS_X ȸԼ. 
	  * @param params IroQ350BG ȸ
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2009/08/19 
	  */
	public String selIroQ350ProcessX(IroQ350BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//PROCESS_X ȸ
			stmt = conn.createStatement();
			sql = IroQ350Query.getInstance().selProcessX(params);
			rs = stmt.executeQuery(sql);
			
			String processX = "";
			
			if (rs.next()) {
				
				processX = StringUtil.checkString(rs.getString("PROCESS_X"));
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if ("I".equals(processX)) returnValue = "Y";//@2013-07-02 codeReview :	if (processX.equals("I")) returnValue = "Y";
			else returnValue = "N"; //<- ̹ ϷǾ.
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ350ProcessX:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ350ProcessX:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  *  IROPS Final Decision ȸԼ. 
	  * @param params IroQ360BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/21 
	  */
	public Hashtable selIroQ360Main(IroQ360BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			String stn = "";
			String flt = "";
			String acreg = "";
			
			//STN ִ 2
			if (!params.getStn().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getStn()), ",");
				int chk = 0;
				while(st.hasMoreTokens()) {
					String token = StringUtil.checkString(st.nextToken());
					if (chk != 0) stn = stn + ",";
					stn = stn + "'" + token + "'";
					chk++;
				}
			}
			//FLT ִ 5
			if (!params.getFlt().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getFlt()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Byteų 4Byte 4° A-Z̸ տ 0 δ.
					if (token.length() == 3 || (token.length() == 4 && StringUtil.isAlphabet(token.substring(3,4)))) {
						token = "0" + token;
					}
					if (chk != 0) flt = flt + ",";
					flt = flt + "'" + token + "'";
					chk++;
				}
			}
			//ACREG ִ 5
			if (!params.getAcreg().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getAcreg()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Bytḛ ڷθ Ǿ տ 7 δ.
					if (token.length() == 3 && !StringUtil.isAlphabet(token)) {
						token = "7" + token;
					}
					if (token.length() <= 4) {
						token = "HL" + token;
					}
					if (chk != 0) acreg = acreg + ",";
					acreg = acreg + "'" + token + "'";
					chk++;
				}
			}
			
			String prevDssStartDt = "";
			String prevSeqNum = "";
			String prevTitleE = "";
			
			String fltNumList = "";
			
			//ACREG  ִ 
			if (!"".equals(acreg)) {//@2013-07-02 codeReview :	if (!acreg.equals("")) {
				
				boolean selFlg = false;
				
				//ȸǿ ACREG ִ  1 - DAILY_SCH_T ȸ
				stmt = conn.createStatement();
				sql = IroQ360Query.getInstance().selMain1(stn, flt, acreg);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					selFlg = true;
					
					String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
					String seqNum = StringUtil.checkString(rs.getString("SEQ_NUM"));
					String titleE = StringUtil.checkString(rs.getString("TITLE_E"));
					String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
					
					if (prevDssStartDt.equals(dssStartDt) && prevSeqNum.equals(seqNum)) {
						
						fltNumList = fltNumList + ", " + fltNum; // IROPS FLT_NUM ش.
					
					} else {
						
						if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//@2013-07-02 codeReview :		if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
							
							IroQ360BG entity = new IroQ360BG();
							
							entity.setDssStartDt(prevDssStartDt);
							entity.setSeqNum(prevSeqNum);
							entity.setTitleE(prevTitleE);
							entity.setFltNum(fltNumList);
							
							listData.add(entity);
						}
						
						prevDssStartDt = dssStartDt;
						prevSeqNum = seqNum;
						prevTitleE = titleE;
						fltNumList = fltNum;
					}
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				// Row ߰
				if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//@2013-07-02 codeReview :		if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
					
					IroQ360BG entity = new IroQ360BG();
					
					entity.setDssStartDt(prevDssStartDt);
					entity.setSeqNum(prevSeqNum);
					entity.setTitleE(prevTitleE);
					entity.setFltNum(fltNumList);		
					
					listData.add(entity);
				}
				
				// ȸ   Ʒ  ȸ
				if (!selFlg) {
					
					//ȸǿ ACREG ִ  2 - DSS_NEW_SCH_T ȸ
					stmt = conn.createStatement();
					sql = IroQ360Query.getInstance().selMain2(stn, flt, acreg);
					rs = stmt.executeQuery(sql);
					
					while (rs.next()) {
						
						String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
						String seqNum = StringUtil.checkString(rs.getString("SEQ_NUM"));
						String titleE = StringUtil.checkString(rs.getString("TITLE_E"));
						String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
						
						if (prevDssStartDt.equals(dssStartDt) && prevSeqNum.equals(seqNum)) {
							
							fltNumList = fltNumList + ", " + fltNum; // IROPS FLT_NUM ش.
	 					
						} else {
	 						
	 						if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//@2013-07-02 codeReview :	if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
	 							
	 							IroQ360BG entity = new IroQ360BG();
	 							
	 							entity.setDssStartDt(prevDssStartDt);
	 							entity.setSeqNum(prevSeqNum);
	 							entity.setTitleE(prevTitleE);
	 							entity.setFltNum(fltNumList);
	 							
	 							listData.add(entity);
	 						}
	 						
	 						prevDssStartDt = dssStartDt;
	 						prevSeqNum = seqNum;
	 						prevTitleE = titleE;
	 						fltNumList = fltNum;
	 					}
					}
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					if (rs != null) rs.close();
					
					// Row ߰
					if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//@2013-07-02 codeReview :	if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
						
						IroQ360BG entity = new IroQ360BG();
						
						entity.setDssStartDt(prevDssStartDt);
						entity.setSeqNum(prevSeqNum);
						entity.setTitleE(prevTitleE);
						entity.setFltNum(fltNumList);		
						
						listData.add(entity);
					}
				}
				
			//ACREG   
			} else {
				
				//ȸ
				stmt = conn.createStatement();
				sql = IroQ360Query.getInstance().selMain3(stn, flt);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
					String seqNum = StringUtil.checkString(rs.getString("SEQ_NUM"));
					String titleE = StringUtil.checkString(rs.getString("TITLE_E"));
					String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
					
					if (prevDssStartDt.equals(dssStartDt) && prevSeqNum.equals(seqNum)) {
						
						fltNumList = fltNumList + ", " + fltNum; // IROPS FLT_NUM ش.
					
					} else {
						
						if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//@2013-07-02 codeReview :	if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
							
							IroQ360BG entity = new IroQ360BG();
							
							entity.setDssStartDt(prevDssStartDt);
							entity.setSeqNum(prevSeqNum);
							entity.setTitleE(prevTitleE);
							entity.setFltNum(fltNumList);
							
							listData.add(entity);
						}
						
						prevDssStartDt = dssStartDt;
						prevSeqNum = seqNum;
						prevTitleE = titleE;
						fltNumList = fltNum;
					}
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				// Row ߰
				if (!"".equals(prevDssStartDt) && !"".equals(prevSeqNum)) {//@2013-07-02 codeReview :	if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
					
					IroQ360BG entity = new IroQ360BG();
					
					entity.setDssStartDt(prevDssStartDt);
					entity.setSeqNum(prevSeqNum);
					entity.setTitleE(prevTitleE);
					entity.setFltNum(fltNumList);		
					
					listData.add(entity);
				}
			}

			hashData.put("DECISION_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ360Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ360Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  IROPS Final Decision - PROCESS_X ȸԼ. 
	  * @param params IroQ360BG ȸ
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2009/08/21 
	  */
	public String selIroQ360ProcessX(IroQ360BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//PROCESS_X ȸ
			stmt = conn.createStatement();
			sql = IroQ360Query.getInstance().selProcessX(params);
			rs = stmt.executeQuery(sql);
			
			String processX = "";
			
			if (rs.next()) {
				
				processX = StringUtil.checkString(rs.getString("PROCESS_X"));
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if ("C".equals(processX)) returnValue = "Y";//@2013-07-02 codeReview :	if (processX.equals("C")) returnValue = "Y";
			else returnValue = "N"; //<- ̹ ϷǾ.
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ360ProcessX:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ360ProcessX:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  *  IROPS Message ȸԼ. 
	  * @param params IroQ370BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/21 
	  */
	public Hashtable selIroQ370Main(IroQ370BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			String stn = "";
			String flt = "";
			String acreg = "";
			
			//STN ִ 2
			if (!params.getStn().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getStn()), ",");
				int chk = 0;
				while(st.hasMoreTokens()) {
					String token = StringUtil.checkString(st.nextToken());
					if (chk != 0) stn = stn + ",";
					stn = stn + "'" + token + "'";
					chk++;
				}
			}
			//FLT ִ 5
			if (!params.getFlt().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getFlt()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Byteų 4Byte 4° A-Z̸ տ 0 δ.
					if (token.length() == 3 || (token.length() == 4 && StringUtil.isAlphabet(token.substring(3,4)))) {
						token = "0" + token;
					}
					if (chk != 0) flt = flt + ",";
					flt = flt + "'" + token + "'";
					chk++;
				}
			}
			//ACREG ִ 5
			if (!params.getAcreg().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getAcreg()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Bytḛ ڷθ Ǿ տ 7 δ.
					if (token.length() == 3 && !StringUtil.isAlphabet(token)) {
						token = "7" + token;
					}
					if (token.length() <= 4) {
						token = "HL" + token;
					}
					if (chk != 0) acreg = acreg + ",";
					acreg = acreg + "'" + token + "'";
					chk++;
				}
			}
			
			String prevDssStartDt = "";
			String prevSeqNum = "";
			String prevTitleE = "";
			
			String fltNumList = "";
			
			//ACREG  ִ 
			if (!"".equals(acreg)) {//@2013-07-02 codeReview :	if (!acreg.equals("")) {
				
				boolean selFlg = false;
				
				//ȸǿ ACREG ִ  1 - DAILY_SCH_T ȸ
				stmt = conn.createStatement();
				sql = IroQ370Query.getInstance().selMain1(stn, flt, acreg);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					selFlg = true;
					
					String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
					String seqNum = StringUtil.checkString(rs.getString("SEQ_NUM"));
					String titleE = StringUtil.checkString(rs.getString("TITLE_E"));
					String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
					
					if (prevDssStartDt.equals(dssStartDt) && prevSeqNum.equals(seqNum)) {
						
						fltNumList = fltNumList + ", " + fltNum; // IROPS FLT_NUM ش.
					
					} else {
						
						if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
							
							IroQ370BG entity = new IroQ370BG();
							
							entity.setDssStartDt(prevDssStartDt);
							entity.setSeqNum(prevSeqNum);
							entity.setTitleE(prevTitleE);
							entity.setFltNum(fltNumList);
							
							listData.add(entity);
						}
						
						prevDssStartDt = dssStartDt;
						prevSeqNum = seqNum;
						prevTitleE = titleE;
						fltNumList = fltNum;
					}
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				// Row ߰
				if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
					
					IroQ370BG entity = new IroQ370BG();
					
					entity.setDssStartDt(prevDssStartDt);
					entity.setSeqNum(prevSeqNum);
					entity.setTitleE(prevTitleE);
					entity.setFltNum(fltNumList);		
					
					listData.add(entity);
				}
				
				// ȸ   Ʒ  ȸ
				if (!selFlg) {
					
					//ȸǿ ACREG ִ  2 - DSS_NEW_SCH_T ȸ
					stmt = conn.createStatement();
					sql = IroQ370Query.getInstance().selMain2(stn, flt, acreg);
					rs = stmt.executeQuery(sql);
					
					while (rs.next()) {
						
						String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
						String seqNum = StringUtil.checkString(rs.getString("SEQ_NUM"));
						String titleE = StringUtil.checkString(rs.getString("TITLE_E"));
						String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
						
						if (prevDssStartDt.equals(dssStartDt) && prevSeqNum.equals(seqNum)) {
							
							fltNumList = fltNumList + ", " + fltNum; // IROPS FLT_NUM ش.
	 					
						} else {
	 						
	 						if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
	 							
	 							IroQ370BG entity = new IroQ370BG();
	 							
	 							entity.setDssStartDt(prevDssStartDt);
	 							entity.setSeqNum(prevSeqNum);
	 							entity.setTitleE(prevTitleE);
	 							entity.setFltNum(fltNumList);
	 							
	 							listData.add(entity);
	 						}
	 						
	 						prevDssStartDt = dssStartDt;
	 						prevSeqNum = seqNum;
	 						prevTitleE = titleE;
	 						fltNumList = fltNum;
	 					}
					}
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					if (rs != null) rs.close();
					
					// Row ߰
					if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
						
						IroQ370BG entity = new IroQ370BG();
						
						entity.setDssStartDt(prevDssStartDt);
						entity.setSeqNum(prevSeqNum);
						entity.setTitleE(prevTitleE);
						entity.setFltNum(fltNumList);		
						
						listData.add(entity);
					}
				}
				
			//ACREG   
			} else {
				
				//ȸ
				stmt = conn.createStatement();
				sql = IroQ370Query.getInstance().selMain3(stn, flt);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
					String seqNum = StringUtil.checkString(rs.getString("SEQ_NUM"));
					String titleE = StringUtil.checkString(rs.getString("TITLE_E"));
					String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
					
					if (prevDssStartDt.equals(dssStartDt) && prevSeqNum.equals(seqNum)) {
						
						fltNumList = fltNumList + ", " + fltNum; // IROPS FLT_NUM ش.
					
					} else {
						
						if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
							
							IroQ370BG entity = new IroQ370BG();
							
							entity.setDssStartDt(prevDssStartDt);
							entity.setSeqNum(prevSeqNum);
							entity.setTitleE(prevTitleE);
							entity.setFltNum(fltNumList);
							
							listData.add(entity);
						}
						
						prevDssStartDt = dssStartDt;
						prevSeqNum = seqNum;
						prevTitleE = titleE;
						fltNumList = fltNum;
					}
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				// Row ߰
				if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
					
					IroQ370BG entity = new IroQ370BG();
					
					entity.setDssStartDt(prevDssStartDt);
					entity.setSeqNum(prevSeqNum);
					entity.setTitleE(prevTitleE);
					entity.setFltNum(fltNumList);		
					
					listData.add(entity);
				}
			}

			hashData.put("MESSAGE_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ370Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ370Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  IROPS Message - PROCESS_X ȸԼ. 
	  * @param params IroQ370BG ȸ
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2009/08/21 
	  */
	public String selIroQ370ProcessX(IroQ370BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//PROCESS_X ȸ
			stmt = conn.createStatement();
			sql = IroQ370Query.getInstance().selProcessX(params);
			rs = stmt.executeQuery(sql);
			
			String processX = "";
			
			if (rs.next()) {
				
				processX = StringUtil.checkString(rs.getString("PROCESS_X"));
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (processX.equals("A")) returnValue = "Y";
			else returnValue = "N"; //<- ̹ ϷǾ.
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ370ProcessX:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ370ProcessX:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  *  IROPS Case Report ȸԼ. 
	  * @param params IroQ410BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/22 
	  */
	public Hashtable selIroQ410Main(IroQ410BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			String flt = "";
			
			//FLT ִ 5
			if (!params.getFlt().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getFlt()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Byteų 4Byte 4° A-Z̸ տ 0 δ.
					if (token.length() == 3 || (token.length() == 4 && StringUtil.isAlphabet(token.substring(3,4)))) {
						token = "0" + token;
					}
					if (chk != 0) flt = flt + ",";
					flt = flt + "'" + token + "'";
					chk++;
				}
			}
			
			String prevDssStartDt = "";
			String prevSeqNum = "";
			String prevTitleE = "";
			String prevProcessX = "";
			String prevIropsDt = "";
			String prevDssDt = "";
			String prevDecisionE = "";
			
			String fltNumList = "";
			
			//ȸ
			stmt = conn.createStatement();
			sql = IroQ410Query.getInstance().selMain(params, flt);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
				String seqNum = StringUtil.checkString(rs.getString("SEQ_NUM"));
				String titleE = StringUtil.checkString(rs.getString("TITLE_E"));
				String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
				String processX = StringUtil.checkString(rs.getString("PROCESS_X"));
				String iropsDt = StringUtil.checkString(rs.getString("IROPS_DT"));
				String dssDt = StringUtil.checkString(rs.getString("DSS_DT"));
				String decisionE = StringUtil.checkString(rs.getString("DECISION_E"));
				
				if (prevDssStartDt.equals(dssStartDt) && prevSeqNum.equals(seqNum)) {
					
					fltNumList = fltNumList + ", " + fltNum; // IROPS FLT_NUM ش.
				
				} else {
					
					if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
						
						IroQ410BG entity = new IroQ410BG();
						
						entity.setDssStartDt(prevDssStartDt);
						entity.setSeqNum(prevSeqNum);
						entity.setTitleE(prevTitleE);
						entity.setFltNum(fltNumList);
						entity.setProcessX(prevProcessX);
						entity.setIropsDt(prevIropsDt);
						entity.setDssDt(prevDssDt);
						entity.setDecisionE(prevDecisionE);
						
						listData.add(entity);
					}
					
					prevDssStartDt = dssStartDt;
					prevSeqNum = seqNum;
					prevTitleE = titleE;
					fltNumList = fltNum;
					prevProcessX = processX;
					prevIropsDt = iropsDt;
					prevDssDt = dssDt;
					prevDecisionE = decisionE;
				}
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			// Row ߰
			if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
				
				IroQ410BG entity = new IroQ410BG();
				
				entity.setDssStartDt(prevDssStartDt);
				entity.setSeqNum(prevSeqNum);
				entity.setTitleE(prevTitleE);
				entity.setFltNum(fltNumList);
				entity.setProcessX(prevProcessX);
				entity.setIropsDt(prevIropsDt);
				entity.setDssDt(prevDssDt);
				entity.setDecisionE(prevDecisionE);
				
				listData.add(entity);
			}

			hashData.put("CASE_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ410Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ410Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  IROPS FLT Report ȸԼ. 
	  * @param params IroQ420BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/24 
	  */
	public Hashtable selIroQ420Main(IroQ420BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			String flt = "";
			String acreg = "";
			
			//FLT ִ 5
			if (!params.getFlt().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getFlt()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Byteų 4Byte 4° A-Z̸ տ 0 δ.
					if (token.length() == 3 || (token.length() == 4 && StringUtil.isAlphabet(token.substring(3,4)))) {
						token = "0" + token;
					}
					if (chk != 0) flt = flt + ",";
					flt = flt + "'" + token + "'";
					chk++;
				}
			}
			//ACREG ִ 5
			if (!params.getAcreg().equals("")) {
				StringTokenizer st = new StringTokenizer(StringUtil.blankToComma(params.getAcreg()), ",");
				int chk = 0;
				while(st.hasMoreTokens()){		
					String token = StringUtil.checkString(st.nextToken());
					//3Bytḛ ڷθ Ǿ տ 7 δ.
					if (token.length() == 3 && !StringUtil.isAlphabet(token)) {
						token = "7" + token;
					}
					if (token.length() <= 4) {
						token = "HL" + token;
					}
					if (chk != 0) acreg = acreg + ",";
					acreg = acreg + "'" + token + "'";
					chk++;
				}
			}
			
			//1. DAILY_SCH_T  ȸ
			stmt = conn.createStatement();
			sql = IroQ420Query.getInstance().selMain1(params, flt, acreg);
			rs = stmt.executeQuery(sql);
			
			boolean selFlg = false;
			
			while (rs.next()) {
				
				selFlg = true;
				
				IroQ420BG entity = new IroQ420BG();
				
				entity.setHideY(StringUtil.checkString(rs.getString("HIDE_Y")));
				entity.setArlnCd(StringUtil.checkString(rs.getString("ARLN_CD")));
				entity.setFirstLegFltDt(StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT")));
				entity.setSchDate(StringUtil.checkString(rs.getString("SCH_DATE")));
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
				entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
				entity.setActyp(StringUtil.checkString(rs.getString("KACTYP")));
				entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
				entity.setStd(StringUtil.checkString(rs.getString("STD")));
				entity.setAtd(StringUtil.checkString(rs.getString("ATD")));
				entity.setSta(StringUtil.checkString(rs.getString("STA")));
				entity.setAta(StringUtil.checkString(rs.getString("ATA")));
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
				entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
				entity.setOcc(StringUtil.checkString(rs.getString("OCC")));
				entity.setGoc(StringUtil.checkString(rs.getString("GOC")));
				entity.setDssStartDt(StringUtil.checkString(rs.getString("DSS_START_DT")));
				entity.setSeqNum(StringUtil.checkString(rs.getString("SEQ_NUM")));
				
				listData.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			// ȸ   Ʒ  ȸ
			if (!selFlg) {
				
				//2. DSS_NEW_SCH_T  ȸ
				stmt = conn.createStatement();
				sql = IroQ420Query.getInstance().selMain2(params, flt, acreg);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
										
					IroQ420BG entity = new IroQ420BG();
					
					entity.setHideY(StringUtil.checkString(rs.getString("HIDE_Y")));
					entity.setArlnCd(StringUtil.checkString(rs.getString("ARLN_CD")));
					entity.setFirstLegFltDt(StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT")));
					entity.setSchDate(StringUtil.checkString(rs.getString("SCH_DATE")));
					entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
					entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
					entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
					entity.setActyp(StringUtil.checkString(rs.getString("KACTYP")));
					entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
					entity.setStd(StringUtil.checkString(rs.getString("STD")));
					entity.setAtd(StringUtil.checkString(rs.getString("ATD")));
					entity.setSta(StringUtil.checkString(rs.getString("STA")));
					entity.setAta(StringUtil.checkString(rs.getString("ATA")));
					entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
					entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
					entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
					entity.setOcc(StringUtil.checkString(rs.getString("OCC")));
					entity.setGoc(StringUtil.checkString(rs.getString("GOC")));
					entity.setDssStartDt(StringUtil.checkString(rs.getString("DSS_START_DT")));
					entity.setSeqNum(StringUtil.checkString(rs.getString("SEQ_NUM")));
					
					listData.add(entity);
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
			}
			
			hashData.put("FLT_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ420Main:Exception] "+((SQLException)se).getMessage());
			System.out.println("[BASE:IroAllSLBean:selIroQ420Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ420Main:Exception] "+((Exception)e).getMessage());
			System.out.println("[BASE:IroAllSLBean:selIroQ420Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  * Ư IROPS SKD HIDE ϴ Լ. 
	  * @param params IroQ420BG ȸ
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2009/09/24 
	  */
	public String updIroQ420HideY(IroQ420BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//DSS_IROPS_SCH_T.HIDE_Y Update
			stmt = conn.createStatement();
			sql = IroQ420Query.getInstance().updHideY(params);
			int updFlg = stmt.executeUpdate(sql);
			
			if (updFlg != 1) throw new BusinessException("IROPS SKD HIde Exception!!");
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			//Data Commit
			conn.commit();
			
			returnValue = "Y";
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroQ420HideY:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroQ420HideY:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroQ420HideY:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  * IROPS  ȸԼ. 
	  * @param params IroQ430BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/09/25 
	  */
	public Hashtable selIroQ430User() throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			// ȸ
			stmt = conn.createStatement();
			sql = IroQ430Query.getInstance().selUser();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				IroQ430BG entity = new IroQ430BG();
				
				entity.setUserId(StringUtil.checkString(rs.getString("USER_ID")));
				entity.setKorN(StringUtil.checkString(rs.getString("KOR_N")));
				entity.setDeskX(StringUtil.checkString(rs.getString("DESK_X")));
				
				listData.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("USER_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ430User:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ430User:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  Pre-Determination ȸԼ. 
	  * @param params IroQ430BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/26 
	  */
	public Hashtable selIroQ430Main(IroQ430BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Pre-Determination ȸ
			stmt = conn.createStatement();
			sql = IroQ430Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			int dla_0 = 0, dla_1 = 0, dla_2 = 0, dla_3 = 0, dla_4 = 0, dla_5 = 0, dla_6 = 0, dla_7 = 0, dla_8 = 0, dla_9 = 0;
			int chg_0 = 0, chg_1 = 0, chg_2 = 0, chg_3 = 0, chg_4 = 0, chg_5 = 0, chg_6 = 0, chg_7 = 0, chg_8 = 0, chg_9 = 0;
			int cnl_0 = 0, cnl_1 = 0, cnl_2 = 0, cnl_3 = 0, cnl_4 = 0, cnl_5 = 0, cnl_6 = 0, cnl_7 = 0, cnl_8 = 0, cnl_9 = 0;
			int rtr_0 = 0, rtr_1 = 0, rtr_2 = 0, rtr_3 = 0, rtr_4 = 0, rtr_5 = 0, rtr_6 = 0, rtr_7 = 0, rtr_8 = 0, rtr_9 = 0;
			int div_0 = 0, div_1 = 0, div_2 = 0, div_3 = 0, div_4 = 0, div_5 = 0, div_6 = 0, div_7 = 0, div_8 = 0, div_9 = 0;
			int new_0 = 0, new_1 = 0, new_2 = 0, new_3 = 0, new_4 = 0, new_5 = 0, new_6 = 0, new_7 = 0, new_8 = 0, new_9 = 0;
			
			while (rs.next()) {
				
				String grp = StringUtil.checkString(rs.getString("GRP"));
				String commentX = StringUtil.checkString(rs.getString("COMMENT_X"));
				int rng = rs.getInt("RNG");
				int cnt = rs.getInt("CNT");
				
				if (commentX.equals("DLA")) {
					if (grp.equals("A") && rng >= 12) dla_0 += cnt;
					if (grp.equals("A") && rng >= 5 && rng < 12) dla_1 += cnt;
					if (grp.equals("A") && rng == 4) dla_2 += cnt;
					if (grp.equals("A") && rng == 3) dla_3 += cnt;
					if (grp.equals("A") && rng == 2) dla_4 += cnt;
					if (grp.equals("A") && rng == 1) dla_5 += cnt;
					if (grp.equals("A") && rng == 0) dla_6 += cnt;
					if (grp.equals("B") && rng == 0) dla_7 += cnt;
					if (grp.equals("B") && rng == -1) dla_8 += cnt;
					if (grp.equals("B") && rng <= -2) dla_9 += cnt;
					
				} else if (commentX.equals("CHG")) {
					if (grp.equals("A") && rng >= 12) chg_0 += cnt;
					if (grp.equals("A") && rng >= 5 && rng < 12) chg_1 += cnt;
					if (grp.equals("A") && rng == 4) chg_2 += cnt;
					if (grp.equals("A") && rng == 3) chg_3 += cnt;
					if (grp.equals("A") && rng == 2) chg_4 += cnt;
					if (grp.equals("A") && rng == 1) chg_5 += cnt;
					if (grp.equals("A") && rng == 0) chg_6 += cnt;
					if (grp.equals("B") && rng == 0) chg_7 += cnt;
					if (grp.equals("B") && rng == -1) chg_8 += cnt;
					if (grp.equals("B") && rng <= -2) chg_9 += cnt;
					
				} else if (commentX.equals("CNL")) {
					if (grp.equals("A") && rng >= 12) cnl_0 += cnt;
					if (grp.equals("A") && rng >= 5 && rng < 12) cnl_1 += cnt;
					if (grp.equals("A") && rng == 4) cnl_2 += cnt;
					if (grp.equals("A") && rng == 3) cnl_3 += cnt;
					if (grp.equals("A") && rng == 2) cnl_4 += cnt;
					if (grp.equals("A") && rng == 1) cnl_5 += cnt;
					if (grp.equals("A") && rng == 0) cnl_6 += cnt;
					if (grp.equals("B") && rng == 0) cnl_7 += cnt;
					if (grp.equals("B") && rng == -1) cnl_8 += cnt;
					if (grp.equals("B") && rng <= -2) cnl_9 += cnt;
					
				} else if (commentX.equals("RTR")) {
					if (grp.equals("A") && rng >= 12) rtr_0 += cnt;
					if (grp.equals("A") && rng >= 5 && rng < 12) rtr_1 += cnt;
					if (grp.equals("A") && rng == 4) rtr_2 += cnt;
					if (grp.equals("A") && rng == 3) rtr_3 += cnt;
					if (grp.equals("A") && rng == 2) rtr_4 += cnt;
					if (grp.equals("A") && rng == 1) rtr_5 += cnt;
					if (grp.equals("A") && rng == 0) rtr_6 += cnt;
					if (grp.equals("B") && rng == 0) rtr_7 += cnt;
					if (grp.equals("B") && rng == -1) rtr_8 += cnt;
					if (grp.equals("B") && rng <= -2) rtr_9 += cnt;
					
				} else if (commentX.equals("DIV")) {
					if (grp.equals("A") && rng >= 12) div_0 += cnt;
					if (grp.equals("A") && rng >= 5 && rng < 12) div_1 += cnt;
					if (grp.equals("A") && rng == 4) div_2 += cnt;
					if (grp.equals("A") && rng == 3) div_3 += cnt;
					if (grp.equals("A") && rng == 2) div_4 += cnt;
					if (grp.equals("A") && rng == 1) div_5 += cnt;
					if (grp.equals("A") && rng == 0) div_6 += cnt;
					if (grp.equals("B") && rng == 0) div_7 += cnt;
					if (grp.equals("B") && rng == -1) div_8 += cnt;
					if (grp.equals("B") && rng <= -2) div_9 += cnt;
					
				} else if (commentX.equals("NEW")) {
					if (grp.equals("A") && rng >= 12) new_0 += cnt;
					if (grp.equals("A") && rng >= 5 && rng < 12) new_1 += cnt;
					if (grp.equals("A") && rng == 4) new_2 += cnt;
					if (grp.equals("A") && rng == 3) new_3 += cnt;
					if (grp.equals("A") && rng == 2) new_4 += cnt;
					if (grp.equals("A") && rng == 1) new_5 += cnt;
					if (grp.equals("A") && rng == 0) new_6 += cnt;
					if (grp.equals("B") && rng == 0) new_7 += cnt;
					if (grp.equals("B") && rng == -1) new_8 += cnt;
					if (grp.equals("B") && rng <= -2) new_9 += cnt;
				}
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			IroQ430BG entity_0 = new IroQ430BG();
			IroQ430BG entity_1 = new IroQ430BG();
			IroQ430BG entity_2 = new IroQ430BG();
			IroQ430BG entity_3 = new IroQ430BG();
			IroQ430BG entity_4 = new IroQ430BG();
			IroQ430BG entity_5 = new IroQ430BG();
			IroQ430BG entity_6 = new IroQ430BG();
			IroQ430BG entity_7 = new IroQ430BG();
			IroQ430BG entity_8 = new IroQ430BG();
			IroQ430BG entity_9 = new IroQ430BG();
			IroQ430BG entity_ttl = new IroQ430BG();
			
			entity_0.setTime("12");
			entity_0.setDlaCnt(String.valueOf(dla_0).toString());
			entity_0.setChgCnt(String.valueOf(chg_0).toString());
			entity_0.setCnlCnt(String.valueOf(cnl_0).toString());
			entity_0.setRtrCnt(String.valueOf(rtr_0).toString());
			entity_0.setDivCnt(String.valueOf(div_0).toString());
			entity_0.setNewCnt(String.valueOf(new_0).toString());
			entity_0.setTotalCnt(String.valueOf(dla_0 + chg_0 + cnl_0 + rtr_0 + div_0 + new_0).toString());
			int total_0 = dla_0 + chg_0 + cnl_0 + rtr_0 + div_0 + new_0;
			
			entity_1.setTime("5");
			entity_1.setDlaCnt(String.valueOf(dla_1).toString());
			entity_1.setChgCnt(String.valueOf(chg_1).toString());
			entity_1.setCnlCnt(String.valueOf(cnl_1).toString());
			entity_1.setRtrCnt(String.valueOf(rtr_1).toString());
			entity_1.setDivCnt(String.valueOf(div_1).toString());
			entity_1.setNewCnt(String.valueOf(new_1).toString());
			entity_1.setTotalCnt(String.valueOf(dla_1 + chg_1 + cnl_1 + rtr_1 + div_1 + new_1).toString());
			int total_1 = dla_1 + chg_1 + cnl_1 + rtr_1 + div_1 + new_1;
			
			entity_2.setTime("4");
			entity_2.setDlaCnt(String.valueOf(dla_2).toString());
			entity_2.setChgCnt(String.valueOf(chg_2).toString());
			entity_2.setCnlCnt(String.valueOf(cnl_2).toString());
			entity_2.setRtrCnt(String.valueOf(rtr_2).toString());
			entity_2.setDivCnt(String.valueOf(div_2).toString());
			entity_2.setNewCnt(String.valueOf(new_2).toString());
			entity_2.setTotalCnt(String.valueOf(dla_2 + chg_2 + cnl_2 + rtr_2 + div_2 + new_2).toString());
			int total_2 = dla_2 + chg_2 + cnl_2 + rtr_2 + div_2 + new_2;
			
			entity_3.setTime("3");
			entity_3.setDlaCnt(String.valueOf(dla_3).toString());
			entity_3.setChgCnt(String.valueOf(chg_3).toString());
			entity_3.setCnlCnt(String.valueOf(cnl_3).toString());
			entity_3.setRtrCnt(String.valueOf(rtr_3).toString());
			entity_3.setDivCnt(String.valueOf(div_3).toString());
			entity_3.setNewCnt(String.valueOf(new_3).toString());
			entity_3.setTotalCnt(String.valueOf(dla_3 + chg_3 + cnl_3 + rtr_3 + div_3 + new_3).toString());
			int total_3 = dla_3 + chg_3 + cnl_3 + rtr_3 + div_3 + new_3;
			
			entity_4.setTime("2");
			entity_4.setDlaCnt(String.valueOf(dla_4).toString());
			entity_4.setChgCnt(String.valueOf(chg_4).toString());
			entity_4.setCnlCnt(String.valueOf(cnl_4).toString());
			entity_4.setRtrCnt(String.valueOf(rtr_4).toString());
			entity_4.setDivCnt(String.valueOf(div_4).toString());
			entity_4.setNewCnt(String.valueOf(new_4).toString());
			entity_4.setTotalCnt(String.valueOf(dla_4 + chg_4 + cnl_4 + rtr_4 + div_4 + new_4).toString());
			int total_4 = dla_4 + chg_4 + cnl_4 + rtr_4 + div_4 + new_4;
			
			entity_5.setTime("1");
			entity_5.setDlaCnt(String.valueOf(dla_5).toString());
			entity_5.setChgCnt(String.valueOf(chg_5).toString());
			entity_5.setCnlCnt(String.valueOf(cnl_5).toString());
			entity_5.setRtrCnt(String.valueOf(rtr_5).toString());
			entity_5.setDivCnt(String.valueOf(div_5).toString());
			entity_5.setNewCnt(String.valueOf(new_5).toString());
			entity_5.setTotalCnt(String.valueOf(dla_5 + chg_5 + cnl_5 + rtr_5 + div_5 + new_5).toString());
			int total_5 = dla_5 + chg_5 + cnl_5 + rtr_5 + div_5 + new_5;
			
			entity_6.setTime("0");
			entity_6.setDlaCnt(String.valueOf(dla_6).toString());
			entity_6.setChgCnt(String.valueOf(chg_6).toString());
			entity_6.setCnlCnt(String.valueOf(cnl_6).toString());
			entity_6.setRtrCnt(String.valueOf(rtr_6).toString());
			entity_6.setDivCnt(String.valueOf(div_6).toString());
			entity_6.setNewCnt(String.valueOf(new_6).toString());
			entity_6.setTotalCnt(String.valueOf(dla_6 + chg_6 + cnl_6 + rtr_6 + div_6 + new_6).toString());
			int total_6 = dla_6 + chg_6 + cnl_6 + rtr_6 + div_6 + new_6;
			
			entity_7.setTime("-0");
			entity_7.setDlaCnt(String.valueOf(dla_7).toString());
			entity_7.setChgCnt(String.valueOf(chg_7).toString());
			entity_7.setCnlCnt(String.valueOf(cnl_7).toString());
			entity_7.setRtrCnt(String.valueOf(rtr_7).toString());
			entity_7.setDivCnt(String.valueOf(div_7).toString());
			entity_7.setNewCnt(String.valueOf(new_7).toString());
			entity_7.setTotalCnt(String.valueOf(dla_7 + chg_7 + cnl_7 + rtr_7 + div_7 + new_7).toString());
			int total_7 = dla_7 + chg_7 + cnl_7 + rtr_7 + div_7 + new_7;
			
			entity_8.setTime("-1");
			entity_8.setDlaCnt(String.valueOf(dla_8).toString());
			entity_8.setChgCnt(String.valueOf(chg_8).toString());
			entity_8.setCnlCnt(String.valueOf(cnl_8).toString());
			entity_8.setRtrCnt(String.valueOf(rtr_8).toString());
			entity_8.setDivCnt(String.valueOf(div_8).toString());
			entity_8.setNewCnt(String.valueOf(new_8).toString());
			entity_8.setTotalCnt(String.valueOf(dla_8 + chg_8 + cnl_8 + rtr_8 + div_8 + new_8).toString());
			int total_8 = dla_8 + chg_8 + cnl_8 + rtr_8 + div_8 + new_8;
			
			entity_9.setTime("-2");
			entity_9.setDlaCnt(String.valueOf(dla_9).toString());
			entity_9.setChgCnt(String.valueOf(chg_9).toString());
			entity_9.setCnlCnt(String.valueOf(cnl_9).toString());
			entity_9.setRtrCnt(String.valueOf(rtr_9).toString());
			entity_9.setDivCnt(String.valueOf(div_9).toString());
			entity_9.setNewCnt(String.valueOf(new_9).toString());
			entity_9.setTotalCnt(String.valueOf(dla_9 + chg_9 + cnl_9 + rtr_9 + div_9 + new_9).toString());
			int total_9 = dla_9 + chg_9 + cnl_9 + rtr_9 + div_9 + new_9;
			
			 //ALL  12ð ̻ Ѵ.(0)
			//2010.04.15 ߰ : -1ð ̳ ~ -2ð ̻ Ѵ.(7,8,9)
			entity_ttl.setTime("ALL");
			entity_ttl.setDlaCnt(String.valueOf(dla_1 + dla_2 + dla_3 + dla_4 + dla_5 + dla_6).toString());
			entity_ttl.setChgCnt(String.valueOf(chg_1 + chg_2 + chg_3 + chg_4 + chg_5 + chg_6).toString());
			entity_ttl.setCnlCnt(String.valueOf(cnl_1 + cnl_2 + cnl_3 + cnl_4 + cnl_5 + cnl_6).toString());
			entity_ttl.setRtrCnt(String.valueOf(rtr_1 + rtr_2 + rtr_3 + rtr_4 + rtr_5 + rtr_6).toString());
			entity_ttl.setDivCnt(String.valueOf(div_1 + div_2 + div_3 + div_4 + div_5 + div_6).toString());
			entity_ttl.setNewCnt(String.valueOf(new_1 + new_2 + new_3 + new_4 + new_5 + new_6).toString());
			entity_ttl.setTotalCnt(String.valueOf(total_1 + total_2 + total_3 + total_4 + total_5 + total_6).toString());
			
			listData.add(entity_0);
			listData.add(entity_1);
			listData.add(entity_2);
			listData.add(entity_3);
			listData.add(entity_4);
			listData.add(entity_5);
			listData.add(entity_6);
			listData.add(entity_7);
			listData.add(entity_8);
			listData.add(entity_9);
			listData.add(entity_ttl);
			
			hashData.put("PRE_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ430Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ430Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  Time Consumption ȸԼ. 
	  * @param params IroQ440BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/27 
	  */
	public Hashtable selIroQ440Main(IroQ440BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Pre-Determination ȸ
			stmt = conn.createStatement();
			sql = IroQ440Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			int dla_1 = 0, dla_2 = 0, dla_3 = 0, dla_4 = 0, dla_5 = 0, dla_6 = 0;
			int chg_1 = 0, chg_2 = 0, chg_3 = 0, chg_4 = 0, chg_5 = 0, chg_6 = 0;
			int cnl_1 = 0, cnl_2 = 0, cnl_3 = 0, cnl_4 = 0, cnl_5 = 0, cnl_6 = 0;
			int rtr_1 = 0, rtr_2 = 0, rtr_3 = 0, rtr_4 = 0, rtr_5 = 0, rtr_6 = 0;
			int div_1 = 0, div_2 = 0, div_3 = 0, div_4 = 0, div_5 = 0, div_6 = 0;
			int new_1 = 0, new_2 = 0, new_3 = 0, new_4 = 0, new_5 = 0, new_6 = 0;
			
			while (rs.next()) {
				
				String commentX = StringUtil.checkString(rs.getString("COMMENT_X"));
				int rng = rs.getInt("RNG");
				int cnt = rs.getInt("CNT");
				
				if (commentX.equals("DLA")) {
					if (rng >= 5) dla_1 += cnt;
					if (rng == 4) dla_2 += cnt;
					if (rng == 3) dla_3 += cnt;
					if (rng == 2) dla_4 += cnt;
					if (rng == 1) dla_5 += cnt;
					if (rng == 0) dla_6 += cnt;
					
				} else if (commentX.equals("CHG")) {
					if (rng >= 5) chg_1 += cnt;
					if (rng == 4) chg_2 += cnt;
					if (rng == 3) chg_3 += cnt;
					if (rng == 2) chg_4 += cnt;
					if (rng == 1) chg_5 += cnt;
					if (rng == 0) chg_6 += cnt;
					
				} else if (commentX.equals("CNL")) {
					if (rng >= 5) cnl_1 += cnt;
					if (rng == 4) cnl_2 += cnt;
					if (rng == 3) cnl_3 += cnt;
					if (rng == 2) cnl_4 += cnt;
					if (rng == 1) cnl_5 += cnt;
					if (rng == 0) cnl_6 += cnt;
					
				} else if (commentX.equals("RTR")) {
					if (rng >= 5) rtr_1 += cnt;
					if (rng == 4) rtr_2 += cnt;
					if (rng == 3) rtr_3 += cnt;
					if (rng == 2) rtr_4 += cnt;
					if (rng == 1) rtr_5 += cnt;
					if (rng == 0) rtr_6 += cnt;
					
				} else if (commentX.equals("DIV")) {
					if (rng >= 5) div_1 += cnt;
					if (rng == 4) div_2 += cnt;
					if (rng == 3) div_3 += cnt;
					if (rng == 2) div_4 += cnt;
					if (rng == 1) div_5 += cnt;
					if (rng == 0) div_6 += cnt;
					
				} else if (commentX.equals("NEW")) {
					if (rng >= 5) new_1 += cnt;
					if (rng == 4) new_2 += cnt;
					if (rng == 3) new_3 += cnt;
					if (rng == 2) new_4 += cnt;
					if (rng == 1) new_5 += cnt;
					if (rng == 0) new_6 += cnt;
				}
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			IroQ440BG entity_1 = new IroQ440BG();
			IroQ440BG entity_2 = new IroQ440BG();
			IroQ440BG entity_3 = new IroQ440BG();
			IroQ440BG entity_4 = new IroQ440BG();
			IroQ440BG entity_5 = new IroQ440BG();
			IroQ440BG entity_6 = new IroQ440BG();
			IroQ440BG entity_ttl = new IroQ440BG();
			
			entity_1.setTime("5");
			entity_1.setDlaCnt(String.valueOf(dla_1).toString());
			entity_1.setChgCnt(String.valueOf(chg_1).toString());
			entity_1.setCnlCnt(String.valueOf(cnl_1).toString());
			entity_1.setRtrCnt(String.valueOf(rtr_1).toString());
			entity_1.setDivCnt(String.valueOf(div_1).toString());
			entity_1.setNewCnt(String.valueOf(new_1).toString());
			entity_1.setTotalCnt(String.valueOf(dla_1 + chg_1 + cnl_1 + rtr_1 + div_1 + new_1).toString());
			int total_1 = dla_1 + chg_1 + cnl_1 + rtr_1 + div_1 + new_1;
			
			entity_2.setTime("4");
			entity_2.setDlaCnt(String.valueOf(dla_2).toString());
			entity_2.setChgCnt(String.valueOf(chg_2).toString());
			entity_2.setCnlCnt(String.valueOf(cnl_2).toString());
			entity_2.setRtrCnt(String.valueOf(rtr_2).toString());
			entity_2.setDivCnt(String.valueOf(div_2).toString());
			entity_2.setNewCnt(String.valueOf(new_2).toString());
			entity_2.setTotalCnt(String.valueOf(dla_2 + chg_2 + cnl_2 + rtr_2 + div_2 + new_2).toString());
			int total_2 = dla_2 + chg_2 + cnl_2 + rtr_2 + div_2 + new_2;
			
			entity_3.setTime("3");
			entity_3.setDlaCnt(String.valueOf(dla_3).toString());
			entity_3.setChgCnt(String.valueOf(chg_3).toString());
			entity_3.setCnlCnt(String.valueOf(cnl_3).toString());
			entity_3.setRtrCnt(String.valueOf(rtr_3).toString());
			entity_3.setDivCnt(String.valueOf(div_3).toString());
			entity_3.setNewCnt(String.valueOf(new_3).toString());
			entity_3.setTotalCnt(String.valueOf(dla_3 + chg_3 + cnl_3 + rtr_3 + div_3 + new_3).toString());
			int total_3 = dla_3 + chg_3 + cnl_3 + rtr_3 + div_3 + new_3;
			
			entity_4.setTime("2");
			entity_4.setDlaCnt(String.valueOf(dla_4).toString());
			entity_4.setChgCnt(String.valueOf(chg_4).toString());
			entity_4.setCnlCnt(String.valueOf(cnl_4).toString());
			entity_4.setRtrCnt(String.valueOf(rtr_4).toString());
			entity_4.setDivCnt(String.valueOf(div_4).toString());
			entity_4.setNewCnt(String.valueOf(new_4).toString());
			entity_4.setTotalCnt(String.valueOf(dla_4 + chg_4 + cnl_4 + rtr_4 + div_4 + new_4).toString());
			int total_4 = dla_4 + chg_4 + cnl_4 + rtr_4 + div_4 + new_4;
			
			entity_5.setTime("1");
			entity_5.setDlaCnt(String.valueOf(dla_5).toString());
			entity_5.setChgCnt(String.valueOf(chg_5).toString());
			entity_5.setCnlCnt(String.valueOf(cnl_5).toString());
			entity_5.setRtrCnt(String.valueOf(rtr_5).toString());
			entity_5.setDivCnt(String.valueOf(div_5).toString());
			entity_5.setNewCnt(String.valueOf(new_5).toString());
			entity_5.setTotalCnt(String.valueOf(dla_5 + chg_5 + cnl_5 + rtr_5 + div_5 + new_5).toString());
			int total_5 = dla_5 + chg_5 + cnl_5 + rtr_5 + div_5 + new_5;
			
			entity_6.setTime("0");
			entity_6.setDlaCnt(String.valueOf(dla_6).toString());
			entity_6.setChgCnt(String.valueOf(chg_6).toString());
			entity_6.setCnlCnt(String.valueOf(cnl_6).toString());
			entity_6.setRtrCnt(String.valueOf(rtr_6).toString());
			entity_6.setDivCnt(String.valueOf(div_6).toString());
			entity_6.setNewCnt(String.valueOf(new_6).toString());
			entity_6.setTotalCnt(String.valueOf(dla_6 + chg_6 + cnl_6 + rtr_6 + div_6 + new_6).toString());
			int total_6 = dla_6 + chg_6 + cnl_6 + rtr_6 + div_6 + new_6;
			
			entity_ttl.setTime("ALL");
			entity_ttl.setDlaCnt(String.valueOf(dla_1 + dla_2 + dla_3 + dla_4 + dla_5 + dla_6).toString());
			entity_ttl.setChgCnt(String.valueOf(chg_1 + chg_2 + chg_3 + chg_4 + chg_5 + chg_6).toString());
			entity_ttl.setCnlCnt(String.valueOf(cnl_1 + cnl_2 + cnl_3 + cnl_4 + cnl_5 + cnl_6).toString());
			entity_ttl.setRtrCnt(String.valueOf(rtr_1 + rtr_2 + rtr_3 + rtr_4 + rtr_5 + rtr_6).toString());
			entity_ttl.setDivCnt(String.valueOf(div_1 + div_2 + div_3 + div_4 + div_5 + div_6).toString());
			entity_ttl.setNewCnt(String.valueOf(new_1 + new_2 + new_3 + new_4 + new_5 + new_6).toString());
			entity_ttl.setTotalCnt(String.valueOf(total_1 + total_2 + total_3 + total_4 + total_5 + total_6).toString());
			
			listData.add(entity_1);
			listData.add(entity_2);
			listData.add(entity_3);
			listData.add(entity_4);
			listData.add(entity_5);
			listData.add(entity_6);
			listData.add(entity_ttl);
			
			hashData.put("TIME_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ440Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ440Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  IROPS REPORT ȸԼ. 
	  * @param params IroQ430BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/28 
	  */
	public Hashtable selIroQ430IropsReport(IroQ430BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			stmt = conn.createStatement();
			
			int min = 0;
			int cnt = 0;
			
			//Pre-Determination ȸ
			if (params.getGubun().equals("A")) {
				
				sql = IroQ430Query.getInstance().selPreReport(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					IroQ430BG entity = new IroQ430BG();
					
					entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
					entity.setSchDate(StringUtil.checkString(rs.getString("SCH_DATE")));
					entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
					entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
					entity.setRouteX(StringUtil.checkString(rs.getString("ROUTE_X")));
					entity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
					entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
					entity.setStd(StringUtil.checkString(rs.getString("STD")));
					entity.setAtd(StringUtil.checkString(rs.getString("ATD")));
					entity.setSta(StringUtil.checkString(rs.getString("STA")));
					entity.setAta(StringUtil.checkString(rs.getString("ATA")));
					entity.setChgreas(StringUtil.checkString(rs.getString("CHGREAS")));
					entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
					entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
					entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
					entity.setIropsDt(StringUtil.checkString(rs.getString("IROPS_DT")));
					entity.setDssDt(StringUtil.checkString(rs.getString("DSS_DT")));
					
					entity.setDssStartDt(StringUtil.checkString(rs.getString("DSS_START_DT")));
					entity.setSeqNum(StringUtil.checkString(rs.getString("SEQ_NUM")));
					
					min = min + rs.getInt("MIN"); //ɸð (д)
					cnt = cnt + 1; //Ѱ
					
					listData.add(entity);
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
			 
			//Time Consumption ȸ
			} else if (params.getGubun().equals("B")) { //2010.05.28  : FLT  CASE  
				
				sql = IroQ430Query.getInstance().selTimeReport(params);
				rs = stmt.executeQuery(sql);
				
				String prevDssStartDt = "";
				String prevSeqNum = "";
				int prevMin = 0;
				String prevDecisionE = "";
				String prevTitleE = "";
				
				String fltNumList = "";
				
				while (rs.next()) {
					
					String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
					String seqNum = StringUtil.checkString(rs.getString("SEQ_NUM"));
					int minute = rs.getInt("MIN");
					String decisionE = StringUtil.checkString(rs.getString("DECISION_E"));
					String titleE = StringUtil.checkString(rs.getString("TITLE_E"));
					String fltNum = StringUtil.checkString(rs.getString("FLT_NUM"));
					
					if (prevDssStartDt.equals(dssStartDt) && prevSeqNum.equals(seqNum)) {
						
						fltNumList = fltNumList + ", " + fltNum; // IROPS FLT_NUM ش.
					
					} else {
						
						if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
							
							IroQ430BG entity = new IroQ430BG();
							
							entity.setDssStartDt(prevDssStartDt);
							entity.setSeqNum(prevSeqNum);
							entity.setDecisionE(prevDecisionE);
							entity.setTitleE(prevTitleE);
							entity.setFltNum(fltNumList);
							
							min = min + prevMin; //ɸð (д)
							cnt = cnt + 1; //Ѱ
							
							listData.add(entity);
						}
						
						prevDssStartDt = dssStartDt;
						prevSeqNum = seqNum;
						prevMin = minute;
						prevDecisionE = decisionE;
						prevTitleE = titleE;
						fltNumList = fltNum;
					}
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				// Row ߰
				if (!prevDssStartDt.equals("") && !prevSeqNum.equals("")) {
					
					IroQ430BG entity = new IroQ430BG();
					
					entity.setDssStartDt(prevDssStartDt);
					entity.setSeqNum(prevSeqNum);
					entity.setDecisionE(prevDecisionE);
					entity.setTitleE(prevTitleE);
					entity.setFltNum(fltNumList);
					
					min = min + prevMin; //ɸð (д)
					cnt = cnt + 1; //Ѱ
					
					listData.add(entity);
				}
			}
			
			int aver = min / cnt; // = ɸð (д) / Ѱ
			int hh = aver / 60;
			int mm = Math.abs(aver % 60);
			
			String averTime = "";
			if (mm < 10) averTime = hh + ":0" + mm;
			else averTime = hh + ":" + mm;
			
			//System.out.println("min => " + min);
			//System.out.println("cnt => " + cnt);
			//System.out.println("aver => " + aver);
			//System.out.println("hh => " + hh);
			//System.out.println("mm => " + mm);
			//System.out.println("averTime => " + averTime);
			
			hashData.put("AVER_TIME",averTime);
			hashData.put("REPORT_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ430IropsReport:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ430IropsReport:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  DSS Messenger ȸԼ. 
	  * @param params IroQ450BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/08/31 
	  */
	public Hashtable selIroQ450Main(IroQ450BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			stmt = conn.createStatement();
			sql = IroQ450Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ450BG entity = new IroQ450BG();
				
				if (rs.getInt("LVL_NO") == 0) entity.setMsgE(StringUtil.checkString(rs.getString("TITLE_E")));
				else entity.setMsgE(StringUtil.checkString(rs.getString("MSG_E")));
				
				entity.setLvlNo(StringUtil.checkString(rs.getString("LVL_NO")));
				entity.setCodeX(StringUtil.checkString(rs.getString("CODE_X")));
				entity.setKorN(StringUtil.checkString(rs.getString("KOR_N")));
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setSchDepD(StringUtil.checkString(rs.getString("SCH_DEP_D")));
				entity.setTimestamp(StringUtil.checkString(rs.getString("TIMESTAMP")));
				entity.setDssStartDt(StringUtil.checkString(rs.getString("DSS_START_DT")));
				entity.setMsgNo(StringUtil.checkString(rs.getString("MSG_NO")));
				entity.setDssLvlX(StringUtil.checkString(rs.getString("DSS_LVL_X")));
				
				//EXCEL 鶧 
				entity.setTitle(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setComment(StringUtil.checkString(rs.getString("MSG_E")));
				
				listData.add(entity);
			}

			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("MESSENGER_LIST",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ450Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ450Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *   OCC, GOC  Լ. 
	  * @param params IroQ460BG ȸ
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2009/09/01 
	  */
	public String updIroQ460OccGoc(IroQ460BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			//PROCESSED ȸ
			stmt = conn.createStatement();
			sql = IroQ460Query.getInstance().selOccGoc(params);
			rs = stmt.executeQuery(sql);
			
			String manager_d1 = "";
			String manager_d2 = "";
			
			if (rs.next()) {
				manager_d1 = StringUtil.checkString(rs.getString("MANAGER_D1")); //GOC : μ
				manager_d2 = StringUtil.checkString(rs.getString("MANAGER_D2")); //OCC : 
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (params.getAuth().equals("A")) { //GOC : μ
				
				if (manager_d1.equals("")) { //ó ѹ ð UPDATE
					
					//GOC 
					stmt = conn.createStatement();
					sql = IroQ460Query.getInstance().updOccGoc(params);
					int updFlg = stmt.executeUpdate(sql);
					
					if (updFlg != 1) throw new BusinessException("Approval Exception!!");
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
				}
				
			} else if (params.getAuth().equals("B")) { //OCC : 
				
				if (manager_d2.equals("")) { //ó ѹ ð UPDATE
					
					//OCC 
					stmt = conn.createStatement();
					sql = IroQ460Query.getInstance().updOccGoc(params);
					int updFlg = stmt.executeUpdate(sql);
					
					if (updFlg != 1) throw new BusinessException("Approval Exception!!");
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
				}
			}
			
			//Data Commit
			conn.commit();
			
			returnValue = "Y";
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroQ460OccGoc:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:updIroQ460OccGoc:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:updIroQ460OccGoc:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try {cr.release();} catch(Exception e) {}
			if (conn != null) try {conn.close();} catch(Exception e) {}
			if (rs != null) try {rs.close();} catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  *   ȸ Լ. 
	  * @param params IroQ460BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/09/01 
	  */
	public Hashtable selIroQ460Main(IroQ460BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    IroQ460BG iropsData = new IroQ460BG();
	    List skdData = new LinkedList();
	    List deskData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			String sm = "";
			String occ = "";
			String goc = "";
			String decisionE = "";
			String korN = "";
			String titleE = "";
			String iropsDt = "";
			String dssDt = "";
			String message = "";
			/*@2013-10-xx
			String emailPortList = "";//@2013-06-19 ߰  
			Ʒ  */
			HashMap<String,Object>	emailPortMap	=	null;
			
			boolean selFlg = false;
			
			//1. DAILY_SCH_T  ȸ
			stmt = conn.createStatement();
			sql = IroQ460Query.getInstance().selMain1(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				selFlg = true;
				
				occ = StringUtil.checkString(rs.getString("OCC"));
				goc = StringUtil.checkString(rs.getString("GOC"));
				decisionE = StringUtil.checkString(rs.getString("DECISION_E"));
				korN = StringUtil.checkString(rs.getString("KOR_N"));
				titleE = StringUtil.checkString(rs.getString("TITLE_E"));
				iropsDt = StringUtil.checkString(rs.getString("IROPS_DT"));
				dssDt = StringUtil.checkString(rs.getString("DSS_DT"));
				
				IroQ460BG entity = new IroQ460BG();
				
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
				entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
				entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
				entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
				entity.setSchDepDm(StringUtil.checkString(rs.getString("SCH_DEP_DM"))); //2017.04.12
				entity.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_DT")));
				entity.setSchArvDt(StringUtil.checkString(rs.getString("SCH_ARV_DT")));
				entity.setEstDepDt(StringUtil.checkString(rs.getString("EST_DEP_DT")));
				if (StringUtil.checkString(rs.getString("CGO_X")).equals("CGO")) {
					entity.setSupply("");
				} else {
					entity.setSupply(StringUtil.checkString(rs.getString("F_BOOK"))+"/"+StringUtil.checkString(rs.getString("C_BOOK"))+"/"+StringUtil.checkString(rs.getString("Y_BOOK")));
				}
				entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
				entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
				
				skdData.add(entity);
				
				/*@2013-10-xx
				//@2013-06-17 ߰
				String paxCgo = "";
				if (StringUtil.checkString(rs.getString("CGO_X")).equals("CGO")) paxCgo = "CGO";
				else paxCgo = "PAX";
				if (emailPortList.length()!=0) {
					emailPortList	+=",";
				}
				emailPortList += "'" + paxCgo + "_" + StringUtil.checkString(rs.getString("STNFR")) + "'";
				emailPortList += ",'" + paxCgo + "_" +  StringUtil.checkString(rs.getString("STNTO")) + "'";
				Ʒ */
				String	routeX	=	StringUtil.checkString(rs.getString("ROUTE_X"));
				emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+entity.getStnfr());
				emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+entity.getStnto());
				emailPortMap	=	portMap_put(emailPortMap,routeX+"_ALL_"+entity.getCommentX());
				
				//20141121 DAILY_SCH_T.DIV_STN ߰
				String	divStn	=	StringUtil.checkString(rs.getString("DIV_STN"));
				if(!"".equals(divStn)){
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+divStn);
				}
			}
			if(emailPortMap!=null && emailPortMap.size()!=0){//@2013-11-14
				emailPortMap	=	portMap_put(emailPortMap,"ALL_ALL_ALL");				
			}

			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			// ȸ   Ʒ  ȸ			
			if (!selFlg) {
				
				//2. DSS_NEW_SCH_T  ȸ
				stmt = conn.createStatement();
				sql = IroQ460Query.getInstance().selMain2(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					selFlg = true;
					
					occ = StringUtil.checkString(rs.getString("OCC"));
					goc = StringUtil.checkString(rs.getString("GOC"));
					decisionE = StringUtil.checkString(rs.getString("DECISION_E"));
					korN = StringUtil.checkString(rs.getString("KOR_N"));
					titleE = StringUtil.checkString(rs.getString("TITLE_E"));
					iropsDt = StringUtil.checkString(rs.getString("IROPS_DT"));
					dssDt = StringUtil.checkString(rs.getString("DSS_DT"));
					
					IroQ460BG entity = new IroQ460BG();
					
					entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
					entity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
					entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
					entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
					entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
					entity.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_DT")));
					entity.setSchArvDt(StringUtil.checkString(rs.getString("SCH_ARV_DT")));
					entity.setEstDepDt(StringUtil.checkString(rs.getString("EST_DEP_DT")));
					if (StringUtil.checkString(rs.getString("CGO_X")).equals("CGO")) {
						entity.setSupply("");
					} else {
						entity.setSupply(StringUtil.checkString(rs.getString("F_BOOK"))+"/"+StringUtil.checkString(rs.getString("C_BOOK"))+"/"+StringUtil.checkString(rs.getString("Y_BOOK")));
					}
					entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
					entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
					
					//@2013-10-xx
					String	routeX	=	StringUtil.checkString(rs.getString("ROUTE_X"));
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+entity.getStnfr());
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+entity.getStnto());
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_ALL_"+entity.getCommentX());
					
					//20141121 DSS_NEW_SCH_T.DIV_STN ÷    ߰  .
					
					skdData.add(entity);
				}
				if(emailPortMap!=null && emailPortMap.size()!=0){//@2013-11-14
					emailPortMap	=	portMap_put(emailPortMap,"ALL_ALL_ALL");				
				}

				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
			}
			
            //	 ȸ   Ʒ  ȸ	
			// 2012.02.24 ߰ : div  Ÿ ִ  
			if (!selFlg) {
				
				stmt = conn.createStatement();
				sql = IroQ460Query.getInstance().selMain3(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					selFlg = true;
					
					occ = StringUtil.checkString(rs.getString("OCC"));
					goc = StringUtil.checkString(rs.getString("GOC"));
					decisionE = StringUtil.checkString(rs.getString("DECISION_E"));
					korN = StringUtil.checkString(rs.getString("KOR_N"));
					titleE = StringUtil.checkString(rs.getString("TITLE_E"));
					iropsDt = StringUtil.checkString(rs.getString("IROPS_DT"));
					dssDt = StringUtil.checkString(rs.getString("DSS_DT"));
					
					IroQ460BG entity = new IroQ460BG();
					
					entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
					entity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
					entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
					entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
					entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
					entity.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_DT")));
					entity.setSchArvDt(StringUtil.checkString(rs.getString("SCH_ARV_DT")));
					entity.setEstDepDt(StringUtil.checkString(rs.getString("EST_DEP_DT")));
					if (StringUtil.checkString(rs.getString("CGO_X")).equals("CGO")) {
						entity.setSupply("");
					} else {
						entity.setSupply(StringUtil.checkString(rs.getString("F_BOOK"))+"/"+StringUtil.checkString(rs.getString("C_BOOK"))+"/"+StringUtil.checkString(rs.getString("Y_BOOK")));
					}
					entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
					entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
					
					//@2013-10-xx
					String	routeX	=	StringUtil.checkString(rs.getString("ROUTE_X"));
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+entity.getStnfr());
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+entity.getStnto());
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_ALL_"+entity.getCommentX());
					
					//20141121 DAILY_SCH_T.DIV_STN ߰
					String	divStn	=	StringUtil.checkString(rs.getString("DIV_STN"));
					if(!"".equals(divStn)){
						emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+divStn);
					}
					
					skdData.add(entity);
				}
				if(emailPortMap!=null && emailPortMap.size()!=0){//@2013-11-14
					emailPortMap	=	portMap_put(emailPortMap,"ALL_ALL_ALL");				
				}

				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
			}
			
			//     ٸ ͵ ȸϰ ´.
			if (selFlg) {
				
				//DESK  ȸ
				stmt = conn.createStatement();
				sql = IroQ460Query.getInstance().selDeskInfo(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					//SHIFT MANAGER Է ð  ´.
					if((StringUtil.checkString(rs.getString("DESK_X"))).equals("A")) sm = StringUtil.checkString(rs.getString("SM"));
					
					IroQ460BG entity = new IroQ460BG();
					
					entity.setCodeX(StringUtil.checkString(rs.getString("CODE_X")));
					entity.setKorN(StringUtil.checkString(rs.getString("KOR_N")));
					entity.setTimestamp(StringUtil.checkString(rs.getString("TIMESTAMP")));
					entity.setDecisionX(StringUtil.checkString(rs.getString("DECISION_X")));
					entity.setDecisionE(StringUtil.checkString(rs.getString("DECISION_E")));
					
					deskData.add(entity);
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				//SITA MESSAGE ȸ
				stmt = conn.createStatement();
				sql = IroQ460Query.getInstance().selMessage(params);
				rs = stmt.executeQuery(sql);
				
				if (rs.next()) {
					message = StringUtil.checkString(rs.getString("MESSAGE"));
				}
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				// S/M, , μ ... 
				iropsData.setSm(sm);
				iropsData.setOcc(occ);
				iropsData.setGoc(goc);
				iropsData.setDecisionE(decisionE);
				iropsData.setKorN(korN);
				iropsData.setTitleE(titleE);
				iropsData.setIropsDt(iropsDt);
				iropsData.setDssDt(dssDt);
				iropsData.setMessage(message);
			}
			
			hashData.put("IROPS_DATA",iropsData);
			hashData.put("SKD_LIST",skdData);
			hashData.put("DESK_LIST",deskData);
			
			/*@2013-10-xx
			//--------------------------@2013-07-19 ߰ 
			if(-1<emailPortList.indexOf("PAX")){
				emailPortList +=	emailPortList.length()!=0? ",'PAX_ALL'":"'PAX_ALL'";
			}
			if(-1<emailPortList.indexOf("CGO")){
				emailPortList +=	emailPortList.length()!=0? ",'CGO_ALL'":"'CGO_ALL'";
			}
			emailPortList +=	emailPortList.length()!=0? ",'ALL_ALL'":"'ALL_ALL'";			
			*/
			//--------------------------@2013-06-10 ߰
			String emailAddr = "";			
			//Email ADDRESS ȸ
			stmt = conn.createStatement();
			//sql = IroQ460Query.getInstance().selEmailAddr(emailPortList);
			sql = IroQ460Query.getInstance().selEmailAddr(portMap_toString(emailPortMap));//@2013-10-xx
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {				
				StringTokenizer st = new StringTokenizer(StringUtil.checkString(rs.getString("ADDR_E")), " ");
				while (st.hasMoreTokens()) {
					String tmp = st.nextToken();
					
					//ADDRESS ߺ ʰ ߰Ѵ.
					if (emailAddr.indexOf(tmp) == -1) {
						if (emailAddr.equals("")) emailAddr = tmp;
						else emailAddr = emailAddr + " " + tmp;
					}
				}
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			hashData.put("EMAIL_ADDR",emailAddr);//@2013-06-10 ߰
			
			//20160331 ߰
			List histListData = new LinkedList();
			
			stmt = conn.createStatement();
			sql = IroQ460Query.getInstance().selHistoryMsgSchPop(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ460BG entity = new IroQ460BG();
				
				if (rs.getInt("LVL_NO") == 0) entity.setMsgE(StringUtil.checkString(rs.getString("TITLE_E")));
				else entity.setMsgE(StringUtil.checkString(rs.getString("MSG_E")));
				
				entity.setLvlNo(StringUtil.checkString(rs.getString("LVL_NO")));
				entity.setCodeX(StringUtil.checkString(rs.getString("CODE_X")));
				entity.setKorN(StringUtil.checkString(rs.getString("KOR_N")));
				entity.setDssLvlX(StringUtil.checkString(rs.getString("DSS_LVL_X")));
				entity.setTimestamp(StringUtil.checkString(rs.getString("TIMESTAMP")));
				entity.setDssStartDt(StringUtil.checkString(rs.getString("DSS_START_DT")));
				entity.setMsgNo(StringUtil.checkString(rs.getString("MSG_NO")));
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_D")));
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
				
				histListData.add(entity);
			}
			hashData.put("HISTORY_LIST", histListData);
			
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ460Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ460Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  * AMEND NOTICE - Seq, Message ȸ Լ. 
	  * @param params IroQ460BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/09/03 
	  */
	public Hashtable selIroQ460IropsMsg(IroQ460BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	    IroQ460BG msgData = new IroQ460BG();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//MSG_SEQ_NUM ȸ
			stmt = conn.createStatement();
			sql = IroQ460Query.getInstance().selMsgSeqNum(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ460BG entity = new IroQ460BG();
				
				entity.setMsgSeqNum(StringUtil.checkString(rs.getString("MSG_SEQ_NUM")));
				
				listData.add(entity);
			}

			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			//MESSAGE ȸ
			stmt = conn.createStatement();
			sql = IroQ460Query.getInstance().selMsg(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				msgData.setDecisionE(StringUtil.checkString(rs.getString("DECISION_E")));
				msgData.setMessage(StringUtil.checkString(rs.getString("MESSAGE")));
			}

			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("SEQ_LIST", listData);
			hashData.put("MSG_DATA", msgData);
			
			//20141121 AMEND NOTICE : ȸ   2, 3  ȸ ߰ 
			boolean selFlg = false;
			
			//@2013-06-17 ߰
			/*@2013-10-xx
			String emailPortList = "";//@2013-06-19 ߰  
			Ʒ*/
			HashMap<String,Object>	emailPortMap	=	null;
			stmt = conn.createStatement();
			sql = IroQ460Query.getInstance().selMain1(params);
			rs = stmt.executeQuery(sql);			
			/*while (rs.next()) {				
				String paxCgo = "";
				if (StringUtil.checkString(rs.getString("CGO_X")).equals("CGO")) paxCgo = "CGO";
				else paxCgo = "PAX";
				if (emailPortList.length()!=0) {
					emailPortList	+=",";
				}
				emailPortList += "'" + paxCgo + "_" + StringUtil.checkString(rs.getString("STNFR")) + "'";
				emailPortList += ",'" + paxCgo + "_" +  StringUtil.checkString(rs.getString("STNTO")) + "'";
			}
			//--------------------------@2013-07-19 ߰ 
			if(-1<emailPortList.indexOf("PAX")){
				emailPortList +=	emailPortList.length()!=0? ",'PAX_ALL'":"'PAX_ALL'";
			}
			if(-1<emailPortList.indexOf("CGO")){
				emailPortList +=	emailPortList.length()!=0? ",'CGO_ALL'":"'CGO_ALL'";
			}
			emailPortList +=	emailPortList.length()!=0? ",'ALL_ALL'":"'ALL_ALL'";
			*/
			while (rs.next()) {		
				
				//20141121 AMEND NOTICE : ȸ   2, 3  ȸ ߰ 
				selFlg = true;
				
				String	routeX	=	StringUtil.checkString(rs.getString("ROUTE_X"));
				emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+StringUtil.checkString(rs.getString("STNFR")));
				emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+StringUtil.checkString(rs.getString("STNTO")));
				emailPortMap	=	portMap_put(emailPortMap,routeX+"_ALL_"+StringUtil.checkString(rs.getString("COMMENT_X")));
				
				//20141121 DAILY_SCH_T.DIV_STN ߰
				String	divStn	=	StringUtil.checkString(rs.getString("DIV_STN"));
				if(!"".equals(divStn)){
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+divStn);
				}
			}
			if(emailPortMap!=null && emailPortMap.size()!=0){//@2013-11-14
				emailPortMap	=	portMap_put(emailPortMap,"ALL_ALL_ALL");				
			}
			
			//20141121 AMEND NOTICE : ȸ   2, 3  ȸ ߰ start
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (!selFlg) {
				stmt = conn.createStatement();
				sql = IroQ460Query.getInstance().selMain2(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					selFlg = true;
					
					String	routeX	=	StringUtil.checkString(rs.getString("ROUTE_X"));
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+StringUtil.checkString(rs.getString("STNFR")));
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+StringUtil.checkString(rs.getString("STNTO")));
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_ALL_"+StringUtil.checkString(rs.getString("COMMENT_X")));
					
					//20141121 DSS_NEW_SCH_T.DIV_STN ÷    ߰  .
				}
				if(emailPortMap!=null && emailPortMap.size()!=0){
					emailPortMap	=	portMap_put(emailPortMap,"ALL_ALL_ALL");				
				}

				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
			}
			
			if (!selFlg) {
				
				stmt = conn.createStatement();
				sql = IroQ460Query.getInstance().selMain3(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					
					selFlg = true;
					
					String	routeX	=	StringUtil.checkString(rs.getString("ROUTE_X"));
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+StringUtil.checkString(rs.getString("STNFR")));
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+StringUtil.checkString(rs.getString("STNTO")));
					emailPortMap	=	portMap_put(emailPortMap,routeX+"_ALL_"+StringUtil.checkString(rs.getString("COMMENT_X")));
					
					//20141121 DAILY_SCH_T.DIV_STN ߰
					String	divStn	=	StringUtil.checkString(rs.getString("DIV_STN"));
					if(!"".equals(divStn)){
						emailPortMap	=	portMap_put(emailPortMap,routeX+"_"+divStn);
					}
				}
				if(emailPortMap!=null && emailPortMap.size()!=0){
					emailPortMap	=	portMap_put(emailPortMap,"ALL_ALL_ALL");				
				}

				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
			}
			//20141121 AMEND NOTICE : ȸ   2, 3  ȸ ߰ end
			
			
			String emailAddr = "";			
			//Email ADDRESS ȸ
			stmt = conn.createStatement();
			//sql = IroQ460Query.getInstance().selEmailAddr(emailPortList);
			sql = IroQ460Query.getInstance().selEmailAddr(portMap_toString(emailPortMap));//@2013-10-xx
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {				
				StringTokenizer st = new StringTokenizer(StringUtil.checkString(rs.getString("ADDR_E")), " ");
				while (st.hasMoreTokens()) {
					String tmp = st.nextToken();
					
					//ADDRESS ߺ ʰ ߰Ѵ.
					if (emailAddr.indexOf(tmp) == -1) {
						if (emailAddr.equals("")) emailAddr = tmp;
						else emailAddr = emailAddr + " " + tmp;
					}
				}
			}			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			hashData.put("EMAIL_ADDR",emailAddr);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ460IropsMsg:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ460IropsMsg:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  * IROPS History Message ȸ Լ. 
	  * @param params IroQ460BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/09/03 
	  */
	public Hashtable selIroQ460HistoryMsg(IroQ460BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//MSG_SEQ_NUM ȸ
			stmt = conn.createStatement();
			sql = IroQ460Query.getInstance().selHistoryMsg(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ460BG entity = new IroQ460BG();
				
				if (rs.getInt("LVL_NO") == 0) entity.setMsgE(StringUtil.checkString(rs.getString("TITLE_E")));
				else entity.setMsgE(StringUtil.checkString(rs.getString("MSG_E")));
				
				entity.setLvlNo(StringUtil.checkString(rs.getString("LVL_NO")));
				entity.setCodeX(StringUtil.checkString(rs.getString("CODE_X")));
				entity.setKorN(StringUtil.checkString(rs.getString("KOR_N")));
				entity.setDssLvlX(StringUtil.checkString(rs.getString("DSS_LVL_X")));
				entity.setTimestamp(StringUtil.checkString(rs.getString("TIMESTAMP")));
				entity.setDssStartDt(StringUtil.checkString(rs.getString("DSS_START_DT")));
				entity.setMsgNo(StringUtil.checkString(rs.getString("MSG_NO")));
				
				listData.add(entity);
			}

			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("HISTORY_LIST", listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ460HistoryMsg:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ460HistoryMsg:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  * IROPS Creation Info & DSS Messenger Msg ߻ ȸ Լ. 
	  * @param params IroQ450BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/09/04 
	  */
	public Hashtable selIroQ450DssMsg(IroQ450BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
		Statement stmt2 = null;
		ResultSet rs2 = null;
	    String sql2 = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//˾ MSG ȸ
			stmt = conn.createStatement();
			sql = IroQ450Query.getInstance().selDssMsg();
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				IroQ450BG entity = new IroQ450BG();
				
				entity.setDssStartDt(StringUtil.checkString(rs.getString("DSS_START_DT")));
				entity.setMsgNo(StringUtil.checkString(rs.getString("MSG_NO")));
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setDssLvlX(StringUtil.checkString(rs.getString("DSS_LVL_X")));
				
				//2009.12.02 ߰ : IROPS Creation Info  شϴ  ȸ
				String dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
				String dssLvlX = StringUtil.checkString(rs.getString("DSS_LVL_X"));
				
				//2012.02.28 ߰
				String msgE = StringUtil.checkString(rs.getString("MSG_E"));
				entity.setMsgE(msgE);
				
				int fltCnt = 0;
				String fltNumList = "";
				
				if (dssLvlX.equals("I") || dssLvlX.equals("R") || dssLvlX.equals("Y")) {
					//ش  ȸ
					stmt2 = conn.createStatement();
					sql2 = IroQ450Query.getInstance().selFltNum(dssStartDt);
					rs2 = stmt2.executeQuery(sql2);
					
					while (rs2.next()) {
						fltCnt++;
						//6 ´.
						if (fltCnt == 1) fltNumList = StringUtil.checkString(rs2.getString("FLT_NUM"));
						else if (fltCnt <= 6) fltNumList = fltNumList + "/" + StringUtil.checkString(rs2.getString("FLT_NUM"));
					}
					if (fltCnt > 6) fltNumList = fltNumList + "/...";
					
					//ü ȯ
					if (stmt2 != null) stmt2.close();
					if (sql2 != null) sql2 = null;
					if (rs2 != null) rs2.close();
				}
				entity.setFltNumList(fltNumList);
				
				listData.add(entity);
			}

			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("DSS_MSG", listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ450DssMsg:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ450DssMsg:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  *  IROPS ܰ Ȯ ȸ Լ. 
	  * @param params IroQ450BG ȸ
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2009/09/07 
	  */
	public String selIroQ450CheckIssue(IroQ450BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//PROCESS_X  SEQ_NUM ȸ
			stmt = conn.createStatement();
			sql = IroQ450Query.getInstance().chkIssue(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				returnValue = StringUtil.checkString(rs.getString("SEQ_NUM"));
			}

			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ450CheckIssue:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ450CheckIssue:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  * Message ȸ Լ. 
	  * @param params IroQ450BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/09/08 
	  */
	public Hashtable selIroQ450Message(IroQ450BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Message ȸ
			stmt = conn.createStatement();
			sql = IroQ450Query.getInstance().selMessage(params);
			rs = stmt.executeQuery(sql);
			
			IroQ450BG entity = new IroQ450BG();
			
			if (rs.next()) {
				entity.setTitleE(StringUtil.checkString(rs.getString("TITLE_E")));
				entity.setMsgE(StringUtil.checkString(rs.getString("MSG_E")));
				entity.setCodeX(StringUtil.checkString(rs.getString("CODE_X")));
				entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
				entity.setSchDepD(StringUtil.checkString(rs.getString("SCH_DEP_D")));
				entity.setTimestamp(StringUtil.checkString(rs.getString("TIMESTAMP")));
				entity.setLvlNo(StringUtil.checkString(rs.getString("LVL_NO")));
				//20160108 DSS_LVL_X ߰
				entity.setDssLvlX(StringUtil.checkString(rs.getString("DSS_LVL_X")));
				entity.setKorN(StringUtil.checkString(rs.getString("KOR_N")));//@2017-10-30
			}

			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("MESSAGE_INFO", entity);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ450Message:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ450Message:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  * DSS_LINK_X, DSS_COMPLETE_Y ȸ Լ. 
	  * @param params IroQ450BG ȸ
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2009/09/08 
	  */
	public String selIroQ450CheckComplete(IroQ450BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//DSS_LINK_X, DSS_COMPLETE_Y ȸ
			stmt = conn.createStatement();
			sql = IroQ450Query.getInstance().chkComplete(params);
			rs = stmt.executeQuery(sql);
			
			String dssLinkX = "";
			String dssCompleteY = "";
			
			if (rs.next()) {
				dssLinkX = StringUtil.checkString(rs.getString("DSS_LINK_X"));
				dssCompleteY = StringUtil.checkString(rs.getString("DSS_COMPLETE_Y"));
			}

			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			if (dssLinkX.equals("L") && dssCompleteY.equals("Y")) returnValue = "1"; //̹ IROPS Ȳ Ǿϴ.
			else if (dssLinkX.equals("L") && dssCompleteY.equals("N")) returnValue = "2"; //̹ Issue Ǿ Դϴ.
			else returnValue = "3"; //OK
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ450CheckComplete:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ450CheckComplete:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  * DSS Messenger Է Լ. 
	  * @param params IroQ450BG ȸ
	  * @return String returnValue
	  * @exception Exception
	  * @author Copyright (c) 2009/09/10 
	  */
	public String insIroQ450Message(IroQ450BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    String returnValue = "";
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Auto Commit Mode False
			conn.setAutoCommit(false);
			
			String msgNo = "";
			String lvlNo = "";
			
			/*
			1. mode = 'X' : ο ޼ Էϴ  (DSS Messenger ȭ MSG ư)
			2. mode = 'A' : FLT_NUM, SCH_DEP_D     ޼ reply ϴ  (DSS_START_DT, TITLE_E, MSG_NO, LVL_NO )
			3. mode = 'B' : FLT_NUM, SCH_DEP_D   ־  ޼ reply ϴ 
			*/
			if (params.getMode().equals("X")) {
				
				String dssStartDt = "";
				
				//1. FLT_NUM, SCH_DEP_D ȸؼ  DSS_START_DT .
				if (!params.getFltNum().equals("") && !params.getSchDepD().equals("")) {
					
					//DSS_START_DT ϴ FLT_NUM SCH_DEP_D ȸ
					stmt = conn.createStatement();
					sql = IroQ450Query.getInstance().selDssStartDt(params);
					rs = stmt.executeQuery(sql);
					
					if (rs.next()) dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					if (rs != null) rs.close();
				}
				
				//2. DSS_START_DT, TITLE_E, MSG_NO, LVL_NO .
				if (dssStartDt.equals("")) { //ο DSS_START_DT ȴ.
					
					//DSS_START_DT ȸ
					stmt = conn.createStatement();
					sql = IroA310Query.getInstance().selDssStartDt();
					rs = stmt.executeQuery(sql);
					
					String tmpDt1 = "";
					String tmpDt2 = "";
					String tmpDt3 = "";
					
					if (rs.next()) {
						tmpDt1 = StringUtil.checkString(rs.getString("DSS_START_DT1"));
						tmpDt2 = StringUtil.checkString(rs.getString("DSS_START_DT2"));
						tmpDt3 = StringUtil.checkString(rs.getString("DSS_START_DT3"));
					}
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					if (rs != null) rs.close();
					
					//ߺ ȸ 1
					stmt = conn.createStatement();
					sql = IroA310Query.getInstance().chkDssStartDt("DSS_IROPS_T", tmpDt1);
					rs = stmt.executeQuery(sql);
					
					boolean chk1_1 = false;
					if (rs.next()) chk1_1 = true;
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					if (rs != null) rs.close();
					
					//ߺ ȸ 2
					stmt = conn.createStatement();
					sql = IroA310Query.getInstance().chkDssStartDt("DSS_MSG_HEAD_T", tmpDt1);
					rs = stmt.executeQuery(sql);
					
					boolean chk1_2 = false;
					if (rs.next()) chk1_2 = true;
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					if (rs != null) rs.close();
					
					//Ѵ ش  Ű Ȯ.
					if (!chk1_1 && !chk1_2) {
						
						dssStartDt = tmpDt1;
						
					} else { //Ѱ شǸ  Ű Ϸ .
						
						//ߺ ȸ 1
						stmt = conn.createStatement();
						sql = IroA310Query.getInstance().chkDssStartDt("DSS_IROPS_T", tmpDt2);
						rs = stmt.executeQuery(sql);
						
						boolean chk2_1 = false;
						if (rs.next()) chk2_1 = true;
						
						//ü ȯ
						if (stmt != null) stmt.close();
						if (sql != null) sql = null;
						if (rs != null) rs.close();
						
						//ߺ ȸ 2
						stmt = conn.createStatement();
						sql = IroA310Query.getInstance().chkDssStartDt("DSS_MSG_HEAD_T", tmpDt2);
						rs = stmt.executeQuery(sql);
						
						boolean chk2_2 = false;
						if (rs.next()) chk2_2 = true;
						
						//ü ȯ
						if (stmt != null) stmt.close();
						if (sql != null) sql = null;
						if (rs != null) rs.close();
						
						//Ѵ ش  Ű Ȯ.
						if (!chk2_1 && !chk2_2) {
							
							dssStartDt = tmpDt2;
							
						} else { //Ѱ شǸ  Ű Ϸ .
							
							//ߺ ȸ 1
							stmt = conn.createStatement();
							sql = IroA310Query.getInstance().chkDssStartDt("DSS_IROPS_T", tmpDt3);
							rs = stmt.executeQuery(sql);
							
							boolean chk3_1 = false;
							if (rs.next()) chk3_1 = true;
							
							//ü ȯ
							if (stmt != null) stmt.close();
							if (sql != null) sql = null;
							if (rs != null) rs.close();
							
							//ߺ ȸ 2
							stmt = conn.createStatement();
							sql = IroA310Query.getInstance().chkDssStartDt("DSS_MSG_HEAD_T", tmpDt3);
							rs = stmt.executeQuery(sql);
							
							boolean chk3_2 = false;
							if (rs.next()) chk3_2 = true;
							
							//ü ȯ
							if (stmt != null) stmt.close();
							if (sql != null) sql = null;
							if (rs != null) rs.close();
							
							//Ѵ ش  Ű Ȯ.
							if (!chk3_1 && !chk3_2) {
								
								dssStartDt = tmpDt3;
								
							} else { //3ϰ ȵǸ Error ߻.
								
								throw new BusinessException(" Ŀ ٽ õ ֽñ ٶϴ.");
							}
						}
					}
					
					params.setDssStartDt(dssStartDt); //  DSS_START_DT 
					msgNo = "00";
					lvlNo = "0";
					
					//DSS_MSG_HEAD_T Է
					stmt = conn.createStatement();
					sql = IroQ450Query.getInstance().insDssMsgHeadT(params);
					int insFlg = stmt.executeUpdate(sql);
					
					if (insFlg != 1) throw new BusinessException("Send Exception!!");
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					
				} else { //ȸ  DSS_START_DT Ѵ.
					
					params.setDssStartDt(dssStartDt);
					params.setMsgNo("00");
					params.setLvlNo("0");
					
					//MSG_NO, LVL_NO ϱ
					stmt = conn.createStatement();
					sql = IroQ450Query.getInstance().selMsgNo(params);
					rs = stmt.executeQuery(sql);
					
					String tmpMsgNo = "";
					
					if (rs.next()) tmpMsgNo = StringUtil.checkString(rs.getString("TMP_MSG_NO"));
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					if (rs != null) rs.close();
					
					lvlNo = String.valueOf(Integer.parseInt(params.getLvlNo()) + 1).toString();
					
					if (params.getLvlNo().equals("0")) msgNo = tmpMsgNo.substring(0,2);
					else msgNo = params.getMsgNo() + tmpMsgNo.substring(0,2);
				}
				
			} else { //mode = 'A' or 'B'
				
				//1. IROPS Ȳ ȸ
				stmt = conn.createStatement();
				sql = IroQ450Query.getInstance().selIropsStatus(params);
				rs = stmt.executeQuery(sql);
				
				boolean status = false;
				String dssLinkX = "";
				
				if (rs.next()) {
					status = true;
					dssLinkX = StringUtil.checkString(rs.getString("DSS_LINK_X"));
				}

				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				//20160108 
				//if (!status) throw new BusinessException("̹ IROPS Ȳ Ǿϴ.");
				if (!status && !"Y".equals(params.getDssLvlXFlag())) throw new BusinessException("̹ IROPS Ȳ Ǿϴ.");
				
				//2. MSG_NO, LVL_NO ϱ
				stmt = conn.createStatement();
				sql = IroQ450Query.getInstance().selMsgNo(params);
				rs = stmt.executeQuery(sql);
				
				String tmpMsgNo = "";
				
				if (rs.next()) tmpMsgNo = StringUtil.checkString(rs.getString("TMP_MSG_NO"));
				
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
				
				lvlNo = String.valueOf(Integer.parseInt(params.getLvlNo()) + 1).toString();
				
				if (params.getLvlNo().equals("0")) msgNo = tmpMsgNo.substring(0,2);
				else msgNo = params.getMsgNo() + tmpMsgNo.substring(0,2);
				
				//3. mode = 'A' ̰, FLT_NUM, SCH_DEP_D  Է   DSS_MSG_HEAD_T ־ .
				if (params.getMode().equals("A") && !params.getFltNum().equals("") && !params.getSchDepD().equals("")) {
					
					//DSS_START_DT ϴ FLT_NUM SCH_DEP_D ȸ
					stmt = conn.createStatement();
					sql = IroQ450Query.getInstance().selDssStartDt(params);
					rs = stmt.executeQuery(sql);
					
					boolean chk = false;
					String dssStartDt = "";
					
					if (rs.next()) {
						chk = true;
						dssStartDt = StringUtil.checkString(rs.getString("DSS_START_DT"));
					}

					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
					if (rs != null) rs.close();
					
					if (chk && !params.getDssStartDt().equals(dssStartDt)) throw new BusinessException(" ٸ MSG Դϴ.");
					
					//DSS_MSG_HEAD_T FLT_NUM SCH_DEP_D Է
					stmt = conn.createStatement();
					sql = IroQ450Query.getInstance().updFltNum(params);
					int updFlg = stmt.executeUpdate(sql);
					
					if (updFlg != 1) throw new BusinessException("Send Exception!!");
					
					//ü ȯ
					if (stmt != null) stmt.close();
					if (sql != null) sql = null;
				}	
			}
			
			//*************************************************************************************
			// DSS_MSG_DETAIL_T  ޼ Էϱ.
			stmt = conn.createStatement();
			
			//20160108 
			//sql = IroQ450Query.getInstance().insDssMsgDetailT(params, msgNo, lvlNo);
			if(params.getDssLvlXFlag() != null && "Y".equals(params.getDssLvlXFlag())) {
				sql = IroQ450Query.getInstance().insDssMsgDetailTDssLvlXA(params, msgNo, lvlNo);
			} else {
				sql = IroQ450Query.getInstance().insDssMsgDetailT(params, msgNo, lvlNo);
			}
			
			
			int msgFlg = stmt.executeUpdate(sql);
			
			if (msgFlg != 1) throw new BusinessException("Send Exception!!");
		
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			//Data Commit
			conn.commit();
			
			returnValue = "Y";
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:insIroQ450Message:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(BusinessException be) {
			if (conn != null) try {conn.rollback(); } catch(Exception ea) {}
			Logger.debug.println("[BASE:IroAllSLBean:insIroQ450Message:BusinessException] "+((BusinessException)be).getMessage());
			throw new BusinessException(((BusinessException)be).getMessage());
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:insIroQ450Message:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return returnValue;
	}//end of function
	
	/**
	  * FLT Progress Information ȸ Լ. 
	  * @param params IroQ470BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/09/15 
	  */
	public Hashtable selIroQ470Main(IroQ470BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
		Statement stmt2 = null;
		ResultSet rs2 = null;
	    String sql2 = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    
	    IroQ470BG fltInfo = new IroQ470BG();
	    List fltList = new LinkedList();
	    IroQ470BG nextFltInfo = new IroQ470BG();//2012.03.15 ߰
	    IroQ470BG categoryInfo = new IroQ470BG();
	    List crewList = new LinkedList();
	    IroQ470BG dcsInfo = new IroQ470BG();
	    List aircraftList = new LinkedList();
	    List paxList1 = new LinkedList();
	    List paxList2 = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//2012.03.15 ߰ : ˻ κп 
			/*
			   1. ˻ ˾   Ѿ SCH_DEP_DT, FLT_NUM 
			      ش Ÿ ˻ ΰ
			       ִ  Ÿ Ѵ    
			   */
			String searchY = StringUtil.checkString(params.getSearchY());
			if(searchY.equals("Y")){
				params.setFirstLegFltDt("20"+params.getFirstLegFltDt());
				
				stmt = conn.createStatement();
				sql = IroQ470Query.getInstance().selSearchFltInfo(params);
				rs = stmt.executeQuery(sql);
				int cnt = 0;
				while(rs.next()){					
					params.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_DT")));
					params.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
					params.setStnto(StringUtil.checkString(rs.getString("STNTO")));
					params.setRegno(StringUtil.checkString(rs.getString("REGNO")));
					cnt++;
				}
				if(cnt == 0) throw new BusinessException("˻ Ÿ ϴ.");
				if(cnt > 1) throw new BusinessException("ش ˻ Ÿ ΰ ̻Դϴ.");
				
				if(rs!=null) rs.close();
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
			}
			
			//2012.03.15 ߰ []
			
			//**************************************************************************************
			//1. FLT INFORMATION
			stmt = conn.createStatement();
			sql = IroQ470Query.getInstance().selFltInfo(params);
			rs = stmt.executeQuery(sql);
			
			String firstLegFltDt = "";
			String schArvDtLoc = "";
			String regno = "";
			
			while (rs.next()) {
				String tmpStnfr = StringUtil.checkString(rs.getString("STNFR"));
				String tmpStnto = StringUtil.checkString(rs.getString("STNTO"));
				
				if (params.getStnfr().equals(tmpStnfr) && params.getStnto().equals(tmpStnto)) {
					
					fltInfo.setFltNum("KE"+params.getFltNum());
					fltInfo.setSchDt(StringUtil.checkString(rs.getString("SCH_DT")));
					fltInfo.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
					fltInfo.setAcver(StringUtil.checkString(rs.getString("ACVER")));
					fltInfo.setRegno(StringUtil.checkString(rs.getString("REGNO")));
					fltInfo.setStnfr(params.getStnfr());
					fltInfo.setStnto(params.getStnto());
					
					regno = StringUtil.checkString(rs.getString("REGNO"));
					firstLegFltDt = StringUtil.checkString(rs.getString("FIRST_LEG_FLT_DT"));
					schArvDtLoc = StringUtil.checkString(rs.getString("SCH_ARV_DT_LOC"));
					
					String domIntX = StringUtil.GetDomIntX(params.getFltNum(), StringUtil.checkString(rs.getString("KACTYP")));
					if (domIntX.equals("CGO")) {
						fltInfo.setCfg("0 / 0 / 0");
						fltInfo.setRsvn("0 / 0 / 0");
						fltInfo.setChkin("0 / 0 / 0");
					} else {
						fltInfo.setCfg(StringUtil.checkString(rs.getString("CFG")));
						fltInfo.setRsvn(StringUtil.checkString(rs.getString("RSVN")));
						fltInfo.setChkin(StringUtil.checkString(rs.getString("CHK_IN")));
					}
				}
				
				IroQ470BG entity = new IroQ470BG();
				
				entity.setSchDt(StringUtil.checkString(rs.getString("SCH_DT")));
				entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
				entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
				entity.setStd(StringUtil.checkString(rs.getString("STD")));
				entity.setSta(StringUtil.checkString(rs.getString("STA")));
				String[] arrDep = StringUtil.StatusTime("D", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), StringUtil.checkString(rs.getString("ETD")), StringUtil.checkString(rs.getString("ATD")), "");
				String[] arrArv = StringUtil.StatusTime("A", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), StringUtil.checkString(rs.getString("ETA")), StringUtil.checkString(rs.getString("ATA")), "");
				entity.setEtd(arrDep[0]);
				entity.setAtd(arrDep[1]);
				entity.setToff(StringUtil.checkString(rs.getString("TKOF_T")));
				entity.setEta(arrArv[0]);
				entity.setTdwn(StringUtil.checkString(rs.getString("LAND_T")));
				entity.setAta(arrArv[1]);
				if (!StringUtil.checkString(rs.getString("DEL_RC1")).equals("")) entity.setDel1(StringUtil.checkString(rs.getString("DEL_RC1")) + " / " + StringUtil.checkString(rs.getString("DEL_DUR1")));
				else entity.setDel1("");
				if (!StringUtil.checkString(rs.getString("DEL_RC2")).equals("")) entity.setDel2(StringUtil.checkString(rs.getString("DEL_RC2")) + " / " + StringUtil.checkString(rs.getString("DEL_DUR2")));
				else entity.setDel2("");
				entity.setDepSpot(StringUtil.checkString(rs.getString("SPOT_OUT")));
				entity.setArrSpot(StringUtil.checkString(rs.getString("SPOT_IN")));
				
				fltList.add(entity);
			}

			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("FLT_INFO", fltInfo);
			hashData.put("FLT_LIST", fltList);
			
			//߿ϴ!!!!
			params.setFirstLegFltDt(firstLegFltDt);
			params.setSchArvDtLoc(schArvDtLoc);
			params.setRegno(regno);
			
			//2012.03.15 ߰ : ش   ǥ
            //**************************************************************************************
			//1.5 NEXT FLT INFORMATION
			params.setSchDepDt(params.getSchDepDt());
			
			stmt = conn.createStatement();
			sql = IroQ470Query.getInstance().selNextFltInfo(params);
			rs = stmt.executeQuery(sql);
			
			if(rs.next()){//ù° Ÿ 
				nextFltInfo.setFltNum(StringUtil.checkString("KE"+rs.getString("FLT_NUM")));
				//nextFltInfo.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_DT")));//2012.06.05 ñ 
				nextFltInfo.setSchDepDtLoc(StringUtil.checkString(rs.getString("SCH_DEP_DT_LOC")));
				nextFltInfo.setStd(StringUtil.checkString(rs.getString("STD")));
				nextFltInfo.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
				nextFltInfo.setStnto(StringUtil.checkString(rs.getString("STNTO")));
			}
            //ü ȯ
			if (rs != null) rs.close();
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			
			hashData.put("NEXT_FLT", nextFltInfo);
			// ===================2012.03.15 ߰ 
			
			//**************************************************************************************
			//2. CATEGORY INFORMATION
			stmt = conn.createStatement();
			sql = IroQ470Query.getInstance().selCategoryInfo(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				categoryInfo.setCat3Date(StringUtil.checkString(rs.getString("CAT3_DATE")));
				categoryInfo.setCat2Date(StringUtil.checkString(rs.getString("CAT2_DATE")));
				categoryInfo.setCatLast(StringUtil.checkString(rs.getString("CAT_LAST")));
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("CATEGORY_INFO", categoryInfo);
			
			//**************************************************************************************
			//3. CREW INFORMATION
			stmt = conn.createStatement();
			sql = IroQ470Query.getInstance().selCrewInfo(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				String tmpStaffNum = StringUtil.checkString(rs.getString("STAFF_NUM"));
				
				IroQ470BG entity = new IroQ470BG();
				
				entity.setStaffNum(StringUtil.checkString(rs.getString("STAFF_NUM")));
				entity.setEngName(StringUtil.checkString(rs.getString("ENG_NAME")));
				entity.setRank(StringUtil.checkString(rs.getString("RANK")));
				entity.setDuty(StringUtil.checkString(rs.getString("DUTY")));
				entity.setPrevInfo(StringUtil.checkString(rs.getString("PREV_INFO")));
				entity.setNextInfo(StringUtil.checkString(rs.getString("NEXT_INFO")));
				
				String lastInfo = "";
				
				if (!tmpStaffNum.equals("")) {
					//CREW LAST FLT INFO
					stmt2 = conn.createStatement();
					sql2 = IroQ470Query.getInstance().selCrewInfoLast(tmpStaffNum);
					rs2 = stmt2.executeQuery(sql2);
					
					if (rs2.next()) lastInfo = StringUtil.checkString(rs2.getString("LAST_INFO"));
					
					//ü ȯ
					if (stmt2 != null) stmt2.close();
					if (sql2 != null) sql2 = null;
					if (rs2 != null) rs2.close();
				}
				
				entity.setLastInfo(lastInfo);
				
				crewList.add(entity);
			}

			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("CREW_LIST", crewList);
			
			//**************************************************************************************
			//4. DCS INFORMATION
			stmt = conn.createStatement();
			sql = IroQ470Query.getInstance().selDcsInfo(params);
			rs = stmt.executeQuery(sql);
			
			if (rs.next()) {
				//double payLoad = rs.getDouble("Act_Payload_q") * 2.20459; <- Detail FLT Status

				dcsInfo.setCfg(StringUtil.checkString(rs.getString("CFG")));
				dcsInfo.setRsvn(StringUtil.checkString(rs.getString("RSVN")));
				dcsInfo.setChkin(StringUtil.checkString(rs.getString("CHK_IN")));
				dcsInfo.setCrew(StringUtil.checkString(rs.getString("CREW")));
				
				DecimalFormat df = new DecimalFormat("#,##0");
				dcsInfo.setPayload(df.format(rs.getDouble("MAX_PAYLOAD_Q")));
				dcsInfo.setAcl(df.format(rs.getDouble("ACT_PAYLOAD_Q")));
				dcsInfo.setBew(df.format(rs.getDouble("ACT_BEW_Q")));
				dcsInfo.setSow(df.format(rs.getDouble("ACT_SOW_Q")));
				dcsInfo.setZfw(df.format(rs.getDouble("ACT_ZFW_Q")));
				dcsInfo.setTow(df.format(rs.getDouble("ACT_TOW_Q")));
				dcsInfo.setLdw(df.format(rs.getDouble("EST_LDW_Q")));
				dcsInfo.setTof(df.format(rs.getDouble("TOF_Q")));
				dcsInfo.setTif(df.format(rs.getDouble("TIF_Q")));
				dcsInfo.setCgoWt(df.format(rs.getDouble("CGO_WT_Q")));
				dcsInfo.setMailWt(df.format(rs.getDouble("MAIL_WT_Q")));
				dcsInfo.setBagWt(df.format(rs.getDouble("BAG_WT_Q")));
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("DCS_INFO", dcsInfo);
			
			//**************************************************************************************
			/* 
			//5. AIRCRAFT CONNECTION INFORMATION
			if (!params.getRegno().equals("ZZZZZ")) { //REGNO='ZZZZZ' ϶ ȸ.
			
				stmt = conn.createStatement();
				sql = IroQ470Query.getInstance().selAircraftConnInfo(params);
				rs = stmt.executeQuery(sql);
				
				while (rs.next()) {
					IroQ470BG entity = new IroQ470BG();
					
					entity.setFltNum("KE"+StringUtil.checkString(rs.getString("FLT_NUM")));
					entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
					entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
					entity.setStd(StringUtil.checkString(rs.getString("STD")));
					entity.setSta(StringUtil.checkString(rs.getString("STA")));
					String[] arrDep = StringUtil.StatusTime("D", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), StringUtil.checkString(rs.getString("ETD")), StringUtil.checkString(rs.getString("ATD")), "");
					String[] arrArv = StringUtil.StatusTime("A", StringUtil.checkString(rs.getString("DEP_STS")), StringUtil.checkString(rs.getString("ARV_STS")), StringUtil.checkString(rs.getString("ETA")), StringUtil.checkString(rs.getString("ATA")), "");
					entity.setEtd(arrDep[0]);
					entity.setAtd(arrDep[1]);
					entity.setToff(StringUtil.checkString(rs.getString("TKOF_T")));
					entity.setEta(arrArv[0]);
					entity.setTdwn(StringUtil.checkString(rs.getString("LAND_T")));
					entity.setAta(arrArv[1]);
					entity.setDepSpot(StringUtil.checkString(rs.getString("SPOT_OUT")));
					entity.setArrSpot(StringUtil.checkString(rs.getString("SPOT_IN")));
					
					aircraftList.add(entity);
				}
	
				//ü ȯ
				if (stmt != null) stmt.close();
				if (sql != null) sql = null;
				if (rs != null) rs.close();
			}
			
			hashData.put("AIRCRAFT_LIST", aircraftList);
			*/
			//**************************************************************************************
			//6. PAX CONNECTION INFORMATION
			
			//DEP_ARV_X = 'D'
			stmt = conn.createStatement();
			sql = IroQ470Query.getInstance().selPaxConnInfo1(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				IroQ470BG entity = new IroQ470BG();
				
				entity.setFltNum(StringUtil.checkString(rs.getString("TRANS_ARLN_CD"))+StringUtil.checkString(rs.getString("TRANS_FLT_NUM")));
				entity.setStnto(StringUtil.checkString(rs.getString("TRANS_STN_C")));
				if (StringUtil.checkString(rs.getString("TRANS_DT")).length() >= 10) entity.setTransDt(StringUtil.checkString(rs.getString("TRANS_DT")).substring(0,10));
				else entity.setTransDt("");
				//2009.12.01  : BOOK  
				//entity.setBook(StringUtil.checkString(rs.getString("F_BOOK_Q")) + " / " + StringUtil.checkString(rs.getString("C_BOOK_Q")) + " / " + StringUtil.checkString(rs.getString("Y_BOOK_Q")));
				entity.setBook(StringUtil.checkString(rs.getString("BOOK_Q")));
				entity.setChkin(StringUtil.checkString(rs.getString("F_CHKIN_Q")) + " / " + StringUtil.checkString(rs.getString("C_CHKIN_Q")) + " / " + StringUtil.checkString(rs.getString("Y_CHKIN_Q")));
				entity.setBagCnt(StringUtil.checkString(rs.getString("BAG_Q")));
				
				//2012.05.30 ߰
				entity.setFBookQ(StringUtil.checkString(rs.getString("F_BOOK_Q")));
				entity.setCBookQ(StringUtil.checkString(rs.getString("C_BOOK_Q")));
				entity.setYBookQ(StringUtil.checkString(rs.getString("Y_BOOK_Q")));
				entity.setFChkinQ(StringUtil.checkString(rs.getString("F_CHKIN_Q")));
				entity.setCChkinQ(StringUtil.checkString(rs.getString("C_CHKIN_Q")));
				entity.setYChkinQ(StringUtil.checkString(rs.getString("Y_CHKIN_Q")));
				
				if (StringUtil.checkString(rs.getString("TRANS_DT")).length() == 16) entity.setStaAta(StringUtil.checkString(rs.getString("TRANS_DT")).substring(11,16));
				else entity.setStaAta("");
				
				paxList1.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("PAX_LIST1", paxList1);
			
			//DEP_ARV_X = 'A'
			stmt = conn.createStatement();
			sql = IroQ470Query.getInstance().selPaxConnInfo2(params);
			rs = stmt.executeQuery(sql);
			
			//2009.12.01  : STD    ش. (STD   '00:00'  )
			List tmpList = new LinkedList();
			TreeSet tSet = new TreeSet();
			
			while (rs.next()) {
				
				IroQ470BG entity = new IroQ470BG();
				
				entity.setFltNum(StringUtil.checkString(rs.getString("TRANS_ARLN_CD"))+StringUtil.checkString(rs.getString("TRANS_FLT_NUM")));
				entity.setStnto(StringUtil.checkString(rs.getString("TRANS_STN_C")));
				if (StringUtil.checkString(rs.getString("TRANS_DT")).length() >= 10) entity.setTransDt(StringUtil.checkString(rs.getString("TRANS_DT")).substring(0,10));
				else entity.setTransDt("");
				//2009.12.01  : BOOK  
				//entity.setBook(StringUtil.checkString(rs.getString("F_BOOK_Q")) + " / " + StringUtil.checkString(rs.getString("C_BOOK_Q")) + " / " + StringUtil.checkString(rs.getString("Y_BOOK_Q")));
				entity.setBook(StringUtil.checkString(rs.getString("BOOK_Q")));
				entity.setChkin(StringUtil.checkString(rs.getString("F_CHKIN_Q")) + " / " + StringUtil.checkString(rs.getString("C_CHKIN_Q")) + " / " + StringUtil.checkString(rs.getString("Y_CHKIN_Q")));
				entity.setBagCnt(StringUtil.checkString(rs.getString("BAG_Q")));
				
                //	2012.06.05 ߰
				entity.setFBookQ(StringUtil.checkString(rs.getString("F_BOOK_Q")));
				entity.setCBookQ(StringUtil.checkString(rs.getString("C_BOOK_Q")));
				entity.setYBookQ(StringUtil.checkString(rs.getString("Y_BOOK_Q")));
				entity.setFChkinQ(StringUtil.checkString(rs.getString("F_CHKIN_Q")));
				entity.setCChkinQ(StringUtil.checkString(rs.getString("C_CHKIN_Q")));
				entity.setYChkinQ(StringUtil.checkString(rs.getString("Y_CHKIN_Q")));
				
				String transDt = StringUtil.checkString(rs.getString("TRANS_DT"));
				String transArlnCd = StringUtil.checkString(rs.getString("TRANS_ARLN_CD"));
				String transFltNum = StringUtil.checkString(rs.getString("TRANS_FLT_NUM"));
				String transStnC = StringUtil.checkString(rs.getString("TRANS_STN_C"));
				
				//String std = "";
				String hh24mi = "";
				
				if (transArlnCd.equals("KE")) {
					
					//TRANS_ARLN_CD = 'KE' ϶
					stmt2 = conn.createStatement();
					sql2 = IroQ470Query.getInstance().selTransArlnCdKE(params.getSchArvDtLoc(), transDt, transFltNum, transStnC);
					rs2 = stmt2.executeQuery(sql2);
					
					if (rs2.next()) hh24mi = StringUtil.checkString(rs2.getString("SCH_DEP_DT_LOC"));
					
					//ü ȯ
					if (stmt2 != null) stmt2.close();
					if (sql2 != null) sql2 = null;
					if (rs2 != null) rs2.close();
					
				} else if (params.getStnto().equals("ICN")) {
					
					//STNTO = 'ICN' ϶
					stmt2 = conn.createStatement();
					sql2 = IroQ470Query.getInstance().selStntoICN(params.getSchArvDtLoc(), transDt, transArlnCd, transFltNum);
					rs2 = stmt2.executeQuery(sql2);
					
					if (rs2.next()) hh24mi = StringUtil.checkString(rs2.getString("SCH_DT_LOC"));
					
					//ü ȯ
					if (stmt2 != null) stmt2.close();
					if (sql2 != null) sql2 = null;
					if (rs2 != null) rs2.close();
				}
				
				entity.setStaAta(hh24mi);
				
				//STD   '00:00' .
				String sortKey = "";
				String hh = "00";
				String mi = "00";
				if (!hh24mi.equals("")) {
					hh = hh24mi.substring(0,2);
					mi = hh24mi.substring(3,5);
				}
				sortKey = transDt.substring(0,4)+transDt.substring(5,7)+transDt.substring(8,10)+hh+mi;
				entity.setSortKey(sortKey);
				
				tSet.add(sortKey);
				tmpList.add(entity);
			}
			
			//tSet <---- KEY(YYYYMMDDHH24MI)  . (KEY ߺ ҰϹǷ ߺ  ü  ̰   ̴)
			//tmpList <----  KEY  ü Ͱ  . (KEY ߺ )
			//paxList2 <----  ü ͸ 
			
			if (tSet != null) {
				Object[] obj = tSet.toArray();
				for (int i=0; i<obj.length; i++) {
					for (int j=0; j<tmpList.size(); j++) {
						if (((IroQ470BG)tmpList.get(j)).getSortKey().equals(String.valueOf(obj[i]).toString())) {
							paxList2.add((IroQ470BG)tmpList.get(j));
						}
					}
				}
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("PAX_LIST2", paxList2);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ470Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		}
	  	//2012.03.15 : BusinessException ߰ : ˻  Ÿ  ..
	  	catch(BusinessException be){
			throw new BusinessException(be.getMessage());
		} 
	  	catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ470Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if (cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try { conn.close(); } catch(Exception e) {}
			if (rs != null) try { rs.close(); } catch(Exception e) {}
			if (stmt != null) try { stmt.close(); } catch(Exception e) {}
			if (rs2 != null) try { rs2.close(); } catch(Exception e) {}
			if (stmt2 != null) try { stmt2.close(); } catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/**
	  * Station Statistics ȸԼ. 
	  * @param params IroQ510BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/09/28 
	  */
	public Hashtable selIroQ510Main(IroQ510BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Station Statistics ȸ
			stmt = conn.createStatement();
			sql = IroQ510Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				IroQ510BG entity = new IroQ510BG();
				
				entity.setStation(StringUtil.checkString(rs.getString("STNFR")));
				entity.setTotalSum(String.valueOf(rs.getInt("TOTAL")).toString());
				entity.setDlaSum(String.valueOf(rs.getInt("DLA")).toString());
				entity.setChgSum(String.valueOf(rs.getInt("CHG")).toString());
				entity.setCnlSum(String.valueOf(rs.getInt("CNL")).toString());
				entity.setRtrSum(String.valueOf(rs.getInt("RTR")).toString());
				entity.setDivSum(String.valueOf(rs.getInt("DIV")).toString());
				entity.setNewSum(String.valueOf(rs.getInt("NEW")).toString());
				
				/*if (StringUtil.checkString(rs.getString("TOTAL")).equals("")) entity.setTotalSum("0");
				else entity.setTotalSum(StringUtil.checkString(rs.getString("TOTAL")));
				if (StringUtil.checkString(rs.getString("DLA")).equals("")) entity.setDlaSum("0");
				else entity.setDlaSum(StringUtil.checkString(rs.getString("DLA")));
				if (StringUtil.checkString(rs.getString("CHG")).equals("")) entity.setChgSum("0");
				else entity.setChgSum(StringUtil.checkString(rs.getString("CHG")));
				if (StringUtil.checkString(rs.getString("CNL")).equals("")) entity.setCnlSum("0");
				else entity.setCnlSum(StringUtil.checkString(rs.getString("CNL")));
				if (StringUtil.checkString(rs.getString("RTR")).equals("")) entity.setRtrSum("0");
				else entity.setRtrSum(StringUtil.checkString(rs.getString("RTR")));
				if (StringUtil.checkString(rs.getString("DIV")).equals("")) entity.setDivSum("0");
				else entity.setDivSum(StringUtil.checkString(rs.getString("DIV")));
				if (StringUtil.checkString(rs.getString("NEW")).equals("")) entity.setNewSum("0");
				else entity.setNewSum(StringUtil.checkString(rs.getString("NEW")));*/
				
				listData.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("STATION_STA",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ510Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ510Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	
	/**
	  * Desk Interactive Statistics ȸԼ. 
	  * @param params IroQ520BG ȸ
	  * @return Hashtable ȸ Data
	  * @exception Exception
	  * @author Copyright (c) 2009/09/28 
	  */
	public Hashtable selIroQ520Main(IroQ520BG params) throws BusinessException {
		//ڿ
		Connection conn = null;
		ConnectionResource cr = null;
		Statement stmt = null;
		ResultSet rs = null;
	    String sql = null;
	    
	    //Return ü
	    Hashtable hashData = new Hashtable();
	    List listData = new LinkedList();
	   
	    try {
	   		//DB 
			cr = new ToolConnectionResource();
			conn = cr.getConnection();
			
			//Desk Interactive Statistics ȸ
			stmt = conn.createStatement();
			sql = IroQ520Query.getInstance().selMain(params);
			rs = stmt.executeQuery(sql);
			
			while (rs.next()) {
				
				IroQ520BG entity = new IroQ520BG();
				
				entity.setDesk(StringUtil.checkString(rs.getString("CODE_X")));
				entity.setAvgDur(StringUtil.secTohms(rs.getInt("AVG_T")));
				entity.setMinDur(StringUtil.secTohms(rs.getInt("MIN_T")));
				entity.setMaxDur(StringUtil.secTohms(rs.getInt("MAX_T")));
				entity.setCaseNum(String.valueOf(rs.getInt("CASE_C")).toString());
				entity.setOpinion(String.valueOf(rs.getInt("OPINION_C")).toString());
				entity.setObjection(String.valueOf(rs.getInt("NOT_C")).toString());
				entity.setNoAction(String.valueOf(rs.getInt("NO_C")).toString());
				
				listData.add(entity);
			}
			
			//ü ȯ
			if (stmt != null) stmt.close();
			if (sql != null) sql = null;
			if (rs != null) rs.close();
			
			hashData.put("DESK_STA",listData);
			
	  	} catch(SQLException se) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ520Main:Exception] "+((SQLException)se).getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		} catch(Exception e) {
			Logger.debug.println("[BASE:IroAllSLBean:selIroQ520Main:Exception] "+((Exception)e).getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		} finally {
			//Ǿ  ڿ ȯѴ
			if ( cr != null) try { cr.release(); } catch(Exception e) {}
			if (conn != null) try {conn.close(); } catch(Exception e) {}
			if (rs != null) try {rs.close(); } catch(Exception e) {}
			if (stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}//end of function
	
	/*-------------------------------------------------------------------	@2013-10-xx	selIroQ710Main
	----------------------------------------------------------------------	*/
	public Hashtable selIroQ710Main(IroQ710BG params) throws BusinessException {
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		ڿ		
		ConnectionResource			cr							=	null;
		Connection						conn					=	null;
		Statement							stmt					=	null;
		ResultSet							rs							=	null;
		String								sql						=	null;
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		Return ü
	    Hashtable<String,Object>	hashData			=	new Hashtable<String,Object>();
	    List<EntityData>				listData				=	new LinkedList<EntityData>();
	   //- - - - - - - - - - - - - - - - - - - - - - - - - -		
	    try {		    	
			cr									=	new ToolConnectionResource();
			conn								=	cr.getConnection();
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		ȸ
			String[]	fltNumArray	= params.getFltNum().replaceAll(" ",",").split(",");
			stmt								=	conn.createStatement();
			sql								=	IroQ710Query.getInstance().sel710Main(params, fltNumArray);
			rs									=	stmt.executeQuery(sql);
			String	dssStartDt			=	null;
			String	seqNum			=	null;
			String	titleE					=	null;
			String	fltNum				=	null;
			String	processX			=	null;
			String	decisionE			=	null;
			String	iropsDt				=	null;
			String	dssDt				=	null;
			while (rs.next()) {
				dssStartDt				=	StringUtil.checkString(rs.getString("DSS_START_DT"));
				seqNum					=	StringUtil.checkString(rs.getString("SEQ_NUM"));
				titleE						=	StringUtil.checkString(rs.getString("TITLE_E"));
				fltNum					=	StringUtil.checkString(rs.getString("FLT_NUM"));
				processX				=	StringUtil.checkString(rs.getString("PROCESS_X"));
				decisionE				=	StringUtil.checkString(rs.getString("DECISION_E"));
				iropsDt					=	StringUtil.checkString(rs.getString("IROPS_DT"));
				dssDt						=	StringUtil.checkString(rs.getString("DSS_DT"));				

				IroQ710BG		entity	=	new IroQ710BG();
				entity.setDssStartDt(dssStartDt);
				entity.setSeqNum(seqNum);
				entity.setTitleE(titleE);
				entity.setFltNum(fltNum);
				entity.setProcessX(processX);
				entity.setDecisionE(decisionE);
				entity.setIropsDt(iropsDt);
				entity.setDssDt(dssDt);
				listData.add(entity);
			}
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		
			hashData.put("MAIN_LIST",listData);			
	  	}catch(SQLException se) {
			//logPrint(new Throwable().getStackTrace()[0],"[SQLException]"+se.getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		}catch(Exception e) {
			//logPrint(new Throwable().getStackTrace()[0],"[Exception]"+e.getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		}finally {
			if( cr != null) try { cr.release(); } catch(Exception e) {}
			if(conn != null) try {conn.close(); } catch(Exception e) {}
			if(rs != null) try {rs.close(); } catch(Exception e) {}
			if(stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	/*-------------------------------------------------------------------	@2013-10-xx	selIroQ711Main
	----------------------------------------------------------------------	*/
	public Hashtable selIroQ711Main(IroQ710BG params) throws BusinessException {
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		ڿ		
		ConnectionResource			cr							=	null;
		Connection						conn					=	null;
		Statement							stmt					=	null;
		ResultSet							rs							=	null;
		String								sql						=	null;
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		Return ü
	    Hashtable<String,Object>	hashData			=	new Hashtable<String,Object>();
		IroQ460BG						iropsData			=	new IroQ460BG();
	    List<EntityData>				skdData				=	new LinkedList<EntityData>();
	    List<EntityData>				deskData			=	new LinkedList<EntityData>();
	   //- - - - - - - - - - - - - - - - - - - - - - - - - -		
	    try {		    	
			cr									=	new ToolConnectionResource();
			conn								=	cr.getConnection();
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		ȸ
			String sm = "";
			String occ = "";
			String goc = "";
			String decisionE = "";
			String korN = "";
			String titleE = "";
			String iropsDt = "";
			String dssDt = "";
			String message = "";
			boolean selFlg = false;
			//- - - - - - - - - - - - - - - - - - - - - - - - - -	
			stmt								=	conn.createStatement();
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		skdData
			for(int i=0;	selFlg==false && i<3; i++){
				if(i==0){
					sql								=	IroQ710Query.getInstance().sel711Main1(params);//1. DAILY_SCH_T  ȸ
				}else if(i==1){
					sql								=	IroQ710Query.getInstance().sel711Main2(params);//2. DSS_NEW_SCH_T  ȸ
				}else if(i==2){
					sql								=	IroQ710Query.getInstance().sel711Main3(params);//3
				}else{
					break;
				}
				rs									=	stmt.executeQuery(sql);

				while (rs.next()) {
					selFlg = true;
					
					occ = StringUtil.checkString(rs.getString("OCC"));
					goc = StringUtil.checkString(rs.getString("GOC"));
					decisionE = StringUtil.checkString(rs.getString("DECISION_E"));
					korN = StringUtil.checkString(rs.getString("KOR_N"));
					titleE = StringUtil.checkString(rs.getString("TITLE_E"));
					iropsDt = StringUtil.checkString(rs.getString("IROPS_DT"));
					dssDt = StringUtil.checkString(rs.getString("DSS_DT"));
					
					IroQ460BG entity = new IroQ460BG();
					
					entity.setFltNum(StringUtil.checkString(rs.getString("FLT_NUM")));
					entity.setKactyp(StringUtil.checkString(rs.getString("KACTYP")));
					entity.setRegno(StringUtil.checkString(rs.getString("REGNO")));
					entity.setStnfr(StringUtil.checkString(rs.getString("STNFR")));
					entity.setStnto(StringUtil.checkString(rs.getString("STNTO")));
					entity.setSchDepDm(StringUtil.checkString(rs.getString("SCH_DEP_DM")));//2017.04.12 ߰
					entity.setSchDepDt(StringUtil.checkString(rs.getString("SCH_DEP_DT")));
					entity.setSchArvDt(StringUtil.checkString(rs.getString("SCH_ARV_DT")));
					entity.setEstDepDt(StringUtil.checkString(rs.getString("EST_DEP_DT")));
					if (StringUtil.checkString(rs.getString("CGO_X")).equals("CGO")) {
						entity.setSupply("");
					} else {
						entity.setSupply(StringUtil.checkString(rs.getString("F_BOOK"))+"/"+StringUtil.checkString(rs.getString("C_BOOK"))+"/"+StringUtil.checkString(rs.getString("Y_BOOK")));
					}
					entity.setCommentX(StringUtil.checkString(rs.getString("COMMENT_X")));
					entity.setCommentE(StringUtil.checkString(rs.getString("COMMENT_E")));
					
					skdData.add(entity);
				}
			}
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		iropsData
			iropsData.setSm(sm);
			iropsData.setOcc(occ);
			iropsData.setGoc(goc);
			iropsData.setDecisionE(decisionE);
			iropsData.setKorN(korN);
			iropsData.setTitleE(titleE);
			iropsData.setIropsDt(iropsDt);
			iropsData.setDssDt(dssDt);
			iropsData.setMessage(message);
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		deskData
			if (selFlg) {
				sql = IroQ710Query.getInstance().sel711DeskInfo(params);
				rs = stmt.executeQuery(sql);
				while (rs.next()) {
					//SHIFT MANAGER Է ð  ´.
					if((StringUtil.checkString(rs.getString("DESK_X"))).equals("A")) sm = StringUtil.checkString(rs.getString("SM"));

					IroQ460BG entity = new IroQ460BG();

					entity.setCodeX(StringUtil.checkString(rs.getString("CODE_X")));
					entity.setKorN(StringUtil.checkString(rs.getString("KOR_N")));
					entity.setTimestamp(StringUtil.checkString(rs.getString("TIMESTAMP")));
					entity.setDecisionX(StringUtil.checkString(rs.getString("DECISION_X")));
					entity.setDecisionE(StringUtil.checkString(rs.getString("DECISION_E")));

					deskData.add(entity);
				}
			}
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		
			hashData.put("IROPS_DATA",iropsData);
			hashData.put("SKD_LIST",skdData);
			hashData.put("DESK_LIST",deskData);	
	  	}catch(SQLException se) {
			//logPrint(new Throwable().getStackTrace()[0],"[SQLException]"+se.getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		}catch(Exception e) {
			//logPrint(new Throwable().getStackTrace()[0],"[Exception]"+e.getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		}finally {
			if( cr != null) try { cr.release(); } catch(Exception e) {}
			if(conn != null) try {conn.close(); } catch(Exception e) {}
			if(rs != null) try {rs.close(); } catch(Exception e) {}
			if(stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	/*-------------------------------------------------------------------	@2013-10-xx	selIroA810Main
	----------------------------------------------------------------------	*/
	public Hashtable selIroA810Main(IroA810BG params) throws BusinessException {
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		ڿ		
		ConnectionResource			cr							=	null;
		Connection						conn					=	null;
		Statement							stmt					=	null;
		ResultSet							rs							=	null;
		String								sql						=	null;
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		Return ü
	    Hashtable<String,Object>	hashData			=	new Hashtable<String,Object>();
	    List<EntityData>				listData				=	new LinkedList<EntityData>();
	   //- - - - - - - - - - - - - - - - - - - - - - - - - -		
	    try {		    	
			cr									=	new ToolConnectionResource();
			conn								=	cr.getConnection();
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		ȸ
			stmt								=	conn.createStatement();
			sql								=	IroA810Query.getInstance().selIroA810Main(params);
			
			String	networkX			=	StringUtil.checkString(params.getNetworkX());
			
			rs							=	stmt.executeQuery(sql);
			
			String	r_projectC			=	null;
			String	r_networkX			=	null;
			String	r_groupC			=	null;
			String	r_groupSvc			=	null;
			String	r_groupDep			=	null;
			String	r_groupArv			=	null;
			int		r_seqNo				=	0;
			String	r_addrE				=	null;
			String	r_remarks			=	null;
			String	r_timestamp			=	null;
			
			String	r_decaddrE				=	null;
			
			Hashtable<String,Integer>	rowspanHash				=	new Hashtable<String,Integer>();
			int								rows	=	0;
			
			
			ArrayList<Box> list = new ArrayList<Box>();

			while (rs.next()) {			
				r_projectC					=	StringUtil.checkString(rs.getString("PROJECT_C"));
				r_networkX					=	StringUtil.checkString(rs.getString("NETWORK_X"));
				r_groupC					=	StringUtil.checkString(rs.getString("GROUP_C"));
				r_groupSvc					=	StringUtil.checkString(rs.getString("GROUP_SVC"));
				r_groupDep					=	StringUtil.checkString(rs.getString("GROUP_DEP"));
				r_groupArv					=	StringUtil.checkString(rs.getString("GROUP_ARV"));
				r_seqNo						=	rs.getInt("SEQ_NO");
				r_addrE						=	StringUtil.checkString(rs.getString("ADDR_E"));
				r_remarks					=	StringUtil.checkString(rs.getString("REMARKS"));
				r_timestamp					=	StringUtil.checkString(rs.getString("TIMESTAMP"));
				
				//2016.09.07 ȣȭ 
				r_decaddrE					=	StringUtil.checkString(rs.getString("ENC_ADDR_E"));
				
				if("".equals(r_decaddrE)){
					
					System.out.println("r_projectC:"+r_projectC);
					System.out.println("r_networkX:"+r_networkX);
					System.out.println("  r_groupC:"+r_groupC);
					
					stmt								=	conn.createStatement();
					sql									=	IroA810Query.getInstance().updIroA810_Enc(r_projectC, r_networkX, r_groupC, r_addrE);
					
					if(stmt.executeUpdate(sql)!=1){
						conn.rollback();
						throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
					}else{
						conn.commit();
					}
					
					r_decaddrE = SecurityUtil.self.encrypt(r_addrE, "INT_EML");
					
					System.out.println("   r_addrE:"+r_addrE);
					System.out.println("r_decaddrE:"+r_decaddrE);
					
					//String dec_addr = SecurityUtil.self.decrypt(r_decaddrE, "INT_EML");
					//System.out.println("  dec_addr:"+dec_addr);
					
				}
				
				
				
				Box box = new Box("");
				
				box.put("r_projectC", r_projectC);
				box.put("r_networkX", r_networkX);
				box.put("r_groupC", r_groupC);
				box.put("r_groupSvc", r_groupSvc);
				box.put("r_groupDep", r_groupDep);
				box.put("r_groupArv", r_groupArv);
				box.put("r_seqNo", r_seqNo);
				box.put("r_addrE", r_addrE);
				box.put("r_remarks", r_remarks);
				box.put("r_timestamp", r_timestamp);
				box.put("r_decaddrE", r_decaddrE);
				
				rows	=	rowspanHash.get(r_groupSvc)==null ?1 : rowspanHash.get(r_groupSvc).intValue()+1;
				rowspanHash.put(r_groupSvc,rows);
				
				rows	=	rowspanHash.get(r_groupSvc+"_"+r_groupDep)==null ?1 : rowspanHash.get(r_groupSvc+"_"+r_groupDep).intValue()+1;
				rowspanHash.put(r_groupSvc+"_"+r_groupDep,rows);	
				
				/*if("SITA".equals(networkX)){
					rows	=	rowspanHash.get(r_groupDep)==null ?1 : rowspanHash.get(r_groupDep).intValue()+1;
					rowspanHash.put(r_groupDep,rows);
					
					rows	=	rowspanHash.get(r_groupDep+"_"+r_groupSvc)==null ?1 : rowspanHash.get(r_groupDep+"_"+r_groupSvc).intValue()+1;
					rowspanHash.put(r_groupDep+"_"+r_groupSvc,rows);	
				}else{				
					rows	=	rowspanHash.get(r_groupSvc)==null ?1 : rowspanHash.get(r_groupSvc).intValue()+1;
					rowspanHash.put(r_groupSvc,rows);
					
					rows	=	rowspanHash.get(r_groupSvc+"_"+r_groupDep)==null ?1 : rowspanHash.get(r_groupSvc+"_"+r_groupDep).intValue()+1;
					rowspanHash.put(r_groupSvc+"_"+r_groupDep,rows);	
				}*/
				
				list.add(box);

			}
			
			ArrayList<Box> boxs =  new ArrayList<Box>();
			
			if(list.size() > 0){
			
				System.out.println("----------------Bean decrypt start -------------");
				//2016.09.07 ȣȭ 
				boxs	= SecurityUtil.self.decrypts(list,new String[][]{
						{"INT_EML","r_decaddrE"}
				});
			
			}else{
				
				boxs = list;
			}
			
			
			Box  box;//HashMap 
			
            for(int i=0; i<boxs.size(); i++){
                box = boxs.get(i);
                
                System.out.println("box r_decaddrE:"+box.get("r_decaddrE"));
                
				IroA810BG		entity	=	new IroA810BG();
				entity.setProjectC(box.get("r_projectC"));
				entity.setNetworkX(box.get("r_networkX"));
				entity.setGroupC(box.get("r_groupC"));
				entity.setGroupSvc(box.get("r_groupSvc"));
				entity.setGroupDep(box.get("r_groupDep"));
				entity.setGroupArv(box.get("r_groupArv"));
				entity.setSeqNo(Integer.valueOf(box.get("r_seqNo")).intValue());  
				entity.setAddrE(box.get("r_addrE"));
				entity.setRemarks(box.get("r_remarks"));
				entity.setTimestamp(box.get("r_timestamp"));
				entity.setDecAddrE(box.get("r_decaddrE"));
	
				listData.add(entity);

            }
			
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		
			hashData.put("MAIN_LIST",listData);			
			hashData.put("rowspanHash",rowspanHash);			
			
	  	}catch(SQLException se) {
	  		System.out.println("SQLException================="+se.toString());
			//logPrint(new Throwable().getStackTrace()[0],"[SQLException]"+se.getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		}catch(Exception e) {
			System.out.println("Exception================="+e.toString());
			//logPrint(new Throwable().getStackTrace()[0],"[Exception]"+e.getMessage());
			throw new BusinessException(MessageCode.getInstance().SELECT_EXPT);
		}finally {
			if( cr != null) try { cr.release(); } catch(Exception e) {}
			if(conn != null) try {conn.close(); } catch(Exception e) {}
			if(rs != null) try {rs.close(); } catch(Exception e) {}
			if(stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return hashData;
	}
	/*-------------------------------------------------------------------	@2013-10-xx	insIroA810
	----------------------------------------------------------------------	*/
	public String insIroA810(IroA810BG params) throws BusinessException {
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		Return ü
		String					result									=	"exception";
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		ڿ		
		ConnectionResource		cr							=	null;
		Connection						conn					=	null;
		Statement							stmt					=	null;
		ResultSet							rs							=	null;
		String									sql						=	null;

		try {
			cr										=	new ToolConnectionResource();
			conn								=	cr.getConnection();
			conn.setAutoCommit(false);
			
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		cntSeqNoIroA810
			int				cnt			=	0;
			stmt											=	conn.createStatement();
			sql												=	IroA810Query.getInstance().cntSeqNoIroA810(params);			
			rs													=	stmt.executeQuery(sql);
			while (rs.next()) {
				cnt								=		rs.getInt("CNT");
			}
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		INSERT
			if(cnt==0){	
				stmt								=	conn.createStatement();
				//sql								=	IroA810Query.getInstance().maxSeqNoIroA810(params);	
				sql									=	IroA810Query.getInstance().insIroA810(params);
				
				if(stmt.executeUpdate(sql)!=1){
					throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
				}else{
					result	=	"inserted";
					conn.commit();
				}
			}else{
				result	=	"overlap";//
				conn.rollback();
			}
		}catch(SQLException se) {
			if(conn != null) {try{conn.rollback();}catch(Exception r){}}
	  		System.out.println("SQLException================="+se.toString());
			//logPrint(new Throwable().getStackTrace()[0],"[SQLException]"+se.getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		}catch(Exception e) {
			if(conn != null) {try{conn.rollback();}catch(Exception r){}}
			System.out.println("Exception================="+e.toString());
			//logPrint(new Throwable().getStackTrace()[0],"[Exception]"+e.getMessage());
			throw new BusinessException(MessageCode.getInstance().INSERT_EXPT);
		}finally {
			if( cr != null) try { cr.release(); } catch(Exception e) {}
			if(conn != null) try {conn.close(); } catch(Exception e) {}
			if(rs != null) try {rs.close(); } catch(Exception e) {}
			if(stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return result;
	}
	/*-------------------------------------------------------------------	@2013-10-xx	updIroA810
	----------------------------------------------------------------------	*/
	public String updIroA810(IroA810BG params) throws BusinessException {
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		Return ü
		String					result									=	"exception";
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		ڿ		
		ConnectionResource		cr				=	null;
		Connection				conn			=	null;
		Statement				stmt			=	null;
		ResultSet				rs				=	null;
		String					sql				=	null;

		try {
			cr									=	new ToolConnectionResource();
			conn								=	cr.getConnection();
			conn.setAutoCommit(false);
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		cntSeqNoIroA810
			int				cnt					=	0;
			stmt								=	conn.createStatement();
			sql									=	IroA810Query.getInstance().cntSeqNoIroA810(params);			
			rs									=	stmt.executeQuery(sql);
			while (rs.next()) {
				cnt								=		rs.getInt("CNT");
			}
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		UPDATE
			if(cnt==1){			
				stmt								=	conn.createStatement();
				sql									=	IroA810Query.getInstance().updIroA810(params);
				
				if(stmt.executeUpdate(sql)!=1){
					throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
				}else{
					result	=	"updated";
					conn.commit();
				}
			}else{
				result	=	"overlap";//
				conn.rollback();
			}
		}catch(SQLException se) {
			if(conn != null) {try{conn.rollback();}catch(Exception r){}}
	  		System.out.println("SQLException================="+se.toString());
			//logPrint(new Throwable().getStackTrace()[0],"[SQLException]"+se.getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		}catch(Exception e) {
			if(conn != null) {try{conn.rollback();}catch(Exception r){}}
			System.out.println("Exception================="+e.toString());
			//logPrint(new Throwable().getStackTrace()[0],"[Exception]"+e.getMessage());
			throw new BusinessException(MessageCode.getInstance().UPDATE_EXPT);
		}finally {
			if( cr != null) try { cr.release(); } catch(Exception e) {}
			if(conn != null) try {conn.close(); } catch(Exception e) {}
			if(rs != null) try {rs.close(); } catch(Exception e) {}
			if(stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return result;
	}
	/*-------------------------------------------------------------------	@2013-10-xx	delIroA810
	----------------------------------------------------------------------	*/
	public String delIroA810(IroA810BG params) throws BusinessException {
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		Return ü
		String					result									=	"exception";
		//- - - - - - - - - - - - - - - - - - - - - - - - - -		ڿ		
		ConnectionResource		cr							=	null;
		Connection						conn					=	null;
		Statement							stmt					=	null;
		ResultSet							rs							=	null;
		String									sql						=	null;

		try {
			cr										=	new ToolConnectionResource();
			conn								=	cr.getConnection();
			conn.setAutoCommit(false);
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		maxSeqNoIroA810
			int				cnt			=	0;
			stmt											=	conn.createStatement();
			sql												=	IroA810Query.getInstance().cntSeqNoIroA810(params);			
			rs													=	stmt.executeQuery(sql);
			while (rs.next()) {
				cnt								=		rs.getInt("CNT");
			}
			//- - - - - - - - - - - - - - - - - - - - - - - - - -		DELETE
			if(cnt==1){			
				stmt								=	conn.createStatement();
				sql									=	IroA810Query.getInstance().delIroA810(params);
				
				if(stmt.executeUpdate(sql)!=1){
					throw new BusinessException(MessageCode.getInstance().DELETE_EXPT);
				}else{
					result	=	"deleted";
					conn.commit();
				}
			}else{
				result	=	"overlap";//
				conn.rollback();
			}
		}catch(SQLException se) {
			if(conn != null) {try{conn.rollback();}catch(Exception r){}}
	  		System.out.println("SQLException================="+se.toString());
			//logPrint(new Throwable().getStackTrace()[0],"[SQLException]"+se.getMessage());
			throw new BusinessException(MessageCode.getInstance().SQL_EXPT);
		}catch(Exception e) {
			if(conn != null) {try{conn.rollback();}catch(Exception r){}}
			System.out.println("Exception================="+e.toString());
			//logPrint(new Throwable().getStackTrace()[0],"[Exception]"+e.getMessage());
			throw new BusinessException(MessageCode.getInstance().DELETE_EXPT);
		}finally {
			if( cr != null) try { cr.release(); } catch(Exception e) {}
			if(conn != null) try {conn.close(); } catch(Exception e) {}
			if(rs != null) try {rs.close(); } catch(Exception e) {}
			if(stmt != null) try {stmt.close();} catch(Exception e) {}
		}
		return result;
	}
	/*-------------------------------------------------------------------	@2013-10-xx	emailPortMap_put,emailPortMap_toString
	----------------------------------------------------------------------	*/
	private HashMap<String,Object>	portMap_put(HashMap<String,Object>	portMap, String key){
		try{
			if(portMap==null){
				portMap	=	new HashMap<String,Object>();
			}
			portMap.put(key,true);
		}catch(Exception e){
			System.out.println("Exception================="+e.toString());
		}
		return portMap;
	}
	private String	portMap_toString(HashMap<String,Object>	portMap){
		String	result	=	"";
		try{
			if(portMap!=null && portMap.size()!=0){
				Object[]	keys	=	  ((java.util.Set) portMap.keySet()).toArray() ;
				for(int i=0; i<keys.length; i++){
					if (result.length()!=0) {
						result	+=",";
					}
					result	+= "'" + keys[i] + "'";
				}
			}
		}catch(Exception e){
			System.out.println("Exception================="+e.toString());
		}
		return result;
	}
	
}//end of class

